/*
  Trigger navázaný na insert a update nad dokladem provede smazání záznamu z díry dokladových řad,
  pokud je číslo odsud bráno.

  Autor: Pavel Cvrček
*/
create or replace function dDoklDelRadDiru() returns trigger as $$
declare
  _idUcetObdobi integer;
begin
  /* Kontrola na bug 9288. Po vyřešení možno odstranit.*/  
  /* Zakomentováno z důvodu importu z W6. Jinak by to neprošlo.
  if (NEW.idPolRady is null) then
    raise exception 'dDoklDelRadDiru(): idPolRady je null';
  end if;*/

  select idUcetObdobi into _idUcetObdobi from nUcetObdobi where platiOdData <= NEW.DatUcto and platiDoData >= NEW.DatUcto; 

  delete from dRadyDiry where CisDira = NEW.Kod and idRadyRok = 
    (select idRadyRok from dRadyRok where idRady = NEW.idRady and idUcetObdobi = _idUcetObdobi group by idRadyRok);
    
  return NEW;
end;
$$ LANGUAGE plpgsql;

drop trigger if exists dDoklFakDelRadDiru on ddoklfak;
drop trigger if exists dDoklIntDelRadDiru on ddoklint;
drop trigger if exists dDoklSkladDelRadDiru on ddoklsklad;

create trigger dDoklFakDelRadDiru before insert or update on ddoklfak 
for each row execute procedure dDoklDelRadDiru();

create trigger dDoklIntDelRadDiru before insert or update on ddoklint
for each row execute procedure dDoklDelRadDiru();

create trigger dDoklSkladDelRadDiru before insert or update on ddoklsklad
for each row execute procedure dDoklDelRadDiru();
