/*
  Zneplatneni uzaverky ucetniho obdobi pri zmene castky nebo zauctovani dokladu v mene.

  Autor: Jan Besta
*/
create or replace function dDoklFakUpdatePreceneni() returns trigger as $$
declare datum date;
begin
  if (NEW.sumCelkemMen <> 0 or OLD.sumCelkemMen <> 0) then                  -- pokud jsou obe nula nemuze nastat chyba preceneni (zrejme to neni doklad v cizi mene)
    if (NEW.ucetni = true and OLD.ucetni = true) then                       -- pokud je ucetni
      if (NEW.datUcto <> OLD.datUcto) then                                  -- pokud se zmenilo datum zauctovani musime nastavit obe
        execute uNastavChybaPreceneni(NEW.datUcto);
        execute uNastavChybaPreceneni(OLD.datUcto);
      else
          if (NEW.sumCelkemMen <> OLD.sumCelkemMen or NEW.kurz <> OLD.kurz) then  -- pokud se zmenilo neco ovlivnujici celkovou castku
            execute uNastavChybaPreceneni(NEW.datUcto);
          end if;
      end if;
    end if;

    if (NEW.ucetni <> OLD.ucetni) then                                      -- pokud je ucetni a nebylo nebo naopak musime vyvolat chybu preceneni
      if (NEW.ucetni = true) then
        execute uNastavChybaPreceneni(NEW.datUcto);
      else
        execute uNastavChybaPreceneni(OLD.datUcto);
      end if;
    end if;

  end if;

  return NEW;
end;
$$ LANGUAGE plpgsql;

drop trigger if exists dDoklFakUpdatePreceneni on dDoklFak;

create trigger dDoklFakUpdatePreceneni before update on dDoklFak
for each row execute procedure dDoklFakUpdatePreceneni();