/*
 Promitnuti zmeny uctu na fakture na navazane doklady

 Autor:        Jan Besta
*/
create or replace function dDoklFakUpdateUcty() returns trigger as $$
declare nelzeZmena int;
        idDokl int;
begin
  -- test zda smi dojit ke zmene na dokladu
  if (OLD.zamek = true and NEW.zamek = true) then
    raise exception 'dDoklFakUpdateUcty(): Dochz ke zmn na faktue, kter je zamen.';
  end if;

  nelzeZmena := 0;
  
  --pokud dojde ke zmene primarniho uctu
  if (compareId(NEW.idPrimUcet, OLD.idPrimUcet) = false) then
    -- uprava banka/pokladna vazbami uhrada a vazbaZDD, pouze pokud ucet nesouhlasi aby nedochazelo k zacykleni
    for idDokl in (select idDoklInt from dDoklInt where compareId(idProtiUcet, NEW.idPrimUcet) = false and idDoklInt in
        (select idTabB from dVazebTab where idTabA = NEW.idDoklFak and typVazbyK in ('typVazbyDokl.uhrada','typVazbyDokl.vazbaZDD')))
    loop
        execute dNastavUcetDokladu(1, idDokl, 1, NEW.idPrimUcet);
    end loop;

    -- uhradaKR, preceneni - u kurzoveho rozdilu a preceneni nevim na ktere strane je hledany ucet, testuji oba
    for idDokl in (select idDoklInt from dDoklInt where compareId(idProtiUcet, NEW.idPrimUcet) = false and compareId(idProtiUcet, OLD.idPrimUcet) = true and idDoklInt in
        (select idTabB from dVazebTab where idTabA = NEW.idDoklFak and typVazbyK in ('typVazbyDokl.uhradaKR','typVazbyDokl.preceneni','typVazbyDokl.uhradaZB')))
    loop
        execute dNastavUcetDokladu(1, idDokl, 1, NEW.idPrimUcet);
    end loop;

    for idDokl in (select idDoklInt from dDoklInt where compareId(idPrimUcet,  NEW.idPrimUcet) = false and compareId(idPrimUcet,  OLD.idPrimUcet) = true and idDoklInt in
        (select idTabB from dVazebTab where idTabA = NEW.idDoklFak and typVazbyK in ('typVazbyDokl.uhradaKR','typVazbyDokl.preceneni','typVazbyDokl.uhradaZB')))
    loop
        execute dNastavUcetDokladu(1, idDokl, 0, NEW.idPrimUcet);
    end loop;
  end if;

  --pokud dojde ke zmene protiuctu (doklad je zdd menime ucty odpoctu)
  if (compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false) then
    if (NEW.typPohybuK = 'typPohybu.prijem') then             -- kdyz je to faktura vydana
      -- zjistime zda neexistujou nake co nesmime zmenit
      select count(*) into nelzeZmena from dPolFak where compareId(idZklDalUcet, NEW.idProtiUcet) = false and kopZklDalUcet = true and
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');
      -- pokud smime zmenit vsechny polozky co potrebujeme menime
      if (nelzeZmena = 0) then
        update dPolFak set idZklDalUcet = NEW.idProtiUcet where compareId(idZklDalUcet, NEW.idProtiUcet) = false and idPolFak in
            (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');
      end if;
    end if;

    if (NEW.typPohybuK = 'typPohybu.vydej') then             -- kdyz je to faktura prijata
      -- zjistime zda neexistujou nake co nesmime zmenit
      select count(*) into nelzeZmena from dPolFak where compareId(idZklMdUcet, NEW.idProtiUcet) = false and kopZklMdUcet = true and
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');
      -- pokud smime zmenit vsechny polozky co potrebujeme menime
      if (nelzeZmena = 0) then
        update dPolFak set idZklMdUcet = NEW.idProtiUcet where compareId(idZklMdUcet, NEW.idProtiUcet) = false and idPolFak in
            (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');
      end if;

      -- vazba na sklad
      for idDokl in (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSkl' and idTabA = NEW.idDoklFak and 
            compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabB), NEW.idProtiUcet) = false)
      loop
        execute dNastavUcetDokladu(2, idDokl, 1, NEW.idProtiUcet);
      end loop;
    end if;
  end if;

  --pokud dojde ke zmene protiuctu zakladni sazby dph (doklad je zdd menime ucty odpoctu)
  if (compareId(NEW.idDphZaklUcet, OLD.idDphZaklUcet) = false and nelzeZmena = 0) then
    if (NEW.typPohybuK = 'typPohybu.prijem') then             -- kdyz je to faktura vydana
      -- zjistime zda neexistujou nake co nesmime zmenit
      select count(*) into nelzeZmena from dPolFak where compareId(idDphDalUcet, NEW.idDphZaklUcet) = false and typSzbDphK = 'typSzbDph.dphZakl' and kopDphDalUcet = true and
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');
      -- pokud smime zmenit vsechny polozky co potrebujeme menime
      if (nelzeZmena = 0) then
        update dPolFak set idDphDalUcet = NEW.idDphZaklUcet where compareId(idDphDalUcet, NEW.idDphZaklUcet) = false and typSzbDphK = 'typSzbDph.dphZakl' and 
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');
      end if;
    end if;

    if (NEW.typPohybuK = 'typPohybu.vydej') then             -- kdyz je to faktura prijata
      -- zjistime zda neexistujou nake co nesmime zmenit
      select count(*) into nelzeZmena from dPolFak where compareId(idDphMdUcet, NEW.idDphZaklUcet) = false and typSzbDphK = 'typSzbDph.dphZakl' and kopDphMdUcet = true and
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');
      -- pokud smime zmenit vsechny polozky co potrebujeme menime
      if (nelzeZmena = 0) then
        update dPolFak set idDphMdUcet = NEW.idDphZaklUcet where compareId(idDphMdUcet, NEW.idDphZaklUcet) = false and typSzbDphK = 'typSzbDph.dphZakl' and 
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');
      end if;
    end if;
  end if;

  --pokud dojde ke zmene protiuctu snizene sazby dph (doklad je zdd menime ucty odpoctu)
  if (compareId(NEW.idDphSnizUcet, OLD.idDphSnizUcet) = false and nelzeZmena = 0) then
    if (NEW.typPohybuK = 'typPohybu.prijem') then             -- kdyz je to faktura vydana
      -- zjistime zda neexistujou nake co nesmime zmenit
      select count(*) into nelzeZmena from dPolFak where compareId(idDphDalUcet, NEW.idDphSnizUcet) = false and typSzbDphK = 'typSzbDph.dphSniz' and kopDphDalUcet = true and
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');
      -- pokud smime zmenit vsechny polozky co potrebujeme menime
      if (nelzeZmena = 0) then
        update dPolFak set idDphDalUcet = NEW.idDphSnizUcet where compareId(idDphDalUcet, NEW.idDphSnizUcet) = false and typSzbDphK = 'typSzbDph.dphSniz' and 
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');
      end if;
    end if;

    if (NEW.typPohybuK = 'typPohybu.vydej') then             -- kdyz je to faktura prijata
      -- zjistime zda neexistujou nake co nesmime zmenit
      select count(*) into nelzeZmena from dPolFak where compareId(idDphMdUcet, NEW.idDphSnizUcet) = false and typSzbDphK = 'typSzbDph.dphSniz' and kopDphMdUcet = true and
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');
      -- pokud smime zmenit vsechny polozky co potrebujeme menime
      if (nelzeZmena = 0) then
        update dPolFak set idDphMdUcet = NEW.idDphSnizUcet where compareId(idDphMdUcet, NEW.idDphSnizUcet) = false and typSzbDphK = 'typSzbDph.dphSniz' and 
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');
      end if;
    end if;
  end if;

  if (nelzeZmena > 0) then
    raise exception 'dDoklFakUpdateUcty(): Nelze zmnit et u navzan poloky.';
  end if;

  return NEW;
end;
$$ LANGUAGE plpgsql;


drop trigger if exists dDoklFakUpdateUcty on ddoklfak;

create trigger dDoklFakUpdateUcty after update on ddoklfak
for each row execute procedure dDoklFakUpdateUcty();