/**
 * odecte obrat stare hodnoty splatkoveho kalendare v tabulce uObraty
 * pricte obrat nove hodnoty splatkoveho kalendare v tabulce uObraty
 * 
 * @author jdrahos
 */
create or replace function mSplatKalUpdate() returns trigger as $$
declare
  mena integer;
begin
  select leasing.idMeny into mena from mleasing leasing where NEW.idleasing = leasing.idleasing;

  execute createOrUpdateObraty(OLD.Ucetni, false, OLD.DatUcto, OLD.idZklMdUcet, OLD.idZklDalUcet,
        mena, OLD.idStred, -OLD.sumZkl, -OLD.sumZklMen);

  execute createOrUpdateObraty(OLD.Ucetni, false, OLD.DatUcto, OLD.idDphMdUcet, OLD.idDphDalUcet,
        mena, OLD.idStred, -OLD.sumDph, -OLD.sumDphMen);

  execute createOrUpdateObraty(NEW.Ucetni, false, NEW.DatUcto, NEW.idZklMdUcet, NEW.idZklDalUcet,
        mena, NEW.idStred, NEW.sumZkl, NEW.sumZklMen);

  execute createOrUpdateObraty(NEW.Ucetni, false, NEW.DatUcto, NEW.idDphMdUcet, NEW.idDphDalUcet,
        mena, NEW.idStred, NEW.sumDph, NEW.sumDphMen);

  return NEW;
end;
$$ LANGUAGE plpgsql;

drop trigger if exists mSplatKalUpdate on msplatkal;

create trigger mSplatKalUpdate before update on msplatkal
for each row execute procedure mSplatKalUpdate();