/*
  Vrati kurz ze skladoveho dokladu urceneho i_doklSkladId
  Autor: Karel Bel
*/

CREATE OR REPLACE FUNCTION getKurzFromDoklad(i_doklSkladId integer, i_DatVyst date)
  RETURNS numeric(19,6) AS
$BODY$ 
declare 
  idMenyTuzemsko integer;
  idMenyDoklad integer;
  _kurzMnozstvi integer;
  _nbStred numeric(10,6);
  _result numeric(19,6);
  
begin 
  /* pokud je doklad v tuzemske mene vrati se kurz 1*/
  select idMeny into idMenyTuzemsko from nNastav where i_DatVyst >= PlatiOdData order by PlatiOdData desc limit 1;
  if (idMenyTuzemsko is null) then
    select idMeny into idMenyTuzemsko from nNastav where PlatiOdData is null limit 1; 
  end if;
  select idMeny into idMenyDoklad from dDoklSklad where idDoklSklad = i_doklSkladId;

  if(idMenyDoklad is null or idMenyDoklad = idMenyTuzemsko) then
    return 1;
  end if; 
  /* jinak se nacte z dokladu */
  select kurz, kurzMnozstvi into _nbStred, _kurzMnozstvi from ddoklsklad where idDoklSklad = i_doklSkladId;

  if _kurzMnozstvi = 0 then
    _result := 0;
  else
    _result := _nbStred / _kurzMnozstvi;
  end if;
  
  return _result; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;