/*
 Provede prime prepocitani skladove karty podle polozky prijemky/vydejky
 Autor: Pavel Cvrcek
*/
CREATE OR REPLACE FUNCTION sprepoctiskladkartu(i_mnozmj numeric, i_cenamj numeric, i_datvyst date, i_skladkartaid integer, i_doklskladid integer, i_skladid integer, i_nasobic integer)
  RETURNS void AS
$BODY$ 
/* Prepocte stavy na skladove karte s id = iSkladKartaId */ 
declare 
  /* Deklarace promennych */ 
  _PomMnozMJ numeric(19,2); 
  _StavMJ numeric(19,2); 
  _StavTuz numeric(19,2); 
  _StavMen numeric(19,2); 
  _PrumCenaTuz numeric(19,2); 
  _PrumCenaMen numeric(19,2); 
  _PoslCenaTuz numeric(19,2); 
  _PoslCenaMen numeric(19,2); 
  _TypPohybuK varchar(50); 
  _DatPosl date; 
  _kurzSkladKarty numeric(19,6);
  _kurzDokladu numeric(19,6);
  loc_MnozMJ numeric(19,6);
  _sklzapor boolean; 
 
  /* Deklarace kurzoru pro nacteni potrebnych dat ze skladove karty a dokladu */ 
  declare ThisDoklSklad cursor for select TypPohybuK from dDoklSklad where idDoklSklad = i_DoklSkladId; 
  declare ThisSkladKarta cursor for select StavMJ,StavTuz,StavMen,PrumCenaTuz,PrumCenaMen,DatPosl from sKarty where idKarty = i_SkladKartaId;   
begin 
  loc_MnozMJ:= i_MnozMJ; 
 
  /* Nacteni dat ze skladove karty */ 
  open ThisSkladKarta; 
  fetch ThisSkladKarta into _StavMJ, 
    _StavTuz,_StavMen,_PrumCenaTuz,_PrumCenaMen,_DatPosl; 
  close ThisSkladKarta; 
   
  /* Zjisteni typPohybuK */ 
  open ThisDoklSklad; 
  fetch ThisDoklSklad into _TypPohybuK; 
  close ThisDoklSklad; 

  /* zjisteni meny skladove karty */
  _KurzSkladKarty := (select getKurzFromSklad(i_skladId, i_DatVyst));
  _KurzDokladu := (select getKurzFromDoklad(i_doklSkladId, i_DatVyst));
  
  /* pokud jde o vydej musim odecitat */ 
  if _TypPohybuK = 'typPohybu.vydej' then 
    loc_MnozMJ:= 0-loc_MnozMJ; 
  end if; 
   
  /* Vypocet StavMJ */ 
  _StavMJ:=_StavMJ+loc_MnozMJ*i_Nasobic; 

  if _StavMJ < 0 then
    select sklzapor into _sklzapor from nNastav where i_DatVyst >= PlatiOdData order by PlatiOdData desc limit 1;
	if (_sklzapor is null) then
		select sklzapor into _sklzapor from nNastav where PlatiOdData is null limit 1; 
	end if;
    if _sklzapor is null or _sklzapor = false then
        /*raise exception '0002:sPreporctiSkladKartu: neni povolen zaporny stav skladu';*/
    end if;
  end if;
	
   
  /* Vypocet StavTuz */ 
  if loc_MnozMJ = 0 then 
    _PomMnozMJ:=1; 
  else 
    _PomMnozMJ:=loc_MnozMJ; 
  end if; 
  _StavTuz:=_StavTuz+(_PomMnozMJ*i_CenaMJ*i_Nasobic*_KurzDokladu); 
  /* Vypocet StavMen */ 
  _StavMen:=_StavMen+(_PomMnozMJ*i_CenaMJ*i_Nasobic*_KurzDokladu)/_KurzSkladKarty; 

  /* Vypocet prumernych cen ma byt proveden jen pri prijmu*/
  if _TypPohybuK = 'typPohybu.prijem' then
    /* Vypocet PrumCenaTuz */ 
    if _StavMJ > 0 then 
      _PrumCenaTuz:=_StavTuz/_StavMJ; 
    end if; 
    /* Vypocet PrumCenaMen */ 
    if _StavMJ > 0 then 
      _PrumCenaMen:=_StavMen/_StavMJ; 
    end if; 
  end if; 
   
  /* Nastaveni posledni ceny */ 
  _PoslCenaTuz:= i_CenaMJ; 
  _PoslCenaMen:= i_CenaMJ; 

  /* Nastaveni data posledniho pohybu na karte */ 
  if _DatPosl is null then 
    _DatPosl:= i_DatVyst; 
  end if; 
  if _DatPosl < i_DatVyst then 
    _DatPosl:=i_DatVyst; 
  end if; 

  /* Update v databazi */ 
  update sKarty set StavMJ = _StavMJ, 
    StavTuz = _StavTuz, 
    StavMen = _StavMen, 
    PrumCenaTuz = _PrumCenaTuz, 
    PrumCenaMen = _PrumCenaMen, 
    PoslCenaTuz = _PoslCenaTuz, 
    PoslCenaMen = _PoslcenaMen, 
    DatPosl = _DatPosl where 
    idKarty = i_SkladKartaId; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;