-----------------------------------------------------------------------------------------
-- Bug 45387 - Provést rozpad existujících rezervací na sady na jednotlivé položky sady
-----------------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION vytvorRezervaceZeSad() RETURNS void
    AS $$  
declare 
    _idCenikPolSady int;
    _datumOd timestamp;
    _datumDo timestamp;
    _mnozstvi numeric;
    _skladMj numeric;
    _poznamka text;
    _idpolobch integer;
    _iduziv integer;
    _idfirmy integer;
    _idsklad integer;
    _sadaMnozstvi numeric;
begin  
    
    for _idCenikPolSady, _datumOd, _datumDo, _mnozstvi, _skladMj, _poznamka, _idpolobch, _iduziv, _idfirmy, _idsklad, _sadaMnozstvi in 
        (select s.idcenik, r.datumOd, r.datumDo, r.mnozstvi, r.skladMj, r.poznamka, r.idpolobch, r.iduziv, r.idfirmy, r.idsklad, s.mnozmj from srezervace r
        inner join csady s on s.idceniksada = r.idcenik)
    loop
       insert into srezervace (lastupdate, idpolobch, iduziv, idfirmy, idcenik, idsklad, mnozstvi, datumod, datumDo, poznamka)
              values (now(), _idPolObch, _idUziv, _idFirmy, _idCenikPolSady, _idSklad, _mnozstvi * _sadaMnozstvi, _datumOd, _datumDo, _poznamka);
    end loop;
    
    perform putglotxvariable('rezerDisableTrigger', '1');
    delete from srezervace where idrezervace in (select r.idrezervace from srezervace r
        inner join csady s on s.idceniksada = r.idcenik);
    perform removeglotxvariable('rezerDisableTrigger');

end;
$$ LANGUAGE plpgsql;


ALTER FUNCTION vytvorRezervaceZeSad() OWNER TO %firmaRole%;

select vytvorRezervaceZeSad();
drop function vytvorRezervaceZeSad();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
values (nextval('seq_dbversion'), 1006, 't', %appVersion%, clock_timestamp());
