----------------------------------------------------------------------
-- Bug 45515 - Nelze naskladnit už vyskladněné výrobní číslo
----------------------------------------------------------------------

CREATE OR REPLACE FUNCTION svyrobnicislohlavduplicitycheck() RETURNS trigger AS $$
BEGIN
    --kontrolu provedu pouze pokud u zboží evidujeme výrobní čísla a požadujeme jejich unikátnost
    IF EXISTS (select 1 from ccenik where idcenik = NEW.idCenik and evidvyrcis = true and unikvyrcis = true)  THEN
    
        --duplicita se kontroluje v rámci stejného zboží
        IF EXISTS (select 1 from svyrobnicislo where kod = NEW.kod and idcenik = NEW.idCenik 
                     and idpolskladvydej is null and idpolfakvydej is null and idpolintvydej is null) THEN
            RAISE EXCEPTION '0010: Duplicitní výrobní číslo::%', NEW.kod;
        END IF;
        
    END IF;
    
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

	
-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 1020, 't', %appVersion%, clock_timestamp());
