--------------------------------------------------------------------------------
--  Bug 46311 - Pokud dojde ke smazání dokladu nedojde ke smazání EET komunikace 
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION ddoklfakdeleteeetkom() RETURNS TRIGGER AS $$
BEGIN
  IF OLD.modul = 'FAV' THEN
    DELETE FROM deetkom WHERE iddokl=OLD.iddoklfak AND modul=OLD.modul;
  END IF;

  RETURN OLD;
END;
$$LANGUAGE plpgsql;
ALTER FUNCTION ddoklfakdeleteeetkom() OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION ddoklintdeleteeetkom() RETURNS TRIGGER AS $$
BEGIN
  IF OLD.modul = 'POK' THEN
    DELETE FROM deetkom WHERE iddokl=OLD.iddoklint AND modul=OLD.modul;
  END IF;

  RETURN OLD;
END;
$$LANGUAGE plpgsql;
ALTER FUNCTION ddoklintdeleteeetkom() OWNER TO %firmaRole%;

CREATE TRIGGER ddoklfakdeleteeetkom AFTER DELETE ON ddoklfak FOR EACH ROW EXECUTE PROCEDURE ddoklfakdeleteeetkom();
CREATE TRIGGER ddoklintdeleteeetkom AFTER DELETE ON ddoklint FOR EACH ROW EXECUTE PROCEDURE ddoklintdeleteeetkom();

--smazani zaznamu komunikace, ke kterym neexistuje doklad
DELETE FROM deetkom k WHERE k.modul='FAV' AND NOT EXISTS(SELECT 1 FROM ddoklfak d WHERE d.iddoklfak=k.iddokl AND d.modul=k.modul);
DELETE FROM deetkom k WHERE k.modul='POK' AND NOT EXISTS(SELECT 1 FROM ddoklint d WHERE d.iddoklint=k.iddokl AND d.modul=k.modul);

CREATE INDEX deetkom_iddokl_index ON deetkom USING BTREE (iddokl);

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 1076, 't', %appVersion%, clock_timestamp());
