--------------------------------------------------------------------------------
-- Bug 46761 - Neziskové organizace - aktualizace standardní účetní osnovy, rozvaha, výsledovka 2016
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION aktualizujOsnovuPodnikatele()
RETURNS void AS $$
DECLARE
  _idtyporgread integer;
  cnt integer;
BEGIN
  select idtyporg into _idtyporgread from nnastav limit 1;

  -- aktualizujeme jen pro cechy, pro podnikatele
  IF (_idtyporgread = 1) THEN
    
  -- standardní účetní osnova
    INSERT INTO ustducty (lastupdate, kod, nazev, show, platiod, platido, druhuctuk, typuctuk, saldo, idtyporg, uuid)
        VALUES ('2017-06-21 00:00:00.000', '064', 'Pořízení dlouhodobého finančního majetku', true, 2017, 9999, 'druhUctu.aktivni', 'typUctu.rozvahovy', false, 1, 'CZ_POD_064');
    INSERT INTO ustducty (lastupdate, kod, nazev, show, platiod, platido, typuctuk, saldo, idtyporg, uuid)
        VALUES ('2017-06-21 00:00:00.000', '790', 'Evidenční účty', true, 0, 9999, 'typUctu.podrozvahovy', false, 1, 'CZ_POD_790');
        
    -- doplnění nového účtu do rozvahy
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1125, '2017-06-21 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 228, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_064'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1126, '2017-06-21 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 230, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_064'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1127, '2017-06-21 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 232, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_064'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1128, '2017-06-21 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavKon', false, false, 235, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_064'));


   
  END IF;
  RETURN;
 END;
 $$ LANGUAGE plpgsql;
 ALTER FUNCTION aktualizujOsnovuPodnikatele() OWNER TO %firmaRole%;
   
select aktualizujOsnovuPodnikatele();
drop function aktualizujOsnovuPodnikatele();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
values (nextval('seq_dbversion'), 1102, 't', %appVersion%, clock_timestamp());
