--------------------------------------------------
-- Bug 46954 - Kontrola rekurzivní definice sady a komplety nefunguje na PostgreSQL <=8.3
--------------------------------------------------

CREATE OR REPLACE FUNCTION checkrekurzecenik(_idcenik integer, _idceniks integer[]) returns void
language plpgsql 
as $$
DECLARE
  _i integer;
  _id integer;
  _ids integer[];
  _copy boolean;
BEGIN
  _copy := false;

  for _i in array_lower(_idceniks, 1) .. array_upper(_idceniks, 1) loop
    _id := _idceniks[_i];
    
    if (_id = _idcenik) then
      _copy := true;
    end if;

    if _copy then
      _ids := _ids || _id;
    end if;
    
  end loop;
  
  if array_upper(_ids, 1) > 0 then
    raise exception '0012: Definice sad obsahuje cyklickou zavislost na ceste::%', array_to_string(array(select kod from ccenik where idcenik = any(_ids)), ', ');
  end if;
  
END;
$$;
ALTER FUNCTION public.checkrekurzecenik(integer, integer[]) OWNER TO %firmaRole%;

 -- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 1108, 't', %appVersion%, clock_timestamp());