--------------------------------------------------------------------------------
-- Bug 47033 - Šifrování výplatnic - úpravy v databázi 
--------------------------------------------------------------------------------

alter table posobahlav add column password character varying(255);

-- trigger prenasejici jmeno apod na hlavicku
CREATE OR REPLACE FUNCTION posobaupdatehlavicka()
  RETURNS trigger AS $$
begin
  if (NEW.platido is null) then
    UPDATE posobahlav SET lastupdate = localtimestamp, osbcis = NEW.osbcis, jmeno = NEW.jmeno, prijmeni = NEW.prijmeni, titul = NEW.titul, password = NEW.password WHERE idosobahlav = NEW.idosobahlav 
       AND (osbcis <> NEW.osbcis or not comparevarchar(jmeno, NEW.jmeno) or not comparevarchar(prijmeni, NEW.prijmeni) or not comparevarchar(titul, NEW.titul) or not comparevarchar(password, NEW.password));  
  end if;
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.posobaupdatehlavicka() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 1115, 't', %appVersion%, clock_timestamp());
