-- Function: dgetstavnasklade(integer, date, integer, character varying, date)

-- DROP FUNCTION dgetstavnasklade(integer, date, integer, character varying, date);

CREATE OR REPLACE FUNCTION dgetstavnasklade(i_skladkartaid integer, i_datum date, i_polskladid integer, i_sarze character varying, i_expirace date)
  RETURNS numeric AS
$BODY$    
declare   
  _pocMj numeric(19,6);   
  _obratMj numeric(19,6);   
  _stavMj numeric(19,6);   
  _idcenik integer; 
  _idskladu integer; 
  _typPohybuK character varying(50); 
begin   
  SELECT pocatMj INTO _pocMj   
  FROM sKarty   
  WHERE idKarty = i_skladkartaid;   
   
  if (i_datum is null) then   
    raise exception '0005:dGetStavNaSklade : Vstupni parametr datum je null.';    
  end if; 
 
  _typPohybuK := null; 
  if (i_polskladid >= 0) then 
    select typPohybuK into _typPohybuK from ddoklsklad  
      where iddoklsklad = (select iddoklsklad from dpolsklad where idpolsklad = i_polskladid); 
  end if; 
 
  select idcenik, idtypdokl into _idcenik, _idskladu from skarty where idkarty = i_skladkartaid; 
   
  if ((i_sarze is null or i_sarze = '') and i_expirace is null) then 
    if (i_polSkladId < 0) then    
      SELECT sum(CASE ds.typPohybuK WHEN 'typPohybu.prijem' THEN ps.mnozMj ELSE -ps.mnozMj END) INTO _obratMj    
      FROM dPolSklad ps LEFT OUTER JOIN dDoklSklad ds ON ps.idDoklSklad = ds.idDoklSklad    
      WHERE idkarty = i_skladkartaid AND ps.datUcto <= i_datum;    
    else    
      SELECT sum(CASE ds.typPohybuK WHEN 'typPohybu.prijem' THEN ps.mnozMj ELSE -ps.mnozMj END) INTO _obratMj    
      FROM dPolSklad ps LEFT OUTER JOIN dDoklSklad ds ON ps.idDoklSklad = ds.idDoklSklad    
      WHERE idkarty = i_skladkartaid AND (ps.datUcto < i_datum OR (ps.datUcto = i_datum AND ps.idPolSklad < i_polskladid));    
    end if; 
    if(_obratMj is null) then _obratMj = 0.0; end if;    
    if(_pocMj is null) then _pocMj = 0.0; end if;     
    _stavMj = _pocMj + _obratMj; 
  else 
    if ((i_sarze is not null and i_sarze <> '') and (i_expirace is null)) then 
      --raise exception 'idCenik = % and idSkladu = %', _idCenik, _idSkladu;
    
      select sum(pocet) into _stavMj from dpolskladf where idcenik = _idcenik and idskladu = _idskladu and sarze = i_sarze; 
    elsif ((i_sarze is null or i_sarze = '') and (i_expirace is not null)) then 
      select sum(pocet) into _stavMj from dpolskladf where idcenik = _idcenik and idskladu = _idskladu and expirace = i_expirace; 
    else 
      select sum(pocet) into _stavMj from dpolskladf where idcenik = _idcenik and idskladu = _idskladu and sarze = i_sarze and expirace = i_expirace; 
    end if; 
    if (_typPohybuK is not null and _typPohybuK = 'typPohybu.prijem') then 
      select mnozMj into _obratMj from dpolsklad where idpolsklad = i_polskladid; 
      if(_stavMj is null) then 
        _stavMj := -_obratMj; 
      else 
        _stavMj := _stavMj - _obratMj; 
      end if; 
    elsif (_typPohybuK is not null and _typPohybuK = 'typPohybu.vydej') then 
      select mnozMj into _obratMj from dpolsklad where idpolsklad = i_polskladid; 
      if(_stavMj is null) then 
        _stavMj := _obratMj; 
      else 
        _stavMj := _stavMj + _obratMj; 
      end if; 
    end if; 
  end if;

  -- muze se stat ze _stavMj je null a to znamena ze na sklade nic neni
  if(_stavMj is null) then
    _stavMj := 0;
  end if;
  
  RETURN _stavMj;    
end    
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dgetstavnasklade(integer, date, integer, character varying, date) OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 114, 't');