-----------------------------------------------------------------------
-- Bug 14295 – [WinStrom] Podpora napojení na internetové obchody
-----------------------------------------------------------------------
-- vytvoreni tabulek pro ulozeni informaci o interneteovych obchodech

CREATE SEQUENCE seq_wkonektor
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
    
ALTER TABLE public.seq_wkonektor OWNER TO %firmaRole%;

CREATE TABLE wkonektor (
  idkonektor integer NOT NULL DEFAULT nextval('seq_wkonektor'::regclass),
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  adresa character varying(255) NOT NULL,
  nazev character varying(255),
  organizace character varying(255),
  typ character varying(255),
  frekvenceK character varying(50) NOT NULL,
  poslSynch timestamp without time zone,
  login character varying(50) NOT NULL,
  heslo character varying(255),
  idtypdoklobj integer,
  typkonk character varying(50) NOT NULL,
  CONSTRAINT wkonektor_pkey PRIMARY KEY (idkonektor),
  CONSTRAINT idtypdoklobj_fk FOREIGN KEY (idtypdoklobj)
        REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE SET NULL
);

ALTER TABLE wkonektor OWNER TO %firmaRole%;

insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 115, 't');
