-- Bug 14995 – [WinStrom] Implementace mimořádných odpisů z protikrizového balíčku

CREATE OR REPLACE FUNCTION spustprotyporg(int[], text) RETURNS void
    AS $$
declare _idtyporgread int;
begin
  select idtyporg into _idtyporgread from nnastav limit 1;

  if (_idtyporgread = ANY ($1)) then
	execute $2;
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.spustprotyporg(int[], text) OWNER TO %firmaRole%;

select spustprotyporg(array[1, 2], 'INSERT INTO msazby (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, dobaodp, koefzrodp1, koefzrodpdalsi, koefzrodpzvceny, mindobaodp, prcroodp1, prcroodpdalsi, prcroodpzvceny, typodpk, zamek, zmena, uuid)
 VALUES (''2009-08-11 00:00:00'', ''MIM1'', ''Mimořádné odpisy 1 skupiny'', NULL, NULL, NULL, 2010, 2009, NULL, 
''Hmotný majetek zařazený v odpisové skupině 1 
podle přílohy č. 1 k tomuto zákonu pořízený
v období od 1. ledna 2009 do 30. června 2010
může poplatník, který je jeho prvním vlastníkem,
odepsat rovnoměrně bez přerušení
do 100 % vstupní ceny za 12 měsíců.'', true, 12, 0, 0, 0, 12, 0.5, 0.5, 0.5, ''typOdp.rovn'', false, false, ''CZ_MIM1'')');
select spustprotyporg(array[1, 2], 'INSERT INTO msazby (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, dobaodp, koefzrodp1, koefzrodpdalsi, koefzrodpzvceny, mindobaodp, prcroodp1, prcroodpdalsi, prcroodpzvceny, typodpk, zamek, zmena, uuid)
 VALUES (''2009-08-11 00:00:00'', ''MIM2'', ''Mimořádné odpisy 2 skupiny'', NULL, NULL, NULL, 2010, 2009, NULL, 
''Hmotný majetek zařazený v odpisové skupině 2
podle přílohy č. 1 k tomuto zákonu pořízený
v období od 1. ledna 2009 do 30. června 2010
může poplatník, který je jeho prvním vlastníkem,
odepsat bez přerušení do 100 % vstupní ceny
za 24 měsíců, přitom za prvních 12 měsíců uplatní
odpisy rovnoměrně do výše 60 % vstupní ceny
hmotného majetku a za dalších bezprostředně
následujících 12 měsíců uplatní odpisy rovnoměrně
do výše 40 % vstupní ceny hmotného majetku.'', true, 24, 0, 0, 0, 12, 0.5, 0.5, 0.5, ''typOdp.rovn'', false, false, ''CZ_MIM2'')');

-- zvýšení verze databáze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 134, 't');
