alter table dpolsklad add column vyrobnicislaok boolean not null default false;
alter table dpolfak add column vyrobnicislaok boolean not null default false;
alter table dpolint add column vyrobnicislaok boolean not null default false;
alter table dpolobch add column vyrobnicislaok boolean not null default false;

-- Function: svyrobniCisloInsertUpdateZavyrobneno()
-- DROP FUNCTION svyrobniCisloInsertUpdateZavyrobneno();
create or replace function svyrobniCisloInsertUpdateZavyrobneno()
returns trigger as
$BODY$
declare
  _pocetVyrCisel integer;
  _mnozMj numeric(19,6);
  _vyrobnicislaok boolean;
begin
  -- prijemka
  if(NEW.idPolSkladPrijem is not null and OLD.idPolSkladPrijem is null) or (NEW.idPolSkladPrijem <> OLD.idPolSkladPrijem) then
    select count(*) into _pocetVyrCisel from svyrobniCislo where idPolSkladPrijem = NEW.idPolSkladPrijem;
    select vyrobnicislaok, mnozMj into _vyrobnicislaok, _mnozMj from dPolSklad where idPolSklad = NEW.idPolSkladPrijem;
    if(_pocetVyrCisel <> _mnozMj and _vyrobnicislaok = true) then
      update dPolSklad set vyrobnicislaok = false where idPolSklad = NEW.idPolSkladPrijem;
    end if;
    if(_pocetVyrCisel = _mnozMj and _vyrobnicislaok = false) then
      update dPolSklad set vyrobnicislaok = true where idPolSklad = NEW.idPolSkladPrijem;
    end if;
  end if;
  -- vydejka
  if(NEW.idPolSkladVydej is not null and OLD.idPolSkladVydej is null) or (NEW.idPolSkladVydej <> OLD.idPolSkladVydej) then
    select count(*) into _pocetVyrCisel from svyrobniCislo where idPolSkladVydej = NEW.idPolSkladVydej;
    select vyrobnicislaok, mnozMj into _vyrobnicislaok, _mnozMj from dPolSklad where idPolSklad = NEW.idPolSkladVydej;
    if(_pocetVyrCisel <> _mnozMj and _vyrobnicislaok = true) then
      update dPolSklad set vyrobnicislaok = false where idPolSklad = NEW.idPolSkladVydej;
    end if;
    if(_pocetVyrCisel = _mnozMj and _vyrobnicislaok = false) then
      update dPolSklad set vyrobnicislaok = true where idPolSklad = NEW.idPolSkladVydej;
    end if;
  end if;

  -- prijata faktura
  if(NEW.idPolFakPrijem is not null and OLD.idPolFakPrijem is null) or (NEW.idPolFakPrijem <> OLD.idPolFakPrijem) then
    select count(*) into _pocetVyrCisel from svyrobniCislo where idPolFakPrijem = NEW.idPolFakPrijem;
    select vyrobnicislaok, mnozMj into _vyrobnicislaok, _mnozMj from dPolFak where idPolFak = NEW.idPolFakPrijem;
    if(_pocetVyrCisel <> _mnozMj and _vyrobnicislaok = true) then
      update dPolFak set vyrobnicislaok = false where idPolFak = NEW.idPolFakPrijem;
    end if;
    if(_pocetVyrCisel = _mnozMj and _vyrobnicislaok = false) then
      update dPolFak set vyrobnicislaok = true where idPolFak = NEW.idPolFakPrijem;
    end if;
  end if;
  -- vydana faktura
  if(NEW.idPolFakVydej is not null and OLD.idPolFakVydej is null) or (NEW.idPolFakVydej <> OLD.idPolFakVydej) then
    select count(*) into _pocetVyrCisel from svyrobniCislo where idPolFakVydej = NEW.idPolFakVydej;
    select vyrobnicislaok, mnozMj into _vyrobnicislaok, _mnozMj from dPolFak where idPolFak = NEW.idPolFakVydej;
    if(_pocetVyrCisel <> _mnozMj and _vyrobnicislaok = true) then
      update dPolFak set vyrobnicislaok = false where idPolFak = NEW.idPolFakVydej;
    end if;
    if(_pocetVyrCisel = _mnozMj and _vyrobnicislaok = false) then
      update dPolFak set vyrobnicislaok = true where idPolFak = NEW.idPolFakVydej;
    end if;
  end if;

  -- vydajovy pokladni doklad
  if(NEW.idPolIntPrijem is not null and OLD.idPolIntPrijem is null) or (NEW.idPolIntPrijem <> OLD.idPolIntPrijem) then
    select count(*) into _pocetVyrCisel from svyrobniCislo where idPolIntPrijem = NEW.idPolIntPrijem;
    select vyrobnicislaok, mnozMj into _vyrobnicislaok, _mnozMj from dPolInt where idPolInt = NEW.idPolIntPrijem;
    if(_pocetVyrCisel <> _mnozMj and _vyrobnicislaok = true) then
      update dPolInt set vyrobnicislaok = false where idPolInt = NEW.idPolIntPrijem;
    end if;
    if(_pocetVyrCisel = _mnozMj and _vyrobnicislaok = false) then
      update dPolInt set vyrobnicislaok = true where idPolInt = NEW.idPolIntPrijem;
    end if;
  end if;
  -- prijmovy pokladni doklad
  if(NEW.idPolIntVydej is not null and OLD.idPolIntVydej is null) or (NEW.idPolIntVydej <> OLD.idPolIntVydej) then
    select count(*) into _pocetVyrCisel from svyrobniCislo where idPolIntVydej = NEW.idPolIntVydej;
    select vyrobnicislaok, mnozMj into _vyrobnicislaok, _mnozMj from dPolInt where idPolInt = NEW.idPolIntVydej;
    if(_pocetVyrCisel <> _mnozMj and _vyrobnicislaok = true) then
      update dPolInt set vyrobnicislaok = false where idPolInt = NEW.idPolIntVydej;
    end if;
    if(_pocetVyrCisel = _mnozMj and _vyrobnicislaok = false) then
      update dPolInt set vyrobnicislaok = true where idPolInt = NEW.idPolIntVydej;
    end if;
  end if;
  RETURN NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION svyrobniCisloInsertUpdateZavyrobneno() OWNER TO %firmaRole%;


CREATE TRIGGER svyrobniCislaInsertUpdateZavyrobneno
  AFTER INSERT OR UPDATE
  ON svyrobnicislo
  FOR EACH ROW
  EXECUTE PROCEDURE svyrobniCisloInsertUpdateZavyrobneno();

-- nastaveni verze vytvorene databaze - nebudou se provadet upgrady s mensi nebo stejnou verzi
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 195, 't');
