-- create1
ALTER TABLE aadresar ALTER popis TYPE text;
ALTER TABLE abanspoj ALTER popis TYPE text;
ALTER TABLE akontakty ALTER popis TYPE text;
ALTER TABLE amisturc ALTER popis TYPE text;
ALTER TABLE askupfir ALTER popis TYPE text;
ALTER TABLE asmerkod ALTER popis TYPE text;
ALTER TABLE astaty ALTER popis TYPE text;
ALTER TABLE audalosti ALTER popis TYPE text;
ALTER TABLE ccenik ALTER popis TYPE text;
ALTER TABLE ccenik ALTER popisa TYPE text;
ALTER TABLE ccenik ALTER popisb TYPE text;
ALTER TABLE ccenik ALTER popisc TYPE text;
ALTER TABLE cmerjed ALTER popis TYPE text;
ALTER TABLE cskupzboz ALTER popis TYPE text;
ALTER TABLE ddoklfak ALTER popis TYPE text;
ALTER TABLE ddoklint ALTER popis TYPE text;
ALTER TABLE ddoklobch ALTER popis TYPE text;
ALTER TABLE ddoklsklad ALTER popis TYPE text;
ALTER TABLE delbanformat ALTER popis TYPE text;
ALTER TABLE dkonsym ALTER popis TYPE text;
ALTER TABLE dpolprikazuhr ALTER popis TYPE text;
ALTER TABLE drady ALTER popis TYPE text;
ALTER TABLE dtypdokl ALTER popis TYPE text;
ALTER TABLE idodpodm ALTER popis TYPE text;
ALTER TABLE idruhdopr ALTER popis TYPE text;
ALTER TABLE iintrmerjed ALTER popis TYPE text;
ALTER TABLE ikrajurc ALTER popis TYPE text;
ALTER TABLE inomen ALTER popis TYPE text;
ALTER TABLE iobchtrans ALTER popis TYPE text;
ALTER TABLE izvlpoh ALTER popis TYPE text;
ALTER TABLE mleasing ALTER popis TYPE text;
ALTER TABLE mmajetek ALTER popis TYPE text;
ALTER TABLE msazby ALTER popis TYPE text;
ALTER TABLE mtypleas ALTER popis TYPE text;
ALTER TABLE mtypmaj ALTER popis TYPE text;
ALTER TABLE mumisteni ALTER popis TYPE text;
ALTER TABLE nucetobdobi ALTER popis TYPE text;
ALTER TABLE skarty ALTER popis TYPE text;
ALTER TABLE skarty ALTER popisa TYPE text;
ALTER TABLE skarty ALTER popisb TYPE text;
ALTER TABLE skarty ALTER popisc TYPE text;
ALTER TABLE uclendph ALTER popis TYPE text;
ALTER TABLE umeny ALTER popis TYPE text;
ALTER TABLE usazbydph ALTER popis TYPE text;
ALTER TABLE usesradky ALTER popis TYPE text;
ALTER TABLE usestavy ALTER popis TYPE text;
ALTER TABLE ustducty ALTER popis TYPE text;
ALTER TABLE ustrediska ALTER popis TYPE text;
ALTER TABLE utyporg ALTER popis TYPE text;
ALTER TABLE uucty ALTER popis TYPE text;
ALTER TABLE uzakazky ALTER popis TYPE text;
ALTER TABLE wtiskses ALTER popis TYPE text;
ALTER TABLE wuzivatel ALTER popis TYPE text;
ALTER TABLE wvybklice ALTER popis TYPE text;

-- pokud chceme opravit typ musime ho smazat, ale nejprve smazeme funkci, co ho
-- pouziva a pak typ, typ zalozime a zalozime i funkci (taky zmeneno character varying na text)
DROP FUNCTION public.findvazbydokladu(_iddokl integer, _modul character varying);
DROP TYPE vazbadokladu;
CREATE TYPE vazbadokladu AS (
	idvazebnidoklad integer,
	datucto timestamp without time zone,
	datvyst timestamp without time zone,
	iddokl integer,
	kod character varying(255),
	modul character varying(255),
	modulk character varying(255),
	popis text,
	poznam text,
	sumcelkem double precision,
	sumcelkemmen double precision,
	typvazbyk character varying(255),
	varsym character varying(255),
	idmeny integer,
	iduziv integer,
	idtypdokl integer,
	novy boolean,
	uroven integer,
	stavk character varying(255)
);

CREATE OR REPLACE FUNCTION findvazbydokladu(_iddokl integer, _modul character varying) RETURNS SETOF vazbadokladu
    AS $$
declare
  zaznam Record;
  _uroven integer;
  _prechodVP boolean;    -- zda povolen prechod z PPV/OBV na PPP/OBP
begin
  _uroven = 1;
  _prechodVP = true;

  drop table if exists vazbydokladu;

  CREATE TEMPORARY TABLE vazbydokladu
   (idvazebnidoklad integer NOT NULL,
    datucto timestamp without time zone,
    datvyst timestamp without time zone,
    iddokl integer,
    kod character varying(255),
    modul character varying(255),
    modulk character varying(255),
    popis text,
    poznam text,
    sumcelkem double precision,
    sumcelkemmen double precision,
    typvazbyk character varying(255),
    varsym character varying(255),
    idmeny integer,
    iduziv integer,
    idtypdokl integer,
    novy boolean,
    uroven integer,
    stavk character varying(255),
    CONSTRAINT vazbydokladu_pkey PRIMARY KEY (idvazebnidoklad)
  ) WITH (OIDS=FALSE);

  perform findViceVazeb('vazbydokladu', _idDokl, _modul, 0, true);

  while (select count(*) from vazbydokladu where novy = true) > 0 LOOP
    if _prechodVP then
      select (count(*) = 0) into _prechodVP from vazbydokladu where modul in ('OBP', 'PPP') and novy = true;
    end if;

    for zaznam in (select * from vazbydokladu where novy = true)
    LOOP
      perform findViceVazeb('vazbydokladu', zaznam.idDokl, zaznam.modul, _uroven, _prechodVP);

      update vazbydokladu set novy = false where idvazebnidoklad = zaznam.idvazebnidoklad;
    end loop;

    _uroven = _uroven + 1;
  end loop;

  update vazbydokladu as V set modulK = modulK ||
    (case when (select typPohybuK from dDoklSklad where idDoklSklad = V.idDokl) = 'typPohybu.prijem' then 'PRI' else 'VYD' end)
    where V.modul = 'SKL';

  return query SELECT * FROM vazbydokladu;
end;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.findvazbydokladu(_iddokl integer, _modul character varying) OWNER TO %firmaRole%;

-- create2
ALTER TABLE utypucop ALTER popis TYPE text;
ALTER TABLE ccenhlad ALTER popis TYPE text;
ALTER TABLE wstrom ALTER popis TYPE text;
ALTER TABLE apsc ALTER popis TYPE text;

-- create3
ALTER TABLE pskuposob ALTER popis TYPE text;
ALTER TABLE pcismzdsloz ALTER popis TYPE text;
ALTER TABLE ptyppracpom ALTER popis TYPE text;
ALTER TABLE pmzdcalchlav ALTER popis TYPE text;
ALTER TABLE pmzdcalc ALTER popis TYPE text;
ALTER TABLE ptyppracpomparam ALTER popis TYPE text;
ALTER TABLE pmzdcalchrom ALTER popis TYPE text;

-- zvyseni cisla verze db
insert into dbversion(iddbversion, dbversion, needreimport)
        values (nextval('seq_dbversion'), 204, 't');