--------------------------------------------------------------------------------------------------------------------------
-- Bug 17027 – [WinStrom] Pořídím FV ze skladu s akt.datumem,opravím na dřívější datum, datum výdejky ale zůstává aktuální
--------------------------------------------------------------------------------------------------------------------------

-- Function: sprepoctisumydokladu(integer, date)
-- DROP FUNCTION sprepoctisumydokladu(integer, date);
CREATE OR REPLACE FUNCTION sprepoctisumydokladu(i_iddoklsklad integer, i_datVyst date)
  RETURNS void AS
$BODY$
declare
 _sumZkl numeric(15,2);
 _sumZklMen numeric(15,2);
begin
 select sum(sumZkl), sum(sumZklMen) into _sumZkl, _sumZklMen from dPolSklad where idDoklSklad = i_idDoklSklad and stornoPol = false;
 if(_sumZkl is null) then _sumZkl = 0.0; end if;
 if(_sumZklMen is null) then _sumZklMen = 0.0; end if;
 update dDoklSklad set sumCelkem = _sumZkl, sumCelkemMen = _sumZklMen, datVyst = i_datVyst, datUcto = i_datVyst where idDoklSklad = i_idDoklSklad;
end
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sprepoctisumydokladu(integer, date) OWNER TO %firmaRole%;


-- Function: dpoldoklupdatesklad()
-- DROP FUNCTION dpoldoklupdatesklad();
CREATE OR REPLACE FUNCTION dpoldoklupdatesklad()
  RETURNS trigger AS
$BODY$ 
declare 
  _idPolDokl integer; 
  _idDoklad integer; 
  _idPolSklad integer; 
  _idDoklSklad integer; 
  _dokladGenerovatSkl boolean; 
  _typDoklGenerovatSkl boolean; 
  _typZasobyK character varying; 
  _vyrobniCislo record; 
  _typPohybuK character varying; 
  _sadaItemCount integer; 
begin 
  if(NEW.storno <> OLD.storno or NEW.stornoPol <> OLD.stornoPol) then 
    return NEW; 
  end if; 
 
  if(NEW.modul like 'POK') then 
    _idPolDokl = NEW.idPolInt; 
    _idDoklad = NEW.idDoklInt; 
    select generovatSkl into _dokladGenerovatSkl from dDoklInt where idDoklInt = NEW.idDoklInt; 
    select generovatSkl into _typDoklGenerovatSkl from dTypDokl where idTypDokl = (select idTypDokl from dDoklInt where idDoklInt = NEW.idDoklInt); 
 
    select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolInt where idpolint = NEW.idPolInt); 
  elsif (NEW.modul like 'FAV' or NEW.modul like 'FAP') then 
    _idPolDokl = NEW.idPolFak; 
    _idDoklad = NEW.idDoklFak; 
    select generovatSkl into _dokladGenerovatSkl from dDoklFak where idDoklFak = NEW.idDoklFak; 
    select generovatSkl into _typDoklGenerovatSkl from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = NEW.idDoklFak); 
 
    select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolfak where idpolfak = NEW.idPolFak); 
  else  
    return NEW;   
  end if; 
 
  -- pokud se lisi sklad, cenik, typPolozky, mnozMj, sarze, expirace 
  -- tak skladovou polozku musim smazat a vytvorit znovu kvuli fifu 
  if(NEW.idSkladu <> OLD.idSkladu or NEW.idCenik <> OLD.idCenik  
     or NEW.typPolozkyK <> OLD.typPolozkyK or NEW.mnozMj <> OLD.mnozMj 
     or NEW.sarze <> OLD.sarze or NEW.expirace <> OLD.expirace) then 
    --raise exception 'mazu polSklad'; 
    execute deleteNavazanePolSklad(_idPolDokl, NEW.modul); 
  end if; 
 
  if(NEW.typPolozkyK like 'typPolozky.katalog') then 
    select typZasobyK into _typZasobyK from cCenik where idCenik = NEW.idCenik; 
     
    if (_typZasobyK like 'typZasoby.skladem' or _typZasobyK like 'typZasoby.vyrobek') then 
      select findParovanyPolSklad(_idPolDokl, NEW.modul) into _idPolSklad; 
      if(_idPolSklad is null) then 
        --select createPolSklad(_idPolDokl, NEW.modul) into _idPolSklad;  
        if(_sadaItemCount > 0) then 
          execute createPolSkladSada(_idPolDokl, NEW.modul); 
        else 
          select createPolSklad(_idPolDokl, NEW.modul) into _idPolSklad;  
        end if; 
      else 
        if(_sadaItemCount > 0) then 
          execute fillPolSkladSada(_idPolDokl, NEW.modul); 
        else 
          select fillPolSklad(_idPolSklad, _idPolDokl, NEW.modul) into _idPolSklad;  
        end if; 
      end if; 
      -- provedeni upgradu vyrobnich cisel 
      if(NEW.modul like 'FAV') then 
        for _vyrobniCislo in select * from sVyrobniCislo where idPolFakVydej = NEW.idPolFak loop 
          update sVyrobniCislo set idPolSkladVydej = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
        end loop; 
      end if; 
      if(NEW.modul like 'FAP') then 
        for _vyrobniCislo in select * from sVyrobniCislo where idPolFakPrijem = NEW.idPolFak loop 
          update sVyrobniCislo set idPolSkladPrijem = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
        end loop; 
      end if; 
      if(NEW.modul like 'POK') then 
        select typPohybuK into _typPohybuK from dDoklInt where idDoklInt = _idDoklad; 
        if(_typPohybuK like 'typPohybu.prijem') then 
          for _vyrobniCislo in select * from sVyrobniCislo where idPolIntVydej = NEW.idPolInt loop 
            update sVyrobniCislo set idPolSkladVydej = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
          end loop; 
        else 
          for _vyrobniCislo in select * from sVyrobniCislo where idPolIntPrijem = NEW.idPolInt loop 
            update sVyrobniCislo set idPolSkladPrijem = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
          end loop; 
        end if; 
      end if; 
 
    end if; 
    -- prepocteni sum na dokladu 
    select findParovanyDoklSklad(_idDoklad, NEW.modul) into _idDoklSklad; 
    execute sprepoctiSumyDokladu(_idDoklSklad, NEW.datVyst); 
  end if; 
 
  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpoldoklupdatesklad() OWNER TO %firmaRole%;


-- Function: fillpolsklad(integer, integer, character varying)
-- DROP FUNCTION fillpolsklad(integer, integer, character varying);
CREATE OR REPLACE FUNCTION fillpolsklad(_idpolsklad integer, _idpoldokl integer, _modul character varying)
  RETURNS integer AS
$BODY$ 
declare 
  _polDokl record; 
  _polSklad record; 
  _idDoklad integer; 
  _typPohybuK character varying; 
  _typPohybuSklad character varying; 
  _cenaMj numeric(19,6); 
  _cenaMjTuz numeric(19,6); 
  _mnozMj numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _idDoklSklad integer; 
  _idUcetObdobi integer; 
  _idKarty integer; 
  _sklad record; 
  _kurz numeric(19,6); 
  _prumCenaTuz numeric(19,6); 
  _isCiziMena boolean; 
  _typDoklK character varying; 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
begin 
  if(_modul like 'POK') then 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    select idDoklInt, typPohybuK into _idDoklad, _typPohybuK from dDoklInt where idDoklInt = _polDokl.idDoklInt; 
    _typDoklK = null; -- pro pokladnu dobropisy nejsou 
  else 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    select idDoklFak, typPohybuK into _idDoklad, _typPohybuK from dDoklFak where idDoklFak = _polDokl.idDoklFak; 
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak); 
  end if; 
 
  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad; 
   
  if(_idDoklSklad is null) then 
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad; 
  end if; 
 
  select * into _polSklad from dPolSklad where idPolSklad = _idPolSklad; 
  select typPohybuK into _typPohybuSklad from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad; 
 
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi; 
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idtypdokl = _polDokl.idskladu and iducetobdobi = _iducetobdobi; 
  select * into _sklad from dTypDokl where idTypDokl = _polDokl.idSkladu; 
   
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty; 
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena; 
 
  if(_typPohybuSklad like 'typPohybu.vydej') then 
    -- vsechny dobropisy generuji prijemky 
    --if(_typDoklK like 'typDokladu.dobropis') then 
    --  _mnozMj = -_polDokl.mnozMj; 
    --else 
      _mnozMj = _polDokl.mnozMj; 
    --end if; 
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena 
    _cenaMj = _polSklad.cenaMj; 
    _sumZkl = _polSklad.sumZkl; 
    _sumZklMen = _polSklad.sumZklMen; 
    -- nastaveni uctu pro polSklad vydej 
    select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet; 
    _idZklDalUcet = _sklad.idPrimUcet; 
  else 
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then 
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny; 
      _mnozMj = -_polDokl.mnozMj; 
      _cenaMjTuz = _prumCenaTuz; 
      if(_cenaMjTuz = 0.0) then 
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik); 
        if(_cenaMj = 0.0) then 
          _cenaMj = _polDokl.cenaMj * _kurz; 
        end if; 
      end if; 
      _cenaMj = _cenaMjTuz / _kurz; 
      _sumZkl = _mnozMj * _cenaMjTuz; 
      if(_isCiziMena) then 
        _sumZklMen = _mnozMj * _cenaMj; 
      else 
        _sumZklMen = 0.0; 
      end if; 
    else 
      -- pokud na sklad prijmam zkopiruji se ceny z faktury 
      _mnozMj = _polDokl.mnozMj; 
      _sumZkl = _polDokl.sumZkl; 
      if(_mnozMj <> 0.0) then 
        _cenaMj = _sumZkl / _mnozMj; 
      else 
        _cenaMj = _sumZkl; 
      end if; 
      _cenaMj = _cenaMj / _kurz; 
      if(_isCiziMena) then 
        if(_mnozMj <> 0.0) then 
          _sumZklMen = _cenaMj * _mnozMj;   
        else 
          _sumZklMen = _cenaMj; 
        end if; 
      else 
        _sumZklMen = 0.0;   
      end if;  
    end if; 
    -- nastaveni uctu pro polSklad prijem 
    _idZklMdUcet = _sklad.idPrimUcet; 
    _idZklDalUcet = _polDokl.idZklMdUcet; 
  end if; 
   
  update dPolSklad set  
    cenaMj = _cenaMj,  
    mnozMj = _mnozMj,  
    sumZkl = _sumZkl,  
    sumZklMen = _sumZklMen,  
    nazev = _polDokl.nazev,  
    nazevA = _polDokl.nazevA,  
    nazevB = _polDokl.nazevB,  
    nazevC = _polDokl.nazevC,  
    datVyst = _polDokl.datVyst,
    datUcto = _polDokl.datVyst,
    baleniId = _polDokl.baleniId,  
    mnozBaleni = _polDokl.mnozBaleni,  
    sarze = _polDokl.sarze,  
    expirace = _polDokl.expirace,  
    cisRad = _polDokl.cisRad,  
    eankod = _polDokl.eanKod,  
    idmj = _polDokl.idmj,  
    idStred = _polDokl.idStred,  
    idMeny = _polSklad.idMeny,  
    idZakazky = _polDokl.idZakazky,  
    idZklMdUcet = _idZklMdUcet,  
    idZklDalUcet = _idZklDalUcet, 
    ucetni = true 
    where idPolSklad = _idPolSklad; 
 
  return _idPolSklad; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION fillpolsklad(integer, integer, character varying) OWNER TO %firmaRole%;


-- Function: fillpolskladsada(integer, character varying)
-- DROP FUNCTION fillpolskladsada(integer, character varying);
CREATE OR REPLACE FUNCTION fillpolskladsada(_idpoldokl integer, _modul character varying)
  RETURNS void AS
$BODY$
declare
  _polDokl record;
  _polSklad record;
  _idDoklad integer;
  _typPohybuK character varying;
  _typPohybuSklad character varying;
  _cenaMj numeric(19,6);
  _cenaMjTuz numeric(19,6);
  _mnozMj numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _idDoklSklad integer;
  _idUcetObdobi integer;
  _idKarty integer;
  _sklad record;
  _kurz numeric(19,6);
  _prumCenaTuz numeric(19,6);
  _isCiziMena boolean;
  _typDoklK character varying;
  _idZklMdUcet integer;
  _idZklDalUcet integer;
begin
  if(_modul like 'POK') then
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;
    select idDoklInt, typPohybuK into _idDoklad, _typPohybuK from dDoklInt where idDoklInt = _polDokl.idDoklInt;
    _typDoklK = null; -- pro pokladnu dobropisy nejsou
  else
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;
    select idDoklFak, typPohybuK into _idDoklad, _typPohybuK from dDoklFak where idDoklFak = _polDokl.idDoklFak;
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);
  end if;

  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad;
  if(_idDoklSklad is null) then
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;
  end if;

  for _polSklad in
    select * from dPolSklad where idPolSklad in (
      select idTabB from dvazebtab where
        typVazbyK like 'typVazbyDokl.polozkaSklSada'
        and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL'
    )
  loop
    select typPohybuK into _typPohybuSklad from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad;

    select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;
    select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idtypdokl = _polDokl.idskladu and iducetobdobi = _iducetobdobi;
    select * into _sklad from dTypDokl where idTypDokl = _polDokl.idSkladu;

    select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;
    select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty;
    select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;

    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena
    _cenaMj = _polSklad.cenaMj;
    _mnozMj = _polSklad.mnozMj;
    _sumZkl = _polSklad.sumZkl;
    _sumZklMen = _polSklad.sumZklMen;
    -- nastaveni uctu pro polSklad vydej
    --TODO doresit zklMdUcet;
    --select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet;
    _idZklDalUcet = _sklad.idPrimUcet;

    update dPolSklad set
      cenaMj = _cenaMj,
      mnozMj = _mnozMj,
      sumZkl = _sumZkl,
      sumZklMen = _sumZklMen,
      --nazev = _polDokl.nazev,
      --nazevA = _polDokl.nazevA,
      --nazevB = _polDokl.nazevB,
      --nazevC = _polDokl.nazevC,
      datVyst = _polDokl.datVyst,
      datUcto = _polDokl.datVyst,
      baleniId = _polDokl.baleniId,
      mnozBaleni = _polDokl.mnozBaleni,
      --sarze = _polDokl.sarze,
      --expirace = _polDokl.expirace,
      --cisRad = _polDokl.cisRad,
      --eankod = _polDokl.eanKod,
      --idmj = _polDokl.idmj,
      idStred = _polDokl.idStred,
      idMeny = _polSklad.idMeny,
      idZakazky = _polDokl.idZakazky,
      --idZklMdUcet = _idZklMdUcet,
      idZklDalUcet = _idZklDalUcet,
      ucetni = true
      where idPolSklad = _polSklad.idPolSklad;
  end loop;
  --return _idPolSklad;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION fillpolskladsada(integer, character varying) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 229, 't');