--------------------------------------------------------------------------------
-- Bug 17557 – [WinStrom] Aktualizace kalkulačky na rok 2010
--------------------------------------------------------------------------------

-- doplneni sloupcu pro typ zavazku na osobe
ALTER TABLE posoba ADD COLUMN idtddobirka integer;
ALTER TABLE posoba ADD COLUMN idtdzaloha integer;

ALTER TABLE posoba ADD CONSTRAINT fkc3adf9fa83f14203 FOREIGN KEY (idtddobirka)
  REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE posoba ADD CONSTRAINT fkc3adf9fa84178d26 FOREIGN KEY (idtdzaloha)
  REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX pOsoba_IdTdDobirka_index ON pOsoba USING btree (IdTdDobirka);
CREATE INDEX pOsoba_IdTdZaloha_index ON pOsoba USING btree (IdTdZaloha);




create or replace function runupgrade()
    returns void as $$
declare
    stat character varying(10);
    pocet integer;
begin
  select a.uuid into stat from nnastav n  left join utyporg u on u.idtyporg = n.idtyporg left join astaty a on a.idstatu = u.idstatu
    where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);
  
  -- kalkulacku aktualizujeme jen pro cechy
  if (stat = 'CZ_CZ') then
-- zacatek ceskeho bloku
-- update slozek
UPDATE pcismzdsloz SET kod = 'PŘEČERPANÁ DOVOLENÁ' WHERE IdCisMzdSloz = 48;
UPDATE pcismzdsloz SET nazev = 'Odečet bonusu v příkazu k úhradě' WHERE IdCisMzdSloz = 228;
UPDATE pcismzdsloz SET vsprocmzd = true WHERE IdCisMzdSloz = 250;
UPDATE pcismzdsloz SET kod = 'PŘE(NEDO)PLATEK DANĚ', nazev = 'Přeplatek(+) nebo nedoplatek(-) daně z ročního zúčtování', naosobu = true WHERE IdCisMzdSloz = 254;
INSERT INTO pcismzdsloz (idcismzdsloz, lastUpdate, kod, nazev, show, typslozkyk, skupslozkyk, naosobu, vsdatod, vsdatdo, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vshodinysvatek, vscastnahod, vscastnaden, vsprocmzd, vszaklmzd, vszakljekracen, vscastmzd, vszmenacastmzd, vspocetmes, vscisdoklnem, vsdoplatzdrpoj, vsprumnadennem, vsprumnahodnem, vyznamk, dnyprac, dnykal, dnysvatek, hodiny, castkahod, castkaden, procmzd, zaklmzd, zakljekracen, castmzd, zmenacastmzd, prumnadennem, prumnahodnem, pracovni)
 VALUES (255, '2010-02-25 00:00:00.000', 'ZŮČTOVÁNÍ DANĚ ', 'Roční zúčtování daně do příkazu k úhradě', true, 'typSlozky.vypocet', 'skupinaSlozky.dan', true, false, false, false, false, false, false, false, false, false, false, false, false, true, false, false, false, false, false, false, 'vyznamSlozky.danZaloha', 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, false, 0.0, false, 0.0, 0.0, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastUpdate, kod, nazev, show, cisrad, typslozkyk, skupslozkyk, naosobu, vsdatod, vsdatdo, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vshodinysvatek, vscastnahod, vscastnaden, vsprocmzd, vszaklmzd, vszakljekracen, vscastmzd, vszmenacastmzd, vspocetmes, vscisdoklnem, vsdoplatzdrpoj, vsprumnadennem, vsprumnahodnem, dnyprac, dnykal, dnysvatek, hodiny, castkahod, castkaden, procmzd, zaklmzd, zakljekracen, castmzd, zmenacastmzd, prumnadennem, prumnahodnem, pracovni)
 VALUES (256, '2010-02-25 00:00:00.000', 'SVÁTEK', 'Svátek', true, 2000, 'typSlozky.vypocet', 'skupinaSlozky.nepritomnost', false, false, false, false, true, false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, false, 0.0, false, 0.0, 0.0, false);

DELETE FROM pmzdsloz WHERE IdCisMzdSloz = 66;
DELETE FROM pmzdsloz WHERE IdCisMzdSloz = 67;
DELETE FROM pstalamzdsloz WHERE IdCisMzdSloz = 66;
DELETE FROM pstalamzdsloz WHERE IdCisMzdSloz = 67;
DELETE FROM pcismzdsloz WHERE IdCisMzdSloz = 66;
DELETE FROM pcismzdsloz WHERE IdCisMzdSloz = 67;

PERFORM pg_catalog.setval('seq_pcismzdsloz', 256, true);

-- update inicializacnich radek kalkulacky
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastUpdate, kod, nazev, popis, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
 VALUES (19, '2010-02-26 00:00:00.000', 'SVÁTEK', 'Svátek', '', true, 17, 'mzdCalcZdroj.pracPom', 'svatkyPrumer', 'procMzd', 'mzdCalcPlatnost.vzdy', 1, 256);

PERFORM pg_catalog.setval('seq_pmzdcalcinit', 19, true);

-- update radek kalkulacky
DELETE FROM pmzdcalc WHERE IdMzdCalc = 54;
DELETE FROM pmzdcalc WHERE IdMzdCalc = 539;
DELETE FROM pmzdcalc WHERE IdMzdCalc = 415;
UPDATE pmzdcalc SET cisrad = 35 WHERE IdMzdCalc = 1;
UPDATE pmzdcalc SET cisrad = 36 WHERE IdMzdCalc = 5;
UPDATE pmzdcalc SET cisrad = 42 WHERE IdMzdCalc = 7;
UPDATE pmzdcalc SET cisrad = 41 WHERE IdMzdCalc = 8;
UPDATE pmzdcalc SET cisrad = 43 WHERE IdMzdCalc = 9;
UPDATE pmzdcalc SET cisrad = 45 WHERE IdMzdCalc = 11;
UPDATE pmzdcalc SET cisrad = 50 WHERE IdMzdCalc = 24;
UPDATE pmzdcalc SET cisrad = 96 WHERE IdMzdCalc = 27;
UPDATE pmzdcalc SET cisrad = 95 WHERE IdMzdCalc = 29;
UPDATE pmzdcalc SET cisrad = 51 WHERE IdMzdCalc = 30;
UPDATE pmzdcalc SET cisrad = 100 WHERE IdMzdCalc = 31;
UPDATE pmzdcalc SET cisrad = 52 WHERE IdMzdCalc = 32;
UPDATE pmzdcalc SET cisrad = 53 WHERE IdMzdCalc = 33;
UPDATE pmzdcalc SET cisrad = 58 WHERE IdMzdCalc = 34;
UPDATE pmzdcalc SET cisrad = 59 WHERE IdMzdCalc = 35;
UPDATE pmzdcalc SET cisrad = 60 WHERE IdMzdCalc = 37;
UPDATE pmzdcalc SET cisrad = 61 WHERE IdMzdCalc = 38;
UPDATE pmzdcalc SET cisrad = 62 WHERE IdMzdCalc = 40;
UPDATE pmzdcalc SET cisrad = 83 WHERE IdMzdCalc = 41;
UPDATE pmzdcalc SET cisrad = 91 WHERE IdMzdCalc = 42;
UPDATE pmzdcalc SET cisrad = 85 WHERE IdMzdCalc = 43;
UPDATE pmzdcalc SET cisrad = 89 WHERE IdMzdCalc = 44;
UPDATE pmzdcalc SET cisrad = 93 WHERE IdMzdCalc = 45;
UPDATE pmzdcalc SET cisrad = 77 WHERE IdMzdCalc = 46;
UPDATE pmzdcalc SET cisrad = 94 WHERE IdMzdCalc = 47;
UPDATE pmzdcalc SET cisrad = 80 WHERE IdMzdCalc = 48;
UPDATE pmzdcalc SET cisrad = 92 WHERE IdMzdCalc = 49;
UPDATE pmzdcalc SET cisrad = 98 WHERE IdMzdCalc = 51;
UPDATE pmzdcalc SET cisrad = 99 WHERE IdMzdCalc = 52;
UPDATE pmzdcalc SET cisrad = 101 WHERE IdMzdCalc = 53;
UPDATE pmzdcalc SET cisrad = 102 WHERE IdMzdCalc = 55;
UPDATE pmzdcalc SET cisrad = 103 WHERE IdMzdCalc = 56;
UPDATE pmzdcalc SET cisrad = 104 WHERE IdMzdCalc = 57;
UPDATE pmzdcalc SET cisrad = 97 WHERE IdMzdCalc = 58;
UPDATE pmzdcalc SET cisrad = 105 WHERE IdMzdCalc = 59;
UPDATE pmzdcalc SET cisrad = 106 WHERE IdMzdCalc = 61;
UPDATE pmzdcalc SET cisrad = 107 WHERE IdMzdCalc = 62;
UPDATE pmzdcalc SET cisrad = 108 WHERE IdMzdCalc = 63;
UPDATE pmzdcalc SET cisrad = 122 WHERE IdMzdCalc = 64;
UPDATE pmzdcalc SET cisrad = 147 WHERE IdMzdCalc = 68;
UPDATE pmzdcalc SET cisrad = 148 WHERE IdMzdCalc = 69;
UPDATE pmzdcalc SET cisrad = 162 WHERE IdMzdCalc = 70;
UPDATE pmzdcalc SET cisrad = 137 WHERE IdMzdCalc = 75;
UPDATE pmzdcalc SET cisrad = 150 WHERE IdMzdCalc = 76;
UPDATE pmzdcalc SET cisrad = 163 WHERE IdMzdCalc = 78;
UPDATE pmzdcalc SET cisrad = 192 WHERE IdMzdCalc = 79;
UPDATE pmzdcalc SET cisrad = 178 WHERE IdMzdCalc = 80;
UPDATE pmzdcalc SET cisrad = 179 WHERE IdMzdCalc = 81;
UPDATE pmzdcalc SET cisrad = 180 WHERE IdMzdCalc = 82;
UPDATE pmzdcalc SET cisrad = 181 WHERE IdMzdCalc = 83;
UPDATE pmzdcalc SET cisrad = 182 WHERE IdMzdCalc = 86;
UPDATE pmzdcalc SET cisrad = 187 WHERE IdMzdCalc = 89;
UPDATE pmzdcalc SET cisrad = 186 WHERE IdMzdCalc = 92;
UPDATE pmzdcalc SET cisrad = 188 WHERE IdMzdCalc = 93;
UPDATE pmzdcalc SET cisrad = 194 WHERE IdMzdCalc = 94;
UPDATE pmzdcalc SET cisrad = 213 WHERE IdMzdCalc = 95;
UPDATE pmzdcalc SET cisrad = 217 WHERE IdMzdCalc = 96;
UPDATE pmzdcalc SET cisrad = 222 WHERE IdMzdCalc = 97;
UPDATE pmzdcalc SET cisrad = 223 WHERE IdMzdCalc = 98;
UPDATE pmzdcalc SET cisrad = 266 WHERE IdMzdCalc = 99;
UPDATE pmzdcalc SET cisrad = 233 WHERE IdMzdCalc = 100;
UPDATE pmzdcalc SET cisrad = 265 WHERE IdMzdCalc = 101;
UPDATE pmzdcalc SET cisrad = 234 WHERE IdMzdCalc = 103;
UPDATE pmzdcalc SET cisrad = 240 WHERE IdMzdCalc = 104;
UPDATE pmzdcalc SET cisrad = 241 WHERE IdMzdCalc = 106;
UPDATE pmzdcalc SET cisrad = 242 WHERE IdMzdCalc = 107;
UPDATE pmzdcalc SET cisrad = 243 WHERE IdMzdCalc = 108;
UPDATE pmzdcalc SET cisrad = 244 WHERE IdMzdCalc = 109;
UPDATE pmzdcalc SET cisrad = 245 WHERE IdMzdCalc = 110;
UPDATE pmzdcalc SET cisrad = 251 WHERE IdMzdCalc = 111;
UPDATE pmzdcalc SET cisrad = 274 WHERE IdMzdCalc = 112;
UPDATE pmzdcalc SET cisrad = 275 WHERE IdMzdCalc = 113;
UPDATE pmzdcalc SET cisrad = 272 WHERE IdMzdCalc = 114;
UPDATE pmzdcalc SET cisrad = 136 WHERE IdMzdCalc = 115;
UPDATE pmzdcalc SET cisrad = 135 WHERE IdMzdCalc = 116;
UPDATE pmzdcalc SET cisrad = 276 WHERE IdMzdCalc = 117;
UPDATE pmzdcalc SET cisrad = 171 WHERE IdMzdCalc = 119;
UPDATE pmzdcalc SET cisrad = 191 WHERE IdMzdCalc = 120;
UPDATE pmzdcalc SET cisrad = 164 WHERE IdMzdCalc = 121;
UPDATE pmzdcalc SET cisrad = 193 WHERE IdMzdCalc = 122;
UPDATE pmzdcalc SET cisrad = 237 WHERE IdMzdCalc = 123;
UPDATE pmzdcalc SET cisrad = 224 WHERE IdMzdCalc = 124;
UPDATE pmzdcalc SET cisrad = 250 WHERE IdMzdCalc = 125;
UPDATE pmzdcalc SET cisrad = 235 WHERE IdMzdCalc = 130;
UPDATE pmzdcalc SET cisrad = 238 WHERE IdMzdCalc = 131;
UPDATE pmzdcalc SET cisrad = 149 WHERE IdMzdCalc = 133;
UPDATE pmzdcalc SET cisrad = 183 WHERE IdMzdCalc = 134;
UPDATE pmzdcalc SET cisrad = 184 WHERE IdMzdCalc = 135;
UPDATE pmzdcalc SET cisrad = 247 WHERE IdMzdCalc = 136;
UPDATE pmzdcalc SET cisrad = 270 WHERE IdMzdCalc = 139;
UPDATE pmzdcalc SET cisrad = 271 WHERE IdMzdCalc = 140;
UPDATE pmzdcalc SET cisrad = 267 WHERE IdMzdCalc = 145;
UPDATE pmzdcalc SET cisrad = 273 WHERE IdMzdCalc = 146;
UPDATE pmzdcalc SET cisrad = 278 WHERE IdMzdCalc = 147;
UPDATE pmzdcalc SET cisrad = 281 WHERE IdMzdCalc = 172;
UPDATE pmzdcalc SET cisrad = 282 WHERE IdMzdCalc = 173;
UPDATE pmzdcalc SET cisrad = 283 WHERE IdMzdCalc = 174;
UPDATE pmzdcalc SET cisrad = 284 WHERE IdMzdCalc = 175;
UPDATE pmzdcalc SET cisrad = 7 WHERE IdMzdCalc = 181;
UPDATE pmzdcalc SET cisrad = 8 WHERE IdMzdCalc = 183;
UPDATE pmzdcalc SET cisrad = 9 WHERE IdMzdCalc = 184;
UPDATE pmzdcalc SET cisrad = 10 WHERE IdMzdCalc = 185;
UPDATE pmzdcalc SET cisrad = 11 WHERE IdMzdCalc = 186;
UPDATE pmzdcalc SET cisrad = 12 WHERE IdMzdCalc = 187;
UPDATE pmzdcalc SET cisrad = 13 WHERE IdMzdCalc = 188;
UPDATE pmzdcalc SET cisrad = 14 WHERE IdMzdCalc = 189;
UPDATE pmzdcalc SET cisrad = 15 WHERE IdMzdCalc = 190;
UPDATE pmzdcalc SET cisrad = 16 WHERE IdMzdCalc = 191;
UPDATE pmzdcalc SET cisrad = 17 WHERE IdMzdCalc = 192;
UPDATE pmzdcalc SET cisrad = 279 WHERE IdMzdCalc = 193;
UPDATE pmzdcalc SET cisrad = 280 WHERE IdMzdCalc = 194;
UPDATE pmzdcalc SET cisrad = 290, polein = 'prumNaHodNem;prumNaHodNem', poleout = 'castMzd;castkaHod' WHERE IdMzdCalc = 195;
UPDATE pmzdcalc SET cisrad = 299, polein = 'prumNaHodNem;prumNaHodNem', poleout = 'castMzd;castkaHod', operacek = 'mzdCalcOper.plus' WHERE IdMzdCalc = 196;
UPDATE pmzdcalc SET cisrad = 285 WHERE IdMzdCalc = 197;
UPDATE pmzdcalc SET cisrad = 291, polein2 = 'castkaHod', idmzdslozin2 = 70 WHERE IdMzdCalc = 198;
UPDATE pmzdcalc SET cisrad = 301 WHERE IdMzdCalc = 200;
UPDATE pmzdcalc SET cisrad = 293 WHERE IdMzdCalc = 201;
UPDATE pmzdcalc SET cisrad = 292 WHERE IdMzdCalc = 202;
UPDATE pmzdcalc SET cisrad = 300, polein2 = 'castkaHod', idmzdslozin2 = 177 WHERE IdMzdCalc = 206;
UPDATE pmzdcalc SET cisrad = 302 WHERE IdMzdCalc = 207;
UPDATE pmzdcalc SET cisrad = 21 WHERE IdMzdCalc = 208;
UPDATE pmzdcalc SET polein = 'dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek', poleout = 'dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek' WHERE IdMzdCalc = 209;
UPDATE pmzdcalc SET cisrad = 37 WHERE IdMzdCalc = 211;
UPDATE pmzdcalc SET cisrad = 304 WHERE IdMzdCalc = 213;
UPDATE pmzdcalc SET cisrad = 305 WHERE IdMzdCalc = 214;
UPDATE pmzdcalc SET cisrad = 306 WHERE IdMzdCalc = 215;
UPDATE pmzdcalc SET cisrad = 32 WHERE IdMzdCalc = 216;
UPDATE pmzdcalc SET cisrad = 31 WHERE IdMzdCalc = 217;
UPDATE pmzdcalc SET cisrad = 318 WHERE IdMzdCalc = 221;
UPDATE pmzdcalc SET cisrad = 313 WHERE IdMzdCalc = 222;
UPDATE pmzdcalc SET cisrad = 317 WHERE IdMzdCalc = 223;
UPDATE pmzdcalc SET cisrad = 118 WHERE IdMzdCalc = 225;
UPDATE pmzdcalc SET cisrad = 254 WHERE IdMzdCalc = 227;
UPDATE pmzdcalc SET cisrad = 6 WHERE IdMzdCalc = 228;
UPDATE pmzdcalc SET kod = '2', cisrad = 29 WHERE IdMzdCalc = 234;
UPDATE pmzdcalc SET cisrad = 34 WHERE IdMzdCalc = 236;
UPDATE pmzdcalc SET cisrad = 256 WHERE IdMzdCalc = 238;
UPDATE pmzdcalc SET cisrad = 252 WHERE IdMzdCalc = 239;
UPDATE pmzdcalc SET cisrad = 257 WHERE IdMzdCalc = 240;
UPDATE pmzdcalc SET cisrad = 258 WHERE IdMzdCalc = 241;
UPDATE pmzdcalc SET cisrad = 262 WHERE IdMzdCalc = 245;
UPDATE pmzdcalc SET cisrad = 263 WHERE IdMzdCalc = 247;
UPDATE pmzdcalc SET cisrad = 264 WHERE IdMzdCalc = 249;
UPDATE pmzdcalc SET cisrad = 174 WHERE IdMzdCalc = 250;
UPDATE pmzdcalc SET cisrad = 173 WHERE IdMzdCalc = 251;
UPDATE pmzdcalc SET cisrad = 175 WHERE IdMzdCalc = 252;
UPDATE pmzdcalc SET cisrad = 176 WHERE IdMzdCalc = 253;
UPDATE pmzdcalc SET cisrad = 177 WHERE IdMzdCalc = 254;
UPDATE pmzdcalc SET cisrad = 314 WHERE IdMzdCalc = 256;
UPDATE pmzdcalc SET cisrad = 195 WHERE IdMzdCalc = 258;
UPDATE pmzdcalc SET cisrad = 196 WHERE IdMzdCalc = 259;
UPDATE pmzdcalc SET cisrad = 197 WHERE IdMzdCalc = 260;
UPDATE pmzdcalc SET cisrad = 198 WHERE IdMzdCalc = 261;
UPDATE pmzdcalc SET cisrad = 200 WHERE IdMzdCalc = 262;
UPDATE pmzdcalc SET cisrad = 81 WHERE IdMzdCalc = 272;
UPDATE pmzdcalc SET cisrad = 82 WHERE IdMzdCalc = 274;
UPDATE pmzdcalc SET cisrad = 73 WHERE IdMzdCalc = 275;
UPDATE pmzdcalc SET cisrad = 71 WHERE IdMzdCalc = 278;
UPDATE pmzdcalc SET cisrad = 72 WHERE IdMzdCalc = 280;
UPDATE pmzdcalc SET cisrad = 75 WHERE IdMzdCalc = 281;
UPDATE pmzdcalc SET cisrad = 76 WHERE IdMzdCalc = 282;
UPDATE pmzdcalc SET cisrad = 78 WHERE IdMzdCalc = 288;
UPDATE pmzdcalc SET cisrad = 79 WHERE IdMzdCalc = 290;
UPDATE pmzdcalc SET cisrad = 88 WHERE IdMzdCalc = 291;
UPDATE pmzdcalc SET cisrad = 86 WHERE IdMzdCalc = 296;
UPDATE pmzdcalc SET cisrad = 87 WHERE IdMzdCalc = 297;
UPDATE pmzdcalc SET cisrad = 364 WHERE IdMzdCalc = 307;
UPDATE pmzdcalc SET cisrad = 366 WHERE IdMzdCalc = 308;
UPDATE pmzdcalc SET cisrad = 319 WHERE IdMzdCalc = 310;
UPDATE pmzdcalc SET cisrad = 320 WHERE IdMzdCalc = 311;
UPDATE pmzdcalc SET cisrad = 165 WHERE IdMzdCalc = 320;
UPDATE pmzdcalc SET cisrad = 168 WHERE IdMzdCalc = 321;
UPDATE pmzdcalc SET cisrad = 169 WHERE IdMzdCalc = 322;
UPDATE pmzdcalc SET cisrad = 166 WHERE IdMzdCalc = 323;
UPDATE pmzdcalc SET cisrad = 167 WHERE IdMzdCalc = 324;
UPDATE pmzdcalc SET cisrad = 185 WHERE IdMzdCalc = 325;
UPDATE pmzdcalc SET cisrad = 189 WHERE IdMzdCalc = 326;
UPDATE pmzdcalc SET cisrad = 190 WHERE IdMzdCalc = 327;
UPDATE pmzdcalc SET cisrad = 321 WHERE IdMzdCalc = 328;
UPDATE pmzdcalc SET cisrad = 322 WHERE IdMzdCalc = 329;
UPDATE pmzdcalc SET cisrad = 323 WHERE IdMzdCalc = 330;
UPDATE pmzdcalc SET cisrad = 324 WHERE IdMzdCalc = 331;
UPDATE pmzdcalc SET cisrad = 33 WHERE IdMzdCalc = 332;
UPDATE pmzdcalc SET cisrad = 303, operacek = 'mzdCalcOper.plus' WHERE IdMzdCalc = 333;
UPDATE pmzdcalc SET cisrad = 39 WHERE IdMzdCalc = 336;
UPDATE pmzdcalc SET cisrad = 40 WHERE IdMzdCalc = 339;
UPDATE pmzdcalc SET cisrad = 5 WHERE IdMzdCalc = 341;
UPDATE pmzdcalc SET cisrad = 138 WHERE IdMzdCalc = 342;
UPDATE pmzdcalc SET cisrad = 139 WHERE IdMzdCalc = 343;
UPDATE pmzdcalc SET cisrad = 140 WHERE IdMzdCalc = 345;
UPDATE pmzdcalc SET cisrad = 141 WHERE IdMzdCalc = 346;
UPDATE pmzdcalc SET cisrad = 142 WHERE IdMzdCalc = 347;
UPDATE pmzdcalc SET cisrad = 143 WHERE IdMzdCalc = 348;
UPDATE pmzdcalc SET cisrad = 144 WHERE IdMzdCalc = 349;
UPDATE pmzdcalc SET cisrad = 145 WHERE IdMzdCalc = 350;
UPDATE pmzdcalc SET cisrad = 146 WHERE IdMzdCalc = 351;
UPDATE pmzdcalc SET cisrad = 239 WHERE IdMzdCalc = 353;
UPDATE pmzdcalc SET cisrad = 260 WHERE IdMzdCalc = 356;
UPDATE pmzdcalc SET cisrad = 363 WHERE IdMzdCalc = 358;
UPDATE pmzdcalc SET cisrad = 365 WHERE IdMzdCalc = 359;
UPDATE pmzdcalc SET cisrad = 225 WHERE IdMzdCalc = 361;
UPDATE pmzdcalc SET cisrad = 226 WHERE IdMzdCalc = 362;
UPDATE pmzdcalc SET cisrad = 227 WHERE IdMzdCalc = 363;
UPDATE pmzdcalc SET cisrad = 228 WHERE IdMzdCalc = 364;
UPDATE pmzdcalc SET cisrad = 230 WHERE IdMzdCalc = 365;
UPDATE pmzdcalc SET cisrad = 231 WHERE IdMzdCalc = 367;
UPDATE pmzdcalc SET cisrad = 232 WHERE IdMzdCalc = 368;
UPDATE pmzdcalc SET cisrad = 248 WHERE IdMzdCalc = 369;
UPDATE pmzdcalc SET cisrad = 249 WHERE IdMzdCalc = 370;
UPDATE pmzdcalc SET cisrad = 69 WHERE IdMzdCalc = 377;
UPDATE pmzdcalc SET cisrad = 286 WHERE IdMzdCalc = 379;
UPDATE pmzdcalc SET cisrad = 287 WHERE IdMzdCalc = 380;
UPDATE pmzdcalc SET cisrad = 288 WHERE IdMzdCalc = 381;
UPDATE pmzdcalc SET cisrad = 289 WHERE IdMzdCalc = 382;
UPDATE pmzdcalc SET cisrad = 294 WHERE IdMzdCalc = 383;
UPDATE pmzdcalc SET cisrad = 295 WHERE IdMzdCalc = 384;
UPDATE pmzdcalc SET cisrad = 296 WHERE IdMzdCalc = 385;
UPDATE pmzdcalc SET cisrad = 298 WHERE IdMzdCalc = 386;
UPDATE pmzdcalc SET cisrad = 297 WHERE IdMzdCalc = 387;
UPDATE pmzdcalc SET cisrad = 325 WHERE IdMzdCalc = 388;
UPDATE pmzdcalc SET cisrad = 201 WHERE IdMzdCalc = 389;
UPDATE pmzdcalc SET cisrad = 210 WHERE IdMzdCalc = 390;
UPDATE pmzdcalc SET cisrad = 211 WHERE IdMzdCalc = 391;
UPDATE pmzdcalc SET cisrad = 212 WHERE IdMzdCalc = 392;
UPDATE pmzdcalc SET cisrad = 202 WHERE IdMzdCalc = 393;
UPDATE pmzdcalc SET cisrad = 204 WHERE IdMzdCalc = 394;
UPDATE pmzdcalc SET cisrad = 207 WHERE IdMzdCalc = 395;
UPDATE pmzdcalc SET cisrad = 203 WHERE IdMzdCalc = 397;
UPDATE pmzdcalc SET cisrad = 205 WHERE IdMzdCalc = 399;
UPDATE pmzdcalc SET cisrad = 206 WHERE IdMzdCalc = 401;
UPDATE pmzdcalc SET cisrad = 208 WHERE IdMzdCalc = 402;
UPDATE pmzdcalc SET cisrad = 209 WHERE IdMzdCalc = 404;
UPDATE pmzdcalc SET cisrad = 316 WHERE IdMzdCalc = 405;
UPDATE pmzdcalc SET cisrad = 214 WHERE IdMzdCalc = 407;
UPDATE pmzdcalc SET cisrad = 219 WHERE IdMzdCalc = 408;
UPDATE pmzdcalc SET cisrad = 44 WHERE IdMzdCalc = 409;
UPDATE pmzdcalc SET cisrad = 315 WHERE IdMzdCalc = 410;
UPDATE pmzdcalc SET cisrad = 84 WHERE IdMzdCalc = 411;
UPDATE pmzdcalc SET cisrad = 326 WHERE IdMzdCalc = 413;
UPDATE pmzdcalc SET cisrad = 327 WHERE IdMzdCalc = 414;
UPDATE pmzdcalc SET cisrad = 328 WHERE IdMzdCalc = 416;
UPDATE pmzdcalc SET cisrad = 329 WHERE IdMzdCalc = 418;
UPDATE pmzdcalc SET cisrad = 330 WHERE IdMzdCalc = 420;
UPDATE pmzdcalc SET cisrad = 333 WHERE IdMzdCalc = 421;
UPDATE pmzdcalc SET cisrad = 334 WHERE IdMzdCalc = 422;
UPDATE pmzdcalc SET cisrad = 348 WHERE IdMzdCalc = 423;
UPDATE pmzdcalc SET cisrad = 338 WHERE IdMzdCalc = 424;
UPDATE pmzdcalc SET cisrad = 341 WHERE IdMzdCalc = 425;
UPDATE pmzdcalc SET cisrad = 331 WHERE IdMzdCalc = 426;
UPDATE pmzdcalc SET cisrad = 332 WHERE IdMzdCalc = 427;
UPDATE pmzdcalc SET cisrad = 335 WHERE IdMzdCalc = 428;
UPDATE pmzdcalc SET cisrad = 340 WHERE IdMzdCalc = 429;
UPDATE pmzdcalc SET cisrad = 347 WHERE IdMzdCalc = 430;
UPDATE pmzdcalc SET cisrad = 342 WHERE IdMzdCalc = 431;
UPDATE pmzdcalc SET cisrad = 343 WHERE IdMzdCalc = 432;
UPDATE pmzdcalc SET cisrad = 344 WHERE IdMzdCalc = 433;
UPDATE pmzdcalc SET cisrad = 345 WHERE IdMzdCalc = 434;
UPDATE pmzdcalc SET cisrad = 346 WHERE IdMzdCalc = 435;
UPDATE pmzdcalc SET cisrad = 349 WHERE IdMzdCalc = 436;
UPDATE pmzdcalc SET cisrad = 132 WHERE IdMzdCalc = 437;
UPDATE pmzdcalc SET cisrad = 133 WHERE IdMzdCalc = 438;
UPDATE pmzdcalc SET cisrad = 134 WHERE IdMzdCalc = 439;
UPDATE pmzdcalc SET cisrad = 131 WHERE IdMzdCalc = 440;
UPDATE pmzdcalc SET cisrad = 123 WHERE IdMzdCalc = 445;
UPDATE pmzdcalc SET cisrad = 124 WHERE IdMzdCalc = 446;
UPDATE pmzdcalc SET cisrad = 125 WHERE IdMzdCalc = 447;
UPDATE pmzdcalc SET cisrad = 126 WHERE IdMzdCalc = 448;
UPDATE pmzdcalc SET cisrad = 127 WHERE IdMzdCalc = 449;
UPDATE pmzdcalc SET cisrad = 128 WHERE IdMzdCalc = 450;
UPDATE pmzdcalc SET cisrad = 129 WHERE IdMzdCalc = 451;
UPDATE pmzdcalc SET cisrad = 130 WHERE IdMzdCalc = 452;
UPDATE pmzdcalc SET cisrad = 352 WHERE IdMzdCalc = 454;
UPDATE pmzdcalc SET cisrad = 339 WHERE IdMzdCalc = 455;
UPDATE pmzdcalc SET cisrad = 310 WHERE IdMzdCalc = 456;
UPDATE pmzdcalc SET cisrad = 311 WHERE IdMzdCalc = 457;
UPDATE pmzdcalc SET cisrad = 312 WHERE IdMzdCalc = 458;
UPDATE pmzdcalc SET cisrad = 4 WHERE IdMzdCalc = 459;
UPDATE pmzdcalc SET cisrad = 155 WHERE IdMzdCalc = 460;
UPDATE pmzdcalc SET cisrad = 156 WHERE IdMzdCalc = 461;
UPDATE pmzdcalc SET cisrad = 157 WHERE IdMzdCalc = 462;
UPDATE pmzdcalc SET cisrad = 158 WHERE IdMzdCalc = 463;
UPDATE pmzdcalc SET cisrad = 151 WHERE IdMzdCalc = 464;
UPDATE pmzdcalc SET cisrad = 152 WHERE IdMzdCalc = 465;
UPDATE pmzdcalc SET cisrad = 153 WHERE IdMzdCalc = 466;
UPDATE pmzdcalc SET cisrad = 154 WHERE IdMzdCalc = 467;
UPDATE pmzdcalc SET cisrad = 161 WHERE IdMzdCalc = 468;
UPDATE pmzdcalc SET cisrad = 229 WHERE IdMzdCalc = 471;
UPDATE pmzdcalc SET cisrad = 246 WHERE IdMzdCalc = 472;
UPDATE pmzdcalc SET cisrad = 159 WHERE IdMzdCalc = 473;
UPDATE pmzdcalc SET cisrad = 160 WHERE IdMzdCalc = 474;
UPDATE pmzdcalc SET cisrad = 199 WHERE IdMzdCalc = 475;
UPDATE pmzdcalc SET cisrad = 172 WHERE IdMzdCalc = 476;
UPDATE pmzdcalc SET cisrad = 236 WHERE IdMzdCalc = 477;
UPDATE pmzdcalc SET cisrad = 277 WHERE IdMzdCalc = 478;
UPDATE pmzdcalc SET kod = 'SVÁTEK', nazev = 'Fond pracovní doby', cisrad = 3, koeficient = 1.0, koeficient2 = 0.0, polein = 'hodinySvatek;dnySvatek;hodinySvatek', poleout = 'hodiny;dnyPrac;hodinySvatek', idmzdslozin = 1, idmzdslozout = 256 WHERE IdMzdCalc = 479;
UPDATE pmzdcalc SET cisrad = 119 WHERE IdMzdCalc = 480;
UPDATE pmzdcalc SET cisrad = 70 WHERE IdMzdCalc = 481;
UPDATE pmzdcalc SET cisrad = 38 WHERE IdMzdCalc = 482;
UPDATE pmzdcalc SET cisrad = 54 WHERE IdMzdCalc = 484;
UPDATE pmzdcalc SET cisrad = 57 WHERE IdMzdCalc = 485;
UPDATE pmzdcalc SET cisrad = 120 WHERE IdMzdCalc = 486;
UPDATE pmzdcalc SET cisrad = 121 WHERE IdMzdCalc = 487;
UPDATE pmzdcalc SET cisrad = 353 WHERE IdMzdCalc = 488;
UPDATE pmzdcalc SET cisrad = 63 WHERE IdMzdCalc = 489;
UPDATE pmzdcalc SET cisrad = 74 WHERE IdMzdCalc = 490;
UPDATE pmzdcalc SET cisrad = 64 WHERE IdMzdCalc = 491;
UPDATE pmzdcalc SET cisrad = 65 WHERE IdMzdCalc = 492;
UPDATE pmzdcalc SET cisrad = 66 WHERE IdMzdCalc = 493;
UPDATE pmzdcalc SET cisrad = 67 WHERE IdMzdCalc = 494;
UPDATE pmzdcalc SET cisrad = 350 WHERE IdMzdCalc = 495;
UPDATE pmzdcalc SET cisrad = 351 WHERE IdMzdCalc = 496;
UPDATE pmzdcalc SET cisrad = 68 WHERE IdMzdCalc = 497;
UPDATE pmzdcalc SET cisrad = 115 WHERE IdMzdCalc = 498;
UPDATE pmzdcalc SET cisrad = 116 WHERE IdMzdCalc = 499;
UPDATE pmzdcalc SET cisrad = 117 WHERE IdMzdCalc = 500;
UPDATE pmzdcalc SET cisrad = 109 WHERE IdMzdCalc = 501;
UPDATE pmzdcalc SET cisrad = 110 WHERE IdMzdCalc = 502;
UPDATE pmzdcalc SET cisrad = 111 WHERE IdMzdCalc = 503;
UPDATE pmzdcalc SET cisrad = 112 WHERE IdMzdCalc = 504;
UPDATE pmzdcalc SET cisrad = 113 WHERE IdMzdCalc = 505;
UPDATE pmzdcalc SET cisrad = 114 WHERE IdMzdCalc = 508;
UPDATE pmzdcalc SET cisrad = 22, polein = 'hodinySvatek;dnySvatek;hodinySvatek;dnySvatek', poleout = 'hodinySvatek;dnySvatek;hodiny;dnyPrac' WHERE IdMzdCalc = 509;
UPDATE pmzdcalc SET cisrad = 23 WHERE IdMzdCalc = 510;
UPDATE pmzdcalc SET cisrad = 255 WHERE IdMzdCalc = 513;
UPDATE pmzdcalc SET cisrad = 309 WHERE IdMzdCalc = 514;
UPDATE pmzdcalc SET cisrad = 354 WHERE IdMzdCalc = 516;
UPDATE pmzdcalc SET cisrad = 355 WHERE IdMzdCalc = 517;
UPDATE pmzdcalc SET cisrad = 356 WHERE IdMzdCalc = 518;
UPDATE pmzdcalc SET cisrad = 357 WHERE IdMzdCalc = 519;
UPDATE pmzdcalc SET cisrad = 358 WHERE IdMzdCalc = 520;
UPDATE pmzdcalc SET cisrad = 359 WHERE IdMzdCalc = 521;
UPDATE pmzdcalc SET cisrad = 307 WHERE IdMzdCalc = 522;
UPDATE pmzdcalc SET cisrad = 337 WHERE IdMzdCalc = 523;
UPDATE pmzdcalc SET cisrad = 336 WHERE IdMzdCalc = 524;
UPDATE pmzdcalc SET cisrad = 56 WHERE IdMzdCalc = 525;
UPDATE pmzdcalc SET cisrad = 55 WHERE IdMzdCalc = 526;
UPDATE pmzdcalc SET cisrad = 18 WHERE IdMzdCalc = 527;
UPDATE pmzdcalc SET cisrad = 19 WHERE IdMzdCalc = 528;
UPDATE pmzdcalc SET cisrad = 90 WHERE IdMzdCalc = 529;
UPDATE pmzdcalc SET popis = 'Posunuto z konce sem a zároveň byla složka PŘEPLATEK DANĚ označena jako společná pro pracovní poměry', cisrad = 308 WHERE IdMzdCalc = 530;
UPDATE pmzdcalc SET cisrad = 46 WHERE IdMzdCalc = 531;
UPDATE pmzdcalc SET cisrad = 47 WHERE IdMzdCalc = 532;
UPDATE pmzdcalc SET cisrad = 48 WHERE IdMzdCalc = 533;
UPDATE pmzdcalc SET cisrad = 49 WHERE IdMzdCalc = 534;
UPDATE pmzdcalc SET cisrad = 220 WHERE IdMzdCalc = 535;
UPDATE pmzdcalc SET cisrad = 221 WHERE IdMzdCalc = 536;
UPDATE pmzdcalc SET cisrad = 360 WHERE IdMzdCalc = 537;
UPDATE pmzdcalc SET cisrad = 361 WHERE IdMzdCalc = 538;
UPDATE pmzdcalc SET cisrad = 215 WHERE IdMzdCalc = 540;
UPDATE pmzdcalc SET cisrad = 216 WHERE IdMzdCalc = 541;
UPDATE pmzdcalc SET cisrad = 218 WHERE IdMzdCalc = 542;
UPDATE pmzdcalc SET cisrad = 268 WHERE IdMzdCalc = 543;
UPDATE pmzdcalc SET cisrad = 269 WHERE IdMzdCalc = 544;
INSERT INTO pmzdcalc (idmzdcalc, lastUpdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (545, '2010-02-26 00:00:00.000', 'HRUBA MZDA CELKEM ', 'Hrubá mzda celkem ', 'do konstatnty dám, zda je hrubá mzda menší než polovina minimální mzdy', true, 253, 4000.0, 0.0, 1.0, 'castMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.mensiRovno', false, 0, 1, 167, 167);
INSERT INTO pmzdcalc (idmzdcalc, lastUpdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (546, '2010-02-26 00:00:00.000', 'BONUS', 'Daňový bonus', 'nuluji bonus, když je hrubá pod 1/2 minimalní mzdy', true, 259, 1.0, 0.0, 0.0, 'castMzd', 'procMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, 1, 109, 167, 109);
INSERT INTO pmzdcalc (idmzdcalc, lastUpdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (547, '2010-02-27 00:00:00.000', 'ZŮČTOVÁNÍ DANĚ ', 'Přeplatek daně z ročního zúčtování', 'Posunuto z konce sem a zároveň byla složka PŘEPLATEK DANĚ označena jako společná pro pracovní poměry', true, 261, -1.0, 0.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, 1, 254, 255);
INSERT INTO pmzdcalc (idmzdcalc, lastUpdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (548, '2010-02-25 00:00:00.000', 'CELKOVÁ NEPŘÍTOMNOST', 'Svátek', true, 20, 1.0, 1.0, 0.0, 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 'dnyPrac;dnyKal;dnySvatek;hodiny;hodinySvatek', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, 1, 256, 16);
INSERT INTO pmzdcalc (idmzdcalc, lastUpdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (549, '2010-02-26 00:00:00.000', '9', '----- -----***** inicializace plátce soc.pojištění ', 'pro dpp, malý rozsah do 2000 atd se nuluje', true, 170, 0.0, 1.0, 0.0, 'procMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, 1, 162, 162);
INSERT INTO pmzdcalc (idmzdcalc, lastUpdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (550, '2010-02-26 00:00:00.000', 'SOC.POJ.CELKEM', '----- *', true, 362, 1.0, 1.0, 0.0, 'procMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, 1, 162, 217);
INSERT INTO pmzdcalc (idmzdcalc, lastUpdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (551, '2010-02-26 00:00:00.000', '2', '----- Negace pole procmzd (z inicializace je 1 když je náhrada za svátek)', true, 26, 1.0, 0.0, 1.0, 'procMzd', 'procMzd', 0.0, 0.0, 'mzdCalcOper.rovno', false, 0, 1, 256, 256);
INSERT INTO pmzdcalc (idmzdcalc, lastUpdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (552, '2010-02-26 00:00:00.000', '2', '----- Přičtení svátku do odpracované doby když za něj není náhrada', true, 28, 1.0, 1.0, 0.0, 'hodinySvatek', '', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, 1, 256, 179);
INSERT INTO pmzdcalc (idmzdcalc, lastUpdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (553, '2010-02-26 00:00:00.000', '2', '----- vrácená pole ODPRACOVÁNO VÝPOČET  do původního stavu', true, 30, -1.0, 1.0, 0.0, 'hodinySvatek', '', 'hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, 1, 256, 179);
INSERT INTO pmzdcalc (idmzdcalc, lastUpdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (554, '2010-02-26 00:00:00.000', '2', '----- nulování hodin svátek', true, 27, 1.0, 0.0, 0.0, 'procMzd', 'hodinySvatek', 'hodinySvatek', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, 1, 256, 256, 256);

UPDATE pmzdcalc SET cisrad = 24 WHERE IdMzdCalc = 209;
UPDATE pmzdcalc SET cisrad = 25 WHERE IdMzdCalc = 226;


PERFORM pg_catalog.setval('seq_pmzdcalc', 554, true);

-- parametry pro typ prac pom
UPDATE ptyppracpomparam SET polenuluj = 'zaklMzd;castMzd;procMzd' WHERE IdTypPracPomParam = 1;
UPDATE ptyppracpomparam SET polenuluj = 'zaklMzd;procMzd' WHERE IdTypPracPomParam = 4;
UPDATE ptyppracpomparam SET polenuluj = 'zaklMzd;procMzd' WHERE IdTypPracPomParam = 5;
UPDATE ptyppracpomparam SET polenuluj = 'zaklMzd;castMzd;procMzd' WHERE IdTypPracPomParam = 17;
UPDATE ptyppracpomparam SET polenuluj = 'zaklMzd;procMzd' WHERE IdTypPracPomParam = 21;


-- konec ceskeho bloku
  end if; 
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();



-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 262, 't');
