---------------------------------------------------------------------
-- Bug 18417 – [Winstrom] Převodka včetně aktualizace cen
---------------------------------------------------------------------

-- Function: findvicevazeb(character varying, integer, character varying, integer, boolean)
-- DROP FUNCTION findvicevazeb(character varying, integer, character varying, integer, boolean);
CREATE OR REPLACE FUNCTION findvicevazeb(_inserttab character varying, _iddokl integer, _modul character varying, _uroven integer, _prechodvp boolean)
  RETURNS void AS
$BODY$  
declare  
  tabulka varchar(20);  
  poleStav varchar(20);  
  dotaz varchar;  
  prechodPom varchar;    
begin  
  tabulka = getdoklnamepostfixbymodul(_modul);  
  prechodPom = '';  
  
  if (_uroven = 0) then  
    if (tabulka = 'Fak') then  
      poleStav = 'stavUhrK';  
    else  
      poleStav = 'stavUzivK';  
    end if;  
      
    dotaz =   
      'select 0 as idVazby, null as typVazbyK, D.idDokl' || tabulka || ' as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.' || poleStav || ' as stavK  
        from dDokl' || tabulka || ' as D where D.idDokl' || tabulka || ' = ' || _idDokl || ' and D.modul = ''' || _modul || '''';  
  else  
  
  if (tabulka = 'Fak') then  
    dotaz =   
      'select V.idVazby, V.typVazbyK, D.idDoklInt as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK  
        from dVazebTab as V left outer join dDoklInt as D on V.idTabB=D.idDoklInt and V.modulB=D.modul   
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.uhrada'', ''typVazbyDokl.uhradaKR'',  
            ''typVazbyDokl.uhradaZB'', ''typVazbyDokl.preceneni'', ''typVazbyDokl.vazbaZDD'', ''typVazbyDokl.uhradaZALOHY'')   
      union  
      select V.idVazby, V.typVazbyK, D.idDoklSklad as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK  
        from dVazebTab as V left outer join dDoklSklad as D on V.idTabB=D.idDoklSklad and V.modulB=D.modul  
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK = ''typVazbyDokl.hlavaSkl''  
      union  
      select min(V.idVazby) as idVazby, V.typVazbyK, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK as stavK  
        from dVazebTab as V left outer join dDoklFak as D on V.idTabB=D.idDoklFak and V.modulB=D.modul  
        where V.idTabA in (select idPolFak from dPolFak where idDoklFak=' || _idDokl || ') and V.modulA=''' || _modul || ''' and  
          V.typVazbyK in (''typVazbyDokl.odpocetZALOHY'', ''typVazbyDokl.odpocetZDD'')   
        group by V.typVazbyK, D.idDoklFak, D.modul, D.kod, D.varSym, D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavuhrK  
      union   
      select min(V.idVazby) as idVazby, V.typVazbyK, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK as stavK  
        from dVazebTab as V left outer join dDoklFak as D on D.idDoklFak=  
                (select idDoklFak from dPolFak where idPolFak = V.idTabA) and V.modulA=D.modul  
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.odpocetZALOHY'', ''typVazbyDokl.odpocetZDD'')  
        group by V.typVazbyK, D.idDoklFak, D.modul, D.kod, D.varSym, D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK  
      union   
      select V.idVazby, V.typVazbyK, D.idDoklObch as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK  
        from dVazebTab as V left outer join dDoklObch as D on V.idTabA=D.idDoklObch and V.modulA=D.modul  
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.obchod_faktura_hla'', ''typVazbyDokl.obchod_zaloha_hla'')';  
  else if (tabulka = 'Int') then  
    dotaz =   
      'select V.idVazby, V.typVazbyK, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK as stavK  
        from dVazebTab as V left outer join dDoklFak as D on V.idTabA=D.idDoklFak and V.modulA=D.modul  
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.uhrada'', ''typVazbyDokl.uhradaKR'',  
            ''typVazbyDokl.uhradaZB'', ''typVazbyDokl.preceneni'', ''typVazbyDokl.vazbaZDD'', ''typVazbyDokl.uhradaZALOHY'')   
      union  
      select V.idVazby, V.typVazbyK, D.idDoklSklad as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK  
        from dVazebTab as V left outer join dDoklSklad as D on V.idTabB=D.idDoklSklad and V.modulB=D.modul  
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.hlavaSkl'')   
      union  
      select V.idVazby, V.typVazbyK, D.idDoklInt as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK  
        from dVazebTab as V left outer join dDoklInt as D on V.idTabA=D.idDoklInt and V.modulA=D.modul  
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.KR'', ''typVazbyDokl.ZB'')   
      union  
      select V.idVazby, V.typVazbyK, D.idDoklInt as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK  
        from dVazebTab as V left outer join dDoklInt as D on V.idTabB=D.idDoklInt and V.modulB=D.modul  
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.KR'', ''typVazbyDokl.ZB'')';  
  else if (tabulka = 'Sklad') then  
    dotaz =   
      'select V.idVazby, V.typVazbyK, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK as stavK  
        from dVazebTab as V left outer join dDoklFak as D on V.idTabA=D.idDoklFak and V.modulA=D.modul  
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and   
          V.modulA in (''FAV'',''FAP'',''PHL'',''ZAV'') and V.typVazbyK = ''typVazbyDokl.hlavaSkl''   
      union   
      select V.idVazby, V.typVazbyK, D.idDoklInt as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK  
        from dVazebTab as V left outer join dDoklInt as D on V.idTabA=D.idDoklInt and V.modulA=D.modul  
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and   
          V.modulA in (''BAN'',''POK'',''INT'') and V.typVazbyK = ''typVazbyDokl.hlavaSkl''  
      union   
      select V.idVazby, V.typVazbyK, D.idDoklSklad as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym, 
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK 
        from dVazebTab as V left outer join dDoklSklad as D on V.idTabA=D.idDoklSklad and V.modulA=D.modul 
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and 
          V.modulA in (''SKL'') and V.typVazbyK = ''typVazbyDokl.hlavaSklKus'' 
      union 
      select V.idVazby, V.typVazbyK, D.idDoklSklad as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym, 
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK 
        from dVazebTab as V left outer join dDoklSklad as D on V.idTabB=D.idDoklSklad and V.modulB=D.modul 
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and 
          V.modulB in (''SKL'') and V.typVazbyK = ''typVazbyDokl.hlavaSklKus'' 
      union   
      select V.idVazby, V.typVazbyK, D.idDoklSklad as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym, 
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK 
        from dVazebTab as V left outer join dDoklSklad as D on V.idTabA=D.idDoklSklad and V.modulA=D.modul 
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and 
          V.modulA in (''SKL'') and V.typVazbyK = ''typVazbyDokl.hlavaSklPrevod'' 
      union 
      select V.idVazby, V.typVazbyK, D.idDoklSklad as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym, 
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK 
        from dVazebTab as V left outer join dDoklSklad as D on V.idTabB=D.idDoklSklad and V.modulB=D.modul 
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and 
          V.modulB in (''SKL'') and V.typVazbyK = ''typVazbyDokl.hlavaSklPrevod'' 
      union   
      select V.idVazby, V.typVazbyK, D.idDoklObch as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK  
        from dVazebTab as V left outer join dDoklObch as D on V.idTabA=D.idDoklObch and V.modulA=D.modul  
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK = ''typVazbyDokl.obchod_sklad_hla''';  
  else if (tabulka = 'Obch') then  
    if (_prechodVP = false and _modul in ('PPV', 'OBV')) then  
      prechodPom = ' and D.modul in (''PPV'', ''NAP'', ''OBV'')';  
    end if;  
    
    dotaz =   
      'select V.idVazby, V.typVazbyK, D.idDoklObch as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK  
        from dVazebTab as V left outer join dDoklObch as D on V.idTabA=D.idDoklObch and V.modulA=D.modul   
        where V.idTabB=' || _idDokl || ' and V.modulB=''' || _modul || ''' and V.typVazbyK = ''typVazbyDokl.obchod_obchod_hla''' || prechodPom || '  
      union   
      select V.idVazby, V.typVazbyK, D.idDoklObch as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK  
        from dVazebTab as V left outer join dDoklObch as D on V.idTabB=D.idDoklObch and V.modulB=D.modul   
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK = ''typVazbyDokl.obchod_obchod_hla''' || prechodPom || '  
      union  
      select V.idVazby, V.typVazbyK, D.idDoklFak as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUhrK as stavK  
        from dVazebTab as V left outer join dDoklFak as D on V.idTabB=D.idDoklFak and V.modulB=D.modul   
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK in (''typVazbyDokl.obchod_faktura_hla'', ''typVazbyDokl.obchod_zaloha_hla'')  
      union  
      select V.idVazby, V.typVazbyK, D.idDoklSklad as idDokl, D.modul, ''modulUcetni.''||D.Modul as ModulK, D.kod, D.varSym,   
        D.datVyst, D.datUcto, D.sumCelkem, D.sumCelkemMen, D.popis, D.poznam, D.idTypDokl, D.idMeny, D.idUziv, D.stavUzivK as stavK  
        from dVazebTab as V left outer join dDoklSklad as D on V.idTabB=D.idDoklSklad and V.modulB=D.modul   
        where V.idTabA=' || _idDokl || ' and V.modulA=''' || _modul || ''' and V.typVazbyK = ''typVazbyDokl.obchod_sklad_hla''';  
  else  
    raise exception 'findVazbyDokladu(): Neznámá tabulka % pro modul %', tabulka, _modul;   
  end if;  
  end if;  
  end if;  
  end if;  
    
  end if;  
    
  execute 'insert into ' || _insertTab || ' (idvazebnidoklad, typVazbyK, idDokl, modul, modulk, kod, varsym, datvyst, datucto, sumcelkem,  
  sumcelkemmen, popis, poznam, idtypdokl,idmeny, iduziv, stavk, uroven, novy) select *, ' || _uroven || ', true from ('   
     || dotaz || ') as UN where (select count(*) from ' || _insertTab || ' as TV where   
     (TV.idDokl = UN.idDokl and TV.modul = UN.modul) or UN.idVazby = TV.idvazebnidoklad) = 0';  
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION findvicevazeb(character varying, integer, character varying, integer, boolean) OWNER TO %firmaRole%;



-- Function: dzkontrolujvazebnitab(integer, boolean, character varying)
-- DROP FUNCTION dzkontrolujvazebnitab(integer, boolean, character varying);
CREATE OR REPLACE FUNCTION dzkontrolujvazebnitab(i_iddokl integer, i_isdoklad boolean, i_modul character varying)
  RETURNS boolean AS
$BODY$  
declare  
  _pocetVazeb integer;  
begin  
    
  /* Jedná se o položku dokladu */  
  if (i_isDoklad = false) then  
    /* idtaba i idtabb jsou položky */  
    select count(*) into _pocetVazeb from dVazebTab where (typvazbyk in ('typVazbyDokl.polozkaSkl',  
                                                             'typVazbyDokl.polozkaSklSada', 'typVazbyDokl.polozkaSklKus', 'typVazbyDokl.polozkaSklPrevod',
                                                             'typVazbyDokl.obchod_obchod_pol', 'typVazbyDokl.obchod_faktura_pol',  
                                                             'typVazbyDokl.obchod_zaloha_pol', 'typVazbyDokl.obchod_sklad_pol'))  
                                                      and ((idtaba = i_idDokl and modula = i_modul) or (idtabb = i_idDokl and modulb = i_modul));  
    if (_PocetVazeb <> 0) then  
      return false;  
    end if;  
      
    /* kontrola, kde je pro položku dokladu jen u idtaba, jedná se o "typVazbyDokl.odpocetZALOHY" a "typVazbyDokl.odpocetZDD" */  
    select count(*) into _pocetVazeb from dVazebTab where (typvazbyk = 'typVazbyDokl.odpocetZALOHY' or typvazbyk = 'typVazbyDokl.odpocetZDD')  
                                                      and ((idtaba = i_idDokl and modula = i_modul and modulb = i_modul));  
    if (_pocetVazeb <> 0) then  
      return false;  
    end if;  
      
    return true;  
  else  
    
   /* Jedná se o doklad, kde je hlavička */  
   select count(*) into _pocetVazeb from dVazebTab where (typvazbyk not in ('typVazbyDokl.polozkaSkl',  
                            'typVazbyDokl.polozkaSklSada', 'typVazbyDokl.polozkaSklKus', 'typVazbyDokl.polozkaSklPrevod', 
                            'typVazbyDokl.obchod_obchod_pol', 'typVazbyDokl.obchod_faktura_pol',  
                            'typVazbyDokl.obchod_zaloha_pol', 'typVazbyDokl.obchod_sklad_pol')  
                        ) and (not (  
                            (modula='FAV' and modulb='FAV' and typvazbyk='typVazbyDokl.odpocetZALOHY') or  
                            (modula='FAV' and modulb='FAV' and typvazbyk='typVazbyDokl.odpocetZDD') or  
                            (modula='FAP' and modulb='FAP' and typvazbyk='typVazbyDokl.odpocetZALOHY') or  
                            (modula='FAP' and modulb='FAP' and typvazbyk='typVazbyDokl.odpocetZDD'))) and  
                        ((idtaba = i_idDokl and modula = i_modul) or (idtabb = i_idDokl and modulb=i_modul));  
   if (_pocetVazeb <> 0) then  
     return false;  
   end if;  
       
   return true;  
  end if;  
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dzkontrolujvazebnitab(integer, boolean, character varying) OWNER TO %firmaRole%;




-- Function: dpolskladupdateucty()
-- DROP FUNCTION dpolskladupdateucty();
CREATE OR REPLACE FUNCTION dpolskladupdateucty()
  RETURNS trigger AS
$BODY$ 
declare 
  nelzeZmena int; 
  _modul character varying; 
begin
  if ((select typPohybuK from dDoklSklad where idDoklSklad = NEW.idDoklSklad) = 'typPohybu.prijem') then 
    -- z prijemky se pres vazbu polozkaSklPrevod ma prenaset ucet zklDal na vydejku zklMd
    if (compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false and NEW.kopZklDalUcet = false) then
      select modulA into _modul from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod';
      if(_modul like 'SKL') then
        select count(*) into nelzeZmena from dPolSklad where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and kopZklMdUcet = true and 
          idPolSklad in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
        if (nelzeZmena = 0) then 
          update dPolSklad set idZklMdUcet = NEW.idZklDalUcet where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and 
            idPolSklad in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
        else 
          raise exception 'dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.'; 
        end if;
      end if;
    end if;
  else
    -- z vydejky se ma pres vazbu polozkaSklPrevod ma prenaset ucet zklMd na ucet zklDal
    if (compareId(NEW.idZklMdUcet, OLD.idZklMdUcet) = false and NEW.kopZklMdUcet = false) then
      select modulB into _modul from dVazebTab where idTabA = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod';
      if(_modul like 'SKL') then
        select count(*) into nelzeZmena from dPolSklad where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and kopZklDalUcet = true and 
          idPolSklad in (select idTabB from dVazebTab where idTabA = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
        if (nelzeZmena = 0) then 
          update dPolSklad set idZklDalUcet = NEW.idZklMdUcet where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and 
            idPolSklad in (select idTabB from dVazebTab where idTabA = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
        else 
          raise exception 'dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.'; 
        end if;
      end if;
    end if;
  end if;

  if ((select typPohybuK from dDoklSklad where idDoklSklad = NEW.idDoklSklad) = 'typPohybu.prijem') then 
    if (compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false and NEW.kopZklDalUcet = false) then 
      select modulA into _modul from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl'; 
      if(_modul like 'POK') then 
        select count(*) into nelzeZmena from dPolInt where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and kopZklMdUcet = true and 
          idPolInt in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl'); 
        --raise exception 'nelze zmena je % ....', nelzeZmena; 
        if (nelzeZmena = 0) then 
          update dPolInt set idZklMdUcet = NEW.idZklDalUcet where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and 
            idPolInt in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl'); 
        else 
          raise exception 'dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.'; 
        end if;
      else 
        select count(*) into nelzeZmena from dPolFak where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and kopZklMdUcet = true and 
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl'); 
        --raise exception 'nelze zmena je % ....', nelzeZmena; 
        if (nelzeZmena = 0) then 
          update dPolFak set idZklMdUcet = NEW.idZklDalUcet where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and 
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSkl'); 
        else 
          raise exception 'dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky.'; 
        end if; 
 
        /*select count(*) into nelzeZmena from dPolSklad where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and kopZklMdUcet = true and 
            idPolSklad in (select idTabB from dVazebTab where idTabA = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklKus'); 
        if (nelzeZmena = 0) then 
          update dPolSklad set idZklMdUcet = NEW.idZklDalUcet where compareId(idZklMdUcet, NEW.idZklDalUcet) = false and 
            idPolSklad in (select idTabB from dVazebTab where idTabA = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklKus'); 
        else 
          raise exception 'dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky. (typVazbyDokl.polozkaSklKus, prijem)'; 
        end if;*/ 
      end if; 
 
    end if; 
  else 
    /*if (compareId(NEW.idZklMdUcet, OLD.idZklMdUcet) = false and NEW.kopZklMdUcet = false) then 
 
      select count(*) into nelzeZmena from dPolSklad where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and kopZklDalUcet = true and 
          idPolSklad in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklKus'); 
      if (nelzeZmena = 0) then 
        update dPolSklad set idZklDalUcet = NEW.idZklMdUcet where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and 
          idPolSklad in (select idTabA from dVazebTab where idTabB = NEW.idPolSklad and typVazbyK = 'typVazbyDokl.polozkaSklKus'); 
      else 
        raise exception 'dPolSkladUpdateUcty(): Nelze zmenit ucet u navazane polozky. (typVazbyDokl.polozkaSklKus, vydej)'; 
      end if; 
 
    end if;*/ 
  end if; 
 
  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladupdateucty() OWNER TO %firmaRole%;


-- Function: ddoklskladupdateucty()
-- DROP FUNCTION ddoklskladupdateucty();
CREATE OR REPLACE FUNCTION ddoklskladupdateucty()
  RETURNS trigger AS
$BODY$ 
declare idFak int;
declare idSklad int;
declare idPok int;
begin 
  if (NEW.typPohybuK = 'typPohybu.prijem' and compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false) then 
    for idFak in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSkl' and idTabB = NEW.idDoklSklad and 
            compareId((select idProtiUcet from dDoklFak where idDoklFak = idTabA), NEW.idProtiUcet) = false) 
    loop 
        execute dNastavUcetDokladu(0, idFak, 1, NEW.idProtiUcet); 
    end loop; 

    for idPok in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSkl' and idTabB = NEW.idDoklSklad and 
            compareId((select idProtiUcet from dDoklInt where idDoklInt = idTabA), NEW.idProtiUcet) = false) 
    loop 
        execute dNastavUcetDokladu(1, idPok, 1, NEW.idProtiUcet); 
    end loop; 
 
    for idSklad in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSklPrevod' and idTabB = NEW.idDoklSklad and 
            compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabA), NEW.idProtiUcet) = false) 
    loop 
        execute dNastavUcetDokladu(2, idSklad, 1, NEW.idProtiUcet); 
    end loop; 
 
  else 
    if (NEW.typPohybuK = 'typPohybu.vydej' and compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false) then 
 
      for idSklad in (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSklPrevod' and idTabA = NEW.idDoklSklad and 
              compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabB), NEW.idProtiUcet) = false) 
      loop 
          execute dNastavUcetDokladu(2, idSklad, 1, NEW.idProtiUcet); 
      end loop; 
 
    end if;
  end if; 
 
  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION ddoklskladupdateucty() OWNER TO %firmaRole%;


-- Function: deletenavazanepolsklad(integer, character varying)
-- DROP FUNCTION deletenavazanepolsklad(integer, character varying);
CREATE OR REPLACE FUNCTION deletenavazanepolsklad(_idpoldokl integer, _modul character varying)
  RETURNS void AS
$BODY$ 
declare 
  _idPolSklad integer; 
  _idVazbyPolSklad integer; 
  _idPolSkladRozpad integer;
  _generujSklDoklad boolean;
begin 
  for _idPolSklad in select idTabB from dvazebtab where 
    typVazbyK like 'typVazbyDokl.polozkaSkl'  
    and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL' 
    loop
    if (_modul like 'FAV' or _modul like 'FAP') then
      select generovatSkl into _generujSklDoklad from dDoklFak where idDoklFak = (select idDoklFak from dPolFak where idPolFak = _idPolDokl);
    elsif (_modul like 'POK') then
      select generovatSkl into _generujSklDoklad from dDoklInt where idDoklInt = (select idDoklInt from dPolInt where idPolInt = _idPolDokl);
    end if;

    if(_generujSklDoklad = true) then
      for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop  
        select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;  
        delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;  
        delete from dPolSklad where idPolSklad = _idPolSkladRozpad;  
      end loop; 
    end if;
 
    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad   
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSkl';  
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad   
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSkl';
    if(_generujSklDoklad = true) then
      delete from dPolSklad where idPolSklad = _idPolSklad;    
    end if;
  end loop; 
 
  for _idPolSklad in select idTabA from dvazebtab where 
    typVazbyK like 'typVazbyDokl.polozkaSkl'  
    and idTabB = _idPolDokl and modulB = _modul and modulA = 'SKL' 
    loop 
    if (_modul like 'FAV' or _modul like 'FAP') then
      select generovatSkl into _generujSklDoklad from dDoklFak where idDoklFak = (select idDoklFak from dPolFak where idPolFak = _idPolDokl);
    elsif (_modul like 'POK') then
      select generovatSkl into _generujSklDoklad from dDoklInt where idDoklInt = (select idDoklInt from dPolInt where idPolInt = _idPolDokl);
    end if;

    if(_generujSklDoklad = true) then
      for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop  
        select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;  
        delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;  
        delete from dPolSklad where idPolSklad = _idPolSkladRozpad;  
      end loop; 
    end if;
    
    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad   
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSkl';  
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad   
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSkl';  
    if(_generujSklDoklad = true) then
      delete from dPolSklad where idPolSklad = _idPolSklad;     
    end if;
  end loop;  

  -- mazani polozek prevodky
  -- polozky prevodky by meli jit mazat z obou stran
  for _idPolSklad in select idTabB from dvazebtab where 
    typVazbyK like 'typVazbyDokl.polozkaSklPrevod'  
    and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL' 
    loop 
 
    for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop  
      select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;  
      delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;  
      delete from dPolSklad where idPolSklad = _idPolSkladRozpad;  
    end loop; 
 
    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad   
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklPrevod';  
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad   
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklPrevod';  
    delete from dPolSklad where idPolSklad = _idPolSklad;    
  end loop; 
 
  for _idPolSklad in select idTabA from dvazebtab where 
    typVazbyK like 'typVazbyDokl.polozkaSklPrevod'  
    and idTabB = _idPolDokl and modulB = _modul and modulA = 'SKL' 
    loop 
 
    for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop  
      select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;  
      delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;  
      delete from dPolSklad where idPolSklad = _idPolSkladRozpad;  
    end loop; 
 
    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad   
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklPrevod';  
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad   
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklPrevod';  
    delete from dPolSklad where idPolSklad = _idPolSklad;     
  end loop;  
 
  -- mazani polozek sady
  for _idPolSklad in select idTabB from dvazebtab where  
    typVazbyK like 'typVazbyDokl.polozkaSklSada'   
    and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL'  
    loop  
  
    for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop   
      select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;   
      delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;   
      delete from dPolSklad where idPolSklad = _idPolSkladRozpad;   
    end loop;  
  
    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad    
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklSada';   
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad    
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklSada';   
    delete from dPolSklad where idPolSklad = _idPolSklad;     
  end loop;  
 
  for _idPolSklad in select idTabA from dvazebtab where  
    typVazbyK like 'typVazbyDokl.polozkaSklSada'   
    and idTabB = _idPolDokl and modulB = _modul and modulA = 'SKL'  
    loop  
  
    for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop   
      select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;   
      delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;   
      delete from dPolSklad where idPolSklad = _idPolSkladRozpad;   
    end loop;  
  
    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad    
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklSada';   
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad    
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklSada';   
    delete from dPolSklad where idPolSklad = _idPolSklad;    
  end loop; 
 
  -- pokud mazu polozku vydejky, ktera byla vytvorena k polozce prijemky podle kusovniku 
  -- vyhodim vyjimku, polozek vydejky se muselo vytvorit vice a musel bych je smazat vsechny 
  -- navic mi prijemka ridi existenci vydejky a tak bych celou vazbu mel ovladat z ni 
  if (exists (select 1 from dvazebtab where idTabB = _idPolDokl and modulB = _modul 
    and typVazbyK = 'typVazbyDokl.polozkaSklKus')) then 
        raise exception 'polozku dokladu vydejky nelze smazat, smazte zavislou polozku na prijemce'; 
  end if; 
 
  for _idPolSklad in select idTabB from dvazebtab where 
    typVazbyK like 'typVazbyDokl.polozkaSklKus'  
    and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL' 
    loop 
 
    for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop  
      select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;  
      delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;  
      delete from dPolSklad where idPolSklad = _idPolSkladRozpad;  
    end loop; 
 
    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad   
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklKus'; 
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad   
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklKus'; 
    delete from dPolSklad where idPolSklad = _idPolSklad;    
  end loop; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION deletenavazanepolsklad(integer, character varying) OWNER TO %firmaRole%;


-- Function: dpolskladdeletesklad()
-- DROP FUNCTION dpolskladdeletesklad();
CREATE OR REPLACE FUNCTION dpolskladdeletesklad()
  RETURNS trigger AS
$BODY$ 
declare 
  _idPolDokl integer; 
  _idDoklad integer; 
  _idDoklSklad integer; 
begin 
  if(OLD.idPolSklad is not null) then 
    execute deleteNavazanePolSklad(OLD.idPolSklad, OLD.modul); 
  end if; 
 
  select findParovanyDoklSklad(OLD.idDoklSklad, OLD.modul, 'typVazbyDokl.hlavaSklKus') into _idDoklSklad; 
  if(_idDoklSklad is not null) then 
    execute sprepoctiSumyDokladu(_idDoklSklad); 
  end if; 

  select findParovanyDoklSklad(OLD.idDoklSklad, OLD.modul, 'typVazbyDokl.hlavaSklPrevod') into _idDoklSklad; 
  if(_idDoklSklad is not null) then 
    execute sprepoctiSumyDokladu(_idDoklSklad); 
  end if; 
 
  return OLD; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladdeletesklad() OWNER TO %firmaRole%;


-- Function: sfifovydej(integer, integer, integer, integer, numeric)
-- DROP FUNCTION sfifovydej(integer, integer, integer, integer, numeric);
CREATE OR REPLACE FUNCTION sfifovydej(idvydej integer, idcenikvydej integer, idskladvydej integer, idkartyvydej integer, vyd numeric)
  RETURNS void AS
$BODY$      
declare       
  _zaznam Record;       
  _vybrano numeric(19,6);     
  _i integer;     
  _novevydcelkem numeric(19,6);     
  _pocet numeric(19,6);     
  _cenamjP numeric(19,6);  
  _cenaMjPMen numeric(19,6);  
  _kurzDokladuP numeric(19,6);   
  _kurzDokladuV numeric(19,6);   
  _idDoklSkladP integer;    
  _idDoklSkladV integer;   
  _datVystV date;   
  _idrozlozeni integer;     
  _vydexpir boolean;     
  _vyrcis character varying(255);     
  _sklfifo boolean;  
  _sarze character varying(255);  
  _expirace date;       
  _evidVyrCis boolean;    
begin       
  _vybrano := 0;     
  _i := 1;     
  _novevydcelkem := vyd;     
  select evidVyrCis into _evidVyrCis from ccenik where idcenik = idcenikvydej;  
  if (not _evidVyrCis) then  
    if (idvydej>0) then  
      select vydexpir into _vydexpir from skarty where idkarty=idkartyvydej limit 1;  
      select sarze, expirace into _sarze, _expirace from dpolsklad where idpolsklad = idvydej;     
      if (not _vydexpir) then     
        --pořadí výdeje dle datvyst (dále se bude řesit upřednostněný výdej mimo FIFO)     
        for _zaznam in select * from dPolSkladF where idCenik=idCenikVydej and idSkladu=idSkladVydej order by datVyst,idpolsklad loop       
          if(not _zaznam is null) then 
            if((_sarze is null or _sarze = _zaznam.sarze) and (_expirace is null or _expirace = _zaznam.expirace)) then  
              if (_vybrano<_novevydcelkem) then     
                _pocet := _zaznam.pocet;     
                if( _vybrano+_pocet) > _novevydcelkem then     
                  _pocet := _novevydcelkem-_vybrano;     
                end if;     
                _vybrano := _vybrano+_pocet;     
                --pokud je výrobní číslo, tak jeho kód zaznamenám na výdejku (otázka je, zda tam nedat rovnou idvyrobnicislo     
                _vyrcis := '';     
                if (_zaznam.idvyrobnicislo>0) then     
                  select kod into _vyrcis from svyrobnicislo where idvyrobnicislo = _zaznam.idvyrobnicislo;     
                end if;     
                --     
                if (_i = 1) then
                  insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo) ;  
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));     
                  if (_sklfifo) then     
                    select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);     
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);    
                    if (_kurzDokladuP <> 0.0) then  
                      _cenamjP := _cenamjP * _kurzDokladuP;     
	                end if;   
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;   
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));  
                    _cenamjP := _cenamjP / _kurzDokladuV;  
                    _cenaMjPMen := 0.0;  
                    if(_kurzDokladuV <> 1.0) then  
                      _cenaMjPMen := _cenaMjP;  
                    end if;  
                    update dpolsklad set mnozmj = _pocet,cenamj = _cenamjP, sumzkl = _pocet*_cenamjP*_kurzDokladuV, sumZklMen = _pocet*_cenaMjPMen, vyrcis=_vyrcis, sarze = _zaznam.sarze, expirace = _zaznam.expirace  
                          where idpolsklad = idvydej;  
                  else  
                    update dpolsklad set sarze = _zaznam.sarze, expirace = _zaznam.expirace where idpolsklad = idvydej;  
                  end if; 
                else     
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));     
                  if (_sklfifo) then     
                    select nextval('seq_dpolsklad') into _idrozlozeni;     
                    select cenamj, idDoklSklad into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);    
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);    
                    if (_kurzDokladuP <> 0.0) then    
                      _cenamjP := _cenamjP * _kurzDokladuP;     
                    end if;    
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;   
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));   
                    _cenamjP := _cenamjP / _kurzDokladuV;  
                    _cenaMjPMen := 0.0;  
                    if(_kurzDokladuV <> 1.0) then  
                      _cenaMjPMen := _cenaMjP;  
                    end if;  
                    insert into dpolsklad(idpolsklad,mnozmj,autozaokr,autogen,baleniid,cenjednotka,cenamj,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,sumzkl,sumzklmen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idskladu,idfirmy,vyrcis)      
                         (select (-1*_idrozlozeni),_pocet,autozaokr,autogen,baleniid,cenjednotka,_cenamjP,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,_zaznam.expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,_zaznam.sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,_pocet*_cenamjP*_kurzDokladuV,_pocet*_cenaMjPMen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idskladu,idfirmy,_vyrcis from dpolsklad where idpolsklad=idVydej);  
                    --     
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,_idrozlozeni,_pocet,_zaznam.idvyrobnicislo);     
                    insert into svazbypolsklad(idpolskladzdroj,idpolskladcil) values (idvydej, _idrozlozeni);     
                  else     
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,idvydej,_pocet,_zaznam.idvyrobnicislo);     
                  end if;     
                end if;     
                --     
                _i:=_i+1;     
              end if;  
            end if; 
          end if; 
        end loop;    
      else     
        --pořadí výdeje dle expirace (dále se bude řesit upřednostněný výdej mimo FIFO)     
        for _zaznam in select * from dPolSkladF where idCenik=idCenikVydej and idSkladu=idSkladVydej order by expirace, idpolsklad loop       
          if(not _zaznam is null) then 
            if((_sarze is null or _sarze = _zaznam.sarze) and (_expirace is null or _expirace = _zaznam.expirace)) then  
              if (_vybrano<_novevydcelkem) then     
                _pocet := _zaznam.pocet;     
                if( _vybrano+_pocet) > _novevydcelkem then     
                  _pocet := _novevydcelkem-_vybrano;     
                end if;     
                _vybrano := _vybrano+_pocet;     
                --pokud je výrobní číslo, tak jeho kód zaznamenám na výdejku (otázka je, zda tam nedat rovnou idvyrobnicislo     
                _vyrcis := '';     
                if (_zaznam.idvyrobnicislo>0) then     
                  select kod into _vyrcis from svyrobnicislo where idvyrobnicislo = _zaznam.idvyrobnicislo;     
                end if;     
                --     
                if (_i = 1) then     
                  insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo) ;     
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));     
                  if (_sklfifo) then     
                    select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);     
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);    
                    if (_kurzDokladuP <> 0.0) then    
                      _cenamjP := _cenamjP * _kurzDokladuP;     
                    end if;   
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;   
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));   
                    _cenamjP := _cenamjP / _kurzDokladuV;  
                    _cenaMjPMen := 0.0;  
                    if(_kurzDokladuV <> 1.0) then  
                      _cenaMjPMen := _cenaMjP;  
                    end if;  
                    update dpolsklad set mnozmj = _pocet,cenamj = _cenamjP, sumzkl = _pocet*_cenamjP*_kurzDokladuV, sumZklMen = _pocet*_cenaMjPMen, vyrcis=_vyrcis, sarze = _zaznam.sarze, expirace = _zaznam.expirace  
                          where idpolsklad = idvydej;  
                  else  
                    update dpolsklad set sarze = _zaznam.sarze, expirace = _zaznam.expirace where idpolsklad = idvydej;  
                  end if;     
                else     
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));     
                  if (_sklfifo) then     
                    select nextval('seq_dpolsklad') into _idrozlozeni;     
                    select cenamj, idDoklSklad into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);    
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);    
                    if (_kurzDokladuP <> 0.0) then    
                      _cenamjP := _cenamjP * _kurzDokladuP;     
                    end if;    
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;   
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));   
                    _cenamjP := _cenamjP / _kurzDokladuV;  
                    _cenaMjPMen := 0.0;  
                    if(_kurzDokladuV <> 1.0) then  
                      _cenaMjPMen := _cenaMjP;  
                    end if;  
                    insert into dpolsklad(idpolsklad,mnozmj,autozaokr,autogen,baleniid,cenjednotka,cenamj,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,sumzkl,sumzklmen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idskladu,idfirmy,vyrcis)      
	                             (select (-1*_idrozlozeni),_pocet,autozaokr,autogen,baleniid,cenjednotka,_cenamjP,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,_zaznam.expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,_zaznam.sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,_pocet*_cenamjP,_pocet*_cenaMjPMen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idskladu,idfirmy,_vyrcis from dpolsklad where idpolsklad=idVydej);  
                    --     
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,_idrozlozeni,_pocet,_zaznam.idvyrobnicislo);     
                    insert into svazbypolsklad(idpolskladzdroj,idpolskladcil) values (idvydej, _idrozlozeni);     
                  else      
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,idvydej,_pocet,_zaznam.idvyrobnicislo);      
                  end if;      
                end if;      
                --      
                _i:=_i+1;      
              end if;   
            end if; 
          end if;     
        end loop;      
      end if;      
    else      
      --nepoustím fifo do rekurze, příznak záporného id udělám opět kladný      
      update dpolsklad set idPolSklad = -1*idVydej where idpolsklad=idVydej;               
    end if;  
  end if;     
end;       
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sfifovydej(integer, integer, integer, integer, numeric) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 281, 't');
