--------------------------------------------------------------------------------
-- Bug 19900 – [WinStrom] Mazat nepouzivane vazebni uzly pres trigger a ne z aplikace
--------------------------------------------------------------------------------

-- smaze nepouzivane vazebni uzly, ktere jsou navazany na strom s tableName a ukazuji na idZaznamu
create or replace function deletevazuzel(tableName character varying, idZaznamu integer) returns void AS $$
begin
    -- tyhle vazebni uzly smazeme, ukazovaly by totiz na smazany zaznam
    delete from wvazuzel
        where idvazuzel in
            -- vazebni uzly k tomuhle stromu s tableName a s timto zaznamem tj. ukazuje na idZaznamu
            (select idvazuzel
            from wvazuzel vu
            left join wuzel u on vu.iduzlu = u.iduzel
            left join wstrom s on u.idstrom = s.idstrom
            where vu.idzaznamu = idZaznamu
            and s.tabulka = tableName);
end;
$$ language plpgsql;
alter function public.deletevazuzel(character varying, integer) owner to %firmaRole%;

-- zaregistrovani triggeru pro mazani vazebnich uzlu nad tabulkou ceniku
create or replace function ccenikdeletevazuzel() returns trigger AS $$
begin
    execute deletevazuzel('cz.winstrom.vo.cen.Cenik', OLD.idcenik);
    return OLD;
end;
$$ language plpgsql;
alter function public.ccenikdeletevazuzel() owner to %firmaRole%;

create trigger ccenikdeletevazuzel before delete on ccenik
    for each row execute procedure ccenikdeletevazuzel();

-- odstraneni neplatnych vazebnich uzlu
create or replace function upgrade() returns void as $$
begin
    -- tyhle vazebni uzly smazeme, ukazovaly by totiz na smazany zaznam
    delete from wvazuzel 
        where idvazuzel in
            -- zatim mame stromovy jenom cenik, ale projistotu si zkontrolujeme
            -- ze vazebni uzly ukazuji jenom na strom ceniku
            (select idvazuzel
            from wvazuzel vu
            left join wuzel u on vu.iduzlu = u.iduzel
            left join wstrom s on u.idstrom = s.idstrom
            where s.tabulka = 'cz.winstrom.vo.cen.Cenik'
            and not exists (select 1
                            from ccenik c
                            where c.idcenik = vu.idzaznamu));
end;
$$ language plpgsql;
alter function public.upgrade() owner to %firmaRole%;

select upgrade();
drop function upgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 337, 't');