--------------------------------------------------------------------------------
-- Bug 19932 – [winstrom] - Vzájemné zápočty
--------------------------------------------------------------------------------

ALTER TABLE ddoklint ADD COLUMN zapocet boolean NOT NULL DEFAULT false;
ALTER TABLE dtypdokl ADD COLUMN zapocet boolean NOT NULL DEFAULT false;

update dtypdokl set generovatSkl = false where modul not in ('FAV', 'FAP', 'POK');

-- vlozeni rad a typu dokladu
create or replace function runupgrade()
    returns void as $$
declare
    _idtyporgread integer;
    _pocet integer;
begin
  select idtyporg into _idtyporgread from nnastav limit 1;

  -- typy dokladu a rady vkladame jen pro ceske podnikatele
  if (_idtyporgread = 1) then
  -- zacatek bloku ceskych podnikatelu
    -- dokladove rady
    INSERT INTO drady (lastupdate, kod, nazev, show, platiod, platido, modul, uuid)
     VALUES ('2010-07-22 00:00:00.000', generateuniquekod('ZAPOCET+', 'dRady', '_'), 'Zápočet +', true, 0, 9999, 'BAN', 'CZ_ZAPOCET_PLUS');
    INSERT INTO dradyrok (lastupdate, cisdelka, zobraznuly, cisakt, cispoc, prefix, postfix, idrady, iducetobdobi)
     VALUES ('2010-07-22 00:00:00.000', 4, true, 1, 1, 'ZAP+', '/%YYYY%', (select IdRady from dRady where uuid = 'CZ_ZAPOCET_PLUS'), (select max(iducetobdobi) from nucetobdobi));
    INSERT INTO drady (lastupdate, kod, nazev, show, platiod, platido, modul, uuid)
     VALUES ('2010-07-22 00:00:00.000', generateuniquekod('ZAPOCET-', 'dRady', '_'), 'Zápočet -', true, 0, 9999, 'BAN', 'CZ_ZAPOCET_MINUS');
    INSERT INTO dradyrok (lastupdate, cisdelka, zobraznuly, cisakt, cispoc, prefix, postfix, idrady, iducetobdobi)
     VALUES ('2010-07-22 00:00:00.000', 4, true, 1, 1, 'ZAP-', '/%YYYY%', (select IdRady from dRady where uuid = 'CZ_ZAPOCET_MINUS'), (select max(iducetobdobi) from nucetobdobi));

    -- ucet
    select count(*) into _pocet from uucty where kod = '395000';
    if(_pocet = 0) then
      INSERT INTO uucty (lastupdate, kod, nazev, show, danovy, saldo, typuctuk, druhuctuk, prijemfav, vydejfap, prijemskl, vydejskl, prijemban, vydejban, prijempok, vydejpok, idstducet, idtyporg, uuid)
       VALUES ('2010-07-23 00:00:00.000', '395000', 'Vnitřní zúčtování - zápočet', true, false, false, 'typUctu.rozvahovy', 'druhUctu.aktivni', false, false, false, false, false, false, false, false, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_395'), 1, 'CZ_POD_395000');
    end if;

    -- typ dokladu
    INSERT INTO dtypdokl (lastupdate, kod, nazev, show, modul, ucetni, typdoklk, primarni, slevadokl, generovatskl, buckonverze, bucprimarni, tiskfaktura, tiskdodak, tiskpokldokl, tiskdodakvydejka, tiskvydejka, tiskautomat, prodejka, zapocet, platiod, platido, idradyprijem, idradyvydej, idmeny, idstatdph, idmenabanky, idprimucet, idtyporg, uuid)
      VALUES ('2010-07-23 00:00:00.000', generateuniquekod('ZAPOCET', 'dTypDokl', '_'), 'Zápočet', true, 'BAN', true, 'typBanUctu.kc', false, 0.0, false, false, false, true, false, false, false, false, false, false, true, 0, 9999, (select IdRady from dRady where uuid = 'CZ_ZAPOCET_PLUS'), (select IdRady from dRady where uuid = 'CZ_ZAPOCET_MINUS'), (select IdMeny from uMeny where uuid = 'CZ_CZK'), (select IdStatu from aStaty where uuid like '%_CZ'), (select IdMeny from uMeny where uuid = 'CZ_CZK'), (select iducet from uUcty where uuid = 'CZ_POD_395000'), 1, 'CZ_ZAPOCET');
  end if;
  -- konec ceskeho bloku
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 342, 't');
