--------------------------------------------------------------------------------
-- Bug 21016 – [winstrom] Do pokladny, banky a skladu doplnit typ dokladu
--------------------------------------------------------------------------------

alter table dpolsklad disable trigger all;
alter table dpolfak disable trigger all;
alter table dpolint disable trigger all;

CREATE SEQUENCE seq_dbsp
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

ALTER TABLE public.seq_dbsp OWNER TO %firmaRole%;


CREATE TABLE dbsp (
    idbsp integer DEFAULT nextval('seq_dbsp'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    modul character varying(3) NOT NULL,

    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    uuid character varying(50),

    buc character varying(255),
    iban character varying(255),
    bic character varying(255),
    specsym character varying(255),
    bucprimarni boolean DEFAULT false NOT NULL,
    -- typuctuk character varying(50),    -- kopie; ale stejne se asi nikde nepouziva

    nazbanky character varying(255),
    ulice character varying(255),
    mesto character varying(255),
    psc character varying(255),
    tel character varying(255),
    mobil character varying(255),
    email character varying(255),
    www character varying(255),
    fax character varying(255),

    zkrklienta character varying(255),
    buckonverze boolean DEFAULT false NOT NULL,
    slovypis character varying(255),
    privypis character varying(255),
    sloprikaz character varying(255),
    priprikaz character varying(255),

    automatickysklad boolean NOT NULL DEFAULT false,

    iducetobdobiod integer,  -- kopie
    iducetobdobido integer,  -- kopie
    idradyprijem integer,    -- kopie
    idradyvydej integer,     -- kopie
    idstred integer,         -- kopie
    idmeny integer,          -- pro BSP přesun
    idmenabanky integer,
    idelbanformat integer,
    idsmerkod integer,
    idstatu integer,
    idprimucet integer,      -- pro BSP přesun
    idtyporg integer NOT NULL,

    CONSTRAINT dbsp_pkey PRIMARY KEY (idbsp),

    CONSTRAINT dbsp_iducetobdobiod FOREIGN KEY (iducetobdobiod)
      REFERENCES nucetobdobi (iducetobdobi) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT dbsp_iducetobdobido FOREIGN KEY (iducetobdobido)
      REFERENCES nucetobdobi (iducetobdobi) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT dbsp_idradyprijem FOREIGN KEY (idradyprijem)
      REFERENCES drady (idrady) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT dbsp_idradyvydej FOREIGN KEY (idradyvydej)
      REFERENCES drady (idrady) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT dbsp_idstred FOREIGN KEY (idstred)
      REFERENCES ustrediska (idstred) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT dbsp_idmeny FOREIGN KEY (idmeny)
      REFERENCES umeny (idmeny) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT dbsp_idmenabanky FOREIGN KEY (idmenabanky)
      REFERENCES umeny (idmeny) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT dbsp_idelbanformat FOREIGN KEY (idelbanformat)
      REFERENCES delbanformat (idelbanformat) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT dbsp_idsmerkod FOREIGN KEY (idsmerkod)
      REFERENCES asmerkod (idsmerkod) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT dbsp_idstatu FOREIGN KEY (idstatu)
      REFERENCES astaty (idstatu) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT dbsp_idprimucet FOREIGN KEY (idprimucet)
      REFERENCES uucty (iducet) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT dbsp_idtyporg FOREIGN KEY (idtyporg)
      REFERENCES utyporg (idtyporg) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

ALTER TABLE public.dbsp OWNER TO %firmaRole%;


CREATE INDEX dbsp_iducetobdobiod_index ON dBsp USING btree (iducetobdobiod);
CREATE INDEX dbsp_iducetobdobido_index ON dBsp USING btree (iducetobdobido);
CREATE INDEX dbsp_idradyprijem_index ON dBsp USING btree (idradyprijem);
CREATE INDEX dbsp_idradyvydej_index ON dBsp USING btree (idradyvydej);
CREATE INDEX dbsp_idstred_index ON dBsp USING btree (idstred);
CREATE INDEX dbsp_idmeny_index ON dBsp USING btree (idmeny);
CREATE INDEX dbsp_idmenabanky_index ON dBsp USING btree (idmenabanky);
CREATE INDEX dbsp_idelbanformat_index ON dBsp USING btree (idelbanformat);
CREATE INDEX dbsp_idsmerkod_index ON dBsp USING btree (idsmerkod);
CREATE INDEX dbsp_idstatu_index ON dBsp USING btree (idstatu);
CREATE INDEX dbsp_idprimucet_index ON dBsp USING btree (idprimucet);
CREATE INDEX dbsp_idtyporg_index ON dBsp USING btree (idtyporg);


--------------------------------------------------------------------------------


ALTER TABLE dtypdokl
    ADD COLUMN typpohybuk character varying(50),
    ADD COLUMN typpohybuskladk character varying(50),
    ADD COLUMN idbsp integer,
    ADD COLUMN idbspban integer,
    ADD COLUMN idtypprotidokladuprijem integer,
    ADD COLUMN idtypprotidokladuvydej integer,

    ADD CONSTRAINT dbsp_idbsp FOREIGN KEY (idbsp)
      REFERENCES dbsp (idbsp) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    ADD CONSTRAINT dbsp_idbspban FOREIGN KEY (idbspban)
      REFERENCES dbsp (idbsp) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    ADD CONSTRAINT dtypdokl_idtypprotidokladuprijem FOREIGN KEY (idtypprotidokladuprijem)
      REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    ADD CONSTRAINT dtypdokl_idtypprotidokladuvydej FOREIGN KEY (idtypprotidokladuvydej)
      REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX dtypdokl_idbsp_index ON dtypdokl USING btree (idbsp);
CREATE INDEX dtypdokl_idbspban_index ON dtypdokl USING btree (idbspban);
CREATE INDEX dtypdokl_idtypprotidokladuprijem_index ON dtypdokl USING btree (idtypprotidokladuprijem);
CREATE INDEX dtypdokl_idtypprotidokladuvydej_index ON dtypdokl USING btree (idtypprotidokladuvydej);


ALTER TABLE ddoklfak
    ADD COLUMN idbsp integer,
    ADD COLUMN idbspban integer,
    ADD COLUMN idtypdoklskl integer,

    ADD CONSTRAINT dbsp_idbsp FOREIGN KEY (idbsp)
      REFERENCES dbsp (idbsp) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    ADD CONSTRAINT dbsp_idbspban FOREIGN KEY (idbspban)
      REFERENCES dbsp (idbsp) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    ADD CONSTRAINT ddoklfak_idtypdoklskl FOREIGN KEY (idtypdoklskl)
      REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX ddoklfak_idbsp_index ON ddoklfak USING btree (idbsp);
CREATE INDEX ddoklfak_idbspban_index ON ddoklfak USING btree (idbspban);
CREATE INDEX ddoklfak_idtypdoklskl_index ON ddoklfak USING btree (idtypdoklskl);


ALTER TABLE ddoklint
    ADD COLUMN idbsp integer,
    ADD COLUMN idbspban integer,
    ADD COLUMN idtypdoklskl integer,

    ADD CONSTRAINT dbsp_idbsp FOREIGN KEY (idbsp)
      REFERENCES dbsp (idbsp) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    ADD CONSTRAINT dbsp_idbspban FOREIGN KEY (idbspban)
      REFERENCES dbsp (idbsp) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    ADD CONSTRAINT ddoklint_idtypdoklskl FOREIGN KEY (idtypdoklskl)
      REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX ddoklint_idbsp_index ON ddoklint USING btree (idbsp);
CREATE INDEX ddoklint_idbspban_index ON ddoklint USING btree (idbspban);
CREATE INDEX ddoklint_idtypdoklskl_index ON ddoklint USING btree (idtypdoklskl);


ALTER TABLE ddoklobch
    ADD COLUMN idbsp integer,
    ADD COLUMN idbspban integer,
    ADD COLUMN idtypdoklskl integer,

    ADD CONSTRAINT dbsp_idbsp FOREIGN KEY (idbsp)
      REFERENCES dbsp (idbsp) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    ADD CONSTRAINT dbsp_idbspban FOREIGN KEY (idbspban)
      REFERENCES dbsp (idbsp) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    ADD CONSTRAINT ddoklobch_idtypdoklskl FOREIGN KEY (idtypdoklskl)
      REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX ddoklobch_idbsp_index ON ddoklobch USING btree (idbsp);
CREATE INDEX ddoklobch_idbspban_index ON ddoklobch USING btree (idbspban);
CREATE INDEX ddoklobch_idtypdoklskl_index ON ddoklobch USING btree (idtypdoklskl);


ALTER TABLE ddoklsklad
    ADD COLUMN idbsp integer,
    ADD COLUMN idbspban integer,
    ADD COLUMN idtypdoklskl integer,

    ADD CONSTRAINT dbsp_idbsp FOREIGN KEY (idbsp)
      REFERENCES dbsp (idbsp) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    ADD CONSTRAINT dbsp_idbspban FOREIGN KEY (idbspban)
      REFERENCES dbsp (idbsp) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    ADD CONSTRAINT ddoklsklad_idtypdoklskl FOREIGN KEY (idtypdoklskl)
      REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX ddoklsklad_idbsp_index ON ddoklsklad USING btree (idbsp);
CREATE INDEX ddoklsklad_idbspban_index ON ddoklsklad USING btree (idbspban);
CREATE INDEX ddoklsklad_idtypdoklskl_index ON ddoklsklad USING btree (idtypdoklskl);


ALTER TABLE skarty
     ADD COLUMN idskladu integer,
     ALTER COLUMN idtypdokl drop not null,
     DROP CONSTRAINT skarty_idcenik_key,
     ADD CONSTRAINT skarty_idskladu FOREIGN KEY (idskladu)
       REFERENCES dbsp (idbsp) MATCH SIMPLE
       ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX skarty_idskladu_index ON skarty USING btree (idskladu);


ALTER TABLE dpolfak
    ADD COLUMN idbspskl integer,

    ADD CONSTRAINT dbsp_idbspskl FOREIGN KEY (idbspskl)
      REFERENCES dbsp (idbsp) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX dpolfak_idbspskl_index ON dpolfak USING btree (idbspskl);


ALTER TABLE dpolint
    ADD COLUMN idbspskl integer,

    ADD CONSTRAINT dbsp_idbspskl FOREIGN KEY (idbspskl)
      REFERENCES dbsp (idbsp) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX dpolint_idbspskl_index ON dpolint USING btree (idbspskl);


ALTER TABLE dpolobch
    ADD COLUMN idbspskl integer,

    ADD CONSTRAINT dbsp_idbspskl FOREIGN KEY (idbspskl)
      REFERENCES dbsp (idbsp) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX dpolobch_idbspskl_index ON dpolobch USING btree (idbspskl);


ALTER TABLE dpolsklad
    ADD COLUMN idbspskl integer,

    ADD CONSTRAINT dbsp_idbspskl FOREIGN KEY (idbspskl)
      REFERENCES dbsp (idbsp) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX dpolsklad_idbspskl_index ON dpolsklad USING btree (idbspskl);

ALTER TABLE svyrobnicislo
    ADD COLUMN idskladu integer,

    ADD CONSTRAINT svyrobnicislo_idskladu FOREIGN KEY (idskladu)
      REFERENCES dbsp (idbsp) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX sVyrobniCislo_IdSkladu_index ON sVyrobniCislo USING btree (IdSkladu);

-- vytvoreni pomocneho sloupce pro rezervace
ALTER TABLE srezervace
    DROP CONSTRAINT fk1f4f5aae39262734;

-- vytvoreni pomocneho sloupce pro mapovani skladu
ALTER TABLE smapsklad
    DROP CONSTRAINT smapsklad_idsklad;


-- rozsireni nastaveni pro nacitani vypisu
ALTER TABLE nnastav ADD COLUMN idtdbanprijem integer;
ALTER TABLE nnastav ADD COLUMN idtdbanvydej integer;

ALTER TABLE nnastav ADD CONSTRAINT nnastav_idtdbanprijem FOREIGN KEY (idtdbanprijem)
  REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT nnastav_idtdbanvydej FOREIGN KEY (idtdbanvydej)
  REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX nNastav_IdTdBanPrijem_index ON nNastav USING btree (IdTdBanPrijem);
CREATE INDEX nNastav_IdTdBanVydej_index ON nNastav USING btree (IdTdBanVydej);

--------------------------------------------------------------------------------


CREATE OR REPLACE FUNCTION runupgrade() RETURNS void AS $$
DECLARE
  _td record;
  _idbsp integer;
  _idtypdoklpv integer;
  _idtypdoklv integer;
BEGIN

  -- Provazani puvodniho TypDokl s novym Bsp
  FOR _td IN (SELECT * FROM dtypdokl WHERE modul IN ('BAN', 'POK', 'SKL') AND zapocet = false) LOOP
    INSERT INTO dbsp (lastupdate, modul,
      kod, nazev, nazeva, nazevb, nazevc,
      popis, poznam, show, platido, platiod, uuid,
      buc, iban, bic, specsym, bucprimarni,
      nazbanky, ulice, mesto, psc,
      tel, mobil, email, www, fax,
      zkrklienta, buckonverze, slovypis, privypis, sloprikaz, priprikaz,
      iducetobdobiod, iducetobdobido, idradyprijem, idradyvydej, idstred,
      idmeny, idmenabanky, idelbanformat, idsmerkod, idstatu, idprimucet, idtyporg,
      automatickysklad)
    VALUES (_td.lastupdate, _td.modul,
      _td.kod, _td.nazev, _td.nazeva, _td.nazevb, _td.nazevc,
      _td.popis, _td.poznam, _td.show, _td.platido, _td.platiod, _td.uuid,
      _td.buc, _td.iban, _td.bic, _td.specsym, _td.bucprimarni,
      _td.nazbanky, _td.ulice, _td.mesto, _td.psc,
      _td.tel, _td.mobil, _td.email, _td.www, _td.fax,
      _td.zkrklienta, _td.buckonverze, _td.slovypis, _td.privypis, _td.sloprikaz, _td.priprikaz,
      _td.iducetobdobiod, _td.iducetobdobido, _td.idradyprijem, _td.idradyvydej, _td.idstred,
      _td.idmeny, _td.idmenabanky, _td.idelbanformat, _td.idsmerkod, _td.idstatu, _td.idprimucet, _td.idtyporg,
      _td.automatickySklad);

    SELECT currval('seq_dbsp') into _idbsp;

    -- Nasetovani vazby na BSP + vynulovani potrebnych poli
    -- 1) ty, ktere se presunuli z typu dokladu do BSP, ale na typu dokladu zustaly pro ostatni moduly.
    -- idmeny integer,          -- pro BSP přesun
    -- idprimucet integer,      -- pro BSP přesun
    -- 2) ty, ktere se zkopirovali, ale na typu dokladu by meli byt prazdne
    -- idradyprijem integer,    -- kopie
    -- idradyvydej integer,     -- kopie
    -- idstred integer,         -- kopie

    UPDATE dtypdokl
    SET idbsp = _idbsp,
        idmeny = null, idprimucet = null,
        idradyprijem = null, idradyvydej = null, idstred = null,
        kod = generateuniquekod('TYP ' || substring(kod from 1 for 16), 'dtypdokl', ' '),
        nazev = 'Typ pro ' || substring(nazev from 1 for 245)
    WHERE idtypdokl = _td.idtypdokl;

/* Kdybysme chteli puvodni typ dokladu rozdelit na 2: 1) TD pro prijem; 2) TD pro vydej
    UPDATE dtypdokl
    SET idbsp = _idbsp,
        idmeny = null, idprimucet = null,
        idradyprijem = null, idradyvydej = null, idstred = null,
        kod = substring(kod from 1 for 18) || '-P',
        nazev = 'Příjem na ' || substring(nazev from 1 for 245),
        typpohybuk = 'typPohybu.prijem', idtypucopv = null,
        uuid = uuid || '-P'
    WHERE idtypdokl = _td.idtypdokl;

    -- Puvodni TypDokl jsem predelali na typ pohybu pro prijem
    --  + vytvorime kopii TypDokl pro vydej

    _td.idbsp := _idbsp;
    _td.idmeny := null;
    _td.idprimucet := null;
    _td.idradyprijem := null;
    _td.idradyvydej := null;
    _td.idstred := null;

    _td.kod := substring(_td.kod from 1 for 18) || '-V';
    _td.nazev := 'Výdej z ' || substring(_td.nazev from 1 for 245);
    _td.typpohybuk = 'typPohybu.vydej';
    _td.idtypucopp = null;
    _td.uuid := _td.uuid || '-V';

    _idtypdoklpv = _td.idtypdokl;
    SELECT nextval('seq_dtypdokl') INTO _td.idtypdokl;
    _idtypdoklv = _td.idtypdokl;

    INSERT INTO dtypdokl
      ( idtypdokl, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, "show",
      bic, buc, buckonverze, bucprimarni, doprava, popisdoklad, uvodtxt, zavtxt,
      email, fax, formauhrk, iban, mesto, mobil, modul, nazbanky, priprikaz, privypis, psc,
      slevadokl, sloprikaz, slovypis, specsym, splatdny, tel, typdoklk, ucetni, ulice,
      www, zaokrjakdphk, zaokrjaksumk, zaokrnadphk, zaokrnasumk, zkrklienta,
      idradyprijem, idstatpuvod, idstatodesl, idobchtrans, idradyvydej, iducetobdobiod,
      idstatdph, idsmerkod, idelbanformat, idkonsym, iddruhdopr, idprimucet, idzvlpoh,
      idstred, idcinnost, idstatu, idtypdoklban, idmeny, idmenabanky, idkrajurc, iducetobdobido,
      iddodpodm, idstaturc, idtyporg, idtypucopp, idtypucopv, platido, platiod,
      razeniprotiskk, tiskautomat, primarni, prodejka, zapocet, automatickysklad,
      idtypdoklpok, idtypdoklskl, uuid, generovatskl, typpohybuk, idbsp, idbspban )
    VALUES
      ( _td.idtypdokl, _td.lastupdate, _td.kod, _td.nazev, _td.nazeva, _td.nazevb, _td.nazevc, _td.popis, _td.poznam, _td."show",
      _td.bic, _td.buc, _td.buckonverze, _td.bucprimarni, _td.doprava, _td.popisdoklad, _td.uvodtxt, _td.zavtxt,
      _td.email, _td.fax, _td.formauhrk, _td.iban, _td.mesto, _td.mobil, _td.modul, _td.nazbanky, _td.priprikaz, _td.privypis, _td.psc,
      _td.slevadokl, _td.sloprikaz, _td.slovypis, _td.specsym, _td.splatdny, _td.tel, _td.typdoklk, _td.ucetni, _td.ulice,
      _td.www, _td.zaokrjakdphk, _td.zaokrjaksumk, _td.zaokrnadphk, _td.zaokrnasumk, _td.zkrklienta,
      _td.idradyprijem, _td.idstatpuvod, _td.idstatodesl, _td.idobchtrans, _td.idradyvydej, _td.iducetobdobiod,
      _td.idstatdph, _td.idsmerkod, _td.idelbanformat, _td.idkonsym, _td.iddruhdopr, _td.idprimucet, _td.idzvlpoh,
      _td.idstred, _td.idcinnost, _td.idstatu, _td.idtypdoklban, _td.idmeny, _td.idmenabanky, _td.idkrajurc, _td.iducetobdobido,
      _td.iddodpodm, _td.idstaturc, _td.idtyporg, _td.idtypucopp, _td.idtypucopv, _td.platido, _td.platiod,
      _td.razeniprotiskk, _td.tiskautomat, _td.primarni, _td.prodejka, _td.zapocet, _td.automatickysklad,
      _td.idtypdoklpok, _td.idtypdoklskl, _td.uuid, _td.generovatskl, _td.typpohybuk, _td.idbsp, _td.idbspban );

    UPDATE ddoklint
    SET idtypdokl = _idtypdoklv
    WHERE idtypdokl = _idtypdoklpv and typpohybuk = 'typPohybu.vydej';

    UPDATE ddoklsklad
    SET idtypdokl = _idtypdoklv
    WHERE idtypdokl = _idtypdoklpv and typpohybuk = 'typPohybu.vydej';
*/

  END LOOP;

  -- Prevazani TypDokl.idTypDoklban -> TypDokl.idBsp
  UPDATE dtypdokl AS td
  SET idbspban = ban.idbsp
  FROM dtypdokl AS ban
  WHERE td.idtypdoklban IS NOT NULL AND td.idtypdoklban = ban.idtypdokl;

  -- Prevazani dDoklFak
  UPDATE ddoklfak AS d
  SET idbsp = td.idbsp
  FROM dtypdokl AS td
  WHERE d.idtypdokl = td.idtypdokl;

  UPDATE ddoklfak AS d
  SET idbspban = td.idbsp
  FROM dtypdokl AS td
  WHERE d.idtypdoklban IS NOT NULL AND d.idtypdoklban = td.idtypdokl;

  -- Prevazani dDoklInt
  UPDATE ddoklint AS d
  SET idbsp = td.idbsp
  FROM dtypdokl AS td
  WHERE d.idtypdokl = td.idtypdokl;

  UPDATE ddoklint AS d
  SET idbspban = td.idbsp
  FROM dtypdokl AS td
  WHERE d.idtypdoklban IS NOT NULL AND d.idtypdoklban = td.idtypdokl;

  -- Prevazani dDoklObch
  UPDATE ddoklobch AS d
  SET idbsp = td.idbsp
  FROM dtypdokl AS td
  WHERE d.idtypdokl = td.idtypdokl;

  UPDATE ddoklobch AS d
  SET idbspban = td.idbsp
  FROM dtypdokl AS td
  WHERE d.idtypdoklban IS NOT NULL AND d.idtypdoklban = td.idtypdokl;

  -- Prevazani dDoklSklad
  UPDATE ddoklsklad AS d
  SET idbsp = td.idbsp
  FROM dtypdokl AS td
  WHERE d.idtypdokl = td.idtypdokl;

  UPDATE ddoklsklad AS d
  SET idbspban = td.idbsp
  FROM dtypdokl AS td
  WHERE d.idtypdoklban IS NOT NULL AND d.idtypdoklban = td.idtypdokl;

  -- Prevazani dPolFak
  UPDATE dpolfak AS p
  SET idbspskl = td.idbsp
  FROM dtypdokl AS td
  WHERE p.idskladu IS NOT NULL AND p.idskladu = td.idtypdokl;

  -- Prevazani dPolint
  UPDATE dpolint AS p
  SET idbspskl = td.idbsp
  FROM dtypdokl AS td
  WHERE p.idskladu IS NOT NULL AND p.idskladu = td.idtypdokl;

  -- Prevazani dPolObch
  UPDATE dpolobch AS p
  SET idbspskl = td.idbsp
  FROM dtypdokl AS td
  WHERE p.idskladu IS NOT NULL AND p.idskladu = td.idtypdokl;

  -- Prevazani dPolSklad
  UPDATE dpolsklad AS p
  SET idbspskl = td.idbsp
  FROM dtypdokl AS td
  WHERE p.idskladu IS NOT NULL AND p.idskladu = td.idtypdokl;

  -- Prevazani SkladKaret
  UPDATE skarty AS k
  SET idskladu = td.idbsp
  FROM dtypdokl AS td
  WHERE k.idtypdokl = td.idtypdokl;

  -- Prevazani vyrobnich cisel
  UPDATE svyrobnicislo AS v
  SET idskladu = td.idbsp
  FROM dtypdokl AS td
  WHERE v.idtypdokl = td.idtypdokl;

  -- Prevazani rezervaci
  UPDATE srezervace AS r
  SET idsklad = td.idbsp
  FROM dtypdokl AS td
  WHERE r.idsklad = td.idtypdokl;

  -- Prevazani mapovani skladu
  UPDATE smapsklad AS m
  SET idsklad = td.idbsp
  FROM dtypdokl AS td
  WHERE m.idsklad = td.idtypdokl;

  -- Prevazani prav pristupu k datum
  UPDATE wdataprava AS d
  SET idobjektu = td.idbsp,
  typdatk = 'BSP'
  FROM dtypdokl AS td
  WHERE d.idobjektu = td.idtypdokl AND d.modulk in ('SKL', 'POK', 'BAN') AND d.typdatk = 'TYP_DOKLADU';

  -- smazani naposledy vybraneho typu dokladu pokladnim a bankovnim deniku - budou se pouzivat jine prefixy
  -- ukladame jenom index v combo -> tezko predvybereme spravnou pokladnu
  delete from wsetting WHERE klic = 'pokDenik.vybranyTypDoklPOK' or klic = 'pokDenik.vybranyTypDoklBAN';
END;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

SELECT runupgrade();

DROP FUNCTION runupgrade();

-- Bug 21728 – [WinStrom] V bance zmizel sloupec Banka
-- Smazani vsech nastaveni sloupcu pro typy dokladu BAN, POK a SKL
DELETE FROM wcolumn
WHERE beankey='cz.winstrom.vo.dok.TypDokl$$BAN' OR
  beankey='cz.winstrom.vo.dok.TypDokl$$POK' OR
  beankey='cz.winstrom.vo.dok.TypDokl$$SKL';

-- Nastaveni sloupce typDokl zmenime na bsp - pouze pro doklady BAN, POK a SKL
UPDATE wcolumn
SET propname='bsp'
WHERE (beankey='cz.winstrom.vo.dok.DoklInt$$BAN' OR
  beankey='cz.winstrom.vo.dok.DoklInt$$POK' OR
  beankey='cz.winstrom.vo.dok.DoklSklad') AND
  propname='typDokl';


-- TOHLE MUSI BYT AZ TADY JINAK TO PRO JEDNO ZBOZI A VICE SKLADU PADNE
ALTER TABLE skarty
     ALTER COLUMN idskladu SET NOT NULL,
     ADD CONSTRAINT skarty_idcenik_idbsp_key UNIQUE(idcenik, idskladu, iducetobdobi);

-- odstraneni pomocneho sloupce pro rezervace a privazani constraintu
ALTER TABLE srezervace
    ADD CONSTRAINT srezervace_idsklad FOREIGN KEY (idsklad)
      REFERENCES dbsp (idbsp) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

-- odtsraneni pomocneho sloupce pro mapovani skladu a privazani constraintu
ALTER TABLE smapsklad
    ADD CONSTRAINT smapsklad_idsklad FOREIGN KEY (idsklad)
      REFERENCES dbsp (idbsp) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

--------------------------------------------------------------------------------


-- kdyz uz sme v tom musime odstranit sloupec vyrCis z polozek dokladu
DROP VIEW dpolskladfbezvc;
DROP VIEW dpolskladf;
DROP VIEW dpolskladdoklad;


ALTER TABLE dtypdokl
    DROP COLUMN buc,
    DROP COLUMN iban,
    DROP COLUMN bic,
    DROP COLUMN specsym,
    DROP COLUMN bucprimarni,

    DROP COLUMN nazbanky,
    DROP COLUMN ulice,
    DROP COLUMN mesto,
    DROP COLUMN psc,
    DROP COLUMN tel,
    DROP COLUMN mobil,
    DROP COLUMN email,
    DROP COLUMN www,
    DROP COLUMN fax,

    DROP COLUMN zkrklienta,
    DROP COLUMN buckonverze,
    DROP COLUMN slovypis,
    DROP COLUMN privypis,
    DROP COLUMN sloprikaz,
    DROP COLUMN priprikaz,

    DROP COLUMN automatickysklad,

    DROP COLUMN idmenabanky,
    DROP COLUMN idelbanformat,
    DROP COLUMN idsmerkod,
    DROP COLUMN idstatu,
    DROP COLUMN idtypdoklban;


ALTER TABLE dtypdokl
    DROP COLUMN idtiskses1,
    DROP COLUMN idtiskses2,
    DROP COLUMN idtiskses3,
    DROP COLUMN idtiskses4,
    DROP COLUMN idtiskses5,
    DROP COLUMN idtiskses6,
    DROP COLUMN jazyk1k,
    DROP COLUMN jazyk2k,
    DROP COLUMN jazyk3k,
    DROP COLUMN jazyk4k,
    DROP COLUMN jazyk5k,
    DROP COLUMN jazyk6k;


DROP TABLE wtiskses;
DROP SEQUENCE seq_wtiskses;


ALTER TABLE ddoklfak
    DROP COLUMN idtypdoklban;

ALTER TABLE ddoklint
    DROP COLUMN idtypdoklban;

ALTER TABLE ddoklobch
    DROP COLUMN idtypdoklban;

ALTER TABLE ddoklsklad
    DROP COLUMN idtypdoklban;


ALTER TABLE dpolfak
    DROP COLUMN idskladu,
    DROP COLUMN vyrCis;

ALTER TABLE dpolint
    DROP COLUMN idskladu,
    DROP COLUMN vyrCis;

ALTER TABLE dpolobch
    DROP COLUMN idskladu,
    DROP COLUMN vyrCis;

ALTER TABLE dpolsklad
    DROP COLUMN idskladu,
    DROP COLUMN vyrCis;


ALTER TABLE skarty
    DROP COLUMN idtypdokl;

ALTER TABLE svyrobnicislo
    DROP COLUMN idtypdokl;

--------------------------------------------------------------------------------

-- pridame novy sloupec na prikaz k uhrade
ALTER TABLE dprikazuhr ADD COLUMN idbanka integer;
ALTER TABLE dprikazuhr ADD CONSTRAINT dprikazuhr_idbanka FOREIGN KEY (idbanka)
  REFERENCES dbsp (idbsp) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
CREATE INDEX dprikazuhr_idbanka_index ON dprikazuhr USING btree (idbanka);

-- vyplnime ho
update dprikazuhr as P set idbanka = T.idbsp from dtypdokl as T 
  where T.idtypdokl = P.idtypdokl;

-- nastavime not null
ALTER TABLE dprikazuhr ALTER COLUMN idbanka SET NOT NULL;
-- odebereme stary
ALTER TABLE dprikazuhr DROP COLUMN idtypdokl;

--------------------------------------------------------------------------------

-- pridame novy sloupec na typ dokladu (pro prodejky)
ALTER TABLE dtypdokl ADD COLUMN idbspskl integer;
ALTER TABLE dtypdokl ADD CONSTRAINT dtypdokl_idbspskl FOREIGN KEY (idbspskl)
  REFERENCES dbsp (idbsp) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
CREATE INDEX dtypdokl_idbspskl_index ON dtypdokl USING btree (idbspskl);

-- vyplnime ho
update dtypdokl as K set idbspskl = T.idbsp from dtypdokl as T 
  where T.idtypdokl = K.idtypdoklskl and K.prodejka;

-- odebereme stary
ALTER TABLE dtypdokl DROP COLUMN idtypdoklskl;

--------------------------------------------------------------------------------
-- UPGRADE pohledus
--------------------------------------------------------------------------------

CREATE OR REPLACE VIEW dpolskladdoklad AS
 SELECT p.idpolsklad, p.lastupdate, p.autozaokr, p.autogen, p.baleniid, p.cenjednotka, p.cenamj,
   p.cenamjnakup, p.cenamjprodej, p.cisrad, p.datucto, p.datvyst, p.eankod, p.expirace, p.kod,
   p.kopclendph, p.kopdphdalucet, p.kopdphmducet, p.kopklice, p.kopstred, p.kopzakazku, p.kopzkldalucet,
   p.kopzklmducet, p.mnozbaleni, p.mnozmj, p.mnozmjplan, p.mnozmjreal, p.modul, p.nazev, p.objednatk, p.objem,
   p.poznam, p.proczakl, p.rezervovat, p.sarze, p.slevadokl, p.slevamnoz, p.slevapol, p.stavuzivk,
   p.storno, p.stornopol, p.sumdph, p.sumdphmen, p.sumzkl, p.sumzklmen, p.szbdph, p.typcenydphk, p.typpolozkyk,
   p.typszbdphk, p.typvypcenyk, p.ucetni, p.uplslevadokl, p.zaokrjakk, p.zaokrnak,
   p.idzkldalucet, p.iddphdalucet, p.idmjobjem, p.idmeny, p.idstred, p.idkarty, p.idcenik, p.idzklmducet, p.iddphmducet,
   p.idsazbydph, p.idclendph, p.idzakazky, p.idmj, p.iddoklsklad, p.idbspskl as idskladu, p.idfirmy, d.typpohybuk
   FROM dpolsklad p
   LEFT JOIN ddoklsklad d ON p.iddoklsklad = d.iddoklsklad;

ALTER TABLE dpolskladdoklad OWNER TO %firmaRole%;

CREATE OR REPLACE VIEW dpolskladf AS
         SELECT p.idpolsklad, p.mnozmj - jevydano(p.idpolsklad) AS pocet, p.cenamj, p.datvyst, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, (null) AS idvyrobnicislo, ( SELECT c.evidvyrcis
                   FROM ccenik c
                  WHERE c.idcenik = p.idcenik) AS evidvyrcis
           FROM dpolskladdoklad p
          WHERE p.typpohybuk::text = 'typPohybu.prijem'::text AND (p.mnozmj - jevydano(p.idpolsklad)) > 0::numeric AND (( SELECT c.evidvyrcis
                   FROM ccenik c
                  WHERE c.idcenik = p.idcenik)) = false AND p.storno <> true
UNION ALL
         SELECT p.idpolsklad, 1 AS pocet, p.cenamj, p.datvyst, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, v.idvyrobnicislo, ( SELECT c.evidvyrcis
                   FROM ccenik c
                  WHERE c.idcenik = p.idcenik) AS evidvyrcis
           FROM svyrobnicislo v
      LEFT JOIN dpolskladdoklad p ON p.idpolsklad = v.idpolskladprijem
     WHERE p.typpohybuk::text = 'typPohybu.prijem'::text AND (( SELECT c.evidvyrcis
              FROM ccenik c
             WHERE c.idcenik = p.idcenik)) = true AND NOT (v.idvyrobnicislo IN ( SELECT sfifovazby.idvyrobnicislo
              FROM sfifovazby
             WHERE sfifovazby.idpolskladprijem = p.idpolsklad)) AND p.storno <> true;

ALTER TABLE dpolskladf OWNER TO %firmaRole%;

CREATE OR REPLACE VIEW dpolskladfbezvc AS
 SELECT p.idpolsklad, p.mnozmj - jevydano(p.idpolsklad) AS pocet, p.cenamj, p.datvyst, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, (null) AS idvyrobnicislo, false AS evidvyrcis
   FROM dpolskladdoklad p
  WHERE p.typpohybuk::text = 'typPohybu.prijem'::text AND (p.mnozmj - jevydano(p.idpolsklad)) > 0::numeric AND p.storno <> true;

ALTER TABLE dpolskladfbezvc OWNER TO %firmaRole%;

--------------------------------------------------------------------------------
-- UPGRADE ulozenych procedurs
--------------------------------------------------------------------------------


-- Function: skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, integer)
-- DROP FUNCTION skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, integer);
CREATE OR REPLACE FUNCTION skladfindcenamjnakup(i_mnozmj numeric, i_idcenik integer, i_idskladu integer, i_datum date, i_sarze character varying, i_expirace date, i_idvyrobnihocisla integer)
  RETURNS numeric AS
$BODY$  
declare  
  _sklfifo boolean;  
  _mazatTmpTable boolean;  
  _idkarty integer;  
  _rozsirenaPolozka record;  
  _iducetobdobi integer;  
  _result numeric(19,6);  
  _pomocDPolSkladF record;  
  _mnozstvi numeric(19,6);  
  _potrebnyPocet numeric(19,6);  
  _sadaItemCount integer;  
  _polozkaSady record;  
  _pomoc numeric(19,6);  
  
  _sumSumZkl numeric(19,6);  
  _sumMnozMj numeric(19,6);  
  _sumTuz numeric(19,6);  
  _mnozMj numeric(19,6);  
  _typPohybuK character varying;  
  _karta record;  
begin  
  _result = 0.0;  
  _mnozstvi = 0.0;  
  
  if(i_mnozMj > 0) then  
    select count(*) into _sadaItemCount from csady where idceniksada = i_idcenik;  
    if(_sadaItemCount > 0) then  
      FOR _polozkaSady IN (select * from cSady where idCenikSada = i_idcenik) LOOP  
        -- TODO doresit sarze expirace a vyrobni cisla  
        select skladfindcenamjnakup(i_mnozmj * _polozkaSady.mnozMj, _polozkaSady.idcenik, i_idskladu, i_datum, null, null, null) into _pomoc;  
        _result = _result + (_pomoc * i_mnozmj * _polozkaSady.mnozMj);  
      end loop;  
    else  
      select findiducetniobdobikdatu(i_datum) into _iducetobdobi;  
      _sklfifo := (select isfifosklad(i_datum));  
      if (_sklfifo) then  
        if(i_idvyrobnihocisla is not null and i_idvyrobnihocisla > 0) then  
          -- pokud je zadano vyrobni cislo ma nejvetsi prioritu  
          select cenaMj into _result from dpolsklad where idpolsklad = (select idpolskladprijem from svyrobnicislo where idvyrobnicislo = i_idvyrobnihocisla);
        elsif(i_sarze is not null and i_expirace is not null) then  
          -- pokud je zadana sarze i expirace  
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu and sarze = i_sarze and expirace = i_expirace order by datVyst,idpolsklad) loop  
            if(i_mnozMj > _mnozstvi) then  
              _potrebnyPocet = _pomocDPolSkladF.pocet;  
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then  
                _potrebnyPocet = i_mnozMj - _mnozstvi;  
              end if;  
              _mnozstvi = _mnozstvi + _potrebnyPocet;  
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj;  
            end if;  
          end loop;  
          if(_mnozstvi != 0.0) then  
            _result = _result / _mnozstvi;  
          else  
            _result = 0.0;  
          end if;  
        elsif(i_sarze is not null and i_expirace is null) then  
          -- pokud je zadana jen sarze  
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu and sarze = i_sarze order by datVyst,idpolsklad) loop  
            if(i_mnozMj > _mnozstvi) then  
              _potrebnyPocet = _pomocDPolSkladF.pocet;  
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then  
                _potrebnyPocet = i_mnozMj - _mnozstvi;  
              end if;  
              _mnozstvi = _mnozstvi + _potrebnyPocet;  
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj;  
            end if;  
          end loop;  
          if(_mnozstvi != 0.0) then  
            _result = _result / _mnozstvi;  
          else  
            _result = 0.0;  
          end if;  
        elsif(i_sarze is null and i_expirace is not null) then  
          -- pokud je zadana jen expirace  
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu and expirace = i_expirace order by datVyst,idpolsklad) loop  
            if(i_mnozMj > _mnozstvi) then  
              _potrebnyPocet = _pomocDPolSkladF.pocet;  
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then  
                _potrebnyPocet = i_mnozMj - _mnozstvi;  
              end if;  
              _mnozstvi = _mnozstvi + _potrebnyPocet;  
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj;  
            end if;  
          end loop;  
          if(_mnozstvi != 0.0) then  
            _result = _result / _mnozstvi;  
          else  
            _result = 0.0;  
          end if;  
        else  
          -- pokud neni zadana ani sarze ani expirace ani vyrobni cislo  
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu order by datVyst,idpolsklad) loop  
            if(i_mnozMj >= _mnozstvi) then  
              _potrebnyPocet = _pomocDPolSkladF.pocet;  
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then  
                _potrebnyPocet = i_mnozMj - _mnozstvi;  
              end if;  
              _mnozstvi = _mnozstvi + _potrebnyPocet;  
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj;  
            end if;  
          end loop;  
          if(_mnozstvi != 0.0) then  
            _result = _result / _mnozstvi;  
          else  
            _result = 0.0;  
          end if;  
        end if;  
      else  
        -- generuji rozsirene polozky  
        select * into _karta from skarty where idcenik = i_idcenik and idskladu = i_idskladu and iducetobdobi = _iducetobdobi;  
	if(_karta is null) then  
	  raise exception 'Nenalezena sklad karta';  
	end if;  
        _sumTuz = 0.0;  
        _mnozMj = 0.0;  
        select sum(p.sumZkl), sum(p.mnozMj) into _sumSumZkl, _sumMnozMj from dPolSklad p, dDoklSklad d  
          where p.idDoklSklad = d.idDoklSklad and p.idKarty = _karta.idKarty and d.typPohybuK = 'typPohybu.prijem' and p.datVyst > i_datum;  
        if(_sumSumZkl is null) then  
          _sumSumZkl = 0.0;  
        end if;  
        if(_sumMnozMj is null) then  
          _sumMnozMj = 0.0;  
        end if;  
        _sumTuz = _sumTuz + _sumSumZkl;  
        _mnozMj = _mnozMj + _sumMnozMj;  
  
        select sum(p.sumZkl), sum(p.mnozMj) into _sumSumZkl, _sumMnozMj from dPolSklad p, dDoklSklad d  
          where p.idDoklSklad = d.idDoklSklad and p.idKarty = _karta.idKarty and d.typPohybuK = 'typPohybu.vydej'and p.datVyst > i_datum;  
        if(_sumSumZkl is null) then  
          _sumSumZkl = 0.0;  
        end if;  
        if(_sumMnozMj is null) then  
          _sumMnozMj = 0.0;  
        end if;  
        _sumTuz = _sumTuz - _sumSumZkl;  
        _mnozMj = _mnozMj - _sumMnozMj;  
  
        _sumTuz = _karta.stavTuz - _sumTuz;  
        _mnozMj = _karta.stavMj - _mnozMj;  
        if(_mnozMj = 0.0) then  
          _result = 0.0;  
        else  
          _result = _sumTuz / _mnozMj;  
        end if;  
      end if;  
    end if;  
  end if;  
  return _result;  
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, integer) OWNER TO %firmaRole%;


-- Function: createdoklsklad(integer, integer, character varying)
-- DROP FUNCTION createdoklsklad(integer, integer, character varying);
CREATE OR REPLACE FUNCTION createdoklsklad(_idpoldokl integer, _iddoklad integer, _modul character varying)
  RETURNS integer AS
$BODY$
declare
  _doklad record;
  _polDokl record;
  _doklSklad record;
  _idDoklSklad integer;
  _cisDoklad character varying;
  _idrada integer;
  _rada record;
  _sklad record;
  _idUcetObd integer;
  _radaRok record;
  _typPohybuSklad character varying;
  _idTypUcOp integer;
  _cisloDokladuCursor refCursor;
  _typDoklFak record;
  _typDoklSkl record;
  _idUcetSklad integer;
  _idProtiUcet integer;
  _typUcOp record;
  _kurz numeric(19,6);
  _idMenyTuzemsko integer;
  _idMenySklad integer;
  _kurzMnozstvi integer;
  _typVazby character varying;
  _stavSklad character varying;
  _typPohybuSkladK character varying;
  _isDobropis boolean;
begin
  if(_modul like 'POK') then
    select * into _doklad from dDoklInt where idDoklInt = _idDoklad;
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;
    _stavSklad = 'stavSklad.vygenPokl';
  elsif (_modul like 'FAV' or _modul like 'FAP') then
    select * into _doklad from dDoklFak where idDoklFak = _idDoklad;
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;
    _stavSklad = 'stavSklad.vygenFakt';
  else
    select * into _doklad from dDoklSklad where idDoklSklad = _idDoklad;
    select * into _polDokl from dPolSklad where idPolSklad = _idPolDokl;
    _stavSklad = 'stavSklad.vyroba';
  end if;

  --select * into _sklad from dTypDokl where idTypDokl = _polDokl.idskladu;
  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl;
  select * into _typDoklFak from dTypDokl where idTypDokl = _doklad.idTypDokl;

  if(_doklad.idTypDoklSkl is null) then
    if(_typDoklFak.typDoklK like 'typDokladu.dobropis') then
      _isDobropis = true;
    else
      _isDobropis = false;
    end if;
    if((_modul like 'FAV' and _isDobropis) or (_modul like 'FAP')) then
      --pro dobropisy vydanych faktur a prijate faktury budeme mit prijemku
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuprijem;
    elsif((_modul like 'FAV' and not _isDobropis)) then
      --pro dobropisy prijatych faktur a vydane faktury budeme mit vydejku
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuvydej;
    elsif(_modul like 'POK' and _doklad.typPohybuK like 'typPohybu.prijem') then
      --pro prijmovy pokladni doklad budeme mit vydejku
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuvydej;
    elsif(_modul like 'POK' and _doklad.typPohybuK like 'typPohybu.vydej') then
      --pro vydajovy pokladni doklad budeme mit prijemku
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuprijem;
    elsif(_modul like 'SKL') then
      -- vyroba
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuvydej;
    else
      raise exception 'createdoklsklad:Nespravny modul %', _modul;
    end if;
    if(_typDoklSkl is null) then
      return null;
    end if;
  else
    select * into _typDoklSkl from dTypDokl where idTypDokl = _doklad.idTypDoklSkl;
  end if;

  -- urceni spravneho typu pohybu
  if((_typDoklFak.modul like 'FAV') and (_typDoklFak.typDoklK like 'typDokladu.dobropis')) then
    _typPohybuSklad = _doklad.typPohybuK;
  else
    if(_doklad.typPohybuK like 'typPohybu.prijem') then
      _typPohybuSklad = 'typPohybu.vydej';
    else
      _typPohybuSklad = 'typPohybu.prijem';
    end if;
  end if;

  -- doplneni zbyvajicich veci zavislich na typu pohybu
  if(_typPohybuSklad like 'typPohybu.prijem') then
    _idrada = _typDoklSkl.idRadyPrijem;
    if(_idrada is null) then
      _idRada = _sklad.idRadyPrijem;
    end if;
    if(_idRada is null) then
      raise exception 'Neni odkud natahnout dokladovou radu.';
    end if;
    _idTypUcOp = _typDoklSkl.idTypUcOpP;
    if(_modul = 'FAV' or _modul = 'FAP' or _modul = 'POK') then
      _typPohybuSkladK = 'typPohybuSklad.prijemPoFak';
    else
      _typPohybuSkladK = 'typPohybuSklad.prijemVyrob';
    end if;
  else
    _idrada = _typDoklSkl.idRadyVydej;
    if(_idrada is null) then
      _idRada = _sklad.idRadyVydej;
    end if;
    if(_idRada is null) then
      raise exception 'Neni odkud natahnout dokladovou radu.';
    end if;
    _idTypUcOp = _typDoklSkl.idTypUcOpV;
    if(_modul = 'FAV' or _modul = 'FAP' or _modul = 'POK') then
      _typPohybuSkladK = 'typPohybuSklad.vydejPoFak';
    else
      _typPohybuSkladK = 'typPohybuSklad.vydejVyrob';
    end if;
  end if;

  _idUcetSklad = _sklad.idPrimUcet;
  select * into _typUcOp from utypucop where idtypucop = _idTypUcOp;
  if(_typPohybuSklad like 'typPohybu.prijem') then
    _idProtiUcet = _typUcOp.idProtiucetP;
  else
    _idProtiUcet = _typUcOp.idProtiucetV;
  end if;
  if(_modul = 'FAP') then
    _idProtiUcet = _doklad.idProtiUcet;
  end if;

  select * into _rada from drady where idRady = _idrada;
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _idUcetObd;
  select * into _radaRok from dRadyRok where iducetobdobi = _idUcetObd and idrady = _idrada;

  select nextval('seq_ddoklsklad') into _idDoklSklad;
  select dgetcisdokl(null, _idrada, _idUcetObd, 'SKL', _typPohybuSklad) into _cisloDokladuCursor;
  fetch _cisloDokladuCursor into _cisDoklad;

  -- ziskani kurzu pro menu skladu
  -- select getKurzFromSklad(_polDokl.idSkladu, _polDokl.datVyst) into _kurz;
  -- nejde pouzit protoze potrebuju jak kurz tak kurzove mnozstvi a ne prepocteny nna kurzove mnozstvi 1
  select idMeny into _idMenyTuzemsko from nNastav where _polDokl.datVyst >= PlatiOdData order by PlatiOdData desc limit 1;
  if (_idMenyTuzemsko is null) then
    select idMeny into _idMenyTuzemsko from nNastav where PlatiOdData is null limit 1;
  end if;
  --select idMeny into _idMenySklad from dTypDokl where idTypDokl = _polDokl.idSkladu;

  if(_sklad.idMeny is null or _sklad.idMeny = _idMenyTuzemsko) then
    _kurz = 0.0;
    _kurzMnozstvi = 1;
  else
    select nbStred, kurzMnozstvi into _kurz, _kurzMnozstvi from uKurzy
      where idMeny = _sklad.idMeny and _polDokl.datVyst >= PlatiOdData and typkurzuk = 'typKurzu.obecny'
      order by PlatiOdData desc limit 1;
    if(_kurz is null) then
      select nbStred, kurzMnozstvi into _kurz, _kurzMnozstvi from uKurzy
        where idMeny = _sklad.idMeny and PlatiOdData is null and typkurzuk = 'typKurzu.obecny'
        limit 1;
    end if;
    if(_kurz is null) then
      raise exception '0001:getKurzFromSklad : neexistuje kurz!';
    end if;
  end if;

  -- vytvoreni noveho skladoveho dokladu
  insert into dDoklSklad (idDoklSklad, lastUpdate, datVyst, datUcto, kod, modul, typPohybuK, idTypDokl, idBsp,ucetni,
         idFirmy, nazFirmy, ulice, mesto, psc, idStatu, ic, dic, vatId,
         idMur, idKrajUrc, idStatUrc, idTypUcOp, cisObj, cisDodak, doprava, idDruhDopr, popis, poznam,
         idStred, idZakazky, idMeny, kurz, kurzMnozstvi,
         eanKod, idstatpuvod, idstatodesl,
         idPrimUcet, idProtiUcet, idRady, idPolRady, zdrojProFak, stavSkladK , typPohybuSkladK
         )
       values (_idDoklSklad, LOCALTIMESTAMP, _doklad.datVyst, _doklad.datVyst, _cisDoklad, 'SKL', _typPohybuSklad, _typDoklSkl.idTypDokl, _sklad.idBsp, _typDoklSkl.ucetni,
         _doklad.idFirmy, _doklad.nazFirmy, _doklad.ulice, _doklad.mesto, _doklad.psc, _doklad.idStatu, _doklad.ic, _doklad.dic, _doklad.vatId,
         _doklad.idMur, _doklad.idKrajUrc, _doklad.idStatUrc, _idTypUcOp, _doklad.cisObj, null, _doklad.doprava, _doklad.idDruhDopr, _doklad.popis, _doklad.poznam,
         _doklad.idStred, _doklad.idZakazky, _sklad.idMeny, _kurz, _kurzMnozstvi,
         _doklad.eanKod, _doklad.idstatpuvod, _doklad.idstatodesl,
         _idUcetSklad, _idProtiUcet, _idRada, _radaRok.idRadyRok, false, _stavSklad, _typPohybuSkladK
         );


  if (_modul = 'SKL') then
    _typVazby = 'typVazbyDokl.hlavaSklKus';
  else
    _typVazby = 'typVazbyDokl.hlavaSkl';
  end if;

  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)
       values (0.0, _idDoklad, _idDoklSklad, _doklad.modul, 'SKL', false, _typVazby);

  return _idDoklSklad;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createdoklsklad(integer, integer, character varying) OWNER TO %firmaRole%;



-- Function: createpolsklad(integer, character varying)
-- DROP FUNCTION createpolsklad(integer, character varying);
CREATE OR REPLACE FUNCTION createpolsklad(_idpoldokl integer, _modul character varying)
  RETURNS integer AS
$BODY$
declare
  _idDoklSklad integer;
  _idDoklad integer;
  _polDokl record;
  _iducetobdobi integer;
  _idkarty integer;
  _idPolSklad integer;
  _cenaMj numeric(19,6);
  _cenaMjTuz numeric(19,6);
  _typPohybuK character varying;
  _prumCenaTuz numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _kurz numeric(19,6);
  _idZklMdUcet integer;
  _idZklDalUcet integer;
  _kopZklMdUcet boolean;
  _kopZklDalUcet boolean;
  _sklad record;
  _typDoklK character varying;
  _mnozMj numeric(19,6);
  _isCiziMena boolean;
  _idMeny integer;
  _skupZboz record;
begin
  _kopZklMdUcet =false;
  _kopZklDalUcet = false;
  if(_modul like 'FAV' or _modul like 'FAP') then
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;
    _idDoklad = _polDokl.idDoklFak;
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);
  else
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;
    _idDoklad = _polDokl.idDoklInt;
    _typDoklK = null; -- pro pokladnu dobropisy nejsou
  end if;

  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad;

  if(_idDoklSklad is null) then
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;
    if(_idDoklSklad is null) then
      return null;
    end if;
  end if;

  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idskladu = _polDokl.idbspskl and iducetobdobi = _iducetobdobi;
  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl;

  select typPohybuK into _typPohybuK from dDoklSklad where idDoklSklad = _idDoklSklad;
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty;
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;
  select idMeny into _idMeny from dDoklSklad where idDoklSklad = _idDoklSklad;

  if(_typPohybuK like 'typPohybu.vydej') then
    -- vsechny dobropisy generuji prijemky
    --if(_typDoklK like 'typDokladu.dobropis') then
    --  _mnozMj = -_polDokl.mnozMj;
    --else
      _mnozMj = _polDokl.mnozMj;
    --end if;
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena
    _cenaMj = _prumCenaTuz / _kurz;
    _sumZkl = _prumCenaTuz * _mnozMj;
    if(_isCiziMena) then
      _sumZklMen = _mnozMj * _cenaMj;
    else
      _sumZklMen = 0.0;
    end if;
    -- nastaveni uctu pro polSklad vydej
    select * into _skupZboz from cskupzboz where idskupzboz = (select idskupzboz from ccenik where idcenik = _polDokl.idCenik);
    if(_skupZboz.idProtiUcetSklV is not null) then
      -- pokud je ve skupine zbozi nastaven protiucet pro vydej ze skladu pouzije se ten a kopirovani se necha na false;
      _idZklMdUcet = _skupZboz.idProtiUcetSklV;
    else
      -- pokud neni ve skupine zbozi nastaven protiucet tak vemu protiucet z hlavicky a dam kopirovat na true
      select idProtiUcet into _idZklMdUcet from dDoklSklad where idDoklSklad = _idDoklSklad;
      _kopZklMdUcet = true;
    end if;
    _idZklDalUcet = _sklad.idPrimUcet;
  else
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny;
      _mnozMj = -_polDokl.mnozMj;
      --_cenaMjTuz = _prumCenaTuz;
      _cenaMjTuz = _polDokl.cenaMjNakup;
      if(_cenaMjTuz = 0.0) then
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik);
        if(_cenaMj = 0.0) then
          _cenaMj = _polDokl.cenaMj * _kurz;
        end if;
      end if;
      _cenaMj = _cenaMjTuz / _kurz;
      _sumZkl = _mnozMj * _cenaMjTuz;
      if(_isCiziMena) then
        _sumZklMen = _mnozMj * _cenaMj;
      else
        _sumZklMen = 0.0;
      end if;
      select * into _skupZboz from cskupzboz where idskupzboz = (select idskupzboz from ccenik where idcenik = _polDokl.idCenik);
      if(_skupZboz.idProtiUcetSklV is not null) then
        -- pokud je ve skupine zbozi nastaven protiucet pro vydej ze skladu pouzije se ten a kopirovani se necha na false;
        _idZklDalUcet = _skupZboz.idProtiUcetSklV;
      else
        -- pokud neni ve skupine zbozi nastaven protiucet tak vemu protiucet z hlavicky a dam kopirovat na true
        select idProtiUcet into _idZklDalUcet from dDoklSklad where idDoklSklad = _idDoklSklad;
        _kopZklDalUcet = true;
      end if;
    else
      -- pokud na sklad prijmam zkopiruji se ceny z faktury
      _mnozMj = _polDokl.mnozMj;
      _sumZkl = _polDokl.sumZkl;
      if(_mnozMj <> 0.0) then
        _cenaMj = _sumZkl / _mnozMj;
      else
        _cenaMj = _sumZkl;
      end if;
      _cenaMj = _cenaMj / _kurz;
      if(_isCiziMena) then
        if(_mnozMj <> 0.0) then
          _sumZklMen = _cenaMj * _mnozMj;
        else
          _sumZklMen = _cenaMj;
        end if;
      else
        _sumZklMen = 0.0;
      end if;
      _idZklDalUcet = _polDokl.idZklMdUcet;
    end if;
    -- nastaveni uctu pro polSklad prijem
    _idZklMdUcet = _sklad.idPrimUcet;
  end if;

  select nextval('seq_dpolsklad') into _idPolSklad;
  insert into dpolsklad(idPolSklad, lastUpdate, idcenik, idbspskl, idkarty, datVyst, datUcto, modul, typPolozkyK, idDoklSklad,
        mnozMj, cenaMj, cenaMjPoriz, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, idmj,
        nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni,
        idStred, idZakazky, idMeny, zdrojProFak)
      values (_idPolSklad, LOCALTIMESTAMP, _polDokl.idcenik, _polDokl.idbspskl, _idkarty, _polDokl.datVyst, _polDokl.datVyst, 'SKL', 'typPolozky.katalog', _idDoklSklad,
        _mnozMj, _cenaMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, _kopZklMdUcet, _kopZklDalUcet, _polDokl.baleniid, _polDokl.mnozBaleni, _polDokl.idmj,
        _polDokl.nazev, _polDokl.nazevA, _polDokl.nazevB, _polDokl.nazevC, _polDokl.sarze, _polDokl.expirace, _polDokl.cisRad, true,
        _polDokl.idStred, _polDokl.idZakazky, _idMeny, false);

  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)
       values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSkl');

  -- prepocteni sum na dokladu
  execute sprepoctiSumyDokladu(_idDoklSklad);

  return _idPolSklad;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createpolsklad(integer, character varying) OWNER TO %firmaRole%;


-- Function: createpolskladsada(integer, character varying)
-- DROP FUNCTION createpolskladsada(integer, character varying);
CREATE OR REPLACE FUNCTION createPolSkladSada(_idPolDokl integer, _modul character varying)
  RETURNS void AS
$BODY$
declare
  _polDokl record;
  _doklad record;
  _polozkaSady record;
  _skladKarta record;
  _cenik record;
  _sklad record;
  _idDoklSklad integer;
  _idDoklad integer;
  _idMeny integer;
  _idUcetObdobi integer;
  _idKarty integer;
  _idPolSklad integer;
  _idZklMdUcet integer;
  _idZklDalUcet integer;
  _i integer;
  _cisRad integer;
  _typDoklK character varying;
  _mnozMj numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _cenaMj numeric(19,6);
  _kurz numeric(19,6);
  _isCiziMena boolean;
  _nasobic integer;
  _idSkladu integer;
  _kopZklMdUcet boolean;
  _kopZklDalUcet boolean;
begin

  if(_modul like 'FAV' or _modul like 'FAP') then
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;
    _idDoklad = _polDokl.idDoklFak;
    select * into _doklad from dDoklFak where idDoklFak = _idDoklad;
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);
  else
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;
    _idDoklad = _polDokl.idDoklInt;
    select * into _doklad from dDoklInt where idDoklInt = _idDoklad;
    _typDoklK = null; -- pro pokladnu dobropisy nejsou
  end if;

  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad;

  if(_idDoklSklad is null) then
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;
    if(_idDoklSklad is null) then
      return;
    end if;
  end if;

  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;
  select idMeny into _idMeny from dDoklSklad where idDoklSklad = _idDoklSklad;

  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl;

  _i = 0;

  FOR _polozkaSady IN
    select * from cSady where idCenikSada = _polDokl.idCenik
  LOOP
    select * into _cenik from cCenik where idCenik = _polozkaSady.idCenik;

    if(_cenik.skladove) then
      _i = _i + 1;
      _cisRad = 100 * _polDokl.cisRad + _i;

      select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;

      _idSkladu = _polDokl.idBspSkl;

      select * into _skladKarta from skarty
        where idSkladu = _idSkladu and idCenik = _polozkaSady.idCenik and idUcetObdobi = _idUcetObdobi;

      -- pokud neexistuje skladova karta pokusim se ji najit pomoci mapovani skladu
      if(_skladKarta is null) then
        select getPrefIdSkladu(_polDokl.idStred, _cenik.idSkupZboz, _cenik.idCenik) into _idSkladu;
        select * into _skladKarta from skarty
          where idSkladu = _idSkladu and idCenik = _cenik.idCenik and idUcetObdobi = _idUcetObdobi;
        if(_skladKarta is null) then
          -- pokud ani podle mapovani skladu se skladova karta nenajde tak vyhazuju vyjimku
          raise exception '0007:Skladová karta neexistuje pro ceník % a sklad % a nebo je špatně nastaveno mapovaní skladu.', _cenik.nazev, _sklad.nazev;
        end if;
      else
        _idSkladu = _skladKarta.idSkladu;
      end if;
      _nasobic = 1;
      if(_typDoklK like 'typDokladu.dobropis') then
        _nasobic = -1;
      end if;
      _mnozMj = _polozkaSady.mnozMj * _polDokl.mnozMj * _nasobic;
      _cenaMj = _skladKarta.prumCenaTuz / _kurz;
      _sumZkl = _mnozMj * _skladKarta.prumCenaTuz;
      if(_isCiziMena) then
        _sumZklMen = _mnozMj * _cenaMj;
      else
        _sumZklMen = 0.0;
      end if;

      -- nastaveni uctu pro polSklad vydej
      _kopZklMdUcet = false;
      _kopZklDalUcet = false;
      if(_typDoklK like 'typDokladu.dobropis') then
        -- dal ucet je ze skupiny zbozi nebo z hlavicky pokud neni ve skupine zbozi nastaven
        select idProtiUcetSklV into _idZklDalUcet from cSkupZboz where idSkupZboz = _cenik.idSkupZboz;
        if(_idZklDalUcet is null) then
          select idProtiUcet into _idZklDalUcet from dDoklSklad where idDoklSklad = _idDoklSklad;
          --pokud je z hlavicky tak se bude kopirovat
          _kopZklDalUcet = true;
        end if;
        -- md ucet musi byt primarni ucet skladu ze ktereho se kousky sady vydavaji
        select idPrimUcet into _idZklMdUcet from dBsp where idBsp = _idSkladu;
      else
        -- md ucet je ze skupiny zbozi nebo z hlavicky pokud neni ve skupine zbozi nastaven
        select idProtiUcetSklV into _idZklMdUcet from cSkupZboz where idSkupZboz = _cenik.idSkupZboz;
        if(_idZklMdUcet is null) then
          select idProtiUcet into _idZklMdUcet from dDoklSklad where idDoklSklad = _idDoklSklad;
          --pokud je z hlavicky tak se bude kopirovat
          _kopZklMdUcet = true;
        end if;
        -- dal ucet musi byt primarni ucet skladu ze ktereho se kousky sady vydavaji
        select idPrimUcet into _idZklDalUcet from dBsp where idBsp = _idSkladu;
      end if;

      select nextval('seq_dpolsklad') into _idPolSklad;
      insert into dpolsklad(idPolSklad, lastUpdate, idcenik, idBspSkl, idkarty, datVyst, datUcto, modul, typPolozkyK, idDoklSklad,
          mnozMj, cenaMj, cenaMjPoriz, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, idmj,
          nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni,
          idStred, idZakazky, idMeny, zdrojProFak)
        values (_idPolSklad, LOCALTIMESTAMP, _polozkaSady.idcenik, _idSkladu, _skladKarta.idKarty, _polDokl.datVyst, _polDokl.datVyst, 'SKL', 'typPolozky.katalog', _idDoklSklad,
          _mnozMj, _cenaMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, _kopZklMdUcet, _kopZklDalUcet, _polDokl.baleniid, 0.0, _cenik.idmj1,
          _cenik.nazev, _cenik.nazevA, _cenik.nazevB, _cenik.nazevC, null, null, _cisRad, true,
          _polDokl.idStred, _polDokl.idZakazky, _idMeny, false);

      insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)
        values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSklSada');
    end if;
  END LOOP;

  execute sprepoctiSumyDokladu(_idDoklSklad);
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createPolSkladSada(integer, character varying) OWNER TO %firmaRole%;


-- Function: fillpolsklad(integer, integer, character varying)
-- DROP FUNCTION fillpolsklad(integer, integer, character varying);
CREATE OR REPLACE FUNCTION fillpolsklad(_idpolsklad integer, _idpoldokl integer, _modul character varying)
  RETURNS integer AS
$BODY$
declare
  _polDokl record;
  _polSklad record;
  _idDoklad integer;
  _typPohybuK character varying;
  _typPohybuSklad character varying;
  _cenaMj numeric(19,6);
  _cenaMjPoriz numeric(19,6);
  _cenaMjTuz numeric(19,6);
  _mnozMj numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _idDoklSklad integer;
  _idUcetObdobi integer;
  _idKarty integer;
  _sklad record;
  _kurz numeric(19,6);
  _prumCenaTuz numeric(19,6);
  _isCiziMena boolean;
  _typDoklK character varying;
  _idZklMdUcet integer;
  _idZklDalUcet integer;
begin
  if(_modul like 'POK') then
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;
    select idDoklInt, typPohybuK into _idDoklad, _typPohybuK from dDoklInt where idDoklInt = _polDokl.idDoklInt;
    _typDoklK = null; -- pro pokladnu dobropisy nejsou
  else
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;
    select idDoklFak, typPohybuK into _idDoklad, _typPohybuK from dDoklFak where idDoklFak = _polDokl.idDoklFak;
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);
  end if;

  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad;

  if(_idDoklSklad is null) then
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;
  end if;

  select * into _polSklad from dPolSklad where idPolSklad = _idPolSklad;
  select typPohybuK into _typPohybuSklad from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad;

  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idskladu = _polDokl.idbspskl and iducetobdobi = _iducetobdobi;
  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl;

  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty;
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;

  if(_typPohybuSklad like 'typPohybu.vydej') then
    -- vsechny dobropisy generuji prijemky
    --if(_typDoklK like 'typDokladu.dobropis') then
    --  _mnozMj = -_polDokl.mnozMj;
    --else
      _mnozMj = _polDokl.mnozMj;
    --end if;
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena
    _cenaMj = _polSklad.cenaMj;
    _cenaMjPoriz = _polSklad.cenaMjPoriz;
    _sumZkl = _polSklad.sumZkl;
    _sumZklMen = _polSklad.sumZklMen;
    -- nastaveni uctu pro polSklad vydej
    select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet;
    _idZklDalUcet = _sklad.idPrimUcet;
  else
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny;
      _mnozMj = -_polDokl.mnozMj;
      _cenaMjTuz = _polDokl.cenaMjNakup;
      if(_cenaMjTuz = 0.0) then
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik);
        if(_cenaMj = 0.0) then
          _cenaMj = _polDokl.cenaMj * _kurz;
        end if;
      end if;
      _cenaMjPoriz = _cenaMjTuz / _kurz;
      _cenaMj = _polSklad.cenaMjNakl + _cenaMjPoriz;
      _sumZkl = _mnozMj * (_cenaMjTuz + (_polSklad.cenaMjNakl * _kurz));
      if(_isCiziMena) then
        _sumZklMen = _mnozMj * _cenaMj;
      else
        _sumZklMen = 0.0;
      end if;
    else
      -- pokud na sklad prijmam zkopiruji se ceny z faktury
      _mnozMj = _polDokl.mnozMj;
      _sumZkl = _polDokl.sumZkl;
      if(_mnozMj <> 0.0) then
        _cenaMjPoriz = _sumZkl / _mnozMj;
      else
        _cenaMjPoriz = _sumZkl;
      end if;
      _cenaMjPoriz = _cenaMjPoriz / _kurz;
      if(_isCiziMena) then
        if(_mnozMj <> 0.0) then
          _sumZklMen = (_cenaMjPoriz + _polSklad.cenaMjNakl) * _mnozMj;
        else
          _sumZklMen = (_cenaMjPoriz + _polSklad.cenaMjNakl);
        end if;
      else
        _sumZklMen = 0.0;
      end if;
      _sumZkl = _sumZkl + (_polSklad.cenaMjNakl * _kurz * _mnozMj);
      _cenaMj = _cenaMjPoriz + _polSklad.cenaMjNakl;
    end if;
    -- nastaveni uctu pro polSklad prijem
    _idZklMdUcet = _sklad.idPrimUcet;
    _idZklDalUcet = _polDokl.idZklMdUcet;
  end if;

  if(_polSklad.cenaMj <> _cenaMj
    or _polSklad.cenaMjPoriz <> _cenaMjPoriz
    or _polSklad.sumZkl <> _sumZkl
    or _polSklad.sumZklMen <> _sumZklMen
    or not compareVarchar(_polSklad.nazev, _polDokl.nazev)
    or not compareVarchar(_polSklad.nazevA, _polDokl.nazevA)
    or not compareVarchar(_polSklad.nazevB, _polDokl.nazevB)
    or not compareVarchar(_polSklad.nazevC, _polDokl.nazevC)
    or not compareDate(_polSklad.datVyst, _polDokl.datVyst)
    or not compareDate(_polSklad.datUcto, _polDokl.datVyst)
    or not compareId(_polSklad.baleniId, _polDokl.baleniId)
    or not compareNumeric(_polSklad.mnozBaleni, _polDokl.mnozBaleni)
    or not compareVarchar(_polSklad.sarze, _polDokl.sarze)
    or not compareDate(_polSklad.expirace, _polDokl.expirace)
    or not compareId(_polSklad.cisRad, _polDokl.cisRad)
    or not compareVarchar(_polSklad.eankod, _polDokl.eanKod)
    or not compareId(_polSklad.idmj, _polDokl.idmj)
    or not compareId(_polSklad.idStred, _polDokl.idStred)
    or not compareId(_polSklad.idZakazky, _polDokl.idZakazky)
    or not compareId(_polSklad.idZklMdUcet, _idZklMdUcet)
    or not compareId(_polSklad.idZklDalUcet, _idZklDalUcet) )
  then
    update dPolSklad set
      lastUpdate = LOCALTIMESTAMP,
      cenaMj = _cenaMj,
      cenaMjPoriz = _cenaMjPoriz,
      --mnozMj = _mnozMj,
      sumZkl = _sumZkl,
      sumZklMen = _sumZklMen,
      nazev = _polDokl.nazev,
      nazevA = _polDokl.nazevA,
      nazevB = _polDokl.nazevB,
      nazevC = _polDokl.nazevC,
      datVyst = _polDokl.datVyst,
      datUcto = _polDokl.datVyst,
      baleniId = _polDokl.baleniId,
      mnozBaleni = _polDokl.mnozBaleni,
      sarze = _polDokl.sarze,
      expirace = _polDokl.expirace,
      cisRad = _polDokl.cisRad,
      eankod = _polDokl.eanKod,
      idmj = _polDokl.idmj,
      idStred = _polDokl.idStred,
      idMeny = _polSklad.idMeny,
      idZakazky = _polDokl.idZakazky,
      --idZklMdUcet = _idZklMdUcet,
      --idZklDalUcet = _idZklDalUcet,
      ucetni = true
      where idPolSklad = _idPolSklad;
  end if;

  return _idPolSklad;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION fillpolsklad(integer, integer, character varying) OWNER TO %firmaRole%;


-- Function: fillpolskladsada(integer, character varying)
-- DROP FUNCTION fillpolskladsada(integer, character varying);
CREATE OR REPLACE FUNCTION fillpolskladsada(_idpoldokl integer, _modul character varying)
  RETURNS void AS
$BODY$
declare
  _polDokl record;
  _polSklad record;
  _idDoklad integer;
  _typPohybuK character varying;
  _typPohybuSklad character varying;
  _cenaMj numeric(19,6);
  _cenaMjTuz numeric(19,6);
  _mnozMj numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _idDoklSklad integer;
  _idUcetObdobi integer;
  _idKarty integer;
  _sklad record;
  _kurz numeric(19,6);
  _prumCenaTuz numeric(19,6);
  _isCiziMena boolean;
  _typDoklK character varying;
  _idZklMdUcet integer;
  _idZklDalUcet integer;
begin
  if(_modul like 'POK') then
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;
    select idDoklInt, typPohybuK into _idDoklad, _typPohybuK from dDoklInt where idDoklInt = _polDokl.idDoklInt;
    _typDoklK = null; -- pro pokladnu dobropisy nejsou
  else
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;
    select idDoklFak, typPohybuK into _idDoklad, _typPohybuK from dDoklFak where idDoklFak = _polDokl.idDoklFak;
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);
  end if;

  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad;
  if(_idDoklSklad is null) then
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;
  end if;

  for _polSklad in
    select * from dPolSklad where idPolSklad in (
      select idTabB from dvazebtab where
        typVazbyK like 'typVazbyDokl.polozkaSklSada'
        and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL'
    )
  loop
    select typPohybuK into _typPohybuSklad from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad;

    select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;
    select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idskladu = _polDokl.idbspskl and iducetobdobi = _iducetobdobi;
    select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl;

    select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;
    select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty;
    select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;

    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena
    _cenaMj = _polSklad.cenaMj;
    _mnozMj = _polSklad.mnozMj;
    _sumZkl = _polSklad.sumZkl;
    _sumZklMen = _polSklad.sumZklMen;
    -- nastaveni uctu pro polSklad vydej
    --TODO doresit zklMdUcet;
    --select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet;
    _idZklDalUcet = _sklad.idPrimUcet;

    update dPolSklad set
      lastUpdate = LOCALTIMESTAMP,
      cenaMj = _cenaMj,
      mnozMj = _mnozMj,
      sumZkl = _sumZkl,
      sumZklMen = _sumZklMen,
      --nazev = _polDokl.nazev,
      --nazevA = _polDokl.nazevA,
      --nazevB = _polDokl.nazevB,
      --nazevC = _polDokl.nazevC,
      datVyst = _polDokl.datVyst,
      datUcto = _polDokl.datVyst,
      baleniId = _polDokl.baleniId,
      mnozBaleni = _polDokl.mnozBaleni,
      --sarze = _polDokl.sarze,
      --expirace = _polDokl.expirace,
      --cisRad = _polDokl.cisRad,
      --eankod = _polDokl.eanKod,
      --idmj = _polDokl.idmj,
      idStred = _polDokl.idStred,
      idMeny = _polSklad.idMeny,
      idZakazky = _polDokl.idZakazky,
      --idZklMdUcet = _idZklMdUcet,
      --idZklDalUcet = _idZklDalUcet,
      ucetni = true
      where idPolSklad = _polSklad.idPolSklad;
  end loop;
  --return _idPolSklad;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION fillpolskladsada(integer, character varying) OWNER TO %firmaRole%;


-- Function: dgetstavnasklade(integer, integer, date, integer, integer, character varying, date)
-- DROP FUNCTION dgetstavnasklade(integer, integer, date, integer, integer, character varying, date);
CREATE OR REPLACE FUNCTION dgetstavnasklade(_idcenik integer, _idsklad integer, _datum date, i_polskladid integer, _idfirma integer, i_sarze character varying, i_expirace date)
  RETURNS numeric AS
$BODY$
declare
  _idUcetObd integer;
  _idKarty integer;
  _mnozMj numeric(19,6);
begin
  select idUcetObdobi into _idUcetObd from nUcetObdobi where platioddata <= _datum and platidodata >= _datum;

  select idkarty into _idKarty from skarty where iducetobdobi = _idUcetObd and idskladu = _idSklad and idcenik = _idCenik;

  select dgetstavnasklade(_idKarty, _datum, i_polskladid, _idFirma, i_sarze, i_expirace) into _mnozMj;

  return _mnozMj;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dgetstavnasklade(integer, integer, date, integer, integer, character varying, date) OWNER TO %firmaRole%;



-- Function: dgetstavnasklade(integer, date, integer, character varying, date)
-- DROP FUNCTION dgetstavnasklade(integer, date, integer, character varying, date);
CREATE OR REPLACE FUNCTION dgetstavnasklade(i_skladkartaid integer, i_datum date, i_polskladid integer, i_sarze character varying, i_expirace date)
  RETURNS numeric AS
$BODY$
declare
  _pocMj numeric(19,6);
  _obratMj numeric(19,6);
  _stavMj numeric(19,6);
  _idcenik integer;
  _idskladu integer;
  _typPohybuK character varying(50);
  _sadaItemCount integer;
  _polozkaSady record;
  _idSkladKarty integer;
  _iducetniobdobi integer;
  _idPolSklad integer;
  _stavSkladuSady numeric(19,6);
  _mnozMj numeric(19,6);
begin
  SELECT pocatMj INTO _pocMj
  FROM sKarty
  WHERE idKarty = i_skladkartaid;

  if (i_datum is null) then
    raise exception '0005:dGetStavNaSklade : Vstupni parametr datum je null.';
  end if;

  _typPohybuK := null;
  if (i_polskladid >= 0) then
    select typPohybuK into _typPohybuK from ddoklsklad
      where iddoklsklad = (select iddoklsklad from dpolsklad where idpolsklad = i_polskladid);
  end if;

  select idcenik, idskladu, iducetobdobi into _idcenik, _idskladu, _iducetniobdobi from skarty where idkarty = i_skladkartaid;

  -- zjistim jestli nahodu dany cenik neni sada nebo komplet
  select count(*) into _sadaItemCount from csady where idceniksada = _idCenik;
  -- pokud se nejedna o sadu tak funguju normalne
  if(_sadaItemCount = 0) then
    if ((i_sarze is null or i_sarze = '') and i_expirace is null) then
      if (i_polSkladId < 0) then
        SELECT sum(CASE ds.typPohybuK WHEN 'typPohybu.prijem' THEN ps.mnozMj ELSE -ps.mnozMj END) INTO _obratMj
        FROM dPolSklad ps LEFT OUTER JOIN dDoklSklad ds ON ps.idDoklSklad = ds.idDoklSklad
        WHERE idkarty = i_skladkartaid AND ps.storno <> true AND ps.datUcto <= i_datum;
      else
        SELECT sum(CASE ds.typPohybuK WHEN 'typPohybu.prijem' THEN ps.mnozMj ELSE -ps.mnozMj END) INTO _obratMj
        FROM dPolSklad ps LEFT OUTER JOIN dDoklSklad ds ON ps.idDoklSklad = ds.idDoklSklad
        WHERE idkarty = i_skladkartaid AND ps.storno <> true AND (ps.datUcto < i_datum OR (ps.datUcto = i_datum AND ps.idPolSklad < i_polskladid));
      end if;
      if(_obratMj is null) then _obratMj = 0.0; end if;
      if(_pocMj is null) then _pocMj = 0.0; end if;
      _stavMj = _pocMj + _obratMj;
    else
      if ((i_sarze is not null and i_sarze <> '') and (i_expirace is null)) then
        --raise exception 'idCenik = % and idSkladu = %', _idCenik, _idSkladu;

        select sum(pocet) into _stavMj from dpolskladf where idcenik = _idcenik and idskladu = _idskladu and sarze = i_sarze;
      elsif ((i_sarze is null or i_sarze = '') and (i_expirace is not null)) then
        select sum(pocet) into _stavMj from dpolskladf where idcenik = _idcenik and idskladu = _idskladu and expirace = i_expirace;
      else
        select sum(pocet) into _stavMj from dpolskladf where idcenik = _idcenik and idskladu = _idskladu and sarze = i_sarze and expirace = i_expirace;
      end if;
      if (_typPohybuK is not null and _typPohybuK = 'typPohybu.prijem') then
        select mnozMj into _obratMj from dpolsklad where idpolsklad = i_polskladid;
        if(_stavMj is null) then
          _stavMj := -_obratMj;
        else
          _stavMj := _stavMj - _obratMj;
        end if;
      elsif (_typPohybuK is not null and _typPohybuK = 'typPohybu.vydej') then
        select mnozMj into _obratMj from dpolsklad where idpolsklad = i_polskladid;
        if(_stavMj is null) then
          _stavMj := _obratMj;
        else
          _stavMj := _stavMj + _obratMj;
        end if;
      end if;
    end if;
  else
    for _polozkaSady in
      select * from cSady where idCenikSada = _idCenik
    loop
      select idKarty into _idSkladKarty from sKarty where idCenik = _polozkaSady.idCenik and idSkladu = _idskladu and idUcetObdobi = _iducetniobdobi;
      if(_idSkladKarty is not null) then
        if(_stavMj is null) then
          _stavMj = 9999999999999.0; -- vic uz pretejka
        end if;
        _idPolSklad = -1;
        --TODO nejak doresit _idPolSklad, sarze a expirace;
        select dgetstavnasklade(_idSkladKarty, i_datum, -1, i_sarze, i_expirace) into _stavSkladuSady;
        _stavSkladuSady = _stavSkladuSady / _polozkaSady.mnozMj;
	if(i_polskladid > 0) then
	  select mnozMj into _mnozMj from dPolSklad where idPolSklad = i_polSkladId;
          _stavSkladuSady = _stavSkladuSady + (_mnozMj/_polozkaSady.mnozMj);
        end if;
        select minValue(_stavMj, _stavSkladuSady) into _stavMj;
      end if;
    end loop;
  end if;

  -- muze se stat ze _stavMj je null a to znamena ze na sklade nic neni
  if(_stavMj is null) then
    _stavMj := 0;
  end if;

  RETURN _stavMj;
end
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dgetstavnasklade(integer, date, integer, character varying, date) OWNER TO %firmaRole%;


-- Function: sfifovydej(integer, integer, integer, integer, numeric)
-- DROP FUNCTION sfifovydej(integer, integer, integer, integer, numeric);
CREATE OR REPLACE FUNCTION sfifovydej(idvydej integer, idcenikvydej integer, idskladvydej integer, idkartyvydej integer, vyd numeric)
  RETURNS void AS
$BODY$
declare
  _zaznam Record;
  _vybrano numeric(19,6);
  _i integer;
  _novevydcelkem numeric(19,6);
  _pocet numeric(19,6);
  _cenamjP numeric(19,6);
  _cenaMjPMen numeric(19,6);
  _kurzDokladuP numeric(19,6);
  _kurzDokladuV numeric(19,6);
  _idDoklSkladP integer;
  _idDoklSkladV integer;
  _datVystV date;
  _idrozlozeni integer;
  _vydexpir boolean;
  _vyrcis character varying(255);
  _sklfifo boolean;
  _sarze character varying(255);
  _expirace date;
  _evidVyrCis boolean;
begin
  _vybrano := 0;
  _i := 1;
  _novevydcelkem := vyd;
  select evidVyrCis into _evidVyrCis from ccenik where idcenik = idcenikvydej;
  if (not _evidVyrCis) then
    if (idvydej>0) then
      select vydexpir into _vydexpir from skarty where idkarty=idkartyvydej limit 1;
      select sarze, expirace into _sarze, _expirace from dpolsklad where idpolsklad = idvydej;
      if (not _vydexpir) then
        --pořadí výdeje dle datvyst (dále se bude řesit upřednostněný výdej mimo FIFO)
        for _zaznam in select * from dPolSkladF where idCenik=idCenikVydej and idSkladu=idSkladVydej order by datVyst,idpolsklad loop
          if(not _zaznam is null) then
            if((_sarze is null or _sarze = _zaznam.sarze) and (_expirace is null or _expirace = _zaznam.expirace)) then
              if (_vybrano<_novevydcelkem) then
                _pocet := _zaznam.pocet;
                if( _vybrano+_pocet) > _novevydcelkem then
                  _pocet := _novevydcelkem-_vybrano;
                end if;
                _vybrano := _vybrano+_pocet;
                --pokud je výrobní číslo, tak jeho kód zaznamenám na výdejku (otázka je, zda tam nedat rovnou idvyrobnicislo
                _vyrcis := '';
                if (_zaznam.idvyrobnicislo>0) then
                  select kod into _vyrcis from svyrobnicislo where idvyrobnicislo = _zaznam.idvyrobnicislo;
                end if;
                --
                if (_i = 1) then
                  insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo) ;
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));
                  if (_sklfifo) then
                    select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);
                    if (_kurzDokladuP <> 0.0) then
                      _cenamjP := _cenamjP * _kurzDokladuP;
	                end if;
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));
                    _cenamjP := _cenamjP / _kurzDokladuV;
                    _cenaMjPMen := 0.0;
                    if(_kurzDokladuV <> 1.0) then
                      _cenaMjPMen := _cenaMjP;
                    end if;
                    update dpolsklad set mnozmj = _pocet,cenamj = _cenamjP, sumzkl = _pocet*_cenamjP*_kurzDokladuV, sumZklMen = _pocet*_cenaMjPMen, sarze = _zaznam.sarze, expirace = _zaznam.expirace
                          where idpolsklad = idvydej;
                  else
                    update dpolsklad set sarze = _zaznam.sarze, expirace = _zaznam.expirace where idpolsklad = idvydej;
                  end if;
                else
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));
                  if (_sklfifo) then
                    select nextval('seq_dpolsklad') into _idrozlozeni;
                    select cenamj, idDoklSklad into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);
                    if (_kurzDokladuP <> 0.0) then
                      _cenamjP := _cenamjP * _kurzDokladuP;
                    end if;
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));
                    _cenamjP := _cenamjP / _kurzDokladuV;
                    _cenaMjPMen := 0.0;
                    if(_kurzDokladuV <> 1.0) then
                      _cenaMjPMen := _cenaMjP;
                    end if;
                    insert into dpolsklad(idpolsklad,mnozmj,autozaokr,autogen,baleniid,cenjednotka,cenamj,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,sumzkl,sumzklmen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy)
                         (select (-1*_idrozlozeni),_pocet,autozaokr,autogen,baleniid,cenjednotka,_cenamjP,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,_zaznam.expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,_zaznam.sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,_pocet*_cenamjP*_kurzDokladuV,_pocet*_cenaMjPMen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy from dpolsklad where idpolsklad=idVydej);
                    --
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,_idrozlozeni,_pocet,_zaznam.idvyrobnicislo);
                    insert into svazbypolsklad(idpolskladzdroj,idpolskladcil) values (idvydej, _idrozlozeni);
                  else
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,idvydej,_pocet,_zaznam.idvyrobnicislo);
                  end if;
                end if;
                --
                _i:=_i+1;
              end if;
            end if;
          end if;
        end loop;
      else
        --pořadí výdeje dle expirace (dále se bude řesit upřednostněný výdej mimo FIFO)
        for _zaznam in select * from dPolSkladF where idCenik=idCenikVydej and idSkladu=idSkladVydej order by expirace, idpolsklad loop
          if(not _zaznam is null) then
            if((_sarze is null or _sarze = _zaznam.sarze) and (_expirace is null or _expirace = _zaznam.expirace)) then
              if (_vybrano<_novevydcelkem) then
                _pocet := _zaznam.pocet;
                if( _vybrano+_pocet) > _novevydcelkem then
                  _pocet := _novevydcelkem-_vybrano;
                end if;
                _vybrano := _vybrano+_pocet;
                --pokud je výrobní číslo, tak jeho kód zaznamenám na výdejku (otázka je, zda tam nedat rovnou idvyrobnicislo
                _vyrcis := '';
                if (_zaznam.idvyrobnicislo>0) then
                    select kod into _vyrcis from svyrobnicislo where idvyrobnicislo = _zaznam.idvyrobnicislo;
                end if;
                --
                if (_i = 1) then
                  insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo) ;
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));
                  if (_sklfifo) then
                    select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);
                    if (_kurzDokladuP <> 0.0) then
                      _cenamjP := _cenamjP * _kurzDokladuP;
                    end if;
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));
                    _cenamjP := _cenamjP / _kurzDokladuV;
                    _cenaMjPMen := 0.0;
                    if(_kurzDokladuV <> 1.0) then
                      _cenaMjPMen := _cenaMjP;
                    end if;
                    update dpolsklad set mnozmj = _pocet,cenamj = _cenamjP, sumzkl = _pocet*_cenamjP*_kurzDokladuV, sumZklMen = _pocet*_cenaMjPMen, sarze = _zaznam.sarze, expirace = _zaznam.expirace
                          where idpolsklad = idvydej;
                  else
                    update dpolsklad set sarze = _zaznam.sarze, expirace = _zaznam.expirace where idpolsklad = idvydej;
                  end if;
                else
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));
                  if (_sklfifo) then
                    select nextval('seq_dpolsklad') into _idrozlozeni;
                    select cenamj, idDoklSklad into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);
                    if (_kurzDokladuP <> 0.0) then
                      _cenamjP := _cenamjP * _kurzDokladuP;
                    end if;
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));
                    _cenamjP := _cenamjP / _kurzDokladuV;
                    _cenaMjPMen := 0.0;
                    if(_kurzDokladuV <> 1.0) then
                      _cenaMjPMen := _cenaMjP;
                    end if;
                    insert into dpolsklad(idpolsklad,mnozmj,autozaokr,autogen,baleniid,cenjednotka,cenamj,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,sumzkl,sumzklmen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy)
	                             (select (-1*_idrozlozeni),_pocet,autozaokr,autogen,baleniid,cenjednotka,_cenamjP,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,_zaznam.expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,_zaznam.sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,_pocet*_cenamjP,_pocet*_cenaMjPMen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy from dpolsklad where idpolsklad=idVydej);
                    --
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,_idrozlozeni,_pocet,_zaznam.idvyrobnicislo);
                    insert into svazbypolsklad(idpolskladzdroj,idpolskladcil) values (idvydej, _idrozlozeni);
                  else
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,idvydej,_pocet,_zaznam.idvyrobnicislo);
                  end if;
                end if;
                --
                _i:=_i+1;
              end if;
            end if;
          end if;
        end loop;
      end if;
    else
      --nepoustím fifo do rekurze, příznak záporného id udělám opět kladný
      update dpolsklad set idPolSklad = -1*idVydej where idpolsklad=idVydej;
    end if;
  end if;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION sfifovydej(integer, integer, integer, integer, numeric) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION svyrobnicisloupdate()
  RETURNS trigger AS
$BODY$
declare
  _sklFifo boolean;
  _mnozMj numeric(19,6);
  _datVyst date;
  _idRozlozeni integer;
  _cenaMjP numeric(19,6);
  _kurzDokladuP numeric(19,6);
  _kurzDokladuV numeric(19,6);
  _idDoklSkladP integer;
  _idDoklSkladV integer;
  _datVystV date;
  _cenaMjPMen numeric(19,6);
  _mnozVyrobnichCisel numeric(19,6);
  _mnozMjPoZmene numeric(19,6);
begin
  if(NEW.idPolSkladVydej is not null and OLD.idPolSkladVydej is null) then
    select datVyst, mnozMj into _datVyst, _mnozMj from dPolSklad where idPolSklad = NEW.idPolSkladVydej;
    _mnozVyrobnichCisel = 1;
    _mnozMjPoZmene = _mnozMj;
    if(_mnozMj < 0.0) then
      _mnozMjPoZmene = 0.0 - _mnozMj;
      _mnozVyrobnichCisel = -1;
    end if;

    _sklfifo := (select isfifosklad(_datVyst));
    if(_sklFifo) then

      select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = NEW.idPolSkladPrijem);
      select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);
      if (_kurzDokladuP <> 0.0) then
	_cenamjP := _cenamjP * _kurzDokladuP;
      end if;
      select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = NEW.idPolSkladVydej;
      _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));
      _cenamjP := _cenamjP / _kurzDokladuV;
      _cenaMjPMen := 0.0;
	  if(_kurzDokladuV <> 1.0) then
        _cenaMjPMen := _cenaMjP;
      end if;
      if(_mnozMjPoZmene > 1) then
        -- odecteni 1 z mnoz mj a vytvoreni nove polozky a mnozstvim 1 a 1 vyrobnim cislem
        select nextval('seq_dpolsklad') into _idrozlozeni;
	update dpolsklad set mnozMJ = _mnozMj - _mnozVyrobnichCisel where idPolSklad = NEW.idPolSkladVydej;

        insert into dpolsklad(idpolsklad,           mnozmj,             autozaokr,autogen,baleniid,cenjednotka,cenamj,  cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,sumzkl,                                       sumzklmen,                       szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy)
                             (select (_idrozlozeni),_mnozVyrobnichCisel,autozaokr,autogen,baleniid,cenjednotka,_cenamjP,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,_cenamjP*_kurzDokladuV * _mnozVyrobnichCisel,_cenaMjPMen * _mnozVyrobnichCisel,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy from dpolsklad where idpolsklad = NEW.idpolskladvydej);
	insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values (NEW.idPolSkladPrijem,_idrozlozeni,1,NEW.idvyrobnicislo);
	insert into svazbypolsklad(idpolskladzdroj,idpolskladcil) values (NEW.idPolSkladVydej, _idrozlozeni);
	NEW.idPolSkladVydej = _idRozlozeni;
      else
        -- nastaveni vyrobniho cisla na a vytvoreni vazby
        --update sfifovazby set idvyrobnicislo = NEW.idvyrobnicislo, kusu = 1, idpolskladprijem = NEW.idpolskladprijem where idpolskladvydej = NEW.idpolskladvydej and idvyrobnicislo = -1;
        insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values (NEW.idPolSkladPrijem,NEW.idPolSkladVydej,1,NEW.idvyrobnicislo);
        --select cenaMj into _cenaMjP from dpolsklad where idPolSklad = NEW.idPolSkladPrijem;
        update dpolsklad set cenaMJ = _cenaMjP, sumZkl = _cenamjP*_kurzDokladuV*_mnozVyrobnichCisel, sumZklMen = _cenaMjPMen*_mnozVyrobnichCisel where idPolSklad = NEW.idPolSkladVydej;
      end if;
      --
    else
      insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values (NEW.idPolSkladPrijem,NEW.idPolSkladVydej,1,NEW.idvyrobnicislo);
    end if;
  elsif (NEW.idPolSkladVydej is null and OLD.idPolSkladVydej is not null) then
    -- pokud se idPolSkladVydej nastavi na null z nejake hodnoty musi se smazat i fifo vazba s timto vyrobnim cislem
    delete from sfifovazby where idvyrobnicislo = NEW.idVyrobniCislo;
  end if;
  execute sprepoctisumydokladu(_idDoklSkladV);
  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION svyrobnicisloupdate() OWNER TO %firmaRole%;

-- Function: dpolskladinsert()
-- DROP FUNCTION dpolskladinsert();
CREATE OR REPLACE FUNCTION dpolskladinsert()
  RETURNS trigger AS
$BODY$
declare
  _rozsirenaPolozka record;
  _typPohybuk character varying;
  _mazatTmpTable boolean;
  _idPolSklad integer;
  _probihaPrepocetSkladu character varying;
begin
  select getglotxvariable('probihaPrepocetSkladu') into _probihaPrepocetSkladu;
  if(_probihaPrepocetSkladu = 'true') then
  else
    -- v pripade ze neprobiha prepocet skladu
    -- generuji rozsirene polozky
    select skladGenerujRozsirenePolozky(NEW.datVyst, NEW.idPolSklad, NEW.idKarty) into _mazatTmpTable;

    execute putglotxvariable('zurnalTxName', 'prepocetSkladu');

    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
      if(_rozsirenaPolozka.idPolSklad <> NEW.idPolSklad) then
        execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
      end if;
    end loop;

    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
      execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
    end loop;

    if(_mazatTmpTable) then
      drop table tmp_RozsirenePolozky;
      drop table tmp_SkladoveKarty;
      execute removeglotxvariable('zurnalTxName');
    end if;
  end if;

  select typpohybuk into _typPohybuk from ddoklsklad where iddoklsklad = NEW.iddoklsklad;
  --pokud výdej, tak fifuju vazby
  if (_typPohybuk = 'typPohybu.vydej') then
    execute sFifoVydej(NEW.idPolSklad, NEW.idCenik, NEW.idBspSkl, NEW.idKarty, NEW.mnozmj);
    execute sPrepoctiSumyDokladu(NEW.idDoklSklad);
  end if;

  if(_probihaPrepocetSkladu = 'true') then
    if(NEW.idPolSklad < 0) then
      _idPolSklad = -NEW.idPolSklad;
    else
      _idPolSklad = NEW.idPolSklad;
    end if;

    execute skladinsertrozsirenoupolozku(_idPolSklad);
  end if;

  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladinsert() OWNER TO %firmaRole%;


--------------------------------------------------------------------------------
-- Rezervace
--------------------------------------------------------------------------------
-- Function: srezervaceupdateskladkarta()
-- DROP FUNCTION srezervaceupdateskladkarta();
CREATE OR REPLACE FUNCTION srezervaceupdateskladkarta()
  RETURNS trigger AS
$BODY$
declare
  ZAZNAM record;
begin
  if (tg_op = 'DELETE' or tg_op = 'UPDATE') then
    ZAZNAM := OLD;

    update skarty set rezervmj = (select coalesce(sum(mnozstvi), 0) from srezervace where idcenik = OLD.idcenik and idsklad = OLD.idsklad)
      where idcenik = OLD.idcenik and idskladu = OLD.idsklad;
  end if;

  if (tg_op = 'INSERT' or tg_op = 'UPDATE') then
    ZAZNAM := NEW;

    update skarty set rezervmj = (select coalesce(sum(mnozstvi), 0) from srezervace where idcenik = NEW.idcenik and idsklad = NEW.idsklad)
      where idcenik = NEW.idcenik and idskladu = NEW.idsklad;
  end if;

  return ZAZNAM;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION srezervaceupdateskladkarta() OWNER TO %firmaRole%;


-- Function: srezervujzprijemky(integer, integer, numeric)
-- DROP FUNCTION srezervujzprijemky(integer, integer, numeric);
CREATE OR REPLACE FUNCTION srezervujzprijemky(_idcenik integer, _idskladu integer, prijato numeric)
  RETURNS void AS
$BODY$
declare
  _zbyva numeric(19,6);
  _uber numeric(19,6);
  _rezer record;
  _idUcetObd integer;
  _sklad numeric(19,6);
begin
  _zbyva = prijato;
  if (prijato > 0) then
    for _rezer in select * from sRezervace where idCenik = _idCenik and idSklad = _idSkladu order by datumod ASC loop
      if (_rezer.mnozstvi > _rezer.skladmj) then
        _uber = minvalue(_zbyva, _rezer.mnozstvi - _rezer.skladmj);
        _zbyva = _zbyva - _uber;

        update sRezervace set skladmj = skladmj + _uber where idrezervace = _rezer.idrezervace;

        if (_zbyva = 0) then
          return;
        end if;
      end if;
    end loop;
  else
    select idUcetObdobi into _idUcetObd from nUcetObdobi where platioddata <= date(now()) and platidodata >= date(now());
    select stavmj into _sklad from skarty where iducetobdobi = _idUcetObd and idskladu = _idSkladu and idcenik = _idCenik;
    select sum(skladmj) into _zbyva from srezervace where idCenik = _idCenik and idSklad = _idSkladu;

    if (_zbyva > _sklad) then
      _zbyva = _zbyva - _sklad;

      for _rezer in select * from sRezervace where idCenik = _idCenik and idSklad = _idSkladu order by datumod DESC loop
        if (_rezer.skladmj > 0) then
          _uber = minvalue(_zbyva, _rezer.skladmj);
          _zbyva = _zbyva - _uber;

          update sRezervace set skladmj = skladmj - _uber where idrezervace = _rezer.idrezervace;

          if (_zbyva = 0) then
            return;
          end if;
        end if;
      end loop;
    end if;
  end if;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION srezervujzprijemky(integer, integer, numeric) OWNER TO %firmaRole%;



-- Function: dpolskladupdaterezer()
-- DROP FUNCTION dpolskladupdaterezer();
CREATE OR REPLACE FUNCTION dpolskladupdaterezer()
  RETURNS trigger AS
$BODY$
declare
  zmena numeric(19,6);
  _idFirmy integer;
  _typPohybuK varchar(50);
begin
  zmena = 0;
  if (tg_op = 'UPDATE') then
    if (OLD.mnozMj = NEW.mnozMj and compareid(OLD.idCenik, NEW.idCenik) and compareid(OLD.idBspSkl, NEW.idBspSkl)) then
      return NEW;         -- pokud nedoslo ke zmene ktera se nas netyka, ukoncime aby jsme nezpomalovali sklad
    end if;

    zmena = OLD.mnozMj;
  end if;

  zmena = NEW.mnozMj - zmena;
  select idfirmy, typPohybuK into _idFirmy, _typPohybuK from ddoklsklad where idDoklSklad = NEW.idDoklSklad;

  if (zmena > 0 and _typPohybuK = 'typPohybu.vydej') then
    perform odrezervuj(_idFirmy, NEW.idCenik, NEW.idBspSkl, zmena);
  end if;
  if (zmena <> 0 and _typPohybuK = 'typPohybu.prijem') then
    perform srezervujzprijemky(NEW.idCenik, NEW.idBspSkl, zmena);
  end if;

  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladupdaterezer() OWNER TO %firmaRole%;



-- Function: dgetstavnasklade(integer, date, integer, integer, character varying, date)
-- DROP FUNCTION dgetstavnasklade(integer, date, integer, integer, character varying, date);
CREATE OR REPLACE FUNCTION dgetstavnasklade(i_skladkartaid integer, i_datum date, i_polskladid integer, i_firmaid integer, i_sarze character varying, i_expirace date)
  RETURNS numeric AS
$BODY$
declare
  _sklad integer;
  _cenik integer;
  _stavMj numeric(19,6);
  _firmaRezerMj numeric(19,6);
  _celkemRezerMj numeric(19,6);
begin
  SELECT dgetstavnasklade(i_skladkartaid, i_datum, i_polskladid, i_sarze, i_expirace) INTO _stavMj;

  -- vymazeme jiz neplatne rezervace
  delete from srezervace where datumdo is not null and datumdo < date(now());
  -- nacteme si info ze skladove karty
  SELECT idCenik, idSkladu INTO _cenik, _sklad FROM sKarty WHERE idKarty = i_skladkartaid;
  -- zjistime kolik je celkem rezervovano
  select coalesce(sum(skladmj), 0) into _celkemRezerMj from srezervace where idcenik = _cenik and idsklad = _sklad;

  IF (i_firmaid > 0) THEN
    -- zjistime kolik ma firma rezervovano
    select coalesce(sum(skladmj), 0) into _firmaRezerMj from srezervace where idfirmy = i_firmaid and idcenik = _cenik and idsklad = _sklad;
  ELSE
    _firmaRezerMj := 0;
  END IF;

  -- spocteme kolik mu muzeme dat
  _stavMj := minValue(_stavMj, maxValue(_stavMj - _celkemRezerMj, 0) + _firmaRezerMj);

  RETURN _stavMj;
end
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dgetstavnasklade(integer, date, integer, integer, character varying, date) OWNER TO %firmaRole%;



-- Function: dpolskladdeleterezer()
-- DROP FUNCTION dpolskladdeleterezer();
CREATE OR REPLACE FUNCTION dpolskladdeleterezer()
  RETURNS trigger AS
$BODY$
begin
  if (OLD.mnozMj > 0) then
    perform srezervujzprijemky(OLD.idCenik, OLD.idBspSkl, -OLD.mnozMj);
  end if;

  return OLD;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladdeleterezer() OWNER TO %firmaRole%;



-- Function: dpolobchupdaterezer()
-- DROP FUNCTION dpolobchupdaterezer();
CREATE OR REPLACE FUNCTION dpolobchupdaterezer()
  RETURNS trigger AS
$BODY$
begin
  if NEW.idBspSkl is not null and NEW.rezervovat then
    perform rezervujPolObch(NEW.idCenik, NEW.idBspSkl, NEW.idPolObch, NEW.rezervovatMj);
  end if;

  if (tg_op = 'UPDATE') then
    if OLD.idBspSkl is not null and OLD.rezervovat then
      perform rezervujPolObch(OLD.idCenik, OLD.idBspSkl, OLD.idPolObch, -OLD.rezervovatMj);
    end if;
  end if;

  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolobchupdaterezer() OWNER TO %firmaRole%;


create or replace function skladPrepoctiRozsirenouPolozku(i_idrozsirenepolozky integer, sign integer) returns void as
$BODY$
declare
  _skladKarta record;
  _rozsirenaPolozka record;
  _polSklad record;
  _navazanaPolSklad record;
  _stavMj numeric(19,6);
  _stavTuz numeric(19,6);
  _stavMen numeric(19,6);
  _prumCenaTuz numeric(19,6);
  _prumCenaMen numeric(19,6);
  _pocetNavazanych integer;
  _cenaMj numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _kurzDokladu numeric(19,6);
  _kurzSkladKarty numeric(19,6);
  _isCiziMena boolean;
  _sklfifo boolean;
  _datPosl date;
  _PoslCenaTuz numeric(19,6);
  _PoslCenaMen numeric(19,6);
  _cenaMjSkl numeric(19,6);
begin
  select * into _rozsirenaPolozka from tmp_RozsirenePolozky where idpolsklad = i_idrozsirenepolozky;
  select * into _polSklad from dPolSklad where idPolSklad = i_idrozsirenepolozky;
  if(_polSklad is null) then
    -- muze se stat ze v rozsirenych polozkach je uz polozka ktera byla v ramci transakce smazana
    return;
  end if;

  select * into _skladKarta from sKarty where idKarty = _rozsirenaPolozka.idskladkarty;
  select getKurzFromDoklad(_rozsirenaPolozka.idDoklSkladPolozky, _rozsirenaPolozka.datum) into _kurzDokladu;

  if(sign = 1) then
    if(_rozsirenaPolozka.skupina = 1) then
      if(_polSklad.mnozMj = 0.0) then
        _stavTuz = _polSklad.cenaMj * _kurzDokladu;
      else
        select sumZkl into _stavTuz from dpolsklad where idPolSklad = _rozsirenaPolozka.idPolSklad;
      end if;
    else
      -- pokud se jedna o prijemku z prevodky nebo vyroby tak se musi cena nastavit podle navazane vydejky
      _cenaMjSkl = 0.0;
      if(_rozsirenaPolozka.skupina = 2 and _rozsirenaPolozka.typPohybuK = 'typPohybu.prijem') then
        select * into _navazanaPolSklad from dPolSklad
            where idPolSklad = (select idTabA from dvazebtab where idTabB = _rozsirenaPolozka.idPolSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklPrevod');
        if(_navazanaPolSklad is null) then
          _cenaMj = _polSklad.cenaMjNeskl;
          _sumZkl = _polSklad.cenaMjNeskl * _polSklad.mnozMj;
          for _navazanaPolSklad in (select * from dPolSklad where idPolSklad in
            (select idTabB from dvazebtab where idTabA = _rozsirenaPolozka.idPolSklad and modulA = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus') )
            loop
	    if(_navazanaPolSklad.mnozMj <> 0.0) then
              _cenaMj = _cenaMj + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
              _cenaMjSkl = _cenaMjSkl + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
            else
              raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit
            end if;
            _sumZkl = _sumZkl + _navazanaPolSklad.sumZkl;
          end loop;
        else
          if(_navazanaPolSklad.mnozMj <> 0.0) then
            _cenaMj = (_navazanaPolSklad.sumZkl / _navazanaPolSklad.mnozMj) / _kurzDokladu;
          else
            raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit
          end if;
          _sumZkl = _navazanaPolSklad.sumZkl;
        end if;
        _sumZklMen = 0.0;
        select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _rozsirenaPolozka.datum) into _isCiziMena;
        if(_isCiziMena) then
          _sumZklMen = _polSklad.mnozMj * _cenaMj;
        end if;
      else
        _cenaMj = _skladKarta.prumCenaTuz;
        if(_kurzDokladu is not null and _kurzDokladu <> 0.0) then
          _cenaMj = _cenaMj / _kurzDokladu;
        end if;
        _sumZkl = _polSklad.mnozMj * _skladKarta.prumCenaTuz;
        _sumZklMen = 0.0;
        select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _rozsirenaPolozka.datum) into _isCiziMena;
        if(_isCiziMena) then
          _sumZklMen = _polSklad.mnozMj * _cenaMj;
        end if;
      end if;

      _sklfifo := (select isfifosklad(_rozsirenaPolozka.datum));
      if (not _sklfifo) then
        update dPolSklad set
          cenaMj = _cenaMj,
          cenaMjSkl = _cenaMjSkl,
          sumZkl = _sumZkl,
          sumZklMen = _sumZklMen
          where idPolSklad = _rozsirenaPolozka.idPolSklad;
      end if;

      execute sprepoctisumydokladu(_rozsirenaPolozka.idDoklSkladPolozky);

      select sumZkl into _stavTuz from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
    end if;
  else
    if(_polSklad.mnozMj = 0.0) then
      _stavTuz = _polSklad.cenaMj * _kurzDokladu;
    else
      select sumZkl into _stavTuz from dpolsklad where idPolSklad = i_idrozsirenepolozky;
    end if;
  end if;

  if(_rozsirenaPolozka.typpohybuk = 'typPohybu.vydej') then
    _stavMj = _skladKarta.stavMj - (sign*_polSklad.mnozMj);
    _stavTuz = _skladKarta.stavTuz - (sign*_stavTuz);
  else
    _stavMj = _skladKarta.stavMj + (sign*_polSklad.mnozMj);
    _stavTuz = _skladKarta.stavTuz + (sign*_stavTuz);
  end if;

  if(_stavMj is null) then
    raise exception 'stav mj je null a idpolsklad je % a _skladkarta je % a _polSklad je %',i_idrozsirenepolozky, _skladkarta, _polSklad;
  end if;

  _prumCenaTuz = 0.0;
  if(_stavMj <> 0.0) then
    _prumCenaTuz = _stavTuz / _stavMj;
  end if;
  if(_prumCenaTuz is null) then
    raise exception 'prumCenaTuz je null, _stavTuz je %, _stavMj je %', _stavTuz, _stavMj;
  end if;

  _datPosl = _skladKarta.datPosl;
  if(_datPosl is null or _datPosl < _polSklad.datVyst) then
    _datPosl = _polSklad.datVyst;
  end if;

  _poslCenaTuz = _skladKarta.poslCenaTuz;
  _poslCenaMen = _skladKarta.poslCenaMen;
  if(_rozsirenaPolozka.typpohybuk = 'typPohybu.prijem') then
    _PoslCenaTuz := _polSklad.cenaMj * _KurzDokladu;
    _PoslCenaMen := _polSklad.cenaMj;
  end if;

  _KurzSkladKarty := (select getKurzFromSklad(_skladKarta.idSkladu, _rozsirenaPolozka.datum));
  if (not _rozsirenaPolozka.storno) then
    update skarty set
      stavmj = _stavMj,
      stavTuz = _stavTuz,
      stavMen = round(_stavTuz / _kurzSkladKarty, 2),
      prumCenaTuz = _prumCenaTuz,
      prumCenaMen = _prumCenaTuz / _kurzSkladKarty,
      datPosl = _datPosl,
      poslCenaTuz = _poslCenaTuz,
      poslCenaMen = _poslCenaMen
      where idkarty = _rozsirenaPolozka.idSkladKarty;
  end if;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladPrepoctiRozsirenouPolozku(integer, integer) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION getkurzfromsklad(i_skladid integer, i_datvyst date) RETURNS numeric
    AS $$
declare
  idMenyTuzemsko integer;
  idMenySklad integer;
  _kurzMnozstvi integer;
  _nbStred numeric(10,6);
  _result numeric(19,6);

begin
  select idMeny into idMenyTuzemsko from nNastav where i_DatVyst >= PlatiOdData order by PlatiOdData desc limit 1;
  if (idMenyTuzemsko is null) then
    select idMeny into idMenyTuzemsko from nNastav where PlatiOdData is null limit 1;
  end if;
  select idMeny into idMenySklad from dBsp where idBsp = i_skladId;

  if(idMenySklad is null or idMenySklad = idMenyTuzemsko) then
    return 1;
  end if;

  select nbStred, kurzMnozstvi into _nbStred, _kurzMnozstvi from uKurzy
  where idMeny = idMenySklad and i_DatVyst >= PlatiOdData and typkurzuk = 'typKurzu.obecny'
  order by PlatiOdData desc limit 1;
  if(_nbStred is null) then
    select nbStred, kurzMnozstvi into _nbStred, _kurzMnozstvi from uKurzy
    where idMeny = idMenySklad and PlatiOdData is null and typkurzuk = 'typKurzu.obecny'
    limit 1;
  end if;
  if(_nbStred is null) then
    raise exception '0001:getKurzFromSklad : neexistuje kurz!';
    /*_nbStred := 0;
    _kurzMnozstvi := 0;*/
  end if;

  if _kurzMnozstvi = 0 then
    _result := 0;
  else
    _result := _nbStred / _kurzMnozstvi;
  end if;

  return _result;
end;
$$
    LANGUAGE plpgsql;
ALTER FUNCTION public.getkurzfromsklad(i_skladid integer, i_datvyst date) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION obchodrealizovatelnost(iddokl integer) RETURNS numeric
    AS $$
declare
  zbyvaNakl numeric(15,2);
  moznoSklad numeric(15,2);
  moznoNesklad numeric(15,2);
  vysledek numeric(6,2);
  _idUcetniObdobi integer;
  _idadresar integer;
begin
  select idUcetObdobi into _idUcetniObdobi from nUcetObdobi where (DATE(NOW()) >= PlatiOdData and DATE(NOW()) <= PlatiDoData) limit 1;

  select coalesce(sum((mnozMj-mnozMjReal) * cenaMj), 0) into zbyvaNakl from dPolObch where idDoklObch = idDokl;

  select idfirmy into _idadresar from ddoklobch where iddoklobch = iddokl;

  select coalesce(sum(
    minValue(
        maxValue(dgetstavnasklade((select idKarty from sKarty where idCenik = P.idCenik AND idSkladu = P.idBspSkl AND idUcetObdobi = _idUcetniObdobi), DATE(NOW()), -1, _idadresar, null, null), 0),
        (mnozMj-mnozMjReal))
    * cenaMj), 0) into moznoSklad
    from dPolObch as P where idDoklObch = idDokl and typPolozkyK = 'typPolozky.katalog';

  select coalesce(sum((mnozMj-mnozMjReal) * cenaMj), 0) into moznoNesklad from dPolObch where idDoklObch = idDokl and typPolozkyK <> 'typPolozky.katalog';

  if (zbyvaNakl = 0) then
    vysledek := 100 ;
  else
    vysledek := ((moznoSklad + moznoNesklad) / zbyvaNakl) * 100;
  end if;

  return vysledek;
end;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.obchodrealizovatelnost(iddokl integer) OWNER TO %firmaRole%;

create or replace function ddokladupdatesklad() returns trigger as
$BODY$
declare
  _polFak record;
  _idPolSklad integer;
  _idDoklSklad integer;
  _idDoklad integer;
  _doklSklad record;
  _pocetPolozek integer;
  _typZasobyK character varying;
  _skladove boolean;
  _sadaItemCount integer;
begin
  if(OLD.generovatSkl <> NEW.generovatSkl) then
    if(NEW.generovatSkl = false and NEW.zdrojProSkl = true) then
      -- pokud se nema podle noveho nastaveni z typu dokladu generovat skladove doklady
      -- a tento doklad je zdrojovy pro generovani skladovych dokladu tak tyto automaticky
      -- vygenerovane doklady musim smazat

      -- nejdriv smazeme polozky navazanych dokladu
      _idDoklad = null;
      if(NEW.modul = 'FAV' or NEW.modul = 'FAP') then
        _idDoklad = NEW.idDoklFak;
        for _polFak in select * from dPolFak where idDoklFak = NEW.idDoklFak loop
          execute deleteNavazanePolSklad(_polFak.idPolFak, _polFak.modul, OLD.generovatSkl);
        end loop;
      elsif(NEW.modul = 'POK') then
        _idDoklad = NEW.idDoklInt;
        for _polFak in select * from dPolInt where idDoklInt = NEW.idDoklInt loop
          execute deleteNavazanePolSklad(_polFak.idPolInt, _polFak.modul, OLD.generovatSkl);
        end loop;
      end if;

      if(_idDoklad is not null) then
        for _idDoklSklad in select idTabB from dVazebTab where idTabA = _idDoklad and modulA = NEW.modul and modulB = 'SKL' and (typVazbyK = 'typVazbyDokl.hlavaSkl') loop
          select * into _doklSklad from dDoklSklad where idDoklSklad = _idDoklSklad;
          select count(idPolSklad) into _pocetPolozek from dPolSklad where idDoklSklad = _idDoklSklad;
          -- smazeme pouze takove doklady, ktere maji pocet polozek = 0 nejsou zdrojove pro generovani faktur
          if(_doklSklad.zdrojProFak = false and _pocetPolozek = 0) then
            delete from dvazebtab where idTabA = _idDoklad and modulA = NEW.modul and idTabB = _idDoklSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.hlavaSkl';
            delete from dDoklSklad where idDoklSklad = _idDoklSklad;
          end if;
        end loop;
      end if;
    elsif (NEW.generovatSkl = true and NEW.zdrojProSkl = true) then
      -- bylo false a nastavi se true tak musime zajistit vygenerovani skladoveho dokladu k polozkam, ktere nejste nejsou vyskladneny
      if(NEW.modul = 'FAV' or NEW.modul = 'FAP') then
        for _polFak in select * from dPolFak where idDoklFak = NEW.idDoklFak loop
          if(_polFak.typPolozkyK like 'typPolozky.katalog' and _polFak.zdrojProSkl) then
            select skladove into _skladove from cCenik where idCenik = _polFak.idCenik;
            if (_skladove and _polFak.idBspSkl is not null) then
              select findParovanyPolSklad(_polFak.idPolFak, NEW.modul) into _idPolSklad;
              if(_idPolSklad is null) then
                select count(*) into _sadaItemCount from csady where idceniksada = _polFak.idCenik;
                if(_sadaItemCount > 0) then
                  execute createPolSkladSada(_polFak.idPolFak, NEW.modul);
                else
                  select createPolSklad(_polFak.idPolFak, NEW.modul) into _idPolSklad;
                end if;
              else
                -- nejspis nebudeme delat nic
              end if;
            end if;
          end if;
        end loop;
      elsif (NEW.modul = 'POK') then
        for _polFak in select * from dPolInt where idDoklInt = NEW.idDoklInt loop
          if(_polFak.typPolozkyK like 'typPolozky.katalog' and _polFak.zdrojProSkl) then
            select skladove into _skladove from cCenik where idCenik = _polFak.idCenik;
            if (_skladove and _polFak.idBspSkl is not null) then
              select findParovanyPolSklad(_polFak.idPolInt, NEW.modul) into _idPolSklad;
              if(_idPolSklad is null) then
                select count(*) into _sadaItemCount from csady where idceniksada = _polFak.idCenik;
                if(_sadaItemCount > 0) then
                  execute createPolSkladSada(_polFak.idPolInt, NEW.modul);
                else
                  select createPolSklad(_polFak.idPolInt, NEW.modul) into _idPolSklad;
                end if;
              else
                -- nejspis nebudeme delat nic
              end if;
            end if;
          end if;
        end loop;
      end if;
    else
    end if;
  end if;

  if(OLD.idtypdoklskl is null and NEW.idtypdoklskl is not null) then
    if (NEW.generovatSkl = true and NEW.zdrojProSkl = true) then
      -- bylo false a nastavi se true tak musime zajistit vygenerovani skladoveho dokladu k polozkam, ktere nejste nejsou vyskladneny
      if(NEW.modul = 'FAV' or NEW.modul = 'FAP') then
        for _polFak in select * from dPolFak where idDoklFak = NEW.idDoklFak loop
          if(_polFak.typPolozkyK like 'typPolozky.katalog' and _polFak.zdrojProSkl) then
            select skladove into _skladove from cCenik where idCenik = _polFak.idCenik;
            if (_skladove and _polFak.idBspSkl is not null) then
              select findParovanyPolSklad(_polFak.idPolFak, NEW.modul) into _idPolSklad;
              if(_idPolSklad is null) then
                select count(*) into _sadaItemCount from csady where idceniksada = _polFak.idCenik;
                if(_sadaItemCount > 0) then
                  execute createPolSkladSada(_polFak.idPolFak, NEW.modul);
                else
                  select createPolSklad(_polFak.idPolFak, NEW.modul) into _idPolSklad;
                end if;
              else
                -- nejspis nebudeme delat nic
              end if;
            end if;
          end if;
        end loop;
      elsif (NEW.modul = 'POK') then
        for _polFak in select * from dPolInt where idDoklInt = NEW.idDoklInt loop
          if(_polFak.typPolozkyK like 'typPolozky.katalog' and _polFak.zdrojProSkl) then
            select skladove into _skladove from cCenik where idCenik = _polFak.idCenik;
            if (_skladove and _polFak.idBspSkl is not null) then
              select findParovanyPolSklad(_polFak.idPolInt, NEW.modul) into _idPolSklad;
              if(_idPolSklad is null) then
                select count(*) into _sadaItemCount from csady where idceniksada = _polFak.idCenik;
                if(_sadaItemCount > 0) then
                  execute createPolSkladSada(_polFak.idPolInt, NEW.modul);
                else
                  select createPolSklad(_polFak.idPolInt, NEW.modul) into _idPolSklad;
                end if;
              else
                -- nejspis nebudeme delat nic
              end if;
            end if;
          end if;
        end loop;
      end if;
    else
    end if;
  end if;

  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION ddokladupdatesklad() OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION dzpoldoklcheckvyrcisl()
  RETURNS trigger AS
$BODY$
declare
  _vyrCisl record;
begin
  /*
   Tento trigger zjistuje zda je sklad na vyrobnim cisle stejny jako na navazane polozce dokladu
   a pokud ne tak ho odvaze z teto polozky
  */
  if(NEW.modul = 'FAV') then
    for _vyrCisl in (select * from svyrobnicislo where idPolFakVydej = NEW.idPolFak) loop
      -- pokud jsou oba sklady null (neskladove zbozi) nebo jsou rovny (skladove zbozi)
      if((_vyrCisl.idskladu is null and NEW.idBspSkl is null) or (_vyrCisl.idskladu = NEW.idbspskl)) then
        -- vsechno je v pohode
      else
        update svyrobnicislo set idpolfakvydej = null, idpolskladvydej = null where idvyrobnicislo = _vyrCisl.idvyrobnicislo;
      end if;
    end loop;
  elsif(NEW.modul = 'POK') then
    for _vyrCisl in (select * from svyrobnicislo where idPolIntVydej = NEW.idPolInt) loop
      if((_vyrCisl.idskladu is null and NEW.idBspSkl is null) or (_vyrCisl.idskladu = NEW.idbspskl)) then
        -- vsechno je v pohode
      else
        update svyrobnicislo set idpolintvydej = null, idpolskladvydej = null where idvyrobnicislo = _vyrCisl.idvyrobnicislo;
      end if;
    end loop;
  end if;
  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dzpoldoklcheckvyrcisl() OWNER TO %firmaRole%;

-- Function: svyrobnicisloupdateprevodka()

-- DROP FUNCTION svyrobnicisloupdateprevodka();

CREATE OR REPLACE FUNCTION svyrobnicisloupdateprevodka()
  RETURNS trigger AS
$BODY$
declare
  _vazbaPrevod record;
  _polSkladPrijemPrevod record;
begin
  /* Vytvoreni novych vyrobnich cisel pro vyrobni cisla, ktera byla privazana */
  if(NEW.idPolSkladVydej is not null and OLD.idPolSkladVydej is null) then
    select * into _vazbaPrevod from dvazebtab where idtabA = NEW.idPolSkladVydej and modulA = 'SKL' and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklPrevod';
    if(_vazbaPrevod is not null) then
      select * into _polSkladPrijemPrevod from dpolsklad where idPolSklad = _vazbaPrevod.idTabB;
      insert into svyrobnicislo(kod, idcenik, idskladu,
          idpolskladprijem, idpolskladvydej, idpolfakprijem, idpolfakvydej, idpolintprijem, idpolintvydej, idvyrobnicislohlav)
        values(NEW.kod, NEW.idcenik, _polSkladPrijemPrevod.idBspSkl,
          _polSkladPrijemPrevod.idPolSklad, null, null, null, null, null, NEW.idvyrobnicislohlav);
    end if;
  end if;

  /* Smazani vyrobnich cisel, ktere byli vygenerovany pro odvazana vyrobni cisla */
  if(NEW.idPolSkladVydej is null and OLD.idPolSkladVydej is not null) then
    select * into _vazbaPrevod from dvazebtab where idtabA = OLD.idPolSkladVydej and modulA = 'SKL' and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklPrevod';
    if(_vazbaPrevod is not null) then
      delete from svyrobnicislo where idvyrobnicislohlav = NEW.idVyrobniCisloHlav and idpolskladprijem = _vazbaPrevod.idTabB
        and idPolSkladVydej is null and idPolFakVydej is null and idPolIntVydej is null;
    end if;
  end if;

  return new;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION svyrobnicisloupdateprevodka() OWNER TO %firmaRole%;

-- Function: svyrobnicisloupdatesklad()
-- DROP FUNCTION svyrobnicisloupdatesklad();
CREATE OR REPLACE FUNCTION svyrobnicisloupdatesklad()
  RETURNS trigger AS
$BODY$
declare
  _idSkladu integer;
  _idCenik integer;
begin
  if(NEW.idPolSkladPrijem is not null) then
    if(OLD.idPolSkladPrijem is null or NEW.idPolSkladPrijem <> OLD.idPolSkladPrijem) then
      select idBspSkl, idCenik into _idSkladu, _idCenik from dPolSklad where idPolSklad = NEW.idPolSkladPrijem;
      if(_idSkladu is not null) then
        NEW.idSkladu = _idSkladu;
      end if;
      if(_idCenik is not null) then
        NEW.idCenik = _idCenik;
      end if;
    end if;
  end if;
  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION svyrobnicisloupdatesklad() OWNER TO %firmaRole%;

-- Function: errorininsertkusovnik(integer, date, integer, integer, boolean)
-- DROP FUNCTION errorininsertkusovnik(integer, date, integer, integer, boolean);
CREATE OR REPLACE FUNCTION errorInInsertKusovnik(_iddoklsklad integer, _datvyst date, _idcenik integer, _idskladu integer, _prevodka boolean)
  RETURNS character varying AS
$BODY$
declare
  _typPohybuK character varying;
  _typZasobyK character varying;
  _idKusovnik integer;
  potKus record;
  _cenik record;
  _sklKarta record;
  _iducetobdobi integer;
  _idSkladPotKus integer;
begin
  -- napriklad pokud se jedna o prevodku mezi sklady nebudeme z prijemky vytvaret prevodku
  if (_prevodka = true) then
    return null;
  end if;

  -- typem pohybu musi byt prijem
  select typpohybuk into _typPohybuK from ddoklsklad d where d.iddoklsklad = _iddoklsklad;
  if (_typPohybuK <> 'typPohybu.prijem') then
    return null;
  end if;

  -- idcenik odkazuje na neco co je soucasti kusovniku.
  select ckus.idkusovnik into _idKusovnik from ckusovnik ckus where ckus.idcenik = _idcenik
    and exists (select 1 from ckusovnik cPot where cPot.idotec = ckus.idkusovnik);
  if (_idKusovnik is null) then
    return null;
  end if;

  -- pro vsechny kusovniky, ktere jsou pod nasim kusovnikem a jsou skladove nebo vyroba
  for potKus in (select * from ckusovnik cPot where cPot.idotec = _idKusovnik) loop
    select * into _cenik from cCenik where idCenik = potKus.idCenik;

    if (not _cenik.skladove) then
        continue;
    end if;

    select findIdUcetniObdobiKDatu(_datvyst) into _iducetobdobi;
    -- vybereme skladovou kartu podle preferovaneho skladu
    select null into _sklKarta;
    _idSkladPotKus = null;

    select getPrefIdSkladu(
	(select idstred from ddoklsklad where iddoklsklad = _iddoklsklad),
	_cenik.idskupzboz, potKus.idcenik) into _idSkladPotKus;

    if (_idSkladPotKus is not null) then
	select * into _sklKarta from skarty where idcenik = potKus.idcenik and idSkladu = _idSkladPotKus and iducetobdobi = _iducetobdobi;
    end if;

    -- sklad karta nebyla nalezena podle preferovaneho skladu, vezmeme sklad stejny jako z vytvarene polozky
    if (_sklKarta is null) then
	select * into _sklKarta from skarty where idcenik = potKus.idcenik and idSkladu = _idskladu and iducetobdobi = _iducetobdobi;
    end if;

    -- skladovou kartu k tomuhle ceniku nelze nalezt
    if (_sklKarta is null) then
	return _cenik.kod;
    end if;
  end loop;

  return null;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION errorInInsertKusovnik(integer, date, integer, integer, boolean) OWNER TO %firmaRole%;

-- Function: dpolskladinsertkusovnik()
--DROP FUNCTION dpolskladinsertkusovnik();
CREATE OR REPLACE FUNCTION dpolskladinsertkusovnik()
  RETURNS trigger AS
$BODY$
declare
  _idPolSklad integer;
begin
  select dpolskladinsertkusovnik(NEW.idPolSklad) into _idPolSklad;
  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladinsertkusovnik() OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION dpolskladinsertkusovnik(i_idPolSklad integer)
  RETURNS integer AS
$BODY$
declare
    _polSklad record;
    _typPohybuK varchar;
    _typZasobyK varchar;
    _skladove boolean;
    _idKusovnik integer;
    _iducetobdobi integer;
    _stavNaSklade numeric;
    _sklKarta record;
    _cenik record;
    _sklzapor boolean;
    _idVydejPolSklad integer;
    _idParovanyDoklad integer;
    potKus record;
    _parKusMnoz numeric;
    _i integer;
    _kurz numeric;
    _isCiziMena boolean;
    _idMeny integer;
    _mnozMj numeric;
    _cenaMj numeric;
    _sumZkl numeric;
    _newSumZkl numeric;
    _sumZklMen numeric;
    _idSkladPotKus integer;
    _idProtiUcetDoklad integer;
    _idStred integer;
    _kopStred boolean;
    _sklad record;
    _typPohybuSkladK character varying;
    _cenaMjSkl numeric(19,6);
    _cenaMjNeskl numeric(19,6);
begin
  select * into _polSklad from dpolsklad where idpolsklad = i_idpolSklad;

  -- napriklad pokud se jedna o prevodku mezi sklady nechceme z prijemky vytvaret prevodku
  if (_polSklad.prevodka = true) then
    return null;
  end if;

  -- typem pohybu musi byt prijem
  select typpohybuk into _typPohybuK from ddoklsklad d where d.iddoklsklad = _polSklad.iddoklsklad;
  if (_typPohybuK <> 'typPohybu.prijem') then
    return null;
  end if;

  -- pokud neni nastaven typ pohybu sklad prijem z vyroby tak koncime
  select typpohybuskladk into _typPohybuSkladK from ddoklsklad d where d.iddoklsklad = _polSklad.iddoklsklad;
  if(_typPohybuSkladK is null or _typPohybuSkladK <> 'typPohybuSklad.prijemVyrob') then
    return null;
  end if;

  -- idcenik odkazuje na neco co je soucasti kusovniku.
  select ckus.idkusovnik into _idKusovnik from ckusovnik ckus where ckus.idcenik = _polSklad.idcenik
    and exists (select 1 from ckusovnik cPot where cPot.idotec = ckus.idkusovnik);
  if (_idKusovnik is null) then
    return null;
  end if;

  -- vytvorime nebo nalezneme zparovany doklad skl vydej
  select findparovanydoklsklad(_polSklad.iddoklsklad, _polSklad.modul, 'typVazbyDokl.hlavaSklKus') into _idParovanyDoklad;
  if (_idParovanyDoklad is null) then
    select createdoklsklad(_polSklad.idpolsklad, _polSklad.iddoklsklad, _polSklad.modul) into _idParovanyDoklad;
  end if;

  if(_idParovanyDoklad is null) then
    return null;
  end if;

  select isDoklSkladMenaCizi(_idParovanyDoklad, _polSklad.datVyst) into _isCiziMena;
  select getkurzfromdoklad(_idParovanyDoklad, _polSklad.datVyst) into _kurz;
  select idMeny into _idMeny from dDoklSklad where idDoklSklad = _idParovanyDoklad;

  _i = 0;
  _newSumZkl = 0.0;
  _cenaMjSkl = 0.0;
  _cenaMjNeskl = 0.0;

  perform putglotxvariable('zurnalTxName', 'rozpadKusovniku');

  -- pro vsechny kusovniky, ktere jsou pod nasim kusovnikem a jsou skladove nebo vyroba a nemaji nulove mnozstvi
  for potKus in (select * from ckusovnik cPot where cPot.idotec = _idKusovnik and cPot.mnoz > 0.0) loop
    select * into _cenik from cCenik where idCenik = potKus.idCenik;

    select mnoz into _parKusMnoz from ckusovnik where idkusovnik = _idKusovnik;

    select skladove into _skladove from cCenik cen where cen.idCenik = potKus.idCenik;
    if (not _skladove) then
        _newSumZkl = _newSumZkl + ((_cenik.nakupcena * potKus.mnoz * _polSklad.mnozMj) / _parKusMnoz);
        _cenaMjNeskl = _cenaMjNeskl + ((_cenik.nakupcena * potKus.mnoz) / _parKusMnoz);
        continue;
    end if;
    _i = _i + 1;

    select findIdUcetniObdobiKDatu(_polSklad.datVyst) into _iducetobdobi;
    -- vybereme skladovou kartu podle preferovaneho skladu
    select null into _sklKarta;
    _idSkladPotKus = null;

    select getPrefIdSkladu(
	(select idstred from ddoklsklad where iddoklsklad = _polSklad.iddoklsklad),
	_cenik.idskupzboz, potKus.idcenik) into _idSkladPotKus;

    if (_idSkladPotKus is not null) then
	select * into _sklKarta from skarty where idcenik = potKus.idcenik and idSkladu = _idSkladPotKus and iducetobdobi = _iducetobdobi;
    end if;

    -- sklad karta nebyla nalezena podle preferovaneho skladu, vezmeme sklad stejny jako z vytvarene polozky
    if (_sklKarta is null) then
	select * into _sklKarta from skarty where idcenik = potKus.idcenik and idSkladu = _polSklad.idBspSkl and iducetobdobi = _iducetobdobi;
	select _polSklad.idStred into _idStred;
	select _polSklad.kopstred into _kopStred;
    else
        select idstred into _idStred from dbsp d where _sklKarta.idskladu = d.idbsp;
	select false into _kopStred;
    end if;

    -- skladovou
    if (_sklKarta is null) then
	raise exception 'Nebyla nalezena skladova karta k polozce ceniku %. Definujte mapovani skladu pro tuto polozku nebo ji pridejte na sklad %',
		_cenik.kod, (select kod from dtypdokl where idtypdokl = _polSklad.idskladu);
    end if;

   _mnozMj = (potKus.mnoz / _parKusMnoz) * _polSklad.mnozMj;
   _cenaMj = _sklKarta.prumCenaTuz / _kurz;
   _sumZkl = _mnozMj * _sklKarta.prumCenaTuz;
   _cenaMjSkl = _cenaMjSkl + (_cenaMj * (potKus.mnoz / _parKusMnoz));
   _newSumZkl = _newSumZkl + _sumZkl;

   if(_isCiziMena) then
     _sumZklMen = _mnozMj * _cenaMj;
   else
     _sumZklMen = 0.0;
   end if;

    -- TODO doplnit sarze a expirace
    select dgetstavnasklade(_sklKarta.idkarty, _polSklad.datVyst, -1, _polSklad.idfirmy, NULL, NULL) into _stavNaSklade;

    -- osetreni zda je povoleny zaporny stav na sklade
    if (_stavNaSklade - _mnozMj < 0) then
        select sklzapor into _sklzapor from nNastav where _polSklad.datVyst >= PlatiOdData order by PlatiOdData desc limit 1;
        if (_sklzapor is null) then
            select sklzapor into _sklzapor from nNastav where PlatiOdData is null limit 1;
        end if;
        if _sklzapor is null or _sklzapor = false then
            raise exception '0002:sPreporctiSkladKartu: neni povolen zaporny stav skladu';
        end if;
    end if;

    select nextval('seq_dpolsklad'::regclass) into _idVydejPolSklad;
    select idprotiucet into _idProtiUcetDoklad from ddoklsklad where iddoklsklad = _idParovanyDoklad;
    select * into _sklad from dBsp where _sklKarta.idSkladu = idBsp;

    insert into dpolsklad(idPolSklad, idcenik, idBspSkl, idkarty, datVyst, datUcto, modul, typPolozkyK, idDoklSklad,
        mnozMj, cenaMj, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni,
        nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni, idStred, idZakazky, idMeny, kopstred)
    values (_idVydejPolSklad, potKus.idcenik, _sklKarta.idSkladu, _sklKarta.idkarty, _polSklad.datVyst, _polSklad.datUcto, _polSklad.modul, _polSklad.typpolozkyk, _idParovanyDoklad,
        _mnozMj, _cenaMj, _sumZkl, _sumZklMen, _idProtiUcetDoklad, _sklad.idprimucet, true, false, _polSklad.baleniid, _polSklad.mnozbaleni,
        _cenik.nazev, _cenik.nazevA, _cenik.nazevB, _cenik.nazevC, NULL, NULL, _polSklad.cisRad * 100 + _i, true,
        _idStred, _polSklad.idZakazky, _idMeny, _kopStred);

    insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)
      values (0.0, _polSklad.idpolsklad, _idVydejPolSklad, 'SKL', 'SKL', false, 'typVazbyDokl.polozkaSklKus');

  end loop;

  perform removeglotxvariable('zurnalTxName');

  select getkurzfromdoklad(_polSklad.iddoklsklad, _polSklad.datvyst) into _kurz;
  _cenaMj = _newSumZkl / _polSklad.mnozMj / _kurz;

  select isDoklSkladMenaCizi(_polSklad.iddoklsklad, _polSklad.datVyst) into _isCiziMena;
  if (_isCiziMena) then
    _sumZklMen = _polSklad.cenaMj * _polSklad.mnozMj;
  else
    _sumZklMen = 0.0;
  end if;

  update dpolsklad set
       sumzkl = _newSumZkl,
       cenaMj = _cenaMj,
       sumZklMen = _sumZklMen,
       cenaMjSkl = _cenaMjSkl,
       cenaMjNeskl = _cenaMjNeskl
     where idpolsklad = _polSklad.idpolsklad;

  return _polSklad.idPolSklad;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladinsertkusovnik(integer) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION ddoklskladupdatekusovnik()
  RETURNS trigger AS
$BODY$
declare
  _polSklad record;
  _polSkladParovana record;
  _idDoklSklad integer;
  _doklSklad record;
begin
  -- pokud se nastavil typ pohybu sklad na prijem vyrobku tak bychom meli vygenerovat rozpad kusovniku
  if(OLD.idtypdoklskl is null and NEW.idtypdoklskl is not null)
  or (NEW.typPohybuSkladK is not null and NEW.typPohybuSkladK = 'typPohybuSklad.prijemVyrob' and NEW.idTypDoklSkl is not null) then
    if (NEW.typPohybuK = 'typPohybu.prijem') then
      for _polSklad in select * from dPolSklad where idDoklSklad = NEW.idDoklSklad loop
        select * into _polSkladParovana from dpolsklad
           where idPolSklad in (
              select idtabb from dvazebtab where idtaba = _polSklad.idPolSklad and modula = 'SKL' and modulb = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus'
           );
        if(_polSkladParovana is null) then
          select dpolskladinsertkusovnik(_polSklad.idPolSklad) into _polSkladParovana;
        end if;
      end loop;
    end if;
  end if;

  -- pokud se odnastavil typ pohybu sklad a predtim byl typ pohybu sklad prijem vyrobku tak bychom meli smazat vytvorenou vydejku
  if(NEW.typPohybuSkladK is null or not NEW.typPohybuSkladK = 'typPohybuSklad.prijemVyrob')
  and (OLD.typPohybuSkladK is not null and OLD.typPohybuSkladK = 'typPohybuSklad.prijemVyrob') then
    for _polSklad in select * from dPolSklad where idDoklSklad = NEW.idDoklSklad loop
      execute deleteNavazanePolSklad(_polSklad.idPolSklad, _polSklad.modul, true);
    end loop;

    for _idDoklSklad in select idTabB from dVazebTab where idTabA = NEW.idDoklSklad and modulA = NEW.modul and modulB = 'SKL' and (typVazbyK = 'typVazbyDokl.hlavaSklKus') loop
      select * into _doklSklad from dDoklSklad where idDoklSklad = _idDoklSklad;
      delete from dvazebtab where idTabA = NEW.idDoklSklad and modulA = NEW.modul and idTabB = _idDoklSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.hlavaSklKus';
      delete from dDoklSklad where idDoklSklad = _idDoklSklad;
    end loop;
  end if;

  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION ddoklskladupdatekusovnik() OWNER TO %firmaRole%;


CREATE TRIGGER ddoklskladupdatekusovnik
  AFTER UPDATE
  ON ddoklsklad
  FOR EACH ROW
  EXECUTE PROCEDURE ddoklskladupdatekusovnik();

-- Function: dpolskladupdate()
-- DROP FUNCTION dpolskladupdate();
CREATE OR REPLACE FUNCTION dpolskladupdate()
  RETURNS trigger AS
$BODY$
declare
  tmp_rozsirenepolozky_exists boolean;
  _updatuj boolean;
  _pocetPolozek integer;
  _rozsirenaPolozka record;
  _sklFifo boolean;
  _vypnutySklad character varying;
  _mazatTmpTable boolean;
begin
  if(NEW.idBspSkl = OLD.idBspSkl and NEW.idCenik = OLD.idCenik and comparedate(NEW.datVyst, OLD.datVyst)
    and comparevarchar(NEW.typPolozkyK, OLD.typPolozkyK)
    and comparevarchar(NEW.sarze, OLD.sarze) and comparedate(NEW.expirace, OLD.expirace)
    and NEW.mnozMj = OLD.mnozMj and NEW.cenaMj = OLD.cenaMj and NEW.sumZkl = OLD.sumZkl and NEW.sumZklMen = OLD.sumZklMen
    and NEW.storno = OLD.storno
  ) then
    return NEW;
  end if;

  /*
    prepocet skladu budeme provadet jen v okamziku kdy neexistuje tabulka tmp_rozsirenePolozky
    nebo kdyz tato tabulka existuje ale neni v ni obsazeno polozka kteoru chceme updatovat
  */
  select getglotxvariable('vypniSklad') into _vypnutySklad;
  if(_vypnutySklad is null or _vypnutySklad <> 'true') then
    _updatuj = true;
    tmp_rozsirenepolozky_exists := (select istableexist('tmp_RozsirenePolozky'));
    if(tmp_rozsirenepolozky_exists = true) then
      select count(*) into _pocetPolozek from tmp_rozsirenePolozky where idPolSklad = NEW.idPolSklad;
      if(_pocetPolozek > 0) then
        _updatuj = false;
      end if;
    end if;

    if(OLD.idPolSklad < 0 and NEW.idPolSklad > 0) then
      _updatuj = false;
    end if;

    _sklfifo := (select isfifosklad(NEW.datvyst));
    if (_sklfifo) then
      --fifo
      if (OLD.storno=false and NEW.storno=true) then
        execute sfifoStorno(OLD.idpolsklad, OLD.iddoklsklad);
      end if;
      if (OLD.cenamj <> NEW.cenamj) then
        execute sfifocenamj(OLD.idpolsklad, OLD.iddoklsklad, NEW.cenamj);
      end if;
      --fifo konec
    end if;

    if(_updatuj) then

      -- generuji rozsirene polozky
      select skladGenerujRozsirenePolozky(NEW.datVyst, NEW.idPolSklad, NEW.idKarty) into _mazatTmpTable;

      execute putglotxvariable('zurnalTxName', 'prepocetSkladu');

      for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
        if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then
          execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
        end if;
      end loop;

      if(OLD.storno = false) then
        execute sprepoctiskladkartu(OLD.mnozMj, OLD.cenaMj, OLD.datVyst, OLD.idKarty, OLD.idDoklSklad, OLD.idBspSkl, -1);
      end if;

      for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
        if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then
          execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
        else
          if(NEW.storno = false) then
            execute sprepoctiskladkartu(NEW.mnozMj, NEW.cenaMj, NEW.datVyst, NEW.idKarty, NEW.idDoklSklad, NEW.idBspSkl, 1);
          end if;
        end if;
      end loop;

      if(_mazatTmpTable) then
        drop table tmp_RozsirenePolozky;
        drop table tmp_SkladoveKarty;
        execute removeglotxvariable('zurnalTxName');
      end if;

    end if;
  end if;
  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladupdate() OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION dpolskladdelete()
  RETURNS trigger AS
$BODY$
declare
  _rozsirenaPolozka record;
  _mazatTmpTable boolean;
begin
  if(not OLD.storno) then
    -- generuji rozsirene polozky
    select skladGenerujRozsirenePolozky(OLD.datVyst, OLD.idPolSklad, OLD.idKarty) into _mazatTmpTable;

    execute putglotxvariable('zurnalTxName', 'prepocetSkladu');

    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
      if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then
        execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
      else
        --raise exception 'v rozsirenych polozkach je mazana polozka s id %', _rozsirenaPolozka;
      end if;
    end loop;

    -- musim jeste odpocist mazanou polozku
    --execute skladOdpoctiRozsirenouPolozku(OLD.idPolSklad);
    execute sprepoctiskladkartu(OLD.mnozMj, OLD.cenaMj, OLD.datVyst, OLD.idKarty, OLD.idDoklSklad, OLD.idBspSkl, -1);

    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
      if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then
        execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
      else
        --raise exception 'v rozsirenych polozkach je mazana polozka s id %', _rozsirenaPolozka;
      end if;
    end loop;

    execute sfifostorno(OLD.idPolSklad, OLD.idDoklSklad);

    if(_mazatTmpTable) then
      drop table tmp_RozsirenePolozky;
      drop table tmp_SkladoveKarty;
      execute removeglotxvariable('zurnalTxName');
    end if;
  end if;

  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladdelete() OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION dpoldoklupdatesklad() RETURNS trigger AS
$BODY$
declare
  _idPolDokl integer;
  _idDoklad integer;
  _idPolSklad integer;
  _idDoklSklad integer;
  _dokladGenerovatSkl boolean;
  _typDoklGenerovatSkl boolean;
  _typZasobyK character varying;
  _skladove boolean;
  _vyrobniCislo record;
  _typPohybuK character varying;
  _sadaItemCount integer;
  _vypnutySklad character varying;
begin
  select getglotxvariable('vypniSklad') into _vypnutySklad;
  if(_vypnutySklad is null or _vypnutySklad <> 'true') then
    --raise exception 'sem sem se nemel dostat';
    if(NEW.storno <> OLD.storno or NEW.stornoPol <> OLD.stornoPol) then
      return NEW;
    end if;

    if(NEW.modul like 'POK') then
      _idPolDokl = NEW.idPolInt;
      _idDoklad = NEW.idDoklInt;
      select generovatSkl into _dokladGenerovatSkl from dDoklInt where idDoklInt = NEW.idDoklInt;
      select generovatSkl into _typDoklGenerovatSkl from dTypDokl where idTypDokl = (select idTypDokl from dDoklInt where idDoklInt = NEW.idDoklInt);

      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolInt where idpolint = NEW.idPolInt);
    elsif (NEW.modul like 'FAV' or NEW.modul like 'FAP') then
      _idPolDokl = NEW.idPolFak;
      _idDoklad = NEW.idDoklFak;
      select generovatSkl into _dokladGenerovatSkl from dDoklFak where idDoklFak = NEW.idDoklFak;
      select generovatSkl into _typDoklGenerovatSkl from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = NEW.idDoklFak);

      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolfak where idpolfak = NEW.idPolFak);
    else
      return NEW;
    end if;

    -- pokud se lisi sklad, cenik, typPolozky, mnozMj, sarze, expirace
    -- tak skladovou polozku musim smazat a vytvorit znovu kvuli fifu
    if((not compareId(NEW.idBspSkl, OLD.idBspSkl)
       or not compareId(NEW.idCenik, OLD.idCenik)
       or not compareVarchar(NEW.typPolozkyK, OLD.typPolozkyK)
       or NEW.mnozMj <> OLD.mnozMj
       or not compareVarchar(NEW.sarze, OLD.sarze)
       or not compareDate(NEW.expirace, OLD.expirace))
       and _dokladGenerovatSkl and NEW.zdrojProSkl) then
      --raise exception 'mazu polSklad';
      execute deleteNavazanePolSklad(_idPolDokl, NEW.modul);
    end if;

    if(NEW.typPolozkyK like 'typPolozky.katalog' and _dokladGenerovatSkl and _typDoklGenerovatSkl and NEW.zdrojProSkl) then
      select skladove into _skladove from cCenik where idCenik = NEW.idCenik;

      if (_skladove and NEW.idBspSkl is not null) then
        select findParovanyPolSklad(_idPolDokl, NEW.modul) into _idPolSklad;
        if(_idPolSklad is null) then
          --select createPolSklad(_idPolDokl, NEW.modul) into _idPolSklad;
          if(_sadaItemCount > 0) then
            execute createPolSkladSada(_idPolDokl, NEW.modul);
          else
            select createPolSklad(_idPolDokl, NEW.modul) into _idPolSklad;
          end if;
        else
          if(_sadaItemCount > 0) then
            execute fillPolSkladSada(_idPolDokl, NEW.modul);
          else
            select fillPolSklad(_idPolSklad, _idPolDokl, NEW.modul) into _idPolSklad;
          end if;
        end if;
        -- provedeni upgradu vyrobnich cisel
        if(NEW.modul like 'FAV') then
          for _vyrobniCislo in select * from sVyrobniCislo where idPolFakVydej = NEW.idPolFak and (idPolSkladVydej is null or idPolSkladVydej <> _idPolSklad) loop
            update sVyrobniCislo set idPolSkladVydej = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo;
          end loop;
        end if;
        if(NEW.modul like 'FAP') then
          for _vyrobniCislo in select * from sVyrobniCislo where idPolFakPrijem = NEW.idPolFak and (idPolSkladPrijem is null or idPolSkladPrijem <> _idPolSklad) loop
            update sVyrobniCislo set idPolSkladPrijem = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo;
          end loop;
        end if;
        if(NEW.modul like 'POK') then
          select typPohybuK into _typPohybuK from dDoklInt where idDoklInt = _idDoklad;
          if(_typPohybuK like 'typPohybu.prijem') then
            for _vyrobniCislo in select * from sVyrobniCislo where idPolIntVydej = NEW.idPolInt and (idPolSkladVydej is null or idPolSkladVydej <> _idPolSklad) loop
              update sVyrobniCislo set idPolSkladVydej = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo;
            end loop;
          else
            for _vyrobniCislo in select * from sVyrobniCislo where idPolIntPrijem = NEW.idPolInt and (idPolSkladPrijem is null or idPolSkladPrijem <> _idPolSklad) loop
              update sVyrobniCislo set idPolSkladPrijem = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo;
            end loop;
          end if;
        end if;

      end if;
      -- prepocteni sum na dokladu
      select findParovanyDoklSklad(_idDoklad, NEW.modul) into _idDoklSklad;
      execute sprepoctiSumyDokladu(_idDoklSklad, NEW.datVyst);
    end if;
  end if;

  return NEW;
end
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpoldoklupdatesklad() OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION dpoldoklinsertsklad() RETURNS trigger AS
$BODY$
declare
  pocetNavazanychDokladu integer;
  _idPolFak integer;
  _idDoklFak integer;
  _idPolSklad integer;
  _dokladGenerovatSkl boolean;
  _typDoklGenerovatSkl boolean;
  _typZasobyK character varying;
  _skladove boolean;
  _sadaItemCount integer;
  _cenaMjNakup numeric(19,6);
  _typDoklK character varying;
begin

  if(NEW.typPolozkyK like 'typPolozky.katalog') then
    if(NEW.modul like 'POK') then
      _idPolFak = NEW.idPolInt;
      _idDoklFak = NEW.idDoklInt;
      select generovatSkl into _dokladGenerovatSkl from dDoklInt where idDoklInt = NEW.idDoklInt;
      select generovatSkl, typDoklK into _typDoklGenerovatSkl, _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklInt where idDoklInt = NEW.idDoklInt);

      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolint where idpolint = NEW.idPolInt);
    else
      _idPolFak = NEW.idPolFak;
      _idDoklFak = NEW.idDoklFak;
      select generovatSkl into _dokladGenerovatSkl from dDoklFak where idDoklFak = NEW.idDoklFak;
      select generovatSkl, typDoklK into _typDoklGenerovatSkl, _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = NEW.idDoklFak);

      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolfak where idpolfak = NEW.idPolFak);
    end if;

    select skladove into _skladove from cCenik where idCenik = NEW.idCenik;

    if (_skladove and NEW.idBspSkl is not null
      and _dokladGenerovatSkl and _typDoklGenerovatSkl and NEW.zdrojProSkl) then
      select count(*) into pocetNavazanychDokladu from dvazebtab where
        typVazbyK like 'typVazbyDokl.hlavaSkl'
        and (
        (idTabA = _idDoklFak and modulA like NEW.modul)
        or
        (idTabB = _idDoklFak and modulB like NEW.modul));

      if(pocetNavazanychDokladu > 2) then
        --neco jeste nevim co
      else
        if(_sadaItemCount > 0) then
          execute createPolSkladSada(_idPolFak, NEW.modul);
        else
          select createPolSklad(_idPolFak, NEW.modul) into _idPolSklad;
        end if;
      end if;

      execute putglotxvariable('vypniSklad', 'true');
      if(NEW.modul = 'FAV' and _typDoklK != 'typDokladu.dobropis') then
        select skladGetCenaMjNakup(_idPolFak, NEW.modul, NEW.mnozMj) into _cenaMjNakup;
        update dpolfak set cenaMjNakup = _cenaMjNakup where idpolfak = _idPolFak;
      elsif(NEW.modul = 'POK') then
	    select skladGetCenaMjNakup(_idPolFak, NEW.modul, NEW.mnozMj) into _cenaMjNakup;
        update dpolint set cenaMjNakup = _cenaMjNakup where idpolint = _idPolFak;
      end if;
      execute removeglotxvariable('vypniSklad');
    end if;
  end if;

  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpoldoklinsertsklad() OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION findZklMdUcetIfVydej(_idPolDokl integer, _modul character varying) RETURNS integer AS
$BODY$
declare
  _polDokl record;
  _doklad record;
  _skupZboz record;
  _idZklMdUcet integer;
begin
  if(_modul like 'POK') then
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;
    select * into _doklad from dDoklInt where idDoklInt = _polDokl.idDoklInt;
  else
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;
    select * into _doklad from dDoklFak where idDoklFak = _polDokl.idDoklFak;
  end if;
  select idProtiUcetSklV into _idZklMdUcet from cSkupZboz where idSkupZboz = (select idSkupZboz from ccenik where idCenik = _polDokl.idCenik);
  if(_idZklMdUcet is null) then
     select idProtiUcetV into _idZklMdUcet from uTypUcOp where idTypUcOp = (select idTypUcOpV from dTypDokl where idTypDokl = _doklad.idTypDoklSkl);
  end if;
  return _idZklMdUcet;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION findZklMdUcetIfVydej(integer, character varying) OWNER TO %firmaRole%;

create or replace function skladGetCenaMjNakup(i_idPolFak integer, i_modul character varying, i_mnozMj numeric(19,6)) returns numeric(19, 6) as
$BODY$
declare
  _result numeric(19,6);
  _polSklad record;
  _fifoPolSklad record;
  _mnozMj numeric(19,6);
  _cenik record;
  _polDokl record;
  _isDobropis boolean;
  _typDoklK character varying;
begin
  _isDobropis = false;
  if(i_modul = 'FAV') then
    select * into _polDokl from dPolFak where idPolFak = i_idPolFak;
    select * into _cenik from ccenik where idcenik = _polDokl.idCenik;
    select typDoklK into _typDoklK from dtypdokl where idtypdokl = (select idtypdokl from ddoklfak where iddoklfak = _polDokl.idDoklFak);
    if(_typDoklK = 'typDokladu.dobropis') then
      _isDobropis = true;
    end if;
  elsif(i_modul = 'POK') then
    select * into _polDokl from dPolInt where idPolInt = i_idPolFak;
    select * into _cenik from ccenik where idcenik = _polDokl.idCenik;
  else
    select null into _cenik;
  end if;

  if(_cenik is null) then
    return 0.0;
  end if;

  if(_isDobropis) then
    _mnozMj = 0 - i_mnozMj;
  else
    _mnozMj = i_mnozMj;
  end if;

  if(not _cenik.skladove) then
    return _cenik.nakupCena;
  end if;
  _result = 0.0;
  --_mnozMj = 0.0;
  for _polSklad in (select * from dpolsklad where idPolSklad in
    (select idTabB from dVazebTab where idTabA = i_idPolFak and modulA = i_modul and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSkl')) loop
    if(_polSklad.mnozMj = 0.0) then
      _result = _result + _polSklad.cenaMj;
    else
      _result = _result + _polSklad.sumZkl;
    end if;
    --_mnozMj = _mnozMj + _polSklad.mnozMj;
    for _fifoPolSklad in (select * from dpolsklad where idPolSklad in
      (select idpolskladcil from svazbypolsklad where idPolSkladZdroj = _polSklad.idPolSklad)) loop
        if(_fifoPolSklad.mnozMj = 0.0) then
          _result = _result + _fifoPolSklad.cenaMj;
        else
          _result = _result + _fifoPolSklad.sumZkl;
        end if;
        --_mnozMj = _mnozMj + _fifoPolSklad.mnozMj;
    end loop;
  end loop;

  for _polSklad in (select * from dpolsklad where idPolSklad in
    (select idTabB from dVazebTab where idTabA = i_idPolFak and modulA = i_modul and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklSada')) loop
    if(_polSklad.mnozMj = 0.0) then
      _result = _result + _polSklad.cenaMj;
    else
      _result = _result + _polSklad.sumZkl;
    end if;
    --_mnozMj = _mnozMj + _polSklad.mnozMj;
    for _fifoPolSklad in (select * from dpolsklad where idPolSklad in
      (select idpolskladcil from svazbypolsklad where idPolSkladZdroj = _polSklad.idPolSklad)) loop
        if(_fifoPolSklad.mnozMj = 0.0) then
          _result = _result + _fifoPolSklad.cenaMj;
        else
          _result = _result + _fifoPolSklad.sumZkl;
        end if;
        --_mnozMj = _mnozMj + _fifoPolSklad.mnozMj;
    end loop;
  end loop;


  if(_mnozMj = 0) then
  else
    _result = _result / _mnozMj;
  end if;
  return _result;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladGetCenaMjNakup(integer, character varying, numeric(19,6)) OWNER TO %firmaRole%;

-- Function: sprepoctisklad(integer)
-- DROP FUNCTION sprepoctisklad(integer);
CREATE OR REPLACE FUNCTION sprepoctisklad(i_ucetobd integer)
  RETURNS void AS
$BODY$
declare
  _rozsirenaPolozka record;
  _zaznam record;
  _vyrobniCislo record;
  _pocatek_ucetobd date;
  _konec_ucetobd date;
  _evidVyrCis boolean;
  _mazatTmpTable boolean;
  _citac integer;
  _pocetPred integer;
  _pocetPo integer;
begin

  execute putglotxvariable('zurnalTxName', 'prepocetSkladu');
  execute putglotxvariable('probihaPrepocetSkladu', 'true');

  -- nacteni datumu zacatku ucetniho obdobi
  select platioddata, platidodata into _pocatek_ucetobd, _konec_ucetobd from nucetobdobi where iducetobdobi = i_ucetobd;

  -- smazani tabulky fifo vazeb
  delete from sfifovazby where idpolskladvydej in
    (select idpolsklad from dpolsklad where
            datVyst >= _pocatek_ucetobd);

  delete from sfifovazby f
    where f.idpolskladvydej not in (select p.idpolsklad from dpolsklad p);

  -- nagenerovani pomocnych tabulek
  select skladGenerujRozsirenePolozky(_pocatek_ucetobd, -1, -1) into _mazatTmpTable;

  select count(*) into _pocetPred from tmp_RozsirenePolozky;

  -- provedu fifovani rozsirenych polozek
  for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
    if (_rozsirenaPolozka.typPohybuk = 'typPohybu.vydej') then
      select * into _zaznam from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
      select evidVyrCis into _evidVyrCis from ccenik where idcenik = _zaznam.idCenik;
      if (not _evidVyrCis) then
        execute sfifoVydej(_zaznam.idPolSklad, _zaznam.idCenik, _zaznam.idBspSkl, _zaznam.idKarty, _zaznam.mnozmj);
      else
        for _vyrobniCislo in select * from svyrobnicislo where idpolskladvydej = _zaznam.idPolSklad loop
          update svyrobnicislo set idpolskladvydej = null where idvyrobnicislo = _vyrobniCislo.idvyrobnicislo;
          update svyrobnicislo set idpolskladvydej = _zaznam.idPolSklad where idvyrobnicislo = _vyrobniCislo.idvyrobnicislo;
        end loop;
      end if;
      execute sPrepoctiSumyDokladu(_zaznam.idDoklSklad);
    end if;
  end loop;

  --select count(*) into _pocetPo from tmp_RozsirenePolozky;

  -- vynulovani skladovych karet
  execute skladVynulujSkladoveKarty();

  -- zafifovane veci zapoctu na skladove karty
  for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
    execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
  end loop;

  if(_mazatTmpTable) then
    drop table tmp_RozsirenePolozky;
    drop table tmp_SkladoveKarty;
    execute removeglotxvariable('zurnalTxName');
    execute removeglotxvariable('probihaPrepocetSkladu');
  end if;

end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sprepoctisklad(integer) OWNER TO %firmaRole%;

alter table dpolsklad enable trigger all;
alter table dpolfak enable trigger all;
alter table dpolint enable trigger all;

--------------------------------------------------------------------------------

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 411, 't', %appVersion%, clock_timestamp());