--------------------------------------------------------------------------------
-- Bug 21619 – [WinStrom] Mapování skladu nefunguje pro nastavení sady
--------------------------------------------------------------------------------

-- Function: skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, integer)
DROP FUNCTION skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, integer);

-- Function: skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, integer)
-- DROP FUNCTION skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, integer);
CREATE OR REPLACE FUNCTION skladfindcenamjnakup(i_mnozmj numeric, i_idcenik integer, i_idskladu integer, i_datum date, i_sarze character varying, i_expirace date, i_idvyrobnihocisla integer, i_idstred integer)
  RETURNS numeric AS
$BODY$
declare
  _sklfifo boolean;
  _mazatTmpTable boolean;
  _idkarty integer;
  _rozsirenaPolozka record;
  _iducetobdobi integer;
  _result numeric(19,6);
  _pomocDPolSkladF record;
  _mnozstvi numeric(19,6);
  _potrebnyPocet numeric(19,6);
  _sadaItemCount integer;
  _polozkaSady record;
  _pomoc numeric(19,6);

  _sumSumZkl numeric(19,6);
  _sumMnozMj numeric(19,6);
  _sumTuz numeric(19,6);
  _mnozMj numeric(19,6);
  _typPohybuK character varying;
  _karta record;
  _idskupzboz integer;
  _idSkladuPref integer;
  _cenik record;
  _sklad record;
begin
  _result = 0.0;
  _mnozstvi = 0.0;

  if(i_mnozMj > 0) then
    select count(*) into _sadaItemCount from csady where idceniksada = i_idcenik;
    if(_sadaItemCount > 0) then
      FOR _polozkaSady IN (select * from cSady where idCenikSada = i_idcenik) LOOP
        -- TODO doresit sarze expirace a vyrobni cisla
        select skladfindcenamjnakup(i_mnozmj * _polozkaSady.mnozMj, _polozkaSady.idcenik, i_idskladu, i_datum, null, null, null, i_idstred) into _pomoc;
        _result = _result + (_pomoc * i_mnozmj * _polozkaSady.mnozMj);
      end loop;
    else
      select findiducetniobdobikdatu(i_datum) into _iducetobdobi;
      _sklfifo := (select isfifosklad(i_datum));
      if (_sklfifo) then
        if(i_idvyrobnihocisla is not null and i_idvyrobnihocisla > 0) then
          -- pokud je zadano vyrobni cislo ma nejvetsi prioritu
          select cenaMj into _result from dpolsklad where idpolsklad = (select idpolskladprijem from svyrobnicislo where idvyrobnicislo = i_idvyrobnihocisla);
        elsif(i_sarze is not null and i_expirace is not null) then
          -- pokud je zadana sarze i expirace
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu and sarze = i_sarze and expirace = i_expirace order by datVyst,idpolsklad) loop
            if(i_mnozMj > _mnozstvi) then
              _potrebnyPocet = _pomocDPolSkladF.pocet;
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then
                _potrebnyPocet = i_mnozMj - _mnozstvi;
              end if;
              _mnozstvi = _mnozstvi + _potrebnyPocet;
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj;
            end if;
          end loop;
          if(_mnozstvi != 0.0) then
            _result = _result / _mnozstvi;
          else
            _result = 0.0;
          end if;
        elsif(i_sarze is not null and i_expirace is null) then
          -- pokud je zadana jen sarze
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu and sarze = i_sarze order by datVyst,idpolsklad) loop
            if(i_mnozMj > _mnozstvi) then
              _potrebnyPocet = _pomocDPolSkladF.pocet;
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then
                _potrebnyPocet = i_mnozMj - _mnozstvi;
              end if;
              _mnozstvi = _mnozstvi + _potrebnyPocet;
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj;
            end if;
          end loop;
          if(_mnozstvi != 0.0) then
            _result = _result / _mnozstvi;
          else
            _result = 0.0;
          end if;
        elsif(i_sarze is null and i_expirace is not null) then
          -- pokud je zadana jen expirace
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu and expirace = i_expirace order by datVyst,idpolsklad) loop
            if(i_mnozMj > _mnozstvi) then
              _potrebnyPocet = _pomocDPolSkladF.pocet;
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then
                _potrebnyPocet = i_mnozMj - _mnozstvi;
              end if;
              _mnozstvi = _mnozstvi + _potrebnyPocet;
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj;
            end if;
          end loop;
          if(_mnozstvi != 0.0) then
            _result = _result / _mnozstvi;
          else
            _result = 0.0;
          end if;
        else
          -- pokud neni zadana ani sarze ani expirace ani vyrobni cislo
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu order by datVyst,idpolsklad) loop
            if(i_mnozMj >= _mnozstvi) then
              _potrebnyPocet = _pomocDPolSkladF.pocet;
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then
                _potrebnyPocet = i_mnozMj - _mnozstvi;
              end if;
              _mnozstvi = _mnozstvi + _potrebnyPocet;
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj;
            end if;
          end loop;
          if(_mnozstvi != 0.0) then
            _result = _result / _mnozstvi;
          else
            _result = 0.0;
          end if;
        end if;
      else
        -- generuji rozsirene polozky
        select * into _karta from skarty where idcenik = i_idcenik and idskladu = i_idskladu and iducetobdobi = _iducetobdobi;
        -- pokud neexistuje skladova karta pokusim se ji najit pomoci mapovani skladu
        if(_karta is null) then
          select idskupzboz into _idskupzboz from ccenik where idcenik = i_idcenik;
          select getPrefIdSkladu(i_idstred, _idskupzboz, i_idcenik) into _idSkladuPref;
          select * into _karta from skarty
            where idSkladu = _idSkladuPref and idCenik = i_idCenik and idUcetObdobi = _idUcetObdobi;
          if(_karta is null) then
            -- pokud ani podle mapovani skladu se skladova karta nenajde tak vyhazuju vyjimku
            select * into _cenik from ccenik where idCenik = i_idcenik;
            select * into _sklad from dbsp where idBsp = i_idSkladu;
            raise exception '0007:Skladová karta neexistuje pro ceník % a sklad % a nebo je špatně nastaveno mapovaní skladu.', _cenik.nazev, _sklad.nazev;
          end if;
        end if;

	if(_karta is null) then
	  raise exception 'Nenalezena sklad karta';
	end if;
        _sumTuz = 0.0;
        _mnozMj = 0.0;
        select sum(p.sumZkl), sum(p.mnozMj) into _sumSumZkl, _sumMnozMj from dPolSklad p, dDoklSklad d
          where p.idDoklSklad = d.idDoklSklad and p.idKarty = _karta.idKarty and d.typPohybuK = 'typPohybu.prijem' and p.datVyst > i_datum;
        if(_sumSumZkl is null) then
          _sumSumZkl = 0.0;
        end if;
        if(_sumMnozMj is null) then
          _sumMnozMj = 0.0;
        end if;
        _sumTuz = _sumTuz + _sumSumZkl;
        _mnozMj = _mnozMj + _sumMnozMj;

        select sum(p.sumZkl), sum(p.mnozMj) into _sumSumZkl, _sumMnozMj from dPolSklad p, dDoklSklad d
          where p.idDoklSklad = d.idDoklSklad and p.idKarty = _karta.idKarty and d.typPohybuK = 'typPohybu.vydej'and p.datVyst > i_datum;
        if(_sumSumZkl is null) then
          _sumSumZkl = 0.0;
        end if;
        if(_sumMnozMj is null) then
          _sumMnozMj = 0.0;
        end if;
        _sumTuz = _sumTuz - _sumSumZkl;
        _mnozMj = _mnozMj - _sumMnozMj;

        _sumTuz = _karta.stavTuz - _sumTuz;
        _mnozMj = _karta.stavMj - _mnozMj;
        if(_mnozMj = 0.0) then
          _result = 0.0;
        else
          _result = _sumTuz / _mnozMj;
        end if;
      end if;
    end if;
  end if;
  return _result;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, integer, integer) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 425, 't', %appVersion%, clock_timestamp());
