--------------------------------------------------------------------------------
-- Bug 22350 – [WinStrom] Pri generovani skladovych dokladu se nevyplnuje sumOsv
--------------------------------------------------------------------------------

-- Function: sprepoctisumydokladu(integer)
-- DROP FUNCTION sprepoctisumydokladu(integer);
CREATE OR REPLACE FUNCTION sprepoctisumydokladu(i_iddoklsklad integer)
  RETURNS void AS
$BODY$ 
declare 
 _sumZkl numeric(15,2);  
 _sumZklMen numeric(15,2);   
 _datVyst date;
begin 
 --select datVyst into _datVyst from dDoklSklad where idDoklSklad = i_idDoklSklad;
 --execute sprepoctisumydokladu(i_idDoklSklad, _datVyst);
 select sum(sumZkl), sum(sumZklMen) into _sumZkl, _sumZklMen from dPolSklad where idDoklSklad = i_idDoklSklad and stornoPol = false;
 if(_sumZkl is null) then _sumZkl = 0.0; end if;
 if(_sumZklMen is null) then _sumZklMen = 0.0; end if;
 update dDoklSklad set sumCelkem = _sumZkl, sumCelkemMen = _sumZklMen, sumOsv = _sumZkl, sumOsvMen = _sumZklMen where idDoklSklad = i_idDoklSklad;
end
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sprepoctisumydokladu(integer) OWNER TO %firmaRole%;



-- Function: sprepoctisumydokladu(integer, date)
-- DROP FUNCTION sprepoctisumydokladu(integer, date);
CREATE OR REPLACE FUNCTION sprepoctisumydokladu(i_iddoklsklad integer, i_datVyst date)
  RETURNS void AS
$BODY$
declare
 _sumZkl numeric(15,2);
 _sumZklMen numeric(15,2);
 _sumZklDoklad numeric(15,2);
 _sumZklMenDoklad numeric(15,2);
 _datVyst date;
 _datUcto date;
begin
 select sum(sumZkl), sum(sumZklMen) into _sumZkl, _sumZklMen from dPolSklad where idDoklSklad = i_idDoklSklad and stornoPol = false;
 select sumCelkem, sumCelkemMen, datVyst, datUcto into _sumZklDoklad, _sumZklMenDoklad, _datVyst, _datUcto from dDoklSklad where idDoklSklad = i_idDoklSklad;
 if(_sumZkl is null) then _sumZkl = 0.0; end if;
 if(_sumZklMen is null) then _sumZklMen = 0.0; end if;
 if(_sumZkl <> _sumZklDoklad or _sumZklMen <> _sumZklMenDoklad or not compareDate(i_datVyst, _datVyst) or not compareDate(i_datVyst, _datUcto)) then
   update dDoklSklad set lastUpdate = LOCALTIMESTAMP, sumCelkem = _sumZkl, sumCelkemMen = _sumZklMen, sumOsv = _sumZkl, sumOsvMen = _sumZklMen, datVyst = i_datVyst, datUcto = i_datVyst where idDoklSklad = i_idDoklSklad;
 end if;
end
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sprepoctisumydokladu(integer, date) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 440, 't', %appVersion%, clock_timestamp());
