--------------------------------------------------------------------------------
-- Bug 22942 – [winstrom] 1 - Objednávky přijaté - storno nezruší rezervace
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION dpolobchupdaterezer()
  RETURNS trigger AS $$
begin
  if NEW.storno = true then
    -- smazeme rezervaci pro polozku
    delete from srezervace where idpolobch = NEW.idpolobch;
    return NEW;
  end if;

  if NEW.idBspSkl is not null and NEW.rezervovat and NEW.storno = false then
    perform rezervujPolObch(NEW.idCenik, NEW.idBspSkl, NEW.idPolObch, NEW.rezervovatMj);
  end if;

  if (tg_op = 'UPDATE') then
    if OLD.idBspSkl is not null and OLD.rezervovat and OLD.storno = false then
      perform rezervujPolObch(OLD.idCenik, OLD.idBspSkl, OLD.idPolObch, -OLD.rezervovatMj);
    end if;
  end if;
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION dpolobchupdaterezer() OWNER TO %firmaRole%;

DELETE from srezervace where idpolobch in (select idpolobch from dpolobch where storno = true and modul = 'OBP');

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 452, 't', %appVersion%, clock_timestamp());
