--------------------------------------------------------------------------------
-- Bug 23339 – [WinStrom] Ukladani dokladu firmy Vizard trva i 5 minut
--------------------------------------------------------------------------------
CREATE OR REPLACE FUNCTION dpolskladupdaterealizovatelnost()
  RETURNS trigger AS
$BODY$ 
declare 
  ZAZNAM record; 
  _newMnozMj numeric(19,6);
  _oldMnozMj numeric(19,6);
begin

  if(tg_op = 'INSERT') then
    _newMnozMj = NEW.mnozMj;
    _oldMnozMj = 0.0;
    ZAZNAM := NEW;
  elsif(tg_op = 'UPDATE') then
    _newMnozMj = NEW.mnozMj;
    _oldMnozMj = OLD.mnozMj;
    ZAZNAM := NEW;
  else
    _newMnozMj = 0.0;
    _oldMnozMj = OLD.mnozMj;
    ZAZNAM := OLD;
  end if;

  if(comparenumeric(_newMnozMj, _oldMnozMj) = false) then
    update ddoklobch set procReal=obchodrealizovatelnost(idDoklObch) where (stavUzivK is null or stavUzivK <> 'stavDoklObch.hotovo') and idDoklObch in 
      (select iddoklobch from dpolobch where modul in ('PPP', 'NAV', 'OBP') and (mnozmj-mnozmjreal) > 0 and idcenik = ZAZNAM.idcenik); 
  end if;

  return ZAZNAM; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladupdaterealizovatelnost() OWNER TO %firmaRole%;


create index ddoklsklad_typpohybuk_index on ddoklsklad(typpohybuk);
create index ccenik_evidvyrcis_index on ccenik(evidvyrcis);


CREATE OR REPLACE VIEW dpolskladf AS
 --J.Svik - pohled, který nabízí příjemky k vyskladnění
 SELECT p.idpolsklad, p.mnozmj - jevydano(p.idpolsklad) AS pocet, p.cenamj, p.datvyst, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, NULL::unknown AS idvyrobnicislo, c.evidvyrcis
                  AS evidvyrcis
           FROM dpolskladdoklad p
	   INNER JOIN ccenik c ON c.idcenik = p.idcenik
          WHERE p.typpohybuk::text = 'typPohybu.prijem'::text AND (p.mnozmj - jevydano(p.idpolsklad)) > 0::numeric
          AND c.evidvyrcis = false AND p.storno <> true
UNION ALL
         SELECT p.idpolsklad, 1 AS pocet, p.cenamj, p.datvyst, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, v.idvyrobnicislo, c.evidvyrcis AS evidvyrcis
           FROM svyrobnicislo v
      INNER JOIN dpolskladdoklad p ON p.idpolsklad = v.idpolskladprijem
      INNER JOIN ccenik c ON c.idcenik 	= p.idcenik
     WHERE p.typpohybuk::text = 'typPohybu.prijem'::text AND c.evidvyrcis = true AND NOT (v.idvyrobnicislo IN ( SELECT sfifovazby.idvyrobnicislo
              FROM sfifovazby
             WHERE sfifovazby.idpolskladprijem = p.idpolsklad)) AND p.storno <> true;
ALTER TABLE dpolskladf OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 464, 't', %appVersion%, clock_timestamp());
