--------------------------------------------------------------------------------
-- Bug 23752 – [winstrom10] mzdy - oprava vyměřovacího základu ZP
--------------------------------------------------------------------------------

ALTER TABLE posoba ADD COLUMN snizvymzaklzp boolean DEFAULT false;

--------------------------------------------------------------------------------
-- Bug 21936 – [winstrom] 7 - Mzdy - špatně počítaný svátek
-- Bug 22325 – [winstrom] 9 -Mzdy - text u položek náhrady mzdy je matoucí
-- Bug 23502 – [winstrom] - Mzdy - počítat ZP pro st.prac.pom.-zam.malého rozsahu
--------------------------------------------------------------------------------

create or replace function runupgrade()
    returns void as $$
declare
    stat character varying(10);
    pocet integer;
begin
  select a.uuid into stat from nnastav n  left join utyporg u on u.idtyporg = n.idtyporg left join astaty a on a.idstatu = u.idstatu
    where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);
  
  -- kalkulacku aktualizujeme jen pro cechy
  if (stat = 'CZ_CZ') then
-- zacatek ceskeho bloku
-- update slozek
ALTER TABLE pmzdsloz DISABLE TRIGGER pmzdslozupdatedatumvypoctu;

UPDATE pcismzdsloz SET vyznamk = null WHERE idcismzdsloz = 2;
UPDATE pcismzdsloz SET vyznamk = 'vyznamSlozky.dobaNeodpr' WHERE idcismzdsloz = 16;
UPDATE pcismzdsloz SET vshodiny = true, vshodinysvatek = true, vscastnahod = true WHERE idcismzdsloz = 21;
UPDATE pcismzdsloz SET nazev = 'Náhrada mzdy za nemoc  - první 3 pracovní dny / směny (část z 21 kalendářních dnů) ' WHERE idcismzdsloz = 69;
UPDATE pcismzdsloz SET nazev = 'Superhrubá mzda  (základ pro výpočet daně)' WHERE idcismzdsloz = 107;
UPDATE pcismzdsloz SET nazev = 'Náhrada mzdy za karanténu - první 3 pracovní dny / směny (část z 21 kalendářních dnů) ' WHERE idcismzdsloz = 171;
UPDATE pcismzdsloz SET nazev = 'Doplacení rozdílu nad 24 hodin za 1. 3 dny / směny' WHERE idcismzdsloz = 232;
UPDATE pcismzdsloz SET uuid = 'ISPV PRESCAS' WHERE idcismzdsloz = 313;
UPDATE pcismzdsloz SET nazev = 'Náhrada za karanténu - za 4. až 15. pracovní den / směnu (část z 21 kalendářních dnů) ' WHERE idcismzdsloz = 337;
UPDATE pcismzdsloz SET nazev = 'Náhrada za nemoc - za 4. až 15. pracovní den / směnu  / směny (část z 21 kalendářních dnů) ' WHERE idcismzdsloz = 338;
UPDATE pcismzdsloz SET cisrad = 1145, paskavelka = true, paskamala = true WHERE idcismzdsloz = 339;
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, show, cisrad, typslozkyk, skupslozkyk, naosobu, vsdatod, vsdatdo, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vshodinysvatek, vscastnahod, vscastnaden, vsprocmzd, vszaklmzd, vszakljekracen, vscastmzd, vszmenacastmzd, vspocetmes, vscisdoklnem, vsdoplatzdrpoj, vsprumnadennem, vsprumnahodnem, dnyprac, dnykal, dnysvatek, hodiny, castkahod, castkaden, procmzd, zaklmzd, zakljekracen, castmzd, zmenacastmzd, prumnadennem, prumnahodnem, pracovni, ukladatnulove, paskamala, paskavelka, zapoctovylist, uuid)
 VALUES (343, '2011-05-05 00:00:00.000', 'SVÁTEK V NEMOCI', 'svátek sumovaná z nemoci', true, 1, 'typSlozky.vypocet', 'skupinaSlozky.nepritomnost', false, false, false, false, false, true, false, true, false, false, false, false, false, false, false, false, false, false, false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, false, 0.0, false, 0.0, 0.0, true, false, false, false, false, 'SVATEK_V_NEMOCI');
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, show, typslozkyk, skupslozkyk, naosobu, vsdatod, vsdatdo, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vshodinysvatek, vscastnahod, vscastnaden, vsprocmzd, vszaklmzd, vszakljekracen, vscastmzd, vszmenacastmzd, vspocetmes, vscisdoklnem, vsdoplatzdrpoj, vsprumnadennem, vsprumnahodnem, dnyprac, dnykal, dnysvatek, hodiny, castkahod, castkaden, procmzd, zaklmzd, zakljekracen, castmzd, zmenacastmzd, prumnadennem, prumnahodnem, pracovni, ukladatnulove, paskamala, paskavelka, zapoctovylist, uuid)
 VALUES (344, '2011-05-11 00:00:00.000', 'ODPOČET ZÁKLADU ZP', 'Snížení vyměřovacího základu ZP (Zákon č. 592/1992 Sb., § 3 - Vyměřovací základ, odstavec 7) ', true, 'typSlozky.vypocet', 'skupinaSlozky.zdravPoj', true, false, false, false, false, false, false, false, false, false, true, true, false, false, true, false, false, false, false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, false, 0.0, false, 0.0, 0.0, false, true, false, false, false, 'ODPOCET_ZAKLADU_ZP');
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, show, cisrad, typslozkyk, skupslozkyk, naosobu, vsdatod, vsdatdo, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vshodinysvatek, vscastnahod, vscastnaden, vsprocmzd, vszaklmzd, vszakljekracen, vscastmzd, vszmenacastmzd, vspocetmes, vscisdoklnem, vsdoplatzdrpoj, vsprumnadennem, vsprumnahodnem, vyznamk, dnyprac, dnykal, dnysvatek, hodiny, castkahod, castkaden, procmzd, zaklmzd, zakljekracen, castmzd, zmenacastmzd, prumnadennem, prumnahodnem, pracovni, ukladatnulove, paskamala, paskavelka, paskapole, zapoctovylist, uuid)
 VALUES (346, '2011-05-11 00:00:00.000', 'DOVOLENÁ CELKEM', 'Celková dovolená zaokrouhlená na Kč nahoru', true, 2002, 'typSlozky.vypocet', 'skupinaSlozky.nepritomnost', false, true, true, true, true, true, true, true, true, false, false, false, false, false, false, false, false, false, false, false, 'vyznamSlozky.dobaDovol', 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, false, 0.0, false, 0.0, 0.0, false, false, true, true, 'hodiny;castMzd', false, 'DOVOLENA_CELKEM');

PERFORM pg_catalog.setval('seq_pcismzdsloz', 346, true);

ALTER TABLE pmzdsloz ENABLE TRIGGER pmzdslozupdatedatumvypoctu;

-- update hlavicky kalkulacky
UPDATE pmzdcalchlav SET poznam = 'vyřazení nulování zdravotky pro zaměstnání malého rozsahu u \nstandardního pracovního poměru - pořadí 50' WHERE idmzdcalchlav = 2;

-- update inicializacnich radek kalkulacky
INSERT INTO pmzdcalcinit (idmzdcalcinit, lastupdate, kod, nazev, show, cisrad, zdrojk, polein, poleout, platnostk, idmzdcalchlav, idmzdslozout)
 VALUES (49, '2011-05-11 00:00:00.000', 'ODPOČET ZÁKLADU ZP', 'odpočet pro kryply', true, 8, 'mzdCalcZdroj.osoba', 'snizVymZaklZp', 'procMzd', 'mzdCalcPlatnost.vzdy', 2, 344);

PERFORM pg_catalog.setval('seq_pmzdcalcinit', 49, true);

-- update radek kalkulacky
DELETE FROM pmzdcalc WHERE idmzdcalc = 1435;
UPDATE pmzdcalc SET kod = 'SVÁTEK V NEMOCI', cisrad = 6, koeficient = 1.0, idmzdslozout = 343 WHERE idmzdcalc = 1004;
UPDATE pmzdcalc SET cisrad = 5 WHERE idmzdcalc = 1005;
UPDATE pmzdcalc SET kod = 'SVÁTEK V NEMOCI', koeficient = 1.0, idmzdslozout = 343 WHERE idmzdcalc = 1007;
UPDATE pmzdcalc SET popis = 'do hodinySvatek nekopirujeme - dostava nahradu mzdy za svatek a ne dovolenou', cisrad = 31, polein = 'dnySvatek;dnySvatek;hodinySvatek', poleout = 'dnySvatek;dnyPrac;hodiny' WHERE idmzdcalc = 1008;
UPDATE pmzdcalc SET kod = 'SVÁTEK V NEMOCI', cisrad = 9, koeficient = 1.0, idmzdslozout = 343 WHERE idmzdcalc = 1009;
UPDATE pmzdcalc SET kod = 'SVÁTEK V NEMOCI', cisrad = 10, koeficient = 1.0, idmzdslozout = 343 WHERE idmzdcalc = 1010;
UPDATE pmzdcalc SET kod = 'SVÁTEK V NEMOCI', cisrad = 11, koeficient = 1.0, idmzdslozout = 343 WHERE idmzdcalc = 1011;
UPDATE pmzdcalc SET kod = 'SVÁTEK V NEMOCI', cisrad = 12, koeficient = 1.0, idmzdslozout = 343 WHERE idmzdcalc = 1012;
UPDATE pmzdcalc SET kod = 'SVÁTEK V NEMOCI', cisrad = 13, koeficient = 1.0, idmzdslozout = 343 WHERE idmzdcalc = 1013;
UPDATE pmzdcalc SET kod = 'SVÁTEK V NEMOCI', cisrad = 14, koeficient = 1.0, idmzdslozout = 343 WHERE idmzdcalc = 1014;
UPDATE pmzdcalc SET kod = 'SVÁTEK V NEMOCI', cisrad = 15, koeficient = 1.0, idmzdslozout = 343 WHERE idmzdcalc = 1015;
UPDATE pmzdcalc SET kod = 'SVÁTEK V NEMOCI', cisrad = 16, koeficient = 1.0, idmzdslozout = 343 WHERE idmzdcalc = 1016;
UPDATE pmzdcalc SET kod = 'SVÁTEK V NEMOCI', cisrad = 17, koeficient = 1.0, idmzdslozout = 343 WHERE idmzdcalc = 1017;
UPDATE pmzdcalc SET kod = 'SVÁTEK V NEMOCI', cisrad = 18, koeficient = 1.0, idmzdslozout = 343 WHERE idmzdcalc = 1018;
UPDATE pmzdcalc SET kod = 'SVÁTEK V NEMOCI', cisrad = 19, koeficient = 1.0, idmzdslozout = 343 WHERE idmzdcalc = 1019;
UPDATE pmzdcalc SET kod = 'SVÁTEK V NEMOCI', cisrad = 20, koeficient = 1.0, idmzdslozout = 343 WHERE idmzdcalc = 1020;
UPDATE pmzdcalc SET kod = 'SVÁTEK V NEMOCI', cisrad = 21, koeficient = 1.0, idmzdslozout = 343 WHERE idmzdcalc = 1021;
UPDATE pmzdcalc SET kod = 'SVÁTEK V NEMOCI', cisrad = 22, koeficient = 1.0, idmzdslozout = 343 WHERE idmzdcalc = 1022;
UPDATE pmzdcalc SET kod = 'SVÁTEK V NEMOCI', cisrad = 23, koeficient = 1.0, idmzdslozout = 343 WHERE idmzdcalc = 1023;
UPDATE pmzdcalc SET kod = 'SVÁTEK V NEMOCI', cisrad = 24, koeficient = 1.0, idmzdslozout = 343 WHERE idmzdcalc = 1024;
UPDATE pmzdcalc SET kod = 'SVÁTEK V NEMOCI', cisrad = 25, koeficient = 1.0, idmzdslozout = 343 WHERE idmzdcalc = 1025;
UPDATE pmzdcalc SET kod = 'SVÁTEK V NEMOCI', cisrad = 26, koeficient = 1.0, idmzdslozout = 343 WHERE idmzdcalc = 1026;
UPDATE pmzdcalc SET kod = 'SVÁTEK V NEMOCI', cisrad = 27, koeficient = 1.0, idmzdslozout = 343 WHERE idmzdcalc = 1027;
UPDATE pmzdcalc SET kod = 'SVÁTEK V NEMOCI', cisrad = 28, koeficient = 1.0, idmzdslozout = 343 WHERE idmzdcalc = 1028;
UPDATE pmzdcalc SET kod = 'SVÁTEK V NEMOCI', cisrad = 29, koeficient = 1.0, idmzdslozout = 343 WHERE idmzdcalc = 1029;
UPDATE pmzdcalc SET cisrad = 32 WHERE idmzdcalc = 1030;
UPDATE pmzdcalc SET cisrad = 33 WHERE idmzdcalc = 1031;
UPDATE pmzdcalc SET cisrad = 34 WHERE idmzdcalc = 1032;
UPDATE pmzdcalc SET cisrad = 35 WHERE idmzdcalc = 1033;
UPDATE pmzdcalc SET cisrad = 36 WHERE idmzdcalc = 1034;
UPDATE pmzdcalc SET cisrad = 37 WHERE idmzdcalc = 1035;
UPDATE pmzdcalc SET cisrad = 38 WHERE idmzdcalc = 1036;
UPDATE pmzdcalc SET cisrad = 39 WHERE idmzdcalc = 1037;
UPDATE pmzdcalc SET cisrad = 40 WHERE idmzdcalc = 1038;
UPDATE pmzdcalc SET cisrad = 41 WHERE idmzdcalc = 1039;
UPDATE pmzdcalc SET cisrad = 42 WHERE idmzdcalc = 1040;
UPDATE pmzdcalc SET cisrad = 43 WHERE idmzdcalc = 1041;
UPDATE pmzdcalc SET cisrad = 44 WHERE idmzdcalc = 1042;
UPDATE pmzdcalc SET cisrad = 45 WHERE idmzdcalc = 1043;
UPDATE pmzdcalc SET cisrad = 46 WHERE idmzdcalc = 1044;
UPDATE pmzdcalc SET cisrad = 47 WHERE idmzdcalc = 1045;
UPDATE pmzdcalc SET cisrad = 48 WHERE idmzdcalc = 1046;
UPDATE pmzdcalc SET cisrad = 49 WHERE idmzdcalc = 1047;
UPDATE pmzdcalc SET cisrad = 50 WHERE idmzdcalc = 1048;
UPDATE pmzdcalc SET cisrad = 51 WHERE idmzdcalc = 1049;
UPDATE pmzdcalc SET cisrad = 53 WHERE idmzdcalc = 1050;
UPDATE pmzdcalc SET cisrad = 54, zaokrjakk = null, zaokrnak = null WHERE idmzdcalc = 1051;
UPDATE pmzdcalc SET cisrad = 56 WHERE idmzdcalc = 1052;
UPDATE pmzdcalc SET cisrad = 52 WHERE idmzdcalc = 1053;
UPDATE pmzdcalc SET cisrad = 57 WHERE idmzdcalc = 1054;
UPDATE pmzdcalc SET cisrad = 58 WHERE idmzdcalc = 1055;
UPDATE pmzdcalc SET cisrad = 59 WHERE idmzdcalc = 1056;
UPDATE pmzdcalc SET cisrad = 60 WHERE idmzdcalc = 1057;
UPDATE pmzdcalc SET cisrad = 61 WHERE idmzdcalc = 1058;
UPDATE pmzdcalc SET cisrad = 62 WHERE idmzdcalc = 1059;
UPDATE pmzdcalc SET cisrad = 63 WHERE idmzdcalc = 1060;
UPDATE pmzdcalc SET cisrad = 64 WHERE idmzdcalc = 1061;
UPDATE pmzdcalc SET cisrad = 65 WHERE idmzdcalc = 1062;
UPDATE pmzdcalc SET cisrad = 66 WHERE idmzdcalc = 1063;
UPDATE pmzdcalc SET cisrad = 67 WHERE idmzdcalc = 1064;
UPDATE pmzdcalc SET cisrad = 68 WHERE idmzdcalc = 1065;
UPDATE pmzdcalc SET cisrad = 69 WHERE idmzdcalc = 1066;
UPDATE pmzdcalc SET cisrad = 70 WHERE idmzdcalc = 1067;
UPDATE pmzdcalc SET cisrad = 71 WHERE idmzdcalc = 1068;
UPDATE pmzdcalc SET cisrad = 72 WHERE idmzdcalc = 1069;
UPDATE pmzdcalc SET cisrad = 73 WHERE idmzdcalc = 1070;
UPDATE pmzdcalc SET cisrad = 74 WHERE idmzdcalc = 1071;
UPDATE pmzdcalc SET cisrad = 75 WHERE idmzdcalc = 1072;
UPDATE pmzdcalc SET cisrad = 76 WHERE idmzdcalc = 1073;
UPDATE pmzdcalc SET cisrad = 77 WHERE idmzdcalc = 1074;
UPDATE pmzdcalc SET cisrad = 78 WHERE idmzdcalc = 1075;
UPDATE pmzdcalc SET cisrad = 79 WHERE idmzdcalc = 1076;
UPDATE pmzdcalc SET cisrad = 80 WHERE idmzdcalc = 1077;
UPDATE pmzdcalc SET cisrad = 81 WHERE idmzdcalc = 1078;
UPDATE pmzdcalc SET cisrad = 82 WHERE idmzdcalc = 1079;
UPDATE pmzdcalc SET cisrad = 83 WHERE idmzdcalc = 1080;
UPDATE pmzdcalc SET cisrad = 84 WHERE idmzdcalc = 1081;
UPDATE pmzdcalc SET cisrad = 85 WHERE idmzdcalc = 1082;
UPDATE pmzdcalc SET cisrad = 86 WHERE idmzdcalc = 1083;
UPDATE pmzdcalc SET cisrad = 87 WHERE idmzdcalc = 1084;
UPDATE pmzdcalc SET cisrad = 88 WHERE idmzdcalc = 1085;
UPDATE pmzdcalc SET cisrad = 89 WHERE idmzdcalc = 1086;
UPDATE pmzdcalc SET cisrad = 90 WHERE idmzdcalc = 1087;
UPDATE pmzdcalc SET cisrad = 91 WHERE idmzdcalc = 1088;
UPDATE pmzdcalc SET cisrad = 92 WHERE idmzdcalc = 1089;
UPDATE pmzdcalc SET cisrad = 93 WHERE idmzdcalc = 1090;
UPDATE pmzdcalc SET cisrad = 94 WHERE idmzdcalc = 1091;
UPDATE pmzdcalc SET cisrad = 95 WHERE idmzdcalc = 1092;
UPDATE pmzdcalc SET cisrad = 96 WHERE idmzdcalc = 1093;
UPDATE pmzdcalc SET cisrad = 97 WHERE idmzdcalc = 1094;
UPDATE pmzdcalc SET cisrad = 98 WHERE idmzdcalc = 1095;
UPDATE pmzdcalc SET cisrad = 99 WHERE idmzdcalc = 1096;
UPDATE pmzdcalc SET cisrad = 100 WHERE idmzdcalc = 1097;
UPDATE pmzdcalc SET cisrad = 101 WHERE idmzdcalc = 1098;
UPDATE pmzdcalc SET cisrad = 102 WHERE idmzdcalc = 1099;
UPDATE pmzdcalc SET cisrad = 103 WHERE idmzdcalc = 1100;
UPDATE pmzdcalc SET cisrad = 104 WHERE idmzdcalc = 1101;
UPDATE pmzdcalc SET cisrad = 105 WHERE idmzdcalc = 1102;
UPDATE pmzdcalc SET cisrad = 106 WHERE idmzdcalc = 1103;
UPDATE pmzdcalc SET cisrad = 107 WHERE idmzdcalc = 1104;
UPDATE pmzdcalc SET cisrad = 108 WHERE idmzdcalc = 1105;
UPDATE pmzdcalc SET cisrad = 109 WHERE idmzdcalc = 1106;
UPDATE pmzdcalc SET cisrad = 110 WHERE idmzdcalc = 1107;
UPDATE pmzdcalc SET cisrad = 111 WHERE idmzdcalc = 1108;
UPDATE pmzdcalc SET cisrad = 112 WHERE idmzdcalc = 1109;
UPDATE pmzdcalc SET cisrad = 113 WHERE idmzdcalc = 1110;
UPDATE pmzdcalc SET cisrad = 114 WHERE idmzdcalc = 1111;
UPDATE pmzdcalc SET cisrad = 115 WHERE idmzdcalc = 1112;
UPDATE pmzdcalc SET cisrad = 116 WHERE idmzdcalc = 1113;
UPDATE pmzdcalc SET cisrad = 117 WHERE idmzdcalc = 1114;
UPDATE pmzdcalc SET cisrad = 118 WHERE idmzdcalc = 1115;
UPDATE pmzdcalc SET cisrad = 119 WHERE idmzdcalc = 1116;
UPDATE pmzdcalc SET cisrad = 120 WHERE idmzdcalc = 1117;
UPDATE pmzdcalc SET cisrad = 121 WHERE idmzdcalc = 1118;
UPDATE pmzdcalc SET cisrad = 122 WHERE idmzdcalc = 1119;
UPDATE pmzdcalc SET cisrad = 123 WHERE idmzdcalc = 1120;
UPDATE pmzdcalc SET cisrad = 124 WHERE idmzdcalc = 1121;
UPDATE pmzdcalc SET cisrad = 125 WHERE idmzdcalc = 1122;
UPDATE pmzdcalc SET cisrad = 126 WHERE idmzdcalc = 1123;
UPDATE pmzdcalc SET cisrad = 127 WHERE idmzdcalc = 1124;
UPDATE pmzdcalc SET cisrad = 128 WHERE idmzdcalc = 1125;
UPDATE pmzdcalc SET cisrad = 129 WHERE idmzdcalc = 1126;
UPDATE pmzdcalc SET cisrad = 130 WHERE idmzdcalc = 1127;
UPDATE pmzdcalc SET cisrad = 131 WHERE idmzdcalc = 1128;
UPDATE pmzdcalc SET cisrad = 132 WHERE idmzdcalc = 1129;
UPDATE pmzdcalc SET cisrad = 133 WHERE idmzdcalc = 1130;
UPDATE pmzdcalc SET cisrad = 134 WHERE idmzdcalc = 1131;
UPDATE pmzdcalc SET cisrad = 135 WHERE idmzdcalc = 1132;
UPDATE pmzdcalc SET cisrad = 136 WHERE idmzdcalc = 1133;
UPDATE pmzdcalc SET cisrad = 137 WHERE idmzdcalc = 1134;
UPDATE pmzdcalc SET cisrad = 138 WHERE idmzdcalc = 1135;
UPDATE pmzdcalc SET cisrad = 139 WHERE idmzdcalc = 1136;
UPDATE pmzdcalc SET cisrad = 140 WHERE idmzdcalc = 1137;
UPDATE pmzdcalc SET cisrad = 141 WHERE idmzdcalc = 1138;
UPDATE pmzdcalc SET cisrad = 142 WHERE idmzdcalc = 1139;
UPDATE pmzdcalc SET cisrad = 143 WHERE idmzdcalc = 1140;
UPDATE pmzdcalc SET cisrad = 144 WHERE idmzdcalc = 1141;
UPDATE pmzdcalc SET cisrad = 145 WHERE idmzdcalc = 1142;
UPDATE pmzdcalc SET cisrad = 146 WHERE idmzdcalc = 1143;
UPDATE pmzdcalc SET cisrad = 147 WHERE idmzdcalc = 1144;
UPDATE pmzdcalc SET cisrad = 148 WHERE idmzdcalc = 1145;
UPDATE pmzdcalc SET cisrad = 149 WHERE idmzdcalc = 1146;
UPDATE pmzdcalc SET cisrad = 150 WHERE idmzdcalc = 1147;
UPDATE pmzdcalc SET cisrad = 151 WHERE idmzdcalc = 1148;
UPDATE pmzdcalc SET cisrad = 152 WHERE idmzdcalc = 1149;
UPDATE pmzdcalc SET cisrad = 153 WHERE idmzdcalc = 1150;
UPDATE pmzdcalc SET cisrad = 154 WHERE idmzdcalc = 1151;
UPDATE pmzdcalc SET cisrad = 155 WHERE idmzdcalc = 1152;
UPDATE pmzdcalc SET cisrad = 156 WHERE idmzdcalc = 1153;
UPDATE pmzdcalc SET cisrad = 157 WHERE idmzdcalc = 1154;
UPDATE pmzdcalc SET cisrad = 158 WHERE idmzdcalc = 1155;
UPDATE pmzdcalc SET cisrad = 159 WHERE idmzdcalc = 1156;
UPDATE pmzdcalc SET cisrad = 160 WHERE idmzdcalc = 1157;
UPDATE pmzdcalc SET cisrad = 161 WHERE idmzdcalc = 1158;
UPDATE pmzdcalc SET cisrad = 162 WHERE idmzdcalc = 1159;
UPDATE pmzdcalc SET cisrad = 163 WHERE idmzdcalc = 1160;
UPDATE pmzdcalc SET cisrad = 164 WHERE idmzdcalc = 1161;
UPDATE pmzdcalc SET cisrad = 165 WHERE idmzdcalc = 1162;
UPDATE pmzdcalc SET cisrad = 166 WHERE idmzdcalc = 1163;
UPDATE pmzdcalc SET cisrad = 167 WHERE idmzdcalc = 1164;
UPDATE pmzdcalc SET cisrad = 168 WHERE idmzdcalc = 1165;
UPDATE pmzdcalc SET cisrad = 169 WHERE idmzdcalc = 1166;
UPDATE pmzdcalc SET cisrad = 170 WHERE idmzdcalc = 1167;
UPDATE pmzdcalc SET cisrad = 171 WHERE idmzdcalc = 1168;
UPDATE pmzdcalc SET cisrad = 172 WHERE idmzdcalc = 1169;
UPDATE pmzdcalc SET cisrad = 173 WHERE idmzdcalc = 1170;
UPDATE pmzdcalc SET cisrad = 174 WHERE idmzdcalc = 1171;
UPDATE pmzdcalc SET cisrad = 175 WHERE idmzdcalc = 1172;
UPDATE pmzdcalc SET cisrad = 176 WHERE idmzdcalc = 1173;
UPDATE pmzdcalc SET cisrad = 177 WHERE idmzdcalc = 1174;
UPDATE pmzdcalc SET cisrad = 178 WHERE idmzdcalc = 1175;
UPDATE pmzdcalc SET cisrad = 179 WHERE idmzdcalc = 1176;
UPDATE pmzdcalc SET cisrad = 180 WHERE idmzdcalc = 1177;
UPDATE pmzdcalc SET cisrad = 181 WHERE idmzdcalc = 1178;
UPDATE pmzdcalc SET cisrad = 182 WHERE idmzdcalc = 1179;
UPDATE pmzdcalc SET cisrad = 183 WHERE idmzdcalc = 1180;
UPDATE pmzdcalc SET cisrad = 184 WHERE idmzdcalc = 1181;
UPDATE pmzdcalc SET cisrad = 185 WHERE idmzdcalc = 1182;
UPDATE pmzdcalc SET cisrad = 186 WHERE idmzdcalc = 1183;
UPDATE pmzdcalc SET cisrad = 187 WHERE idmzdcalc = 1184;
UPDATE pmzdcalc SET cisrad = 188 WHERE idmzdcalc = 1185;
UPDATE pmzdcalc SET cisrad = 189 WHERE idmzdcalc = 1186;
UPDATE pmzdcalc SET cisrad = 190 WHERE idmzdcalc = 1187;
UPDATE pmzdcalc SET cisrad = 191 WHERE idmzdcalc = 1188;
UPDATE pmzdcalc SET cisrad = 192 WHERE idmzdcalc = 1189;
UPDATE pmzdcalc SET kod = 'DOVOLENÁ', popis = '!!!!!!!!!!!!  11.5. zrušeno zaokrouhlování - test', cisrad = 193, zaokrjakk = null, zaokrnak = null WHERE idmzdcalc = 1190;
UPDATE pmzdcalc SET nazev = 'Celková dovolená zaokrouhlená na Kč nahoru', cisrad = 196, idmzdslozin = 346 WHERE idmzdcalc = 1191;
UPDATE pmzdcalc SET cisrad = 197 WHERE idmzdcalc = 1192;
UPDATE pmzdcalc SET cisrad = 198 WHERE idmzdcalc = 1193;
UPDATE pmzdcalc SET cisrad = 199 WHERE idmzdcalc = 1194;
UPDATE pmzdcalc SET cisrad = 200 WHERE idmzdcalc = 1195;
UPDATE pmzdcalc SET cisrad = 201 WHERE idmzdcalc = 1196;
UPDATE pmzdcalc SET cisrad = 202 WHERE idmzdcalc = 1197;
UPDATE pmzdcalc SET cisrad = 203 WHERE idmzdcalc = 1198;
UPDATE pmzdcalc SET cisrad = 204 WHERE idmzdcalc = 1199;
UPDATE pmzdcalc SET cisrad = 205 WHERE idmzdcalc = 1200;
UPDATE pmzdcalc SET cisrad = 206 WHERE idmzdcalc = 1201;
UPDATE pmzdcalc SET cisrad = 207 WHERE idmzdcalc = 1202;
UPDATE pmzdcalc SET cisrad = 208 WHERE idmzdcalc = 1203;
UPDATE pmzdcalc SET cisrad = 209 WHERE idmzdcalc = 1204;
UPDATE pmzdcalc SET cisrad = 210 WHERE idmzdcalc = 1205;
UPDATE pmzdcalc SET cisrad = 211 WHERE idmzdcalc = 1206;
UPDATE pmzdcalc SET cisrad = 212 WHERE idmzdcalc = 1207;
UPDATE pmzdcalc SET cisrad = 213 WHERE idmzdcalc = 1208;
UPDATE pmzdcalc SET cisrad = 214 WHERE idmzdcalc = 1209;
UPDATE pmzdcalc SET cisrad = 215 WHERE idmzdcalc = 1210;
UPDATE pmzdcalc SET cisrad = 216 WHERE idmzdcalc = 1211;
UPDATE pmzdcalc SET cisrad = 217 WHERE idmzdcalc = 1212;
UPDATE pmzdcalc SET cisrad = 218 WHERE idmzdcalc = 1213;
UPDATE pmzdcalc SET cisrad = 219 WHERE idmzdcalc = 1214;
UPDATE pmzdcalc SET cisrad = 220 WHERE idmzdcalc = 1215;
UPDATE pmzdcalc SET cisrad = 221 WHERE idmzdcalc = 1216;
UPDATE pmzdcalc SET cisrad = 222 WHERE idmzdcalc = 1217;
UPDATE pmzdcalc SET cisrad = 223 WHERE idmzdcalc = 1218;
UPDATE pmzdcalc SET cisrad = 224 WHERE idmzdcalc = 1219;
UPDATE pmzdcalc SET cisrad = 225 WHERE idmzdcalc = 1220;
UPDATE pmzdcalc SET cisrad = 226 WHERE idmzdcalc = 1221;
UPDATE pmzdcalc SET cisrad = 227 WHERE idmzdcalc = 1222;
UPDATE pmzdcalc SET cisrad = 228 WHERE idmzdcalc = 1223;
UPDATE pmzdcalc SET cisrad = 229 WHERE idmzdcalc = 1224;
UPDATE pmzdcalc SET cisrad = 230 WHERE idmzdcalc = 1225;
UPDATE pmzdcalc SET cisrad = 231 WHERE idmzdcalc = 1226;
UPDATE pmzdcalc SET cisrad = 232 WHERE idmzdcalc = 1227;
UPDATE pmzdcalc SET cisrad = 233 WHERE idmzdcalc = 1228;
UPDATE pmzdcalc SET cisrad = 234 WHERE idmzdcalc = 1229;
UPDATE pmzdcalc SET cisrad = 235 WHERE idmzdcalc = 1230;
UPDATE pmzdcalc SET cisrad = 236 WHERE idmzdcalc = 1231;
UPDATE pmzdcalc SET cisrad = 237 WHERE idmzdcalc = 1232;
UPDATE pmzdcalc SET cisrad = 238 WHERE idmzdcalc = 1233;
UPDATE pmzdcalc SET cisrad = 239 WHERE idmzdcalc = 1234;
UPDATE pmzdcalc SET cisrad = 240 WHERE idmzdcalc = 1235;
UPDATE pmzdcalc SET cisrad = 241 WHERE idmzdcalc = 1236;
UPDATE pmzdcalc SET cisrad = 242 WHERE idmzdcalc = 1237;
UPDATE pmzdcalc SET cisrad = 243 WHERE idmzdcalc = 1238;
UPDATE pmzdcalc SET cisrad = 244 WHERE idmzdcalc = 1239;
UPDATE pmzdcalc SET cisrad = 245 WHERE idmzdcalc = 1240;
UPDATE pmzdcalc SET cisrad = 246 WHERE idmzdcalc = 1241;
UPDATE pmzdcalc SET cisrad = 247 WHERE idmzdcalc = 1242;
UPDATE pmzdcalc SET cisrad = 248 WHERE idmzdcalc = 1243;
UPDATE pmzdcalc SET cisrad = 249 WHERE idmzdcalc = 1244;
UPDATE pmzdcalc SET cisrad = 250 WHERE idmzdcalc = 1245;
UPDATE pmzdcalc SET cisrad = 251 WHERE idmzdcalc = 1246;
UPDATE pmzdcalc SET cisrad = 252 WHERE idmzdcalc = 1247;
UPDATE pmzdcalc SET cisrad = 253 WHERE idmzdcalc = 1248;
UPDATE pmzdcalc SET cisrad = 254 WHERE idmzdcalc = 1249;
UPDATE pmzdcalc SET cisrad = 255 WHERE idmzdcalc = 1250;
UPDATE pmzdcalc SET cisrad = 256 WHERE idmzdcalc = 1251;
UPDATE pmzdcalc SET cisrad = 257 WHERE idmzdcalc = 1252;
UPDATE pmzdcalc SET cisrad = 258 WHERE idmzdcalc = 1253;
UPDATE pmzdcalc SET cisrad = 259 WHERE idmzdcalc = 1254;
UPDATE pmzdcalc SET cisrad = 260 WHERE idmzdcalc = 1255;
UPDATE pmzdcalc SET cisrad = 261 WHERE idmzdcalc = 1256;
UPDATE pmzdcalc SET cisrad = 262 WHERE idmzdcalc = 1257;
UPDATE pmzdcalc SET cisrad = 263 WHERE idmzdcalc = 1258;
UPDATE pmzdcalc SET cisrad = 264 WHERE idmzdcalc = 1259;
UPDATE pmzdcalc SET cisrad = 265 WHERE idmzdcalc = 1260;
UPDATE pmzdcalc SET cisrad = 266 WHERE idmzdcalc = 1261;
UPDATE pmzdcalc SET cisrad = 267 WHERE idmzdcalc = 1262;
UPDATE pmzdcalc SET cisrad = 268 WHERE idmzdcalc = 1263;
UPDATE pmzdcalc SET cisrad = 270 WHERE idmzdcalc = 1264;
UPDATE pmzdcalc SET cisrad = 271 WHERE idmzdcalc = 1265;
UPDATE pmzdcalc SET cisrad = 272 WHERE idmzdcalc = 1266;
UPDATE pmzdcalc SET cisrad = 273 WHERE idmzdcalc = 1267;
UPDATE pmzdcalc SET cisrad = 274 WHERE idmzdcalc = 1268;
UPDATE pmzdcalc SET cisrad = 275 WHERE idmzdcalc = 1269;
UPDATE pmzdcalc SET cisrad = 276 WHERE idmzdcalc = 1270;
UPDATE pmzdcalc SET cisrad = 277 WHERE idmzdcalc = 1271;
UPDATE pmzdcalc SET cisrad = 278 WHERE idmzdcalc = 1272;
UPDATE pmzdcalc SET cisrad = 279 WHERE idmzdcalc = 1273;
UPDATE pmzdcalc SET cisrad = 280 WHERE idmzdcalc = 1274;
UPDATE pmzdcalc SET cisrad = 281 WHERE idmzdcalc = 1275;
UPDATE pmzdcalc SET cisrad = 282 WHERE idmzdcalc = 1276;
UPDATE pmzdcalc SET cisrad = 283 WHERE idmzdcalc = 1277;
UPDATE pmzdcalc SET cisrad = 284 WHERE idmzdcalc = 1278;
UPDATE pmzdcalc SET cisrad = 289 WHERE idmzdcalc = 1279;
UPDATE pmzdcalc SET cisrad = 290 WHERE idmzdcalc = 1280;
UPDATE pmzdcalc SET cisrad = 291 WHERE idmzdcalc = 1281;
UPDATE pmzdcalc SET cisrad = 292 WHERE idmzdcalc = 1282;
UPDATE pmzdcalc SET cisrad = 293 WHERE idmzdcalc = 1283;
UPDATE pmzdcalc SET cisrad = 285 WHERE idmzdcalc = 1284;
UPDATE pmzdcalc SET cisrad = 294 WHERE idmzdcalc = 1285;
UPDATE pmzdcalc SET cisrad = 295 WHERE idmzdcalc = 1286;
UPDATE pmzdcalc SET cisrad = 296 WHERE idmzdcalc = 1287;
UPDATE pmzdcalc SET cisrad = 297 WHERE idmzdcalc = 1288;
UPDATE pmzdcalc SET cisrad = 298 WHERE idmzdcalc = 1289;
UPDATE pmzdcalc SET cisrad = 299 WHERE idmzdcalc = 1290;
UPDATE pmzdcalc SET cisrad = 300 WHERE idmzdcalc = 1291;
UPDATE pmzdcalc SET cisrad = 301 WHERE idmzdcalc = 1292;
UPDATE pmzdcalc SET cisrad = 302 WHERE idmzdcalc = 1293;
UPDATE pmzdcalc SET cisrad = 303 WHERE idmzdcalc = 1294;
UPDATE pmzdcalc SET cisrad = 304 WHERE idmzdcalc = 1295;
UPDATE pmzdcalc SET cisrad = 305 WHERE idmzdcalc = 1296;
UPDATE pmzdcalc SET cisrad = 306 WHERE idmzdcalc = 1297;
UPDATE pmzdcalc SET cisrad = 307 WHERE idmzdcalc = 1298;
UPDATE pmzdcalc SET cisrad = 308 WHERE idmzdcalc = 1299;
UPDATE pmzdcalc SET cisrad = 309 WHERE idmzdcalc = 1300;
UPDATE pmzdcalc SET cisrad = 310 WHERE idmzdcalc = 1301;
UPDATE pmzdcalc SET cisrad = 311 WHERE idmzdcalc = 1302;
UPDATE pmzdcalc SET cisrad = 312 WHERE idmzdcalc = 1303;
UPDATE pmzdcalc SET cisrad = 313 WHERE idmzdcalc = 1304;
UPDATE pmzdcalc SET cisrad = 314 WHERE idmzdcalc = 1305;
UPDATE pmzdcalc SET cisrad = 315 WHERE idmzdcalc = 1306;
UPDATE pmzdcalc SET cisrad = 316 WHERE idmzdcalc = 1307;
UPDATE pmzdcalc SET cisrad = 317 WHERE idmzdcalc = 1308;
UPDATE pmzdcalc SET cisrad = 318 WHERE idmzdcalc = 1309;
UPDATE pmzdcalc SET cisrad = 319 WHERE idmzdcalc = 1310;
UPDATE pmzdcalc SET cisrad = 320 WHERE idmzdcalc = 1311;
UPDATE pmzdcalc SET cisrad = 321 WHERE idmzdcalc = 1312;
UPDATE pmzdcalc SET cisrad = 322 WHERE idmzdcalc = 1313;
UPDATE pmzdcalc SET cisrad = 323 WHERE idmzdcalc = 1314;
UPDATE pmzdcalc SET cisrad = 324 WHERE idmzdcalc = 1315;
UPDATE pmzdcalc SET cisrad = 325 WHERE idmzdcalc = 1316;
UPDATE pmzdcalc SET cisrad = 326 WHERE idmzdcalc = 1317;
UPDATE pmzdcalc SET cisrad = 327 WHERE idmzdcalc = 1318;
UPDATE pmzdcalc SET cisrad = 328 WHERE idmzdcalc = 1319;
UPDATE pmzdcalc SET cisrad = 329 WHERE idmzdcalc = 1320;
UPDATE pmzdcalc SET cisrad = 330 WHERE idmzdcalc = 1321;
UPDATE pmzdcalc SET cisrad = 331 WHERE idmzdcalc = 1322;
UPDATE pmzdcalc SET cisrad = 332 WHERE idmzdcalc = 1323;
UPDATE pmzdcalc SET cisrad = 333 WHERE idmzdcalc = 1324;
UPDATE pmzdcalc SET cisrad = 334 WHERE idmzdcalc = 1325;
UPDATE pmzdcalc SET cisrad = 335 WHERE idmzdcalc = 1326;
UPDATE pmzdcalc SET cisrad = 336 WHERE idmzdcalc = 1327;
UPDATE pmzdcalc SET cisrad = 337 WHERE idmzdcalc = 1328;
UPDATE pmzdcalc SET cisrad = 338 WHERE idmzdcalc = 1329;
UPDATE pmzdcalc SET cisrad = 339 WHERE idmzdcalc = 1330;
UPDATE pmzdcalc SET cisrad = 340 WHERE idmzdcalc = 1331;
UPDATE pmzdcalc SET cisrad = 341 WHERE idmzdcalc = 1332;
UPDATE pmzdcalc SET cisrad = 342 WHERE idmzdcalc = 1333;
UPDATE pmzdcalc SET cisrad = 343 WHERE idmzdcalc = 1334;
UPDATE pmzdcalc SET cisrad = 344 WHERE idmzdcalc = 1335;
UPDATE pmzdcalc SET cisrad = 345 WHERE idmzdcalc = 1336;
UPDATE pmzdcalc SET cisrad = 346 WHERE idmzdcalc = 1337;
UPDATE pmzdcalc SET cisrad = 347 WHERE idmzdcalc = 1338;
UPDATE pmzdcalc SET cisrad = 348 WHERE idmzdcalc = 1339;
UPDATE pmzdcalc SET cisrad = 349 WHERE idmzdcalc = 1340;
UPDATE pmzdcalc SET cisrad = 350 WHERE idmzdcalc = 1341;
UPDATE pmzdcalc SET cisrad = 351 WHERE idmzdcalc = 1342;
UPDATE pmzdcalc SET cisrad = 352 WHERE idmzdcalc = 1343;
UPDATE pmzdcalc SET cisrad = 353 WHERE idmzdcalc = 1344;
UPDATE pmzdcalc SET cisrad = 354 WHERE idmzdcalc = 1345;
UPDATE pmzdcalc SET cisrad = 355 WHERE idmzdcalc = 1346;
UPDATE pmzdcalc SET cisrad = 356 WHERE idmzdcalc = 1347;
UPDATE pmzdcalc SET cisrad = 357 WHERE idmzdcalc = 1348;
UPDATE pmzdcalc SET cisrad = 358 WHERE idmzdcalc = 1349;
UPDATE pmzdcalc SET cisrad = 359 WHERE idmzdcalc = 1350;
UPDATE pmzdcalc SET cisrad = 360 WHERE idmzdcalc = 1351;
UPDATE pmzdcalc SET cisrad = 361 WHERE idmzdcalc = 1352;
UPDATE pmzdcalc SET cisrad = 362 WHERE idmzdcalc = 1353;
UPDATE pmzdcalc SET cisrad = 363 WHERE idmzdcalc = 1354;
UPDATE pmzdcalc SET cisrad = 364 WHERE idmzdcalc = 1355;
UPDATE pmzdcalc SET cisrad = 365 WHERE idmzdcalc = 1356;
UPDATE pmzdcalc SET cisrad = 366 WHERE idmzdcalc = 1357;
UPDATE pmzdcalc SET cisrad = 367 WHERE idmzdcalc = 1358;
UPDATE pmzdcalc SET cisrad = 368 WHERE idmzdcalc = 1359;
UPDATE pmzdcalc SET cisrad = 369 WHERE idmzdcalc = 1360;
UPDATE pmzdcalc SET cisrad = 370 WHERE idmzdcalc = 1361;
UPDATE pmzdcalc SET cisrad = 371 WHERE idmzdcalc = 1362;
UPDATE pmzdcalc SET cisrad = 372 WHERE idmzdcalc = 1363;
UPDATE pmzdcalc SET cisrad = 373 WHERE idmzdcalc = 1364;
UPDATE pmzdcalc SET cisrad = 374 WHERE idmzdcalc = 1365;
UPDATE pmzdcalc SET cisrad = 375 WHERE idmzdcalc = 1366;
UPDATE pmzdcalc SET cisrad = 376 WHERE idmzdcalc = 1367;
UPDATE pmzdcalc SET cisrad = 377 WHERE idmzdcalc = 1368;
UPDATE pmzdcalc SET cisrad = 378 WHERE idmzdcalc = 1369;
UPDATE pmzdcalc SET cisrad = 379 WHERE idmzdcalc = 1370;
UPDATE pmzdcalc SET cisrad = 380 WHERE idmzdcalc = 1371;
UPDATE pmzdcalc SET cisrad = 381 WHERE idmzdcalc = 1372;
UPDATE pmzdcalc SET cisrad = 382 WHERE idmzdcalc = 1373;
UPDATE pmzdcalc SET cisrad = 383 WHERE idmzdcalc = 1374;
UPDATE pmzdcalc SET cisrad = 384 WHERE idmzdcalc = 1375;
UPDATE pmzdcalc SET cisrad = 385 WHERE idmzdcalc = 1376;
UPDATE pmzdcalc SET cisrad = 386 WHERE idmzdcalc = 1377;
UPDATE pmzdcalc SET cisrad = 387 WHERE idmzdcalc = 1378;
UPDATE pmzdcalc SET cisrad = 388 WHERE idmzdcalc = 1379;
UPDATE pmzdcalc SET cisrad = 389 WHERE idmzdcalc = 1380;
UPDATE pmzdcalc SET cisrad = 390 WHERE idmzdcalc = 1381;
UPDATE pmzdcalc SET cisrad = 391 WHERE idmzdcalc = 1382;
UPDATE pmzdcalc SET cisrad = 392 WHERE idmzdcalc = 1383;
UPDATE pmzdcalc SET cisrad = 393 WHERE idmzdcalc = 1384;
UPDATE pmzdcalc SET cisrad = 394 WHERE idmzdcalc = 1385;
UPDATE pmzdcalc SET cisrad = 395 WHERE idmzdcalc = 1386;
UPDATE pmzdcalc SET cisrad = 396 WHERE idmzdcalc = 1387;
UPDATE pmzdcalc SET cisrad = 397 WHERE idmzdcalc = 1388;
UPDATE pmzdcalc SET cisrad = 404 WHERE idmzdcalc = 1391;
UPDATE pmzdcalc SET cisrad = 405 WHERE idmzdcalc = 1392;
UPDATE pmzdcalc SET cisrad = 407 WHERE idmzdcalc = 1393;
UPDATE pmzdcalc SET cisrad = 408 WHERE idmzdcalc = 1394;
UPDATE pmzdcalc SET cisrad = 409 WHERE idmzdcalc = 1395;
UPDATE pmzdcalc SET cisrad = 410 WHERE idmzdcalc = 1396;
UPDATE pmzdcalc SET cisrad = 411 WHERE idmzdcalc = 1397;
UPDATE pmzdcalc SET cisrad = 412 WHERE idmzdcalc = 1398;
UPDATE pmzdcalc SET cisrad = 413 WHERE idmzdcalc = 1399;
UPDATE pmzdcalc SET cisrad = 414 WHERE idmzdcalc = 1400;
UPDATE pmzdcalc SET cisrad = 415 WHERE idmzdcalc = 1401;
UPDATE pmzdcalc SET cisrad = 416 WHERE idmzdcalc = 1402;
UPDATE pmzdcalc SET cisrad = 417 WHERE idmzdcalc = 1403;
UPDATE pmzdcalc SET cisrad = 418 WHERE idmzdcalc = 1404;
UPDATE pmzdcalc SET cisrad = 419 WHERE idmzdcalc = 1405;
UPDATE pmzdcalc SET cisrad = 420 WHERE idmzdcalc = 1406;
UPDATE pmzdcalc SET cisrad = 421 WHERE idmzdcalc = 1407;
UPDATE pmzdcalc SET cisrad = 422 WHERE idmzdcalc = 1408;
UPDATE pmzdcalc SET cisrad = 423 WHERE idmzdcalc = 1409;
UPDATE pmzdcalc SET cisrad = 424 WHERE idmzdcalc = 1410;
UPDATE pmzdcalc SET cisrad = 425 WHERE idmzdcalc = 1411;
UPDATE pmzdcalc SET cisrad = 426 WHERE idmzdcalc = 1412;
UPDATE pmzdcalc SET cisrad = 428 WHERE idmzdcalc = 1413;
UPDATE pmzdcalc SET cisrad = 429 WHERE idmzdcalc = 1414;
UPDATE pmzdcalc SET cisrad = 430 WHERE idmzdcalc = 1415;
UPDATE pmzdcalc SET cisrad = 431 WHERE idmzdcalc = 1416;
UPDATE pmzdcalc SET cisrad = 432 WHERE idmzdcalc = 1417;
UPDATE pmzdcalc SET cisrad = 433 WHERE idmzdcalc = 1418;
UPDATE pmzdcalc SET cisrad = 434 WHERE idmzdcalc = 1419;
UPDATE pmzdcalc SET cisrad = 435 WHERE idmzdcalc = 1420;
UPDATE pmzdcalc SET cisrad = 436 WHERE idmzdcalc = 1421;
UPDATE pmzdcalc SET cisrad = 437 WHERE idmzdcalc = 1422;
UPDATE pmzdcalc SET cisrad = 438 WHERE idmzdcalc = 1423;
UPDATE pmzdcalc SET cisrad = 439 WHERE idmzdcalc = 1424;
UPDATE pmzdcalc SET cisrad = 440 WHERE idmzdcalc = 1425;
UPDATE pmzdcalc SET cisrad = 441 WHERE idmzdcalc = 1426;
UPDATE pmzdcalc SET cisrad = 442 WHERE idmzdcalc = 1427;
UPDATE pmzdcalc SET cisrad = 443 WHERE idmzdcalc = 1428;
UPDATE pmzdcalc SET cisrad = 444 WHERE idmzdcalc = 1429;
UPDATE pmzdcalc SET cisrad = 445 WHERE idmzdcalc = 1430;
UPDATE pmzdcalc SET cisrad = 446 WHERE idmzdcalc = 1431;
UPDATE pmzdcalc SET cisrad = 447 WHERE idmzdcalc = 1432;
UPDATE pmzdcalc SET cisrad = 448 WHERE idmzdcalc = 1433;
UPDATE pmzdcalc SET cisrad = 449 WHERE idmzdcalc = 1434;
UPDATE pmzdcalc SET cisrad = 450 WHERE idmzdcalc = 1436;
UPDATE pmzdcalc SET cisrad = 451 WHERE idmzdcalc = 1437;
UPDATE pmzdcalc SET cisrad = 452 WHERE idmzdcalc = 1438;
UPDATE pmzdcalc SET cisrad = 453 WHERE idmzdcalc = 1439;
UPDATE pmzdcalc SET cisrad = 454 WHERE idmzdcalc = 1440;
UPDATE pmzdcalc SET cisrad = 455 WHERE idmzdcalc = 1441;
UPDATE pmzdcalc SET cisrad = 456 WHERE idmzdcalc = 1442;
UPDATE pmzdcalc SET cisrad = 457 WHERE idmzdcalc = 1443;
UPDATE pmzdcalc SET cisrad = 458 WHERE idmzdcalc = 1444;
UPDATE pmzdcalc SET cisrad = 459 WHERE idmzdcalc = 1445;
UPDATE pmzdcalc SET cisrad = 460 WHERE idmzdcalc = 1446;
UPDATE pmzdcalc SET cisrad = 461 WHERE idmzdcalc = 1447;
UPDATE pmzdcalc SET cisrad = 462 WHERE idmzdcalc = 1448;
UPDATE pmzdcalc SET cisrad = 463 WHERE idmzdcalc = 1449;
UPDATE pmzdcalc SET cisrad = 464 WHERE idmzdcalc = 1450;
UPDATE pmzdcalc SET cisrad = 465 WHERE idmzdcalc = 1451;
UPDATE pmzdcalc SET cisrad = 466 WHERE idmzdcalc = 1452;
UPDATE pmzdcalc SET cisrad = 467 WHERE idmzdcalc = 1453;
UPDATE pmzdcalc SET cisrad = 468 WHERE idmzdcalc = 1454;
UPDATE pmzdcalc SET cisrad = 469 WHERE idmzdcalc = 1455;
UPDATE pmzdcalc SET cisrad = 470 WHERE idmzdcalc = 1456;
UPDATE pmzdcalc SET cisrad = 471 WHERE idmzdcalc = 1457;
UPDATE pmzdcalc SET cisrad = 472 WHERE idmzdcalc = 1458;
UPDATE pmzdcalc SET cisrad = 473 WHERE idmzdcalc = 1459;
UPDATE pmzdcalc SET cisrad = 474 WHERE idmzdcalc = 1460;
UPDATE pmzdcalc SET cisrad = 475 WHERE idmzdcalc = 1461;
UPDATE pmzdcalc SET cisrad = 476 WHERE idmzdcalc = 1462;
UPDATE pmzdcalc SET cisrad = 477 WHERE idmzdcalc = 1463;
UPDATE pmzdcalc SET cisrad = 478 WHERE idmzdcalc = 1464;
UPDATE pmzdcalc SET cisrad = 479 WHERE idmzdcalc = 1465;
UPDATE pmzdcalc SET cisrad = 480 WHERE idmzdcalc = 1466;
UPDATE pmzdcalc SET cisrad = 481 WHERE idmzdcalc = 1467;
UPDATE pmzdcalc SET cisrad = 482 WHERE idmzdcalc = 1468;
UPDATE pmzdcalc SET cisrad = 483 WHERE idmzdcalc = 1469;
UPDATE pmzdcalc SET cisrad = 484 WHERE idmzdcalc = 1470;
UPDATE pmzdcalc SET cisrad = 485 WHERE idmzdcalc = 1471;
UPDATE pmzdcalc SET cisrad = 486 WHERE idmzdcalc = 1472;
UPDATE pmzdcalc SET cisrad = 487 WHERE idmzdcalc = 1473;
UPDATE pmzdcalc SET cisrad = 488 WHERE idmzdcalc = 1474;
UPDATE pmzdcalc SET cisrad = 489 WHERE idmzdcalc = 1475;
UPDATE pmzdcalc SET cisrad = 490 WHERE idmzdcalc = 1476;
UPDATE pmzdcalc SET cisrad = 491 WHERE idmzdcalc = 1477;
UPDATE pmzdcalc SET cisrad = 492 WHERE idmzdcalc = 1478;
UPDATE pmzdcalc SET cisrad = 493 WHERE idmzdcalc = 1479;
UPDATE pmzdcalc SET cisrad = 494 WHERE idmzdcalc = 1480;
UPDATE pmzdcalc SET cisrad = 495 WHERE idmzdcalc = 1481;
UPDATE pmzdcalc SET cisrad = 496 WHERE idmzdcalc = 1482;
UPDATE pmzdcalc SET cisrad = 497 WHERE idmzdcalc = 1483;
UPDATE pmzdcalc SET cisrad = 498 WHERE idmzdcalc = 1484;
UPDATE pmzdcalc SET cisrad = 499 WHERE idmzdcalc = 1485;
UPDATE pmzdcalc SET cisrad = 500 WHERE idmzdcalc = 1486;
UPDATE pmzdcalc SET cisrad = 501 WHERE idmzdcalc = 1487;
UPDATE pmzdcalc SET cisrad = 502 WHERE idmzdcalc = 1488;
UPDATE pmzdcalc SET cisrad = 503 WHERE idmzdcalc = 1489;
UPDATE pmzdcalc SET cisrad = 504 WHERE idmzdcalc = 1490;
UPDATE pmzdcalc SET cisrad = 505 WHERE idmzdcalc = 1491;
UPDATE pmzdcalc SET cisrad = 506 WHERE idmzdcalc = 1492;
UPDATE pmzdcalc SET cisrad = 507 WHERE idmzdcalc = 1493;
UPDATE pmzdcalc SET cisrad = 508 WHERE idmzdcalc = 1494;
UPDATE pmzdcalc SET cisrad = 509 WHERE idmzdcalc = 1495;
UPDATE pmzdcalc SET cisrad = 510 WHERE idmzdcalc = 1496;
UPDATE pmzdcalc SET cisrad = 511 WHERE idmzdcalc = 1497;
UPDATE pmzdcalc SET cisrad = 512 WHERE idmzdcalc = 1498;
UPDATE pmzdcalc SET cisrad = 513 WHERE idmzdcalc = 1499;
UPDATE pmzdcalc SET cisrad = 514 WHERE idmzdcalc = 1500;
UPDATE pmzdcalc SET cisrad = 515 WHERE idmzdcalc = 1501;
UPDATE pmzdcalc SET cisrad = 516 WHERE idmzdcalc = 1502;
UPDATE pmzdcalc SET cisrad = 517 WHERE idmzdcalc = 1503;
UPDATE pmzdcalc SET cisrad = 518 WHERE idmzdcalc = 1504;
UPDATE pmzdcalc SET cisrad = 519 WHERE idmzdcalc = 1505;
UPDATE pmzdcalc SET cisrad = 520 WHERE idmzdcalc = 1506;
UPDATE pmzdcalc SET cisrad = 521 WHERE idmzdcalc = 1507;
UPDATE pmzdcalc SET cisrad = 522 WHERE idmzdcalc = 1508;
UPDATE pmzdcalc SET cisrad = 523 WHERE idmzdcalc = 1509;
UPDATE pmzdcalc SET cisrad = 524 WHERE idmzdcalc = 1510;
UPDATE pmzdcalc SET cisrad = 525 WHERE idmzdcalc = 1511;
UPDATE pmzdcalc SET cisrad = 526 WHERE idmzdcalc = 1512;
UPDATE pmzdcalc SET cisrad = 527 WHERE idmzdcalc = 1513;
UPDATE pmzdcalc SET cisrad = 528 WHERE idmzdcalc = 1514;
UPDATE pmzdcalc SET cisrad = 529 WHERE idmzdcalc = 1515;
UPDATE pmzdcalc SET cisrad = 530 WHERE idmzdcalc = 1516;
UPDATE pmzdcalc SET cisrad = 531 WHERE idmzdcalc = 1517;
UPDATE pmzdcalc SET cisrad = 532 WHERE idmzdcalc = 1518;
UPDATE pmzdcalc SET cisrad = 533 WHERE idmzdcalc = 1519;
UPDATE pmzdcalc SET cisrad = 534 WHERE idmzdcalc = 1520;
UPDATE pmzdcalc SET cisrad = 535 WHERE idmzdcalc = 1521;
UPDATE pmzdcalc SET cisrad = 536 WHERE idmzdcalc = 1522;
UPDATE pmzdcalc SET cisrad = 537 WHERE idmzdcalc = 1523;
UPDATE pmzdcalc SET cisrad = 538 WHERE idmzdcalc = 1524;
UPDATE pmzdcalc SET cisrad = 539 WHERE idmzdcalc = 1525;
UPDATE pmzdcalc SET cisrad = 540 WHERE idmzdcalc = 1526;
UPDATE pmzdcalc SET cisrad = 541 WHERE idmzdcalc = 1527;
UPDATE pmzdcalc SET cisrad = 542 WHERE idmzdcalc = 1528;
UPDATE pmzdcalc SET cisrad = 543 WHERE idmzdcalc = 1529;
UPDATE pmzdcalc SET cisrad = 544 WHERE idmzdcalc = 1530;
UPDATE pmzdcalc SET cisrad = 545 WHERE idmzdcalc = 1531;
UPDATE pmzdcalc SET cisrad = 546 WHERE idmzdcalc = 1532;
UPDATE pmzdcalc SET cisrad = 547 WHERE idmzdcalc = 1533;
UPDATE pmzdcalc SET cisrad = 548 WHERE idmzdcalc = 1534;
UPDATE pmzdcalc SET cisrad = 549 WHERE idmzdcalc = 1535;
UPDATE pmzdcalc SET cisrad = 550 WHERE idmzdcalc = 1536;
UPDATE pmzdcalc SET cisrad = 551 WHERE idmzdcalc = 1537;
UPDATE pmzdcalc SET cisrad = 552 WHERE idmzdcalc = 1538;
UPDATE pmzdcalc SET cisrad = 553 WHERE idmzdcalc = 1539;
UPDATE pmzdcalc SET cisrad = 554 WHERE idmzdcalc = 1540;
UPDATE pmzdcalc SET cisrad = 555 WHERE idmzdcalc = 1541;
UPDATE pmzdcalc SET cisrad = 556 WHERE idmzdcalc = 1542;
UPDATE pmzdcalc SET cisrad = 557 WHERE idmzdcalc = 1543;
UPDATE pmzdcalc SET cisrad = 558 WHERE idmzdcalc = 1544;
UPDATE pmzdcalc SET cisrad = 559 WHERE idmzdcalc = 1545;
UPDATE pmzdcalc SET cisrad = 560 WHERE idmzdcalc = 1546;
UPDATE pmzdcalc SET cisrad = 561 WHERE idmzdcalc = 1547;
UPDATE pmzdcalc SET cisrad = 562 WHERE idmzdcalc = 1548;
UPDATE pmzdcalc SET cisrad = 427 WHERE idmzdcalc = 1549;
UPDATE pmzdcalc SET cisrad = 269 WHERE idmzdcalc = 1550;
UPDATE pmzdcalc SET cisrad = 398 WHERE idmzdcalc = 1551;
UPDATE pmzdcalc SET kod = 'DOVOLENÁ POČÁTEK', cisrad = 406, idmzdslozout = 184 WHERE idmzdcalc = 1552;
UPDATE pmzdcalc SET cisrad = 399 WHERE idmzdcalc = 1553;
UPDATE pmzdcalc SET cisrad = 400 WHERE idmzdcalc = 1554;
UPDATE pmzdcalc SET cisrad = 401 WHERE idmzdcalc = 1555;
UPDATE pmzdcalc SET cisrad = 402 WHERE idmzdcalc = 1556;
UPDATE pmzdcalc SET cisrad = 403 WHERE idmzdcalc = 1557;
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (1560, '2011-04-04 00:00:00.000', 'NÁHRADA ZA SVÁTEK', 'svátek sumovaná z nemoci', true, 55, -1.0, 1.0, 0.0, 'dnySvatek;hodinySvatek;dnySvatek;hodinySvatek', 'dnySvatek;hodinySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 2, 343, 21);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (1561, '2011-04-13 00:00:00.000', 'SVÁTEK', 'svátek sumovaná z nemoci', 'do hodinySvatek nekopirujeme - dostava nahradu mzdy za svatek a ne dovolenou', true, 30, -1.0, 1.0, 0.0, 'dnySvatek;dnySvatek;hodinySvatek', 'dnySvatek;dnyPrac;hodiny', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 2, 343, 256);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (1562, '2011-05-11 00:00:00.000', 'ODPOČET ZÁKLADU ZP', '11.5.           odpočet pro kryply', true, 286, 0.0, 0.0, 5355.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 2, 344, 344);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozin2, idmzdslozout)
 VALUES (1563, '2011-05-11 00:00:00.000', 'ODPOČET ZÁKLADU ZP', 'odpočet pro kryply', true, 287, 1.0, 0.0, 0.0, 'zaklMzd', 'procMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.krat', false, 0, false, 2, 344, 344, 344);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (1564, '2011-05-11 00:00:00.000', '10', '11.5.           odpočet pro kryply', true, 288, -1.0, 1.0, 0.0, 'zaklMzd', 'zaklMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 2, 344, 92);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (1565, '2011-05-11 00:00:00.000', 'DOVOLENÁ CELKEM', 'Dovolená', '!!!!!!!!!!!!  11.5. zrušeno zaokrouhlování - test', true, 194, 1.0, 1.0, 0.0, 'castMzd;castkaHod;dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek;prumNaHodNem', '', 'castMzd;castkaHod;dnyKal;dnyPrac;dnySvatek;hodiny;hodinySvatek;prumNaHodNem', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 2, 2, 346);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, popis, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, polein2, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, ispv, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (1566, '2011-05-11 00:00:00.000', 'DOVOLENÁ CELKEM', 'Celková dovolená zaokrouhlená na Kč nahoru', '!!!!!!!!!!!!  11.5. zrušeno zaokrouhlování - test', true, 195, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', '', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, false, 2, 346, 346);

PERFORM pg_catalog.setval('seq_pmzdcalc', 1566, true);

-- pracovni pomery
-- parametry pro typ prac pom
UPDATE ptyppracpomparam SET cisrad = 42 WHERE idtyppracpomparam = 35;
UPDATE ptyppracpomparam SET cisrad = 41 WHERE idtyppracpomparam = 38;
UPDATE ptyppracpomparam SET cisrad = 42 WHERE idtyppracpomparam = 41;
UPDATE ptyppracpomparam SET cisrad = 44 WHERE idtyppracpomparam = 47;
UPDATE ptyppracpomparam SET cisrad = 43 WHERE idtyppracpomparam = 48;
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (53, '2011-04-19 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', 'doplněno 19.4.2011', true, 45, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, true, true, true, true, true, true, true, 2, 8, 221);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (54, '2011-04-19 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', 'doplněno 19.4.2011', true, 45, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, true, true, true, true, true, true, true, 2, 9, 221);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (55, '2011-04-19 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', 'doplněno 19.4.2011', true, 45, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, true, true, true, true, true, true, true, 2, 10, 221);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
 VALUES (56, '2011-04-19 00:00:00.000', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', '', true, 45, 0.0, 9.999999999999E12, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, true, true, true, true, true, true, true, 2, 6, 221);
--DELETE FROM ptyppracpomparam WHERE idtyppracpomparam = 38;  -- nulovani SP u DPP zustava
DELETE FROM ptyppracpomparam WHERE idtyppracpomparam = 36;

PERFORM pg_catalog.setval('seq_ptyppracpomparam', 56, true);

-- konec ceskeho bloku
  end if; 
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

--------------------------------------------------------------------------------
-- Bug 23637 – [winstrom] mzdy - chybný výpočet alikvotní části mzdy
--------------------------------------------------------------------------------

ALTER TABLE ppracpomhlav ADD COLUMN zacatek date;
ALTER TABLE ppracpomhlav ADD COLUMN konecpomeru date;

-- pridani funkce ktera zjisti zda je datum posledni den v mesici
CREATE OR REPLACE FUNCTION iskonecmesice(datum date)
  RETURNS boolean AS $$   
declare poslden integer;
begin   
  if datum is not null then
    poslden = extract (day from (date_trunc('month', datum) + interval '1 month' - interval '1 day'));
    if poslden = extract (day from datum) then   
      return true;
    end if;
  end if;
  
  return false;
end;   
$$ LANGUAGE plpgsql;
ALTER FUNCTION iskonecmesice(date) OWNER TO %firmaRole%;

-- trigger prenasejici datumy aktivnosti pracovniho pomeru z jednoho nastaveni na ostatni a na hlavicku
CREATE OR REPLACE FUNCTION ppracpomupdateaktivni()
  RETURNS trigger AS $$
begin
  update ppracpomhlav set aktivniod = NEW.aktivniod, aktivnido = NEW.aktivnido, zacatek = NEW.zacatek, konecpomeru = NEW.konecpomeru
    where idpracpomhlav = NEW.idpracpomhlav and 
      (comparedate(aktivniod, NEW.aktivniod) = false or comparedate(aktivnido, NEW.aktivnido) = false or
       comparedate(zacatek, NEW.zacatek) = false or comparedate(konecpomeru, NEW.konecpomeru) = false);
  
  update ppracpom set aktivniod = NEW.aktivniod, aktivnido = NEW.aktivnido, zacatek = NEW.zacatek, konecpomeru = NEW.konecpomeru
    where idpracpomhlav = NEW.idpracpomhlav and 
      (comparedate(aktivniod, NEW.aktivniod) = false or comparedate(aktivnido, NEW.aktivnido) = false or
       comparedate(zacatek, NEW.zacatek) = false or comparedate(konecpomeru, NEW.konecpomeru) = false);
  
  if (NEW.platido is null) then
    update ppracpomhlav set kod = NEW.kod, nazev = NEW.nazev, hlavni = NEW.hlavni where idpracpomhlav = NEW.idpracpomhlav 
      and (kod <> NEW.kod or nazev <> NEW.nazev or hlavni <> NEW.hlavni);
  end if;
  
  -- pokud vkladame nove nastaveni nebo doslo ke zmene bez zmeny datumu aktivnosti zkontrolujeme smeny
  if (tg_op = 'INSERT') then
    perform pgeneratemzdslozforpracpom(NEW.idpracpomhlav);
  end if;
  if (tg_op = 'UPDATE') then
   if not (((OLD.aktivniod is null) <> (NEW.aktivniod is null)) or (OLD.aktivniod is not null and OLD.aktivniod <> NEW.aktivniod) or
       ((OLD.aktivnido is null) <> (NEW.aktivnido is null)) or (OLD.aktivnido is not null and OLD.aktivnido <> NEW.aktivnido)) then
      perform pgeneratemzdslozforpracpom(NEW.idpracpomhlav);
    end if;
  end if;
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ppracpomupdateaktivni() OWNER TO %firmaRole%;

-- trigger generujici mzdove slozky pri uprave pracovnich pomeru
CREATE OR REPLACE FUNCTION ppracpomhlavupdatemzdsloz()
  RETURNS trigger AS $$
declare
  nullcount integer;
  _rok integer;
  _mesic integer;
  _idSmena integer;
  pregenSmenuRok integer;
  pregenSmenuMesic integer;
begin
  -- vymazeme nadbytecne slozky pro pracovni pomer
  if (NEW.aktivniod is not null) then
    _rok = date_part('year', NEW.aktivniod);
    _mesic = date_part('month', NEW.aktivniod);
    
    delete from pmzdsloz where idpracpom = NEW.idpracpomhlav and (rok < _rok or (rok = _rok and mesic < _mesic));
    delete from psmeny where idpracpom = NEW.idpracpomhlav and (rok < _rok or (rok = _rok and mesic < _mesic));
  end if;
  
  if (NEW.aktivnido is not null) then
    _rok = date_part('year', NEW.aktivnido);
    _mesic = date_part('month', NEW.aktivnido);
    
    delete from pmzdsloz where idpracpom = NEW.idpracpomhlav and (rok > _rok or (rok = _rok and mesic > _mesic));
    delete from psmeny where idpracpom = NEW.idpracpomhlav and (rok > _rok or (rok = _rok and mesic > _mesic));
  end if;
  
  -- vymazeme nadbytecne spolecne slozky
  select count(*) into nullcount from ppracpomhlav where idosoba = NEW.idosoba and aktivniod is null;
  if nullcount = 0 then
    select date_part('year', min(aktivniod)), date_part('month', min(aktivniod)) into _rok, _mesic from ppracpom where idosoba = NEW.idosoba;
    
    delete from pmzdsloz where idosoba = NEW.idosoba and (rok < _rok or (rok = _rok and mesic < _mesic));
  end if;
  
  select count(*) into nullcount from ppracpomhlav where idosoba = NEW.idosoba and aktivnido is null;
  if nullcount = 0 then
    select date_part('year', max(aktivnido)), date_part('month', max(aktivnido)) into _rok, _mesic from ppracpom where idosoba = NEW.idosoba;
    
    delete from pmzdsloz where idosoba = NEW.idosoba and (rok > _rok or (rok = _rok and mesic > _mesic));
  end if;
  
  -- vygenerujeme chybejici
  perform pgeneratemzdslozforpracpom(NEW.idpracpomhlav);
  
  if (tg_op = 'UPDATE') then       -- pri zmene aktivni od/do zjistime jesteli neni potreba pregenerovat nejaky mesic, kvuli dobe kdy nepracuje
    -- zkontrolujeme zda se nezmenil zacatek pomeru a neni treba neco pregenerovat
    if (comparedate(NEW.zacatek, OLD.zacatek) = false) then
      pregenSmenuRok = 0;
      pregenSmenuMesic = 0;
      
      if (NEW.zacatek is null) then
        if extract(day from OLD.zacatek) > 1 then
          pregenSmenuRok = extract(year from OLD.zacatek);
          pregenSmenuMesic = extract(month from OLD.zacatek);
        end if;
      end if;
      if (OLD.zacatek is null) then
        if extract(day from NEW.zacatek) > 1 then
          pregenSmenuRok = extract(year from NEW.zacatek);
          pregenSmenuMesic = extract(month from NEW.zacatek);
        end if;
      end if;
      if NEW.zacatek is not null and OLD.zacatek is not null then
        if (extract(month from NEW.zacatek) = extract(month from OLD.zacatek) and extract(year from NEW.zacatek) = extract(year from OLD.zacatek)) then
          pregenSmenuRok = extract(year from NEW.zacatek);       -- zmenil se den pocatku ale mesic zustal
          pregenSmenuMesic = extract(month from NEW.zacatek);
        else
          if (extract(day from OLD.zacatek) > 1 and (extract(month from NEW.zacatek) < extract(month from OLD.zacatek) or extract(year from NEW.zacatek) < extract(year from OLD.zacatek))) then
            pregenSmenuRok = extract(year from NEW.zacatek);    -- stary den pocatku neni 1 a mesic se posunul v case dozadu - tj mesic existule ale uz je tam celej
            pregenSmenuMesic = extract(month from NEW.zacatek);
          end if;
          if (extract(day from NEW.zacatek) > 1 and (extract(month from NEW.zacatek) > extract(month from OLD.zacatek) or extract(year from NEW.zacatek) > extract(year from OLD.zacatek))) then
            pregenSmenuRok = extract(year from NEW.zacatek);    -- novy den pocatku neni 1 a mesic se posunul v case dopredu - tj mesic existuje ale meni se
            pregenSmenuMesic = extract(month from NEW.zacatek);
          end if;
        end if;
      end if;
      
      if pregenSmenuMesic > 0 then
        select idsmeny into _idSmena from psmeny where idpracpom = NEW.idpracpomhlav and rok = pregenSmenuRok and mesic = pregenSmenuMesic;
        if _idSmena is not null then
          perform pcreatemzdslozforsmeny(_idSmena);
        end if;
      end if;
    end if;
    
    -- zkontrolujeme zda se nezmenil konec pomeru a neni treba neco pregenerovat
    if (comparedate(NEW.konecpomeru, OLD.konecpomeru) = false) then
      pregenSmenuRok = 0;
      pregenSmenuMesic = 0;
      
      if (NEW.konecpomeru is null) then
        if iskonecmesice(OLD.konecpomeru) = false then
          pregenSmenuRok = extract(year from OLD.konecpomeru);
          pregenSmenuMesic = extract(month from OLD.konecpomeru);
        end if;
      end if;
      if (OLD.konecpomeru is null) then
        if iskonecmesice(NEW.konecpomeru) = false then
          pregenSmenuRok = extract(year from NEW.konecpomeru);
          pregenSmenuMesic = extract(month from NEW.konecpomeru);
        end if;
      end if;
      if NEW.konecpomeru is not null and OLD.konecpomeru is not null then
        if (extract(month from NEW.konecpomeru) = extract(month from OLD.konecpomeru) and extract(year from NEW.konecpomeru) = extract(year from OLD.konecpomeru)) then
          pregenSmenuRok = extract(year from NEW.konecpomeru);       -- zmenil se den konce ale mesic zustal
          pregenSmenuMesic = extract(month from NEW.konecpomeru);
        else
          if (iskonecmesice(NEW.konecpomeru) = false and (extract(month from NEW.konecpomeru) < extract(month from OLD.konecpomeru) or extract(year from NEW.konecpomeru) < extract(year from OLD.konecpomeru))) then
            pregenSmenuRok = extract(year from NEW.konecpomeru);    -- novy den konce neni konec mesice a mesic se posunul v case dozadu - tj mesic existule ale uz je tam celej
            pregenSmenuMesic = extract(month from NEW.konecpomeru);
          end if;
          if (iskonecmesice(OLD.konecpomeru) = false and (extract(month from NEW.konecpomeru) > extract(month from OLD.konecpomeru) or extract(year from NEW.konecpomeru) > extract(year from OLD.konecpomeru))) then
            pregenSmenuRok = extract(year from OLD.konecpomeru);    -- stary den konce neni konec mesice a mesic se posunul v case dopredu - tj mesic existuje ale meni se, ma tam byt ted cely
            pregenSmenuMesic = extract(month from OLD.konecpomeru);
          end if;
        end if;
      end if;
      
      if pregenSmenuMesic > 0 then
        select idsmeny into _idSmena from psmeny where idpracpom = NEW.idpracpomhlav and rok = pregenSmenuRok and mesic = pregenSmenuMesic;
        if _idSmena is not null then
          perform pcreatemzdslozforsmeny(_idSmena);
        end if;
      end if;
    end if;
  end if;
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ppracpomhlavupdatemzdsloz() OWNER TO %firmaRole%;

-- pro smeny se zadanym id vygeneruje mzdovou slozku pracovni doby
CREATE OR REPLACE FUNCTION pcreatemzdslozforsmeny(_idSmeny integer)
  RETURNS void AS $$
declare
  SM record;
  SMnext record;
  _hodin numeric;
  _dnuPrac numeric;
  _hodinPoc numeric;
  _dnuPracPoc numeric;
  _konecMes date;
  _okolMes date;
  _denOd integer;
  _denDo integer;
  _denOdPoc integer;
  _denDoPoc integer;
  _pocatek boolean;
  _aktivOd date;
  _aktivDo date;
  i integer;
  smeny varchar[];
  smena varchar[];
  _aktSmena varchar;
  pocSmena integer;
  konSmena integer;
  denSmena integer;
  _idcisMzd integer;
  _idmzdsloz integer;
  _aktHodin numeric;
  _svatek boolean;
  _dnuSvat numeric;
  _hodinSvat numeric;
  _dnuSvatPoc numeric;
  _hodinSvatPoc numeric;
begin
  select * into SM from psmeny where idsmeny = _idsmeny;
  _hodin = 0;
  _dnuPrac = 0;
  _hodinPoc = 0;
  _dnuPracPoc = 0;
  _dnuSvat = 0;
  _hodinSvat = 0;
  _dnuSvatPoc = 0;
  _hodinSvatPoc = 0;
  _konecMes = date(SM.rok || '-' || SM.mesic || '-01') + interval '1 month' - interval '1 day';
  _denOd = 1;
  _denDo = extract (day from _konecMes);
  _denOdPoc = 1;
  _denDoPoc = _denDo;
  
  select zacatek, konecpomeru into _aktivOd, _aktivDo from ppracpomhlav where idpracpomhlav = SM.idpracpom;
  
  if (_aktivOd is not null) then
    if (SM.mesic = extract(month from _aktivOd) and SM.rok = extract(year from _aktivOd)) then
      _denOdPoc = extract (day from _aktivOd);
    end if;
  end if;
  if (_aktivDo is not null) then
    if (SM.mesic = extract(month from _aktivDo) and SM.rok = extract(year from _aktivDo)) then
      _denDoPoc = extract (day from _aktivDo);
    end if;
  end if;
  _pocatek = (_denOd <> _denOdPoc or _denDo <> _denDoPoc);
  
  if (SM.planovane is not null and length(SM.planovane) > 0) then
    smeny = string_to_array(SM.planovane,';');
    _aktSmena = '';
    
    for i in array_lower(smeny,1) .. array_upper(smeny,1) loop  -- prochazime smeny
      smena = string_to_array(smeny[i],':');
      if (smena[1] <> '0' and smena[1] <> 's0') then                     -- zbytek smeny z minuleho mesice nas nezajima
        pocSmena = smena[2];
        konSmena = smena[3];
        
        if (_aktSmena <> smena[1]) then
          denSmena = pocSmena / (24 * 60) + 1;    -- zjistime den
          _svatek = (strpos(smena[1], 's') > 0);    -- zjistime jestli jde o svatek
          
          if (_svatek) then
            _dnuSvat = _dnuSvat + 1;  -- pripocteme svatek kdy mel pracovat ale flakal se
            if (denSmena < _denOdPoc or denSmena > _denDoPoc) then
              _dnuSvatPoc = _dnuSvatPoc + 1;
            end if;
          else
            _dnuPrac = _dnuPrac + 1;  -- pripocteme pracovni den
            if (denSmena < _denOdPoc or denSmena > _denDoPoc) then
              _dnuPracPoc = _dnuPracPoc + 1;
            end if;
          end if;
          _aktSmena = smena[1];
        end if;
        
        _aktHodin = cast((konSmena - pocSmena + 1) as numeric) / 60;
        
        if (_svatek) then
          _hodinSvat = _hodinSvat + _aktHodin;  -- pripocteme svatecni hodiny
          if (denSmena < _denOdPoc or denSmena > _denDoPoc) then
            _hodinSvatPoc = _hodinSvatPoc + _aktHodin;
          end if;
        else
          _hodin = _hodin + _aktHodin;    -- pripocteme pracovni hodiny
          if (denSmena < _denOdPoc or denSmena > _denDoPoc) then
            _hodinPoc = _hodinPoc + _aktHodin;
          end if;
        end if;
      else
        _okolMes = date(SM.rok || '-' || SM.mesic || '-01') - interval '1 month';
        select pcreatemzdslozforsmeny(idsmeny)from psmeny where idpracpom = sm.idpracpom and 
               rok = extract(year from _okolMes) and mesic = extract(month from _okolMes);
      end if;
    end loop;
  end if;
  
  -- podivame se o mesic dal jestli tam nemame kousicek
  /*_okolMes = date(SM.rok || '-' || SM.mesic || '-01') + interval '1 month';
  select * into SMnext from psmeny where idpracpom = sm.idpracpom and 
               rok = extract(year from _okolMes) and mesic = extract(month from _okolMes) limit 1;
  if (SMnext.idsmeny is not null) then
    if (SMnext.planovane is not null and length(SMnext.planovane) > 0) then
      smeny = string_to_array(SMnext.planovane,';');
      
      for i in array_lower(smeny,1) .. array_upper(smeny,1) loop  -- prochazime smeny
        smena = string_to_array(smeny[i],':');
        _aktSmena = smena[1];
      
        if (_aktSmena = '0' or _aktSmena = 's0') then
          pocSmena = smena[2];
          konSmena = smena[3];
          _aktHodin = (konSmena - pocSmena + 1) / 60;
          if (_aktSmena = '0') then
            _hodin = _hodin + _aktHodin;
          else
            _hodinSvat = _hodinSvat + _aktHodin;
          end if;
        end if;
      end loop;  
    end if;
  end if;*/
  
  select idcismzdsloz into _idcisMzd from pcismzdsloz where typslozkyk = 'typSlozky.kopie' and skupslozkyk = 'skupinaSlozky.doba';
  select idmzdsloz into _idmzdsloz from pmzdsloz where idpracpom = SM.idpracpom and rok = SM.rok and mesic = SM.mesic 
      and idcismzdsloz = _idcisMzd;
  
  if (_idmzdsloz is null) then      -- slozka neexistuje vytvorime ji
    select pcreatemzdslozfromcis(_idcisMzd, SM.idpracpom, null, SM.rok, SM.mesic) into _idmzdsloz;
  end if;
  
  update pmzdsloz set dnyKal = (_denDo-_denOd+1), dnyPrac = _dnuPrac, hodiny = _hodin, dnySvatek = _dnuSvat, hodinySvatek = _hodinSvat where idmzdsloz = _idmzdsloz;

  
  select idcismzdsloz into _idcisMzd from pcismzdsloz where typslozkyk = 'typSlozky.inicializace' and skupslozkyk = 'skupinaSlozky.doba';
  if (_idcisMzd is not null) then
    select idmzdsloz into _idmzdsloz from pmzdsloz where idpracpom = SM.idpracpom and rok = SM.rok and mesic = SM.mesic
      and idcismzdsloz = _idcisMzd;

    if (_pocatek) then
      if (_idmzdsloz is null) then      -- slozka neexistuje vytvorime ji
        select pcreatemzdslozfromcis(_idcisMzd, SM.idpracpom, null, SM.rok, SM.mesic) into _idmzdsloz;
      end if;

      update pmzdsloz set dnyKal = (_denDo-_denOd - _denDoPoc+_denOdPoc), dnyPrac = _dnuPracPoc, hodiny = _hodinPoc, dnySvatek = _dnuSvatPoc, hodinySvatek = _hodinSvatPoc where idmzdsloz = _idmzdsloz;
    else
      if (_idmzdsloz is not null) then      -- slozka neexistuje smazeme ji
        delete from pmzdsloz where idmzdsloz = _idmzdsloz;
      end if;
    end if;
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pcreatemzdslozforsmeny(integer) OWNER TO %firmaRole%;

-- oprava datumu kdyby byli rozbite - az na konci aby pripadne nove triggery opravili slozky
-- vypneme detekci zmeny slozek v zamcenem obdobi - mzda se nezmeni ale opravi se vychozi slozky
-- takze pokud by se spustil znova prepocet tak se spocte jiz dobre
ALTER TABLE pmzdsloz DISABLE TRIGGER pmzdslozupdatedatumvypoctu;

UPDATE ppracpomhlav as H set zacatek = (select N.zacatek from ppracpom as N where N.idpracpomhlav = H.idpracpomhlav and N.platiod is null),
                             konecpomeru = (select N.konecpomeru from ppracpom as N where N.idpracpomhlav = H.idpracpomhlav and N.platido is null)
    where comparedate(zacatek, (select N.zacatek from ppracpom as N where N.idpracpomhlav = H.idpracpomhlav and N.platiod is null)) = false or
       comparedate(konecpomeru, (select N.konecpomeru from ppracpom as N where N.idpracpomhlav = H.idpracpomhlav and N.platido is null)) = false;

UPDATE ppracpom as N set zacatek = (select H.zacatek from ppracpomhlav as H where N.idpracpomhlav = H.idpracpomhlav),
                         konecpomeru = (select H.konecpomeru from ppracpomhlav as H where N.idpracpomhlav = H.idpracpomhlav)
    where comparedate(zacatek, (select H.zacatek from ppracpomhlav as H where N.idpracpomhlav = H.idpracpomhlav)) = false or
       comparedate(konecpomeru, (select H.konecpomeru from ppracpomhlav as H where N.idpracpomhlav = H.idpracpomhlav)) = false;

ALTER TABLE pmzdsloz ENABLE TRIGGER pmzdslozupdatedatumvypoctu;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 469, 't', %appVersion%, clock_timestamp());
