------------------------------------------------------------------------------------
-- Bug 24148 – [WinStrom] Pořadí výpočtu průměrné ceny
------------------------------------------------------------------------------------
-- Bug 23739 – [WinStrom] Umoznit vraceni vyrobnich cisel na sklad prijemkou
------------------------------------------------------------------------------------

alter table dpolsklad disable trigger all;
alter table ddoklsklad disable trigger all;

alter table ddoklsklad add column datsklad date;
alter table dpolsklad add column datsklad date;

update ddoklsklad set datSklad = datVyst;
update dpolsklad set datSklad = datVyst;

alter table ddoklsklad alter column datsklad set not null;
alter table dpolsklad alter column datsklad set not null;

UPDATE ddoklsklad AS ds1
  SET typPohybuSkladK = 'typPohybuSklad.prijemVydejVratka'
  FROM ddoklsklad ds
  inner join dvazebtab vt on vt.idTabB = ds.iddoklsklad and vt.modulB = 'SKL' and typVazbyK = 'typVazbyDokl.hlavaSkl'
  inner join ddoklfak df on vt.idtaba = df.idDoklFak and (vt.modulA = 'FAP')
  inner join dtypdokl td on df.idTypDokl = td.idTypDokl and td.typDoklK = 'typDokladu.dobropis'
  where ds1.iddoklsklad = ds.idDoklSklad and ds.typPohybuSkladK = 'typPohybuSklad.prijemPoFak';

UPDATE ddoklsklad AS ds1
  SET typPohybuSkladK = 'typPohybuSklad.prijemVratka'
  FROM ddoklsklad ds
  inner join dvazebtab vt on vt.idTabB = ds.iddoklsklad and vt.modulB = 'SKL' and typVazbyK = 'typVazbyDokl.hlavaSkl'
  inner join ddoklfak df on vt.idtaba = df.idDoklFak and (vt.modulA = 'FAV')
  inner join dtypdokl td on df.idTypDokl = td.idTypDokl and td.typDoklK = 'typDokladu.dobropis'
  where ds1.iddoklsklad = ds.idDoklSklad and ds.typPohybuSkladK = 'typPohybuSklad.prijemPoFak';

alter table dpolsklad enable trigger all;
alter table ddoklsklad enable trigger all;

-- Function: createdoklsklad(integer, integer, character varying)

-- DROP FUNCTION createdoklsklad(integer, integer, character varying);

CREATE OR REPLACE FUNCTION createdoklsklad(_idpoldokl integer, _iddoklad integer, _modul character varying)
  RETURNS integer AS
$BODY$ 
declare 
  _doklad record; 
  _polDokl record; 
  _doklSklad record; 
  _idDoklSklad integer; 
  _cisDoklad character varying; 
  _idrada integer; 
  _rada record; 
  _sklad record; 
  _idUcetObd integer; 
  _radaRok record; 
  _typPohybuSklad character varying; 
  _idTypUcOp integer; 
  _cisloDokladuCursor refCursor; 
  _typDoklFak record; 
  _typDoklSkl record; 
  _idUcetSklad integer; 
  _idProtiUcet integer; 
  _typUcOp record; 
  _kurz numeric(19,6); 
  _idMenyTuzemsko integer; 
  _idMenySklad integer; 
  _kurzMnozstvi integer; 
  _typVazby character varying; 
  _stavSklad character varying; 
  _typPohybuSkladK character varying; 
  _isDobropis boolean; 
  _datSklad date; 
  _ucetObdPlatiOd date;
  _ucetObdPlatiDo date;
begin 
  if(_modul like 'POK') then 
    select * into _doklad from dDoklInt where idDoklInt = _idDoklad; 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    _stavSklad = 'stavSklad.vygenPokl'; 
  elsif (_modul like 'FAV' or _modul like 'FAP') then 
    select * into _doklad from dDoklFak where idDoklFak = _idDoklad; 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    _stavSklad = 'stavSklad.vygenFakt'; 
  else 
    select * into _doklad from dDoklSklad where idDoklSklad = _idDoklad; 
    select * into _polDokl from dPolSklad where idPolSklad = _idPolDokl; 
    _stavSklad = 'stavSklad.vyroba'; 
  end if; 
 
  --select * into _sklad from dTypDokl where idTypDokl = _polDokl.idskladu; 
  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl; 
  select * into _typDoklFak from dTypDokl where idTypDokl = _doklad.idTypDokl; 
 
  if(_typDoklFak.typDoklK like 'typDokladu.dobropis') then
    _isDobropis = true;
  else
    _isDobropis = false;
  end if;
 
  if(_doklad.idTypDoklSkl is null) then 
    if((_modul like 'FAV' and _isDobropis) or (_modul like 'FAP')) then 
      --pro dobropisy vydanych faktur a prijate faktury budeme mit prijemku 
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuprijem; 
    elsif((_modul like 'FAV' and not _isDobropis)) then 
      --pro dobropisy prijatych faktur a vydane faktury budeme mit vydejku 
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuvydej; 
    elsif(_modul like 'POK' and _doklad.typPohybuK like 'typPohybu.prijem') then 
      --pro prijmovy pokladni doklad budeme mit vydejku 
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuvydej; 
    elsif(_modul like 'POK' and _doklad.typPohybuK like 'typPohybu.vydej') then 
      --pro vydajovy pokladni doklad budeme mit prijemku 
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuprijem; 
    elsif(_modul like 'SKL') then 
      -- vyroba 
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuvydej; 
    else 
      raise exception 'createdoklsklad:Nespravny modul %', _modul; 
    end if; 
    if(_typDoklSkl is null) then 
      return null; 
    end if; 
  else 
    select * into _typDoklSkl from dTypDokl where idTypDokl = _doklad.idTypDoklSkl; 
  end if; 
 
  -- urceni spravneho typu pohybu 
  if((_typDoklFak.modul like 'FAV') and (_typDoklFak.typDoklK like 'typDokladu.dobropis')) then 
    _typPohybuSklad = _doklad.typPohybuK; 
  else 
    if(_doklad.typPohybuK like 'typPohybu.prijem') then 
      _typPohybuSklad = 'typPohybu.vydej'; 
    else 
      _typPohybuSklad = 'typPohybu.prijem'; 
    end if; 
  end if; 
 
  -- doplneni zbyvajicich veci zavislich na typu pohybu 
  if(_typPohybuSklad like 'typPohybu.prijem') then 
    _idrada = _typDoklSkl.idRadyPrijem; 
    if(_idrada is null) then 
      _idRada = _sklad.idRadyPrijem; 
    end if; 
    if(_idRada is null) then 
      raise exception 'Neni odkud natahnout dokladovou radu.'; 
    end if; 
    _idTypUcOp = _typDoklSkl.idTypUcOpP; 
    if(_modul = 'FAV' or _modul = 'FAP' or _modul = 'POK') then 
      _typPohybuSkladK = 'typPohybuSklad.prijemPoFak'; 
    else 
      _typPohybuSkladK = 'typPohybuSklad.prijemVyrob'; 
    end if; 
  else 
    _idrada = _typDoklSkl.idRadyVydej; 
    if(_idrada is null) then 
      _idRada = _sklad.idRadyVydej; 
    end if; 
    if(_idRada is null) then 
      raise exception 'Neni odkud natahnout dokladovou radu.'; 
    end if; 
    _idTypUcOp = _typDoklSkl.idTypUcOpV; 
    if(_modul = 'FAV' or _modul = 'FAP' or _modul = 'POK') then 
      _typPohybuSkladK = 'typPohybuSklad.vydejPoFak'; 
    else 
      _typPohybuSkladK = 'typPohybuSklad.vydejVyrob'; 
    end if; 
  end if; 
 
  _idUcetSklad = _sklad.idPrimUcet; 
  select * into _typUcOp from utypucop where idtypucop = _idTypUcOp; 
  if(_typPohybuSklad like 'typPohybu.prijem') then 
    _idProtiUcet = _typUcOp.idProtiucetP; 
  else 
    _idProtiUcet = _typUcOp.idProtiucetV; 
  end if; 
  if(_modul = 'FAP') then 
    _idProtiUcet = _doklad.idProtiUcet; 
  end if; 
 
  select * into _rada from drady where idRady = _idrada; 
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _idUcetObd; 
  select * into _radaRok from dRadyRok where iducetobdobi = _idUcetObd and idrady = _idrada; 
 
  select nextval('seq_ddoklsklad') into _idDoklSklad; 
  select dgetcisdokl(null, _idrada, _idUcetObd, 'SKL', _typPohybuSklad) into _cisloDokladuCursor; 
  fetch _cisloDokladuCursor into _cisDoklad; 
 
  -- ziskani kurzu pro menu skladu 
  -- select getKurzFromSklad(_polDokl.idSkladu, _polDokl.datVyst) into _kurz; 
  -- nejde pouzit protoze potrebuju jak kurz tak kurzove mnozstvi a ne prepocteny nna kurzove mnozstvi 1 
  select idMeny into _idMenyTuzemsko from nNastav where _polDokl.datVyst >= PlatiOdData order by PlatiOdData desc limit 1; 
  if (_idMenyTuzemsko is null) then 
    select idMeny into _idMenyTuzemsko from nNastav where PlatiOdData is null limit 1; 
  end if; 
  --select idMeny into _idMenySklad from dTypDokl where idTypDokl = _polDokl.idSkladu; 
 
  if(_sklad.idMeny is null or _sklad.idMeny = _idMenyTuzemsko) then 
    _kurz = 0.0; 
    _kurzMnozstvi = 1; 
  else 
    select nbStred, kurzMnozstvi into _kurz, _kurzMnozstvi from uKurzy 
      where idMeny = _sklad.idMeny and _polDokl.datVyst >= PlatiOdData and typkurzuk = 'typKurzu.obecny' 
      order by PlatiOdData desc limit 1; 
    if(_kurz is null) then 
      select nbStred, kurzMnozstvi into _kurz, _kurzMnozstvi from uKurzy 
        where idMeny = _sklad.idMeny and PlatiOdData is null and typkurzuk = 'typKurzu.obecny' 
        limit 1; 
    end if; 
    if(_kurz is null) then 
      raise exception '0001:getKurzFromSklad : neexistuje kurz!'; 
    end if; 
  end if; 

  select CURRENT_DATE into _datSklad;
  select platiOdData, platiDoData into _ucetObdPlatiOd, _ucetObdPlatiDo from nucetobdobi where idUcetObdobi = _idUcetObd;
  if(_datSklad < _ucetObdPlatiOd) then
    _datSklad = _ucetObdPlatiOd;
  elsif (_datSklad > _ucetObdPlatiDo) then
    _datSklad = _ucetObdPlatiDo;
  else
    -- datSklad je v pohode
  end if; 
 
  if(_isDobropis) then
    if(_modul like 'FAV') then
      _typPohybuSkladK = 'typPohybuSklad.prijemVratka';
    else
      _typPohybuSkladK = 'typPohybuSklad.prijemVydejVratka';
    end if;
  end if;

  -- vytvoreni noveho skladoveho dokladu 
  insert into dDoklSklad (idDoklSklad, lastUpdate, datVyst, datSklad, datUcto, kod, modul, typPohybuK, idTypDokl, idBsp,ucetni, 
         idFirmy, nazFirmy, ulice, mesto, psc, idStatu, ic, dic, vatId, 
         idMur, idKrajUrc, idStatUrc, idTypUcOp, cisObj, cisDodak, doprava, idDruhDopr, popis, poznam, 
         idStred, idZakazky, idMeny, kurz, kurzMnozstvi, 
         eanKod, idstatpuvod, idstatodesl, 
         idPrimUcet, idProtiUcet, idRady, idPolRady, zdrojProFak, stavSkladK , typPohybuSkladK, 
         idCinnost, idKontaktOsoba, idZodpOsoba 
         ) 
       values (_idDoklSklad, LOCALTIMESTAMP, _doklad.datVyst, _datSklad, _doklad.datVyst, _cisDoklad, 'SKL', _typPohybuSklad, _typDoklSkl.idTypDokl, _sklad.idBsp, _typDoklSkl.ucetni, 
         _doklad.idFirmy, _doklad.nazFirmy, _doklad.ulice, _doklad.mesto, _doklad.psc, _doklad.idStatu, _doklad.ic, _doklad.dic, _doklad.vatId, 
         _doklad.idMur, _doklad.idKrajUrc, _doklad.idStatUrc, _idTypUcOp, _doklad.cisObj, null, _doklad.doprava, _doklad.idDruhDopr, _doklad.popis, _doklad.poznam, 
         _doklad.idStred, _doklad.idZakazky, _sklad.idMeny, _kurz, _kurzMnozstvi, 
         _doklad.eanKod, _doklad.idstatpuvod, _doklad.idstatodesl, 
         _idUcetSklad, _idProtiUcet, _idRada, _radaRok.idRadyRok, false, _stavSklad, _typPohybuSkladK, 
         _doklad.idCinnost, _doklad.idKontaktOsoba, _doklad.idZodpOsoba 
         ); 
 
 
  if (_modul = 'SKL') then 
    _typVazby = 'typVazbyDokl.hlavaSklKus'; 
  else 
    _typVazby = 'typVazbyDokl.hlavaSkl'; 
  end if; 
 
  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK) 
       values (0.0, _idDoklad, _idDoklSklad, _doklad.modul, 'SKL', false, _typVazby); 
 
  return _idDoklSklad; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createdoklsklad(integer, integer, character varying) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION createPolSklad(_idPolDokl integer, _modul character varying) RETURNS integer AS
$BODY$
declare
  _idDoklSklad integer;
  _idDoklad integer;
  _polDokl record;
  _iducetobdobi integer;
  _idkarty integer;
  _idPolSklad integer;
  _cenaMj numeric(19,6);
  _cenaMjTuz numeric(19,6);
  _typPohybuK character varying;
  _prumCenaTuz numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _kurz numeric(19,6);
  _idZklMdUcet integer;
  _idZklDalUcet integer;
  _kopZklMdUcet boolean;
  _kopZklDalUcet boolean;
  _sklad record;
  _typDoklK character varying;
  _mnozMj numeric(19,6);
  _isCiziMena boolean;
  _idMeny integer;  
  _skupZboz record;
  _idTypUcOp integer;
  _datSklad date;
begin
  _kopZklMdUcet =false;
  _kopZklDalUcet = false;
  if(_modul like 'FAV' or _modul like 'FAP') then
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;
    _idDoklad = _polDokl.idDoklFak;
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);
  else
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;
    _idDoklad = _polDokl.idDoklInt;
    _typDoklK = null; -- pro pokladnu dobropisy nejsou
  end if;

  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad;
  
  if(_idDoklSklad is null) then
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;
    if(_idDoklSklad is null) then
      return null;
    end if;
  end if;

  select datSklad into _datSklad from ddoklSklad where idDoklSklad = _idDoklSklad;
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idskladu = _polDokl.idbspskl and iducetobdobi = _iducetobdobi;
  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl;
  
  select typPohybuK into _typPohybuK from dDoklSklad where idDoklSklad = _idDoklSklad;
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty;
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;
  select idMeny, idTypUcOp into _idMeny, _idTypUcOp from dDoklSklad where idDoklSklad = _idDoklSklad;
      
  if(_typPohybuK like 'typPohybu.vydej') then
    -- vsechny dobropisy generuji prijemky
    --if(_typDoklK like 'typDokladu.dobropis') then
    --  _mnozMj = -_polDokl.mnozMj;
    --else
      _mnozMj = _polDokl.mnozMj;
    --end if;
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena
    _cenaMj = _prumCenaTuz / _kurz;
    _sumZkl = _prumCenaTuz * _mnozMj;
    if(_isCiziMena) then
      _sumZklMen = _mnozMj * _cenaMj;
    else
      _sumZklMen = 0.0;
    end if;
    -- nastaveni uctu pro polSklad vydej
    select * into _skupZboz from cskupzboz where idskupzboz = (select idskupzboz from ccenik where idcenik = _polDokl.idCenik);
    if(_skupZboz.idProtiUcetSklV is not null) then
      -- pokud je ve skupine zbozi nastaven protiucet pro vydej ze skladu pouzije se ten a kopirovani se necha na false;
      _idZklMdUcet = _skupZboz.idProtiUcetSklV;
    else
      -- pokud neni ve skupine zbozi nastaven protiucet tak vemu protiucet z hlavicky a dam kopirovat na true
      select idProtiUcet into _idZklMdUcet from dDoklSklad where idDoklSklad = _idDoklSklad;
      _kopZklMdUcet = true;
    end if;
    _idZklDalUcet = _sklad.idPrimUcet;
  else
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny;
      _mnozMj = -_polDokl.mnozMj;
      --_cenaMjTuz = _prumCenaTuz;
      _cenaMjTuz = _polDokl.cenaMjNakup;
      if(_cenaMjTuz = 0.0) then
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik);
        if(_cenaMj = 0.0) then
          _cenaMj = _polDokl.cenaMj * _kurz;
        end if;
      end if;
      _cenaMj = _cenaMjTuz / _kurz;
      _sumZkl = _mnozMj * _cenaMjTuz;
      if(_isCiziMena) then
        _sumZklMen = _mnozMj * _cenaMj;
      else
        _sumZklMen = 0.0;
      end if;
      select * into _skupZboz from cskupzboz where idskupzboz = (select idskupzboz from ccenik where idcenik = _polDokl.idCenik);
      if(_skupZboz.idProtiUcetSklV is not null) then
        -- pokud je ve skupine zbozi nastaven protiucet pro vydej ze skladu pouzije se ten a kopirovani se necha na false;
        _idZklDalUcet = _skupZboz.idProtiUcetSklV;
      else
        -- pokud neni ve skupine zbozi nastaven protiucet tak vemu protiucet z hlavicky a dam kopirovat na true
        select idProtiUcet into _idZklDalUcet from dDoklSklad where idDoklSklad = _idDoklSklad;
        _kopZklDalUcet = true;
      end if;
    else
      -- pokud na sklad prijmam zkopiruji se ceny z faktury
      _mnozMj = _polDokl.mnozMj;
      _sumZkl = _polDokl.sumZkl;
      if(_mnozMj <> 0.0) then
        _cenaMj = _sumZkl / _mnozMj;
      else
        _cenaMj = _sumZkl;
      end if;
      _cenaMj = _cenaMj / _kurz;
      if(_isCiziMena) then
        if(_mnozMj <> 0.0) then
          _sumZklMen = _cenaMj * _mnozMj;  
        else
          _sumZklMen = _cenaMj;
        end if;
      else
        _sumZklMen = 0.0;  
      end if;
      _idZklDalUcet = _polDokl.idZklMdUcet;
    end if;
    -- nastaveni uctu pro polSklad prijem
    _idZklMdUcet = _sklad.idPrimUcet;
  end if;
  
  select nextval('seq_dpolsklad') into _idPolSklad;  
  insert into dpolsklad(idPolSklad, lastUpdate, idcenik, idbspskl, idkarty, datVyst, datSklad, datUcto, modul, typPolozkyK, idDoklSklad,
        mnozMj, cenaMj, cenaMjPoriz, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, idmj,
        nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni, 
        idStred, idZakazky, idMeny, zdrojProFak, idCinnost, idTypUcOp)
      values (_idPolSklad, LOCALTIMESTAMP, _polDokl.idcenik, _polDokl.idbspskl, _idkarty, _polDokl.datVyst, _datSklad, _polDokl.datVyst, 'SKL', 'typPolozky.katalog', _idDoklSklad,
        _mnozMj, _cenaMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, _kopZklMdUcet, _kopZklDalUcet, _polDokl.baleniid, _polDokl.mnozBaleni, _polDokl.idmj,
        _polDokl.nazev, _polDokl.nazevA, _polDokl.nazevB, _polDokl.nazevC, _polDokl.sarze, _polDokl.expirace, _polDokl.cisRad, true, 
        _polDokl.idStred, _polDokl.idZakazky, _idMeny, false, _polDokl.idCinnost, _idTypUcOp);
 
  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)
       values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSkl');

  -- prepocteni sum na dokladu
  execute sprepoctiSumyDokladu(_idDoklSklad);

  return _idPolSklad;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createPolSklad(integer, character varying) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION createPolSkladSada(_idPolDokl integer, _modul character varying)
  RETURNS void AS
$BODY$ 
declare
  _polDokl record;
  _doklad record;
  _polozkaSady record;
  _skladKarta record;
  _cenik record;
  _sklad record;
  _idDoklSklad integer;
  _idDoklad integer;
  _idMeny integer;
  _idUcetObdobi integer;
  _idKarty integer;
  _idPolSklad integer;
  _idZklMdUcet integer;
  _idZklDalUcet integer;
  _i integer;
  _cisRad integer;
  _typDoklK character varying;
  _mnozMj numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _cenaMj numeric(19,6);
  _kurz numeric(19,6);
  _isCiziMena boolean;
  _nasobic integer;
  _idSkladu integer;
  _kopZklMdUcet boolean;
  _kopZklDalUcet boolean;
  _idTypUcOp integer;
  _datSklad date;
begin

  if(_modul like 'FAV' or _modul like 'FAP') then 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    _idDoklad = _polDokl.idDoklFak;
    select * into _doklad from dDoklFak where idDoklFak = _idDoklad;
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak); 
  else 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    _idDoklad = _polDokl.idDoklInt;
    select * into _doklad from dDoklInt where idDoklInt = _idDoklad;
    _typDoklK = null; -- pro pokladnu dobropisy nejsou 
  end if;

  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad; 
  
  if(_idDoklSklad is null) then 
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad; 
    if(_idDoklSklad is null) then
      return;
    end if;
  end if;

  select datSklad into _datSklad from ddoklSklad where idDoklSklad = _idDoklSklad;
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena; 
  select idMeny, idTypUcOp into _idMeny, _idTypUcOp from dDoklSklad where idDoklSklad = _idDoklSklad;

  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl;

  _i = 0;

  FOR _polozkaSady IN
    select * from cSady where idCenikSada = _polDokl.idCenik
  LOOP
    select * into _cenik from cCenik where idCenik = _polozkaSady.idCenik;

    if(_cenik.skladove) then
      _i = _i + 1;
      _cisRad = 100 * _polDokl.cisRad + _i;
  
      select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi; 

      _idSkladu = _polDokl.idBspSkl;

      select * into _skladKarta from skarty 
        where idSkladu = _idSkladu and idCenik = _polozkaSady.idCenik and idUcetObdobi = _idUcetObdobi;

      -- pokud neexistuje skladova karta pokusim se ji najit pomoci mapovani skladu
      if(_skladKarta is null) then
        select getPrefIdSkladu(_polDokl.idStred, _cenik.idSkupZboz, _cenik.idCenik) into _idSkladu;
        select * into _skladKarta from skarty
          where idSkladu = _idSkladu and idCenik = _cenik.idCenik and idUcetObdobi = _idUcetObdobi;
        if(_skladKarta is null) then
          -- pokud ani podle mapovani skladu se skladova karta nenajde tak vyhazuju vyjimku
          raise exception '0007:Skladová karta neexistuje pro ceník % a sklad % a nebo je špatně nastaveno mapovaní skladu.', _cenik.nazev, _sklad.nazev;
        end if;
      else
        _idSkladu = _skladKarta.idSkladu;
      end if;
      _nasobic = 1;
      if(_typDoklK like 'typDokladu.dobropis') then
        _nasobic = -1;
      end if;
      _mnozMj = _polozkaSady.mnozMj * _polDokl.mnozMj * _nasobic;
      _cenaMj = _skladKarta.prumCenaTuz / _kurz;
      _sumZkl = _mnozMj * _skladKarta.prumCenaTuz;
      if(_isCiziMena) then 
        _sumZklMen = _mnozMj * _cenaMj; 
      else 
        _sumZklMen = 0.0; 
      end if;
    
      -- nastaveni uctu pro polSklad vydej 
      _kopZklMdUcet = false;
      _kopZklDalUcet = false;
      if(_typDoklK like 'typDokladu.dobropis') then
        -- dal ucet je ze skupiny zbozi nebo z hlavicky pokud neni ve skupine zbozi nastaven
        select idProtiUcetSklV into _idZklDalUcet from cSkupZboz where idSkupZboz = _cenik.idSkupZboz;
        if(_idZklDalUcet is null) then
          select idProtiUcet into _idZklDalUcet from dDoklSklad where idDoklSklad = _idDoklSklad;
          --pokud je z hlavicky tak se bude kopirovat
          _kopZklDalUcet = true;
        end if;
        -- md ucet musi byt primarni ucet skladu ze ktereho se kousky sady vydavaji
        select idPrimUcet into _idZklMdUcet from dBsp where idBsp = _idSkladu;
      else
        -- md ucet je ze skupiny zbozi nebo z hlavicky pokud neni ve skupine zbozi nastaven
        select idProtiUcetSklV into _idZklMdUcet from cSkupZboz where idSkupZboz = _cenik.idSkupZboz;
        if(_idZklMdUcet is null) then
          select idProtiUcet into _idZklMdUcet from dDoklSklad where idDoklSklad = _idDoklSklad;
          --pokud je z hlavicky tak se bude kopirovat
          _kopZklMdUcet = true;
        end if;
        -- dal ucet musi byt primarni ucet skladu ze ktereho se kousky sady vydavaji
        select idPrimUcet into _idZklDalUcet from dBsp where idBsp = _idSkladu;
      end if;

      select nextval('seq_dpolsklad') into _idPolSklad;
      insert into dpolsklad(idPolSklad, lastUpdate, idcenik, idBspSkl, idkarty, datVyst, datSklad, datUcto, modul, typPolozkyK, idDoklSklad,
          mnozMj, cenaMj, cenaMjPoriz, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, idmj,
          nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni,  
          idStred, idZakazky, idMeny, zdrojProFak, idCinnost, idTypUcOp)
        values (_idPolSklad, LOCALTIMESTAMP, _polozkaSady.idcenik, _idSkladu, _skladKarta.idKarty, _polDokl.datVyst, _datSklad, _polDokl.datVyst, 'SKL', 'typPolozky.katalog', _idDoklSklad,    
          _mnozMj, _cenaMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, _kopZklMdUcet, _kopZklDalUcet, _polDokl.baleniid, 0.0, _cenik.idmj1,
          _cenik.nazev, _cenik.nazevA, _cenik.nazevB, _cenik.nazevC, null, null, _cisRad, true,  
          _polDokl.idStred, _polDokl.idZakazky, _idMeny, false, _polDokl.idCinnost, _idTypUcOp);

      insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)  
        values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSklSada');  
    end if; 
  END LOOP; 

  execute sprepoctiSumyDokladu(_idDoklSklad); 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createPolSkladSada(integer, character varying) OWNER TO %firmaRole%;


--------------------------------------------------------------------------------

-- Function: dpolskladinsert()
-- DROP FUNCTION dpolskladinsert();
CREATE OR REPLACE FUNCTION dpolskladinsert()
  RETURNS trigger AS
$BODY$ 
declare 
  _rozsirenaPolozka record; 
  _typPohybuk character varying; 
  _mazatTmpTable boolean; 
  _idPolSklad integer; 
  _probihaPrepocetSkladu character varying; 
begin 
  select getglotxvariable('probihaPrepocetSkladu') into _probihaPrepocetSkladu; 
  if(_probihaPrepocetSkladu = 'true') then 
  else 
    -- v pripade ze neprobiha prepocet skladu 
    -- generuji rozsirene polozky 
    select skladGenerujRozsirenePolozky(NEW.datSklad, NEW.idPolSklad, NEW.idKarty) into _mazatTmpTable; 
 
    execute putglotxvariable('zurnalTxName', 'prepocetSkladu'); 
 
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
      if(_rozsirenaPolozka.idPolSklad <> NEW.idPolSklad) then 
        execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
      end if; 
    end loop; 
 
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
      execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
    end loop; 
 
    if(_mazatTmpTable) then 
      drop table tmp_RozsirenePolozky; 
      drop table tmp_SkladoveKarty; 
      execute removeglotxvariable('zurnalTxName'); 
    end if; 
  end if; 
 
  select typpohybuk into _typPohybuk from ddoklsklad where iddoklsklad = NEW.iddoklsklad; 
  --pokud výdej, tak fifuju vazby 
  if (_typPohybuk = 'typPohybu.vydej' or (_typPohybuK = 'typPohybu.prijem' and NEW.mnozMj < 0.0)) then 
    execute sFifoVydej(NEW.idPolSklad, NEW.idCenik, NEW.idBspSkl, NEW.idKarty, NEW.mnozmj); 
    execute sPrepoctiSumyDokladu(NEW.idDoklSklad); 
  end if; 
 
  if(_probihaPrepocetSkladu = 'true') then 
    if(NEW.idPolSklad < 0) then 
      _idPolSklad = -NEW.idPolSklad; 
    else 
      _idPolSklad = NEW.idPolSklad; 
    end if; 
 
    execute skladinsertrozsirenoupolozku(_idPolSklad); 
  end if; 
 
  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladinsert() OWNER TO %firmaRole%;

-- Function: dpolskladdelete()
-- DROP FUNCTION dpolskladdelete();
CREATE OR REPLACE FUNCTION dpolskladdelete()
  RETURNS trigger AS
$BODY$ 
declare 
  _rozsirenaPolozka record; 
  _mazatTmpTable boolean;  
begin 
  if(not OLD.storno) then 
    -- generuji rozsirene polozky 
    select skladGenerujRozsirenePolozky(OLD.datSklad, OLD.idPolSklad, OLD.idKarty) into _mazatTmpTable; 
 
    execute putglotxvariable('zurnalTxName', 'prepocetSkladu'); 
 
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
      if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then  
        execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
      else  
        --raise exception 'v rozsirenych polozkach je mazana polozka s id %', _rozsirenaPolozka;  
      end if; 
    end loop; 
 
    -- musim jeste odpocist mazanou polozku 
    --execute skladOdpoctiRozsirenouPolozku(OLD.idPolSklad); 
    execute sprepoctiskladkartu(OLD.mnozMj, OLD.cenaMj, OLD.datSklad, OLD.idKarty, OLD.idDoklSklad, OLD.idBspSkl, -1); 
   
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
      if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then 
        execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
      else 
        --raise exception 'v rozsirenych polozkach je mazana polozka s id %', _rozsirenaPolozka;  
      end if; 
    end loop; 
     
    execute sfifostorno(OLD.idPolSklad, OLD.idDoklSklad); 
 
    if(_mazatTmpTable) then 
      drop table tmp_RozsirenePolozky; 
      drop table tmp_SkladoveKarty; 
      execute removeglotxvariable('zurnalTxName'); 
    end if; 
  end if;  
   
  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladdelete() OWNER TO %firmaRole%;

-- Function: dpolskladupdate()
-- DROP FUNCTION dpolskladupdate();
CREATE OR REPLACE FUNCTION dpolskladupdate()
  RETURNS trigger AS
$BODY$  
declare  
  tmp_rozsirenepolozky_exists boolean;  
  _updatuj boolean;  
  _pocetPolozek integer;  
  _rozsirenaPolozka record;  
  _sklFifo boolean;  
  _vypnutySklad character varying; 
  _mazatTmpTable boolean;  
begin  
  if(NEW.idBspSkl = OLD.idBspSkl and NEW.idCenik = OLD.idCenik and comparedate(NEW.datSklad, OLD.datSklad) 
    and comparevarchar(NEW.typPolozkyK, OLD.typPolozkyK) 
    and comparevarchar(NEW.sarze, OLD.sarze) and comparedate(NEW.expirace, OLD.expirace) 
    and NEW.mnozMj = OLD.mnozMj and NEW.cenaMj = OLD.cenaMj and NEW.sumZkl = OLD.sumZkl and NEW.sumZklMen = OLD.sumZklMen 
    and NEW.storno = OLD.storno  
  ) then 
    return NEW; 
  end if; 
 
  /*  
    prepocet skladu budeme provadet jen v okamziku kdy neexistuje tabulka tmp_rozsirenePolozky  
    nebo kdyz tato tabulka existuje ale neni v ni obsazeno polozka kteoru chceme updatovat  
  */  
  select getglotxvariable('vypniSklad') into _vypnutySklad;  
  if(_vypnutySklad is null or _vypnutySklad <> 'true') then  
    _updatuj = true;  
    tmp_rozsirenepolozky_exists := (select istableexist('tmp_RozsirenePolozky'));  
    if(tmp_rozsirenepolozky_exists = true) then  
      select count(*) into _pocetPolozek from tmp_rozsirenePolozky where idPolSklad = NEW.idPolSklad;  
      if(_pocetPolozek > 0) then  
        _updatuj = false;  
      end if;  
    end if;  
  
    if(OLD.idPolSklad < 0 and NEW.idPolSklad > 0) then  
      _updatuj = false;  
    end if;  
    
    _sklfifo := (select isfifosklad(NEW.datSklad));    
    if (_sklfifo) then    
      --fifo    
      if (OLD.storno=false and NEW.storno=true) then    
        execute sfifoStorno(OLD.idpolsklad, OLD.iddoklsklad);    
      end if;      
      if (OLD.cenamj <> NEW.cenamj) then    
        execute sfifocenamj(OLD.idpolsklad, OLD.iddoklsklad, NEW.cenamj);    
      end if;      
      --fifo konec    
    end if;    
  
    -- tohle musi byt i pro prumerne ceny protoze jinak se negeneruji fifo vazby 
    if (OLD.mnozMj = 0.0 and NEW.mnozMj != 0.0) then 
      execute sfifovydej(NEW.idPolSklad, NEW.idCenik, NEW.idBspSkl, NEW.idkarty, NEW.mnozMjPlan); 
    end if; 
     
    if(_updatuj) then  
  
      -- generuji rozsirene polozky  
      select skladGenerujRozsirenePolozky(NEW.datSklad, NEW.idPolSklad, NEW.idKarty) into _mazatTmpTable;  
      
      execute putglotxvariable('zurnalTxName', 'prepocetSkladu');  
   
      for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop  
        if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then  
          execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);  
        end if;  
      end loop;  
 
      if(OLD.storno = false) then 
        execute sprepoctiskladkartu(OLD.mnozMj, OLD.cenaMj, OLD.datSklad, OLD.idKarty, OLD.idDoklSklad, OLD.idBspSkl, -1); 
      end if; 
 
      for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop  
        if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then  
          execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);  
        else 
          if(NEW.storno = false) then 
            execute sprepoctiskladkartu(NEW.mnozMj, NEW.cenaMj, NEW.datSklad, NEW.idKarty, NEW.idDoklSklad, NEW.idBspSkl, 1); 
          end if; 
        end if; 
      end loop;  
  
      if(_mazatTmpTable) then  
        drop table tmp_RozsirenePolozky;  
        drop table tmp_SkladoveKarty;  
        execute removeglotxvariable('zurnalTxName');  
      end if;  
         
    end if;  
  end if; 
  return NEW;  
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladupdate() OWNER TO %firmaRole%;

-- Function: skladgenerujrozsirenepolozky(date, integer, integer)
-- DROP FUNCTION skladgenerujrozsirenepolozky(date, integer, integer);
CREATE OR REPLACE FUNCTION skladgenerujrozsirenepolozky(i_datum date, i_idpolsklad integer, i_idskladkarty integer)
  RETURNS boolean AS
$BODY$ 
declare 
  tmp_skladovekarty_exists boolean; 
  tmp_rozsirenepolozky_exists boolean; 
  _polSklad record; 
  _skladKarta record; 
  _pocetSkladKarty integer; 
  _result boolean; 
  _idUcetObd integer; 
begin 
  -- pokud se zde nebyli tabulky vytvoreny tak se vrati false a pokud ano tak se true 
  _result = false; 
 
  -- vytvoreni temporary tabulky pro ulozeni seznamu skladovych karet na kterych dochazi k prepoctu 
  tmp_skladovekarty_exists := (select istableexist('tmp_SkladoveKarty')); 
  if(tmp_skladovekarty_exists <> true) then 
    --raise exception 'tmp_skladoveKarty se vytvari'; 
    CREATE TEMPORARY TABLE tmp_SkladoveKarty ( 
      idskladkarty integer 
    ) WITH (OIDS=TRUE) ON COMMIT DROP; 
  end if; 
 
  -- vytvoreni temporary tabulky pro ulozeni seznamu polozek, ktere budou prepocitavat skladove karty 
  tmp_rozsirenepolozky_exists := (select istableexist('tmp_RozsirenePolozky')); 
  if(tmp_rozsirenepolozky_exists <> true) then 
    CREATE TEMPORARY TABLE tmp_RozsirenePolozky ( 
      idpolsklad integer, 
      iddoklskladMaster integer, 
      iddoklskladpolozky integer, 
      datum date, 
      skupina integer, 
      typPohybuK character varying, 
      idskladkarty integer, 
      storno boolean 
      --mnozMj numeric(19,6), 
      --cenaMj numeric(19,6), 
      --sumZkl numeric(19,6) 
    ) WITH (OIDS=TRUE) ON COMMIT DROP; 
 
    -- tabulky zde byli vytvoreny tim padem se musi vracet true 
    _result = true; 
  end if; 
   
  if(i_idSkladKarty is not null and i_idSkladKarty <> -1) then 
    -- pokud se jedna o prepocet po vlozeni jedna polozky nebo o rekurzi tak se vse dela jen s jednou skladovou kartou 
    select count(*) into _pocetSkladKarty from tmp_SkladoveKarty where idskladkarty = i_idSkladKarty; 
    if(_pocetSkladKarty = 0) then 
      insert into tmp_SkladoveKarty (idskladkarty) values (i_idSkladKarty); 
      for _polSklad in (select * from dpolsklad where datSklad >= i_datum and idkarty = i_idSkladKarty) loop 
        execute skladInsertRozsirenouPolozku(_polSklad.idPolSklad); 
      end loop; 
    else 
      -- do something stupid - kdyz je skladkarta v seznamu 
    end if; 
  else 
    -- pokud se jedna o celkovy prepocet skladu tak do tmp tabulky skladovych karet dam vsechny pro dane obdobi 
    select iducetobdobi into _idUcetObd from nucetobdobi where platioddata <= i_datum and platidodata >= i_datum; 
    for _skladKarta in (select * from skarty where iducetobdobi = _idUcetObd) loop 
      insert into tmp_SkladoveKarty(idskladkarty) values (_skladKarta.idKarty); 
      --for _polSklad in (select * from dpolsklad where datSklad >= i_datum and idkarty = _skladKarta.idKarty) loop 
      -- tento for cyklus je spatne protoze pokud jsou spatna data (dat vyst je 2010 a karta 2011) tak k prepoctu nedojde 
      for _polSklad in (select * from dpolsklad where idkarty = _skladKarta.idKarty) loop 
        execute skladInsertRozsirenouPolozku(_polSklad.idPolSklad); 
      end loop; 
    end loop; 
  end if; 
 
  return _result; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladgenerujrozsirenepolozky(date, integer, integer) OWNER TO %firmaRole%;

-- Function: skladinsertrozsirenoupolozku(integer)
-- DROP FUNCTION skladinsertrozsirenoupolozku(integer);
CREATE OR REPLACE FUNCTION skladinsertrozsirenoupolozku(i_idpolsklad integer)
  RETURNS void AS
$BODY$ 
declare 
  _polSklad record; 
  _navazanaPolSklad record; 
  _pocetRozsirenePolSklad integer; 
  _typPohybuK character varying; 
  _pocetProSkupinu integer; 
  _skupina integer; 
  _idDoklSkladMaster integer; 
  _idDoklSkladMasterPom integer; 
  _mazatTmpTable boolean; 
begin 
  select * into _polSklad from dPolSklad where idPolSklad = i_idPolSklad; 
  select count(*) into _pocetRozsirenePolSklad from tmp_RozsirenePolozky where idPolSklad = _polSklad.idPolSklad; 
  if(_pocetRozsirenePolSklad = 0) then 
    select typPohybuK into _typPohybuK from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad; 
 
    -- urceni skupiny do ktere dana polozka patri 
    _skupina = 2; 
    select count(*) into _pocetProSkupinu from dvazebtab  
         where (idtabA = _polSklad.idPolSklad and modulA = 'SKL' and (typVazbyK = 'typVazbyDokl.polozkaSklPrevod' or typVazbyK = 'typVazbyDokl.polozkaSklKus')) 
             or (idtabB = _polSklad.idPolSklad and modulB = 'SKL' and (typVazbyK = 'typVazbyDokl.polozkaSklPrevod' or typVazbyK = 'typVazbyDokl.polozkaSklKus')); 
    if(_pocetProSkupinu = 0) then 
      if(_typPohybuK = 'typPohybu.prijem') then 
        _skupina = 1; 
      else 
        _skupina = 3; 
      end if; 
    end if; 
 
    -- urceni id skladoveho doklad ktery je master 
    _idDoklSkladMaster = _polSklad.idDoklSklad; 
    if(_skupina = 2) then 
      -- _idDoklSkladMasterPom 
      select idtabA into _idDoklSkladMasterPom from dvazebtab where idtabB = _polSklad.idDoklSklad and modulB = 'SKL' and modulA = 'SKL' and  
          (typVazbyK = 'typVazbyDokl.hlavaSklPrevod' or typVazbyK = 'typVazbyDokl.hlavaSklKus'); 
      if(_idDoklSkladMasterPom is not null) then 
        _idDoklSkladMaster = _idDoklSkladMasterPom; 
      end if; 
    end if; 
 
    -- rekurzi spoustim pro prevodku a kusovnik 
    if(_skupina = 2 and _typPohybuK = 'typPohybu.vydej') then 
      select * into _navazanaPolSklad from dPolSklad  
        where idPolSklad = (select idTabB from dvazebtab where idTabA = _polSklad.idPolSklad and modulA = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
 
      -- pokud neni soucasti prevodky tak se jedna o kusovnik 
      if(_navazanaPolSklad is null) then 
        select * into _navazanaPolSklad from dPolSklad 
          where idPolSklad = (select idTabA from dVazebTab where idTabB = _polSklad.idPolSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus'); 
      end if; 
       
      if(_navazanaPolSklad is null) then 
        --raise notice 'navazana je null'; 
      else 
        --raise notice 'volam rekurzi'; 
        select skladGenerujRozsirenePolozky(_navazanaPolSklad.datSklad, _navazanaPolSklad.idPolSklad, _navazanaPolSklad.idKarty ) into _mazatTmpTable; 
      end if; 
    end if; 
 
    -- vlozeni zaznamu o polozce do tmp tabulky 
    insert into tmp_RozsirenePolozky (idpolsklad, iddoklskladMaster, datum, skupina, typPohybuK, idskladkarty, /*mnozMj, cenaMj, sumZkl,*/ iddoklskladpolozky, storno) 
            values (_polSklad.idPolSklad, _idDoklSkladMaster, _polSklad.datSklad, _skupina, _typPohybuK, _polSklad.idkarty, /*_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl,*/ _polSklad.idDoklSklad, _polSklad.storno); 
  else 
    -- do something stupid - kdyz je polozka v seznamu 
  end if; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladinsertrozsirenoupolozku(integer) OWNER TO %firmaRole%;

-- Function: sprepoctisklad(integer)
-- DROP FUNCTION sprepoctisklad(integer);
CREATE OR REPLACE FUNCTION sprepoctisklad(i_ucetobd integer)
  RETURNS void AS
$BODY$ 
declare 
  _rozsirenaPolozka record; 
  _zaznam record; 
  _vyrobniCislo record; 
  _pocatek_ucetobd date; 
  _konec_ucetobd date; 
  _evidVyrCis boolean; 
  _mazatTmpTable boolean; 
  _citac integer; 
  _pocetPred integer; 
  _pocetPo integer; 
begin 
 
  execute putglotxvariable('zurnalTxName', 'prepocetSkladu'); 
  execute putglotxvariable('probihaPrepocetSkladu', 'true'); 
 
  -- nacteni datumu zacatku ucetniho obdobi 
  select platioddata, platidodata into _pocatek_ucetobd, _konec_ucetobd from nucetobdobi where iducetobdobi = i_ucetobd; 
 
  -- smazani tabulky fifo vazeb 
  delete from sfifovazby where idpolskladvydej in 
    (select idpolsklad from dpolsklad where 
            datSklad >= _pocatek_ucetobd); 
 
  delete from sfifovazby f 
    where f.idpolskladvydej not in (select p.idpolsklad from dpolsklad p); 
 
  -- nagenerovani pomocnych tabulek 
  select skladGenerujRozsirenePolozky(_pocatek_ucetobd, -1, -1) into _mazatTmpTable; 
 
  select count(*) into _pocetPred from tmp_RozsirenePolozky; 
 
  -- provedu fifovani rozsirenych polozek 
  for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
    select * into _zaznam from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad; 
    if (_rozsirenaPolozka.typPohybuk = 'typPohybu.vydej'  or (_rozsirenaPolozka.typPohybuk = 'typPohybu.prijem' and _zaznam.mnozMj < 0.0)) then 
      select evidVyrCis into _evidVyrCis from ccenik where idcenik = _zaznam.idCenik; 
      if (not _evidVyrCis) then 
        execute sfifoVydej(_zaznam.idPolSklad, _zaznam.idCenik, _zaznam.idBspSkl, _zaznam.idKarty, _zaznam.mnozmj); 
      else 
        for _vyrobniCislo in select * from svyrobnicislo where idpolskladvydej = _zaznam.idPolSklad loop 
          update svyrobnicislo set idpolskladvydej = null where idvyrobnicislo = _vyrobniCislo.idvyrobnicislo; 
          update svyrobnicislo set idpolskladvydej = _zaznam.idPolSklad where idvyrobnicislo = _vyrobniCislo.idvyrobnicislo; 
        end loop; 
      end if; 
      execute sPrepoctiSumyDokladu(_zaznam.idDoklSklad); 
    end if; 
  end loop; 
 
  --select count(*) into _pocetPo from tmp_RozsirenePolozky; 
 
  -- vynulovani skladovych karet 
  execute skladVynulujSkladoveKarty(); 
 
  -- zafifovane veci zapoctu na skladove karty 
  for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
    execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
  end loop; 
 
  if(_mazatTmpTable) then 
    drop table tmp_RozsirenePolozky; 
    drop table tmp_SkladoveKarty; 
    execute removeglotxvariable('zurnalTxName'); 
    execute removeglotxvariable('probihaPrepocetSkladu'); 
  end if; 
 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sprepoctisklad(integer) OWNER TO %firmaRole%;

-- Function: dgetstavnasklade(integer, date, integer, character varying, date, character varying)
-- DROP FUNCTION dgetstavnasklade(integer, date, integer, character varying, date, character varying);
CREATE OR REPLACE FUNCTION dgetstavnasklade(i_skladkartaid integer, i_datum date, i_polskladid integer, i_sarze character varying, i_expirace date, i_typpohybuk character varying)
  RETURNS numeric AS
$BODY$       
declare      
  _pocMj numeric(19,6);      
  _obratMj numeric(19,6);      
  _stavMj numeric(19,6);      
  _idcenik integer;    
  _idskladu integer;    
  _typPohybuK character varying(50);    
  _sadaItemCount integer;  
  _polozkaSady record;  
  _idSkladKarty integer;  
  _iducetniobdobi integer;  
  _idPolSklad integer;  
  _stavSkladuSady numeric(19,6);  
  _mnozMj numeric(19,6);  
  _stavMjKarty numeric(19,6);  
  _rozpadlaPolSklad record;  
begin      
  SELECT pocatMj INTO _pocMj      
  FROM sKarty      
  WHERE idKarty = i_skladkartaid;      
      
  if (i_datum is null) then      
    raise exception '0005:dGetStavNaSklade : Vstupni parametr datum je null.';       
  end if;    
    
  _typPohybuK := i_typPohybuK;    
  --if (i_polskladid >= 0) then    
  --  select typPohybuK into _typPohybuK from ddoklsklad     
  --    where iddoklsklad = (select iddoklsklad from dpolsklad where idpolsklad = i_polskladid);    
  --end if;    
    
  select idcenik, idskladu, iducetobdobi into _idcenik, _idskladu, _iducetniobdobi from skarty where idkarty = i_skladkartaid;  
  
  -- zjistim jestli nahodu dany cenik neni sada nebo komplet  
  select count(*) into _sadaItemCount from csady where idceniksada = _idCenik;  
  -- pokud se nejedna o sadu tak funguju normalne  
  if(_sadaItemCount = 0) then  
    if ((i_sarze is null or i_sarze = '') and i_expirace is null) then     
      -- zkusime zjistit stav skladu k datu  
      if (i_polSkladId < 0) then        
        SELECT sum(CASE ds.typPohybuK WHEN 'typPohybu.prijem' THEN ps.mnozMj ELSE -ps.mnozMj END) INTO _obratMj        
        FROM dPolSklad ps LEFT OUTER JOIN dDoklSklad ds ON ps.idDoklSklad = ds.idDoklSklad        
        WHERE idkarty = i_skladkartaid AND ps.storno <> true AND ps.datSklad <= i_datum;        
      else        
        SELECT sum(CASE ds.typPohybuK WHEN 'typPohybu.prijem' THEN ps.mnozMj ELSE -ps.mnozMj END) INTO _obratMj        
        FROM dPolSklad ps LEFT OUTER JOIN dDoklSklad ds ON ps.idDoklSklad = ds.idDoklSklad        
        WHERE idkarty = i_skladkartaid AND ps.storno <> true AND (ps.datSklad < i_datum OR (ps.datSklad = i_datum AND ps.idPolSklad < i_polskladid));        
      end if;     
      if(_obratMj is null) then _obratMj = 0.0; end if;        
      if(_pocMj is null) then _pocMj = 0.0; end if;         
      _stavMj = _pocMj + _obratMj;     
      -- zkusime vypocitat stav na vrcholu  
      select stavMj into _stavMjKarty from skarty where idkarty = i_skladkartaid;  
      _mnozMj = 0.0;  
      if(i_polSkladId >= 0) then  
        select mnozMj into _mnozMj from dPolSklad where idPolSklad = i_polSkladId;  
      end if; 
      for _rozpadlaPolSklad in (select * from dPolSklad where idPolSklad in   
        (select idpolskladcil from svazbypolsklad where idpolskladzdroj = i_polSkladId))   
      loop   
        _mnozMj = _mnozMj + _rozpadlaPolSklad.mnozMj;  
      end loop;  
      if(_typPohybuK = 'typPohybu.vydej') then  
        _stavMjKarty = _stavMjKarty + _mnozMj;  
      else  
        _stavMjKarty = _stavMjKarty - _mnozMj;  
      end if;  
       
      -- spravna hodnota dle bugu 21375 minimum z obou hodnot  
      if(_typPohybuK = 'typPohybu.vydej') then  
        select minValue(_stavMj, _stavMjKarty) into _stavMj;  
      end if;  
    else     
      if ((i_sarze is not null and i_sarze <> '') and (i_expirace is null)) then     
        --raise exception 'idCenik = % and idSkladu = %', _idCenik, _idSkladu;    
        
        select sum(pocet) into _stavMj from dpolskladf where idcenik = _idcenik and idskladu = _idskladu and sarze = i_sarze;     
      elsif ((i_sarze is null or i_sarze = '') and (i_expirace is not null)) then     
        select sum(pocet) into _stavMj from dpolskladf where idcenik = _idcenik and idskladu = _idskladu and expirace = i_expirace;     
      else     
        select sum(pocet) into _stavMj from dpolskladf where idcenik = _idcenik and idskladu = _idskladu and sarze = i_sarze and expirace = i_expirace;     
      end if;     
      if (_typPohybuK is not null and _typPohybuK = 'typPohybu.prijem') then     
        select mnozMj into _obratMj from dpolsklad where idpolsklad = i_polskladid;     
        if(_stavMj is null) then     
          _stavMj := -_obratMj;     
        else     
          _stavMj := _stavMj - _obratMj;     
        end if;     
      elsif (_typPohybuK is not null and _typPohybuK = 'typPohybu.vydej') then     
        select mnozMj into _obratMj from dpolsklad where idpolsklad = i_polskladid;     
        if(_stavMj is null) then     
          _stavMj := _obratMj;     
        else     
          _stavMj := _stavMj + _obratMj;     
        end if;     
      end if;     
    end if;    
  else  
    for _polozkaSady in  
      select * from cSady where idCenikSada = _idCenik  
    loop  
      select idKarty into _idSkladKarty from sKarty where idCenik = _polozkaSady.idCenik and idSkladu = _idskladu and idUcetObdobi = _iducetniobdobi;  
      if(_idSkladKarty is not null) then   
        if(_stavMj is null) then  
          _stavMj = 9999999999999.0; -- vic uz pretejka  
        end if;  
        _idPolSklad = -1;  
        --TODO nejak doresit _idPolSklad, sarze a expirace;  
        select dgetstavnasklade(_idSkladKarty, i_datum, -1, i_sarze, i_expirace, _typPohybuK) into _stavSkladuSady;  
        _stavSkladuSady = _stavSkladuSady / _polozkaSady.mnozMj;  
	if(i_polskladid > 0) then  
	  select mnozMj into _mnozMj from dPolSklad where idPolSklad = i_polSkladId;  
          _stavSkladuSady = _stavSkladuSady + (_mnozMj/_polozkaSady.mnozMj);  
        end if;  
        select minValue(_stavMj, _stavSkladuSady) into _stavMj;  
      end if;  
    end loop;  
  end if;   
   
  -- muze se stat ze _stavMj je null a to znamena ze na sklade nic neni   
  if(_stavMj is null) then   
    _stavMj := 0;   
  end if;   
     
  RETURN _stavMj;       
end       
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dgetstavnasklade(integer, date, integer, character varying, date, character varying) OWNER TO %firmaRole%;

-- Function: skladprepoctirozsirenoupolozku(integer, integer)
-- DROP FUNCTION skladprepoctirozsirenoupolozku(integer, integer);
CREATE OR REPLACE FUNCTION skladprepoctirozsirenoupolozku(i_idrozsirenepolozky integer, sign integer)
  RETURNS void AS
$BODY$ 
declare 
  _skladKarta record; 
  _rozsirenaPolozka record; 
  _polSklad record; 
  _navazanaPolSklad record; 
  _stavMj numeric(19,6); 
  _stavTuz numeric(19,6); 
  _stavMen numeric(19,6); 
  _prumCenaTuz numeric(19,6); 
  _prumCenaMen numeric(19,6); 
  _pocetNavazanych integer; 
  _cenaMj numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _kurzDokladu numeric(19,6); 
  _kurzSkladKarty numeric(19,6); 
  _isCiziMena boolean; 
  _sklfifo boolean; 
  _datPosl date;  
  _PoslCenaTuz numeric(19,6);      
  _PoslCenaMen numeric(19,6);      
  _cenaMjSkl numeric(19,6); 
  _updateCena boolean; 
  _rozpadlaPolSklad record; 
  _sumZklProCenaMj numeric(19,6); 
  _mnozMjProCenaMj numeric(19,6); 
  _cenaMjPoriz numeric(19,6); 
  --_cenaMjNakl numeric(19,6); 
begin 
  select * into _rozsirenaPolozka from tmp_RozsirenePolozky where idpolsklad = i_idrozsirenepolozky; 
  select * into _polSklad from dPolSklad where idPolSklad = i_idrozsirenepolozky; 
  if(_polSklad is null) then 
    -- muze se stat ze v rozsirenych polozkach je uz polozka ktera byla v ramci transakce smazana 
    return; 
  end if; 
   
  select * into _skladKarta from sKarty where idKarty = _rozsirenaPolozka.idskladkarty; 
  select getKurzFromDoklad(_rozsirenaPolozka.idDoklSkladPolozky, _rozsirenaPolozka.datum) into _kurzDokladu; 
 
  if(sign = 1) then 
    if(_rozsirenaPolozka.skupina = 1) then 
      if(_polSklad.mnozMj = 0.0) then 
        _stavTuz = _polSklad.cenaMj * _kurzDokladu; 
      else 
        select sumZkl into _stavTuz from dpolsklad where idPolSklad = _rozsirenaPolozka.idPolSklad; 
      end if; 
    else 
      -- pokud se jedna o prijemku z prevodky nebo vyroby tak se musi cena nastavit podle navazane vydejky 
      _cenaMjSkl = 0.0; 
      _sklfifo := (select isfifosklad(_rozsirenaPolozka.datum)); 
      -- menit cenu budeme jen pokud to neni fifo 
      _updateCena = not _sklFifo; 
      if(_rozsirenaPolozka.skupina = 2 and _rozsirenaPolozka.typPohybuK = 'typPohybu.prijem') then 
        select * into _navazanaPolSklad from dPolSklad  
            where idPolSklad = (select idTabA from dvazebtab where idTabB = _rozsirenaPolozka.idPolSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
        if(_navazanaPolSklad is null) then 
          _cenaMj = _polSklad.cenaMjNeskl; 
          _cenaMjSkl = 0.0; 
          _cenaMjPoriz = _cenaMj; 
          _sumZkl = _polSklad.cenaMjNeskl * _polSklad.mnozMj; 
          for _navazanaPolSklad in (select * from dPolSklad where idPolSklad in  
            (select idTabB from dvazebtab where idTabA = _rozsirenaPolozka.idPolSklad and modulA = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus') ) 
            loop 
            if(_navazanaPolSklad.mnozMj <> 0.0) then 
              _cenaMj = _cenaMj + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu; 
              _cenaMjSkl = _cenaMjSkl + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu; 
            else 
              raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit 
            end if; 
            _sumZkl = _sumZkl + _navazanaPolSklad.sumZkl; 
 
            -- musime zohlednit i pripadne rozpady skladovych polozek 
            for _rozpadlaPolSklad in (select * from dPolSklad where idPolSklad in 
              (select idpolskladcil from svazbypolsklad where idpolskladzdroj = _navazanaPolSklad.idPolSklad)) 
            loop 
              if(_rozpadlaPolSklad.mnozMj <> 0.0) then 
                _cenaMj = _cenaMj + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu; 
                _cenaMjSkl = _cenaMjSkl + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu; 
              else 
                raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit 
              end if; 
              _sumZkl = _sumZkl + _rozpadlaPolSklad.sumZkl; 
            end loop; 
 
            _cenaMjPoriz = _cenaMj; 
 
            -- ovsem pokud se jedna o vyrobu musime zmenit cenu prijmky z vyroby 
            _updateCena = true; 
          end loop; 
          _cenaMj = _cenaMjPoriz + _polSklad.cenaMjNakl; 
          _sumZkl = _sumZkl + (_polSklad.mnozMj * _polSklad.cenaMjNakl); 
        else 
          _sumZklProCenaMj = 0.0; 
          _mnozMjProCenaMj = 0.0; 
          if(_navazanaPolSklad.mnozMj <> 0.0) then 
            _sumZklProCenaMj = _sumZklProCenaMj + _navazanaPolSklad.sumZkl / _kurzDokladu; 
            _mnozMjProCenaMj = _mnozMjProCenaMj + _navazanaPolSklad.mnozMj; 
          else 
            raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit 
          end if; 
          _sumZkl = _navazanaPolSklad.sumZkl; 
          -- musime zohlednit i pripadne rozpady skladovych polozek 
          for _rozpadlaPolSklad in (select * from dPolSklad where idPolSklad in 
            (select idpolskladcil from svazbypolsklad where idpolskladzdroj = _navazanaPolSklad.idPolSklad order by idpolskladcil desc) 
            order by idpolsklad desc)  
          loop 
            if(_polSklad.mnozMj > _mnozMjProCenaMj) then 
              if(_rozpadlaPolSklad.mnozMj <> 0.0) then 
                _sumZklProCenaMj = _sumZklProCenaMj + _rozpadlaPolSklad.sumZkl / _kurzDokladu; 
                _mnozMjProCenaMj = _mnozMjProCenaMj + _rozpadlaPolSklad.mnozMj; 
              else 
                raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit 
              end if; 
              _sumZkl = _sumZkl + _rozpadlaPolSklad.sumZkl; 
            end if; 
          end loop; 
 
          if(_mnozMjProCenaMj <> 0.0) then 
            _cenaMjPoriz = _sumZklProCenaMj / _mnozMjProCenaMj; 
          else 
            raise exception '_mnozMjProCenaMj je 0.0'; -- TODO vyresit co se bude dit 
          end if; 
          _cenaMj = _cenaMjPoriz + _polSklad.cenaMjNakl; 
          _sumZkl = _sumZkl + (_polSklad.mnozMj * _polSklad.cenaMjNakl); 
          --_sumZkl = _polSklad.mnozMj * _cenaMj; 
          -- ovsem pokud se jedna o prevodku musime zmenit cenu prijmky z prevodky 
          _updateCena = true; 
        end if; 
        _sumZklMen = 0.0; 
        select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _rozsirenaPolozka.datum) into _isCiziMena; 
        if(_isCiziMena) then 
          _sumZklMen = _polSklad.mnozMj * _cenaMj; 
        end if; 
      else 
        _cenaMj = _skladKarta.prumCenaTuz; 
        _cenaMjPoriz = _skladKarta.prumCenaTuz; 
        if(_kurzDokladu is not null and _kurzDokladu <> 0.0) then 
          _cenaMj = _cenaMj / _kurzDokladu; 
        end if; 
        _sumZkl = _polSklad.mnozMj * _skladKarta.prumCenaTuz; 
        _sumZklMen = 0.0; 
        select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _rozsirenaPolozka.datum) into _isCiziMena; 
        if(_isCiziMena) then 
          _sumZklMen = _polSklad.mnozMj * _cenaMj;  
        end if; 
      end if; 
 
      if (_updateCena) then 
        update dPolSklad set 
          cenaMjPoriz = _cenaMjPoriz, 
          cenaMj = _cenaMj, 
          cenaMjSkl = _cenaMjSkl, 
          sumZkl = _sumZkl, 
          sumZklMen = _sumZklMen 
          where idPolSklad = _rozsirenaPolozka.idPolSklad; 
      end if; 
 
      execute sprepoctisumydokladu(_rozsirenaPolozka.idDoklSkladPolozky); 
 
      select sumZkl into _stavTuz from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad; 
    end if; 
  else 
    if(_polSklad.mnozMj = 0.0 and _rozsirenaPolozka.typpohybuk = 'typPohybu.prijem') then 
      _stavTuz = _polSklad.cenaMj * _kurzDokladu; 
    else 
      select sumZkl into _stavTuz from dpolsklad where idPolSklad = i_idrozsirenepolozky; 
    end if; 
  end if; 
 
  if(_rozsirenaPolozka.typpohybuk = 'typPohybu.vydej') then 
    _stavMj = _skladKarta.stavMj - (sign*_polSklad.mnozMj); 
    _stavTuz = _skladKarta.stavTuz - (sign*_stavTuz); 
  else 
    _stavMj = _skladKarta.stavMj + (sign*_polSklad.mnozMj); 
    _stavTuz = _skladKarta.stavTuz + (sign*_stavTuz); 
  end if; 
 
  if(_stavMj is null) then 
    raise exception 'stav mj je null a idpolsklad je % a _skladkarta je % a _polSklad je %',i_idrozsirenepolozky, _skladkarta, _polSklad; 
  end if; 
 
  _prumCenaTuz = _skladKarta.prumCenaTuz; 
  if(_stavMj <> 0.0) then 
    _prumCenaTuz = _stavTuz / _stavMj; 
  end if; 
  if(_prumCenaTuz is null) then 
    raise exception 'prumCenaTuz je null, _stavTuz je %, _stavMj je %', _stavTuz, _stavMj; 
  end if;  
  
  _datPosl = _skladKarta.datPosl; 
  if(_datPosl is null or _datPosl < _polSklad.datSklad) then 
    _datPosl = _polSklad.datSklad; 
  end if; 
 
  _poslCenaTuz = _skladKarta.poslCenaTuz; 
  _poslCenaMen = _skladKarta.poslCenaMen; 
  if(_rozsirenaPolozka.typpohybuk = 'typPohybu.prijem') then 
    _PoslCenaTuz := _polSklad.cenaMj * _KurzDokladu;    
    _PoslCenaMen := _polSklad.cenaMj;  
  end if; 
  
  _KurzSkladKarty := (select getKurzFromSklad(_skladKarta.idSkladu, _rozsirenaPolozka.datum)); 
  if (not _rozsirenaPolozka.storno) then 
    update skarty set  
      stavmj = _stavMj, 
      stavTuz = _stavTuz, 
      stavMen = round(_stavTuz / _kurzSkladKarty, 2), 
      prumCenaTuz = _prumCenaTuz, 
      prumCenaMen = _prumCenaTuz / _kurzSkladKarty, 
      datPosl = _datPosl, 
      poslCenaTuz = _poslCenaTuz, 
      poslCenaMen = _poslCenaMen 
      where idkarty = _rozsirenaPolozka.idSkladKarty; 
  end if; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladprepoctirozsirenoupolozku(integer, integer) OWNER TO %firmaRole%;

-- Function: dpolskladinsertkusovnik(integer)
-- DROP FUNCTION dpolskladinsertkusovnik(integer);
CREATE OR REPLACE FUNCTION dpolskladinsertkusovnik(i_idpolsklad integer)
  RETURNS integer AS
$BODY$ 
declare 
    _polSklad record; 
    _typPohybuK varchar; 
    _typZasobyK varchar; 
    _skladove boolean; 
    _idKusovnik integer; 
    _iducetobdobi integer; 
    _stavNaSklade numeric; 
    _sklKarta record; 
    _cenik record; 
    _sklzapor boolean; 
    _idVydejPolSklad integer; 
    _idParovanyDoklad integer; 
    potKus record; 
    _parKusMnoz numeric; 
    _i integer; 
    _kurz numeric; 
    _isCiziMena boolean; 
    _idMeny integer; 
    _mnozMj numeric; 
    _cenaMj numeric; 
    _sumZkl numeric; 
    _newSumZkl numeric; 
    _sumZklMen numeric; 
    _idSkladPotKus integer; 
    _idProtiUcetDoklad integer; 
    _idStred integer; 
    _kopStred boolean; 
    _sklad record; 
    _typPohybuSkladK character varying; 
    _cenaMjSkl numeric(19,6); 
    _cenaMjNeskl numeric(19,6); 
    _navazanaPolSklad record; 
    _rozpadlaPolSklad record; 
    _kurzDokladu numeric; 
begin 
  select * into _polSklad from dpolsklad where idpolsklad = i_idpolSklad; 
 
  -- napriklad pokud se jedna o prevodku mezi sklady nechceme z prijemky vytvaret prevodku 
  if (_polSklad.prevodka = true) then 
    return null; 
  end if; 
 
  -- typem pohybu musi byt prijem 
  select typpohybuk into _typPohybuK from ddoklsklad d where d.iddoklsklad = _polSklad.iddoklsklad; 
  if (_typPohybuK <> 'typPohybu.prijem') then 
    return null; 
  end if; 
 
  -- pokud neni nastaven typ pohybu sklad prijem z vyroby tak koncime 
  select typpohybuskladk into _typPohybuSkladK from ddoklsklad d where d.iddoklsklad = _polSklad.iddoklsklad; 
  if(_typPohybuSkladK is null or _typPohybuSkladK <> 'typPohybuSklad.prijemVyrob') then 
    return null; 
  end if; 
 
  -- idcenik odkazuje na neco co je soucasti kusovniku. 
  select ckus.idkusovnik into _idKusovnik from ckusovnik ckus where ckus.idcenik = _polSklad.idcenik 
    and exists (select 1 from ckusovnik cPot where cPot.idotec = ckus.idkusovnik); 
  if (_idKusovnik is null) then 
    return null; 
  end if; 
 
  -- vytvorime nebo nalezneme zparovany doklad skl vydej 
  select findparovanydoklsklad(_polSklad.iddoklsklad, _polSklad.modul, 'typVazbyDokl.hlavaSklKus') into _idParovanyDoklad; 
  if (_idParovanyDoklad is null) then 
    select createdoklsklad(_polSklad.idpolsklad, _polSklad.iddoklsklad, _polSklad.modul) into _idParovanyDoklad; 
  end if; 
 
  if(_idParovanyDoklad is null) then 
    return null; 
  end if; 
 
  select isDoklSkladMenaCizi(_idParovanyDoklad, _polSklad.datVyst) into _isCiziMena; 
  select getkurzfromdoklad(_idParovanyDoklad, _polSklad.datVyst) into _kurz; 
  select idMeny into _idMeny from dDoklSklad where idDoklSklad = _idParovanyDoklad; 
 
  _i = 0; 
  _newSumZkl = 0.0; 
  _cenaMjSkl = 0.0; 
  _cenaMjNeskl = 0.0; 
 
  perform putglotxvariable('zurnalTxName', 'rozpadKusovniku'); 
 
  -- pro vsechny kusovniky, ktere jsou pod nasim kusovnikem a jsou skladove nebo vyroba a nemaji nulove mnozstvi 
  for potKus in (select * from ckusovnik cPot where cPot.idotec = _idKusovnik and cPot.mnoz > 0.0) loop 
    select * into _cenik from cCenik where idCenik = potKus.idCenik; 
 
    select mnoz into _parKusMnoz from ckusovnik where idkusovnik = _idKusovnik; 
 
    select skladove into _skladove from cCenik cen where cen.idCenik = potKus.idCenik; 
    if (not _skladove) then 
        _newSumZkl = _newSumZkl + ((_cenik.nakupcena * potKus.mnoz * _polSklad.mnozMj) / _parKusMnoz); 
        _cenaMjNeskl = _cenaMjNeskl + ((_cenik.nakupcena * potKus.mnoz) / _parKusMnoz); 
        continue; 
    end if; 
    _i = _i + 1; 
 
    select findIdUcetniObdobiKDatu(_polSklad.datVyst) into _iducetobdobi; 
    -- vybereme skladovou kartu podle preferovaneho skladu 
    select null into _sklKarta; 
    _idSkladPotKus = null; 
 
    select getPrefIdSkladu( 
	(select idstred from ddoklsklad where iddoklsklad = _polSklad.iddoklsklad), 
	_cenik.idskupzboz, potKus.idcenik) into _idSkladPotKus; 
 
    if (_idSkladPotKus is not null) then 
	select * into _sklKarta from skarty where idcenik = potKus.idcenik and idSkladu = _idSkladPotKus and iducetobdobi = _iducetobdobi; 
    end if; 
 
    -- sklad karta nebyla nalezena podle preferovaneho skladu, vezmeme sklad stejny jako z vytvarene polozky 
    if (_sklKarta is null) then 
	select * into _sklKarta from skarty where idcenik = potKus.idcenik and idSkladu = _polSklad.idBspSkl and iducetobdobi = _iducetobdobi; 
	select _polSklad.idStred into _idStred; 
	select _polSklad.kopstred into _kopStred; 
    else 
        select idstred into _idStred from dbsp d where _sklKarta.idskladu = d.idbsp; 
	select false into _kopStred; 
    end if; 
 
    -- skladovou 
    if (_sklKarta is null) then 
	raise exception 'Nebyla nalezena skladova karta k polozce ceniku %. Definujte mapovani skladu pro tuto polozku nebo ji pridejte na sklad %', 
		_cenik.kod, (select kod from dtypdokl where idtypdokl = _polSklad.idskladu); 
    end if; 
 
   _mnozMj = (potKus.mnoz / _parKusMnoz) * _polSklad.mnozMj; 
   _cenaMj = _sklKarta.prumCenaTuz / _kurz; 
   _sumZkl = _mnozMj * _sklKarta.prumCenaTuz; 
   _cenaMjSkl = _cenaMjSkl + (_cenaMj * (potKus.mnoz / _parKusMnoz)); 
   _newSumZkl = _newSumZkl + _sumZkl; 
 
   if(_isCiziMena) then 
     _sumZklMen = _mnozMj * _cenaMj; 
   else 
     _sumZklMen = 0.0; 
   end if; 
 
    -- TODO doplnit sarze a expirace 
    select dgetstavnasklade(_sklKarta.idkarty, _polSklad.datSklad, -1, _polSklad.idfirmy, NULL, NULL, _typPohybuK) into _stavNaSklade; 
 
    -- osetreni zda je povoleny zaporny stav na sklade 
    if (_stavNaSklade - _mnozMj < 0) then 
        select sklzapor into _sklzapor from nNastav where _polSklad.datVyst >= PlatiOdData order by PlatiOdData desc limit 1; 
        if (_sklzapor is null) then 
            select sklzapor into _sklzapor from nNastav where PlatiOdData is null limit 1; 
        end if; 
        if _sklzapor is null or _sklzapor = false then 
            raise exception '0002:sPreporctiSkladKartu: neni povolen zaporny stav skladu'; 
        end if; 
    end if; 
 
    select nextval('seq_dpolsklad'::regclass) into _idVydejPolSklad; 
 
    if(_cenik.idskupzboz is not null) then 
      select idprotiucetsklv into _idProtiUcetDoklad from cskupzboz where idskupzboz = _cenik.idskupzboz; 
    end if; 
    if(_idProtiUcetDoklad is null) then 
      select idprotiucet into _idProtiUcetDoklad from ddoklsklad where iddoklsklad = _idParovanyDoklad; 
    end if; 
 
    select * into _sklad from dBsp where _sklKarta.idSkladu = idBsp; 
 
    insert into dpolsklad(idPolSklad, idcenik, idBspSkl, idkarty, datVyst, datSklad, datUcto, modul, typPolozkyK, idDoklSklad, 
        mnozMj, cenaMj, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, 
        nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni, idStred, idZakazky, idMeny, kopstred) 
    values (_idVydejPolSklad, potKus.idcenik, _sklKarta.idSkladu, _sklKarta.idkarty, _polSklad.datVyst, _polSklad.datSklad, _polSklad.datUcto, _polSklad.modul, _polSklad.typpolozkyk, _idParovanyDoklad, 
        _mnozMj, _cenaMj, _sumZkl, _sumZklMen, _idProtiUcetDoklad, _sklad.idprimucet, false, false, _polSklad.baleniid, _polSklad.mnozbaleni, 
        _cenik.nazev, _cenik.nazevA, _cenik.nazevB, _cenik.nazevC, NULL, NULL, _polSklad.cisRad * 100 + _i, true, 
        _idStred, _polSklad.idZakazky, _idMeny, _kopStred); 
 
    insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK) 
      values (0.0, _polSklad.idpolsklad, _idVydejPolSklad, 'SKL', 'SKL', false, 'typVazbyDokl.polozkaSklKus'); 
 
  end loop; 
 
  perform removeglotxvariable('zurnalTxName'); 
 
  select getkurzfromdoklad(_polSklad.iddoklsklad, _polSklad.datvyst) into _kurz; 
  _cenaMj = _newSumZkl / _polSklad.mnozMj / _kurz; 
 
  select isDoklSkladMenaCizi(_polSklad.iddoklsklad, _polSklad.datVyst) into _isCiziMena; 
  if (_isCiziMena) then 
    _sumZklMen = _polSklad.cenaMj * _polSklad.mnozMj; 
  else 
    _sumZklMen = 0.0; 
  end if; 
 
 
  select getKurzFromDoklad(_polSklad.idDoklSklad, _polSklad.datVyst) into _kurzDokladu; 
  _cenaMjSkl = 0.0; 
  _cenaMj = _cenaMjNeskl; 
  _sumZkl = _cenaMjNeskl * _polSklad.mnozMj; 
  for _navazanaPolSklad in (select * from dPolSklad where idPolSklad in 
    (select idTabB from dvazebtab where idTabA = _polSklad.idPolSklad and modulA = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus') ) 
    loop 
      if(_navazanaPolSklad.mnozMj <> 0.0) then 
        _cenaMj = _cenaMj + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu; 
        _cenaMjSkl = _cenaMjSkl + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu; 
      else 
        raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit 
      end if; 
      _sumZkl = _sumZkl + _navazanaPolSklad.sumZkl; 
 
      -- musime zohlednit i pripadne rozpady skladovych polozek 
      for _rozpadlaPolSklad in (select * from dPolSklad where idPolSklad in 
        (select idpolskladcil from svazbypolsklad where idpolskladzdroj = _navazanaPolSklad.idPolSklad)) 
        loop 
          if(_rozpadlaPolSklad.mnozMj <> 0.0) then 
            _cenaMj = _cenaMj + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu; 
            _cenaMjSkl = _cenaMjSkl + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu; 
          else 
            raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit 
          end if; 
          _sumZkl = _sumZkl + _rozpadlaPolSklad.sumZkl; 
      end loop; 
  end loop; 
 
  update dpolsklad set 
       sumzkl = _sumZkl, 
       cenaMj = _cenaMj, 
       --sumZklMen = _sumZklMen, 
       cenaMjSkl = _cenaMjSkl, 
       cenaMjNeskl = _cenaMjNeskl 
     where idpolsklad = _polSklad.idpolsklad; 
 
  execute sprepoctisumydokladu(_polSklad.idDoklSklad); 
 
  return _polSklad.idPolSklad; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladinsertkusovnik(integer) OWNER TO %firmaRole%;

-- Function: skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, integer, integer)
-- DROP FUNCTION skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, integer, integer);
CREATE OR REPLACE FUNCTION skladfindcenamjnakup(i_mnozmj numeric, i_idcenik integer, i_idskladu integer, i_datum date, i_sarze character varying, i_expirace date, i_idvyrobnihocisla integer, i_idstred integer)
  RETURNS numeric AS
$BODY$ 
declare 
  _sklfifo boolean; 
  _mazatTmpTable boolean; 
  _idkarty integer; 
  _rozsirenaPolozka record; 
  _iducetobdobi integer; 
  _result numeric(19,6); 
  _pomocDPolSkladF record; 
  _mnozstvi numeric(19,6); 
  _potrebnyPocet numeric(19,6); 
  _sadaItemCount integer; 
  _polozkaSady record; 
  _pomoc numeric(19,6); 
 
  _sumSumZkl numeric(19,6); 
  _sumMnozMj numeric(19,6); 
  _sumTuz numeric(19,6); 
  _mnozMj numeric(19,6); 
  _typPohybuK character varying; 
  _karta record; 
  _idskupzboz integer; 
  _idSkladuPref integer; 
  _cenik record; 
  _sklad record; 
begin 
  _result = 0.0; 
  _mnozstvi = 0.0; 
 
  if(i_mnozMj > 0) then 
    select count(*) into _sadaItemCount from csady where idceniksada = i_idcenik; 
    if(_sadaItemCount > 0) then 
      FOR _polozkaSady IN (select * from cSady where idCenikSada = i_idcenik) LOOP 
        -- TODO doresit sarze expirace a vyrobni cisla 
        select skladfindcenamjnakup(i_mnozmj * _polozkaSady.mnozMj, _polozkaSady.idcenik, i_idskladu, i_datum, null, null, null, i_idstred) into _pomoc; 
        _result = _result + (_pomoc * i_mnozmj * _polozkaSady.mnozMj); 
      end loop; 
    else 
      select findiducetniobdobikdatu(i_datum) into _iducetobdobi; 
      _sklfifo := (select isfifosklad(i_datum)); 
      if (_sklfifo) then 
        if(i_idvyrobnihocisla is not null and i_idvyrobnihocisla > 0) then 
          -- pokud je zadano vyrobni cislo ma nejvetsi prioritu 
          select cenaMj into _result from dpolsklad where idpolsklad = (select idpolskladprijem from svyrobnicislo where idvyrobnicislo = i_idvyrobnihocisla); 
        elsif(i_sarze is not null and i_expirace is not null) then 
          -- pokud je zadana sarze i expirace 
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu and sarze = i_sarze and expirace = i_expirace order by datSklad,idpolsklad) loop 
            if(i_mnozMj > _mnozstvi) then 
              _potrebnyPocet = _pomocDPolSkladF.pocet; 
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then 
                _potrebnyPocet = i_mnozMj - _mnozstvi; 
              end if; 
              _mnozstvi = _mnozstvi + _potrebnyPocet; 
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj; 
            end if; 
          end loop; 
          if(_mnozstvi != 0.0) then 
            _result = _result / _mnozstvi; 
          else 
            _result = 0.0; 
          end if; 
        elsif(i_sarze is not null and i_expirace is null) then 
          -- pokud je zadana jen sarze 
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu and sarze = i_sarze order by datSklad,idpolsklad) loop 
            if(i_mnozMj > _mnozstvi) then 
              _potrebnyPocet = _pomocDPolSkladF.pocet; 
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then 
                _potrebnyPocet = i_mnozMj - _mnozstvi; 
              end if; 
              _mnozstvi = _mnozstvi + _potrebnyPocet; 
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj; 
            end if; 
          end loop; 
          if(_mnozstvi != 0.0) then 
            _result = _result / _mnozstvi; 
          else 
            _result = 0.0; 
          end if; 
        elsif(i_sarze is null and i_expirace is not null) then 
          -- pokud je zadana jen expirace 
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu and expirace = i_expirace order by datSklad,idpolsklad) loop 
            if(i_mnozMj > _mnozstvi) then 
              _potrebnyPocet = _pomocDPolSkladF.pocet; 
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then 
                _potrebnyPocet = i_mnozMj - _mnozstvi; 
              end if; 
              _mnozstvi = _mnozstvi + _potrebnyPocet; 
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj; 
            end if; 
          end loop; 
          if(_mnozstvi != 0.0) then 
            _result = _result / _mnozstvi; 
          else 
            _result = 0.0; 
          end if; 
        else 
          -- pokud neni zadana ani sarze ani expirace ani vyrobni cislo 
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu order by datSklad,idpolsklad) loop 
            if(i_mnozMj >= _mnozstvi) then 
              _potrebnyPocet = _pomocDPolSkladF.pocet; 
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then 
                _potrebnyPocet = i_mnozMj - _mnozstvi; 
              end if; 
              _mnozstvi = _mnozstvi + _potrebnyPocet; 
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj; 
            end if; 
          end loop; 
          if(_mnozstvi != 0.0) then 
            _result = _result / _mnozstvi; 
          else 
            _result = 0.0; 
          end if; 
        end if; 
      else 
        -- generuji rozsirene polozky 
        select * into _karta from skarty where idcenik = i_idcenik and idskladu = i_idskladu and iducetobdobi = _iducetobdobi; 
        -- pokud neexistuje skladova karta pokusim se ji najit pomoci mapovani skladu 
        if(_karta is null) then 
          select idskupzboz into _idskupzboz from ccenik where idcenik = i_idcenik; 
          select getPrefIdSkladu(i_idstred, _idskupzboz, i_idcenik) into _idSkladuPref; 
          select * into _karta from skarty 
            where idSkladu = _idSkladuPref and idCenik = i_idCenik and idUcetObdobi = _idUcetObdobi; 
          if(_karta is null) then 
            -- pokud ani podle mapovani skladu se skladova karta nenajde tak vyhazuju vyjimku 
            select * into _cenik from ccenik where idCenik = i_idcenik; 
            select * into _sklad from dbsp where idBsp = i_idSkladu; 
            raise exception '0007:Skladová karta neexistuje pro ceník % a sklad % a nebo je špatně nastaveno mapovaní skladu.', _cenik.nazev, _sklad.nazev; 
          end if; 
        end if; 
 
	if(_karta is null) then 
	  raise exception 'Nenalezena sklad karta'; 
	end if; 
        _sumTuz = 0.0; 
        _mnozMj = 0.0; 
        select sum(p.sumZkl), sum(p.mnozMj) into _sumSumZkl, _sumMnozMj from dPolSklad p, dDoklSklad d 
          where p.idDoklSklad = d.idDoklSklad and p.idKarty = _karta.idKarty and d.typPohybuK = 'typPohybu.prijem' and p.datSklad > i_datum; 
        if(_sumSumZkl is null) then 
          _sumSumZkl = 0.0; 
        end if; 
        if(_sumMnozMj is null) then 
          _sumMnozMj = 0.0; 
        end if; 
        _sumTuz = _sumTuz + _sumSumZkl; 
        _mnozMj = _mnozMj + _sumMnozMj; 
 
        select sum(p.sumZkl), sum(p.mnozMj) into _sumSumZkl, _sumMnozMj from dPolSklad p, dDoklSklad d 
          where p.idDoklSklad = d.idDoklSklad and p.idKarty = _karta.idKarty and d.typPohybuK = 'typPohybu.vydej'and p.datSklad > i_datum; 
        if(_sumSumZkl is null) then 
          _sumSumZkl = 0.0; 
        end if; 
        if(_sumMnozMj is null) then 
          _sumMnozMj = 0.0; 
        end if; 
        _sumTuz = _sumTuz - _sumSumZkl; 
        _mnozMj = _mnozMj - _sumMnozMj; 
 
        _sumTuz = _karta.stavTuz - _sumTuz; 
        _mnozMj = _karta.stavMj - _mnozMj; 
        if(_mnozMj = 0.0) then 
          _result = 0.0; 
        else 
          _result = _sumTuz / _mnozMj; 
        end if; 
      end if; 
    end if; 
  end if; 
  return _result; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, integer, integer) OWNER TO %firmaRole%;

-- dropnuti pohledu protoze na sobe zavisi
DROP VIEW dpolskladf;
DROP VIEW dpolskladfbezvc;
DROP VIEW dpolskladdoklad;

-- View: dpolskladdoklad
CREATE OR REPLACE VIEW dpolskladdoklad AS 
 SELECT p.idpolsklad, p.lastupdate, p.autozaokr, p.autogen, p.baleniid, p.cenjednotka, p.cenamj, p.cenamjnakup, p.cenamjprodej, p.cisrad, p.datucto, p.datvyst, p.datSklad, p.eankod, p.expirace, p.kod, p.kopclendph, p.kopdphdalucet, p.kopdphmducet, p.kopklice, p.kopstred, p.kopzakazku, p.kopzkldalucet, p.kopzklmducet, p.mnozbaleni, p.mnozmj, p.mnozmjplan, p.mnozmjreal, p.modul, p.nazev, p.objednatk, p.objem, p.poznam, p.proczakl, p.rezervovat, p.sarze, p.slevadokl, p.slevamnoz, p.slevapol, p.stavuzivk, p.storno, p.stornopol, p.sumdph, p.sumdphmen, p.sumzkl, p.sumzklmen, p.szbdph, p.typcenydphk, p.typpolozkyk, p.typszbdphk, p.typvypcenyk, p.ucetni, p.uplslevadokl, p.zaokrjakk, p.zaokrnak, p.idzkldalucet, p.iddphdalucet, p.idmjobjem, p.idmeny, p.idstred, p.idkarty, p.idcenik, p.idzklmducet, p.iddphmducet, p.idsazbydph, p.idclendph, p.idzakazky, p.idmj, p.iddoklsklad, p.idbspskl AS idskladu, p.idfirmy, d.typpohybuk
   FROM dpolsklad p
   LEFT JOIN ddoklsklad d ON p.iddoklsklad = d.iddoklsklad;

ALTER TABLE dpolskladdoklad OWNER TO %firmaRole%;

-- View: dpolskladf
CREATE OR REPLACE VIEW dpolskladf AS 
         SELECT p.idpolsklad, p.mnozmj - jevydano(p.idpolsklad) AS pocet, p.cenamj, p.datvyst, p.datSklad, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, cast(NULL as integer) AS idvyrobnicislo, c.evidvyrcis
           FROM dpolskladdoklad p
      JOIN ccenik c ON c.idcenik = p.idcenik
     WHERE p.typpohybuk::text = 'typPohybu.prijem'::text AND (p.mnozmj - jevydano(p.idpolsklad)) > 0::numeric AND c.evidvyrcis = false AND p.storno <> true
UNION ALL 
         SELECT p.idpolsklad, 1 AS pocet, p.cenamj, p.datvyst, p.datSklad, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, v.idvyrobnicislo, c.evidvyrcis
           FROM svyrobnicislo v
      JOIN dpolskladdoklad p ON p.idpolsklad = v.idpolskladprijem
   JOIN ccenik c ON c.idcenik = p.idcenik
  WHERE p.typpohybuk::text = 'typPohybu.prijem'::text AND c.evidvyrcis = true AND NOT (v.idvyrobnicislo IN ( SELECT sfifovazby.idvyrobnicislo
         FROM sfifovazby
        WHERE sfifovazby.idpolskladprijem = p.idpolsklad)) AND p.storno <> true;

ALTER TABLE dpolskladf OWNER TO %firmaRole%;

-- View: dpolskladfbezvc
CREATE OR REPLACE VIEW dpolskladfbezvc AS 
 SELECT p.idpolsklad, p.mnozmj - jevydano(p.idpolsklad) AS pocet, p.cenamj, p.datvyst, p.datSklad, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, cast(NULL as integer) AS idvyrobnicislo, false AS evidvyrcis
   FROM dpolskladdoklad p
  WHERE p.typpohybuk::text = 'typPohybu.prijem'::text AND (p.mnozmj - jevydano(p.idpolsklad)) > 0::numeric AND p.storno <> true;

ALTER TABLE dpolskladfbezvc OWNER TO %firmaRole%;

-- Function: skladrealizujpozadavky()
-- DROP FUNCTION skladrealizujpozadavky();
CREATE OR REPLACE FUNCTION skladrealizujpozadavky()
  RETURNS void AS
$BODY$  
declare 
  _polSklad record; 
  _stavSkladu numeric(19,6); 
begin 
  for _polSklad in ( 
    select p.*, d.typPohybuK from dpolsklad p join ddoklsklad d on p.idDoklSklad = d.idDoklSklad 
    where typPohybuK = 'typPohybu.vydej' and mnozMj = 0 and mnozMjPlan != 0 
    order by datSklad, idPolSklad) loop 
      select dgetstavnasklade(_polSklad.idkarty, _polSklad.datSklad, /*_polSklad.idpolsklad*/ -1, _polSklad.sarze, _polSklad.expirace, _polSklad.typPohybuK) into _stavSkladu; 
      if(_stavSkladu >= _polSklad.mnozMjPlan) then 
        update dpolsklad set mnozMj = mnozMjPlan, sumZkl = mnozMjPlan * cenaMj where idpolsklad = _polSklad.idPolSklad; 
        perform sprepoctisumydokladu(_polSklad.iddoklsklad); 
      end if; 
  end loop; 
end;     
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladrealizujpozadavky() OWNER TO %firmaRole%;

-- Function: snastavstavkartydne(integer, date, integer)
-- DROP FUNCTION snastavstavkartydne(integer, date, integer);
CREATE OR REPLACE FUNCTION snastavstavkartydne(i_skladkartaid integer, i_datum date, i_polskladid integer)
  RETURNS void AS
$BODY$    
declare    
  zaznam Record; 
  _idPolSklad integer;    
  _typPohybuK character varying; 
begin 
  _idPolSklad := i_polskladid; 
  if(_idPolSklad < 0) then 
    _idPolSklad := -1*_idPolSklad; 
  end if;    
  select typPohybuK into _typPohybuK from ddoklsklad where idDoklSklad = (select idDoklSklad from dpolsklad where idpolsklad = _idPolSklad); 
  for zaznam in select * from (select *, (select typPohybuK from ddoklSklad where idDoklSklad = p.idDoklSklad) as typPohybuK from dPolSklad p) as vysledek 
  where ((DatSklad > i_datum) or (DatSklad = i_datum and typpohybuk > _typPohybuK) or (DatSklad = i_datum and typPohybuK = _typPohybuK and idPolSklad > i_polskladid))  
    and idKarty = i_skladkartaid 
  order by DatSklad, typPohybuK, idPolSklad asc 
  loop 
    execute sOdectiSkladKartu(zaznam.MnozMJ,zaznam.CenaMj,zaznam.DatSklad,zaznam.idKarty,zaznam.idDoklSklad,zaznam.idskladu,-1);    
  end loop;    
end    
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION snastavstavkartydne(integer, date, integer) OWNER TO %firmaRole%;

-- Function: szapoctipolozkyoddata(integer, date, integer)
-- DROP FUNCTION szapoctipolozkyoddata(integer, date, integer);
CREATE OR REPLACE FUNCTION szapoctipolozkyoddata(i_skladkartaid integer, i_datum date, i_polskladid integer)
  RETURNS void AS
$BODY$     
declare     
  zaznam Record; 
  _polskladpomoc Record; 
  _sklfifo boolean;  
  _idPolSklad integer; 
  _typPohybuK character varying; 
begin    
  _idPolSklad := i_polskladid; 
  if(_idPolSklad < 0) then 
    _idPolSklad := -1*_idPolSklad; 
  end if;    
  select typPohybuK into _typPohybuK from ddoklsklad where idDoklSklad = (select idDoklSklad from dpolsklad where idpolsklad = _idPolSklad); 
  for zaznam in select * from (select *, (select typPohybuK from ddoklSklad where idDoklSklad = p.idDoklSklad) as typPohybuK from dPolSklad p) as vysledek 
  where ((DatSklad > i_datum) or (DatSklad = i_datum and typpohybuk > _typPohybuK) or (DatSklad = i_datum and typPohybuK = _typPohybuK and idPolSklad > i_polskladid))  
    and idKarty = i_skladkartaid 
  order by DatSklad, typPohybuK, idPolSklad asc 
  loop     
    _sklfifo := (select isfifosklad(zaznam.datSklad));  
    if (_sklfifo <> true) then  
      execute sZmenCenyNaPolSklad(zaznam.idPolSklad, i_SkladKartaId, zaznam.iddoklsklad);    
    end if;  
 
    select * into _polskladpomoc from dpolsklad where idpolsklad = zaznam.idpolsklad; 
     
    execute sPrepoctiSkladKartu(_polskladpomoc.MnozMJ,_polskladpomoc.CenaMj,_polskladpomoc.DatSklad,_polskladpomoc.idKarty,_polskladpomoc.idDoklSklad,_polskladpomoc.idSkladu,1);     
  end loop;    
end;    
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION szapoctipolozkyoddata(integer, date, integer) OWNER TO %firmaRole%;

-- Function: szmencenynapolsklad(integer, integer, integer)
-- DROP FUNCTION szmencenynapolsklad(integer, integer, integer);
CREATE OR REPLACE FUNCTION szmencenynapolsklad(i_polskladid integer, i_skladkartaid integer, i_doklskladid integer)
  RETURNS void AS
$BODY$      
declare     
  /* Deklarace promennych */     
  _MnozMJ numeric(19,6);    
  _CenaMJOld numeric(19,6);     
  _SumZkl numeric(19,2);     
  _SumZklMen numeric(19,2);     
  _PrumCenaTuz numeric(19,6);     
  _PrumCenaMen numeric(19,6);    
  _PrumCena numeric(19,6);     
  _TypPohybuK varchar(50);     
  _DatVyst date;    
  _CiziMena boolean;      
  zaznam record;    
  _KurzSkladKarty numeric(19,6);     
  _KurzDokladu numeric(19,6);  
  tmp_polsklad_exists boolean;  
       
  /* Deklarace kurzoru pro nacteni potrebnych dat ze skladove karty a dokladu */    
  declare ThisDoklSklad cursor for select TypPohybuK, DatSklad from dDoklSklad where idDoklSklad = i_DoklSkladId;   
  declare ThisPolSklad cursor for select MnozMJ, CenaMJ from dPolSklad  where idPolSklad = i_PolSkladId;   
  declare ThisSkladKarta cursor for select PrumCenaTuz,PrumCenaMen from sKarty where idKarty = i_SkladKartaId;   
  declare ThisPolSkladSum cursor for select SumZkl, SumZklMen from dPolSklad where idDoklSklad = i_DoklSkladId;      
begin   
  /* Zjisteni typPohybuK */   
  open ThisDoklSklad;    
  fetch ThisDoklSklad into _TypPohybuK, _DatVyst;    
  close ThisDoklSklad;    
   
  /* Zjisteni mnozstvi jednotek */   
  open ThisPolSklad;    
  fetch ThisPolSklad into _MnozMJ, _CenaMJOld;    
  close ThisPolSklad;    
   
  /* Nacteni dat ze skladove karty */   
  open ThisSkladKarta;    
  fetch ThisSkladKarta into _PrumCenaTuz,_PrumCenaMen;    
  close ThisSkladKarta;   
     
  if _TypPohybuK = 'typPohybu.vydej' then   
    --_KurzSkladKarty := (select getKurzFromSklad(i_skladId, i_DatVyst));    
    _KurzDokladu := (select getKurzFromDoklad(i_DoklSkladId, _DatVyst));    
    _PrumCena := _PrumCenaTuz / _KurzDokladu; 
    --_CiziMena := (select isDoklSkladMenaCizi(i_DoklSkladId, _DatVyst));    
    --if _CiziMena then    
    --  _PrumCena := _PrumCenaMen;    
    --else    
    --  _PrumCena := _PrumCenaTuz;    
    --end if;    
 
    _SumZkl := _PrumCenaTuz * _MnozMJ; 
    _SumZklMen := 0; 
    if(_KurzDokladu <> 1.0) then 
      _sumZklMen := _PrumCena * _MnozMJ; 
    end if; 
    tmp_polsklad_exists := (select istableexist('tmp_polsklad')); 
    if(tmp_polsklad_exists) then 
      insert into tmp_polsklad(idpolsklad) values (i_polskladid); 
      update dPolSklad set     
        cenaMJ = _PrumCena,    
        sumZkl = _SumZkl,  
        sumZklMen = _SumZklMen  
        where     
        idPolSklad = i_PolSkladId;    
    end if; 
    /* Nacteni novych souctu na skladovem dokladu */   
    execute sPrepoctiSumyDokladu(i_doklskladid); 
  end if;   
end;   
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION szmencenynapolsklad(integer, integer, integer) OWNER TO %firmaRole%;

-- Function: sfifovydej(integer, integer, integer, integer, numeric)
-- DROP FUNCTION sfifovydej(integer, integer, integer, integer, numeric);
CREATE OR REPLACE FUNCTION sfifovydej(idvydej integer, idcenikvydej integer, idskladvydej integer, idkartyvydej integer, vyd numeric)
  RETURNS void AS
$BODY$     
declare      
  _zaznam Record;      
  _vybrano numeric(19,6);    
  _i integer;    
  _novevydcelkem numeric(19,6);    
  _pocet numeric(19,6);    
  _cenamjP numeric(19,6); 
  _cenaMjPMen numeric(19,6); 
  _kurzDokladuP numeric(19,6);  
  _kurzDokladuV numeric(19,6);  
  _idDoklSkladP integer;   
  _idDoklSkladV integer;  
  _datVystV date;  
  _idrozlozeni integer;    
  _vydexpir boolean;    
  _vyrcis character varying(255);    
  _sklfifo boolean; 
  _sarze character varying(255); 
  _expirace date;      
  _evidVyrCis boolean;   
begin      
  _vybrano := 0;    
  _i := 1;    
  _novevydcelkem := vyd;    
  select evidVyrCis into _evidVyrCis from ccenik where idcenik = idcenikvydej; 
  if (not _evidVyrCis) then 
    if (idvydej>0) then 
      select vydexpir into _vydexpir from skarty where idkarty=idkartyvydej limit 1; 
      select sarze, expirace into _sarze, _expirace from dpolsklad where idpolsklad = idvydej;    
      if (not _vydexpir) then    
        --pořadí výdeje dle datvyst (dále se bude řesit upřednostněný výdej mimo FIFO)    
        for _zaznam in select * from dPolSkladF where idCenik=idCenikVydej and idSkladu=idSkladVydej order by datSklad,idpolsklad loop      
          if(not _zaznam is null) then
            if((_sarze is null or _sarze = _zaznam.sarze) and (_expirace is null or _expirace = _zaznam.expirace)) then 
              if (_vybrano<_novevydcelkem) then    
                _pocet := _zaznam.pocet;    
                if( _vybrano+_pocet) > _novevydcelkem then    
                  _pocet := _novevydcelkem-_vybrano;    
                end if;    
                _vybrano := _vybrano+_pocet;    
                --pokud je výrobní číslo, tak jeho kód zaznamenám na výdejku (otázka je, zda tam nedat rovnou idvyrobnicislo    
                _vyrcis := '';    
                if (_zaznam.idvyrobnicislo>0) then    
                  select kod into _vyrcis from svyrobnicislo where idvyrobnicislo = _zaznam.idvyrobnicislo;
                end if;    
                --    
                if (_i = 1) then 
                  insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo) ; 
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));    
                  if (_sklfifo) then    
                    select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);    
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);   
                    if (_kurzDokladuP <> 0.0) then 
                      _cenamjP := _cenamjP * _kurzDokladuP;    
	                end if;  
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;  
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV)); 
                    _cenamjP := _cenamjP / _kurzDokladuV; 
                    _cenaMjPMen := 0.0; 
                    if(_kurzDokladuV <> 1.0) then 
                      _cenaMjPMen := _cenaMjP; 
                    end if; 
                    update dpolsklad set mnozmj = _pocet,cenamj = _cenamjP, cenaMjPoriz = _cenaMjP, sumzkl = _pocet*_cenamjP*_kurzDokladuV, sumZklMen = _pocet*_cenaMjPMen, sarze = _zaznam.sarze, expirace = _zaznam.expirace 
                          where idpolsklad = idvydej; 
                  else 
                    update dpolsklad set sarze = _zaznam.sarze, expirace = _zaznam.expirace where idpolsklad = idvydej; 
                  end if;
                else    
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));    
                  if (_sklfifo) then    
                    select nextval('seq_dpolsklad') into _idrozlozeni;    
                    select cenamj, idDoklSklad into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);   
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);   
                    if (_kurzDokladuP <> 0.0) then   
                      _cenamjP := _cenamjP * _kurzDokladuP;    
                    end if;   
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;  
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));  
                    _cenamjP := _cenamjP / _kurzDokladuV; 
                    _cenaMjPMen := 0.0; 
                    if(_kurzDokladuV <> 1.0) then 
                      _cenaMjPMen := _cenaMjP; 
                    end if; 
                    insert into dpolsklad(idpolsklad,mnozmj,autozaokr,autogen,baleniid,cenjednotka,cenamj,cenaMjPoriz,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,datsklad,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,sumzkl,sumzklmen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy)
                         (select (-1*_idrozlozeni),_pocet,autozaokr,autogen,baleniid,cenjednotka,_cenamjP,_cenaMjP,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,datsklad,eankod,_zaznam.expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,_zaznam.sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,_pocet*_cenamjP*_kurzDokladuV,_pocet*_cenaMjPMen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy from dpolsklad where idpolsklad=idVydej);
                    --    
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,_idrozlozeni,_pocet,_zaznam.idvyrobnicislo);    
                    insert into svazbypolsklad(idpolskladzdroj,idpolskladcil) values (idvydej, _idrozlozeni);    
                  else    
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,idvydej,_pocet,_zaznam.idvyrobnicislo);    
                  end if;    
                end if;    
                --    
                _i:=_i+1;    
              else
                if (_vybrano>_novevydcelkem) then
                  _pocet := -_zaznam.pocet;
                  if(( _vybrano+_pocet) < _novevydcelkem) then
                    _pocet := _novevydcelkem-_vybrano;
                  end if;
                  _vybrano := _vybrano+_pocet;
                  insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, 0-_pocet,_zaznam.idvyrobnicislo) ;
                end if;
              end if; 
            end if;
          end if;
        end loop;   
      else    
        --pořadí výdeje dle expirace (dále se bude řesit upřednostněný výdej mimo FIFO)    
        for _zaznam in select * from dPolSkladF where idCenik=idCenikVydej and idSkladu=idSkladVydej order by expirace, idpolsklad loop      
          if(not _zaznam is null) then
            if((_sarze is null or _sarze = _zaznam.sarze) and (_expirace is null or _expirace = _zaznam.expirace)) then 
              if (_vybrano<_novevydcelkem) then    
                _pocet := _zaznam.pocet;    
                if( _vybrano+_pocet) > _novevydcelkem then    
                  _pocet := _novevydcelkem-_vybrano;    
                end if;    
                _vybrano := _vybrano+_pocet;    
                --pokud je výrobní číslo, tak jeho kód zaznamenám na výdejku (otázka je, zda tam nedat rovnou idvyrobnicislo    
                _vyrcis := '';    
                if (_zaznam.idvyrobnicislo>0) then    
                    select kod into _vyrcis from svyrobnicislo where idvyrobnicislo = _zaznam.idvyrobnicislo;
                end if;    
                --    
                if (_i = 1) then    
                  insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo) ;    
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));    
                  if (_sklfifo) then    
                    select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);    
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);   
                    if (_kurzDokladuP <> 0.0) then   
                      _cenamjP := _cenamjP * _kurzDokladuP;    
                    end if;  
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;  
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));  
                    _cenamjP := _cenamjP / _kurzDokladuV; 
                    _cenaMjPMen := 0.0; 
                    if(_kurzDokladuV <> 1.0) then 
                      _cenaMjPMen := _cenaMjP; 
                    end if; 
                    update dpolsklad set mnozmj = _pocet,cenamj = _cenamjP, cenaMjPoriz = _cenaMjP, sumzkl = _pocet*_cenamjP*_kurzDokladuV, sumZklMen = _pocet*_cenaMjPMen, sarze = _zaznam.sarze, expirace = _zaznam.expirace 
                          where idpolsklad = idvydej; 
                  else 
                    update dpolsklad set sarze = _zaznam.sarze, expirace = _zaznam.expirace where idpolsklad = idvydej; 
                  end if;    
                else    
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));    
                  if (_sklfifo) then    
                    select nextval('seq_dpolsklad') into _idrozlozeni;    
                    select cenamj, idDoklSklad into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);   
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);   
                    if (_kurzDokladuP <> 0.0) then   
                      _cenamjP := _cenamjP * _kurzDokladuP;    
                    end if;   
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;  
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));  
                    _cenamjP := _cenamjP / _kurzDokladuV; 
                    _cenaMjPMen := 0.0; 
                    if(_kurzDokladuV <> 1.0) then 
                      _cenaMjPMen := _cenaMjP; 
                    end if; 
                    insert into dpolsklad(idpolsklad,mnozmj,autozaokr,autogen,baleniid,cenjednotka,cenamj,cenaMjPoriz,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,datsklad,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,sumzkl,sumzklmen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy) 
	                             (select (-1*_idrozlozeni),_pocet,autozaokr,autogen,baleniid,cenjednotka,_cenamjP,_cenaMjP,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,datsklad,eankod,_zaznam.expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,_zaznam.sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,_pocet*_cenamjP,_pocet*_cenaMjPMen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy from dpolsklad where idpolsklad=idVydej); 
                    --    
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,_idrozlozeni,_pocet,_zaznam.idvyrobnicislo);    
                    insert into svazbypolsklad(idpolskladzdroj,idpolskladcil) values (idvydej, _idrozlozeni);    
                  else     
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,idvydej,_pocet,_zaznam.idvyrobnicislo);     
                  end if;     
                end if;     
                --     
                _i:=_i+1;     
              else
                if (_vybrano>_novevydcelkem) then
                  _pocet := -_zaznam.pocet;
                  if(( _vybrano+_pocet) < _novevydcelkem) then
                    _pocet := _novevydcelkem-_vybrano;
                  end if;
                  _vybrano := _vybrano+_pocet;
                  insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, 0-_pocet,_zaznam.idvyrobnicislo) ;
                end if;
              end if;  
            end if;
          end if;    
        end loop;     
      end if;     
    else     
      --nepoustím fifo do rekurze, příznak záporného id udělám opět kladný     
      update dpolsklad set idPolSklad = -1*idVydej where idpolsklad=idVydej;              
    end if; 
  end if;    
end;      
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION sfifovydej(integer, integer, integer, integer, numeric) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION svyrobnicisloupdate()
  RETURNS trigger AS
$BODY$   
declare
  _sklFifo boolean;
  _mnozMj numeric(19,6);
  _datVyst date;
  _idRozlozeni integer;
  _cenaMjP numeric(19,6);
  _kurzDokladuP numeric(19,6);
  _kurzDokladuV numeric(19,6);
  _idDoklSkladP integer;
  _idDoklSkladV integer;
  _datVystV date;
  _cenaMjPMen numeric(19,6);
  _mnozVyrobnichCisel numeric(19,6); 
  _mnozMjPoZmene numeric(19,6);
begin
  if(NEW.idPolSkladVydej is not null and OLD.idPolSkladVydej is null) then
    select datVyst, mnozMj into _datVyst, _mnozMj from dPolSklad where idPolSklad = NEW.idPolSkladVydej;
    _mnozVyrobnichCisel = 1;
    _mnozMjPoZmene = _mnozMj;
    if(_mnozMj < 0.0) then
      _mnozMjPoZmene = 0.0 - _mnozMj;
      _mnozVyrobnichCisel = -1;
    end if;
 
    _sklfifo := (select isfifosklad(_datVyst));
    if(_sklFifo) then

      select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = NEW.idPolSkladPrijem);    
      select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);   
      if (_kurzDokladuP <> 0.0) then   
	_cenamjP := _cenamjP * _kurzDokladuP;    
      end if;  
      select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = NEW.idPolSkladVydej;  
      _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));  
      _cenamjP := _cenamjP / _kurzDokladuV;
      _cenaMjPMen := 0.0;
	  if(_kurzDokladuV <> 1.0) then
        _cenaMjPMen := _cenaMjP;
      end if;
      if(_mnozMjPoZmene > 1) then
        -- odecteni 1 z mnoz mj a vytvoreni nove polozky a mnozstvim 1 a 1 vyrobnim cislem
        select nextval('seq_dpolsklad') into _idrozlozeni;                       
	update dpolsklad set mnozMJ = _mnozMj - _mnozVyrobnichCisel where idPolSklad = NEW.idPolSkladVydej;

        insert into dpolsklad(idpolsklad,           mnozmj,             autozaokr,autogen,baleniid,cenjednotka,cenamj,  cenaMjPoriz,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,datsklad,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,sumzkl,                                       sumzklmen,                       szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy) 
                             (select (_idrozlozeni),_mnozVyrobnichCisel,autozaokr,autogen,baleniid,cenjednotka,_cenamjP,_cenaMjP,   cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,datsklad,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,_cenamjP*_kurzDokladuV * _mnozVyrobnichCisel,_cenaMjPMen * _mnozVyrobnichCisel,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy from dpolsklad where idpolsklad = NEW.idpolskladvydej); 
	insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values (NEW.idPolSkladPrijem,_idrozlozeni,1,NEW.idvyrobnicislo);
	insert into svazbypolsklad(idpolskladzdroj,idpolskladcil) values (NEW.idPolSkladVydej, _idrozlozeni);
	NEW.idPolSkladVydej = _idRozlozeni;
      else
        -- nastaveni vyrobniho cisla na a vytvoreni vazby
        --update sfifovazby set idvyrobnicislo = NEW.idvyrobnicislo, kusu = 1, idpolskladprijem = NEW.idpolskladprijem where idpolskladvydej = NEW.idpolskladvydej and idvyrobnicislo = -1;
        insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values (NEW.idPolSkladPrijem,NEW.idPolSkladVydej,1,NEW.idvyrobnicislo);
        --select cenaMj into _cenaMjP from dpolsklad where idPolSklad = NEW.idPolSkladPrijem;
        update dpolsklad set cenaMJ = _cenaMjP, cenaMjPoriz = _cenaMjP, sumZkl = _cenamjP*_kurzDokladuV*_mnozVyrobnichCisel, sumZklMen = _cenaMjPMen*_mnozVyrobnichCisel where idPolSklad = NEW.idPolSkladVydej;
      end if;
      --
    else
      insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values (NEW.idPolSkladPrijem,NEW.idPolSkladVydej,1,NEW.idvyrobnicislo);
    end if;
  elsif (NEW.idPolSkladVydej is null and OLD.idPolSkladVydej is not null) then
    -- pokud se idPolSkladVydej nastavi na null z nejake hodnoty musi se smazat i fifo vazba s timto vyrobnim cislem
    delete from sfifovazby where idvyrobnicislo = NEW.idVyrobniCislo;
  end if;
  execute sprepoctisumydokladu(_idDoklSkladV);
  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION svyrobnicisloupdate() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 493, 't', %appVersion%, clock_timestamp());
