--------------------------------------------------------------------------------
-- Bug 27844 – [WinStrom] Umožnit povolit/zakázat šarže/expirace pro jednotlivé zboží
--------------------------------------------------------------------------------

-- uprava stavajiciho pole
ALTER TABLE ccenik RENAME COLUMN evidsarzeexpir TO evidsarze;
ALTER TABLE ccenik ALTER COLUMN evidsarze SET DEFAULT false;

-- vytvoreni noveho pole
ALTER TABLE ccenik ADD COLUMN evidexpir boolean NOT NULL DEFAULT false;

-- nastaveni hodnot podle polozek dokladu
update ccenik as C set 
  evidsarze = (skladove and (
    EXISTS (select 1 from dpolfak where idcenik = C.idcenik and sarze is not null and sarze <> '') or
    EXISTS (select 1 from dpolint where idcenik = C.idcenik and sarze is not null and sarze <> '') or
    EXISTS (select 1 from dpolsklad where idcenik = C.idcenik and sarze is not null and sarze <> ''))),
  evidexpir = (skladove and (
    EXISTS (select 1 from dpolfak where idcenik = C.idcenik and expirace is not null) or
    EXISTS (select 1 from dpolint where idcenik = C.idcenik and expirace is not null) or
    EXISTS (select 1 from dpolsklad where idcenik = C.idcenik and expirace is not null)));

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 577, 't', %appVersion%, clock_timestamp());
