--------------------------------------------------------------------------------
-- Bug 28947 – [winstrom] - sklad - zrychlení skladu a zrušení rozpadů fifa
--------------------------------------------------------------------------------

DROP VIEW dpolskladf;
DROP VIEW dpolskladfbezvc;
DROP VIEW dpolskladdoklad;

alter table dpolsklad alter column datSklad type TIMESTAMP;
alter table dpolsklad alter column datSklad set default LOCALTIMESTAMP;

alter table ddoklsklad drop column datSklad;

-- tam kde maji pusteny zaporny stav skladu se pusti pozadavky
update nnastav set sklGenerovatPozadavky = true where sklZapor = true;
alter table nnastav drop column sklZapor;

-- View: dpolskladdoklad
CREATE OR REPLACE VIEW dpolskladdoklad AS 
 SELECT p.idpolsklad, p.lastupdate, p.autozaokr, p.autogen, p.baleniid, p.cenjednotka, p.cenamj, p.cenamjnakup, p.cenamjprodej, p.cisrad, p.datucto, p.datvyst, p.datsklad, p.eankod, p.expirace, p.kod, p.kopclendph, p.kopdphdalucet, p.kopdphmducet, p.kopklice, p.kopstred, p.kopzakazku, p.kopzkldalucet, p.kopzklmducet, p.mnozbaleni, p.mnozmj, p.mnozmjplan, p.mnozmjreal, p.modul, p.nazev, p.objednatk, p.objem, p.poznam, p.proczakl, p.rezervovat, p.sarze, p.slevadokl, p.slevamnoz, p.slevapol, p.stavuzivk, p.storno, p.stornopol, p.sumdph, p.sumdphmen, p.sumzkl, p.sumzklmen, p.szbdph, p.typcenydphk, p.typpolozkyk, p.typszbdphk, p.typvypcenyk, p.ucetni, p.uplslevadokl, p.zaokrjakk, p.zaokrnak, p.idzkldalucet, p.iddphdalucet, p.idmjobjem, p.idmeny, p.idstred, p.idkarty, p.idcenik, p.idzklmducet, p.iddphmducet, p.idsazbydph, p.idclendph, p.idzakazky, p.idmj, p.iddoklsklad, p.idbspskl AS idskladu, p.idfirmy, d.typpohybuk
   FROM dpolsklad p
   LEFT JOIN ddoklsklad d ON p.iddoklsklad = d.iddoklsklad;

ALTER TABLE dpolskladdoklad
  OWNER TO %firmaRole%;

-- View: dpolskladf
CREATE OR REPLACE VIEW dpolskladf AS 
         SELECT p.idpolsklad, 
                CASE
                    WHEN p.typpohybuk::text = 'typPohybu.prijem'::text THEN p.mnozmj - jevydano(p.idpolsklad)
                    ELSE (- p.mnozmj) - jevydano(p.idpolsklad)
                END AS pocet, p.cenamj, p.datvyst, p.datsklad, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, NULL::integer AS idvyrobnicislo, c.evidvyrcis, p.typpohybuk
           FROM dpolskladdoklad p
      JOIN ccenik c ON c.idcenik = p.idcenik
     WHERE (p.typpohybuk::text = 'typPohybu.prijem'::text AND p.mnozmj >= 0.0 AND (p.mnozmj - jevydano(p.idpolsklad)) > 0::numeric OR p.typpohybuk::text = 'typPohybu.vydej'::text AND p.mnozmj < 0.0 AND ((- p.mnozmj) - jevydano(p.idpolsklad)) > 0::numeric) AND c.evidvyrcis = false AND p.storno <> true
UNION ALL 
         SELECT p.idpolsklad, 1 AS pocet, p.cenamj, p.datvyst, p.datsklad, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, v.idvyrobnicislo, c.evidvyrcis, p.typpohybuk
           FROM svyrobnicislo v
      JOIN dpolskladdoklad p ON p.idpolsklad = v.idpolskladprijem
   JOIN ccenik c ON c.idcenik = p.idcenik
  WHERE p.typpohybuk::text = 'typPohybu.prijem'::text AND c.evidvyrcis = true AND NOT (v.idvyrobnicislo IN ( SELECT sfifovazby.idvyrobnicislo
         FROM sfifovazby
        WHERE sfifovazby.idpolskladprijem = p.idpolsklad)) AND p.storno <> true;

ALTER TABLE dpolskladf
  OWNER TO %firmaRole%;

-- View: dpolskladfbezvc
CREATE OR REPLACE VIEW dpolskladfbezvc AS 
 SELECT p.idpolsklad, 
        CASE
            WHEN p.typpohybuk::text = 'typPohybu.prijem'::text THEN p.mnozmj - jevydano(p.idpolsklad)
            ELSE (- p.mnozmj) - jevydano(p.idpolsklad)
        END AS pocet, p.cenamj, p.datvyst, p.datsklad, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, NULL::integer AS idvyrobnicislo, false AS evidvyrcis, p.typpohybuk
   FROM dpolskladdoklad p
  WHERE (p.typpohybuk::text = 'typPohybu.prijem'::text AND p.mnozmj >= 0.0 AND (p.mnozmj - jevydano(p.idpolsklad)) > 0::numeric OR p.typpohybuk::text = 'typPohybu.vydej'::text AND p.mnozmj < 0.0 AND ((- p.mnozmj) - jevydano(p.idpolsklad)) > 0::numeric) AND p.storno <> true;

ALTER TABLE dpolskladfbezvc
  OWNER TO %firmaRole%;

-- Function: createpolsklad(integer, character varying)
-- DROP FUNCTION createpolsklad(integer, character varying);
CREATE OR REPLACE FUNCTION createpolsklad(_idpoldokl integer, _modul character varying)
  RETURNS integer AS
$BODY$ 
declare 
  _idDoklSklad integer; 
  _idDoklad integer; 
  _polDokl record; 
  _iducetobdobi integer; 
  _idkarty integer; 
  _idPolSklad integer; 
  _cenaMj numeric(19,6); 
  _cenaMjTuz numeric(19,6); 
  _typPohybuK character varying; 
  _prumCenaTuz numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _kurz numeric(19,6); 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
  _kopZklMdUcet boolean; 
  _kopZklDalUcet boolean; 
  _sklad record; 
  _typDoklK character varying; 
  _mnozMj numeric(19,6); 
  _isCiziMena boolean; 
  _idMeny integer;   
  _skupZboz record; 
  _idTypUcOp integer; 
  _kopStred boolean; 
  _kopCinnost boolean; 
  _kopZakazku boolean; 
  _idStredDoklSklad integer; 
  _idCinnostDoklSklad integer; 
  _idZakazkyDoklSklad integer; 
begin 
  _kopZklMdUcet =false; 
  _kopZklDalUcet = false; 
  if(_modul like 'FAV' or _modul like 'FAP') then 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    _idDoklad = _polDokl.idDoklFak; 
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak); 
  else 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    _idDoklad = _polDokl.idDoklInt; 
    _typDoklK = null; -- pro pokladnu dobropisy nejsou 
  end if; 
 
  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true) into _idDoklSklad;  
   
  if(_idDoklSklad is null) then 
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad; 
    if(_idDoklSklad is null) then 
      return null; 
    end if; 
  end if; 
 
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi; 
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idskladu = _polDokl.idbspskl and iducetobdobi = _iducetobdobi; 
  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl; 
   
  select typPohybuK, idstred, idcinnost, idZakazky 
    into _typPohybuK, _idStredDoklSklad, _idCinnostDoklSklad, _idZakazkyDoklSklad 
    from dDoklSklad where idDoklSklad = _idDoklSklad;  
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty; 
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena; 
  select idMeny, idTypUcOp into _idMeny, _idTypUcOp from dDoklSklad where idDoklSklad = _idDoklSklad; 
       
  if(_typPohybuK like 'typPohybu.vydej') then 
    -- vsechny dobropisy generuji prijemky 
    --if(_typDoklK like 'typDokladu.dobropis') then 
    --  _mnozMj = -_polDokl.mnozMj; 
    --else 
      _mnozMj = _polDokl.mnozMj; 
    --end if; 
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena 
    _cenaMj = _prumCenaTuz / _kurz; 
    _sumZkl = _prumCenaTuz * _mnozMj; 
    if(_isCiziMena) then 
      _sumZklMen = _mnozMj * _cenaMj; 
    else 
      _sumZklMen = 0.0; 
    end if; 
    -- nastaveni uctu pro polSklad vydej 
    select * into _skupZboz from cskupzboz where idskupzboz = (select idskupzboz from ccenik where idcenik = _polDokl.idCenik); 
    if(_skupZboz.idProtiUcetSklV is not null) then 
      -- pokud je ve skupine zbozi nastaven protiucet pro vydej ze skladu pouzije se ten a kopirovani se necha na false; 
      _idZklMdUcet = _skupZboz.idProtiUcetSklV; 
    else 
      -- pokud neni ve skupine zbozi nastaven protiucet tak vemu protiucet z hlavicky a dam kopirovat na true 
      select idProtiUcet into _idZklMdUcet from dDoklSklad where idDoklSklad = _idDoklSklad; 
      _kopZklMdUcet = true; 
    end if; 
    _idZklDalUcet = _sklad.idPrimUcet; 
  else 
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then 
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny; 
      _mnozMj = -_polDokl.mnozMj; 
      --_cenaMjTuz = _prumCenaTuz; 
      _cenaMjTuz = _polDokl.cenaMjNakup; 
      if(_cenaMjTuz = 0.0) then 
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik); 
        if(_cenaMj = 0.0) then 
          _cenaMj = _polDokl.cenaMj * _kurz; 
        end if; 
      end if; 
      _cenaMj = _cenaMjTuz / _kurz; 
      _sumZkl = _mnozMj * _cenaMjTuz; 
      if(_isCiziMena) then 
        _sumZklMen = _mnozMj * _cenaMj; 
      else 
        _sumZklMen = 0.0; 
      end if; 
      select * into _skupZboz from cskupzboz where idskupzboz = (select idskupzboz from ccenik where idcenik = _polDokl.idCenik); 
      if(_skupZboz.idProtiUcetSklV is not null) then 
        -- pokud je ve skupine zbozi nastaven protiucet pro vydej ze skladu pouzije se ten a kopirovani se necha na false; 
        _idZklDalUcet = _skupZboz.idProtiUcetSklV; 
      else 
        -- pokud neni ve skupine zbozi nastaven protiucet tak vemu protiucet z hlavicky a dam kopirovat na true 
        select idProtiUcet into _idZklDalUcet from dDoklSklad where idDoklSklad = _idDoklSklad; 
        _kopZklDalUcet = true; 
      end if; 
    else 
      -- pokud na sklad prijmam zkopiruji se ceny z faktury 
      _mnozMj = _polDokl.mnozMj; 
      _sumZkl = _polDokl.sumZkl; 
      if(_mnozMj <> 0.0) then 
        _cenaMj = _sumZkl / _mnozMj; 
      else 
        _cenaMj = _sumZkl; 
      end if; 
      _cenaMj = _cenaMj / _kurz; 
      if(_isCiziMena) then 
        if(_mnozMj <> 0.0) then 
          _sumZklMen = _cenaMj * _mnozMj;   
        else 
          _sumZklMen = _cenaMj; 
        end if; 
      else 
        _sumZklMen = 0.0;   
      end if; 
      _idZklDalUcet = _polDokl.idZklMdUcet; 
    end if; 
    -- nastaveni uctu pro polSklad prijem 
    _idZklMdUcet = _sklad.idPrimUcet; 
  end if;  
 
  _kopStred = true; 
  if(not compareId(_idStredDoklSklad, _polDokl.idStred)) then 
    _kopStred = false; 
  end if; 
  _kopCinnost = true; 
  if(not compareId(_idCinnostDoklSklad, _polDokl.idCinnost)) then 
    _kopCinnost = false; 
  end if; 
  _kopZakazku = true; 
  if(not compareId(_idZakazkyDoklSklad, _polDokl.idZakazky)) then 
    _kopZakazku = false; 
  end if; 
   
  select nextval('seq_dpolsklad') into _idPolSklad;   
  insert into dpolsklad(idPolSklad, lastUpdate, idcenik, idbspskl, idkarty, datVyst, datSklad, datUcto, modul, typPolozkyK, idDoklSklad, 
        mnozMj, cenaMj, cenaMjPoriz, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, idmj, 
        nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni,  
        idStred, kopStred, idZakazky, kopZakazku, idMeny, zdrojProFak, idCinnost, kopCinnost, idTypUcOp) 
      values (_idPolSklad, LOCALTIMESTAMP, _polDokl.idcenik, _polDokl.idbspskl, _idkarty, _polDokl.datVyst, LOCALTIMESTAMP, _polDokl.datVyst, 'SKL', 'typPolozky.katalog', _idDoklSklad, 
        _mnozMj, _cenaMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, _kopZklMdUcet, _kopZklDalUcet, _polDokl.baleniid, _polDokl.mnozBaleni, _polDokl.idmj, 
        _polDokl.nazev, _polDokl.nazevA, _polDokl.nazevB, _polDokl.nazevC, _polDokl.sarze, _polDokl.expirace, _polDokl.cisRad, true,  
        _polDokl.idStred, _kopStred, _polDokl.idZakazky, _kopZakazku, _idMeny, false, _polDokl.idCinnost, _kopCinnost, _idTypUcOp); 
  
  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK) 
       values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSkl'); 
 
  -- prepocteni sum na dokladu 
  execute sprepoctiSumyDokladu(_idDoklSklad); 
 
  return _idPolSklad; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION createpolsklad(integer, character varying)
  OWNER TO %firmaRole%;

-- Function: createdoklsklad(integer, integer, character varying)
-- DROP FUNCTION createdoklsklad(integer, integer, character varying);
CREATE OR REPLACE FUNCTION createdoklsklad(_idpoldokl integer, _iddoklad integer, _modul character varying)
  RETURNS integer AS
$BODY$ 
declare 
  _doklad record; 
  _polDokl record; 
  _doklSklad record; 
  _idDoklSklad integer; 
  _cisDoklad character varying; 
  _idrada integer; 
  _rada record; 
  _sklad record; 
  _idUcetObd integer; 
  _radaRok record; 
  _typPohybuSklad character varying; 
  _idTypUcOp integer; 
  _cisloDokladuCursor refCursor; 
  _typDoklFak record; 
  _typDoklSkl record; 
  _idUcetSklad integer; 
  _idProtiUcet integer; 
  _typUcOp record; 
  _kurz numeric(19,6); 
  _idMenyTuzemsko integer; 
  _idMenySklad integer; 
  _kurzMnozstvi numeric(19,6); 
  _typVazby character varying; 
  _stavSklad character varying; 
  _typPohybuSkladK character varying; 
  _isDobropis boolean; 
  _ucetObdPlatiOd date; 
  _ucetObdPlatiDo date; 
begin 
  if(_modul like 'POK') then 
    select * into _doklad from dDoklInt where idDoklInt = _idDoklad; 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    _stavSklad = 'stavSklad.vygenPokl'; 
  elsif (_modul like 'FAV' or _modul like 'FAP') then 
    select * into _doklad from dDoklFak where idDoklFak = _idDoklad; 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    _stavSklad = 'stavSklad.vygenFakt'; 
  else 
    select * into _doklad from dDoklSklad where idDoklSklad = _idDoklad; 
    select * into _polDokl from dPolSklad where idPolSklad = _idPolDokl; 
    _stavSklad = 'stavSklad.vyroba'; 
  end if; 
 
  --select * into _sklad from dTypDokl where idTypDokl = _polDokl.idskladu; 
  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl; 
  select * into _typDoklFak from dTypDokl where idTypDokl = _doklad.idTypDokl; 
 
  if(_typDoklFak.typDoklK like 'typDokladu.dobropis') then 
    _isDobropis = true; 
  else 
    _isDobropis = false; 
  end if; 
  
  if(_doklad.idTypDoklSkl is null) then  
    if((_modul like 'FAV' and _isDobropis) or (_modul like 'FAP')) then 
      --pro dobropisy vydanych faktur a prijate faktury budeme mit prijemku 
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuprijem; 
    elsif((_modul like 'FAV' and not _isDobropis)) then 
      --pro dobropisy prijatych faktur a vydane faktury budeme mit vydejku 
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuvydej; 
    elsif(_modul like 'POK' and _doklad.typPohybuK like 'typPohybu.prijem') then 
      --pro prijmovy pokladni doklad budeme mit vydejku 
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuvydej; 
    elsif(_modul like 'POK' and _doklad.typPohybuK like 'typPohybu.vydej') then 
      --pro vydajovy pokladni doklad budeme mit prijemku 
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuprijem; 
    elsif(_modul like 'SKL') then 
      -- vyroba 
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuvydej; 
    else 
      raise exception 'createdoklsklad:Nespravny modul %', _modul; 
    end if; 
    if(_typDoklSkl is null) then 
      return null; 
    end if; 
  else 
    select * into _typDoklSkl from dTypDokl where idTypDokl = _doklad.idTypDoklSkl; 
  end if; 
 
  -- urceni spravneho typu pohybu 
  if((_typDoklFak.modul like 'FAV') and (_typDoklFak.typDoklK like 'typDokladu.dobropis')) then 
    _typPohybuSklad = _doklad.typPohybuK; 
  else 
    if(_doklad.typPohybuK like 'typPohybu.prijem') then 
      _typPohybuSklad = 'typPohybu.vydej'; 
    else 
      _typPohybuSklad = 'typPohybu.prijem'; 
    end if; 
  end if; 
 
  -- doplneni zbyvajicich veci zavislich na typu pohybu 
  if(_typPohybuSklad like 'typPohybu.prijem') then 
    _idrada = _typDoklSkl.idRadyPrijem; 
    if(_idrada is null) then 
      _idRada = _sklad.idRadyPrijem; 
    end if; 
    if(_idRada is null) then 
      raise exception 'Neni odkud natahnout dokladovou radu.'; 
    end if; 
    _idTypUcOp = _typDoklSkl.idTypUcOpP; 
    if(_modul = 'FAV' or _modul = 'FAP' or _modul = 'POK') then 
      _typPohybuSkladK = 'typPohybuSklad.prijemPoFak'; 
    else 
      _typPohybuSkladK = 'typPohybuSklad.prijemVyrob'; 
    end if; 
  else 
    _idrada = _typDoklSkl.idRadyVydej; 
    if(_idrada is null) then 
      _idRada = _sklad.idRadyVydej; 
    end if; 
    if(_idRada is null) then 
      raise exception 'Neni odkud natahnout dokladovou radu.'; 
    end if; 
    _idTypUcOp = _typDoklSkl.idTypUcOpV; 
    if(_modul = 'FAV' or _modul = 'FAP' or _modul = 'POK') then 
      _typPohybuSkladK = 'typPohybuSklad.vydejPoFak'; 
    else 
      _typPohybuSkladK = 'typPohybuSklad.vydejVyrob'; 
    end if; 
  end if; 
 
  _idUcetSklad = _sklad.idPrimUcet; 
  select * into _typUcOp from utypucop where idtypucop = _idTypUcOp; 
  if(_typPohybuSklad like 'typPohybu.prijem') then 
    _idProtiUcet = _typUcOp.idProtiucetP; 
  else 
    _idProtiUcet = _typUcOp.idProtiucetV; 
  end if; 
  if(_modul = 'FAP') then 
    _idProtiUcet = _doklad.idProtiUcet; 
  end if; 
 
  select * into _rada from drady where idRady = _idrada; 
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _idUcetObd; 
  select * into _radaRok from dRadyRok where iducetobdobi = _idUcetObd and idrady = _idrada; 
 
  select nextval('seq_ddoklsklad') into _idDoklSklad; 
  select dgetcisdokl(null, _idrada, _idUcetObd, 'SKL', _typPohybuSklad) into _cisloDokladuCursor; 
  fetch _cisloDokladuCursor into _cisDoklad; 
 
  -- ziskani kurzu pro menu skladu 
  -- select getKurzFromSklad(_polDokl.idSkladu, _polDokl.datVyst) into _kurz; 
  -- nejde pouzit protoze potrebuju jak kurz tak kurzove mnozstvi a ne prepocteny nna kurzove mnozstvi 1 
  select idMeny into _idMenyTuzemsko from nNastav where _polDokl.datVyst >= PlatiOdData order by PlatiOdData desc limit 1; 
  if (_idMenyTuzemsko is null) then 
    select idMeny into _idMenyTuzemsko from nNastav where PlatiOdData is null limit 1; 
  end if; 
  --select idMeny into _idMenySklad from dTypDokl where idTypDokl = _polDokl.idSkladu; 
 
  if(_sklad.idMeny is null or _sklad.idMeny = _idMenyTuzemsko) then 
    _kurz = 0.0; 
    _kurzMnozstvi = 1; 
  else 
    select nbStred, kurzMnozstvi into _kurz, _kurzMnozstvi from uKurzy 
      where idMeny = _sklad.idMeny and _polDokl.datVyst >= PlatiOdData and typkurzuk = 'typKurzu.obecny' 
      order by PlatiOdData desc limit 1; 
    if(_kurz is null) then 
      select nbStred, kurzMnozstvi into _kurz, _kurzMnozstvi from uKurzy 
        where idMeny = _sklad.idMeny and PlatiOdData is null and typkurzuk = 'typKurzu.obecny' 
        limit 1; 
    end if; 
    if(_kurz is null) then 
      raise exception '0001:getKurzFromSklad : neexistuje kurz!'; 
    end if; 
  end if; 
 
  if(_isDobropis) then 
    if(_modul like 'FAV') then 
      _typPohybuSkladK = 'typPohybuSklad.prijemVratka'; 
    else 
      _typPohybuSkladK = 'typPohybuSklad.prijemVydejVratka'; 
    end if; 
  end if; 
 
  -- vytvoreni noveho skladoveho dokladu 
  insert into dDoklSklad (idDoklSklad, lastUpdate, datVyst, datUcto, kod, modul, typPohybuK, idTypDokl, idBsp,ucetni, varSym, 
         idFirmy, nazFirmy, ulice, mesto, psc, idStatu, ic, dic, vatId, 
         idMur, idKrajUrc, idStatUrc, idTypUcOp, cisObj, cisDodak, doprava, idDruhDopr, popis, poznam, 
         idStred, idZakazky, idMeny, kurz, kurzMnozstvi, 
         eanKod, idstatpuvod, idstatodesl, idobchtrans, iddodpodm, idzvlpoh, 
         idPrimUcet, idProtiUcet, idRady, idPolRady, zdrojProFak, stavSkladK , typPohybuSkladK, 
         idCinnost, idKontaktOsoba, idZodpOsoba 
         ) 
       values (_idDoklSklad, LOCALTIMESTAMP, _doklad.datVyst, _doklad.datVyst, _cisDoklad, 'SKL', _typPohybuSklad, _typDoklSkl.idTypDokl, _sklad.idBsp, _typDoklSkl.ucetni, _doklad.varSym, 
         _doklad.idFirmy, _doklad.nazFirmy, _doklad.ulice, _doklad.mesto, _doklad.psc, _doklad.idStatu, _doklad.ic, _doklad.dic, _doklad.vatId, 
         _doklad.idMur, _doklad.idKrajUrc, _doklad.idStatUrc, _idTypUcOp, _doklad.cisObj, null, _doklad.doprava, _doklad.idDruhDopr, _doklad.popis, _doklad.poznam, 
         _doklad.idStred, _doklad.idZakazky, _sklad.idMeny, _kurz, _kurzMnozstvi, 
         _doklad.eanKod, _doklad.idstatpuvod, _doklad.idstatodesl, _doklad.idobchtrans, _doklad.iddodpodm, _doklad.idzvlpoh, 
         _idUcetSklad, _idProtiUcet, _idRada, _radaRok.idRadyRok, false, _stavSklad, _typPohybuSkladK, 
         _doklad.idCinnost, _doklad.idKontaktOsoba, _doklad.idZodpOsoba 
         ); 
 
 
  if (_modul = 'SKL') then 
    _typVazby = 'typVazbyDokl.hlavaSklKus'; 
  else 
    _typVazby = 'typVazbyDokl.hlavaSkl'; 
  end if; 
 
  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK) 
       values (0.0, _idDoklad, _idDoklSklad, _doklad.modul, 'SKL', false, _typVazby); 
 
  return _idDoklSklad; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION createdoklsklad(integer, integer, character varying)
  OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION daapolskladinsertmnozmj()
  RETURNS trigger AS
$BODY$  
declare  
  _stavSkladu numeric(19,6); 
  _typPohybuK character varying; 
  _sklGenerovatPozadavky boolean; 
begin 
  -- tento trigger tu musi zustat protoze jinak na obycejnych vydejkach a prijemkach nebude vyplneno mnozMjPlan
  select sklgenerovatpozadavky into _sklGenerovatPozadavky from nNastav where NEW.datVyst >= PlatiOdData order by PlatiOdData desc limit 1;  
  if (_sklGenerovatPozadavky is null) then  
        select sklgenerovatpozadavky into _sklGenerovatPozadavky from nNastav where PlatiOdData is null limit 1;   
  end if;  
 
  NEW.mnozMjPlan = NEW.mnozMj;
 
  if (_sklGenerovatPozadavky) then 
    select typPohybuK into _typPohybuK from ddoklsklad where iddoklsklad = NEW.idDoklSklad; 
    select stavMj into _stavSkladu from skarty where idKarty = NEW.idKarty;
   
    if(_typPohybuK = 'typPohybu.vydej' and NEW.mnozMj > _stavSkladu) then 
      NEW.mnozMj = 0.0; 
    end if; 
  end if; 
   
  return NEW; 
end;  
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION daapolskladinsertmnozmj()
  OWNER TO %firmaRole%;


-- INSERT TRIGGER
-- Function: dpolskladinsert()
-- DROP FUNCTION dpolskladinsert();
CREATE OR REPLACE FUNCTION dpolskladinsert()
  RETURNS trigger AS
$BODY$ 
declare 
  _rozsirenaPolozka record; 
  _typPohybuk character varying; 
  _mazatTmpTable boolean; 
  _idPolSklad integer; 
  _probihaPrepocetSkladu character varying; 
  _polSklad record;  
  _pocetMenenychVydejek integer; 
begin 
  if(NEW.storno = true) then 
    return NEW; 
  end if;  
   
  select getglotxvariable('probihaPrepocetSkladu') into _probihaPrepocetSkladu; 
  if(_probihaPrepocetSkladu = 'true') then 
  else 
    -- tento select zjisti kolik je vydejek, ktere by se meli prepocitavat 
    select count(idpolsklad) into _pocetMenenychVydejek from dpolsklad ps join ddoklsklad ds  
      on ps.datsklad >= NEW.datSklad and ps.cenyRucne = false and ps.iddoklsklad = ds.iddoklsklad and ds.typpohybuk = 'typPohybu.vydej'; 
    if(_pocetMenenychVydejek = 0 and NEW.cenyRucne = true) then 
      execute sprepoctiskladkartu(NEW.mnozMj, NEW.cenaMj, NEW.sumZkl, NEW.datVyst, NEW.idKarty, NEW.idDoklSklad, NEW.idBspSkl, 1);  
      return NEW; 
    end if; 
 
    -- v pripade ze neprobiha prepocet skladu 
    -- generuji rozsirene polozky 
    select skladGenerujRozsirenePolozky(NEW.datSklad, NEW.idPolSklad, NEW.idKarty) into _mazatTmpTable; 
 
    execute putglotxvariable('zurnalTxName', 'prepocetSkladu'); 
 
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
      if(_rozsirenaPolozka.idPolSklad <> NEW.idPolSklad) then 
        if(_rozsirenaPolozka.cenyRucne = true) then 
          -- pokud maji byt ceny zadany rucne a nemaji se nikterak menit tak jen zmenime skladovou kartu a jedeme dal 
          if(_rozsirenaPolozka.storno = false) then  
            select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad; 
            execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, -1);  
          end if; 
        else 
          execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
        end if; 
      end if; 
    end loop; 
 
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
      if(_rozsirenaPolozka.cenyRucne = true) then 
        -- pokud maji byt ceny zadany rucne a nemaji se nikterak menit tak jen zmenime skladovou kartu a jedeme dal 
        if(_rozsirenaPolozka.storno = false) then  
          select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad; 
          execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, 1);  
        end if; 
      else 
        execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
      end if; 
    end loop; 
 
    if(_mazatTmpTable) then 
      drop table tmp_RozsirenePolozky; 
      drop table tmp_SkladoveKarty; 
      execute removeglotxvariable('zurnalTxName'); 
    end if; 
  end if; 
 
  select typpohybuk into _typPohybuk from ddoklsklad where iddoklsklad = NEW.iddoklsklad; 
  --pokud výdej, tak fifuju vazby 
  if (_typPohybuk = 'typPohybu.vydej' or (_typPohybuK = 'typPohybu.prijem' and NEW.mnozMj < 0.0)) then 
    execute sFifoVydej(NEW.idPolSklad, NEW.idCenik, NEW.idBspSkl, NEW.idKarty, NEW.mnozmj, NEW.cenyRucne); 
    execute sPrepoctiSumyDokladu(NEW.idDoklSklad); 
  end if; 
 
  if(_probihaPrepocetSkladu = 'true') then 
    if(NEW.idPolSklad < 0) then 
      _idPolSklad = -NEW.idPolSklad; 
    else 
      _idPolSklad = NEW.idPolSklad; 
    end if; 
 
    execute skladinsertrozsirenoupolozku(_idPolSklad); 
  end if; 
 
  return NEW; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION dpolskladinsert()
  OWNER TO %firmaRole%;



-- Function: skladgenerujrozsirenepolozky(date, integer, integer)
DROP FUNCTION if exists skladgenerujrozsirenepolozky(date, integer, integer);
CREATE OR REPLACE FUNCTION skladgenerujrozsirenepolozky(i_datum timestamp, i_idpolsklad integer, i_idskladkarty integer)
  RETURNS boolean AS
$BODY$ 
declare 
  tmp_skladovekarty_exists boolean; 
  tmp_rozsirenepolozky_exists boolean; 
  _polSklad record; 
  _skladKarta record; 
  _pocetSkladKarty integer; 
  _result boolean; 
  _idUcetObd integer; 
begin 
  -- pokud se zde nebyli tabulky vytvoreny tak se vrati false a pokud ano tak se true 
  _result = false; 
 
  -- vytvoreni temporary tabulky pro ulozeni seznamu skladovych karet na kterych dochazi k prepoctu 
  tmp_skladovekarty_exists := (select istableexist('tmp_SkladoveKarty')); 
  if(tmp_skladovekarty_exists <> true) then 
    --raise exception 'tmp_skladoveKarty se vytvari'; 
    CREATE TEMPORARY TABLE tmp_SkladoveKarty ( 
      idskladkarty integer 
    ) WITH (OIDS=TRUE) ON COMMIT DROP; 
  end if; 
 
  -- vytvoreni temporary tabulky pro ulozeni seznamu polozek, ktere budou prepocitavat skladove karty 
  tmp_rozsirenepolozky_exists := (select istableexist('tmp_RozsirenePolozky')); 
  if(tmp_rozsirenepolozky_exists <> true) then 
    CREATE TEMPORARY TABLE tmp_RozsirenePolozky ( 
      idpolsklad integer, 
      iddoklskladMaster integer, 
      iddoklskladpolozky integer, 
      datum timestamp, 
      skupina integer, 
      typPohybuK character varying, 
      idskladkarty integer, 
      storno boolean, 
      cenyRucne boolean  
      --mnozMj numeric(19,6), 
      --cenaMj numeric(19,6), 
      --sumZkl numeric(19,6) 
    ) WITH (OIDS=TRUE) ON COMMIT DROP; 
 
    -- tabulky zde byli vytvoreny tim padem se musi vracet true 
    _result = true; 
  end if; 
   
  if(i_idSkladKarty is not null and i_idSkladKarty <> -1) then 
    -- pokud se jedna o prepocet po vlozeni jedna polozky nebo o rekurzi tak se vse dela jen s jednou skladovou kartou 
    select count(*) into _pocetSkladKarty from tmp_SkladoveKarty where idskladkarty = i_idSkladKarty; 
    if(_pocetSkladKarty = 0) then 
      insert into tmp_SkladoveKarty (idskladkarty) values (i_idSkladKarty); 
      for _polSklad in (select * from dpolsklad where datSklad >= i_datum and idkarty = i_idSkladKarty) loop 
        execute skladInsertRozsirenouPolozku(_polSklad.idPolSklad); 
      end loop; 
    else 
      -- do something stupid - kdyz je skladkarta v seznamu 
    end if; 
  else 
    -- pokud se jedna o celkovy prepocet skladu tak do tmp tabulky skladovych karet dam vsechny pro dane obdobi 
    select iducetobdobi into _idUcetObd from nucetobdobi where platioddata <= i_datum and platidodata >= i_datum; 
    for _skladKarta in (select * from skarty where iducetobdobi = _idUcetObd) loop 
      insert into tmp_SkladoveKarty(idskladkarty) values (_skladKarta.idKarty); 
      --for _polSklad in (select * from dpolsklad where datSklad >= i_datum and idkarty = _skladKarta.idKarty) loop 
      -- tento for cyklus je spatne protoze pokud jsou spatna data (dat vyst je 2010 a karta 2011) tak k prepoctu nedojde 
      for _polSklad in (select * from dpolsklad where idkarty = _skladKarta.idKarty) loop 
        execute skladInsertRozsirenouPolozku(_polSklad.idPolSklad); 
      end loop; 
    end loop; 
  end if; 
 
  return _result; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION skladgenerujrozsirenepolozky(timestamp, integer, integer)
  OWNER TO %firmaRole%;



-- Function: skladprepoctirozsirenoupolozku(integer, integer)
-- DROP FUNCTION skladprepoctirozsirenoupolozku(integer, integer);
CREATE OR REPLACE FUNCTION skladprepoctirozsirenoupolozku(i_idrozsirenepolozky integer, sign integer)
  RETURNS void AS
$BODY$ 
declare 
  _skladKarta record; 
  _rozsirenaPolozka record; 
  _polSklad record; 
  _navazanaPolSklad record; 
  _stavMj numeric(19,6); 
  _stavTuz numeric(19,6); 
  _stavMen numeric(19,6); 
  _prumCenaTuz numeric(19,6); 
  _prumCenaMen numeric(19,6); 
  _pocetNavazanych integer; 
  _cenaMj numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _kurzDokladu numeric(19,6); 
  _kurzSkladKarty numeric(19,6); 
  _isCiziMena boolean; 
  _sklfifo boolean; 
  _datPosl date;  
  _PoslCenaTuz numeric(19,6);      
  _PoslCenaMen numeric(19,6);      
  _cenaMjSkl numeric(19,6); 
  _updateCena boolean; 
  _rozpadlaPolSklad record; 
  _sumZklProCenaMj numeric(19,6); 
  _mnozMjProCenaMj numeric(19,6); 
  _cenaMjPoriz numeric(19,6); 
  --_cenaMjNakl numeric(19,6); 
begin 
  select * into _rozsirenaPolozka from tmp_RozsirenePolozky where idpolsklad = i_idrozsirenepolozky; 
  select * into _polSklad from dPolSklad where idPolSklad = i_idrozsirenepolozky; 
  if(_polSklad is null) then 
    -- muze se stat ze v rozsirenych polozkach je uz polozka ktera byla v ramci transakce smazana 
    return; 
  end if; 
   
  select * into _skladKarta from sKarty where idKarty = _rozsirenaPolozka.idskladkarty; 
  select getKurzFromDoklad(_rozsirenaPolozka.idDoklSkladPolozky, _polSklad.datVyst) into _kurzDokladu; 
 
  if(sign = 1) then 
    if(_rozsirenaPolozka.skupina = 1) then 
      if(_polSklad.mnozMj = 0.0) then 
        _stavTuz = _polSklad.cenaMj * _kurzDokladu; 
      else 
        select sumZkl into _stavTuz from dpolsklad where idPolSklad = _rozsirenaPolozka.idPolSklad; 
      end if; 
    else 
      -- pokud se jedna o prijemku z prevodky nebo vyroby tak se musi cena nastavit podle navazane vydejky 
      _cenaMjSkl = 0.0; 
      _sklfifo := (select isfifosklad(_polSklad.datVyst)); 
      -- menit cenu budeme jen pokud to neni fifo 
      _updateCena = not _sklFifo; 
      if(_rozsirenaPolozka.skupina = 2 and _rozsirenaPolozka.typPohybuK = 'typPohybu.prijem') then 
        select * into _navazanaPolSklad from dPolSklad  
            where idPolSklad = (select idTabA from dvazebtab where idTabB = _rozsirenaPolozka.idPolSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
        if(_navazanaPolSklad is null) then 
          _cenaMj = _polSklad.cenaMjNeskl; 
          _cenaMjSkl = 0.0; 
          _cenaMjPoriz = _cenaMj; 
          _sumZkl = _polSklad.cenaMjNeskl * _polSklad.mnozMj; 
          for _navazanaPolSklad in (select * from dPolSklad where idPolSklad in  
            (select idTabB from dvazebtab where idTabA = _rozsirenaPolozka.idPolSklad and modulA = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus') ) 
            loop 
            if(_navazanaPolSklad.mnozMj <> 0.0) then 
              _cenaMj = _cenaMj + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu; 
              _cenaMjSkl = _cenaMjSkl + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu; 
            else 
              raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit 
            end if; 
            _sumZkl = _sumZkl + _navazanaPolSklad.sumZkl; 
 
            -- musime zohlednit i pripadne rozpady skladovych polozek 
            for _rozpadlaPolSklad in (select * from dPolSklad where idPolSklad in 
              (select idpolskladcil from svazbypolsklad where idpolskladzdroj = _navazanaPolSklad.idPolSklad)) 
            loop 
              if(_rozpadlaPolSklad.mnozMj <> 0.0) then 
                _cenaMj = _cenaMj + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu; 
                _cenaMjSkl = _cenaMjSkl + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu; 
              else 
                raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit 
              end if; 
              _sumZkl = _sumZkl + _rozpadlaPolSklad.sumZkl; 
            end loop; 
 
            _cenaMjPoriz = _cenaMj; 
 
            -- ovsem pokud se jedna o vyrobu musime zmenit cenu prijmky z vyroby 
            _updateCena = true; 
          end loop; 
          _cenaMj = _cenaMjPoriz + _polSklad.cenaMjNakl; 
          _sumZkl = _sumZkl + (_polSklad.mnozMj * _polSklad.cenaMjNakl); 
        else 
          _sumZklProCenaMj = 0.0; 
          _mnozMjProCenaMj = 0.0; 
          if(_navazanaPolSklad.mnozMj <> 0.0) then 
            _sumZklProCenaMj = _sumZklProCenaMj + _navazanaPolSklad.sumZkl / _kurzDokladu; 
            _mnozMjProCenaMj = _mnozMjProCenaMj + _navazanaPolSklad.mnozMj; 
          else 
            raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit 
          end if; 
          _sumZkl = _navazanaPolSklad.sumZkl; 
          -- musime zohlednit i pripadne rozpady skladovych polozek 
          for _rozpadlaPolSklad in (select * from dPolSklad where idPolSklad in 
            (select idpolskladcil from svazbypolsklad where idpolskladzdroj = _navazanaPolSklad.idPolSklad order by idpolskladcil desc) 
            order by idpolsklad desc)  
          loop 
            if(_polSklad.mnozMj > _mnozMjProCenaMj) then 
              if(_rozpadlaPolSklad.mnozMj <> 0.0) then 
                _sumZklProCenaMj = _sumZklProCenaMj + _rozpadlaPolSklad.sumZkl / _kurzDokladu; 
                _mnozMjProCenaMj = _mnozMjProCenaMj + _rozpadlaPolSklad.mnozMj; 
              else 
                raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit 
              end if; 
              _sumZkl = _sumZkl + _rozpadlaPolSklad.sumZkl; 
            end if; 
          end loop; 
 
          if(_mnozMjProCenaMj <> 0.0) then 
            _cenaMjPoriz = _sumZklProCenaMj / _mnozMjProCenaMj; 
          else 
            raise exception '_mnozMjProCenaMj je 0.0'; -- TODO vyresit co se bude dit 
          end if; 
          _cenaMj = _cenaMjPoriz + _polSklad.cenaMjNakl; 
          _sumZkl = _sumZkl + (_polSklad.mnozMj * _polSklad.cenaMjNakl); 
          --_sumZkl = _polSklad.mnozMj * _cenaMj; 
          -- ovsem pokud se jedna o prevodku musime zmenit cenu prijmky z prevodky 
          _updateCena = true; 
        end if; 
        _sumZklMen = 0.0; 
        select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _polSklad.datVyst) into _isCiziMena; 
        if(_isCiziMena) then 
          _sumZklMen = _polSklad.mnozMj * _cenaMj; 
        end if; 
      else 
        _cenaMj = _skladKarta.prumCenaTuz; 
        _cenaMjPoriz = _skladKarta.prumCenaTuz; 
        if(_kurzDokladu is not null and _kurzDokladu <> 0.0) then 
          _cenaMj = _cenaMj / _kurzDokladu; 
        end if; 
        _sumZkl = _polSklad.mnozMj * _skladKarta.prumCenaTuz; 
        _sumZklMen = 0.0; 
        select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _polSklad.datVyst) into _isCiziMena; 
        if(_isCiziMena) then 
          _sumZklMen = _polSklad.mnozMj * _cenaMj;  
        end if; 
      end if; 
 
      if (_updateCena) then 
        update dPolSklad set 
          cenaMjPoriz = _cenaMjPoriz, 
          cenaMj = _cenaMj, 
          cenaMjSkl = _cenaMjSkl, 
          sumZkl = _sumZkl, 
          sumZklMen = _sumZklMen 
          where idPolSklad = _rozsirenaPolozka.idPolSklad; 
      end if; 
 
      execute sprepoctisumydokladu(_rozsirenaPolozka.idDoklSkladPolozky); 
 
      select sumZkl into _stavTuz from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad; 
    end if; 
  else 
    if(_polSklad.mnozMj = 0.0 and _rozsirenaPolozka.typpohybuk = 'typPohybu.prijem') then 
      _stavTuz = _polSklad.cenaMj * _kurzDokladu; 
    else 
      select sumZkl into _stavTuz from dpolsklad where idPolSklad = i_idrozsirenepolozky; 
    end if; 
  end if; 
 
  if(_rozsirenaPolozka.typpohybuk = 'typPohybu.vydej') then 
    _stavMj = _skladKarta.stavMj - (sign*_polSklad.mnozMj); 
    _stavTuz = _skladKarta.stavTuz - (sign*_stavTuz); 
  else 
    _stavMj = _skladKarta.stavMj + (sign*_polSklad.mnozMj); 
    _stavTuz = _skladKarta.stavTuz + (sign*_stavTuz); 
  end if; 
 
  if(_stavMj is null) then 
    raise exception 'stav mj je null a idpolsklad je % a _skladkarta je % a _polSklad je %',i_idrozsirenepolozky, _skladkarta, _polSklad; 
  end if; 
 
  _prumCenaTuz = _skladKarta.prumCenaTuz; 
  if(_stavMj <> 0.0) then 
    _prumCenaTuz = _stavTuz / _stavMj; 
  end if; 
  if(_prumCenaTuz is null) then 
    raise exception 'prumCenaTuz je null, _stavTuz je %, _stavMj je %', _stavTuz, _stavMj; 
  end if;  
  
  _datPosl = _skladKarta.datPosl; 
  if(_datPosl is null or _datPosl < _polSklad.datVyst) then 
    _datPosl = _polSklad.datVyst; 
  end if; 
 
  _poslCenaTuz = _skladKarta.poslCenaTuz; 
  _poslCenaMen = _skladKarta.poslCenaMen; 
  if(_rozsirenaPolozka.typpohybuk = 'typPohybu.prijem') then 
    _PoslCenaTuz := _polSklad.cenaMj * _KurzDokladu;    
    _PoslCenaMen := _polSklad.cenaMj;  
  end if; 
  
  _KurzSkladKarty := (select getKurzFromSklad(_skladKarta.idSkladu, _polSklad.datVyst)); 
  if (not _rozsirenaPolozka.storno) then 
    update skarty set  
      stavmj = _stavMj, 
      stavTuz = _stavTuz, 
      stavMen = round(_stavTuz / _kurzSkladKarty, 2), 
      prumCenaTuz = _prumCenaTuz, 
      prumCenaMen = _prumCenaTuz / _kurzSkladKarty, 
      datPosl = _datPosl, 
      poslCenaTuz = _poslCenaTuz, 
      poslCenaMen = _poslCenaMen, 
      lastUpdate = LOCALTIMESTAMP 
      where idkarty = _rozsirenaPolozka.idSkladKarty; 
  end if; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION skladprepoctirozsirenoupolozku(integer, integer)
  OWNER TO %firmaRole%;


-- UPDATE TRIGGER
-- Function: dpolskladupdate()
-- DROP FUNCTION dpolskladupdate();
CREATE OR REPLACE FUNCTION dpolskladupdate()
  RETURNS trigger AS
$BODY$  
declare  
  tmp_rozsirenepolozky_exists boolean;  
  _updatuj boolean;  
  _pocetPolozek integer;  
  _rozsirenaPolozka record;  
  _sklFifo boolean;  
  _vypnutySklad character varying; 
  _mazatTmpTable boolean;  
  _polSklad record; 
begin  
 
  if(NEW.idBspSkl = OLD.idBspSkl and NEW.idCenik = OLD.idCenik
    and comparevarchar(NEW.typPolozkyK, OLD.typPolozkyK) 
    and comparevarchar(NEW.sarze, OLD.sarze) and comparedate(NEW.expirace, OLD.expirace) 
    and NEW.mnozMj = OLD.mnozMj and NEW.cenaMj = OLD.cenaMj and NEW.sumZkl = OLD.sumZkl and NEW.sumZklMen = OLD.sumZklMen 
    and NEW.storno = OLD.storno  
  ) then 
    return NEW; 
  end if; 
 
  /*  
    prepocet skladu budeme provadet jen v okamziku kdy neexistuje tabulka tmp_rozsirenePolozky  
    nebo kdyz tato tabulka existuje ale neni v ni obsazeno polozka kteoru chceme updatovat  
  */  
  select getglotxvariable('vypniSklad') into _vypnutySklad;  
  if(_vypnutySklad is null or _vypnutySklad <> 'true') then  
    _updatuj = true;  
    tmp_rozsirenepolozky_exists := (select istableexist('tmp_RozsirenePolozky'));  
    if(tmp_rozsirenepolozky_exists = true) then  
      select count(*) into _pocetPolozek from tmp_rozsirenePolozky where idPolSklad = NEW.idPolSklad;  
      if(_pocetPolozek > 0) then  
        _updatuj = false;  
      end if;  
    end if;  
  
    if(OLD.idPolSklad < 0 and NEW.idPolSklad > 0) then  
      _updatuj = false;  
    end if;  
    
    _sklfifo := (select isfifosklad(NEW.datVyst));    
    if (_sklfifo) then    
      --fifo    
      if (OLD.storno=false and NEW.storno=true) then    
        execute sfifoStorno(OLD.idpolsklad, OLD.iddoklsklad);    
      end if;      
      if (OLD.cenamj <> NEW.cenamj) then    
        execute sfifocenamj(OLD.idpolsklad, OLD.iddoklsklad, NEW.cenamj);    
      end if;      
      --fifo konec    
    end if;    
  
    -- tohle musi byt i pro prumerne ceny protoze jinak se negeneruji fifo vazby 
    if (OLD.mnozMj = 0.0 and NEW.mnozMj != 0.0) then 
      execute sfifovydej(NEW.idPolSklad, NEW.idCenik, NEW.idBspSkl, NEW.idkarty, NEW.mnozMjPlan, NEW.cenyRucne); 
    end if; 
     
    if(_updatuj) then  
  
      -- generuji rozsirene polozky  
      select skladGenerujRozsirenePolozky(NEW.datSklad, NEW.idPolSklad, NEW.idKarty) into _mazatTmpTable;  
      
      execute putglotxvariable('zurnalTxName', 'prepocetSkladu');  
   
      for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop  
        if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then  
          if(_rozsirenaPolozka.cenyRucne = true) then 
            if(_rozsirenaPolozka.storno = false) then  
              select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad; 
              execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, -1);  
            end if; 
          else  
            execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);  
          end if; 
        end if;  
      end loop;  
 
      if(OLD.storno = false) then 
        execute sprepoctiskladkartu(OLD.mnozMj, OLD.cenaMj, OLD.sumZkl, OLD.datVyst, OLD.idKarty, OLD.idDoklSklad, OLD.idBspSkl, -1); 
      end if; 
 
      for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop  
        if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then  
          if(_rozsirenaPolozka.cenyRucne = true) then 
            if(_rozsirenaPolozka.storno = false) then  
              select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad; 
              execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, 1);  
            end if; 
          else 
            execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);  
          end if; 
        else 
          if(NEW.storno = false) then 
            execute sprepoctiskladkartu(NEW.mnozMj, NEW.cenaMj, NEW.sumZkl, NEW.datVyst, NEW.idKarty, NEW.idDoklSklad, NEW.idBspSkl, 1); 
          end if; 
        end if; 
      end loop;  
  
      if(_mazatTmpTable) then  
        drop table tmp_RozsirenePolozky;  
        drop table tmp_SkladoveKarty;  
        execute removeglotxvariable('zurnalTxName');  
      end if;  
         
    end if;  
  end if; 
  return NEW;  
end;  
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION dpolskladupdate()
  OWNER TO %firmaRole%;


-- Function: sprepoctisumydokladu(integer)
-- DROP FUNCTION sprepoctisumydokladu(integer);
CREATE OR REPLACE FUNCTION sprepoctisumydokladu(i_iddoklsklad integer)
  RETURNS void AS
$BODY$  
declare  
 _sumZkl numeric(15,2);   
 _sumZklMen numeric(15,2);    
 _datVyst date; 
begin  
 select datVyst into _datVyst from dDoklSklad where idDoklSklad = i_idDoklSklad; 
 execute sprepoctisumydokladu(i_idDoklSklad, _datVyst); 
end 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION sprepoctisumydokladu(integer)
  OWNER TO %firmaRole%;


-- Function: sprepoctisumydokladu(integer, date)
-- DROP FUNCTION sprepoctisumydokladu(integer, date);
CREATE OR REPLACE FUNCTION sprepoctisumydokladu(i_iddoklsklad integer, i_datvyst date)
  RETURNS void AS
$BODY$ 
declare 
 _sumZkl numeric(15,2); 
 _sumZklMen numeric(15,2); 
 _sumZklDoklad numeric(15,2); 
 _sumZklMenDoklad numeric(15,2); 
 _datVyst date; 
 _datUcto date; 
 _stavSkladK character varying;
 _stavSkladKNew character varying;
 _typPohybuK character varying;
 _sumMnozMj numeric(19,6);
 _sumMnozMjPlan numeric(19,6);
begin 
 select sum(sumZkl), sum(sumZklMen), sum(mnozMj), sum(mnozMjPlan) into _sumZkl, _sumZklMen, _sumMnozMj, _sumMnozMjPlan from dPolSklad where idDoklSklad = i_idDoklSklad and stornoPol = false; 

 select sumCelkem, sumCelkemMen, datVyst, datUcto, stavSkladK, typPohybuK 
   into _sumZklDoklad, _sumZklMenDoklad, _datVyst, _datUcto, _stavSkladK, _typPohybuK
   from dDoklSklad where idDoklSklad = i_idDoklSklad; 

 if(_sumZkl is null) then _sumZkl = 0.0; end if; 
 if(_sumZklMen is null) then _sumZklMen = 0.0; end if; 

 _stavSkladKNew = _stavSkladK;
 if(_typPohybuK = 'typPohybu.vydej' and _sumMnozMj != _sumMnozMjPlan) then 
   if(compareVarchar(_stavSkladK, 'stavSklad.vygenFakt')) then 
     _stavSkladKNew = 'stavSklad.vygenFaktNeuplny'; 
   end if; 
   if(compareVarchar(_stavSkladK, 'stavSklad.vygenPokl')) then 
     _stavSkladKNew = 'stavSklad.vygenPoklNeuplny'; 
   end if; 
 end if; 
 if(_typPohybuK = 'typPohybu.vydej' and _sumMnozMj = _sumMnozMjPlan) then 
   if(compareVarchar(_stavSkladK, 'stavSklad.vygenFaktNeuplny')) then 
     _stavSkladKNew = 'stavSklad.vygenFakt'; 
   end if; 
   if(compareVarchar(_stavSkladK, 'stavSklad.vygenPoklNeuplny')) then 
     _stavSkladKNew = 'stavSklad.vygenPokl'; 
   end if; 
 end if;
 
 if(_sumZkl <> _sumZklDoklad 
    or _sumZklMen <> _sumZklMenDoklad
    or not compareDate(i_datVyst, _datVyst)
    or not compareDate(i_datVyst, _datUcto)
    or not compareVarchar(_stavSkladK, _stavSkladKNew)
    ) then 
   update dDoklSklad set 
       lastUpdate = LOCALTIMESTAMP, 
       sumCelkem = _sumZkl, 
       sumCelkemMen = _sumZklMen, 
       sumOsv = _sumZkl, 
       sumOsvMen = _sumZklMen, 
       datVyst = i_datVyst, 
       datUcto = i_datVyst,
       stavSkladK = _stavSkladKNew
     where idDoklSklad = i_idDoklSklad; 
 end if; 
end 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION sprepoctisumydokladu(integer, date)
  OWNER TO %firmaRole%;


-- DELETE TRIGGER
-- Function: dpolskladdelete()
-- DROP FUNCTION dpolskladdelete();
CREATE OR REPLACE FUNCTION dpolskladdelete()
  RETURNS trigger AS
$BODY$ 
declare 
  _rozsirenaPolozka record; 
  _mazatTmpTable boolean;  
  _polSklad record;   
begin 
   
  if(not OLD.storno) then 
    -- generuji rozsirene polozky 
    select skladGenerujRozsirenePolozky(OLD.datSklad, OLD.idPolSklad, OLD.idKarty) into _mazatTmpTable; 
 
    execute putglotxvariable('zurnalTxName', 'prepocetSkladu'); 
 
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
      if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then  
        if(_rozsirenaPolozka.cenyRucne = true) then 
          select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad; 
          execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, -1);  
        else 
          execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
        end if; 
      else  
        --raise exception 'v rozsirenych polozkach je mazana polozka s id %', _rozsirenaPolozka;  
      end if; 
    end loop; 
 
    -- musim jeste odpocist mazanou polozku 
    --execute skladOdpoctiRozsirenouPolozku(OLD.idPolSklad); 
    execute sprepoctiskladkartu(OLD.mnozMj, OLD.cenaMj, OLD.sumZkl, OLD.datVyst, OLD.idKarty, OLD.idDoklSklad, OLD.idBspSkl, -1); 
   
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
      if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then 
        if(_rozsirenaPolozka.cenyRucne = true) then 
          select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad; 
          execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, 1);  
        else 
          execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
        end if; 
      else 
        --raise exception 'v rozsirenych polozkach je mazana polozka s id %', _rozsirenaPolozka;  
      end if; 
    end loop; 
     
    execute sfifostorno(OLD.idPolSklad, OLD.idDoklSklad); 
 
    if(_mazatTmpTable) then 
      drop table tmp_RozsirenePolozky; 
      drop table tmp_SkladoveKarty; 
      execute removeglotxvariable('zurnalTxName'); 
    end if; 
  end if;  
   
  return NEW; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION dpolskladdelete()
  OWNER TO %firmaRole%;


-- vyroba
-- Function: dpolskladinsertkusovnik(integer)
-- DROP FUNCTION dpolskladinsertkusovnik(integer);
CREATE OR REPLACE FUNCTION dpolskladinsertkusovnik(i_idpolsklad integer)
  RETURNS integer AS
$BODY$ 
declare 
    _polSklad record; 
    _typPohybuK varchar; 
    _typZasobyK varchar; 
    _skladove boolean; 
    _idKusovnik integer; 
    _iducetobdobi integer; 
    _stavNaSklade numeric; 
    _sklKarta record; 
    _cenik record; 
    --_sklzapor boolean; 
    _idVydejPolSklad integer; 
    _idParovanyDoklad integer; 
    potKus record; 
    _parKusMnoz numeric; 
    _i integer; 
    _kurz numeric; 
    _isCiziMena boolean; 
    _idMeny integer; 
    _mnozMj numeric; 
    _cenaMj numeric; 
    _sumZkl numeric; 
    _newSumZkl numeric; 
    _sumZklMen numeric; 
    _idSkladPotKus integer; 
    _idProtiUcetDoklad integer; 
    _idStred integer; 
    _kopStred boolean; 
    _sklad record; 
    _typPohybuSkladK character varying; 
    _cenaMjSkl numeric(19,6); 
    _cenaMjNeskl numeric(19,6); 
    _navazanaPolSklad record; 
    _rozpadlaPolSklad record; 
    _kurzDokladu numeric; 
begin 
  select * into _polSklad from dpolsklad where idpolsklad = i_idpolSklad; 
 
  -- napriklad pokud se jedna o prevodku mezi sklady nechceme z prijemky vytvaret prevodku 
  if (_polSklad.prevodka = true) then 
    return null; 
  end if; 
 
  -- typem pohybu musi byt prijem 
  select typpohybuk into _typPohybuK from ddoklsklad d where d.iddoklsklad = _polSklad.iddoklsklad; 
  if (_typPohybuK <> 'typPohybu.prijem') then 
    return null; 
  end if; 
 
  -- pokud neni nastaven typ pohybu sklad prijem z vyroby tak koncime 
  select typpohybuskladk into _typPohybuSkladK from ddoklsklad d where d.iddoklsklad = _polSklad.iddoklsklad; 
  if(_typPohybuSkladK is null or _typPohybuSkladK <> 'typPohybuSklad.prijemVyrob') then 
    return null; 
  end if; 
 
  -- idcenik odkazuje na neco co je soucasti kusovniku. 
  select ckus.idkusovnik into _idKusovnik from ckusovnik ckus where ckus.idcenik = _polSklad.idcenik 
    and exists (select 1 from ckusovnik cPot where cPot.idotec = ckus.idkusovnik); 
  if (_idKusovnik is null) then 
    return null; 
  end if; 
 
  -- vytvorime nebo nalezneme zparovany doklad skl vydej 
  select findparovanydoklsklad(_polSklad.iddoklsklad, _polSklad.modul, 'typVazbyDokl.hlavaSklKus') into _idParovanyDoklad; 
  if (_idParovanyDoklad is null) then 
    select createdoklsklad(_polSklad.idpolsklad, _polSklad.iddoklsklad, _polSklad.modul) into _idParovanyDoklad; 
  end if; 
 
  if(_idParovanyDoklad is null) then 
    return null; 
  end if; 
 
  select isDoklSkladMenaCizi(_idParovanyDoklad, _polSklad.datVyst) into _isCiziMena; 
  select getkurzfromdoklad(_idParovanyDoklad, _polSklad.datVyst) into _kurz; 
  select idMeny into _idMeny from dDoklSklad where idDoklSklad = _idParovanyDoklad; 
 
  _i = 0; 
  _newSumZkl = 0.0; 
  _cenaMjSkl = 0.0; 
  _cenaMjNeskl = 0.0; 
 
  perform putglotxvariable('zurnalTxName', 'rozpadKusovniku'); 
 
  -- pro vsechny kusovniky, ktere jsou pod nasim kusovnikem a jsou skladove nebo vyroba a nemaji nulove mnozstvi 
  for potKus in (select * from ckusovnik cPot where cPot.idotec = _idKusovnik and cPot.mnoz > 0.0) loop 
    select * into _cenik from cCenik where idCenik = potKus.idCenik; 
 
    select mnoz into _parKusMnoz from ckusovnik where idkusovnik = _idKusovnik; 
 
    select skladove into _skladove from cCenik cen where cen.idCenik = potKus.idCenik; 
    if (not _skladove) then 
        _newSumZkl = _newSumZkl + ((_cenik.nakupcena * potKus.mnoz * _polSklad.mnozMj) / _parKusMnoz); 
        _cenaMjNeskl = _cenaMjNeskl + ((_cenik.nakupcena * potKus.mnoz) / _parKusMnoz); 
        continue; 
    end if; 
    _i = _i + 1; 
 
    select findIdUcetniObdobiKDatu(_polSklad.datVyst) into _iducetobdobi; 
    -- vybereme skladovou kartu podle preferovaneho skladu 
    select null into _sklKarta; 
    _idSkladPotKus = null; 
 
    select getPrefIdSkladu( 
	(select idstred from ddoklsklad where iddoklsklad = _polSklad.iddoklsklad), 
	_cenik.idskupzboz, potKus.idcenik) into _idSkladPotKus; 
 
    if (_idSkladPotKus is not null) then 
	select * into _sklKarta from skarty where idcenik = potKus.idcenik and idSkladu = _idSkladPotKus and iducetobdobi = _iducetobdobi; 
    end if; 
 
    -- sklad karta nebyla nalezena podle preferovaneho skladu, vezmeme sklad stejny jako z vytvarene polozky 
    if (_sklKarta is null) then 
	select * into _sklKarta from skarty where idcenik = potKus.idcenik and idSkladu = _polSklad.idBspSkl and iducetobdobi = _iducetobdobi; 
	select _polSklad.idStred into _idStred; 
	select _polSklad.kopstred into _kopStred; 
    else 
        select idstred into _idStred from dbsp d where _sklKarta.idskladu = d.idbsp; 
	select false into _kopStred; 
    end if; 
 
    -- skladovou 
    if (_sklKarta is null) then 
	raise exception 'Nebyla nalezena skladova karta k polozce ceniku %. Definujte mapovani skladu pro tuto polozku nebo ji pridejte na sklad %', 
		_cenik.kod, (select kod from dtypdokl where idtypdokl = _polSklad.idskladu); 
    end if; 
 
   _mnozMj = (potKus.mnoz / _parKusMnoz) * _polSklad.mnozMj; 
   _cenaMj = _sklKarta.prumCenaTuz / _kurz; 
   _sumZkl = _mnozMj * _sklKarta.prumCenaTuz; 
   _cenaMjSkl = _cenaMjSkl + (_cenaMj * (potKus.mnoz / _parKusMnoz)); 
   _newSumZkl = _newSumZkl + _sumZkl; 
 
   if(_isCiziMena) then 
     _sumZklMen = _mnozMj * _cenaMj; 
   else 
     _sumZklMen = 0.0; 
   end if; 
 
    -- TODO doplnit sarze a expirace 
    select dgetstavnasklade(_sklKarta.idkarty, _polSklad.datVyst, -1, _polSklad.idfirmy, NULL, NULL, _typPohybuK) into _stavNaSklade; 
 
    -- osetreni zda je povoleny zaporny stav na sklade 
    if (_stavNaSklade - _mnozMj < 0) then 
        /*select sklzapor into _sklzapor from nNastav where _polSklad.datVyst >= PlatiOdData order by PlatiOdData desc limit 1; 
        if (_sklzapor is null) then 
            select sklzapor into _sklzapor from nNastav where PlatiOdData is null limit 1; 
        end if; 
        if _sklzapor is null or _sklzapor = false then */
            raise exception '0002:sPreporctiSkladKartu: neni povolen zaporny stav skladu'; 
        /*end if; */
    end if; 
 
    select nextval('seq_dpolsklad'::regclass) into _idVydejPolSklad; 
 
    if(_cenik.idskupzboz is not null) then 
      select idprotiucetsklv into _idProtiUcetDoklad from cskupzboz where idskupzboz = _cenik.idskupzboz; 
    end if; 
    if(_idProtiUcetDoklad is null) then 
      select idprotiucet into _idProtiUcetDoklad from ddoklsklad where iddoklsklad = _idParovanyDoklad; 
    end if; 
 
    select * into _sklad from dBsp where _sklKarta.idSkladu = idBsp; 
 
    insert into dpolsklad(idPolSklad, idcenik, idBspSkl, idkarty, datVyst, datSklad, datUcto, modul, typPolozkyK, idDoklSklad, 
        mnozMj, cenaMj, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, 
        nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni, idStred, idZakazky, idMeny, kopstred) 
    values (_idVydejPolSklad, potKus.idcenik, _sklKarta.idSkladu, _sklKarta.idkarty, _polSklad.datVyst, _polSklad.datSklad - interval '0.000001', _polSklad.datUcto, _polSklad.modul, _polSklad.typpolozkyk, _idParovanyDoklad, 
        _mnozMj, _cenaMj, _sumZkl, _sumZklMen, _idProtiUcetDoklad, _sklad.idprimucet, false, false, _polSklad.baleniid, _polSklad.mnozbaleni, 
        _cenik.nazev, _cenik.nazevA, _cenik.nazevB, _cenik.nazevC, NULL, NULL, _polSklad.cisRad * 100 + _i, true, 
        _idStred, _polSklad.idZakazky, _idMeny, _kopStred); 
 
    insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK) 
      values (0.0, _polSklad.idpolsklad, _idVydejPolSklad, 'SKL', 'SKL', false, 'typVazbyDokl.polozkaSklKus'); 
 
  end loop; 
 
  perform removeglotxvariable('zurnalTxName'); 
 
  select getkurzfromdoklad(_polSklad.iddoklsklad, _polSklad.datvyst) into _kurz; 
  _cenaMj = _newSumZkl / _polSklad.mnozMj / _kurz; 
 
  select isDoklSkladMenaCizi(_polSklad.iddoklsklad, _polSklad.datVyst) into _isCiziMena; 
  if (_isCiziMena) then 
    _sumZklMen = _polSklad.cenaMj * _polSklad.mnozMj; 
  else 
    _sumZklMen = 0.0; 
  end if; 
 
 
  select getKurzFromDoklad(_polSklad.idDoklSklad, _polSklad.datVyst) into _kurzDokladu; 
  _cenaMjSkl = 0.0; 
  _cenaMj = _cenaMjNeskl; 
  _sumZkl = _cenaMjNeskl * _polSklad.mnozMj; 
  for _navazanaPolSklad in (select * from dPolSklad where idPolSklad in 
    (select idTabB from dvazebtab where idTabA = _polSklad.idPolSklad and modulA = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus') ) 
    loop 
      if(_navazanaPolSklad.mnozMj <> 0.0) then 
        _cenaMj = _cenaMj + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu; 
        _cenaMjSkl = _cenaMjSkl + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu; 
      else 
        raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit 
      end if; 
      _sumZkl = _sumZkl + _navazanaPolSklad.sumZkl; 
 
      -- musime zohlednit i pripadne rozpady skladovych polozek 
      for _rozpadlaPolSklad in (select * from dPolSklad where idPolSklad in 
        (select idpolskladcil from svazbypolsklad where idpolskladzdroj = _navazanaPolSklad.idPolSklad)) 
        loop 
          if(_rozpadlaPolSklad.mnozMj <> 0.0) then 
            _cenaMj = _cenaMj + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu; 
            _cenaMjSkl = _cenaMjSkl + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu; 
          else 
            raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit 
          end if; 
          _sumZkl = _sumZkl + _rozpadlaPolSklad.sumZkl; 
      end loop; 
  end loop; 
 
  update dpolsklad set 
       sumzkl = _sumZkl, 
       cenaMj = _cenaMj, 
       --sumZklMen = _sumZklMen, 
       cenaMjSkl = _cenaMjSkl, 
       cenaMjNeskl = _cenaMjNeskl 
     where idpolsklad = _polSklad.idpolsklad; 
 
  execute sprepoctisumydokladu(_polSklad.idDoklSklad); 
 
  return _polSklad.idPolSklad; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION dpolskladinsertkusovnik(integer)
  OWNER TO %firmaRole%;


-- Function: skladrealizujpozadavky()
-- DROP FUNCTION skladrealizujpozadavky();
CREATE OR REPLACE FUNCTION skladrealizujpozadavky()
  RETURNS void AS
$BODY$  
declare 
  _polSklad record; 
  _polSkladDoklSklad record; 
  _stavSkladu numeric(19,6); 
  _cenaMj numeric(19,6);
  _pocetPozadavku integer; 
begin 
  for _polSklad in ( 
    select p.*, d.typPohybuK, d.stavSkladK from dpolsklad p join ddoklsklad d on p.idDoklSklad = d.idDoklSklad 
    where typPohybuK = 'typPohybu.vydej' and mnozMj = 0 and mnozMjPlan != 0 
    order by datSklad, idPolSklad) loop 
      --select dgetstavnasklade(_polSklad.idkarty, _polSklad.datSklad, /*_polSklad.idpolsklad*/ -1, _polSklad.sarze, _polSklad.expirace, _polSklad.typPohybuK) into _stavSkladu; 
      select stavMj, prumCenaTuz into _stavSkladu, _cenaMj from skarty where idkarty = _polSklad.idKarty;
      
      if(_stavSkladu >= _polSklad.mnozMjPlan) then 
        update dpolsklad set mnozMj = mnozMjPlan, cenaMj = _cenaMj, sumZkl = mnozMjPlan * _cenaMj, datSklad = LOCALTIMESTAMP where idpolsklad = _polSklad.idPolSklad; 
        perform sprepoctisumydokladu(_polSklad.iddoklsklad); 
         
        select count(*) into _pocetPozadavku from dpolSklad where idDoklSklad = _polSklad.idDoklSklad and mnozMj = 0.0 and mnozMjPlan != 0.0; 
        if(_pocetPozadavku = 0) then 
          if(compareVarchar(_polSklad.stavSkladK, 'stavSklad.vygenFaktNeuplny')) then 
            update ddoklsklad set stavSkladK = 'stavSklad.vygenFakt' where idDoklSklad = _polSklad.idDoklSklad; 
          end if; 
          if(compareVarchar(_polSklad.stavSkladK, 'stavSklad.vygenPoklNeuplny')) then 
            update ddoklsklad set stavSkladK = 'stavSklad.vygenPokl' where idDoklSklad = _polSklad.idDoklSklad; 
          end if; 
        end if; 
      end if; 
  end loop; 
end;     
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION skladrealizujpozadavky()
  OWNER TO %firmaRole%;

-- Function: createpolskladsada(integer, character varying)
-- DROP FUNCTION createpolskladsada(integer, character varying);
CREATE OR REPLACE FUNCTION createpolskladsada(_idpoldokl integer, _modul character varying)
  RETURNS void AS
$BODY$  
declare 
  _polDokl record; 
  _doklad record; 
  _polozkaSady record; 
  _skladKarta record; 
  _cenik record; 
  _sklad record; 
  _idDoklSklad integer; 
  _idDoklad integer; 
  _idMeny integer; 
  _idUcetObdobi integer; 
  _idKarty integer; 
  _idPolSklad integer; 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
  _i integer; 
  _cisRad integer; 
  _typDoklK character varying; 
  _mnozMj numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _cenaMj numeric(19,6); 
  _kurz numeric(19,6); 
  _isCiziMena boolean; 
  _nasobic integer; 
  _idSkladu integer; 
  _kopZklMdUcet boolean; 
  _kopZklDalUcet boolean; 
  _idTypUcOp integer; 
  _kopStred boolean; 
  _kopCinnost boolean; 
  _kopZakazku boolean; 
  _idStredDoklSklad integer; 
  _idCinnostDoklSklad integer; 
  _idZakazkyDoklSklad integer; 
begin 
 
  if(_modul like 'FAV' or _modul like 'FAP') then  
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;  
    _idDoklad = _polDokl.idDoklFak; 
    select * into _doklad from dDoklFak where idDoklFak = _idDoklad; 
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);  
  else  
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;  
    _idDoklad = _polDokl.idDoklInt; 
    select * into _doklad from dDoklInt where idDoklInt = _idDoklad; 
    _typDoklK = null; -- pro pokladnu dobropisy nejsou  
  end if; 
 
  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true) into _idDoklSklad;  
   
  if(_idDoklSklad is null) then  
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;  
    if(_idDoklSklad is null) then 
      return; 
    end if; 
  end if; 
 
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;  
 
  select idMeny, idTypUcOp, idstred, idcinnost, idZakazky 
   into _idMeny, _idTypUcOp, _idStredDoklSklad, _idCinnostDoklSklad, _idZakazkyDoklSklad  
   from dDoklSklad where idDoklSklad = _idDoklSklad;  
 
  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl; 
 
  _i = 0; 
 
  FOR _polozkaSady IN 
    select * from cSady where idCenikSada = _polDokl.idCenik 
  LOOP 
    select * into _cenik from cCenik where idCenik = _polozkaSady.idCenik; 
 
    if(_cenik.skladove) then 
      _i = _i + 1; 
      _cisRad = 100 * _polDokl.cisRad + _i; 
   
      select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;  
 
      _idSkladu = _polDokl.idBspSkl; 
 
      select * into _skladKarta from skarty  
        where idSkladu = _idSkladu and idCenik = _polozkaSady.idCenik and idUcetObdobi = _idUcetObdobi; 
 
      -- pokud neexistuje skladova karta pokusim se ji najit pomoci mapovani skladu 
      if(_skladKarta is null) then 
        select getPrefIdSkladu(_polDokl.idStred, _cenik.idSkupZboz, _cenik.idCenik) into _idSkladu; 
        select * into _skladKarta from skarty 
          where idSkladu = _idSkladu and idCenik = _cenik.idCenik and idUcetObdobi = _idUcetObdobi; 
        if(_skladKarta is null) then 
          -- pokud ani podle mapovani skladu se skladova karta nenajde tak vyhazuju vyjimku 
          raise exception '0007:Skladová karta neexistuje pro ceník % a sklad % a nebo je špatně nastaveno mapovaní skladu.', _cenik.nazev, _sklad.nazev; 
        end if; 
      else 
        _idSkladu = _skladKarta.idSkladu; 
      end if; 
      _nasobic = 1; 
      if(_typDoklK like 'typDokladu.dobropis') then 
        _nasobic = -1; 
      end if; 
      _mnozMj = _polozkaSady.mnozMj * _polDokl.mnozMj * _nasobic; 
      _cenaMj = _skladKarta.prumCenaTuz / _kurz; 
      _sumZkl = _mnozMj * _skladKarta.prumCenaTuz; 
      if(_isCiziMena) then  
        _sumZklMen = _mnozMj * _cenaMj;  
      else  
        _sumZklMen = 0.0;  
      end if; 
     
      -- nastaveni uctu pro polSklad vydej  
      _kopZklMdUcet = false; 
      _kopZklDalUcet = false; 
      if(_typDoklK like 'typDokladu.dobropis') then 
        -- dal ucet je ze skupiny zbozi nebo z hlavicky pokud neni ve skupine zbozi nastaven 
        select idProtiUcetSklV into _idZklDalUcet from cSkupZboz where idSkupZboz = _cenik.idSkupZboz; 
        if(_idZklDalUcet is null) then 
          select idProtiUcet into _idZklDalUcet from dDoklSklad where idDoklSklad = _idDoklSklad; 
          --pokud je z hlavicky tak se bude kopirovat 
          _kopZklDalUcet = true; 
        end if; 
        -- md ucet musi byt primarni ucet skladu ze ktereho se kousky sady vydavaji 
        select idPrimUcet into _idZklMdUcet from dBsp where idBsp = _idSkladu; 
      else 
        -- md ucet je ze skupiny zbozi nebo z hlavicky pokud neni ve skupine zbozi nastaven 
        select idProtiUcetSklV into _idZklMdUcet from cSkupZboz where idSkupZboz = _cenik.idSkupZboz; 
        if(_idZklMdUcet is null) then 
          select idProtiUcet into _idZklMdUcet from dDoklSklad where idDoklSklad = _idDoklSklad; 
          --pokud je z hlavicky tak se bude kopirovat 
          _kopZklMdUcet = true; 
        end if; 
        -- dal ucet musi byt primarni ucet skladu ze ktereho se kousky sady vydavaji 
        select idPrimUcet into _idZklDalUcet from dBsp where idBsp = _idSkladu; 
      end if;  
  
      _kopStred = true; 
      if(not compareId(_idStredDoklSklad, _polDokl.idStred)) then 
        _kopStred = false; 
      end if; 
      _kopCinnost = true; 
      if(not compareId(_idCinnostDoklSklad, _polDokl.idCinnost)) then 
        _kopCinnost = false; 
      end if; 
      _kopZakazku = true; 
      if(not compareId(_idZakazkyDoklSklad, _polDokl.idZakazky)) then 
        _kopZakazku = false; 
      end if; 
 
      select nextval('seq_dpolsklad') into _idPolSklad; 
      insert into dpolsklad(idPolSklad, lastUpdate, idcenik, idBspSkl, idkarty, datVyst, datSklad, datUcto, modul, typPolozkyK, idDoklSklad, 
          mnozMj, cenaMj, cenaMjPoriz, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, idmj, 
          nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni,   
          idStred, kopStred, idZakazky, kopZakazku, idMeny, zdrojProFak, idCinnost, kopCinnost, idTypUcOp) 
        values (_idPolSklad, LOCALTIMESTAMP, _polozkaSady.idcenik, _idSkladu, _skladKarta.idKarty, _polDokl.datVyst, LOCALTIMESTAMP, _polDokl.datVyst, 'SKL', 'typPolozky.katalog', _idDoklSklad,     
          _mnozMj, _cenaMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, _kopZklMdUcet, _kopZklDalUcet, _polDokl.baleniid, 0.0, _cenik.idmj1, 
          _cenik.nazev, _cenik.nazevA, _cenik.nazevB, _cenik.nazevC, null, null, _cisRad, true,   
          _polDokl.idStred, _kopStred, _polDokl.idZakazky, _kopZakazku, _idMeny, false, _polDokl.idCinnost, _kopCinnost, _idTypUcOp); 
 
      insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)   
        values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSklSada');   
    end if;  
  END LOOP;  
 
  execute sprepoctiSumyDokladu(_idDoklSklad);  
end;  
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION createpolskladsada(integer, character varying)
  OWNER TO %firmaRole%;

-- Function: dgetstavnaskladeaktualni(integer)
-- DROP FUNCTION dgetstavnaskladeaktualni(integer);
CREATE OR REPLACE FUNCTION dgetstavnaskladeaktualni(i_skladkartaid integer)
  RETURNS numeric AS
$BODY$        
declare       
  _idcenik integer;     
  _idskladu integer;     
  _iducetniobdobi integer;   
  _stavMj numeric(19,6);       
  _idSkladKarty integer;   
  _sadaItemCount integer;   
  _polozkaSady record;   
  _stavSkladuSady numeric(19,6);   
  _pocetPozadavku numeric(19,6);
begin       
  select idcenik, idskladu, iducetobdobi into _idcenik, _idskladu, _iducetniobdobi from skarty where idkarty = i_skladkartaid;   
   
  -- zjistim jestli nahodu dany cenik neni sada nebo komplet   
  select count(*) into _sadaItemCount from csady where idceniksada = _idCenik;   
  -- pokud se nejedna o sadu tak funguju normalne   
  if(_sadaItemCount = 0) then   
      -- zkusime vypocitat stav na vrcholu   
      select stavMj into _stavMj from skarty where idkarty = i_skladkartaid;   
      select sum(mnozMjPlan) into _pocetPozadavku from dpolsklad where mnozMjPlan <> 0.0 and mnozMj = 0.0 and idkarty = i_skladkartaid;
      if(_pocetPozadavku is not null) then
        _stavMj = _stavMj - _pocetPozadavku;
      end if;
  else   
    for _polozkaSady in   
      select * from cSady where idCenikSada = _idCenik   
    loop   
      select idKarty into _idSkladKarty from sKarty where idCenik = _polozkaSady.idCenik and idSkladu = _idskladu and idUcetObdobi = _iducetniobdobi;   
      if(_idSkladKarty is not null) then    
        if(_stavMj is null) then   
          _stavMj = 9999999999999.0; -- vic uz pretejka   
        end if;   
        select dGetStavNaSkladeAktualni(_idSkladKarty) into _stavSkladuSady;   
        _stavSkladuSady = _stavSkladuSady / _polozkaSady.mnozMj;   
        select minValue(_stavMj, _stavSkladuSady) into _stavMj;   
      end if;   
    end loop;   
  end if;    
    
  -- muze se stat ze _stavMj je null a to znamena ze na sklade nic neni    
  if(_stavMj is null) then    
    _stavMj := 0;    
  end if;    
      
  RETURN _stavMj;        
end        
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION dgetstavnaskladeaktualni(integer)
  OWNER TO %firmaRole%;


-- Function: dgetstavnaskladeaktualni(integer, integer, date)
-- DROP FUNCTION dgetstavnaskladeaktualni(integer, integer, date);
CREATE OR REPLACE FUNCTION dgetstavnaskladeaktualni(i_idcenik integer, i_idsklad integer, i_datum date)
  RETURNS numeric AS
$BODY$        
declare       
  _iducetniobdobi integer;   
  _stavMj numeric(19,6);       
  _idSkladKarty integer;   
  _sadaItemCount integer;   
  _polozkaSady record;   
  _stavSkladuSady numeric(19,6); 
  _pocetPozadavku numeric(19,6);  
begin       
  --select idcenik, idskladu, iducetobdobi into _idcenik, _idskladu, _iducetniobdobi from skarty where idkarty = i_skladkartaid;   
  select idUcetObdobi into _iducetniobdobi from nUcetObdobi where platiOdData <= i_datum and platiDoData >= i_datum; 
   
  -- zjistim jestli nahodu dany cenik neni sada nebo komplet   
  select count(*) into _sadaItemCount from csady where idceniksada = i_idCenik;   
  -- pokud se nejedna o sadu tak funguju normalne   
  if(_sadaItemCount = 0) then   
      -- zkusime vypocitat stav na vrcholu   
      select idKarty into _idSkladKarty from sKarty where idCenik = i_idCenik and idSkladu = i_idsklad and idUcetObdobi = _iducetniobdobi;   
      select stavMj into _stavMj from skarty where idkarty = _idSkladKarty;   
      select sum(mnozMjPlan) into _pocetPozadavku from dpolsklad where mnozMjPlan <> 0.0 and mnozMj = 0.0 and idkarty = _idSkladKarty;
      if(_pocetPozadavku is not null) then
        _stavMj = _stavMj - _pocetPozadavku;
      end if;
  else   
    for _polozkaSady in   
      select * from cSady where idCenikSada = i_idCenik   
    loop   
      select idKarty into _idSkladKarty from sKarty where idCenik = _polozkaSady.idCenik and idSkladu = i_idsklad and idUcetObdobi = _iducetniobdobi;   
      if(_idSkladKarty is not null) then    
        if(_stavMj is null) then   
          _stavMj = 9999999999999.0; -- vic uz pretejka   
        end if;   
        select dGetStavNaSkladeAktualni(_idSkladKarty) into _stavSkladuSady;   
        _stavSkladuSady = _stavSkladuSady / _polozkaSady.mnozMj;   
        select minValue(_stavMj, _stavSkladuSady) into _stavMj;   
      end if;   
    end loop;   
  end if;    
    
  -- muze se stat ze _stavMj je null a to znamena ze na sklade nic neni    
  if(_stavMj is null) then    
    _stavMj := 0;    
  end if;    
      
  RETURN _stavMj;        
end        
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION dgetstavnaskladeaktualni(integer, integer, date)
  OWNER TO %firmaRole%;

-- Function: sprepoctisklad(integer)
-- DROP FUNCTION sprepoctisklad(integer);
CREATE OR REPLACE FUNCTION sprepoctisklad(i_ucetobd integer)
  RETURNS void AS
$BODY$
declare
  _rozsirenaPolozka record;
  _zaznam record;
  _vyrobniCislo record;
  _pocatek_ucetobd date;
  _konec_ucetobd date;
  _evidVyrCis boolean;
  _mazatTmpTable boolean;
  _citac integer;
  _pocetPred integer;
  _pocetPo integer;
  _polSklad record;
begin

  execute putglotxvariable('zurnalTxName', 'prepocetSkladu');
  execute putglotxvariable('probihaPrepocetSkladu', 'true');

  -- nacteni datumu zacatku ucetniho obdobi
  select platioddata, platidodata into _pocatek_ucetobd, _konec_ucetobd from nucetobdobi where iducetobdobi = i_ucetobd;

  -- smazani tabulky fifo vazeb
  delete from sfifovazby where idpolskladvydej in
    (select idpolsklad from dpolsklad where
            datVyst >= _pocatek_ucetobd);

  delete from sfifovazby f
    where f.idpolskladvydej not in (select p.idpolsklad from dpolsklad p);

  -- nagenerovani pomocnych tabulek
  select skladGenerujRozsirenePolozky(_pocatek_ucetobd, -1, -1) into _mazatTmpTable;

  select count(*) into _pocetPred from tmp_RozsirenePolozky;

  -- provedu fifovani rozsirenych polozek
  for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky where storno = false order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
    select * into _zaznam from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
    if (_rozsirenaPolozka.typPohybuk = 'typPohybu.vydej'  or (_rozsirenaPolozka.typPohybuk = 'typPohybu.prijem' and _zaznam.mnozMj < 0.0)) then
      select evidVyrCis into _evidVyrCis from ccenik where idcenik = _zaznam.idCenik;
      if (not _evidVyrCis) then
        execute sfifoVydej(_zaznam.idPolSklad, _zaznam.idCenik, _zaznam.idBspSkl, _zaznam.idKarty, _zaznam.mnozmj, _zaznam.cenyrucne);
      else
        for _vyrobniCislo in select * from svyrobnicislo where idpolskladvydej = _zaznam.idPolSklad loop
          update svyrobnicislo set idpolskladvydej = null where idvyrobnicislo = _vyrobniCislo.idvyrobnicislo;
          update svyrobnicislo set idpolskladvydej = _zaznam.idPolSklad where idvyrobnicislo = _vyrobniCislo.idvyrobnicislo;
        end loop;
      end if;
      execute sPrepoctiSumyDokladu(_zaznam.idDoklSklad);
    end if;
  end loop;

  --select count(*) into _pocetPo from tmp_RozsirenePolozky;

  -- vynulovani skladovych karet
  execute skladVynulujSkladoveKarty();

  -- zafifovane veci zapoctu na skladove karty
  for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky where storno = false order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
    if(_rozsirenaPolozka.cenyRucne = true) then
      select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
      execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, 1); 
    else
      execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
    end if;
  end loop;

  if(_mazatTmpTable) then
    drop table tmp_RozsirenePolozky;
    drop table tmp_SkladoveKarty;
    execute removeglotxvariable('zurnalTxName');
    execute removeglotxvariable('probihaPrepocetSkladu');
  end if;

end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sprepoctisklad(integer) OWNER TO %firmaRole%;

-- Function: dpoldoklupdatesklad()

-- DROP FUNCTION dpoldoklupdatesklad();

CREATE OR REPLACE FUNCTION dpoldoklupdatesklad()
  RETURNS trigger AS
$BODY$  
declare  
  _idPolDokl integer;  
  _idDoklad integer;  
  _idPolSklad integer;  
  _idDoklSklad integer;  
  _dokladGenerovatSkl boolean;  
  _typDoklGenerovatSkl boolean;  
  _typZasobyK character varying;  
  _skladove boolean;  
  _vyrobniCislo record;  
  _typPohybuK character varying;  
  _sadaItemCount integer;  
  _vypnutySklad character varying; 
  _typDoklK character varying;   
begin  
  select getglotxvariable('vypniSklad') into _vypnutySklad;  
  if(_vypnutySklad is null or _vypnutySklad <> 'true') then  
    --raise exception 'sem sem se nemel dostat';  
    if(NEW.storno <> OLD.storno or NEW.stornoPol <> OLD.stornoPol) then  
      return NEW;  
    end if;  
 
    _typDoklK = ''; 
     
    if(NEW.modul like 'POK') then  
      _idPolDokl = NEW.idPolInt;  
      _idDoklad = NEW.idDoklInt;  
      select generovatSkl into _dokladGenerovatSkl from dDoklInt where idDoklInt = NEW.idDoklInt;  
      select generovatSkl into _typDoklGenerovatSkl from dTypDokl where idTypDokl = (select idTypDokl from dDoklInt where idDoklInt = NEW.idDoklInt);  
  
      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolInt where idpolint = NEW.idPolInt);  
    elsif (NEW.modul like 'FAV' or NEW.modul like 'FAP') then  
      _idPolDokl = NEW.idPolFak;  
      _idDoklad = NEW.idDoklFak;  
      select generovatSkl into _dokladGenerovatSkl from dDoklFak where idDoklFak = NEW.idDoklFak;  
      select generovatSkl, typDoklK into _typDoklGenerovatSkl, _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = NEW.idDoklFak);  
  
      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolfak where idpolfak = NEW.idPolFak);  
    else   
      return NEW;    
    end if;  
  
    -- pokud se lisi sklad, cenik, typPolozky, mnozMj, sarze, expirace  
    -- tak skladovou polozku musim smazat a vytvorit znovu kvuli fifu  
    if((not compareId(NEW.idBspSkl, OLD.idBspSkl)  
       or not compareId(NEW.idCenik, OLD.idCenik)  
       or not compareVarchar(NEW.typPolozkyK, OLD.typPolozkyK)  
       or NEW.mnozMj <> OLD.mnozMj  
       or not compareVarchar(NEW.sarze, OLD.sarze)  
       or not compareDate(NEW.expirace, OLD.expirace)  
       )  
       and _dokladGenerovatSkl and NEW.zdrojProSkl) then    
      --raise exception 'mazu polSklad';  
      execute deleteNavazanePolSklad(_idPolDokl, NEW.modul);  
    end if;  
  
    if(NEW.typPolozkyK like 'typPolozky.katalog' and _dokladGenerovatSkl and _typDoklGenerovatSkl and NEW.zdrojProSkl) then    
      select skladove into _skladove from cCenik where idCenik = NEW.idCenik;  
      
      if (_skladove and NEW.idBspSkl is not null) then  
        select findParovanyPolSklad(_idPolDokl, NEW.modul) into _idPolSklad;  
        if(_idPolSklad is null) then  
          --select createPolSklad(_idPolDokl, NEW.modul) into _idPolSklad;   
          if(_sadaItemCount > 0) then  
            execute createPolSkladSada(_idPolDokl, NEW.modul);  
          else  
            select createPolSklad(_idPolDokl, NEW.modul) into _idPolSklad;   
          end if;  
        else  
          if(_sadaItemCount > 0) then  
            execute fillPolSkladSada(_idPolDokl, NEW.modul);  
          else  
            select fillPolSklad(_idPolSklad, _idPolDokl, NEW.modul) into _idPolSklad;   
          end if;  
        end if;  
        -- provedeni upgradu vyrobnich cisel  
        if((NEW.modul like 'FAV' and _typDoklK not like 'typDokladu.dobropis') or (NEW.modul like 'FAP' and _typDoklK like 'typDokladu.dobropis')) then  
          for _vyrobniCislo in select * from sVyrobniCislo where idPolFakVydej = NEW.idPolFak and (idPolSkladVydej is null or idPolSkladVydej <> _idPolSklad) loop  
            update sVyrobniCislo set idPolSkladVydej = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo;  
          end loop;  
        end if;  
        if((NEW.modul like 'FAP' and _typDoklK not like 'typDokladu.dobropis') or (NEW.modul like 'FAV' and _typDoklK like 'typDokladu.dobropis')) then  
          for _vyrobniCislo in select * from sVyrobniCislo where idPolFakPrijem = NEW.idPolFak and (idPolSkladPrijem is null or idPolSkladPrijem <> _idPolSklad) loop  
            update sVyrobniCislo set idPolSkladPrijem = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo;  
          end loop;  
        end if;  
        if(NEW.modul like 'POK') then  
          select typPohybuK into _typPohybuK from dDoklInt where idDoklInt = _idDoklad;  
          if(_typPohybuK like 'typPohybu.prijem') then  
            for _vyrobniCislo in select * from sVyrobniCislo where idPolIntVydej = NEW.idPolInt and (idPolSkladVydej is null or idPolSkladVydej <> _idPolSklad) loop  
              update sVyrobniCislo set idPolSkladVydej = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo;  
            end loop;  
          else  
            for _vyrobniCislo in select * from sVyrobniCislo where idPolIntPrijem = NEW.idPolInt and (idPolSkladPrijem is null or idPolSkladPrijem <> _idPolSklad) loop  
              update sVyrobniCislo set idPolSkladPrijem = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo;  
            end loop;  
          end if;  
        end if;  
  
      end if;  
      -- prepocteni sum na dokladu  
      select findParovanyDoklSklad(_idDoklad, NEW.modul) into _idDoklSklad;  
      execute sprepoctiSumyDokladu(_idDoklSklad, NEW.datVyst);  
    end if;  
  end if;  
  
  return NEW;  
end  
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION dpoldoklupdatesklad() OWNER TO %firmaRole%;

-- Function: skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, integer, integer)

-- DROP FUNCTION skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, integer, integer);

CREATE OR REPLACE FUNCTION skladfindcenamjnakup(i_mnozmj numeric, i_idcenik integer, i_idskladu integer, i_datum date, i_sarze character varying, i_expirace date, i_idvyrobnihocisla integer, i_idstred integer)
  RETURNS numeric AS
$BODY$ 
declare 
  _sklfifo boolean; 
  _mazatTmpTable boolean; 
  _idkarty integer; 
  _rozsirenaPolozka record; 
  _iducetobdobi integer; 
  _result numeric(19,6); 
  _pomocDPolSkladF record; 
  _mnozstvi numeric(19,6); 
  _potrebnyPocet numeric(19,6); 
  _sadaItemCount integer; 
  _polozkaSady record; 
  _pomoc numeric(19,6); 
 
  _sumSumZkl numeric(19,6); 
  _sumMnozMj numeric(19,6); 
  _sumTuz numeric(19,6); 
  _mnozMj numeric(19,6); 
  _typPohybuK character varying; 
  _karta record; 
  _idskupzboz integer; 
  _idSkladuPref integer; 
  _cenik record; 
  _sklad record; 
begin 
  _result = 0.0; 
  _mnozstvi = 0.0; 
 
  if(i_mnozMj > 0) then 
    select count(*) into _sadaItemCount from csady where idceniksada = i_idcenik; 
    if(_sadaItemCount > 0) then 
      FOR _polozkaSady IN (select * from cSady where idCenikSada = i_idcenik) LOOP 
        -- TODO doresit sarze expirace a vyrobni cisla 
        select skladfindcenamjnakup(i_mnozmj * _polozkaSady.mnozMj, _polozkaSady.idcenik, i_idskladu, i_datum, null, null, null, i_idstred) into _pomoc; 
        _result = _result + (_pomoc * _polozkaSady.mnozMj); 
      end loop; 
    else 
      select findiducetniobdobikdatu(i_datum) into _iducetobdobi; 
      _sklfifo := (select isfifosklad(i_datum)); 
      if (_sklfifo) then 
        if(i_idvyrobnihocisla is not null and i_idvyrobnihocisla > 0) then 
          -- pokud je zadano vyrobni cislo ma nejvetsi prioritu 
          select cenaMj into _result from dpolsklad where idpolsklad = (select idpolskladprijem from svyrobnicislo where idvyrobnicislo = i_idvyrobnihocisla); 
        elsif(i_sarze is not null and i_expirace is not null) then 
          -- pokud je zadana sarze i expirace 
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu and sarze = i_sarze and expirace = i_expirace order by datSklad,idpolsklad) loop 
            if(i_mnozMj > _mnozstvi) then 
              _potrebnyPocet = _pomocDPolSkladF.pocet; 
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then 
                _potrebnyPocet = i_mnozMj - _mnozstvi; 
              end if; 
              _mnozstvi = _mnozstvi + _potrebnyPocet; 
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj; 
            end if; 
          end loop; 
          if(_mnozstvi != 0.0) then 
            _result = _result / _mnozstvi; 
          else 
            _result = 0.0; 
          end if; 
        elsif(i_sarze is not null and i_expirace is null) then 
          -- pokud je zadana jen sarze 
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu and sarze = i_sarze order by datSklad,idpolsklad) loop 
            if(i_mnozMj > _mnozstvi) then 
              _potrebnyPocet = _pomocDPolSkladF.pocet; 
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then 
                _potrebnyPocet = i_mnozMj - _mnozstvi; 
              end if; 
              _mnozstvi = _mnozstvi + _potrebnyPocet; 
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj; 
            end if; 
          end loop; 
          if(_mnozstvi != 0.0) then 
            _result = _result / _mnozstvi; 
          else 
            _result = 0.0; 
          end if; 
        elsif(i_sarze is null and i_expirace is not null) then 
          -- pokud je zadana jen expirace 
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu and expirace = i_expirace order by datSklad,idpolsklad) loop 
            if(i_mnozMj > _mnozstvi) then 
              _potrebnyPocet = _pomocDPolSkladF.pocet; 
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then 
                _potrebnyPocet = i_mnozMj - _mnozstvi; 
              end if; 
              _mnozstvi = _mnozstvi + _potrebnyPocet; 
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj; 
            end if; 
          end loop; 
          if(_mnozstvi != 0.0) then 
            _result = _result / _mnozstvi; 
          else 
            _result = 0.0; 
          end if; 
        else 
          -- pokud neni zadana ani sarze ani expirace ani vyrobni cislo 
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu order by datSklad,idpolsklad) loop 
            if(i_mnozMj >= _mnozstvi) then 
              _potrebnyPocet = _pomocDPolSkladF.pocet; 
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then 
                _potrebnyPocet = i_mnozMj - _mnozstvi; 
              end if; 
              _mnozstvi = _mnozstvi + _potrebnyPocet; 
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj; 
            end if; 
          end loop; 
          if(_mnozstvi != 0.0) then 
            _result = _result / _mnozstvi; 
          else 
            _result = 0.0; 
          end if; 
        end if; 
      else 
        -- generuji rozsirene polozky 
        select * into _karta from skarty where idcenik = i_idcenik and idskladu = i_idskladu and iducetobdobi = _iducetobdobi; 
        -- pokud neexistuje skladova karta pokusim se ji najit pomoci mapovani skladu 
        if(_karta is null) then 
          select idskupzboz into _idskupzboz from ccenik where idcenik = i_idcenik; 
          select getPrefIdSkladu(i_idstred, _idskupzboz, i_idcenik) into _idSkladuPref; 
          select * into _karta from skarty 
            where idSkladu = _idSkladuPref and idCenik = i_idCenik and idUcetObdobi = _idUcetObdobi; 
          if(_karta is null) then 
            -- pokud ani podle mapovani skladu se skladova karta nenajde tak vyhazuju vyjimku 
            select * into _cenik from ccenik where idCenik = i_idcenik; 
            select * into _sklad from dbsp where idBsp = i_idSkladu; 
            raise exception '0007:Skladová karta neexistuje pro ceník % a sklad % a nebo je špatně nastaveno mapovaní skladu.', _cenik.nazev, _sklad.nazev; 
          end if; 
        end if; 
 
	if(_karta is null) then 
	  raise exception 'Nenalezena sklad karta'; 
	end if; 
        _sumTuz = 0.0; 
        _mnozMj = 0.0; 

        _sumTuz = _karta.stavTuz - _sumTuz; 
        _mnozMj = _karta.stavMj - _mnozMj; 
        if(_mnozMj = 0.0) then 
          _result = 0.0; 
        else 
          _result = _sumTuz / _mnozMj; 
        end if; 
      end if; 
    end if; 
  end if; 
  return _result; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, integer, integer) OWNER TO %firmaRole%;

-- Function: svyrobnicisloupdate
CREATE OR REPLACE FUNCTION svyrobnicisloupdate()
  RETURNS trigger AS
$BODY$   
declare
  _mnozMj numeric(19,6);
  _datVyst date;
  _idDoklSkladV integer; 
  _idDoklSkladP integer;
  _kurzDokladuP numeric(19,6);
  _kurzDokladuV numeric(19,6);
  _sumZklVysl numeric(19,6);
  _sumZklMenVysl numeric(19,6);
  _sklFifo boolean;
  _cenaMjP numeric(19,6);
  _cenaMjVysl numeric(19,6);
  _koeficient integer;
  _pomoc record; 
begin
  if(NEW.idPolSkladVydej is not null and OLD.idPolSkladVydej is null) then
    select datVyst, mnozMj, idDoklSklad into _datVyst, _mnozMj, _idDoklSkladV
      from dpolsklad where idpolsklad = NEW.idPolSkladVydej;
    _koeficient = 1;
    if(_mnozMj < 0.0) then
      _koeficient = -1;
    end if;
    _sklfifo := (select isfifosklad(_datVyst));
    if(_sklFifo and _mnozMj <> 0.0) then
      _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVyst));    
      _sumZklVysl := 0.0;
      _sumZklMenVysl := 0.0;
      
      for _pomoc in (select ps.nazev, ps.cenaMj, fv.idvyrobnicislo, fv.idpolskladvydej, ps.iddoklsklad, ds.kurz, ds.kurzMnozstvi
                      from dpolsklad ps 
                      join sfifovazby fv on fv.idPolSkladPrijem = ps.idPolSklad
                      join ddoklsklad ds on ps.iddoklsklad = ds.iddoklsklad
                      where idvyrobnicislo is not null and fv.idpolskladvydej = NEW.idPolSkladVydej)
      loop
        _cenaMjP := _pomoc.cenaMj;
        if (_pomoc.kurz <> 0.0) then
          _cenamjP := _cenamjP * _pomoc.kurz / _pomoc.kurzMnozstvi;
        end if;
        
        _sumZklVysl = _sumZklVysl + (_koeficient * _cenaMjP); 
        if(_kurzDokladuV <> 1.0) then  
          _cenamjP := _cenamjP / _kurzDokladuV; 
          _sumZklMenVysl = _sumZklMenVysl + (_koeficient * _cenaMjP); 
          _cenaMjVysl = _sumZklMenVysl / _mnozMj; 
        else 
          _sumZklMenVysl = 0.0; 
          _cenaMjVysl = _sumZklVysl / _mnozMj; 
        end if;
 
      end loop;

      select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where idpolsklad = NEW.idPolSkladPrijem;
      
      select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);   
      if (_kurzDokladuP <> 0.0) then   
	_cenamjP := _cenamjP * _kurzDokladuP;    
      end if;  
      _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVyst));  

      _sumZklVysl = _sumZklVysl + (_koeficient * _cenaMjP);
      if(_kurzDokladuV <> 1.0) then
        _cenamjP := _cenamjP / _kurzDokladuV;
        _sumZklMenVysl = _sumZklMenVysl + (_koeficient * _cenaMjP);
        _cenaMjVysl = _sumZklMenVysl / _mnozMj;
      else
        _sumZklMenVysl = 0.0;
        _cenaMjVysl = _sumZklVysl / _mnozMj;
      end if;

      update dpolsklad set
        lastUpdate = LOCALTIMESTAMP, 
        sumZkl = _sumZklVysl,
        sumZklMen = _sumZklMenVysl,
        cenaMj = _cenaMjVysl,
	cenaMjPoriz = _cenaMjVysl
        where idpolsklad = NEW.idPolSkladVydej;
    end if;

    insert into sfifovazby(idpolskladprijem,    idpolskladvydej,    kusu,idvyrobnicislo) 
                   values (NEW.idPolSkladPrijem,NEW.idPolSkladVydej,1,   NEW.idvyrobnicislo); 

  elsif (NEW.idPolSkladVydej is null and OLD.idPolSkladVydej is not null) then 
    -- pokud se idPolSkladVydej nastavi na null z nejake hodnoty musi se smazat i fifo vazba s timto vyrobnim cislem 
    delete from sfifovazby where idvyrobnicislo = NEW.idVyrobniCislo; 
  end if;

  execute sprepoctisumydokladu(_idDoklSkladV);
  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION svyrobnicisloupdate() OWNER TO %firmaRole%;


-- uklid nesmyslu
drop function if exists snastavstavkartydne(integer, date, integer);
drop function if exists szapoctidominulosti(numeric, numeric, date, integer, integer, integer, integer, integer);
drop function if exists szapoctipolozkyoddata(integer, date, integer);
drop function if exists szmencenynapolsklad(integer, integer, integer);


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 624, 't', %appVersion%, clock_timestamp());