--------------------------------------------------------------------------------
-- Bug 28947 – [winstrom] - sklad - zrychlení skladu a zrušení rozpadů fifa
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION ddoklskladupdateceny()
  RETURNS trigger AS
$BODY$ 
declare 
begin
  execute sprepoctisumydokladu(NEW.idDoklSklad);
  return NEW;
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION ddoklskladupdateceny()
  OWNER TO %firmaRole%;

CREATE TRIGGER ddoklskladupdateceny
  AFTER UPDATE
  ON ddoklsklad
  FOR EACH ROW
  EXECUTE PROCEDURE ddoklskladupdateceny();

create or replace function skladPrepoctiRozsirenouPolozku(i_idrozsirenepolozky integer, sign integer) returns void as
$BODY$
declare
  _skladKarta record;
  _rozsirenaPolozka record;
  _polSklad record;
  _navazanaPolSklad record;
  _stavMj numeric(19,6);
  _stavTuz numeric(19,6);
  _stavMen numeric(19,6);
  _prumCenaTuz numeric(19,6);
  _prumCenaMen numeric(19,6);
  _pocetNavazanych integer;
  _cenaMj numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _kurzDokladu numeric(19,6);
  _kurzSkladKarty numeric(19,6);
  _isCiziMena boolean;
  _sklfifo boolean;
  _datPosl date; 
  _PoslCenaTuz numeric(19,6);     
  _PoslCenaMen numeric(19,6);     
  _cenaMjSkl numeric(19,6);
  _updateCena boolean;
  _rozpadlaPolSklad record;
  _sumZklProCenaMj numeric(19,6);
  _mnozMjProCenaMj numeric(19,6);
  _cenaMjPoriz numeric(19,6);
  --_cenaMjNakl numeric(19,6);
begin
  select * into _rozsirenaPolozka from tmp_RozsirenePolozky where idpolsklad = i_idrozsirenepolozky;
  select * into _polSklad from dPolSklad where idPolSklad = i_idrozsirenepolozky;
  if(_polSklad is null) then
    -- muze se stat ze v rozsirenych polozkach je uz polozka ktera byla v ramci transakce smazana
    return;
  end if;
  
  select * into _skladKarta from sKarty where idKarty = _rozsirenaPolozka.idskladkarty;
  select getKurzFromDoklad(_rozsirenaPolozka.idDoklSkladPolozky, _polSklad.datVyst) into _kurzDokladu;

  if(sign = 1) then
    if(_rozsirenaPolozka.skupina = 1) then
      if(_polSklad.mnozMj = 0.0) then
        _stavTuz = _polSklad.cenaMj * _kurzDokladu;
      else
        select sumZkl into _stavTuz from dpolsklad where idPolSklad = _rozsirenaPolozka.idPolSklad;
      end if;
    else
      -- pokud se jedna o prijemku z prevodky nebo vyroby tak se musi cena nastavit podle navazane vydejky
      _cenaMjSkl = 0.0;
      _sklfifo := (select isfifosklad(_polSklad.datVyst));
      -- menit cenu budeme jen pokud to neni fifo
      _updateCena = not _sklFifo;
      if(_rozsirenaPolozka.skupina = 2 and _rozsirenaPolozka.typPohybuK = 'typPohybu.prijem') then
        select * into _navazanaPolSklad from dPolSklad 
            where idPolSklad = (select idTabA from dvazebtab where idTabB = _rozsirenaPolozka.idPolSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklPrevod');
        if(_navazanaPolSklad is null) then
          _cenaMj = _polSklad.cenaMjNeskl;
          _cenaMjSkl = 0.0;
          _cenaMjPoriz = _cenaMj;
          _sumZkl = _polSklad.cenaMjNeskl * _polSklad.mnozMj;
          for _navazanaPolSklad in (select * from dPolSklad where idPolSklad in 
            (select idTabB from dvazebtab where idTabA = _rozsirenaPolozka.idPolSklad and modulA = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus') )
            loop
            if(_navazanaPolSklad.mnozMj <> 0.0) then
              _cenaMj = _cenaMj + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
              _cenaMjSkl = _cenaMjSkl + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
            else
              raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit
            end if;
            _sumZkl = _sumZkl + _navazanaPolSklad.sumZkl;

            -- musime zohlednit i pripadne rozpady skladovych polozek
            for _rozpadlaPolSklad in (select * from dPolSklad where idPolSklad in
              (select idpolskladcil from svazbypolsklad where idpolskladzdroj = _navazanaPolSklad.idPolSklad))
            loop
              if(_rozpadlaPolSklad.mnozMj <> 0.0) then
                _cenaMj = _cenaMj + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
                _cenaMjSkl = _cenaMjSkl + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
              else
                raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit
              end if;
              _sumZkl = _sumZkl + _rozpadlaPolSklad.sumZkl;
            end loop;

            _cenaMjPoriz = _cenaMj;

            -- ovsem pokud se jedna o vyrobu musime zmenit cenu prijmky z vyroby
            _updateCena = true;
          end loop;
          _cenaMj = _cenaMjPoriz + _polSklad.cenaMjNakl;
          _sumZkl = _sumZkl + (_polSklad.mnozMj * _polSklad.cenaMjNakl);
        else
          _sumZklProCenaMj = 0.0;
          _mnozMjProCenaMj = 0.0;
          if(_navazanaPolSklad.mnozMj <> 0.0) then
            _sumZklProCenaMj = _sumZklProCenaMj + _navazanaPolSklad.sumZkl / _kurzDokladu;
            _mnozMjProCenaMj = _mnozMjProCenaMj + _navazanaPolSklad.mnozMj;
          else
            raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit
          end if;
          _sumZkl = _navazanaPolSklad.sumZkl;
          -- musime zohlednit i pripadne rozpady skladovych polozek
          for _rozpadlaPolSklad in (select * from dPolSklad where idPolSklad in
            (select idpolskladcil from svazbypolsklad where idpolskladzdroj = _navazanaPolSklad.idPolSklad order by idpolskladcil desc)
            order by idpolsklad desc) 
          loop
            if(_polSklad.mnozMj > _mnozMjProCenaMj) then
              if(_rozpadlaPolSklad.mnozMj <> 0.0) then
                _sumZklProCenaMj = _sumZklProCenaMj + _rozpadlaPolSklad.sumZkl / _kurzDokladu;
                _mnozMjProCenaMj = _mnozMjProCenaMj + _rozpadlaPolSklad.mnozMj;
              else
                raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit
              end if;
              _sumZkl = _sumZkl + _rozpadlaPolSklad.sumZkl;
            end if;
          end loop;

          if(_mnozMjProCenaMj <> 0.0) then
            _cenaMjPoriz = _sumZklProCenaMj / _mnozMjProCenaMj;
          else
            raise exception '_mnozMjProCenaMj je 0.0'; -- TODO vyresit co se bude dit
          end if;
          _cenaMj = _cenaMjPoriz + _polSklad.cenaMjNakl;
          _sumZkl = _sumZkl + (_polSklad.mnozMj * _polSklad.cenaMjNakl);
          --_sumZkl = _polSklad.mnozMj * _cenaMj;
          -- ovsem pokud se jedna o prevodku musime zmenit cenu prijmky z prevodky
          _updateCena = true;
        end if;
        _sumZklMen = 0.0;
        select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _polSklad.datVyst) into _isCiziMena;
        if(_isCiziMena) then
          _sumZklMen = _polSklad.mnozMj * _cenaMj;
        end if;
      else
        _cenaMj = _skladKarta.prumCenaTuz;
        _cenaMjPoriz = _skladKarta.prumCenaTuz;
        if(_kurzDokladu is not null and _kurzDokladu <> 0.0) then
          _cenaMj = _cenaMj / _kurzDokladu;
        end if;
        _sumZkl = _polSklad.mnozMj * _skladKarta.prumCenaTuz;
        _sumZklMen = 0.0;
        select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _polSklad.datVyst) into _isCiziMena;
        if(_isCiziMena) then
          _sumZklMen = _polSklad.mnozMj * _cenaMj; 
        end if;
      end if;

      if (_updateCena) then
        update dPolSklad set
          cenaMjPoriz = _cenaMjPoriz,
          cenaMj = _cenaMj,
          cenaMjSkl = _cenaMjSkl,
          sumZkl = _sumZkl,
          sumZklMen = _sumZklMen
          where idPolSklad = _rozsirenaPolozka.idPolSklad;
      end if;

      --execute sprepoctisumydokladu(_rozsirenaPolozka.idDoklSkladPolozky);

      select sumZkl into _stavTuz from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
    end if;
  else
    if(_polSklad.mnozMj = 0.0 and _rozsirenaPolozka.typpohybuk = 'typPohybu.prijem') then
      _stavTuz = _polSklad.cenaMj * _kurzDokladu;
    else
      select sumZkl into _stavTuz from dpolsklad where idPolSklad = i_idrozsirenepolozky;
    end if;
  end if;

  if(_rozsirenaPolozka.typpohybuk = 'typPohybu.vydej') then
    _stavMj = _skladKarta.stavMj - (sign*_polSklad.mnozMj);
    _stavTuz = _skladKarta.stavTuz - (sign*_stavTuz);
  else
    _stavMj = _skladKarta.stavMj + (sign*_polSklad.mnozMj);
    _stavTuz = _skladKarta.stavTuz + (sign*_stavTuz);
  end if;

  if(_stavMj is null) then
    raise exception 'stav mj je null a idpolsklad je % a _skladkarta je % a _polSklad je %',i_idrozsirenepolozky, _skladkarta, _polSklad;
  end if;

  _prumCenaTuz = _skladKarta.prumCenaTuz;
  if(_stavMj <> 0.0) then
    _prumCenaTuz = _stavTuz / _stavMj;
  end if;
  if(_prumCenaTuz is null) then
    raise exception 'prumCenaTuz je null, _stavTuz je %, _stavMj je %', _stavTuz, _stavMj;
  end if; 
 
  _datPosl = _skladKarta.datPosl;
  if(_datPosl is null or _datPosl < _polSklad.datVyst) then
    _datPosl = _polSklad.datVyst;
  end if;

  _poslCenaTuz = _skladKarta.poslCenaTuz;
  _poslCenaMen = _skladKarta.poslCenaMen;
  if(_rozsirenaPolozka.typpohybuk = 'typPohybu.prijem') then
    _PoslCenaTuz := _polSklad.cenaMj * _KurzDokladu;   
    _PoslCenaMen := _polSklad.cenaMj; 
  end if;
 
  _KurzSkladKarty := (select getKurzFromSklad(_skladKarta.idSkladu, _polSklad.datVyst));
  if (not _rozsirenaPolozka.storno) then
    update skarty set 
      stavmj = _stavMj,
      stavTuz = _stavTuz,
      stavMen = round(_stavTuz / _kurzSkladKarty, 2),
      prumCenaTuz = _prumCenaTuz,
      prumCenaMen = _prumCenaTuz / _kurzSkladKarty,
      datPosl = _datPosl,
      poslCenaTuz = _poslCenaTuz,
      poslCenaMen = _poslCenaMen,
      lastUpdate = LOCALTIMESTAMP
      where idkarty = _rozsirenaPolozka.idSkladKarty;
  end if;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladPrepoctiRozsirenouPolozku(integer, integer) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION dpolskladinsert()
  RETURNS trigger AS
$BODY$
declare
  _rozsirenaPolozka record;
  _typPohybuk character varying;
  _mazatTmpTable boolean;
  _idPolSklad integer;
  _probihaPrepocetSkladu character varying;
  _polSklad record; 
  _pocetMenenychVydejek integer;
begin
  if(NEW.storno = true) then
    return NEW;
  end if; 
  
  select getglotxvariable('probihaPrepocetSkladu') into _probihaPrepocetSkladu;
  if(_probihaPrepocetSkladu = 'true') then
  else
    -- tento select zjisti kolik je vydejek, ktere by se meli prepocitavat
    select count(idpolsklad) into _pocetMenenychVydejek from dpolsklad ps join ddoklsklad ds 
      on ps.datsklad >= NEW.datSklad and ps.cenyRucne = false and ps.iddoklsklad = ds.iddoklsklad and ds.typpohybuk = 'typPohybu.vydej';
    if(_pocetMenenychVydejek = 0 and NEW.cenyRucne = true) then
      execute sprepoctiskladkartu(NEW.mnozMj, NEW.cenaMj, NEW.sumZkl, NEW.datVyst, NEW.idKarty, NEW.idDoklSklad, NEW.idBspSkl, 1); 
      return NEW;
    end if;

    -- v pripade ze neprobiha prepocet skladu
    -- generuji rozsirene polozky
    select skladGenerujRozsirenePolozky(NEW.datSklad, NEW.idPolSklad, NEW.idKarty) into _mazatTmpTable;

    execute putglotxvariable('zurnalTxName', 'prepocetSkladu');

    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
      if(_rozsirenaPolozka.idPolSklad <> NEW.idPolSklad) then
        if(_rozsirenaPolozka.cenyRucne = true) then
          -- pokud maji byt ceny zadany rucne a nemaji se nikterak menit tak jen zmenime skladovou kartu a jedeme dal
          if(_rozsirenaPolozka.storno = false) then 
            select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
            execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, -1); 
          end if;
        else
          execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
        end if;
      end if;
    end loop;

    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
      if(_rozsirenaPolozka.cenyRucne = true) then
        -- pokud maji byt ceny zadany rucne a nemaji se nikterak menit tak jen zmenime skladovou kartu a jedeme dal
        if(_rozsirenaPolozka.storno = false) then 
          select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
          execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, 1); 
        end if;
      else
        execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
      end if;
    end loop;

    if(_mazatTmpTable) then
      drop table tmp_RozsirenePolozky;
      drop table tmp_SkladoveKarty;
      execute removeglotxvariable('zurnalTxName');
    end if;
  end if;

  select typpohybuk into _typPohybuk from ddoklsklad where iddoklsklad = NEW.iddoklsklad;
  --pokud výdej, tak fifuju vazby
  if (_typPohybuk = 'typPohybu.vydej' or (_typPohybuK = 'typPohybu.prijem' and NEW.mnozMj < 0.0)) then
    execute sFifoVydej(NEW.idPolSklad, NEW.idCenik, NEW.idBspSkl, NEW.idKarty, NEW.mnozmj, NEW.cenyRucne);
    --execute sPrepoctiSumyDokladu(NEW.idDoklSklad);
  end if;

  if(_probihaPrepocetSkladu = 'true') then
    if(NEW.idPolSklad < 0) then
      _idPolSklad = -NEW.idPolSklad;
    else
      _idPolSklad = NEW.idPolSklad;
    end if;

    execute skladinsertrozsirenoupolozku(_idPolSklad);
  end if;

  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladinsert() OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 628, 't', %appVersion%, clock_timestamp());
