--------------------------------------------------------------------------------
-- Bug 31902 – [WinStrom] - Příjemky x Přijaté faktury - Cena
--------------------------------------------------------------------------------
CREATE OR REPLACE FUNCTION sprepoctiSumyDoklFak(_idDokladu integer, _modul character varying) RETURNS void AS
$BODY$  
declare
  _sumOsv numeric(15,2);
  _sumOsvMen numeric(15,2);

  _sumZklSniz numeric(15,2);
  _sumZklSnizMen numeric(15,2);
  _sumDphSniz numeric(15,2);
  _sumDphSnizMen numeric(15,2);

  _sumZklZakl numeric(15,2);
  _sumZklZaklMen numeric(15,2);
  _sumDphZakl numeric(15,2); 
  _sumDphZaklMen numeric(15,2); 

  _sumCelkem numeric(15,2);
  _sumCelkemMen numeric(15,2);

  _polDokl record;
  _typPlneniK character varying(50);
begin
  _sumOsv = 0.0;
  _sumOsvMen = 0.0;

  _sumZklSniz = 0.0;
  _sumZklSnizMen = 0.0;
  _sumDphSniz = 0.0;
  _sumDphSnizMen = 0.0;

  _sumZklZakl = 0.0;
  _sumZklZaklMen = 0.0;
  _sumDphZakl = 0.0;
  _sumDphZaklMen = 0.0;

  _sumCelkem = 0.0;
  _sumCelkemMen = 0.0;
  if(_modul = 'FAP') then
    for _polDokl in (select * from dpolfak where idDoklFak = _idDokladu and stornoPol = false) loop

      _typPlneniK = null;
      if(_polDokl.idClenDph is not null) then
        select typPlneniK into _typPlneniK from uclendph where idclendph = _polDokl.idClenDph;
      end if;

      if(_typPlneniK is not null and
        (_typPlneniK = 'typPlneni.prijataRCH' or _typPlneniK = 'typPlneni.uskutecnenaRCH' or _typPlneniK = 'typPlneni.obojiRCH')) then
          _sumCelkem = _sumCelkem + _polDokl.sumZkl;
          _sumCelkemMen = _sumCelkemMen + _polDokl.sumZklMen;
      else
          _sumCelkem = _sumCelkem + _polDokl.sumZkl + _polDokl.sumDph;
          _sumCelkemMen = _sumCelkemMen + _polDokl.sumZklMen + _polDokl.sumDphMen;
      end if;
      
      if(_polDokl.typSzbDphK is null or _polDokl.typSzbDphK = 'typSzbDph.dphOsv') then
        _sumOsv = _sumOsv + _polDokl.sumZkl;
        _sumOsvMen = _sumOsvMen + _polDokl.sumZklMen;
      elsif(_polDokl.typSzbDphK = 'typSzbDph.dphSniz') then
        _sumZklSniz = _sumZklSniz + _polDokl.sumZkl;
        _sumZklSnizMen = _sumZklSnizMen + _polDokl.sumZklMen;
        _sumDphSniz = _sumDphSniz + _polDokl.sumDph;
        _sumDphSnizMen = _sumDphSnizMen + _polDokl.sumDphMen;
      elsif(_polDokl.typSzbDphK = 'typSzbDph.dphZakl') then
        _sumZklZakl = _sumZklZakl + _polDokl.sumZkl;
        _sumZklZaklMen = _sumZklZaklMen + _polDokl.sumZklMen;
        _sumDphZakl = _sumDphZakl + _polDokl.sumDph;
        _sumDphZaklMen = _sumDphZaklMen + _polDokl.sumDphMen;
      else
        raise exception 'nepodporovany typSzbDph %', _polDokl.typSzbDphK;
      end if;
    end loop;
    update ddoklfak set 
      sumOsv = _sumOsv,
      sumOsvMen = _sumOsvMen,

      sumZklSniz = _sumZklSniz,
      sumZklSnizMen = _sumZklSnizMen,
      sumDphSniz = _sumDphSniz,
      sumDphSnizMen = _sumDphSnizMen,

      sumZklZakl = _sumZklZakl,
      sumZklZaklMen = _sumZklZaklMen,
      sumDphZakl = _sumDphZakl,
      sumDphZaklMen = _sumDphZaklMen,

      sumCelkem = _sumCelkem,
      sumCelkemMen = _sumCelkemMen
      where idDoklFak = _idDokladu;

  elsif (_modul = 'POK') then
    for _polDokl in (select * from dpolint where idDoklInt = _idDokladu and stornoPol = false) loop

      _typPlneniK = null;
      if(_polDokl.idClenDph is not null) then
        select typPlneniK into _typPlneniK from uclendph where idclendph = _polDokl.idClenDph;
      end if;

      if(_typPlneniK is not null and
        (_typPlneniK = 'typPlneni.prijataRCH' or _typPlneniK = 'typPlneni.uskutecnenaRCH' or _typPlneniK = 'typPlneni.obojiRCH')) then
          _sumCelkem = _sumCelkem + _polDokl.sumZkl;
          _sumCelkemMen = _sumCelkemMen + _polDokl.sumZklMen;
      else
          _sumCelkem = _sumCelkem + _polDokl.sumZkl + _polDokl.sumDph;
          _sumCelkemMen = _sumCelkemMen + _polDokl.sumZklMen + _polDokl.sumDphMen;
      end if;
      
      if(_polDokl.typSzbDphK is null or _polDokl.typSzbDphK = 'typSzbDph.dphOsv') then
        _sumOsv = _sumOsv + _polDokl.sumZkl;
        _sumOsvMen = _sumOsvMen + _polDokl.sumZklMen;
      elsif(_polDokl.typSzbDphK = 'typSzbDph.dphSniz') then
        _sumZklSniz = _sumZklSniz + _polDokl.sumZkl;
        _sumZklSnizMen = _sumZklSnizMen + _polDokl.sumZklMen;
        _sumDphSniz = _sumDphSniz + _polDokl.sumDph;
        _sumDphSnizMen = _sumDphSnizMen + _polDokl.sumDphMen;
      elsif(_polDokl.typSzbDphK = 'typSzbDph.dphZakl') then
        _sumZklZakl = _sumZklZakl + _polDokl.sumZkl;
        _sumZklZaklMen = _sumZklZaklMen + _polDokl.sumZklMen;
        _sumDphZakl = _sumDphZakl + _polDokl.sumDph;
        _sumDphZaklMen = _sumDphZaklMen + _polDokl.sumDphMen;
      else
        raise exception 'nepodporovany typSzbDph %', _polDokl.typSzbDphK;
      end if;
    end loop;
    update ddoklint set 
      sumOsv = _sumOsv,
      sumOsvMen = _sumOsvMen,

      sumZklSniz = _sumZklSniz,
      sumZklSnizMen = _sumZklSnizMen,
      sumDphSniz = _sumDphSniz,
      sumDphSnizMen = _sumDphSnizMen,

      sumZklZakl = _sumZklZakl,
      sumZklZaklMen = _sumZklZaklMen,
      sumDphZakl = _sumDphZakl,
      sumDphZaklMen = _sumDphZaklMen,

      sumCelkem = _sumCelkem,
      sumCelkemMen = _sumCelkemMen
      where idDoklInt = _idDokladu;

  else
    raise exception 'nepodporovany modul %', _modul;
  end if;
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION sprepoctiSumyDoklFak(integer, character varying)
  OWNER TO %firmaRole%;

-- Function: dpolskladupdatecenamjnafap()
-- DROP FUNCTION dpolskladupdatecenamjnafap();
CREATE OR REPLACE FUNCTION dpolskladupdatecenamjnafap()
  RETURNS trigger AS
$BODY$  
declare 
  _idPolFak integer; 
  _modul character varying; 
  _oldSumZkl numeric(15,2); 
  _oldSumDph numeric(15,2); 
  _newSumZkl numeric(15,2); 
  _newSumDph numeric(15,2); 
  _typSzbDphK character varying(50);
  _szbDph numeric(6,2);
  _typCenyDphK character varying(50);
  _mnozMj numeric(19,6);
  _newCenaMj numeric(19,6);
  _idDokladu integer;
  _typPohybuK character varying(50);
  _typPohybuSklK character varying(50);
begin 
  select typPohybuK into _typPohybuSklK from ddoklsklad where idDoklSklad = NEW.idDoklSklad;
  
  if(NEW.zdrojProFak is not null and NEW.zdrojProFak = true and _typPohybuSklK is not null and _typPohybuSklK = 'typPohybu.prijem') then
    -- cela tato synchronizace se bude dit tehdy a jen tehdy kdyz bude prijemka zdrojovym dokladem
    select idTabA, modulA into _idPolFak, _modul from dVazebTab where idTabB = NEW.idPolSklad and modulB = 'SKL' and  
       (typVazbyK = 'typVazbyDokl.polozkaSkl' or typVazbyK = 'typVazbyDokl.polozkaSklSada'); 
    
    if(NEW.sumZkl <> OLD.sumZkl and _idPolFak is not null and _modul is not null and (_modul = 'FAP' or _modul = 'POK')) then
      if(_modul = 'FAP') then 
        select sumZkl, sumDph, typSzbDphK, szbDph, typCenyDphK, mnozMj, idDoklFak 
            into _oldSumZkl, _oldSumDph, _typSzbDphK, _szbDph, _typCenyDphK, _mnozMj, _idDokladu
          from dPolFak where idPolFak = _idPolFak; 
      elsif(_modul = 'POK') then 
        select sumZkl, sumDph, typSzbDphK, szbDph, typCenyDphK, mnozMj, idDoklInt 
            into _oldSumZkl, _oldSumDph, _typSzbDphK, _szbDph, _typCenyDphK, _mnozMj, _idDokladu
          from dPolInt where idPolInt = _idPolFak;

        select typPohybuK into _typPohybuK from dDoklInt where idDoklInt = _idDokladu; 
        if(_typPohybuK is not null and _typPohybuK = 'typPohybu.prijem') then
          -- Pokud je u modulu POK typPohybu prijem tak tady nemam co delat
          return NEW;
        end if;
      end if;

      if((_oldSumZkl + _oldSumDph) = NEW.sumZkl) then
        return NEW;
      end if;

      _newSumZkl = NEW.sumZkl;
      _newSumDph = NEW.sumZkl * (_szbDph/100);
      _newCenaMj = 0.0;
      if(_typCenyDphK = 'typCeny.bezDph') then
        _newCenaMj = NEW.sumZkl / _mnozMj;
      elsif(_typCenyDphK = 'typCeny.sDphKoef' or _typCenyDphK = 'typCeny.sDph') then
        _newCenaMj = (_newSumZkl + _newSumDph) / _mnozMj;
      else
        raise exception 'neznamy typCenyDphK = %', _typCenyDphK;
      end if;
      
      execute putglotxvariable('vypniSklad', 'true');  
      
      if(_modul = 'FAP') then 
        update dpolfak set cenaMj = _newCenaMj, sumZkl = _newSumZkl, sumDph = _newSumDph where idpolfak = _idPolFak; 
      elsif(_modul = 'POK') then 
        update dpolint set cenaMj = _newCenaMj, sumZkl = _newSumZkl, sumDph = _newSumDph where idpolint = _idPolFak; 
      end if; 

      execute sprepoctiSumyDoklFak(_idDokladu, _modul);
 
      execute removeglotxvariable('vypniSklad'); 
    end if;
  end if;
  
  return NEW; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION dpolskladupdatecenamjnafap()
  OWNER TO %firmaRole%;

CREATE TRIGGER dpolskladupdatecenamjnafap
  AFTER UPDATE
  ON dpolsklad
  FOR EACH ROW
  EXECUTE PROCEDURE dpolskladupdatecenamjnafap();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 677, 't', %appVersion%, clock_timestamp());
