--------------------------------------------------------------------------------
-- Bug 32163 – [WinStrom] Záporný součet požadavků na výdej u PROFIZOO
--------------------------------------------------------------------------------
update skarty k set pozadavkyMj = 0.0 where pozadavkyMj <> 0.0;
update skarty k set stavmjspozadavky = stavMj where stavmjspozadavky <> stavMj;

update skarty k set pozadavkyMj = 
(select coalesce(sum(mnozMjPlan), 0.0) from dpolsklad p where mnozMj = 0.0 and mnozMjPlan <> 0.0 and p.idkarty = k.idkarty)
where (select count(*) from dpolsklad p where mnozMj = 0.0 and mnozMjPlan <> 0.0 and p.idkarty = k.idkarty) <> 0;

update skarty k set stavmjspozadavky = stavMj - pozadavkyMj where pozadavkyMj <> 0;


CREATE OR REPLACE FUNCTION skladrealizujpozadavky()
  RETURNS void AS
$BODY$ 
declare
  _polSklad record;
  _polSkladDoklSklad record;
  _stavSkladu numeric(19,6);
  _cenaMj numeric(19,6);
  _pocetPozadavku integer;
begin
  for _polSklad in (
    select p.*, d.typPohybuK, d.stavSkladK from dpolsklad p join ddoklsklad d on p.idDoklSklad = d.idDoklSklad
    where typPohybuK = 'typPohybu.vydej' and mnozMj = 0 and mnozMjPlan != 0 and p.storno = false
    order by datSklad, idPolSklad) loop
      --select dgetstavnasklade(_polSklad.idkarty, _polSklad.datSklad, /*_polSklad.idpolsklad*/ -1, _polSklad.sarze, _polSklad.expirace, _polSklad.typPohybuK) into _stavSkladu;
      select stavMj, prumCenaTuz into _stavSkladu, _cenaMj from skarty where idkarty = _polSklad.idKarty;
      
      if(_stavSkladu >= _polSklad.mnozMjPlan) then
        update skarty set
          pozadavkyMj = pozadavkyMj - _polSklad.mnozMjPlan,
          stavMjSPozadavky = stavMjSPozadavky + _polSklad.mnozMjPlan
        where idkarty = _polSklad.idKarty;
        
        update dpolsklad set mnozMj = mnozMjPlan, cenaMj = _cenaMj, sumZkl = mnozMjPlan * _cenaMj, datSklad = LOCALTIMESTAMP, lastupdate = LOCALTIMESTAMP
          where idpolsklad = _polSklad.idPolSklad;
        perform sprepoctisumydokladu(_polSklad.iddoklsklad);
        
        select count(*) into _pocetPozadavku from dpolSklad where idDoklSklad = _polSklad.idDoklSklad and mnozMj = 0.0 and mnozMjPlan != 0.0;
        if(_pocetPozadavku = 0) then
          if(compareVarchar(_polSklad.stavSkladK, 'stavSklad.vygenFaktNeuplny')) then
            update ddoklsklad set stavSkladK = 'stavSklad.vygenFakt' where idDoklSklad = _polSklad.idDoklSklad;
          end if;
          if(compareVarchar(_polSklad.stavSkladK, 'stavSklad.vygenPoklNeuplny')) then
            update ddoklsklad set stavSkladK = 'stavSklad.vygenPokl' where idDoklSklad = _polSklad.idDoklSklad;
          end if;
        end if;
      end if;
  end loop;
end;    
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladrealizujpozadavky() OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION dGetStavNaSkladeAktualni(i_skladkartaid integer)
  RETURNS numeric AS
$BODY$       
declare      
  _idcenik integer;    
  _idskladu integer;    
  _iducetniobdobi integer;  
  _stavMj numeric(19,6);      
  _idSkladKarty integer;  
  _sadaItemCount integer;  
  _polozkaSady record;  
  _stavSkladuSady numeric(19,6);  
  _pocetPozadavku numeric(19,6);
begin      
  select idcenik, idskladu, iducetobdobi into _idcenik, _idskladu, _iducetniobdobi from skarty where idkarty = i_skladkartaid;  
  
  -- zjistim jestli nahodu dany cenik neni sada nebo komplet  
  select count(*) into _sadaItemCount from csady where idceniksada = _idCenik;  
  -- pokud se nejedna o sadu tak funguju normalne  
  if(_sadaItemCount = 0) then  
      -- zkusime vypocitat stav na vrcholu  
      select stavMj into _stavMj from skarty where idkarty = i_skladkartaid;  
      select sum(mnozMjPlan) into _pocetPozadavku from dpolsklad where mnozMjPlan <> 0.0 and mnozMj = 0.0 and idkarty = i_skladkartaid and storno = false;
      if(_pocetPozadavku is not null) then
        _stavMj = _stavMj - _pocetPozadavku;
      end if;
  else  
    for _polozkaSady in  
      select * from cSady where idCenikSada = _idCenik  
    loop  
      select idKarty into _idSkladKarty from sKarty where idCenik = _polozkaSady.idCenik and idSkladu = _idskladu and idUcetObdobi = _iducetniobdobi;  
      if(_idSkladKarty is not null) then   
        if(_stavMj is null) then  
          _stavMj = 9999999999999.0; -- vic uz pretejka  
        end if;  
        select dGetStavNaSkladeAktualni(_idSkladKarty) into _stavSkladuSady;  
        _stavSkladuSady = _stavSkladuSady / _polozkaSady.mnozMj;  
        select minValue(_stavMj, _stavSkladuSady) into _stavMj;  
      end if;  
    end loop;  
  end if;   
   
  -- muze se stat ze _stavMj je null a to znamena ze na sklade nic neni   
  if(_stavMj is null) then   
    _stavMj := 0;   
  end if;   
     
  RETURN _stavMj;       
end       
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dGetStavNaSkladeAktualni(integer) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION dgetstavnaskladeaktualni(i_idcenik integer, i_idsklad integer, i_datum date)
  RETURNS numeric AS
$BODY$       
declare      
  _iducetniobdobi integer;  
  _stavMj numeric(19,6);      
  _idSkladKarty integer;  
  _sadaItemCount integer;  
  _polozkaSady record;  
  _stavSkladuSady numeric(19,6);  
  _pocetPozadavku numeric(19,6);
begin      
  --select idcenik, idskladu, iducetobdobi into _idcenik, _idskladu, _iducetniobdobi from skarty where idkarty = i_skladkartaid;  
  select idUcetObdobi into _iducetniobdobi from nUcetObdobi where platiOdData <= i_datum and platiDoData >= i_datum;
  
  -- zjistim jestli nahodu dany cenik neni sada nebo komplet  
  select count(*) into _sadaItemCount from csady where idceniksada = i_idCenik;  
  -- pokud se nejedna o sadu tak funguju normalne  
  if(_sadaItemCount = 0) then  
      -- zkusime vypocitat stav na vrcholu  
      select idKarty into _idSkladKarty from sKarty where idCenik = i_idCenik and idSkladu = i_idsklad and idUcetObdobi = _iducetniobdobi;  
      select stavMj into _stavMj from skarty where idkarty = _idSkladKarty;  
      select sum(mnozMjPlan) into _pocetPozadavku from dpolsklad where mnozMjPlan <> 0.0 and mnozMj = 0.0 and idkarty = _idSkladKarty and storno = false;
      if(_pocetPozadavku is not null) then
        _stavMj = _stavMj - _pocetPozadavku;
      end if;
  else  
    for _polozkaSady in  
      select * from cSady where idCenikSada = i_idCenik  
    loop  
      select idKarty into _idSkladKarty from sKarty where idCenik = _polozkaSady.idCenik and idSkladu = i_idsklad and idUcetObdobi = _iducetniobdobi;  
      if(_idSkladKarty is not null) then   
        if(_stavMj is null) then  
          _stavMj = 9999999999999.0; -- vic uz pretejka  
        end if;  
        select dGetStavNaSkladeAktualni(_idSkladKarty) into _stavSkladuSady;  
        _stavSkladuSady = _stavSkladuSady / _polozkaSady.mnozMj;  
        select minValue(_stavMj, _stavSkladuSady) into _stavMj;  
      end if;  
    end loop;  
  end if;   
   
  -- muze se stat ze _stavMj je null a to znamena ze na sklade nic neni   
  if(_stavMj is null) then   
    _stavMj := 0;   
  end if;   
     
  RETURN _stavMj;       
end       
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dgetstavnaskladeaktualni(integer, integer, date) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 683, 't', %appVersion%, clock_timestamp());
