--------------------------------------------------------------------------------
-- Bug 32257 – [WinStrom] - OBP - generace faktury
--------------------------------------------------------------------------------

ALTER TABLE aadresar ADD COLUMN obpautomhotovo boolean NOT NULL DEFAULT false;

--------------------------------------------------------------------------------
-- Bug 32284 – [WinStrom] - Realizovatelnost - oprava chyby
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION obchodrealizovatelnost(iddokl integer) RETURNS numeric AS $$  
declare 
  zbyvaNakl numeric(15,2); 
  moznoSklad numeric(15,2); 
  moznoNesklad numeric(15,2); 
  vysledek numeric(20,2); 
  _idadresar integer;
begin  
  select coalesce(sum((mnozMj-mnozMjReal) * cenaMj), 0) into zbyvaNakl from dPolObch where idDoklObch = idDokl and mnozmj > 0 and cenamj > 0; 
  
  select idfirmy into _idadresar from ddoklobch where iddoklobch = iddokl;
  
  select coalesce(sum(a.procpol), 0) into moznoSklad from 
   (select minValue( 
        maxValue(dgetstavnaskladeaktualni(P.idCenik, P.idBspSkl, DATE(NOW()), _idadresar), 0),
        sum(mnozMj-mnozMjReal)) 
    * (sum(cenamj * (mnozMj-mnozMjReal)) / sum(mnozMj-mnozMjReal)) as procpol
    from dPolObch as P left outer join ccenik as C on P.idcenik = C.idcenik 
      where idDoklObch = idDokl and C.skladove = true and mnozMj-mnozMjReal > 0
    group by P.idcenik, idbspskl) as a;
 
  select coalesce(sum((mnozMj-mnozMjReal) * cenaMj), 0) into moznoNesklad 
    from dPolObch as P left outer join ccenik as C on P.idcenik = C.idcenik  where idDoklObch = idDokl and cenaMj > 0 and mnozmj > 0 and  (C.skladove is null or C.skladove = false); 
 
  if (zbyvaNakl = 0) then 
    vysledek := 100 ; 
  else 
    vysledek := ((moznoSklad + moznoNesklad) / zbyvaNakl) * 100; 
  end if;  
  if (vysledek < 0.0) then 
     vysledek := -1.0;
  end if;	
  if (vysledek > 999) then 
     vysledek := 999;
  end if; 
   
  return vysledek; 
end;  
$$ LANGUAGE plpgsql;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 687, 't', %appVersion%, clock_timestamp());
