--------------------------------------------------------------------------------
-- Bug 34412 – [WinStrom] Doklady-tvorba dobropisů s vazbou
--------------------------------------------------------------------------------

alter table dpolfak add column idpoldobropis integer;
alter table dpolsklad add column idpoldobropis integer;
alter table dpolint add column idpoldobropis integer;
alter table dpolobch add column idpoldobropis integer;

CREATE OR REPLACE FUNCTION dpoldoklinsertsklad() RETURNS trigger AS
$BODY$
declare
  pocetNavazanychDokladu integer;
  _idPolFak integer;
  _idDoklFak integer;
  _idPolSklad integer;
  _dokladGenerovatSkl boolean;
  _typDoklGenerovatSkl boolean;
  _typZasobyK character varying;
  _skladove boolean;
  _sadaItemCount integer; 
  _cenaMjNakup numeric(19,6);  
  _typDoklK character varying;
  _idPolDobropis integer;
  _idPolSkladDobropis integer;
begin
  if(NEW.idPolDobropis is not null and NEW.idPolDobropis > 0) then
    -- kdyz je to dobropis
    if(NEW.modul like 'POK') then 
      _idPolFak = NEW.idPolInt; 
    else
      _idPolFak = NEW.idPolFak; 
    end if;
    select idtabb into _idPolSkladDobropis from dvazebtab 
        where idtaba = NEW.idPolDobropis and modulA = NEW.modul and modulB = 'SKL' 
              and typVazbyK = 'typVazbyDokl.polozkaSkl';
    if(_idPolSkladDobropis is not null) then
      -- z dobropisovane polozky byl vygenerovan skladovy doklad nesadovy
      select createpolskladdobropis(_idPolSkladDobropis, _idPolFak, NEW.modul, 'typVazbyDokl.polozkaSkl') into _idPolSklad;
    else
      -- pripadne zohledneni vsech sadovych rozpadu
      for _idPolSkladDobropis in (select idtabb from dvazebtab 
        where idtaba = NEW.idPolDobropis and modulA = NEW.modul and modulB = 'SKL' 
              and typVazbyK = 'typVazbyDokl.polozkaSklSada') loop
        select createpolskladdobropis(_idPolSkladDobropis, _idPolFak, NEW.modul, 'typVazbyDokl.polozkaSklSada') into _idPolSklad;
      end loop;
    end if;
  else
    if(NEW.typPolozkyK like 'typPolozky.katalog') then
      if(NEW.modul like 'POK') then
        _idPolFak = NEW.idPolInt;
        _idDoklFak = NEW.idDoklInt;
        select generovatSkl into _dokladGenerovatSkl from dDoklInt where idDoklInt = NEW.idDoklInt;
        select generovatSkl, typDoklK into _typDoklGenerovatSkl, _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklInt where idDoklInt = NEW.idDoklInt);

        select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolint where idpolint = NEW.idPolInt);
      else
        _idPolFak = NEW.idPolFak;
        _idDoklFak = NEW.idDoklFak;
        select generovatSkl into _dokladGenerovatSkl from dDoklFak where idDoklFak = NEW.idDoklFak;
        select generovatSkl, typDoklK into _typDoklGenerovatSkl, _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = NEW.idDoklFak);

        select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolfak where idpolfak = NEW.idPolFak);
      end if;

      select skladove into _skladove from cCenik where idCenik = NEW.idCenik;
    
      if (_skladove and NEW.idBspSkl is not null
        and _dokladGenerovatSkl and _typDoklGenerovatSkl and NEW.zdrojProSkl) then
        select count(*) into pocetNavazanychDokladu from dvazebtab where
          typVazbyK like 'typVazbyDokl.hlavaSkl'
          and (
          (idTabA = _idDoklFak and modulA like NEW.modul)
          or
          (idTabB = _idDoklFak and modulB like NEW.modul));

        --if(pocetNavazanychDokladu > 1) then
          --neco jeste nevim co
        --else
          if(_sadaItemCount > 0) then
            execute createPolSkladSada(_idPolFak, NEW.modul);
          else
            select createPolSklad(_idPolFak, NEW.modul) into _idPolSklad; 
          end if;
        --end if;
  
        execute putglotxvariable('vypniSklad', 'true');
        if(NEW.modul = 'FAV' and _typDoklK != 'typDokladu.dobropis') then
          select skladGetCenaMjNakup(_idPolFak, NEW.modul, NEW.mnozMj) into _cenaMjNakup;
          update dpolfak set cenaMjNakup = _cenaMjNakup where idpolfak = _idPolFak;
        elsif(NEW.modul = 'POK') then
          select skladGetCenaMjNakup(_idPolFak, NEW.modul, NEW.mnozMj) into _cenaMjNakup;
          update dpolint set cenaMjNakup = _cenaMjNakup where idpolint = _idPolFak;
        end if;
        execute removeglotxvariable('vypniSklad');
      end if;
    end if; 
  end if;
 
  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpoldoklinsertsklad() OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION createPolSklad(_idPolDokl integer, _modul character varying) RETURNS integer AS
$BODY$
declare
  _idDoklSklad integer;
  _idDoklad integer;
  _polDokl record;
  _iducetobdobi integer;
  _idkarty integer;
  _idPolSklad integer;
  _cenaMj numeric(19,6);
  _cenaMjTuz numeric(19,6);
  _typPohybuK character varying;
  _prumCenaTuz numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _kurz numeric(19,6);
  _idZklMdUcet integer;
  _idZklDalUcet integer;
  _kopZklMdUcet boolean;
  _kopZklDalUcet boolean;
  _sklad record;
  _typDoklK character varying;
  _mnozMj numeric(19,6);
  _isCiziMena boolean;
  _idMeny integer;  
  _skupZboz record;
  _idTypUcOp integer;
  _kopStred boolean;
  _kopCinnost boolean;
  _kopZakazku boolean;
  _idStredDoklSklad integer;
  _idCinnostDoklSklad integer;
  _idZakazkyDoklSklad integer;
  _typPohybuSkladKVydej character varying;
begin
  _kopZklMdUcet =false;
  _kopZklDalUcet = false;
  if(_modul like 'FAV' or _modul like 'FAP') then
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;
    _idDoklad = _polDokl.idDoklFak;
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);
  else
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;
    _idDoklad = _polDokl.idDoklInt;
    _typDoklK = null; -- pro pokladnu dobropisy nejsou
  end if;

  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true) into _idDoklSklad; 
  
  if(_idDoklSklad is null) then
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;
    if(_idDoklSklad is null) then
      return null;
    end if;
  end if;

  if(_polDokl.idPolDobropis is not null and _polDokl.idPolDobropis > 0) then
    return null;
  end if;

  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idskladu = _polDokl.idbspskl and iducetobdobi = _iducetobdobi;
  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl;
  
  select typPohybuK, idstred, idcinnost, idZakazky
    into _typPohybuK, _idStredDoklSklad, _idCinnostDoklSklad, _idZakazkyDoklSklad
    from dDoklSklad where idDoklSklad = _idDoklSklad; 
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty;
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;
  select idMeny, idTypUcOp into _idMeny, _idTypUcOp from dDoklSklad where idDoklSklad = _idDoklSklad;
      
  if(_typPohybuK like 'typPohybu.vydej') then
    -- vsechny dobropisy generuji prijemky
    --if(_typDoklK like 'typDokladu.dobropis') then
    --  _mnozMj = -_polDokl.mnozMj;
    --else
      _mnozMj = _polDokl.mnozMj;
    --end if;
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena
    _cenaMj = _prumCenaTuz / _kurz;
    _sumZkl = _prumCenaTuz * _mnozMj;
    if(_isCiziMena) then
      _sumZklMen = _mnozMj * _cenaMj;
    else
      _sumZklMen = 0.0;
    end if;
    -- nastaveni uctu pro polSklad vydej
    select typPohybuSkladK into _typPohybuSkladKVydej from ddoklsklad where iddoklsklad = _idDoklSklad;
    select * into _skupZboz from cskupzboz where idskupzboz = (select idskupzboz from ccenik where idcenik = _polDokl.idCenik);
    if(_skupzboz.idskupzboz is not null) then
      -- Úpravy dle Bug 32848 – [WinStrom] - nerespektování upřesnění typu pohybu při tvorbě výdejky
      if(_typPohybuSkladKVydej is null) then
        _idZklMdUcet = _skupZboz.idprotiucetsklv;
      -- typPohybuSklad.vydejHoly -  Holý" výdej  - idprotiucetsklholyv
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejHoly') then
        _idZklMdUcet = _skupZboz.idprotiucetsklholyv;
      -- typPohybuSklad.vydejPoFak - Výdej po faktuře  - idprotiucetsklv
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejPoFak') then
        _idZklMdUcet = _skupZboz.idprotiucetsklv;
      -- typPohybuSklad.vydejPolot - Výdej polotovaru - idprotiucetsklholyv
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejPolot') then
        _idZklMdUcet = _skupZboz.idprotiucetsklholyv;
      -- typPohybuSklad.vydejPoObch - Výdej po objednávce  -  idprotiucetsklv
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejPoObch') then
        _idZklMdUcet = _skupZboz.idprotiucetsklv;
      -- typPohybuSklad.vydejPrevod -  Výdej pro převodku  - idprotiucetsklprevv
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejPrevod') then
        _idZklMdUcet = _skupZboz.idprotiucetsklprevv;
      -- typPohybuSklad.vydejProFakCenik - Výdej pro fakturaci (ceny z ceníku) - idprotiucetsklv
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejProFakCenik') then
        _idZklMdUcet = _skupZboz.idprotiucetsklv;
      -- typPohybuSklad.vydejProFakRucne - Výdej pro fakturaci (ceny ručně) - idprotiucetsklv
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejProFakRucne') then
        _idZklMdUcet = _skupZboz.idprotiucetsklv; 
      --typPohybuSklad.vydejVyrob - Výdej výrobku  - idprotiucetsklholyv
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejVyrob') then
        _idZklMdUcet = _skupZboz.idprotiucetsklholyv; 
      end if;
    end if; 
    
    if(_idZklMdUcet is null) then 
      -- pokud neni ve skupine zbozi nastaven protiucet tak vemu protiucet z hlavicky a dam kopirovat na true
      select idProtiUcet into _idZklMdUcet from dDoklSklad where idDoklSklad = _idDoklSklad;
      _kopZklMdUcet = true;
    end if;
    _idZklDalUcet = _sklad.idPrimUcet;
  else
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny;
      _mnozMj = -_polDokl.mnozMj;
      --_cenaMjTuz = _prumCenaTuz;
      _cenaMjTuz = _polDokl.cenaMjNakup;
      if(_cenaMjTuz = 0.0) then
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik);
        if(_cenaMj = 0.0) then
          _cenaMj = _polDokl.cenaMj * _kurz;
        end if;
      end if;
      _cenaMj = _cenaMjTuz / _kurz;
      _sumZkl = _mnozMj * _cenaMjTuz;
      if(_isCiziMena) then
        _sumZklMen = _mnozMj * _cenaMj;
      else
        _sumZklMen = 0.0;
      end if;
      select * into _skupZboz from cskupzboz where idskupzboz = (select idskupzboz from ccenik where idcenik = _polDokl.idCenik);
      if(_skupZboz.idProtiUcetSklV is not null) then
        -- pokud je ve skupine zbozi nastaven protiucet pro vydej ze skladu pouzije se ten a kopirovani se necha na false;
        _idZklDalUcet = _skupZboz.idProtiUcetSklV;
      else
        -- pokud neni ve skupine zbozi nastaven protiucet tak vemu protiucet z hlavicky a dam kopirovat na true
        select idProtiUcet into _idZklDalUcet from dDoklSklad where idDoklSklad = _idDoklSklad;
        _kopZklDalUcet = true;
      end if;
    else
      -- pokud na sklad prijmam zkopiruji se ceny z faktury
      _mnozMj = _polDokl.mnozMj;
      _sumZkl = _polDokl.sumZkl;
      if(_mnozMj <> 0.0) then
        _cenaMj = _sumZkl / _mnozMj;
      else
        _cenaMj = _sumZkl;
      end if;
      _cenaMj = _cenaMj / _kurz;
      if(_isCiziMena) then
        if(_mnozMj <> 0.0) then
          _sumZklMen = _cenaMj * _mnozMj;  
        else
          _sumZklMen = _cenaMj;
        end if;
      else
        _sumZklMen = 0.0;  
      end if;
      _idZklDalUcet = _polDokl.idZklMdUcet;
    end if;
    -- nastaveni uctu pro polSklad prijem
    _idZklMdUcet = _sklad.idPrimUcet;
  end if; 

  _kopStred = true;
  if(not compareId(_idStredDoklSklad, _polDokl.idStred)) then
    _kopStred = false;
  end if;
  _kopCinnost = true;
  if(not compareId(_idCinnostDoklSklad, _polDokl.idCinnost)) then
    _kopCinnost = false;
  end if;
  _kopZakazku = true;
  if(not compareId(_idZakazkyDoklSklad, _polDokl.idZakazky)) then
    _kopZakazku = false;
  end if;
  
  select nextval('seq_dpolsklad') into _idPolSklad;  
  insert into dpolsklad(idPolSklad, lastUpdate, idcenik, idbspskl, idkarty, datVyst, datSklad, datUcto, modul, typPolozkyK, idDoklSklad,
        mnozMj, cenaMj, cenaMjPoriz, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, idmj,
        nazev, nazevA, nazevB, nazevC, sarze, expirace, datTrvan, datVyroby, cisRad, ucetni, 
        idStred, kopStred, idZakazky, kopZakazku, idMeny, zdrojProFak, idCinnost, kopCinnost, idTypUcOp)
      values (_idPolSklad, LOCALTIMESTAMP, _polDokl.idcenik, _polDokl.idbspskl, _idkarty, _polDokl.datVyst, LOCALTIMESTAMP, _polDokl.datVyst, 'SKL', 'typPolozky.katalog', _idDoklSklad,
        _mnozMj, _cenaMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, _kopZklMdUcet, _kopZklDalUcet, _polDokl.baleniid, _polDokl.mnozBaleni, _polDokl.idmj,
        _polDokl.nazev, _polDokl.nazevA, _polDokl.nazevB, _polDokl.nazevC, _polDokl.sarze, _polDokl.expirace, _polDokl.datTrvan, _polDokl.datVyroby, _polDokl.cisRad, true, 
        _polDokl.idStred, _kopStred, _polDokl.idZakazky, _kopZakazku, _idMeny, false, _polDokl.idCinnost, _kopCinnost, _idTypUcOp);
 
  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)
       values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSkl');

  -- prepocteni sum na dokladu
  execute sprepoctiSumyDokladu(_idDoklSklad);

  return _idPolSklad;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createPolSklad(integer, character varying) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION createpolskladdobropis(_iddobropisovanepolsklad integer, _iddobropisujicipoldokl integer, _modul character varying, _typVazbyK character varying)
  RETURNS integer AS
$BODY$ 
declare
  _idPolSklad integer;
  _idDoklad integer;
  _idDoklSklad integer; 
  _dobropisovanaPolSklad record;
  _kopZakazku boolean;
  _kopStred boolean;
  _kopCinnost boolean;
  _polDokl record;
  _idStredDoklSklad integer;
  _idCinnostDoklSklad integer;
  _idZakazkyDoklSklad integer;
  _iducetobdobi integer;
  _idkarty integer;
  _mnozMj numeric(19,6); 
  _pomer numeric(19,6);
  _cenaMj numeric(19,6); 
  _cenaMjTuz numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _mnozMjDobropisovane numeric(19,6);
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
  _kopZklMdUcet boolean; 
  _kopZklDalUcet boolean; 
  _idMeny integer;
  _idTypUcOp integer; 
  _kurz numeric(19,6); 
  _ciziMena boolean;
  _typPohybuK character varying;
  _nasobic numeric(19,6);
  _skupZboz record;
begin
  if(_modul like 'FAV' or _modul like 'FAP') then 
    select * into _polDokl from dPolFak where idPolFak = _iddobropisujicipoldokl;
    _idDoklad = _polDokl.idDoklFak;
    select mnozMj into _mnozMjDobropisovane from dPolFak where idPolFak = _polDokl.idPolDobropis;
    select typPohybuK into _typPohybuK from ddoklfak where iddoklfak = _idDoklad;
  else 
    select * into _polDokl from dPolInt where idPolInt = _iddobropisujicipoldokl;
    _idDoklad = _polDokl.idDoklInt;
    select mnozMj into _mnozMjDobropisovane from dPolInt where idPolInt = _polDokl.idPolDobropis;
    select typPohybuK into _typPohybuK from ddoklfak where iddoklfak = _idDoklad;
  end if; 

  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true) into _idDoklSklad;  
   
  if(_idDoklSklad is null) then 
    select createDoklSklad(_iddobropisujicipoldokl, _idDoklad, _modul) into _idDoklSklad; 
    if(_idDoklSklad is null) then 
      return null; 
    end if; 
  end if; 

  select * into _dobropisovanaPolSklad from dpolsklad where idpolsklad = _iddobropisovanepolsklad;
  select idstred, idcinnost, idZakazky, idMeny
      into _idStredDoklSklad, _idCinnostDoklSklad, _idZakazkyDoklSklad, _idMeny 
      from dDoklSklad where idDoklSklad = _idDoklSklad;  

  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi; 
  select idkarty into _idkarty from skarty where idcenik = _dobropisovanaPolSklad.idcenik and idskladu = _dobropisovanaPolSklad.idbspskl and iducetobdobi = _iducetobdobi;
  if(_idkarty is null) then
    raise exception 'idkarty je null protoze neexistuje skladova karta pro ucetni obdobi';
  end if;
  
  _nasobic = 1;
  if(_typPohybuK is not null and _typPohybuK = 'typPohybu.vydej')then
    _nasobic = -1;
  end if;
  _mnozMj = _nasobic * _dobropisovanaPolSklad.mnozMj;
  _sumZkl = _nasobic * _dobropisovanaPolSklad.sumZkl;
  
  if((-1 * _polDokl.mnozMj) <> _mnozMjDobropisovane) then
    _pomer = -1 * _polDokl.mnozMj / _mnozMjDobropisovane;
    _mnozMj = _mnozMj * _pomer;
    _sumZkl = _sumZkl * _pomer;
  end if;
  --raise exception '% % %', _polDokl.mnozMj, _mnozMjDobropisovane, _mnozMj;
  -- zohledneni meny
  select ismenacizi(_idMeny, _polDokl.datvyst) into _ciziMena;
  if(_ciziMena) then
    select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
    _sumZklMen = _sumZkl / _kurz;
    _cenaMj = _sumZklMen / _mnozMj;
  else
    _sumZklMen = 0.0;
    _cenaMj = _sumZkl / _mnozMj;
  end if;
    
  _kopStred = true; 
  if(not compareId(_idStredDoklSklad, _polDokl.idStred)) then 
    _kopStred = false; 
  end if; 
  _kopCinnost = true; 
  if(not compareId(_idCinnostDoklSklad, _polDokl.idCinnost)) then 
    _kopCinnost = false; 
  end if; 
  _kopZakazku = true; 
  if(not compareId(_idZakazkyDoklSklad, _polDokl.idZakazky)) then 
    _kopZakazku = false; 
  end if;  

  select idprimucet into _idZklMdUcet from dbsp where idbsp = _dobropisovanaPolSklad.idbspskl;
  _kopZklMdUcet = false;

  _kopZklDalUcet = false;
  if(_modul like 'FAV') then
    select * into _skupZboz from cskupzboz where idskupzboz = (select idskupzboz from ccenik where idcenik = _dobropisovanaPolSklad.idCenik); 
    if(_skupZboz.idProtiUcetSklV is not null) then 
      -- pokud je ve skupine zbozi nastaven protiucet pro vydej ze skladu pouzije se ten a kopirovani se necha na false; 
      _idZklDalUcet = _skupZboz.idProtiUcetSklV; 
    else 
      -- pokud neni ve skupine zbozi nastaven protiucet tak vemu protiucet z hlavicky a dam kopirovat na true 
      select idProtiUcet into _idZklDalUcet from dDoklSklad where idDoklSklad = _idDoklSklad; 
      _kopZklDalUcet = true;
    end if; 
  else
    _idZklDalUcet = _polDokl.idZklMdUcet; 
  end if;

  select nextval('seq_dpolsklad') into _idPolSklad;   
  insert into dpolsklad(idPolSklad, lastUpdate, idcenik, idbspskl, idkarty, datVyst, datSklad, datUcto, modul, typPolozkyK, idDoklSklad, 
      mnozMj, cenaMj, cenaMjPoriz, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, idmj, 
      nazev, nazevA, nazevB, nazevC, sarze, expirace, datTrvan, datVyroby, cisRad, ucetni,  
      idStred, kopStred, idZakazky, kopZakazku, idMeny, zdrojProFak, idCinnost, kopCinnost, idTypUcOp,
      idPolDobropis) 
    values (_idPolSklad, LOCALTIMESTAMP, _dobropisovanaPolSklad.idcenik, _dobropisovanaPolSklad.idbspskl, _idkarty, _polDokl.datVyst, _dobropisovanaPolSklad.datSklad + interval '0.000001', _polDokl.datVyst, 'SKL', 'typPolozky.katalog', _idDoklSklad, 
      _mnozMj, _cenaMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, _kopZklMdUcet, _kopZklDalUcet, _polDokl.baleniid, _polDokl.mnozBaleni, _dobropisovanaPolSklad.idmj, 
      _dobropisovanaPolSklad.nazev, _dobropisovanaPolSklad.nazevA, _dobropisovanaPolSklad.nazevB, _dobropisovanaPolSklad.nazevC, _dobropisovanaPolSklad.sarze, _dobropisovanaPolSklad.expirace, _dobropisovanaPolSklad.datTrvan, _dobropisovanaPolSklad.datVyroby, _dobropisovanaPolSklad.cisRad, true,  
      _polDokl.idStred, _kopStred, _polDokl.idZakazky, _kopZakazku, _idMeny, false, _polDokl.idCinnost, _kopCinnost, _idTypUcOp,
      _iddobropisovanepolsklad); 

  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK) 
       values (0.0, _iddobropisujicipoldokl, _idPolSklad, _modul, 'SKL', false, _typVazbyK); 

  -- prepocteni sum na dokladu 
  execute sprepoctiSumyDokladu(_idDoklSklad); 

  return _idPolSklad; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION createpolskladdobropis(integer, integer, character varying, character varying) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION dpolskladinsert()
  RETURNS trigger AS
$BODY$
declare
  _rozsirenaPolozka record;
  _typPohybuk character varying;
  _mazatTmpTable boolean;
  _idPolSklad integer;
  _probihaPrepocetSkladu character varying;
  _polSklad record; 
  _pocetMenenychVydejek integer;
  _odsunutaVydejka record;
  _pomocnaVydejka record;
begin
  if(NEW.storno = true) then
    return NEW;
  end if; 
  
  select getglotxvariable('probihaPrepocetSkladu') into _probihaPrepocetSkladu;
  if(_probihaPrepocetSkladu = 'true') then
  else
    -- tento select zjisti kolik je vydejek, ktere by se meli prepocitavat
    select count(idpolsklad) into _pocetMenenychVydejek from dpolsklad ps join ddoklsklad ds 
      on ps.datsklad >= NEW.datSklad and ps.cenyRucne = false and ps.iddoklsklad = ds.iddoklsklad and ds.typpohybuk = 'typPohybu.vydej';
    if(_pocetMenenychVydejek = 0 and NEW.cenyRucne = true) then
      execute sprepoctiskladkartu(NEW.mnozMj, NEW.cenaMj, NEW.sumZkl, NEW.datVyst, NEW.idKarty, NEW.idDoklSklad, NEW.idBspSkl, 1); 
      return NEW;
    end if;

    -- v pripade ze neprobiha prepocet skladu
    -- generuji rozsirene polozky
    select skladGenerujRozsirenePolozky(NEW.datSklad, NEW.idPolSklad, NEW.idKarty) into _mazatTmpTable;

    execute putglotxvariable('zurnalTxName', 'prepocetSkladu');

    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
      if(_rozsirenaPolozka.idPolSklad <> NEW.idPolSklad) then
        if(_rozsirenaPolozka.cenyRucne = true) then
          -- pokud maji byt ceny zadany rucne a nemaji se nikterak menit tak jen zmenime skladovou kartu a jedeme dal
          if(_rozsirenaPolozka.storno = false) then 
            select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
            execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, -1); 
          end if;
        else
          execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
        end if;
      end if;
    end loop;

    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
      if(_rozsirenaPolozka.cenyRucne = true) then
        -- pokud maji byt ceny zadany rucne a nemaji se nikterak menit tak jen zmenime skladovou kartu a jedeme dal
        if(_rozsirenaPolozka.storno = false) then 
          select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
          execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, 1); 
        end if;
      else
        execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
      end if;
    end loop;

    if(_mazatTmpTable) then
      drop table tmp_RozsirenePolozky;
      drop table tmp_SkladoveKarty;
      execute removeglotxvariable('zurnalTxName');
    end if;
  end if;

  select typpohybuk into _typPohybuk from ddoklsklad where iddoklsklad = NEW.iddoklsklad;
  --pokud výdej, tak fifuju vazby
  if (_typPohybuk = 'typPohybu.vydej' or (_typPohybuK = 'typPohybu.prijem' and NEW.mnozMj < 0.0)) then
    if(NEW.idpoldobropis is not null and NEW.idpoldobropis > 0) then
      --_odsunuteVydejky = ARRAY(select idpolskladvydej from sfifovazby where idpolskladprijem = NEW.idPolDobropis);
      --raise exception 'nevim zkusim sem dat nejakej text a uvidime %', _odsunuteVydejky;
      CREATE TEMPORARY TABLE tmp_odsunutevydejky ( 
         idpolskladvydej integer,
         idvyrobnicislo integer,
         kusu numeric(19,6)
      ) WITH (OIDS=TRUE) ON COMMIT DROP; 
      for _odsunutaVydejka in (select * from sfifovazby where idpolskladprijem = NEW.idPolDobropis) loop
        insert into tmp_odsunutevydejky(idpolskladvydej, idvyrobnicislo,kusu)
          values (_odsunutaVydejka.idpolskladvydej, _odsunutaVydejka.idvyrobnicislo, _odsunutaVydejka.kusu);
      end loop;
      delete from sfifovazby where idpolskladprijem = NEW.idpoldobropis;      
    end if;
    
    execute sFifoVydej(NEW.idPolSklad, NEW.idCenik, NEW.idBspSkl, NEW.idKarty, NEW.mnozmj, NEW.cenyRucne);

    if(NEW.idpoldobropis is not null and NEW.idpoldobropis > 0) then
      for _odsunutaVydejka in (select * from tmp_odsunutevydejky) loop
        select * into _pomocnaVydejka from dpolsklad where idpolsklad = _odsunutaVydejka.idpolskladvydej;
        execute sFifoVydej(_pomocnaVydejka.idPolSklad, _pomocnaVydejka.idCenik, _pomocnaVydejka.idBspSkl, _pomocnaVydejka.idKarty, _odsunutaVydejka.kusu, _pomocnaVydejka.cenyRucne); 
      end loop;
      drop table tmp_odsunutevydejky;
    end if;
    
    --execute sPrepoctiSumyDokladu(NEW.idDoklSklad);
  end if;

  if(_probihaPrepocetSkladu = 'true') then
    if(NEW.idPolSklad < 0) then
      _idPolSklad = -NEW.idPolSklad;
    else
      _idPolSklad = NEW.idPolSklad;
    end if;

    execute skladinsertrozsirenoupolozku(_idPolSklad);
  end if;

  execute sprepoctisumydokladu(NEW.idDoklSklad);

  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladinsert() OWNER TO %firmaRole%;

create or replace function skladPrepoctiRozsirenouPolozku(i_idrozsirenepolozky integer, sign integer) returns void as
$BODY$
declare
  _skladKarta record;
  _rozsirenaPolozka record;
  _polSklad record;
  _navazanaPolSklad record;
  _stavMj numeric(19,6);
  _stavTuz numeric(19,6);
  _stavMen numeric(19,6);
  _prumCenaTuz numeric(19,6);
  _prumCenaMen numeric(19,6);
  _pocetNavazanych integer;
  _cenaMj numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _kurzDokladu numeric(19,6);
  _kurzSkladKarty numeric(19,6);
  _isCiziMena boolean;
  _sklfifo boolean;
  _datPosl date; 
  _PoslCenaTuz numeric(19,6);     
  _PoslCenaMen numeric(19,6);     
  _cenaMjSkl numeric(19,6);
  _updateCena boolean;
  _rozpadlaPolSklad record;
  _sumZklProCenaMj numeric(19,6);
  _mnozMjProCenaMj numeric(19,6);
  _cenaMjPoriz numeric(19,6);
  _dobropisovanaPolSklad record;
  _nasobic integer;
  _typPohybuDobropisovanePolozky character varying;
  --_cenaMjNakl numeric(19,6);
begin
  select * into _rozsirenaPolozka from tmp_RozsirenePolozky where idpolsklad = i_idrozsirenepolozky;
  select * into _polSklad from dPolSklad where idPolSklad = i_idrozsirenepolozky;
  if(_polSklad is null) then
    -- muze se stat ze v rozsirenych polozkach je uz polozka ktera byla v ramci transakce smazana
    return;
  end if;
  
  select * into _skladKarta from sKarty where idKarty = _rozsirenaPolozka.idskladkarty;
  select getKurzFromDoklad(_rozsirenaPolozka.idDoklSkladPolozky, _polSklad.datVyst) into _kurzDokladu;

  if(sign = 1) then
    if(_rozsirenaPolozka.skupina = 1) then
      if(_polSklad.mnozMj = 0.0) then
        _stavTuz = _polSklad.cenaMj * _kurzDokladu;
      else
        --select sumZkl into _stavTuz from dpolsklad where idPolSklad = _rozsirenaPolozka.idPolSklad;
        _stavTuz = _polSklad.sumZkl;
      end if;
    else
      -- pokud se jedna o prijemku z prevodky nebo vyroby tak se musi cena nastavit podle navazane vydejky
      _cenaMjSkl = 0.0;
      _sklfifo := (select isfifosklad(_polSklad.datVyst));
      -- menit cenu budeme jen pokud to neni fifo
      _updateCena = not _sklFifo;
      if(_rozsirenaPolozka.skupina = 2 and _polSklad.idPolDobropis is not null) then
        select * into _dobropisovanaPolSklad from dpolsklad where idpolsklad = _polSklad.idPolDobropis;
        select typPohybuK into _typPohybuDobropisovanePolozky from dDoklSklad where idDoklSklad = _dobropisovanaPolSklad.idDoklSklad;
        _nasobic = 1; 
        if(_typPohybuDobropisovanePolozky = 'typPohybu.prijem') then 
          _nasobic = -1; 
        end if; 
        _sumZkl = _nasobic * _dobropisovanaPolSklad.sumZkl; 
        _sumZkl = _sumZkl * _nasobic * _polSklad.mnozMj / _dobropisovanaPolSklad.mnozMj; 

        select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _polSklad.datVyst) into _isCiziMena; 
        if(_isciziMena) then 
          _sumZklMen = _sumZkl / _kurzDokladu; 
          _cenaMj = _sumZklMen / _polSklad.mnozMj; 
        else 
          _sumZklMen = 0.0; 
          _cenaMj = _sumZkl / _polSklad.mnozMj; 
        end if; 
        _cenaMjPoriz = _cenaMj;
        _cenaMjSkl = _cenaMj;
      elsif(_rozsirenaPolozka.skupina = 2 and _rozsirenaPolozka.typPohybuK = 'typPohybu.prijem') then
        select * into _navazanaPolSklad from dPolSklad 
            where idPolSklad = (select idTabA from dvazebtab where idTabB = _rozsirenaPolozka.idPolSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklPrevod');
        if(_navazanaPolSklad is null) then
          _cenaMj = _polSklad.cenaMjNeskl;
          _cenaMjSkl = 0.0;
          _cenaMjPoriz = _cenaMj;
          _sumZkl = _polSklad.cenaMjNeskl * _polSklad.mnozMj;
          for _navazanaPolSklad in (select * from dPolSklad where idPolSklad in 
            (select idTabB from dvazebtab where idTabA = _rozsirenaPolozka.idPolSklad and modulA = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus') )
            loop
            if(_navazanaPolSklad.mnozMj <> 0.0) then
              _cenaMj = _cenaMj + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
              _cenaMjSkl = _cenaMjSkl + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
            else
              raise exception 'mnozMj je 0.0 - 1'; -- TODO vyresit co se bude dit
            end if;
            _sumZkl = _sumZkl + _navazanaPolSklad.sumZkl;

            -- musime zohlednit i pripadne rozpady skladovych polozek
            for _rozpadlaPolSklad in (select * from dPolSklad where idPolSklad in
              (select idpolskladcil from svazbypolsklad where idpolskladzdroj = _navazanaPolSklad.idPolSklad))
            loop
              if(_rozpadlaPolSklad.mnozMj <> 0.0) then
                _cenaMj = _cenaMj + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
                _cenaMjSkl = _cenaMjSkl + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
              else
                raise exception 'mnozMj je 0.0 - 2'; -- TODO vyresit co se bude dit
              end if;
              _sumZkl = _sumZkl + _rozpadlaPolSklad.sumZkl;
            end loop;

            _cenaMjPoriz = _cenaMj;

            -- ovsem pokud se jedna o vyrobu musime zmenit cenu prijmky z vyroby
            _updateCena = true;
          end loop;
          _cenaMj = _cenaMjPoriz + _polSklad.cenaMjNakl;
          _sumZkl = _sumZkl + (_polSklad.mnozMj * _polSklad.cenaMjNakl);
        else
          _sumZklProCenaMj = 0.0;
          _mnozMjProCenaMj = 0.0;
          if((_navazanaPolSklad.mnozMj <> 0.0) and (_polSklad.mnozMj <> 0.0)) then
            _sumZklProCenaMj = _sumZklProCenaMj + _navazanaPolSklad.sumZkl / _kurzDokladu;
            _mnozMjProCenaMj = _mnozMjProCenaMj + _navazanaPolSklad.mnozMj;
            _sumZkl = _navazanaPolSklad.sumZkl; 
          else
            _sumZklProCenaMj = 0.0;
            _mnozMjProCenaMj = 0.0;
            _sumZkl = 0.0; 
          end if;
          -- musime zohlednit i pripadne rozpady skladovych polozek
          for _rozpadlaPolSklad in (select * from dPolSklad where idPolSklad in
            (select idpolskladcil from svazbypolsklad where idpolskladzdroj = _navazanaPolSklad.idPolSklad order by idpolskladcil desc)
            order by idpolsklad desc) 
          loop
            if(_polSklad.mnozMj > _mnozMjProCenaMj) then
              if(_rozpadlaPolSklad.mnozMj <> 0.0) then
                _sumZklProCenaMj = _sumZklProCenaMj + _rozpadlaPolSklad.sumZkl / _kurzDokladu;
                _mnozMjProCenaMj = _mnozMjProCenaMj + _rozpadlaPolSklad.mnozMj;
              else
                raise exception 'mnozMj je 0.0 - 4'; -- TODO vyresit co se bude dit
              end if;
              _sumZkl = _sumZkl + _rozpadlaPolSklad.sumZkl;
            end if;
          end loop;

          if(_mnozMjProCenaMj <> 0.0) then
            _cenaMjPoriz = _sumZklProCenaMj / _mnozMjProCenaMj;
          else
            _cenaMjPoriz = _sumZklProCenaMj;
          end if;
          _cenaMj = _cenaMjPoriz + _polSklad.cenaMjNakl;
          _sumZkl = _sumZkl + (_polSklad.mnozMj * _polSklad.cenaMjNakl);
          --_sumZkl = _polSklad.mnozMj * _cenaMj;
          -- ovsem pokud se jedna o prevodku musime zmenit cenu prijmky z prevodky
          _updateCena = true;
        end if;
        _sumZklMen = 0.0;
        select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _polSklad.datVyst) into _isCiziMena;
        if(_isCiziMena) then
          _sumZklMen = _polSklad.mnozMj * _cenaMj;
        end if;
      else
        _cenaMj = _skladKarta.prumCenaTuz;
        _cenaMjPoriz = _skladKarta.prumCenaTuz;
        if(_kurzDokladu is not null and _kurzDokladu <> 0.0) then
          _cenaMj = _cenaMj / _kurzDokladu;
        end if;
        _sumZkl = _polSklad.mnozMj * _skladKarta.prumCenaTuz;
        _sumZklMen = 0.0;
        select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _polSklad.datVyst) into _isCiziMena;
        if(_isCiziMena) then
          _sumZklMen = _polSklad.mnozMj * _cenaMj; 
        end if;
      end if;

      if (_updateCena) then
        if(_polSklad.cenaMjPoriz <> _cenaMjPoriz or
          _polSklad.cenaMj <> _cenaMj or
          _polSklad.cenaMjSkl <> _cenaMjSkl or
          _polSklad.sumZkl <> _sumZkl or
          _polSklad.sumZklMen <> _sumZklMen
        ) then
          update dPolSklad set
            cenaMjPoriz = _cenaMjPoriz,
            cenaMj = _cenaMj,
            cenaMjSkl = _cenaMjSkl,
            sumZkl = _sumZkl,
            sumZklMen = _sumZklMen
          where idPolSklad = _rozsirenaPolozka.idPolSklad;
        end if;
      end if;

      --execute sprepoctisumydokladu(_rozsirenaPolozka.idDoklSkladPolozky);

      select sumZkl into _stavTuz from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
    end if;
  else
    if(_polSklad.mnozMj = 0.0 and _rozsirenaPolozka.typpohybuk = 'typPohybu.prijem') then
      _stavTuz = _polSklad.cenaMj * _kurzDokladu;
    else
      select sumZkl into _stavTuz from dpolsklad where idPolSklad = i_idrozsirenepolozky;
    end if;
  end if;

  if(_rozsirenaPolozka.typpohybuk = 'typPohybu.vydej') then
    _stavMj = _skladKarta.stavMj - (sign*_polSklad.mnozMj);
    _stavTuz = _skladKarta.stavTuz - (sign*_stavTuz);
  else
    _stavMj = _skladKarta.stavMj + (sign*_polSklad.mnozMj);
    _stavTuz = _skladKarta.stavTuz + (sign*_stavTuz);
  end if;

  if(_stavMj is null) then
    raise exception 'stav mj je null a idpolsklad je % a _skladkarta je % a _polSklad je %',i_idrozsirenepolozky, _skladkarta, _polSklad;
  end if;

  _prumCenaTuz = _skladKarta.prumCenaTuz;
  if(_stavMj <> 0.0) then
    _prumCenaTuz = _stavTuz / _stavMj;
  end if;
  if(_prumCenaTuz is null) then
    raise exception 'prumCenaTuz je null, _stavTuz je %, _stavMj je %', _stavTuz, _stavMj;
  end if; 
 
  _datPosl = _skladKarta.datPosl;
  if(_datPosl is null or _datPosl < _polSklad.datVyst) then
    _datPosl = _polSklad.datVyst;
  end if;

  _poslCenaTuz = _skladKarta.poslCenaTuz;
  _poslCenaMen = _skladKarta.poslCenaMen;
  if(_rozsirenaPolozka.typpohybuk = 'typPohybu.prijem') then
    _PoslCenaTuz := _polSklad.cenaMj * _KurzDokladu;   
    _PoslCenaMen := _polSklad.cenaMj; 
  end if;
 
  _KurzSkladKarty := (select getKurzFromSklad(_skladKarta.idSkladu, _polSklad.datVyst));
  if (not _rozsirenaPolozka.storno) then
    update skarty set 
      stavmj = _stavMj,
      stavMjSPozadavky = _stavMj - _skladKarta.pozadavkyMj,
      stavTuz = _stavTuz,
      stavMen = round(_stavTuz / _kurzSkladKarty, 2),
      prumCenaTuz = _prumCenaTuz,
      prumCenaMen = _prumCenaTuz / _kurzSkladKarty,
      datPosl = _datPosl,
      poslCenaTuz = _poslCenaTuz,
      poslCenaMen = _poslCenaMen,
      lastUpdate = LOCALTIMESTAMP
      where idkarty = _rozsirenaPolozka.idSkladKarty;
  end if;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladPrepoctiRozsirenouPolozku(integer, integer) OWNER TO %firmaRole%;


create or replace function skladInsertRozsirenouPolozku(i_idPolSklad integer) returns void as
$BODY$
declare
  _polSklad record;
  _navazanaPolSklad record;
  _pocetRozsirenePolSklad integer;
  _typPohybuK character varying;
  _pocetProSkupinu integer;
  _skupina integer;
  _idDoklSkladMaster integer;
  _idDoklSkladMasterPom integer;
  _mazatTmpTable boolean;
  _evidVyrCis boolean;
begin
  --select count(*) into _pocetRozsirenePolSklad from tmp_RozsirenePolozky where idPolSklad = i_idPolSklad;
  --if(_pocetRozsirenePolSklad = 0) then
  select 1 into _pocetRozsirenePolSklad from tmp_RozsirenePolozky where idPolSklad = i_idPolSklad limit 1;
  if(_pocetRozsirenePolSklad is null) then
    select * into _polSklad from dPolSklad where idPolSklad = i_idPolSklad;
    select typPohybuK into _typPohybuK from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad;

    -- urceni skupiny do ktere dana polozka patri
    _skupina = 2;
    select 1 into _pocetProSkupinu from dvazebtab
         where (idtabA = _polSklad.idPolSklad and modulA = 'SKL' and (typVazbyK = 'typVazbyDokl.polozkaSklPrevod' or typVazbyK = 'typVazbyDokl.polozkaSklKus'))
             or (idtabB = _polSklad.idPolSklad and modulB = 'SKL' and (typVazbyK = 'typVazbyDokl.polozkaSklPrevod' or typVazbyK = 'typVazbyDokl.polozkaSklKus'))
         limit 1;
    if(_pocetProSkupinu is null and _polSklad.idPolDobropis is null) then
      if(_typPohybuK = 'typPohybu.prijem') then
        _skupina = 1;
      else
        _skupina = 3;
      end if;
    end if;

    -- urceni id skladoveho doklad ktery je master
    _idDoklSkladMaster = _polSklad.idDoklSklad;
    if(_skupina = 2) then
      -- _idDoklSkladMasterPom
      select idtabA into _idDoklSkladMasterPom from dvazebtab where idtabB = _polSklad.idDoklSklad and modulB = 'SKL' and modulA = 'SKL' and 
          (typVazbyK = 'typVazbyDokl.hlavaSklPrevod' or typVazbyK = 'typVazbyDokl.hlavaSklKus');
      if(_idDoklSkladMasterPom is not null) then
        _idDoklSkladMaster = _idDoklSkladMasterPom;
      end if;
    end if;

    -- rekurzi spoustim pro prevodku a kusovnik
    if(_skupina = 2 and _typPohybuK = 'typPohybu.vydej') then
      select * into _navazanaPolSklad from dPolSklad 
        where idPolSklad = (select idTabB from dvazebtab where idTabA = _polSklad.idPolSklad and modulA = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklPrevod');

      -- pokud neni soucasti prevodky tak se jedna o kusovnik
      if(_navazanaPolSklad is null) then
        select * into _navazanaPolSklad from dPolSklad
          where idPolSklad = (select idTabA from dVazebTab where idTabB = _polSklad.idPolSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus');
      end if;
      
      if(_navazanaPolSklad is null) then
        --raise notice 'navazana je null';
      else
        --raise notice 'volam rekurzi';
        select skladGenerujRozsirenePolozky(_navazanaPolSklad.datSklad, _navazanaPolSklad.idPolSklad, _navazanaPolSklad.idKarty ) into _mazatTmpTable;
      end if;
    end if;

    select evidVyrCis into _evidVyrCis from ccenik where idcenik = _polSklad.idcenik;
    -- vlozeni zaznamu o polozce do tmp tabulky
    insert into tmp_RozsirenePolozky (idpolsklad, iddoklskladMaster, datum, skupina, typPohybuK, idskladkarty, mnozMj, /*cenaMj, sumZkl,*/ iddoklskladpolozky, storno, cenyRucne, evidVyrCis, idcenik, idbspskl)
            values (_polSklad.idPolSklad, _idDoklSkladMaster, _polSklad.datSklad, _skupina, _typPohybuK, _polSklad.idkarty, _polSklad.mnozMj, /*_polSklad.cenaMj, _polSklad.sumZkl,*/ _polSklad.idDoklSklad, _polSklad.storno, _polSklad.cenyRucne, _evidVyrCis, _polSklad.idcenik, _polSklad.idbspskl);
  else
    -- do something stupid - kdyz je polozka v seznamu
  end if;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladInsertRozsirenouPolozku(integer) OWNER TO %firmaRole%;


-- zvyseni verze databaze
INSERT INTO dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  VALUES (nextval('seq_dbversion'), 752, 't', %appVersion%, clock_timestamp());
