--Bug 13565 – [WinStrom] Sprava osobních certifikátu

CREATE SEQUENCE seq_woscert
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_woscert OWNER TO %firmaRole%;

CREATE TABLE woscert (
    idoscert integer DEFAULT nextval('seq_woscert'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    typcertk character varying(50) NOT NULL,
    platido timestamp without time zone DEFAULT '2009-01-01 00:00:00'::timestamp without time zone NOT NULL,
    platiod timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    certifikat oid NULL,
    uzivNazev character varying(255),
    certNazev character varying(255) NOT NULL,
    certOrgan character varying(255) NOT NULL,
    cesta character varying(255),
    iduzivatel integer DEFAULT NULL
);


ALTER TABLE public.woscert OWNER TO %firmaRole%;

ALTER TABLE ONLY woscert
    ADD CONSTRAINT woscert_pkey PRIMARY KEY (idoscert);

ALTER TABLE woscert ADD CONSTRAINT woscert_uzivatel_id FOREIGN KEY (iduzivatel) REFERENCES wuzivatel (iduzivatel)    ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX woscert_iduzivatel_index ON woscert USING btree (iduzivatel);

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 83, 't');
