--------------------------------------------------------------------------------
-- Bug 38657 – Štítky k zakázkám
--------------------------------------------------------------------------------

CREATE TABLE wkli_uzakazky (
    idzakazky integer NOT NULL,
    idvybklic integer NOT NULL,

    CONSTRAINT wkli_uzakazky_pkey PRIMARY KEY (idzakazky, idvybklic),
    CONSTRAINT wkli_uzakazky_idzakazky FOREIGN KEY (idzakazky)
      REFERENCES uzakazky (idzakazky) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wkli_uzakazky_idvybklic FOREIGN KEY (idvybklic)
        REFERENCES wvybklice(idvybklice) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE public.wkli_uzakazky OWNER TO %firmaRole%;

CREATE INDEX wkli_uzakazky_idzakazky_index ON wkli_uzakazky USING btree (idzakazky);
CREATE INDEX wkli_uzakazky_idvybklic_index ON wkli_uzakazky USING btree (idvybklic);

-- zvyseni verze databaze
INSERT INTO dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  VALUES (nextval('seq_dbversion'), 859, 't', %appVersion%, clock_timestamp());
