--------------------------------------------------------------------------------
-- Bug 39900 - [WinStrom] Uhrazená záloha a výkaz DE (peněžní deník)
--------------------------------------------------------------------------------

create or replace function uUpdateDanEvid (in _idDoklInt integer) returns void as $$
declare
  doklInt record;
  tempRec record;
  podvoj boolean;
  navazaneDotaz varchar;
  vazeb integer;
  _danEvidK character varying(50);
  _idTypUcOp integer;
  _idStred integer;
  _idZakazky integer;
  nespadaDph character varying(50);
  _idDanEvid integer;
  _idDoklFak integer;
  castka numeric(15,2);
  castkaMen numeric(15,2);
  castkaZbyva numeric(15,2);
  castkaZbyvaMen numeric(15,2);
  castkaOdpocet numeric(15,2);
  castkaOdpocetMen numeric(15,2);
  zapocteno numeric(15,2);
  zapoctenoMen numeric(15,2);
  domaciMena integer;
  ciziMena boolean;
  menpost varchar;
  --MSTEKL
  plnaUhradaMena boolean;  --plna uhrada ruznych men  
  sparovanoKc  numeric(15,2); --nahrada castky v mene u vazeb mezi doklady
  kas integer;
begin
  nespadaDph := 'danEvid.NeDanEvid';

  select * into doklInt from ddoklint where iddoklint = _idDoklInt;
  select podvojucto, idmeny into podvoj, domaciMena from nnastav where (platioddata is null or platioddata <= doklInt.datUcto) 
    order by coalesce(platioddata, '0001-01-01') desc limit 1;
  
  select count(*) into vazeb from dpolint as P where P.iddoklint = _idDoklInt and sumzkl <> 0.0;
  if doklInt.storno = true or vazeb = 0 then
    DELETE from uDanEvid where idDoklInt = doklInt.idDoklInt;
    return;
  end if;
  
  ciziMena := (doklInt.idMeny is not null and domaciMena <> doklInt.idMeny);
  
  if (doklInt.modul not in ('BAN', 'POK')) then
    return;
  end if;
  
  menpost = '';
  if cizimena then
    menpost = 'men';
  end if;

  if (podvoj = false and doklInt.ucetni = true) then
    -- dotaz ktery nalezne veschny navazane faktury a navazane castky
    navazaneDotaz := '(select V.idDoklFak, sum(V.castka) as castka from
         (select idTabA as idDoklFak, castka from dvazebtab as V where typvazbyk in (''typVazbyDokl.uhrada'', ''typVazbyDokl.vazbaZDD'', ''typVazbyDokl.zaucProdejky'') 
                   and idtabb = ' || doklInt.idDoklInt || ' and modulb =''' || doklInt.modul || ''' and storno = false
          union
          select idTabA as idDoklFak, (castka +
            (select coalesce(sum(P.sumzkl' || menpost || ' + P.sumdph' || menpost || '), 0) from dpolfak as P inner join dVazebTab as V2 
                on P.idPolFak = V2.idtaba and V2.typVazbyK = ''typVazbyDokl.odpocetZALOHY'' where V2.idtabb = V.idtaba))
              as castka 
            from dvazebtab as V where typvazbyk = ''typVazbyDokl.uhradaZALOHY'' and idtabb = ' || doklInt.idDoklInt || ' and modulb = ''' || doklInt.modul || ''' and storno = false
              and (select count(*) from dvazebtab where typvazbyk = ''typVazbyDokl.vazbaZDD'' and idtabb = V.idtabb) = 0
          union
          select P.idDoklFak, coalesce(sum(-P.sumzkl' || menpost || ' - P.sumdph' || menpost || '), 0) as castka from dpolfak as P inner join dVazebTab as VOdp 
            on VOdp.idtaba = P.idpolfak and VOdp.typVazbyK = ''typVazbyDokl.odpocetZALOHY''
             inner join dVazebTab as VUhr on VUhr.idtaba = VOdp.idtabb and VUhr.typvazbyk = ''typVazbyDokl.uhradaZALOHY'' where VUhr.idtabb = ' || doklInt.idDoklInt || ' 
                 and VUhr.modulb = ''' || doklInt.modul || ''' and P.storno = false and VUhr.storno = false group by P.idDoklFak
          ) as V group by V.idDoklFak having sum(V.castka) <> 0)';
    
    execute 'select count(*) from ' || navazaneDotaz || ' as D' into vazeb;
  
    if (vazeb = 0) then			-- pro interni doklad neni vazba
      DELETE from uDanEvid where idDoklInt = doklInt.idDoklInt and idDoklFak is not null;           -- vymazeme ty co byli vytvorene pres vazbu
      UPDATE uDanEvid set sumZkl = 0, sumDph = 0, sumZklMen = 0, sumDphMen = 0 where idDoklInt = doklInt.idDoklInt;     -- vynulujeme ostatni
             
      -- DPH
      for _idStred, _idZakazky, castka, castkaMen in select idStred, idZakazky, sum(sumDph), sum(sumDphMen) 
                from dPolInt where idDoklInt = doklInt.idDoklInt and storno = false group by idStred, idZakazky loop
        select idDanEvid into _idDanEvid from uDanEvid where danEvidK = nespadaDph and idDoklInt = doklInt.idDoklInt
          and compareid(_idStred, idStred) and compareid(_idZakazky, idZakazky);  -- zjistime zda uz zaznam existuje
        
        if (_idDanEvid is null) then              -- zaznam jeste nebyl vytvoren
          INSERT into uDanEvid (danEvidK, sumDph, sumDphMen, kurz, kurzMnozstvi, idDoklInt, idMeny, idStred, idZakazky) 
            VALUES (nespadaDph, castka, castkaMen, doklInt.kurz, doklInt.kurzmnozstvi, doklInt.idDoklInt, doklInt.idMeny, _idStred, _idZakazky);
        else                                     -- zaznam jiz byl vytvoren, vynulujeme i zaklad pokud by jiz nebyl pouzit
          UPDATE uDanEvid SET sumDph = castka, sumDphMen = castkaMen, sumZkl = 0, sumZklMen = 0, kurz = doklInt.kurz, 
            kurzMnozstvi = doklInt.kurzmnozstvi, idMeny = doklInt.idMeny, idDoklFak = null WHERE idDanEvid = _idDanEvid;
        end if;
      end loop;
    
      -- Zaklad
      for _danEvidK, _idTypUcOp, _idStred, _idZakazky, castka, castkaMen in select danEvidK, idTypUcOp, idStred, idZakazky, sum(sumZkl), sum(sumZklMen) 
                from dPolInt where idDoklInt = doklInt.idDoklInt and storno = false group by danEvidK, idTypUcOp, idStred, idZakazky loop 
        select idDanEvid into _idDanEvid from uDanEvid where danEvidK = _danEvidK and idDoklInt = doklInt.idDoklInt
          and compareid(_idTypUcOp, idTypUcOp) and compareid(_idStred, idStred) and compareid(_idZakazky, idZakazky);  -- zjistime zda uz zaznam existuje
        
        if (_idDanEvid is null) then              -- zaznam jeste nebyl vytvoren
          INSERT into uDanEvid (danEvidK, idTypUcOp, idStred, idZakazky, sumZkl, sumZklMen, kurz, kurzMnozstvi, idDoklInt, idMeny) 
            VALUES (_danEvidK, _idTypUcOp, _idStred, _idZakazky, castka, castkaMen, doklInt.kurz, doklInt.kurzmnozstvi, doklInt.idDoklInt, doklInt.idMeny);
        else                                     -- zaznam jiz byl vytvoren
          UPDATE uDanEvid SET sumZkl = castka, sumZklMen = castkaMen, kurz = doklInt.kurz, kurzMnozstvi = doklInt.kurzmnozstvi,
            idMeny = doklInt.idMeny, idDoklFak = null WHERE idDanEvid = _idDanEvid;
        end if;
      end loop; 
    else				            -- pro interni doklad je vazba
      DELETE from uDanEvid where idDoklInt = doklInt.idDoklInt and idDoklFak is null;           -- smazeme polozky co nemaji vazbu na fakturu
      UPDATE uDanEvid set sumZkl = 0, sumDph = 0, sumZklMen = 0, sumDphMen = 0 where idDoklInt = doklInt.idDoklInt;     -- vynulujeme ostatni
      
      drop table if exists tempDanEvid;
      
      CREATE TEMPORARY TABLE tempDanEvid
        (idDoklFak integer NOT NULL,
         danEvidK character varying(50),
         idTypUcOp integer,
         idStred integer,
         idZakazky integer,
         dan boolean DEFAULT false,
         kUhrade numeric(15,2) DEFAULT 0.0 NOT NULL,
         kUhradeMen numeric(15,2) DEFAULT 0.0 NOT NULL,
         uhrazeno numeric(15,2) DEFAULT 0.0 NOT NULL,
         uhrazenoMen numeric(15,2) DEFAULT 0.0 NOT NULL,
         vazbaFak numeric(15,2) DEFAULT 0.0 NOT NULL
        );

      for tempRec in execute 'select * from ' || navazaneDotaz || ' as D' loop
        _idDoklFak = tempRec.idDoklFak;
        castka = tempRec.castka;
      
        select * into tempRec from dDoklFak where idDoklFak = _idDoklFak;

        plnaUhradaMena := false; 
        if ((ciziMena = true and (tempRec.idMeny is null or tempRec.idMeny <> doklInt.idMeny)) 
         or (ciziMena = false and tempRec.idMeny is not null and tempRec.idMeny <> domaciMena)) then
          -- MSTEKL  raise exception 'uUpdateDanEvid: Nesouhlasi meny dokladu';  MSTEKL
          plnaUhradaMena := true; 
        end if; 

        sparovanoKc := castka; 
        if (plnaUhradaMena = true) then 
        -- MSTEKL  zacnu se k uhrade chovat jako k parovani v tuzemske mene 
           sparovanoKc := doklInt.sumCelkem ;
           ciziMena := false;
        end if;
      
        select count(*) into kas from dvazebtab as V2 where V2.idtabb = _idDoklFak and typVazbyK = 'typVazbyDokl.zaucProdejky' and modulb = 'PHL';

        if kas = 0 then 
          -- zjistime kolik je treba na fakture uhradit a kolik je uhrazeno
          insert into tempDanEvid (idDoklFak, danEvidK, idTypUcOp, idStred, idZakazky, vazbaFak, kUhrade, kUhradeMen, uhrazeno, uhrazenoMen) 
            select _idDoklFak, danEvidK, idTypUcOp, idStred, idZakazky, sparovanoKc, sum(sumZkl) + sum(case when C.jedph = false then sumDph else 0 end), sum(sumZklMen) + sum(case when C.jedph = false then sumDphMen else 0 end), 
                 (select coalesce(sum(sumZkl),0) from uDanEvid where idDoklFak = _idDoklFak and danEvidK = P.danEvidK and 
                   compareid(P.idTypUcOp, idTypUcOp) and compareid(P.idStred, idStred) and compareid(P.idZakazky, idZakazky)),
                 (select coalesce(sum(sumZklMen),0) from uDanEvid where idDoklFak = _idDoklFak and danEvidK = P.danEvidK and
                   compareid(P.idTypUcOp, idTypUcOp) and compareid(P.idStred, idStred) and compareid(P.idZakazky, idZakazky))
             from dPolFak as P left outer join uclendph as C on P.idclendph = C.idclendph where idDoklFak = _idDoklFak and storno = false
               and typPolozkyK not in ('typPolozky.odpocetZalohy') group by danEvidK, idTypUcOp, idStred, idZakazky;
           
          -- dan
          insert into tempDanEvid (idDoklFak, danEvidK, dan, idStred, idZakazky, vazbaFak, kUhrade, kUhradeMen, uhrazeno, uhrazenoMen) -- dan si oznacime jako null
            select _idDoklFak, null, true, idStred, idZakazky, sparovanoKc, sum(sumDph), sum(sumDphMen),
                 (select coalesce(sum(sumDph),0) from uDanEvid where idDoklFak = _idDoklFak and 
                   compareid(P.idStred, idStred) and compareid(P.idZakazky, idZakazky)),                             -- uhrazena dan dokladu
                 (select coalesce(sum(sumDphMen),0) from uDanEvid where idDoklFak = _idDoklFak and 
                   compareid(P.idStred, idStred) and compareid(P.idZakazky, idZakazky))
             from dPolFak as P left outer join uclendph as C on P.idclendph = C.idclendph where idDoklFak = _idDoklFak and storno = false
               and ((C.typplnenik is null) or (C.jedph = true and C.typplnenik not in ('typPlneni.prijataRCH', 'typPlneni.uskutecnenaRCH', 'typPlneni.obojiRCH')))
               and typPolozkyK not in ('typPolozky.odpocetZalohy') group by idStred, idZakazky;
        else
          -- zjistime kolik je treba na fakture uhradit a kolik je uhrazeno
          insert into tempDanEvid (idDoklFak, danEvidK, idTypUcOp, idStred, idZakazky, vazbaFak, kUhrade, kUhradeMen, uhrazeno, uhrazenoMen) 
            select _idDoklFak, danEvidK, idTypUcOp, idStred, idZakazky, sparovanoKc, sum(sumZkl) + sum(case when C.jedph = false then sumDph else 0 end), sum(sumZklMen) + sum(case when C.jedph = false then sumDphMen else 0 end), 
                 (select coalesce(sum(sumZkl),0) from uDanEvid where idDoklFak = _idDoklFak and danEvidK = P.danEvidK and 
                   compareid(P.idTypUcOp, idTypUcOp) and compareid(P.idStred, idStred) and compareid(P.idZakazky, idZakazky)),
                 (select coalesce(sum(sumZklMen),0) from uDanEvid where idDoklFak = _idDoklFak and danEvidK = P.danEvidK and
                   compareid(P.idTypUcOp, idTypUcOp) and compareid(P.idStred, idStred) and compareid(P.idZakazky, idZakazky))
             from dPolFak as P left outer join uclendph as C on P.idclendph = C.idclendph where idDoklFak in (select idtaba from dvazebtab where idtabb = _idDoklFak and typVazbyK = 'typVazbyDokl.zaucProdejky' and modulb = 'PHL') 
               and storno = false and typPolozkyK not in ('typPolozky.odpocetZalohy') group by danEvidK, idTypUcOp, idStred, idZakazky;
           
          -- dan
          insert into tempDanEvid (idDoklFak, danEvidK, dan, idStred, idZakazky, vazbaFak, kUhrade, kUhradeMen, uhrazeno, uhrazenoMen) -- dan si oznacime jako null
            select _idDoklFak, null, true, idStred, idZakazky, sparovanoKc, sum(sumDph), sum(sumDphMen),
                 (select coalesce(sum(sumDph),0) from uDanEvid where idDoklFak = _idDoklFak and 
                   compareid(P.idStred, idStred) and compareid(P.idZakazky, idZakazky)),                             -- uhrazena dan dokladu
                 (select coalesce(sum(sumDphMen),0) from uDanEvid where idDoklFak = _idDoklFak and 
                   compareid(P.idStred, idStred) and compareid(P.idZakazky, idZakazky))
             from dPolFak as P left outer join uclendph as C on P.idclendph = C.idclendph where idDoklFak in (select idtaba from dvazebtab where idtabb = _idDoklFak and typVazbyK = 'typVazbyDokl.zaucProdejky' and modulb = 'PHL')
               and storno = false
               and ((C.typplnenik is null) or (C.jedph = true and C.typplnenik not in ('typPlneni.prijataRCH', 'typPlneni.uskutecnenaRCH', 'typPlneni.obojiRCH')))
               and typPolozkyK not in ('typPolozky.odpocetZalohy') group by idStred, idZakazky;
        end if;
      end loop;
      
      zapocteno := 0;
      zapoctenoMen := 0;
      
      for _idDoklFak,castka in select idDoklFak,vazbaFak from tempDanEvid group by idDoklFak,vazbaFak loop           -- prochazime navazene faktury
        castkaMen := castka;

        for tempRec in select * from tempDanEvid where idDoklFak = _idDoklFak order by (case when (kUhrade-uhrazeno) < 0 then -1 else 1 end), -- napred zaporny 
                                                                                              dan desc, danEvidK desc loop    -- sestupne aby null (dan) bylo prvni
        
          if ((ciziMena = false and castka <> 0) or (ciziMena = true and castkaMen <> 0)) then                -- pokud jeste mame nejakou castku
            castkaZbyva := tempRec.kUhrade - tempRec.uhrazeno;
            castkaZbyvaMen := tempRec.kUhradeMen - tempRec.uhrazenoMen;
            
            if ((ciziMena = false and castkaZbyva <> 0) or (ciziMena = true and castkaZbyvaMen <> 0)) then    -- pokud na aktualnim zaznamu zbyva neco uhradit
              if ((ciziMena = false and castka > 0 and castkaZbyva > 0) or (ciziMena = true and castkaMen > 0 and castkaZbyvaMen > 0)) then
                castkaOdpocet := minValue(castka, castkaZbyva);      -- spocteme kolik budeme "odpocitavat"
                castkaOdpocetMen := minValue(castkaMen, castkaZbyvaMen);
              else
                if ((ciziMena = false and castka < 0 and castkaZbyva < 0) or (ciziMena = true and castkaMen < 0 and castkaZbyvaMen < 0)) then
                  castkaOdpocet := maxValue(castka, castkaZbyva);
                  castkaOdpocetMen := maxValue(castkaMen, castkaZbyvaMen);
                else
                  castkaOdpocet := castkaZbyva;
                  castkaOdpocetMen := castkaZbyvaMen;
                end if;
              end if;
              
              castka := castka - castkaOdpocet;                    -- odebereme to z odpocitatelne castky
              castkaMen := castkaMen - castkaOdpocetMen;
              zapocteno := zapocteno + castkaOdpocet;
              zapoctenoMen := zapoctenoMen + castkaOdpocetMen;
              
              if (ciziMena = true) then
                castkaOdpocet := castkaOdpocetMen * doklInt.kurz / doklInt.kurzmnozstvi;
              else
                castkaOdpocetMen := 0;
              end if;
              
              if (tempRec.dan) then        -- pokud se jedna o dan
                select idDanEvid into _idDanEvid from uDanEvid where idDoklInt = doklInt.idDoklInt and idDoklFak = tempRec.idDoklFak and danEvidK = nespadaDph
                  and compareid(tempRec.idStred, idStred) and compareid(tempRec.idZakazky, idZakazky);  -- zjistime zda uz zaznam existuje
                
                if (_idDanEvid is null) then            -- zaznam jeste nebyl vytvoren
                  INSERT into uDanEvid (danEvidK, idStred, idZakazky, sumDph, sumDphMen, kurz, kurzMnozstvi, idDoklInt, idDoklFak, idMeny) 
                    VALUES (nespadaDph, tempRec.idStred, tempRec.idZakazky, castkaOdpocet, castkaOdpocetMen, doklInt.kurz, doklInt.kurzmnozstvi, doklInt.idDoklInt, tempRec.idDoklFak, doklInt.idMeny);
                else                                    -- zaznam jiz byl vytvoren
                  UPDATE uDanEvid SET sumDph = castkaOdpocet, sumDphMen = castkaOdpocetMen, 
                    kurz = doklInt.kurz, kurzMnozstvi = doklInt.kurzmnozstvi, idMeny = doklInt.idMeny WHERE idDanEvid = _idDanEvid;
                end if;
              else                                      -- pokud se nejedna o dan
                select idDanEvid into _idDanEvid from uDanEvid where idDoklInt = doklInt.idDoklInt and idDoklFak = tempRec.idDoklFak 
                  and ((tempRec.danEvidK is null and danEvidK is null) or (danEvidK = tempRec.danEvidK))
                  and compareid(tempRec.idTypUcOp, idTypUcOp) and compareid(tempRec.idStred, idStred) and compareid(tempRec.idZakazky, idZakazky);  -- zjistime zda uz zaznam existuje
                
                if (_idDanEvid is null) then            -- zaznam jeste nebyl vytvoren
                  INSERT into uDanEvid (danEvidK, idTypUcOp, idStred, idZakazky, sumZkl, sumZklMen, kurz, kurzMnozstvi, idDoklInt, idDoklFak, idMeny) 
                    VALUES (tempRec.danEvidK, tempRec.idTypUcOp, tempRec.idStred, tempRec.idZakazky, castkaOdpocet, castkaOdpocetMen, doklInt.kurz, doklInt.kurzmnozstvi, doklInt.idDoklInt, tempRec.idDoklFak, doklInt.idMeny);
                else                                    -- zaznam jiz byl vytvoren
                  UPDATE uDanEvid SET sumZkl = castkaOdpocet, sumZklMen = castkaOdpocetMen, 
                    kurz = doklInt.kurz, kurzMnozstvi = doklInt.kurzmnozstvi, idMeny = doklInt.idMeny WHERE idDanEvid = _idDanEvid;
                end if;
              end if;
            
              --select idDanEvid into _idDanEvid from uDanEvid where idDoklInt = doklInt.idDoklInt and idDoklFak = tempRec.idDoklFak and
              --   ((tempRec.danEvidK is not null and danEvidK = tempRec.danEvidK) or (tempRec.danEvidK is null and danEvidK = nespadaDph));  -- zjistime zda uz zaznam existuje
            end if;
          end if;
        
        end loop;
        
        if ((ciziMena = false and castka <> 0) or (ciziMena = true and castkaMen <> 0)) then
          if (ciziMena = true) then
            castka := castkaMen * doklInt.kurz / doklInt.kurzmnozstvi;
          else
            castkaMen := 0;
          end if;
        
          -- vybereme typ pro ktery je nejvetsi castka, pokud takovy neni nechame castku viset, protoze se jedna o celou castku
          select danEvidK, idTypUcOp, idStred, idZakazky into _danEvidK, _idTypUcOp, _idStred, _idZakazky from uDanEvid 
            where idDoklFak = _idDoklFak order by sumZkl desc limit 1;
          if _danEvidK is not null then
            INSERT into uDanEvid (danEvidK, idTypUcOp, idStred, idZakazky, sumZkl, sumZklMen, kurz, kurzMnozstvi, idDoklInt, idMeny) 
              VALUES (_danEvidK, _idTypUcOp, _idStred, _idZakazky, castka, castkaMen, doklInt.kurz, doklInt.kurzmnozstvi, doklInt.idDoklInt, doklInt.idMeny);
            zapocteno = zapocteno + castka;
            zapoctenoMen = zapoctenoMen + castkaMen;
          end if;
        end if;
      end loop;
      
      if ((ciziMena = false and zapocteno < doklInt.sumCelkem) or (ciziMena = true and zapoctenoMen < doklInt.sumCelkemMen)) then     -- pokud neni komplet sparovan
        castka = doklInt.sumCelkem - zapocteno;
        castkaMen = doklInt.sumCelkemMen - zapoctenoMen;
        if (ciziMena = true) then
          castka := castkaMen * doklInt.kurz / doklInt.kurzmnozstvi;
        else
          castkaMen := 0;
        end if;
        
        -- vybereme typ pro ktery je nejvetsi castka, pokud takovy neni nechame castku viset, protoze se jedna o celou castku
        select danEvidK, idTypUcOp, idStred, idZakazky into _danEvidK, _idTypUcOp, _idStred, _idZakazky from uDanEvid 
          where idDoklInt = doklInt.idDoklInt order by sumZkl desc limit 1;
        if _danEvidK is not null then
          INSERT into uDanEvid (danEvidK, idTypUcOp, idStred, idZakazky, sumZkl, sumZklMen, kurz, kurzMnozstvi, idDoklInt, idMeny) 
            VALUES (_danEvidK, _idTypUcOp, _idStred, _idZakazky, castka, castkaMen, doklInt.kurz, doklInt.kurzmnozstvi, doklInt.idDoklInt, doklInt.idMeny);
        end if;
        
      end if;
      
    end if;
  end if;
  
  DELETE from uDanEvid WHERE idDoklInt = doklInt.idDoklInt and sumZkl = 0 and sumZklMen = 0 and sumDph = 0 and sumDphMen = 0;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.uUpdateDanEvid(integer) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 867, 't', %appVersion%, clock_timestamp());
