--------------------------------------------------------------------------------
-- Bug 41275 - Přepočet skladu špatně určí cenu na dobropisech u FIFO skladu
--------------------------------------------------------------------------------

-- drop FUNCTION sfifoDobropis(integer, integer, integer, integer, integer, numeric(19,6), boolean)

-- funkce, která zavolá fifo výdej, ale naví - pokud se jedná o dobropis, provede zahrnutí dobropisu a až pak výdej 
 CREATE OR REPLACE FUNCTION sfifoDobropis(s_idpoldobropis integer, s_idPolSklad integer, s_idCenik integer, s_idBspSkl integer, s_idKarty integer, s_mnozmj numeric(19,6), s_cenyRucne boolean)
  RETURNS void AS
$BODY$ 
declare 
  _odsunutaVydejka record;
  _pomocnaVydejka record;
   
begin 
 
    if(s_idpoldobropis is not null and s_idpoldobropis > 0) then 
      --_odsunuteVydejky = ARRAY(select idpolskladvydej from sfifovazby where idpolskladprijem = NEW.idPolDobropis); 
      --raise exception 'nevim zkusim sem dat nejakej text a uvidime %', _odsunuteVydejky; 
      CREATE TEMPORARY TABLE tmp_odsunutevydejky (  
         idpolskladvydej integer, 
         idvyrobnicislo integer, 
         kusu numeric(19,6) 
      ) WITH (OIDS=TRUE) ON COMMIT DROP;  
      for _odsunutaVydejka in (select * from sfifovazby where idpolskladprijem = s_idpoldobropis) loop 
        insert into tmp_odsunutevydejky(idpolskladvydej, idvyrobnicislo,kusu) 
          values (_odsunutaVydejka.idpolskladvydej, _odsunutaVydejka.idvyrobnicislo, _odsunutaVydejka.kusu); 
      end loop; 
      delete from sfifovazby where idpolskladprijem = s_idpoldobropis;       
    end if; 
     
    execute sFifoVydej(s_idPolSklad, s_idCenik, s_idBspSkl, s_idKarty, s_mnozmj, s_cenyRucne); 
 
    if(s_idpoldobropis is not null and s_idpoldobropis > 0) then 
      for _odsunutaVydejka in (select * from tmp_odsunutevydejky) loop 
        select * into _pomocnaVydejka from dpolsklad where idpolsklad = _odsunutaVydejka.idpolskladvydej; 
        execute sFifoVydej(_pomocnaVydejka.idPolSklad, _pomocnaVydejka.idCenik, _pomocnaVydejka.idBspSkl, _pomocnaVydejka.idKarty, _odsunutaVydejka.kusu, _pomocnaVydejka.cenyRucne);  
      end loop; 
      drop table tmp_odsunutevydejky; 
    end if;
    
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION sfifoDobropis(integer, integer, integer, integer, integer, numeric(19,6), boolean)
  OWNER TO %firmaRole%;     

-- Function: skladinsertrozsirenoupolozku(integer)

-- DROP FUNCTION skladinsertrozsirenoupolozku(integer);

CREATE OR REPLACE FUNCTION skladinsertrozsirenoupolozku(i_idpolsklad integer)
  RETURNS void AS
$BODY$ 
declare 
  _polSklad record; 
  _navazanaPolSklad record; 
  _pocetRozsirenePolSklad integer; 
  _typPohybuK character varying; 
  _pocetProSkupinu integer; 
  _skupina integer; 
  _idDoklSkladMaster integer; 
  _idDoklSkladMasterPom integer; 
  _mazatTmpTable boolean; 
  _evidVyrCis boolean; 
begin 
  --select count(*) into _pocetRozsirenePolSklad from tmp_RozsirenePolozky where idPolSklad = i_idPolSklad; 
  --if(_pocetRozsirenePolSklad = 0) then 
  select 1 into _pocetRozsirenePolSklad from tmp_RozsirenePolozky where idPolSklad = i_idPolSklad limit 1; 
  if(_pocetRozsirenePolSklad is null) then 
    select * into _polSklad from dPolSklad where idPolSklad = i_idPolSklad; 
    select typPohybuK into _typPohybuK from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad; 
 
    -- urceni skupiny do ktere dana polozka patri 
    _skupina = 2; 
    select 1 into _pocetProSkupinu from dvazebtab 
         where (idtabA = _polSklad.idPolSklad and modulA = 'SKL' and (typVazbyK = 'typVazbyDokl.polozkaSklPrevod' or typVazbyK = 'typVazbyDokl.polozkaSklKus')) 
             or (idtabB = _polSklad.idPolSklad and modulB = 'SKL' and (typVazbyK = 'typVazbyDokl.polozkaSklPrevod' or typVazbyK = 'typVazbyDokl.polozkaSklKus')) 
         limit 1; 
    if(_pocetProSkupinu is null and _polSklad.idPolDobropis is null) then 
      if((_typPohybuK = 'typPohybu.prijem' and _polSklad.mnozMj >= 0.0) or (_typPohybuK = 'typPohybu.vydej' and _polSklad.mnozMj < 0.0)) then  
        _skupina = 1; 
      else 
        _skupina = 3; 
      end if; 
    end if; 
 
    -- urceni id skladoveho doklad ktery je master 
    _idDoklSkladMaster = _polSklad.idDoklSklad; 
    if(_skupina = 2) then 
      -- _idDoklSkladMasterPom 
      select idtabA into _idDoklSkladMasterPom from dvazebtab where idtabB = _polSklad.idDoklSklad and modulB = 'SKL' and modulA = 'SKL' and  
          (typVazbyK = 'typVazbyDokl.hlavaSklPrevod' or typVazbyK = 'typVazbyDokl.hlavaSklKus'); 
      if(_idDoklSkladMasterPom is not null) then 
        _idDoklSkladMaster = _idDoklSkladMasterPom; 
      end if; 
    end if; 
 
    -- rekurzi spoustim pro prevodku a kusovnik 
    if(_skupina = 2 and _typPohybuK = 'typPohybu.vydej') then 
      select * into _navazanaPolSklad from dPolSklad  
        where idPolSklad = (select idTabB from dvazebtab where idTabA = _polSklad.idPolSklad and modulA = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklPrevod'); 
 
      -- pokud neni soucasti prevodky tak se jedna o kusovnik 
      if(_navazanaPolSklad is null) then 
        select * into _navazanaPolSklad from dPolSklad 
          where idPolSklad = (select idTabA from dVazebTab where idTabB = _polSklad.idPolSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus'); 
      end if; 
       
      if(_navazanaPolSklad is null) then 
        --raise notice 'navazana je null'; 
      else 
        --raise notice 'volam rekurzi'; 
        select skladGenerujRozsirenePolozky(_navazanaPolSklad.datSklad, _navazanaPolSklad.idPolSklad, _navazanaPolSklad.idKarty ) into _mazatTmpTable; 
      end if; 
    end if; 
 
    select evidVyrCis into _evidVyrCis from ccenik where idcenik = _polSklad.idcenik; 
    -- vlozeni zaznamu o polozce do tmp tabulky 
    insert into tmp_RozsirenePolozky (idpolsklad,idpoldobropis, iddoklskladMaster, datum, datVyst, skupina, typPohybuK, idskladkarty, mnozMj, /*cenaMj, sumZkl,*/ iddoklskladpolozky, storno, cenyRucne, evidVyrCis, idcenik, idbspskl) 
            values (_polSklad.idPolSklad, _polSklad.idpoldobropis,  _idDoklSkladMaster, _polSklad.datSklad, _polSklad.datVyst, _skupina, _typPohybuK, _polSklad.idkarty, _polSklad.mnozMj, /*_polSklad.cenaMj, _polSklad.sumZkl,*/ _polSklad.idDoklSklad, _polSklad.storno, _polSklad.cenyRucne, _evidVyrCis, _polSklad.idcenik, _polSklad.idbspskl); 
  else 
    -- do something stupid - kdyz je polozka v seznamu 
  end if; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION skladinsertrozsirenoupolozku(integer)
    OWNER TO %firmaRole%;

    
    
-- Function: skladgenerujrozsirenepolozky(timestamp without time zone, integer, integer)

-- DROP FUNCTION skladgenerujrozsirenepolozky(timestamp without time zone, integer, integer);

CREATE OR REPLACE FUNCTION skladgenerujrozsirenepolozky(
    i_datum timestamp without time zone,
    i_idpolsklad integer,
    i_idskladkarty integer)
  RETURNS boolean AS
$BODY$ 
declare 
  tmp_skladovekarty_exists boolean; 
  tmp_rozsirenepolozky_exists boolean; 
  _polSklad record; 
  _skladKarta record; 
  _pocetSkladKarty integer; 
  _result boolean; 
  _idUcetObd integer; 
begin 
  -- pokud se zde nebyli tabulky vytvoreny tak se vrati false a pokud ano tak se true 
  _result = false; 
 
  -- vytvoreni temporary tabulky pro ulozeni seznamu skladovych karet na kterych dochazi k prepoctu 
  tmp_skladovekarty_exists := (select istableexist('tmp_SkladoveKarty')); 
  if(tmp_skladovekarty_exists <> true) then 
    --raise exception 'tmp_skladoveKarty se vytvari'; 
    CREATE TEMPORARY TABLE tmp_SkladoveKarty ( 
      idskladkarty integer 
    ) WITH (OIDS=TRUE) ON COMMIT DROP; 
 
    CREATE INDEX tmp_SkladoveKarty_idskladkarty_index ON tmp_SkladoveKarty USING btree (idskladkarty ); 
  end if; 
 
  -- vytvoreni temporary tabulky pro ulozeni seznamu polozek, ktere budou prepocitavat skladove karty 
  tmp_rozsirenepolozky_exists := (select istableexist('tmp_RozsirenePolozky')); 
  if(tmp_rozsirenepolozky_exists <> true) then 
    CREATE TEMPORARY TABLE tmp_RozsirenePolozky ( 
      idpolsklad integer, 
      idpoldobropis integer,
      iddoklskladMaster integer, 
      iddoklskladpolozky integer, 
      datum timestamp,  
      datVyst date, 
      skupina integer, 
      typPohybuK character varying, 
      idskladkarty integer, 
      storno boolean, 
      cenyRucne boolean, 
      evidVyrCis boolean, 
      idcenik integer, 
      idbspskl integer, 
      mnozMj numeric(19,6) 
      --cenaMj numeric(19,6), 
      --sumZkl numeric(19,6) 
    ) WITH (OIDS=TRUE) ON COMMIT DROP; 
 
    CREATE INDEX tmp_RozsirenePolozky_idpolsklad_index ON tmp_RozsirenePolozky USING btree (idpolsklad ); 
     
    -- tabulky zde byli vytvoreny tim padem se musi vracet true   
    _result = true; 
  end if; 
   
  if(i_idSkladKarty is not null and i_idSkladKarty <> -1) then 
    -- pokud se jedna o prepocet po vlozeni jedna polozky nebo o rekurzi tak se vse dela jen s jednou skladovou kartou 
    --select count(*) into _pocetSkladKarty from tmp_SkladoveKarty where idskladkarty = i_idSkladKarty; 
    --if(_pocetSkladKarty = 0) then 
    select 1 into _pocetSkladKarty from tmp_SkladoveKarty where idskladkarty = i_idSkladKarty limit 1; 
    if (_pocetSkladKarty is null) then 
      insert into tmp_SkladoveKarty (idskladkarty) values (i_idSkladKarty); 
      for _polSklad in (select * from dpolsklad where datSklad >= i_datum and idkarty = i_idSkladKarty) loop 
        execute skladInsertRozsirenouPolozku(_polSklad.idPolSklad); 
      end loop; 
    else 
      -- do something stupid - kdyz je skladkarta v seznamu 
    end if; 
  else 
    -- pokud se jedna o celkovy prepocet skladu tak do tmp tabulky skladovych karet dam vsechny pro dane obdobi 
    select iducetobdobi into _idUcetObd from nucetobdobi where platioddata <= i_datum and platidodata >= i_datum; 
    for _skladKarta in (select * from skarty where iducetobdobi = _idUcetObd) loop 
      select 1 into _pocetSkladKarty from tmp_SkladoveKarty where idskladkarty = _skladKarta.idKarty limit 1; 
      if (_pocetSkladKarty is null) then 
        insert into tmp_SkladoveKarty(idskladkarty) values (_skladKarta.idKarty); 
      end if; 
      --for _polSklad in (select * from dpolsklad where datSklad >= i_datum and idkarty = _skladKarta.idKarty) loop 
      -- tento for cyklus je spatne protoze pokud jsou spatna data (dat vyst je 2010 a karta 2011) tak k prepoctu nedojde 
      for _polSklad in (select * from dpolsklad where idkarty = _skladKarta.idKarty) loop 
        execute skladInsertRozsirenouPolozku(_polSklad.idPolSklad); 
      end loop; 
    end loop; 
  end if; 
 
  return _result; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION skladgenerujrozsirenepolozky(timestamp without time zone, integer, integer)
    OWNER TO %firmaRole%;


  -- Function: sprepoctisklad(integer, integer)

-- DROP FUNCTION sprepoctisklad(integer, integer);

CREATE OR REPLACE FUNCTION sprepoctisklad(
    i_ucetobd integer,
    i_idskladkarty integer)
  RETURNS void AS
$BODY$ 
declare 
  _rozsirenaPolozka record; 
  --_zaznam record; 
  _vyrobniCislo record; 
  _pocatek_ucetobd date; 
  _konec_ucetobd date; 
  _evidVyrCis boolean; 
  _mazatTmpTable boolean; 
  _citac integer; 
  _pocetPred integer; 
  _pocetPo integer; 
  _polSklad record;
  _odsunutaVydejka record; 
  _pomocnaVydejka record; 
begin 
  -- pokud nechceme volat prepocet celeho skladu predame parametr i_idskladkarta 
  -- pokud chceme volat prepocet celeho skladu dame za parametr i_idskladkarta -1 
 
  execute putglotxvariable('zurnalTxName', 'prepocetSkladuFull'); 
  execute putglotxvariable('probihaPrepocetSkladu', 'true'); 
 
  -- nacteni datumu zacatku ucetniho obdobi 
  select platioddata, platidodata into _pocatek_ucetobd, _konec_ucetobd from nucetobdobi where iducetobdobi = i_ucetobd; 
 
  -- nagenerovani pomocnych tabulek 
  select skladGenerujRozsirenePolozky(_pocatek_ucetobd, -1, i_idskladkarty) into _mazatTmpTable; 
 
  --select count(*) into _pocetPred from tmp_RozsirenePolozky; 
  --raise notice 'pocet pred %', _pocetPred; 
  
  -- smazani tabulky fifo vazeb 
  /*delete from sfifovazby where idpolskladvydej in 
    (select idpolsklad from dpolsklad where 
            datVyst >= _pocatek_ucetobd); */ 
 
  if(i_idskladkarty is not null and i_idskladkarty = -1) then 
    delete from sfifovazby fv using dpolsklad ps 
      where fv.idpolskladvydej = ps.idpolsklad and ps.datVyst >= _pocatek_ucetobd; 
 
    -- fifo vazby maji constrainty toto neni potreba 
    /*delete from sfifovazby f  
      where f.idpolskladvydej not in (select p.idpolsklad from dpolsklad p); */ 
 
    -- provedu fifovani rozsirenych polozek 
    for _rozsirenaPolozka in ( 
         select * from tmp_RozsirenePolozky  
           where storno = false  
             and (typPohybuK = 'typPohybu.vydej' or (typPohybuk = 'typPohybu.prijem' and mnozMj < 0.0)) 
           order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
      --select * into _zaznam from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad; 
      if (_rozsirenaPolozka.typPohybuk = 'typPohybu.vydej'  or (_rozsirenaPolozka.typPohybuk = 'typPohybu.prijem' and _rozsirenaPolozka.mnozMj < 0.0)) then 
        if (not _rozsirenaPolozka.evidVyrCis) then 

        execute sfifoDobropis(_rozsirenaPolozka.idpoldobropis, _rozsirenaPolozka.idPolSklad, _rozsirenaPolozka.idCenik, _rozsirenaPolozka.idBspSkl, 
              _rozsirenaPolozka.idSkladKarty, _rozsirenaPolozka.mnozmj, _rozsirenaPolozka.cenyrucne);
                   
        else 
          for _vyrobniCislo in select * from svyrobnicislo where idpolskladvydej = _rozsirenaPolozka.idPolSklad loop 
            update svyrobnicislo set idpolskladvydej = null where idvyrobnicislo = _vyrobniCislo.idvyrobnicislo; 
            update svyrobnicislo set idpolskladvydej = _rozsirenaPolozka.idPolSklad where idvyrobnicislo = _vyrobniCislo.idvyrobnicislo; 
          end loop; 
        end if; 
        execute sPrepoctiSumyDokladu(_rozsirenaPolozka.iddoklskladpolozky); 
      end if; 
    end loop; 
  end if; 
 
  --select count(*) into _pocetPo from tmp_RozsirenePolozky; 
 
  -- vynulovani skladovych karet 
  execute skladVynulujSkladoveKarty(); 
 
  -- zafifovane veci zapoctu na skladove karty 
  for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky where storno = false order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
    if(_rozsirenaPolozka.cenyRucne = true) then 
      select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad; 
      execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, 1);  
    else 
      execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
    end if; 
  end loop; 
 
  if(_mazatTmpTable) then 
    drop table tmp_RozsirenePolozky; 
    drop table tmp_SkladoveKarty; 
    execute removeglotxvariable('zurnalTxName'); 
    execute removeglotxvariable('probihaPrepocetSkladu'); 
  end if; 
 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION sprepoctisklad(integer, integer)
    OWNER TO %firmaRole%;
    


-- Function: dpolskladinsert()

-- DROP FUNCTION dpolskladinsert();

CREATE OR REPLACE FUNCTION dpolskladinsert()
  RETURNS trigger AS
$BODY$ 
declare 
  _rozsirenaPolozka record; 
  _typPohybuk character varying; 
  _mazatTmpTable boolean; 
  _idPolSklad integer; 
  _probihaPrepocetSkladu character varying; 
  _polSklad record;  
  _pocetMenenychVydejek integer; 
  _odsunutaVydejka record; 
  _pomocnaVydejka record; 
begin 
  if(NEW.storno = true) then 
    return NEW; 
  end if;  
   
  select getglotxvariable('probihaPrepocetSkladu') into _probihaPrepocetSkladu; 
  if(_probihaPrepocetSkladu = 'true') then 
  else 
    -- tento select zjisti kolik je vydejek, ktere by se meli prepocitavat 
    select count(idpolsklad) into _pocetMenenychVydejek from dpolsklad ps join ddoklsklad ds  
      on ps.datsklad >= NEW.datSklad and ps.cenyRucne = false and ps.iddoklsklad = ds.iddoklsklad and ds.typpohybuk = 'typPohybu.vydej'; 
    if(_pocetMenenychVydejek = 0 and NEW.cenyRucne = true) then 
      execute sprepoctiskladkartu(NEW.mnozMj, NEW.cenaMj, NEW.sumZkl, NEW.datVyst, NEW.idKarty, NEW.idDoklSklad, NEW.idBspSkl, 1);  
      return NEW; 
    end if; 
 
    -- v pripade ze neprobiha prepocet skladu 
    -- generuji rozsirene polozky 
    select skladGenerujRozsirenePolozky(NEW.datSklad, NEW.idPolSklad, NEW.idKarty) into _mazatTmpTable; 
 
    execute putglotxvariable('zurnalTxName', 'prepocetSkladu'); 
 
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
      if(_rozsirenaPolozka.idPolSklad <> NEW.idPolSklad) then 
        if(_rozsirenaPolozka.cenyRucne = true) then 
          -- pokud maji byt ceny zadany rucne a nemaji se nikterak menit tak jen zmenime skladovou kartu a jedeme dal 
          if(_rozsirenaPolozka.storno = false) then  
            select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad; 
            execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, -1);  
          end if; 
        else 
          execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
        end if; 
      end if; 
    end loop; 
 
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
      if(_rozsirenaPolozka.cenyRucne = true) then 
        -- pokud maji byt ceny zadany rucne a nemaji se nikterak menit tak jen zmenime skladovou kartu a jedeme dal 
        if(_rozsirenaPolozka.storno = false) then  
          select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad; 
          execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, 1);  
        end if; 
      else 
        execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
      end if; 
    end loop; 
 
    if(_mazatTmpTable) then 
      drop table tmp_RozsirenePolozky; 
      drop table tmp_SkladoveKarty; 
      execute removeglotxvariable('zurnalTxName'); 
    end if; 
  end if; 
 
  select typpohybuk into _typPohybuk from ddoklsklad where iddoklsklad = NEW.iddoklsklad; 
  --pokud výdej, tak fifuju vazby 
  if (_typPohybuk = 'typPohybu.vydej' or (_typPohybuK = 'typPohybu.prijem' and NEW.mnozMj < 0.0)) then 

     execute sfifoDobropis(NEW.idpoldobropis, NEW.idPolSklad, NEW.idCenik, NEW.idBspSkl, 
              NEW.idKarty, NEW.mnozmj, NEW.cenyrucne);
    
    --execute sPrepoctiSumyDokladu(NEW.idDoklSklad); 
  end if; 
 
  if(_probihaPrepocetSkladu = 'true') then 
    if(NEW.idPolSklad < 0) then 
      _idPolSklad = -NEW.idPolSklad; 
    else 
      _idPolSklad = NEW.idPolSklad; 
    end if; 
 
    execute skladinsertrozsirenoupolozku(_idPolSklad); 
  end if; 
 
  execute sprepoctisumydokladu(NEW.idDoklSklad); 
 
  return NEW; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION dpolskladinsert()
  OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 892, 't', %appVersion%, clock_timestamp());
