---------------------------------------------------------------------------------------------------------------
-- Bug 41912 - Přepočet skladu při FIFO počítá i s příjemkami z jiného účetního období
---------------------------------------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION skladfindcenamjnakup(
    i_mnozmj numeric,
    i_idcenik integer,
    i_idskladu integer,
    i_datum date,
    i_sarze character varying,
    i_expirace date,
    i_dattrvan date,
    i_idvyrobnihocisla integer,
    i_idstred integer)
  RETURNS numeric AS
$BODY$ 
declare 
  _sklfifo boolean; 
  _mazatTmpTable boolean; 
  _idkarty integer; 
  _rozsirenaPolozka record; 
  _iducetobdobi integer; 
  _result numeric(19,6); 
  _pomocDPolSkladF record; 
  _mnozstvi numeric(19,6); 
  _potrebnyPocet numeric(19,6); 
  _sadaItemCount integer; 
  _polozkaSady record; 
  _pomoc numeric(19,6); 
 
  _sumSumZkl numeric(19,6); 
  _sumMnozMj numeric(19,6); 
  _sumTuz numeric(19,6); 
  _mnozMj numeric(19,6); 
  _typPohybuK character varying; 
  _karta record; 
  _idskupzboz integer; 
  _idSkladuPref integer; 
  _cenik record; 
  _sklad record; 
  _query character varying; 
begin 
  _result = null; 
  _mnozstvi = 0.0; 
 
  if(i_mnozMj > 0) then 
    select count(*) into _sadaItemCount from csady where idceniksada = i_idcenik; 
    if(_sadaItemCount > 0) then 
      FOR _polozkaSady IN (select * from cSady where idCenikSada = i_idcenik) LOOP 
        -- TODO doresit sarze expirace a vyrobni cisla 
        select skladfindcenamjnakup(i_mnozmj * _polozkaSady.mnozMj, _polozkaSady.idcenik, i_idskladu, i_datum, null, null, null, null, i_idstred) into _pomoc; 
        if (_result is null) then 
          _result = 0.0; 
        end if; 
        _result = _result + (_pomoc * _polozkaSady.mnozMj); 
      end loop; 
    else 
      select * into _cenik from ccenik where idCenik = i_idcenik; 
      if(_cenik.skladove) then 
        select findiducetniobdobikdatu(i_datum) into _iducetobdobi; 
        _sklfifo := (select isfifosklad(i_datum)); 
        if (_sklfifo) then 
          if(i_idvyrobnihocisla is not null and i_idvyrobnihocisla > 0) then 
            -- pokud je zadano vyrobni cislo ma nejvetsi prioritu 
            select (sumzkl / (case when mnozmj = 0.0 then 1 else mnozmj end))::numeric(19,6) into _result  
              from dpolsklad where idpolsklad = (select idpolskladprijem from svyrobnicislo where idvyrobnicislo = i_idvyrobnihocisla); 
          else 
            _query = 'select * from dpolskladf psf ' || 
		' inner join dpolsklad ps on psf.idpolsklad = ps.idpolsklad ' ||
		' inner join skarty k on ps.idkarty = k.idkarty ' ||
		' inner join nucetobdobi uo on k.iducetobdobi = uo.iducetobdobi ' ||
                ' where psf.idcenik = ''' || i_idcenik || '''' || 
                ' and psf.idSkladu = ''' || i_idSkladu || ''''; 
              
             if (i_sarze is not null) then 
               _query = _query || 
                   ' and psf.sarze = ''' || i_sarze || ''''; 
             end if; 
             if (i_expirace is not null) then 
               _query = _query || 
                   ' and psf.expirace = ''' || i_expirace || ''''; 
             end if; 
             if (i_dattrvan is not null) then 
               _query = _query || 
                   ' and psf.dattrvan = ''' || i_dattrvan || ''''; 
             end if; 
 
            _query = _query || 
                ' order by uo.platioddata, psf.datSklad,psf.idpolsklad'; 
 
            for _pomocDPolSkladF in execute _query loop 
              if (i_mnozMj > _mnozstvi) then 
                _potrebnyPocet = _pomocDPolSkladF.pocet; 
                if ((_mnozstvi + _potrebnyPocet) > i_mnozMj) then 
                  _potrebnyPocet = i_mnozMj - _mnozstvi; 
                end if; 
                _mnozstvi = _mnozstvi + _potrebnyPocet; 
                if (_result is null) then 
                  _result = 0.0; 
                end if; 
                _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMjTuz; 
              end if; 
            end loop; 
            if(_mnozstvi != 0.0) then 
              _result = _result / _mnozstvi; 
            else 
              if (_result is not null) then 
                _result = 0.0; 
              end if; 
            end if; 
          end if; 
        else 
          -- generuji rozsirene polozky 
          select * into _karta from skarty where idcenik = i_idcenik and idskladu = i_idskladu and iducetobdobi = _iducetobdobi; 
          -- pokud neexistuje skladova karta pokusim se ji najit pomoci mapovani skladu 
          if(_karta is null) then 
            select idskupzboz into _idskupzboz from ccenik where idcenik = i_idcenik; 
            select getPrefIdSkladu(i_idstred, _idskupzboz, i_idcenik) into _idSkladuPref; 
            select * into _karta from skarty 
              where idSkladu = _idSkladuPref and idCenik = i_idCenik and idUcetObdobi = _idUcetObdobi; 
            if(_karta is null) then 
              -- pokud ani podle mapovani skladu se skladova karta nenajde tak vyhazuju vyjimku 
              select * into _sklad from dbsp where idBsp = i_idSkladu; 
              raise exception '0007:Skladová karta neexistuje pro ceník % a sklad % a nebo je špatně nastaveno mapovaní skladu.', _cenik.nazev, _sklad.nazev; 
            end if; 
          end if; 
 
          if(_karta is null) then 
            raise exception 'Nenalezena sklad karta'; 
          end if; 
 
          _sumTuz = _karta.stavTuz; 
          _mnozMj = _karta.stavMj; 
          if(_mnozMj <> 0.0) then 
            _result = _sumTuz / _mnozMj; 
          end if; 
        end if; 
      else 
        --nejedna se o skladove zbozi 
        _result = _cenik.nakupCena; 
      end if; 
    end if; 
 
    if (_result is null) then 
      select (case when cenjednotka<>0.0 then round(nakupcena/cenjednotka, 6) else 0.0 end) into _result from ccenik where idcenik = i_idcenik; 
    end if; 
  else 
    _result = 0.0;   
  end if; 
  return _result; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, date, integer, integer)
  OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION sfifovydej(
    idvydej integer,
    idcenikvydej integer,
    idskladvydej integer,
    idkartyvydej integer,
    vyd numeric,
    _cenyrucne boolean,
    _prepocitatdobropis boolean)
  RETURNS void AS
$BODY$      
declare       
  _zaznam Record;       
  _vybrano numeric(19,6);     
  _i integer;     
  _novevydcelkem numeric(19,6);     
  _pocet numeric(19,6);     
  _cenamjP numeric(19,6);  
  _cenaMjPomoc numeric(19,6); 
  _sumZklP numeric(19,2); 
  _cenaMjPMen numeric(19,6);  
  _kurzDokladuP numeric(19,6);   
  _kurzDokladuV numeric(19,6);   
  _idDoklSkladP integer;    
  _idDoklSkladV integer;   
  _datVystV date;   
  _idrozlozeni integer;     
  _vydexpir boolean;     
  _vyrcis character varying(255);     
  _sklfifo boolean;  
  _sarze character varying(255);  
  _expirace date;       
  _evidVyrCis boolean;    
  _typPohybuK character varying(255); 
  _sumZklVysl numeric(19,6); 
 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _cenaMj numeric(19,6); 
begin       
  -- pokud ma byt vydane mnozstvi 0.0 tak i cena byt tomu mela odpovidat -> 0.0   
  -- a tim samozrejme skoncime 
  if(vyd = 0.0) then 
    update dpolsklad set 
      lastUpdate = LOCALTIMESTAMP,  
      cenaMj = 0.0, 
      sumZkl = 0.0, 
      sumZklMen = 0.0 
      where idPolSklad = idvydej; 
    return; 
  end if; 
   
  -- pokud se sem dostane zaporna vydejka tak to je jako prijemka a nefifuje se 
  select ds.typpohybuk, ps.datVyst, sarze,  expirace,  ps.iddoklsklad  
      into _typPohybuK, _datVystV,  _sarze, _expirace, _idDoklSkladV  
      from ddoklsklad ds join dpolsklad ps on ds.iddoklsklad = ps.iddoklsklad and ps.idpolsklad = idvydej; 
  if(_typPohybuK = 'typPohybu.vydej' and vyd < 0.0) then 
    return; 
  end if; 
 
  _vybrano := 0;     
  _i := 1;     
  _novevydcelkem := vyd;     
  if(_prepocitatDobropis and _typPohybuK = 'typPohybu.prijem' and _noveVydCelkem < 0.0) then 
	_novevydcelkem := (-1) * _noveVydCelkem; 
  end if; 
  _sumZklVysl = 0.0; 
  _sklfifo := (select isfifosklad(_datVystV));       
  _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));    
 
  -- pro polozky na kterych se eviduji vyrobni cisla je samostatny trigger na vyrobnich cislech 
  select evidVyrCis into _evidVyrCis from ccenik where idcenik = idcenikvydej;  
  if (not _evidVyrCis) then  
    select vydexpir into _vydexpir from skarty where idkarty=idkartyvydej limit 1;  
 
    if (not _vydexpir) then 
      --pořadí výdeje dle datvyst (dále se bude řesit upřednostněný výdej mimo FIFO) 
      for _zaznam in select * from dPolSkladF psf 
inner join dpolsklad ps on psf.idpolsklad = ps.idpolsklad
inner join skarty k on ps.idkarty = k.idkarty
inner join nucetobdobi uo on k.iducetobdobi = uo.iducetobdobi
where psf.idCenik=idCenikVydej and psf.idSkladu=idSkladVydej 
 order by uo.platioddata, psf.datSklad,psf.idpolsklad loop 
        if(not _zaznam is null) then 
          -- pokud je nejaka sarze nebo expirace musime vyfiltrovat danou sarzi nebo expiraci pokud ne tak nas to netrapi 
          if((_sarze is null or _sarze ~ '^\s*$' or _sarze = _zaznam.sarze) and (_expirace is null or _expirace = _zaznam.expirace)) then 
            -- pokud je doted rozfifovane mnozstvi mensi nez celkove ktere ma byt vydano 
            if(_vybrano<_novevydcelkem) then 
              _pocet := _zaznam.pocet; 
              if( _vybrano+_pocet) > _novevydcelkem then 
                _pocet := _novevydcelkem-_vybrano; 
              end if; 
              _vybrano := _vybrano+_pocet; 
               
              if (_sklfifo and not _cenyRucne) then 
                -- pokud se jedna o fifo sklad musime spravne fifalne urcit cenu 
                select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);     
                select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);    
                if (_kurzDokladuP <> 0.0) then  
                  _cenamjP := _cenamjP * _kurzDokladuP;     
                end if; 
 
                _cenaMjPomoc := _cenaMjP; 
 
                _cenamjP := _cenamjP / _kurzDokladuV;  
                _cenaMjPMen := 0.0;  
                if(_kurzDokladuV <> 1.0) then  
                  _cenaMjPMen := _cenaMjP;  
                end if;  
                _sumZklP = _pocet*_cenamjP*_kurzDokladuV; 
 
                if(_zaznam.pocet = _pocet) then 
                  select (case when _zaznam.typPohybuK = 'typPohybu.vydej' then -pp.sumZkl else pp.sumZkl end) 
                     - coalesce(((select sum(round(kusu * _cenaMjPomoc, 2)) from sfifoVazby where idpolskladprijem = _zaznam.idpolsklad)), 0.0) 
                    into _sumZklP 
                  from dpolsklad pp where idpolsklad = _zaznam.idpolsklad; 
                else   
                end if; 
 
                _sumZklVysl = _sumZklVysl + _sumZklP; 
              end if;   
              insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo); 
            else 
              if (_vybrano>_novevydcelkem) then 
                _pocet := -_zaznam.pocet; 
                if(( _vybrano+_pocet) < _novevydcelkem) then 
                  _pocet := _novevydcelkem-_vybrano; 
                end if; 
                _vybrano := _vybrano+_pocet; 
                insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, 0-_pocet,_zaznam.idvyrobnicislo) ;   
              end if; 
            end if; 
          end if; 
        end if; 
      end loop; 
    else       
      --pořadí výdeje dle expirace (dále se bude řesit upřednostněný výdej mimo FIFO)       
      for _zaznam in select * from dPolSkladF where idCenik=idCenikVydej and idSkladu=idSkladVydej order by expirace, idpolsklad loop         
        if(not _zaznam is null) then  
          -- pokud je nejaka sarze nebo expirace musime vyfiltrovat danou sarzi nebo expiraci pokud ne tak nas to netrapi 
          if((_sarze is null or _sarze ~ '^\s*$' or _sarze = _zaznam.sarze) and (_expirace is null or _expirace = _zaznam.expirace)) then 
            -- pokud je doted rozfifovane mnozstvi mensi nez celkove ktere ma byt vydano 
            if(_vybrano<_novevydcelkem) then 
              _pocet := _zaznam.pocet; 
              if( _vybrano+_pocet) > _novevydcelkem then 
                _pocet := _novevydcelkem-_vybrano; 
              end if; 
              _vybrano := _vybrano+_pocet; 
               
              if (_sklfifo and not _cenyRucne) then 
                -- pokud se jedna o fifo sklad musime spravne fifalne urcit cenu 
                select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);       
                select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);      
                if (_kurzDokladuP <> 0.0) then    
                  _cenamjP := _cenamjP * _kurzDokladuP;       
                end if; 
 
                _cenaMjPomoc := _cenaMjP; 
 
                _cenamjP := _cenamjP / _kurzDokladuV;    
                _cenaMjPMen := 0.0;    
                if(_kurzDokladuV <> 1.0) then    
                  _cenaMjPMen := _cenaMjP;    
                end if;    
                _sumZklP = _pocet*_cenamjP*_kurzDokladuV; 
 
                if(_zaznam.pocet = _pocet) then 
                  select (case when _zaznam.typPohybuK = 'typPohybu.vydej' then -pp.sumZkl else pp.sumZkl end) 
                     - coalesce(((select sum(round(kusu * _cenaMjPomoc, 2)) from sfifoVazby where idpolskladprijem = _zaznam.idpolsklad)), 0.0) 
                    into _sumZklP 
                  from dpolsklad pp where idpolsklad = _zaznam.idpolsklad; 
                else   
                end if;                 
 
 
                _sumZklVysl = _sumZklVysl + _sumZklP; 
              end if;   
              insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo); 
            else 
              if (_vybrano>_novevydcelkem) then 
                _pocet := -_zaznam.pocet; 
                if(( _vybrano+_pocet) < _novevydcelkem) then 
                  _pocet := _novevydcelkem-_vybrano; 
                end if; 
                _vybrano := _vybrano+_pocet; 
                insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, 0-_pocet,_zaznam.idvyrobnicislo) ;   
              end if; 
            end if; 
          end if; 
        end if; 
      end loop; 
    end if; 
  end if; 
   
  -- nakonec nastavime spravne ceny na vydejce 
  if((_typPohybuK = 'typPohybu.vydej' or (_prepocitatDobropis and _typPohybuK = 'typPohybu.prijem' and vyd < 0.0) ) and _sklfifo and not _cenyRucne) then 
    if(_prepocitatDobropis and vyd < 0.0) then 
	_sumZklVysl = (-1) * _sumZklVysl; 
    end if; 
    _sumZkl := _sumZklVysl; 
    _sumZklMen := 0.0; 
    _cenaMj = _sumZklVysl / vyd; 
    if(_kurzDokladuV <> 1.0) then 
       _sumZklMen := _sumZklVysl / _kurzDokladuV; 
       _sumZkl := _sumZklVysl; 
       _cenaMj := _sumZklMen / vyd; 
    end if; 
    update dpolsklad set 
      lastUpdate = LOCALTIMESTAMP,  
      sumZkl = _sumZkl, 
      sumZklMen = _sumZklMen, 
      cenaMj = _cenaMj 
      where idpolsklad = idvydej; 
  end if;     
end;       
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION sfifovydej(integer, integer, integer, integer, numeric, boolean, boolean)
  OWNER TO  %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 901, 't', %appVersion%, clock_timestamp());

