-------------------------------------------------------------------------------------------------------------
-- Bug 44703 - Analytické účty firem vytvořených od v. 2016.1.4 mají špatné syntetické účty
-------------------------------------------------------------------------------------------------------------

create or replace function runupgrade()
    returns void as $$
declare
    _idtyporg integer;
    cnt integer; 
begin
  select idtyporg into _idtyporg from nnastav where ((select max(platioddata) from nnastav) is null
        or (select max(platioddata) from nnastav) = platioddata);

  -- chceme provést aktualizaci jen pro podnikatele
  if (_idtyporg = 1) then
  
-- nastavení správných syntetických účtů
update uucty u set idstdUcet = (select s.idstducet from ustducty s where substring(u.kod, 1, 3) = s.kod) where iducet in
(select u.iducet 
    from uucty u
    inner join ustducty s on u.idstducet = s.idstducet
        where substring(u.kod, 1, 3) <> s.kod);

--------------------------------------------------------------------------------------
-- Bug 44685 - Účet 432 v roce 2015 
--------------------------------------------------------------------------------------

update ustducty set platiOd = 2014 where uuid = 'CZ_POD_599';
update ustducty set platiOd = 2014 where uuid = 'CZ_POD_432';


-- POZOR bug 44879 - pokud se jednou budeme tady opičit, tak to asi nepůjde takhle jednoduše, u vyšších čísel hrozí, že si tam uživatel přidával idčka řádků sestavy sám a že idčka jsou v různých firmách různá
UPDATE usesradky SET oznaceni = 'P  A  V  1' WHERE idsesradky = 60;
UPDATE usesradky SET cisrad = 92 WHERE idsesradky = 61;
UPDATE usesradky SET cisrad = 93 WHERE idsesradky = 62;
UPDATE usesradky SET cisrad = 94 WHERE idsesradky = 63;
UPDATE usesradky SET cisrad = 98 WHERE idsesradky = 64;
UPDATE usesradky SET cisrad = 99 WHERE idsesradky = 65;
UPDATE usesradky SET cisrad = 101 WHERE idsesradky = 66;
UPDATE usesradky SET cisrad = 106 WHERE idsesradky = 67;
UPDATE usesradky SET cisrad = 108 WHERE idsesradky = 68;
UPDATE usesradky SET cisrad = 109 WHERE idsesradky = 69;
UPDATE usesradky SET cisrad = 110 WHERE idsesradky = 70;
UPDATE usesradky SET cisrad = 111 WHERE idsesradky = 71;
UPDATE usesradky SET cisrad = 112 WHERE idsesradky = 72;
UPDATE usesradky SET cisrad = 113 WHERE idsesradky = 73;
UPDATE usesradky SET cisrad = 114 WHERE idsesradky = 74;
UPDATE usesradky SET cisrad = 115 WHERE idsesradky = 75;
UPDATE usesradky SET cisrad = 116 WHERE idsesradky = 76;
UPDATE usesradky SET cisrad = 117 WHERE idsesradky = 77;
UPDATE usesradky SET cisrad = 118 WHERE idsesradky = 78;
UPDATE usesradky SET cisrad = 120 WHERE idsesradky = 79;
UPDATE usesradky SET cisrad = 121 WHERE idsesradky = 80;
UPDATE usesradky SET cisrad = 122 WHERE idsesradky = 81;
UPDATE usesradky SET cisrad = 124 WHERE idsesradky = 82;
UPDATE usesradky SET cisrad = 125 WHERE idsesradky = 83;
UPDATE usesradky SET cisrad = 90 WHERE idsesradky = 105;
UPDATE usesradky SET cisrad = 123 WHERE idsesradky = 106;
UPDATE usesradky SET cisrad = 91 WHERE idsesradky = 111;
UPDATE usesradky SET cisrad = 96 WHERE idsesradky = 112;
UPDATE usesradky SET cisrad = 107 WHERE idsesradky = 113;
UPDATE usesradky SET cisrad = 119 WHERE idsesradky = 114;
UPDATE usesradky SET cisrad = 95 WHERE idsesradky = 115;
UPDATE usesradky SET cisrad = 103 WHERE idsesradky = 116;
UPDATE usesradky SET cisrad = 105 WHERE idsesradky = 117;
UPDATE usesradky SET cisrad = 104 WHERE idsesradky = 118;
UPDATE usesradky SET cisrad = 102 WHERE idsesradky = 119;
UPDATE usesradky SET cisrad = 100 WHERE idsesradky = 120;
UPDATE usesradky SET cisrad = 97 WHERE idsesradky = 121;
UPDATE usesradky SET cisrad = 126 WHERE idsesradky = 122;
INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, zjednodusena, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
 VALUES (188, '2016-02-25 00:00:00.000', 89, 'P  A  V  2', 'Rozhodnuto o zálohách a na výplatu podílu na zisku /-/', false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1);

INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
 VALUES (454, '2016-02-25 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.stavKon', true, false, 188, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_432'));


   end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();
        
-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 984, 't', %appVersion%, clock_timestamp());