CREATE OR REPLACE FUNCTION create_or_drop_mzdy_zurnal_triggers(docreate boolean)
  RETURNS void AS
$BODY$
BEGIN
  -- Na nektere z tabulek muze byt uvalen zamek (napr. typu AccessShareLock)
  LOCK TABLE pcismzdsloz IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE pdite IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE pmzdsloz IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE pmzdvazbazav IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE pnepritomnost IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE posoba IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE posobahlav IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE ppracpom IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE ppracpomhlav IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE pskuposob IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE psmeny IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE psrazka IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE pstalamzdsloz IN ACCESS EXCLUSIVE MODE NOWAIT;
  
  IF docreate THEN
    CREATE TRIGGER pcismzdslozzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON pcismzdsloz FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER pditezurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON pdite FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER pmzdslozzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON pmzdsloz FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER pmzdvazbazavzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON pmzdvazbazav FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER pnepritomnostzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON pnepritomnost FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER posobazurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON posoba FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER posobahlavzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON posobahlav FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER ppracpomzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON ppracpom FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER ppracpomhlavzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON ppracpomhlav FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER pskuposobzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON pskuposob FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER psmenyzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON psmeny FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER psrazkazurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON psrazka FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER pstalamzdslozzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON pstalamzdsloz FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

  ELSE
    DROP TRIGGER IF EXISTS pcismzdslozzurnal ON pcismzdsloz;
    DROP TRIGGER IF EXISTS pditezurnal ON pdite;
    DROP TRIGGER IF EXISTS pmzdslozzurnal ON pmzdsloz;
    DROP TRIGGER IF EXISTS pmzdvazbazavzurnal ON pmzdvazbazav;
    DROP TRIGGER IF EXISTS pnepritomnostzurnal ON pnepritomnost;
    DROP TRIGGER IF EXISTS posobazurnal ON posoba;
    DROP TRIGGER IF EXISTS posobahlavzurnal ON posobahlav;
    DROP TRIGGER IF EXISTS ppracpomzurnal ON ppracpom;
    DROP TRIGGER IF EXISTS ppracpomhlavzurnal ON ppracpomhlav;
    DROP TRIGGER IF EXISTS pskuposobzurnal ON pskuposob;
    DROP TRIGGER IF EXISTS psmenyzurnal ON psmeny;
    DROP TRIGGER IF EXISTS psrazkazurnal ON psrazka;
    DROP TRIGGER IF EXISTS pstalamzdslozzurnal ON pstalamzdsloz;
  END IF;
END;
$BODY$
LANGUAGE 'plpgsql' VOLATILE;
