<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
    <!-- fakturační XML pro pokladny firmy APLS -->
    <xsl:output method="xml"  encoding="utf-8" />

    <xsl:template match="winstrom">
	<winstrom version="1.0">
		<xsl:apply-templates select="pokladni-pohyb"/>
	</winstrom>
    </xsl:template>

    
    <xsl:template match="pokladni-pohyb">
		<pokladni-pohyb>
			<id>code:<xsl:value-of select="CISLO_DOKLADU" /></id>
			<typDokl>code:<xsl:value-of select="POKLADNA" /></typDokl>
			<kod><xsl:value-of select="CISLO_DOKLADU" /></kod>

			<datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(DUZP, 'd.m.y')" /></datVyst>
			<duzpPuv><xsl:value-of select="java:flexibee.Tool.parseDate(DUZP, 'd.m.y')" /></duzpPuv>

			<stredisko>code:<xsl:value-of select="STREDISKO"/></stredisko>


			<bezPolozek>true</bezPolozek>
			<sumOsv><xsl:value-of select="ZAKLAD_0"/></sumOsv>
			<sumZklSniz><xsl:value-of select="ZAKLAD_SS"/></sumZklSniz>
			<sumZklZakl><xsl:value-of select="ZAKLAD_ZS"/></sumZklZakl>
			<sumDphSniz><xsl:value-of select="DAN_SS"/></sumDphSniz>
			<sumDphZakl><xsl:value-of select="DAN_ZS"/></sumDphZakl>
			<sumCelkem><xsl:value-of select="DAN_ZS"/></sumCelkem>


			<xsl:if test="java:flexibee.Tool.trim(CIZI_MENA) != ''">
			    <mena>code:<xsl:value-of select="CIZI_MENA"/></mena>
			    <kurz><xsl:value-of select="CIZI_KURZ"/></kurz>
			</xsl:if>

		</pokladni-pohyb>
    </xsl:template>

<!--

    <CISLO_DOKLADU>1012010100</CISLO_DOKLADU>	-ok
    <DUZP>1.1.2010</DUZP>			-ok
    <STREDISKO>100</STREDISKO>			-ok
    <POKLADNA>001</POKLADNA>  			-ok
    <ZAKLAD_0>0</ZAKLAD_0>			-ok
    <ZAKLAD_SS>0</ZAKLAD_SS>			-ok
    <ZAKLAD_ZS>1000</ZAKLAD_ZS>			-ok
    <DAN_SS>0</DAN_SS>				-ok
    <DAN_ZS>200</DAN_ZS>			-ok
    <CELKEM>1200</CELKEM>			-ok
    <CIZI_MENA>  </CIZI_MENA>			-ok
    <CIZI_KURZ>0</CIZI_KURZ>			-ok
    <CIZI_CELKEM>0</CIZI_CELKEM>
    <CELKEM_HOTOVOST>600</CELKEM_HOTOVOST>
    <CELKEM_KARTY>600</CELKEM_KARTY>
    <CELKEM_STRAVENKY>0</CELKEM_STRAVENKY>
    <CELKEM_POUKAZKY>0</CELKEM_POUKAZKY>

-->

</xsl:stylesheet>