<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:template match="winstrom">
	<stock>
	    <xsl:attribute name="date">
		    <xsl:value-of  select="java:flexibee.Tool.currentDate()"/> 
	    </xsl:attribute>
		<xsl:apply-templates select="skladova-karta"/>
	</stock>
    </xsl:template>

    <xsl:template match="skladova-karta">
	<stock>
	    <xsl:attribute name="id">
		<xsl:value-of select="id"/>
	    </xsl:attribute>
	    <xsl:attribute name="external_id">0</xsl:attribute>
	    <xsl:attribute name="plu">
		<xsl:value-of select="cenik/cenik/kodPlu"/>
	    </xsl:attribute>


	    <xsl:attribute name="name">
		<xsl:value-of select="cenik/cenik/nazev"/>
	    </xsl:attribute>
	    <xsl:attribute name="measure">
		<xsl:value-of select="java:flexibee.Tool.toLower(java:flexibee.Tool.substring(cenik/cenik/mj1, 5))"/>
	    </xsl:attribute>

	    <xsl:attribute name="ean">
		<xsl:value-of select="cenik/cenik/eanKod"/>
	    </xsl:attribute>

	    <xsl:attribute name="price">
		<xsl:value-of select="cenik/cenik/cenaZakl"/>
	    </xsl:attribute>

	    <xsl:attribute name="type">
		<xsl:choose>
		    <xsl:when test="cenik/cenik/typZasobyK = 'typZasoby.sluzba'">Service</xsl:when>
		    <xsl:otherwise>Goods</xsl:otherwise>
		</xsl:choose>
	    </xsl:attribute>

	    <xsl:attribute name="amount">
		<xsl:value-of select="stavMJ"/>
	    </xsl:attribute>
	    <xsl:attribute name="stock-price">
		<xsl:value-of select="prumCenaTuz"/>
	    </xsl:attribute>


	</stock>
    </xsl:template>

</xsl:stylesheet>