<?xml version="1.0" encoding="utf-8"?>

<!-- soubor pro transformaci výpisů z formátu camt.053.001.06 do XML, které umí FlexiBee naimportovat 
(mělo by být totožné s xslt ve složce camt_053, liší se jen namespace pro camt )-->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
xmlns:java="http://xml.apache.org/xalan/java" 
xmlns:camt="urn:iso:std:iso:20022:tech:xsd:camt.053.001.06"
exclude-result-prefixes="java">

  <xsl:template match="/">
    <xsl:apply-templates select="camt:Document"/>
  </xsl:template>

  <xsl:template match="camt:Document">
    <winstrom version="1.0" source="importVypisu">  
      <xsl:apply-templates select="camt:BkToCstmrStmt"/>
    </winstrom>

  </xsl:template>



  <xsl:template match="camt:BkToCstmrStmt">
    <xsl:apply-templates select="camt:GrpHdr" /> 
    <xsl:apply-templates select="camt:Stmt" /> 
  </xsl:template>
  
  <!-- group header -->
  <xsl:template match="camt:GrpHdr">
     <xsl:apply-templates select="camt:MsgId" /> 
    <!-- datum a čas vytvoření -->
    <!-- < xsl:apply-templates select="CreDtTm" / > -->
    <!-- Příjemce výpisu (může být odlišný od majitele účtu -->
    <!-- MsgRcpt -->
    <!--MsgPgntn-->
    <!--PgNb-->
    <!--LastPgInd-->
    <!--AddtlInf-->
  </xsl:template>

  <!-- id zprávy -->
  <xsl:template match="camt:MsgId">
    <!-- <xsl:value-of select="."/> --> <!-- TODO ? využití ? -->
  </xsl:template>


  <xsl:template match="camt:Stmt">
    <!-- IBAN-­RRRR-­MM-­DD (deň,za ktorý bol výpis zostavený (denný výpis), posledný deň v mesiaci (mesačný výpis)) -->
    <xsl:apply-templates select="camt:Id"/>
    <!-- č. el. výpisu -->
    
    <xsl:variable name="cisloVypisu">
       <xsl:choose>
          <xsl:when test="camt:LglSeqNb">
            <xsl:value-of select="camt:LglSeqNb"/>
          </xsl:when>
          <xsl:when test="camt:ElctrncSeqNb">
            <xsl:value-of select="camt:ElctrncSeqNb"/>
          </xsl:when>
          <xsl:otherwise>0</xsl:otherwise>
       </xsl:choose>
    </xsl:variable>
    <!-- < xsl:apply-templates select="camt:ElctrncSeqNb"/ -->
    <!-- č. výpisu -->
    <!-- <xsl:apply-templates select="camt:LglSeqNb"/ -->
    
    <!-- CreDtTm -->
    <!-- FrToDt -->
    <!-- FrDtTm -->
    <!-- ToDtTm -->
    
    <!-- informace o účtě -->
    <!--xsl:variable name="account"><xsl:apply-templates select="camt:Acct"/></xsl:variable-->
    <xsl:variable name="account">bankovniUcet.urlParam</xsl:variable>
    <!-- informace o úročení -->
    <!-- Intrst -->
    
    <!-- informace o zůstatku ? zpracovat -->
    <!-- Bal -->
    
    <!-- info o počtu a součtu položek ? bylo by nám to k něčemu? -->
    <!-- TxsSummry -->
    <xsl:for-each select="camt:Ntry">
      <xsl:call-template name="camt_Ntry">
        <xsl:with-param name="account"><xsl:value-of select="$account"/></xsl:with-param>
        <xsl:with-param name="cisloVypisu">    
          <xsl:value-of select="$cisloVypisu"/>
        </xsl:with-param>
      </xsl:call-template>
    </xsl:for-each>
  </xsl:template>
 
  <!-- identifikátor výpis: IBAN-­RRRR-­MM-­DD  -->
  <xsl:template match="camt:Id">
  </xsl:template>
  
  <!-- informace o účtě -->
  <xsl:template match="camt:Acct">
   
   <xsl:choose>
     <xsl:when test="camt:Id/camt:IBAN">
       <xsl:apply-templates select="camt:Id/camt:IBAN"/>
     </xsl:when>
     <xsl:when test="camt:Id/camt:Othr/camt:Id">
       <!-- TODO zatím takhle, aby bylo jasné, že je chyba, na konkrétním příkladu bude potřeba vymyslet, jak tohle vyřešit -->
       code:
     </xsl:when>
   </xsl:choose>
   <!-- kód typu účtu: Tp/Cd-->
   <!-- typ účtu: Tp/Prtry -->
   <xsl:apply-templates select="camt:Ccy"/>
   <!-- Ownr -->
   <!-- Nm -->
   <!-- PstlAdr -->
   <!-- StrtNm -->
   <!-- BldgNb -->
   <!-- PstCd -->
   <!-- TwnNm -->
   <!-- Ctry -->
   <!-- AdrLine -->
   <!-- Id -->
   <!-- Svcr -->
  </xsl:template>
 
  <!-- takhle v jendom řádku to je, protože pak bylo odřádkování ve výstupu a to zlobilo při importu -->
  <xsl:template match="camt:Id/camt:IBAN">iban:<xsl:value-of select="."/>
  </xsl:template>
  
  <!-- měna účtu -->
  <xsl:template match="camt:Ccy">
      <!-- TODO zpracovat (až časem, přijde-li fixopie na více nalezených účtů) -->
  </xsl:template>
  
  <!-- informace o položce -->
  <!--<xsl:template match="camt:Ntry"> -->
  <xsl:template name="camt_Ntry">
      <xsl:param name="account"/>
      <xsl:param name="cisloVypisu"/>
      
      <!-- konstantní symbol - pokud nebude, tak ho tam přidáme, aby to nebránilo importu -->
      <xsl:variable name="KSvar">
        <xsl:if test="camt:Sts = 'BOOK'">
          <xsl:variable name="ksIndex" select="java:flexibee.Tool.indexOf(camt:NtryDtls/camt:TxDtls/camt:Refs/camt:EndToEndId, '/KS')"/>
          <xsl:if test="$ksIndex > -1">
            <xsl:variable name="konSym">
              <xsl:value-of select="java:flexibee.Tool.substring3(camt:NtryDtls/camt:TxDtls/camt:Refs/camt:EndToEndId, $ksIndex +3 , java:flexibee.Tool.indexOf(camt:NtryDtls/camt:TxDtls/camt:Refs/camt:EndToEndId, '/', $ksIndex + 3))"/>
            </xsl:variable>
            <xsl:value-of select="java:flexibee.Tool.formatToString($konSym, '0',4)" />
          </xsl:if>
        </xsl:if>
      </xsl:variable>
      
      <xsl:if test="string-length($KSvar) and $KSvar != '0000'">
        <konst-symbol create="ok" update="ignore">
          <id>code:<xsl:value-of select="$KSvar"/></id>
          <kod><xsl:value-of select="$KSvar"/></kod>
          <nazev><xsl:value-of select="$KSvar"/> - vyplněno při importu</nazev>                                        
        </konst-symbol>
      </xsl:if>
      <banka>
      
      <!-- typ dokladu si z nastavení vezme sám XML importer -->
      <typDokl>typDokl.zNastaveni</typDokl>
      <bezPolozek>true</bezPolozek>
      <banka><xsl:value-of select="$account"/></banka>
      <!-- jedinečná reference položky NtryRef -->
      <!-- <xsl:value-of select="camt:NtryRef"/> -->
      <sumOsv><xsl:apply-templates select="camt:CdtDbtInd"/><xsl:value-of select="camt:Amt"/></sumOsv>
      <sumZklCelkem><xsl:apply-templates select="camt:CdtDbtInd"/><xsl:value-of select="camt:Amt"/></sumZklCelkem>
      <sumCelkem><xsl:apply-templates select="camt:CdtDbtInd"/><xsl:value-of select="camt:Amt"/></sumCelkem>
      <mena>code:<xsl:apply-templates select="camt:Amt/@Ccy"/></mena>

      <xsl:choose>
        <xsl:when test="camt:CdtDbtInd = 'CRDT'">
          <typPohybuK>typPohybu.prijem</typPohybuK>
        </xsl:when>
        <xsl:when test="camt:CdtDbtInd = 'DBIT'">
          <typPohybuK>typPohybu.vydej</typPohybuK>
        </xsl:when>
      </xsl:choose>

      <!-- storno položka RvslInd ? TODO je to k něčemu? -->
      
      <!-- Sts - BOOK, PDNG, INFO - mě by mělo zajímat jen to BOOK -->
      <xsl:if test="camt:Sts = 'BOOK'">
          <!-- upřednostníme datum valuty před datem zaúčtování -->
          <xsl:variable name="datPolVar">
            <xsl:call-template name="datPol"/>
          </xsl:variable>
          <datVyst><xsl:value-of select="$datPolVar"/></datVyst>
          <datUcto><xsl:value-of select="$datPolVar"/></datUcto>
          <cisSouhrnne><xsl:value-of select="java:flexibee.Tool.substring($datPolVar, 0,4)"/>/<xsl:value-of select="$cisloVypisu"/>/<xsl:value-of select="java:flexibee.Tool.formatToString(position(), '0', 2)"/></cisSouhrnne>
          <!-- AcctSvcrRef -->
          <!-- kód bankovní transakce: BkTxCd/Prtry/Cd -->
          <!-- správce tohodo dat. formátu : BkTxCd/Prtry/Issr -->
          
          <!-- částka AmtDtls -->
          <!-- poplatky Chrgs -->
          <!-- detaily transakce: -->
          <xsl:apply-templates select="camt:NtryDtls">
            <xsl:with-param name="cdtDbtVar"><xsl:value-of select="camt:CdtDbtInd"/></xsl:with-param>
          </xsl:apply-templates>
      </xsl:if>
      
      </banka>
      
  </xsl:template>
  
  <xsl:template match="camt:Amt"> 
      <xsl:value-of select="@Ccy"/>
      <xsl:value-of select="."/>
  </xsl:template>
  
  <xsl:template match="camt:CdtDbtInd"> 
      <!-- <xsl:value-of select="."/> -->
      <!-- DBIT|CRDT-->
      <!-- asi netřeba,zpracováno výše -->
  </xsl:template>
  
  <xsl:template name="datPol">
    <xsl:choose>
      <xsl:when test="camt:ValDt/camt:Dt">
        <!-- datum valuty-->
       <xsl:value-of select="camt:ValDt/camt:Dt"/>
      </xsl:when>
      <xsl:when test="camt:ValDt/camt:DtTm">
        <!-- datum valuty-->
        <xsl:value-of select="camt:ValDt/camt:Dt"/>
      </xsl:when>
      <xsl:when test="camt:BookgDt/camt:Dt">
        <!-- datum zaúčtování -->
        <xsl:value-of select="camt:BookgDt/camt:Dt"/>
      </xsl:when>          
    </xsl:choose>
  </xsl:template>
  
  <xsl:template match="camt:NtryDtls">
      <xsl:param name="cdtDbtVar"/>
      <!-- Btch -->
      <!-- MsgId -->
      <!-- PmtInfId -->
      <!-- NbOfTxs -->
      <!-- TtlAmt -->
      
      <!-- DBIT/CRDT -->
      <!-- TtlAmt -->
      
      <xsl:apply-templates select="camt:TxDtls">
        <xsl:with-param name="cdtDbtVar">
          <xsl:value-of select="$cdtDbtVar"/>
        </xsl:with-param>
      </xsl:apply-templates>
  </xsl:template>
  
  <xsl:template match="camt:TxDtls">
      <xsl:param name="cdtDbtVar"/>
      <xsl:apply-templates select="camt:Refs"/>
      <!-- detaily částky: AmtDtls -->
      <!-- kód transakce BkTxCd/rtry/Cd -->
      <!-- správce formátu BkTxCd/rtry/Issr -->
      <!-- poplatky - částka Chrgs/Amt -->
      <!-- poplatky - DBIT/CRDT Chrgs/CdtDbtInd -->
      <!-- poplatky - označení Chrgs/Br -->
      
      <!-- plátce/příjemce -->
      <xsl:apply-templates select="camt:RltdPties">
        <xsl:with-param name="cdtDbtVar">
          <xsl:value-of select="$cdtDbtVar"/>
        </xsl:with-param>
      </xsl:apply-templates>

      <!-- banka plátce, příjemce-->
      <xsl:apply-templates select="camt:RltdAgts">
        <xsl:with-param name="cdtDbtVar">
          <xsl:value-of select="$cdtDbtVar"/>
        </xsl:with-param>
      </xsl:apply-templates>
      
      
      <!-- účel platby: Purp/Cd-->
      
      <xsl:apply-templates select="camt:RmtInf"/>
      
      <!-- důvod vrácení transakce: RtrInf -->
      
      <!-- dodatečné informace: AddtlTxInf -->
  
  </xsl:template>
  
  <!-- reference pro různé typy plateb -->
  <xsl:template match="camt:Refs">
      <!-- MsgId -->
      <!-- AcctSvcrRef -->
      <!-- PmtInfId -->
      <!-- InstrId -->
            
      <xsl:apply-templates select="camt:EndToEndId" />
      
      <!-- MndtId -->
      <!-- TxId -->
      <!-- ChqNb -->
      <!-- ClrSysRef -->
  
  </xsl:template>
  
  <!-- Klientská reference transakce - mj. zde může být VS, KS, SS -->
  <xsl:template match="camt:EndToEndId">    
      <xsl:if test="starts-with(., '/VS') or starts-with(., '/KS') or starts-with(., '/SS')">
         <xsl:variable name="vsIndex" select="java:flexibee.Tool.indexOf(., '/VS')"/>
         <xsl:if test="$vsIndex &gt; -1">
           <varSym><xsl:value-of select="java:flexibee.Tool.trimText0(java:flexibee.Tool.substring3(., $vsIndex + 3, java:flexibee.Tool.indexOf(., '/', $vsIndex + 3)))" /></varSym>
         </xsl:if>
          
         <xsl:variable name="ksIndex" select="java:flexibee.Tool.indexOf(., '/KS')"/>
         <xsl:if test="$ksIndex > -1">
            <xsl:variable name="konSym">
              <xsl:value-of select="java:flexibee.Tool.formatToString(java:flexibee.Tool.substring3(., $ksIndex +3 , java:flexibee.Tool.indexOf(., '/', $ksIndex + 3)), '0',4)" />
            </xsl:variable>
            <xsl:if test="$konSym != '0000'">
              <konSym>code:<xsl:value-of select="$konSym"/></konSym>
            </xsl:if>
          </xsl:if>
          
          <xsl:variable name="ssIndex" select="java:flexibee.Tool.indexOf(., '/SS')"/>
          <xsl:if test="$ssIndex > -1">
            <specSym><xsl:value-of select="java:flexibee.Tool.trimText0(java:flexibee.Tool.substring3(., $ssIndex +3 , java:flexibee.Tool.indexOf(., '/', $ssIndex + 3)))" /></specSym>
          </xsl:if> 
      </xsl:if>
  </xsl:template>
  
  <!-- Plátce/příjemce -->
  <xsl:template match="camt:RltdPties"> 
      <xsl:param name="cdtDbtVar"/>
      <!-- 
         CRDT = kredit, příjem, zajímají nás údaje o protistraně, tj. o plátci
         DBIT = debet, výdej, zajímají nás údaje o protistraně, tj. o příjemci
      -->
      <xsl:choose>
        <xsl:when test="$cdtDbtVar = 'CRDT'">
          <!-- plátce -->
          <xsl:apply-templates select="camt:Dbtr"/>
        </xsl:when>
        <xsl:when test="$cdtDbtVar = 'DBIT'">
          <!-- příjemce -->
          <xsl:apply-templates select="camt:Cdtr"/>
        </xsl:when>
      </xsl:choose>
         
      
      <!-- získání čísla účtu protistrany (očekávám, že bude vyplněno buď DbtrAcct nebo CdtrAcct) -->
      <xsl:variable name="cUctuIban">
        <xsl:choose>
          <xsl:when test="$cdtDbtVar = 'CRDT'">
            <xsl:value-of select="camt:DbtrAcct/camt:Id/camt:IBAN"/>
          </xsl:when>
          <xsl:when test="$cdtDbtVar = 'DBIT'">
            <xsl:value-of select="camt:CdtrAcct/camt:Id/camt:IBAN"/>
          </xsl:when>
        </xsl:choose>
      </xsl:variable>
      
      <xsl:variable name="cUctu">
        <xsl:choose>
          <xsl:when test="$cdtDbtVar = 'CRDT'">
            <xsl:value-of select="camt:DbtrAcct/camt:Id/camt:Othr/camt:Id"/>
          </xsl:when>
          <xsl:when test="$cdtDbtVar = 'DBIT'">
            <xsl:value-of select="camt:CdtrAcct/camt:Id/camt:Othr/camt:Id"/>
          </xsl:when>
        </xsl:choose>
        
      </xsl:variable>
      
      <xsl:choose>
        <xsl:when test="$cUctuIban and string-length($cUctuIban) > 0">
          <iban><xsl:value-of select="$cUctuIban"/></iban>
        </xsl:when>
        <xsl:when test="$cUctu">
          <buc><xsl:value-of select="$cUctu"/></buc>
        </xsl:when>
      </xsl:choose>
      

       
      <!-- UltmtDbtr -->

      <!-- camt:CdtrAcct/camt:Nm -->
      <!-- UltmtCdtr -->
      <!-- Prtry/Tp-->
      <!-- Prtry/Pty/Nm-->
  </xsl:template>

  <!-- plátce -->
  <xsl:template match="camt:Dbtr">
     <xsl:if test="camt:Nm">
       <xsl:call-template name="protistrana-nazev"/>
     </xsl:if>
     
     <xsl:if test="camt:PstlAdr">
       <xsl:call-template name="protistrana-pstlAdr"/>
     </xsl:if>
     
  </xsl:template>
  
  <!-- Cdtr - duplicitní s Dbtr -->
  <xsl:template match="camt:Cdtr">
     <xsl:if test="camt:Nm">
       <xsl:call-template name="protistrana-nazev"/>
     </xsl:if>
     
     <xsl:if test="camt:PstlAdr">
       <xsl:call-template name="protistrana-pstlAdr"/>
     </xsl:if>
     
  </xsl:template>

  <xsl:template name="protistrana-nazev">
     <nazFirmy><xsl:value-of select="camt:Nm"/></nazFirmy>
  </xsl:template>
  
  <xsl:template name="protistrana-pstlAdr">
     <xsl:if test="camt:PstlAdr/camt:StrtNm or camt:PstlAdr/camt:BldgNb">
     <ulice>
      <xsl:value-of select="camt:PstlAdr/camt:StrtNm"/>
       <xsl:value-of select="camt:PstlAdr/camt:BldgNb"/>
     </ulice>
     </xsl:if>
     <psc><xsl:value-of select="camt:PstlAdr/camt:PstCd"/></psc>
     <mesto><xsl:value-of select="camt:PstlAdr/camt:TwnNm"/></mesto>
     <xsl:if test="camt:PstlAdr/camt:Ctry">
      <stat>code:<xsl:value-of select="camt:PstlAdr/camt:Ctry"/></stat>
     </xsl:if>
     <xsl:if test="camt:PstlAdr/camt:AdrLine">
        <!-- TODO ? šlo by to nějak lépe? zatím stačí takhle -->
        <!-- je třeba takle zformátované  jinak vkládá nový řádek -->
      <ulice>                 
        <xsl:for-each select="camt:PstlAdr/camt:AdrLine"><xsl:value-of select="."/>; </xsl:for-each>
       </ulice>
     </xsl:if>
     <!-- id -->
  </xsl:template>
  
  <!-- banka plátce/příjemce -->
  <xsl:template match="camt:RltdAgts">  
      <xsl:param name="cdtDbtVar"/>     
      <!-- 
         CRDT = kredit, příjem, zajímají nás údaje o protistraně, tj. o plátci
         DBIT = debet, výdej, zajímají nás údaje o protistraně, tj. o příjemci
      -->
      <xsl:choose>
        <xsl:when test="$cdtDbtVar = 'CRDT'">
          <!-- banka plátce -->
          <bic><xsl:apply-templates select="camt:DbtrAgt/camt:FinInstnId/camt:BIC"/></bic>
        </xsl:when>
        <xsl:when test="$cdtDbtVar = 'DBIT'">
          <!-- banka příjemce -->
          <bic><xsl:apply-templates select="camt:CdtrAgt/camt:FinInstnId/camt:BIC"/></bic>
        </xsl:when>
      </xsl:choose>
      
      <!-- ostatní údaje o bance (adresa, kód banky, ...) nás aktuálně nezajímají -->
  </xsl:template>
  
  <!-- informace k transakci, zpráva pro příjemce -->
  <xsl:template match="camt:RmtInf">
      <popis>
        <xsl:value-of select="camt:Ustrd"/>
        <xsl:value-of select="camt:Strd"/>
      </popis>
      <!-- CdtrRefInf/Tp -->
      <!-- CdtrRefInf/Ref -->
  </xsl:template>
  
</xsl:stylesheet>
