<?xml version="1.0" encoding="utf-8" ?>
<!--Nemam dukaz o tom, ze by se tento soubor pouzival, viz cz.winstrom.elcom.ECR.receivePLUs-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:template match="winstrom">
	<winstrom>
            <pokladni-pohyb>
                <typPohybuK>typPohybu.prijem</typPohybuK>
                <mena>code:CZK</mena>
                <bsp>code:<xsl:value-of select="java:flexibee.Tool.toUpper(java:flexibee.Tool.params('pokladna'))" /></bsp>
                <typDokl>code:<xsl:choose>
			    <xsl:when test="java:flexibee.Tool.params('typ-dokl') != ''"><xsl:value-of select="java:flexibee.Tool.toUpper(java:flexibee.Tool.params('typ-dokl'))"/></xsl:when>
			    <xsl:otherwise>STANDARD</xsl:otherwise>
                </xsl:choose></typDokl>
                <formaUhrK>formaUhr.hotove</formaUhrK>
                <polozkyIntDokladu removeAll="true">
                        <xsl:apply-templates select="*"/>
                </polozkyIntDokladu>
            </pokladni-pohyb>
	</winstrom>
    </xsl:template>

    <!--
    PLU_ID
    BARCODE
    NAME
    DESC
    SOLE
    PRINT_STOCK
    NEG
    FRAC
    UNIT_ID
    DPT_ID
    SALE
    HALO
    TAX_ID
    LPLU1
    PRICE
    STOCK
    NUMBER
    AMOUNT
    -->

    <xsl:template match="//winstrom/*">
        <xsl:if test="AMOUNT &gt; 0">
	            <pokladni-pohyb-polozka>
                        <cenik>[plu:<xsl:value-of select="java:flexibee.Tool.padNumber(4, PLU_ID)"/>][plu:<xsl:value-of select="PLU_ID"/>]<xsl:if test="BARCODE != ''">[ean:<xsl:value-of select="BARCODE"/>]</xsl:if></cenik>
                        <sklad>code:<xsl:value-of select="java:flexibee.Tool.toUpper(java:flexibee.Tool.params('terminal-store'))"/></sklad>
<!--                        <nazev><xsl:value-of select="NAME"/></nazev> -->
                        <typPolozkyK>typPolozky.katalog</typPolozkyK>
                        <mnozMj><xsl:value-of select="NUMBER"/></mnozMj>
                        <cenaMj><xsl:value-of select="AMOUNT div NUMBER"/></cenaMj>
                    </pokladni-pohyb-polozka>
        </xsl:if>
    </xsl:template>

</xsl:stylesheet>