<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
    <!-- import VOIP pro GA Holding -->
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

	<!-- vytvoření indexu pro sloučení duplicitních záznamů -->
	<xsl:key name="cisloKey" match="row" use="cislo-zakaznika"/>

<!--
  Ukázkové XML vytvořené z CSV 
  <row>
    <id>29219</id>
    <cislo-zakaznika>561019000</cislo-zakaznika>
    <datum>2011-12-13 08:19:12</datum>
    <volajici-cislo>561019000</volajici-cislo>
    <nazev-destinace>Czech republic</nazev-destinace>
    <volane-cislo>561019003</volane-cislo>
    <smer-hovoru>sipsip</smer-hovoru>
    <uctovany-cas>163</uctovany-cas>
    <cena-hovoru-NT>0.978</cena-hovoru-NT>
    <cena-hovoru>1.5485</cena-hovoru>
  </row>

-->
    <xsl:template match="/">
		<winstrom version="1.0">
	    	<xsl:apply-templates />
	    </winstrom>
    </xsl:template>

    <xsl:template match="/winstrom/row">
       		<xsl:if test="(generate-id(.) = generate-id(key('cisloKey', cislo-zakaznika)[1])) and cislo-zakaznika != 'N/A' and sum(key('cisloKey', cislo-zakaznika)[smer-hovoru!='incoming' and smer-hovoru!='sipsip']/cena-hovoru) != 0.0">
        		<xsl:variable name="cislo" select="concat('420', cislo-zakaznika)"/>
        		<xsl:variable name="mapovani" select="document('mapovani.xml')/winstrom/smlouva-polozka[kod=$cislo]"/>
        		<smlouva create="fail">
        			<xsl:choose>
        				<xsl:when test="$mapovani/smlouva != ''">
							<id><xsl:value-of select="$mapovani/smlouva"/></id>
						</xsl:when>
						<xsl:otherwise>
							<id>Neznáme číslo <xsl:value-of select="$cislo"/></id>						
						</xsl:otherwise>
					</xsl:choose>
					<xsl:value-of select="'&lt;!--'"/>
					<xsl:value-of select="$cislo"/>
					<xsl:value-of select="'--&gt;'"/>
					<polozkySmlouvyExt>
						<smlouva-polozka>
	    					<id>ext:VOIP:<xsl:value-of select="id"/></id>
	<a><xsl:value-of select="java:flexibee.Tool.parseDate(key('cisloKey', cislo-zakaznika)[1]/datum, 'yyyy-MM-dd')"/></a>
    						<nazev><xsl:value-of select="$mapovani/nazev"/><xsl:value-of select="' - '"/><xsl:value-of select="$cislo"/> - <xsl:value-of select="java:flexibee.Tool.formatDate(java:flexibee.Tool.firstDayOfMonth(java:flexibee.Tool.parseDate(key('cisloKey', cislo-zakaznika)[1]/datum, 'yyyy-MM-dd')), 'd.M.yyyy')"/> - <xsl:value-of select="java:flexibee.Tool.formatDate(java:flexibee.Tool.lastDayOfMonth(java:flexibee.Tool.parseDate(key('cisloKey', cislo-zakaznika)[1]/datum, 'yyyy-MM-dd')), 'd.M.yyyy')"/> (<xsl:value-of select="format-number(java:flexibee.Tool.round(sum(key('cisloKey', cislo-zakaznika)[smer-hovoru!='incoming' and smer-hovoru!='sipsip']/uctovany-cas) div 100, '0'), '0')" /> minut)</nazev>
    						<kod><xsl:value-of select="cislo-zakaznika"/></kod>
    						<mnozMj>1</mnozMj>
    						<frekFakt>0</frekFakt>
	    					<cenaRucne>true</cenaRucne>
		    				<cenaMj><xsl:value-of select="java:flexibee.Tool.round(sum(key('cisloKey', cislo-zakaznika)[smer-hovoru!='incoming' and smer-hovoru!='sipsip']/cena-hovoru), '2')" /></cenaMj>
    						<typCenyDphK>typCeny.bezDph</typCenyDphK>
    						<typSzbDphK>typSzbDph.dphZakl</typSzbDphK>
	    				</smlouva-polozka>
					</polozkySmlouvyExt>
    			</smlouva>
	    	</xsl:if>		
    </xsl:template>

</xsl:stylesheet>
