set character_set_server='utf8';
set character_set_database='utf8';

select 
	cu.klient_number, 
	'' as nazev_smlouvy, 
	cu.ico, 
	cu.dic, 
	cu.stav, 
	concat('a',sl.id) as id, 
	sl.username, 
	sl.klientid, 
	c_smlouvy, 
	vratna_zaloha,
	inst_poplatek,
	fakt_obdobi, 
	1 as pocet, 
	pausalni_cena, 
	sl.cena, 
	sl.zkratka, 
	delka_smlouvy, 
	parentuser, 
	IF (delka_smlouvy != 0, (cast(from_unixtime(pripojen_od) as date) + interval delka_smlouvy month), null) as zavazek_do,
	cast(from_unixtime(fakturovat_od) as date) as platnost_od, 
	cast(from_unixtime(pripojen_od) as date) as pripojen_od, 
	IF(trvani_smlouvy_do != 0, cast(from_unixtime(trvani_smlouvy_do) as date), null) as platnost_do, 
	ulice_inst, 
	psc_inst, 
	mesto_inst, 
	cast(from_unixtime(fakturovat_od) as date) as fakturovat_od, 
	ct.zkratka as tarif_zkratka, 
	ct.popis as tarif_popis, 
	ct.id as tarif_id, 
	ct.cena as tarif_cena, 
	sl.userip as userip, 
	sl.usermac as usermac, 
	sl.poznamka as poznamka, 
	sl.vernostni_sleva, 
	sl.vernostni_sleva_nazev, 
	sl.pausalni_poznamka, 
	(select greatest(1, max(sl2.fakt_obdobi)) from sl_internet sl2 where sl2.klientid = sl.klientid) as max_fakt_obdobi,
	cast(from_unixtime((select min(sl2.pripojen_od) from sl_internet sl2 where sl2.klientid = sl.klientid)) as date)  as max_pripojen_od 
from sl_internet sl inner join cable_users cu on cu.id = sl.klientid left join cable_tarif ct on ct.id = sl.tarif where sl.visible = 1 and cu.visible = 1
union 
select 
	cu.klient_number, 
	sl.nazev as nazev_smlouvy, 
	cu.ico, 
	cu.dic, 
	cu.stav, 
	concat('b',sl.id) as id, 
	sl.username, 
	sl.klientid, 
	c_smlouvy, 
	0 as vratna_zaloha,
	0 as inst_poplatek,
	fakt_obdobi, 
	pocet, 
	0.0 as pausalni_cena, 
	cena_ks as cena, 
	items.nazev as zkratka, 
	'' as delka_smlouvy, 
	0 as parentuser, 
	null as zavazek_do,
	cast(from_unixtime(fakturovat_od) as date) as platnost_od, 
	cast(from_unixtime(pripojen_od) as date) as pripojen_od, 
	null as platnost_do, 
	ulice_inst, 
	psc_inst, 
	mesto_inst, 
	cast(from_unixtime(fakturovat_od) as date) as fakturovat_od, 
	'' as tarif_zkratka, 
	'' as tarif_popis, 
	0 as tarif_id, 
	0.0 as tarif_cena, 
	'' as userip, 
	'' as usermac, 
	'' as poznamka, 
	0.0 as vernostni_sleva, 
	'' as vernostni_sleva_nazev, 
	'' as pausalni_poznamka,
	(select greatest(1, max(sl2.fakt_obdobi)) from sl_universal sl2 where sl2.klientid = sl.klientid) as max_fakt_obdobi,
	cast(from_unixtime((select min(sl2.pripojen_od) from sl_universal sl2 where sl2.klientid = sl.klientid)) as date)  as max_pripojen_od 
from sl_universal sl inner join cable_users cu on cu.id = sl.klientid inner join sl_universal_items items on items.slid = sl.id where sl.visible = 1 and cu.visible = 1
union 
select 
	cu.klient_number, 
	sl.nazev as nazev_smlouvy, 
	cu.ico, 
	cu.dic, 
	cu.stav, 
	concat('c', sl.id) as id,
	sl.username, 
	sl.klientid, 
	c_smlouvy, 
	0 as vratna_zaloha,
	inst_poplatek,
	fakt_obdobi, 
	1 as pocet, 
	pausalni_cena, 
	0.0 as cena, 
	tel as zkratka, 
	'' as delka_smlouvy, 
	0 as parentuser, 
	null as zavazek_do,
	cast(from_unixtime(fakturovat_od) as date) as platnost_od, 
	cast(from_unixtime(pripojen_od) as date) as pripojen_od, 
	null as platnost_do, 
	ulice_inst, 
	psc_inst, 
	mesto_inst, 
	cast(from_unixtime(fakturovat_od) as date) as fakturovat_od, 
	ct.zkratka as tarif_zkratka, 
	ct.nazev as tarif_popis, 
	concat('tel-', sl.tel) as tarif_id, 
	0.0 as tarif_cena, 
	ip as userip, 
	'' as usermac, 
	poznamka, 
	0.0 as vernostni_sleva, 
	'' as vernostni_sleva_nazev, 
	pausalni_poznamka,
	(select greatest(1, max(sl2.fakt_obdobi)) from sl_voip sl2 where sl2.klientid = sl.klientid) as max_fakt_obdobi,
	cast(from_unixtime((select min(sl2.pripojen_od) from sl_voip sl2 where sl2.klientid = sl.klientid)) as date)  as max_pripojen_od 
from sl_voip sl inner join cable_users cu on cu.id = sl.klientid left join tarif_voip ct on ct.id = sl.tarif where sl.visible = 1 and cu.visible = 1;
