<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
  
  <xsl:output method="xml" indent="yes" encoding="utf-8" />
  <xsl:template match="winstrom">
    <winstrom version="1.0">
      <xsl:apply-templates select="faktura-prijata"/>
    </winstrom>
  </xsl:template>
    
    <!--
	    
CISLO,N,11,0
DOKLAD,C,10
STORNO,N,11,0
RADA,C,5
CISRADA,N,11,0
UDOKLAD,C,10
POPIS,C,50
DODAVATEL,N,11,0
D_NAZEV,C,50
D_ULICE,C,30
D_MESTO,C,40
D_PSC,C,10
D_STAT,C,20
D_ICO,C,10
D_DIC,C,20
D_JMENO,C,50
D_NAZEVOB,C,50
D_ULICEOB,C,30
D_MESTOOB,C,40
D_PSCOB,C,10
D_STATOB,C,20
VYSTAVENO,D
DATUCPR,D
PLNENODPH,D
SPLATNO,D
UHRAZENO,D
DORUCENO,D
KONSTSYM,C,4
KODDPH,C,10
VARSYMBOL,C,20
SPECSYMBOL,C,20
PRIJATDOKL,C,50
PARSYMBOL,C,20
ZAKAZKA,C,10
UCET,C,10
DRUH,C,1
DOBROPIS,L
UHRADA,C,20
PREDKONTAC,C,10
CINNOST,C,10
DODBANSPOJ,N,11,0
SAZBADPH1,N,15,4
SAZBADPH1V,N,15,4
METODADPH1,C,1
SAZBADPH2,N,15,4
SAZBADPH2V,N,15,4
METODADPH2,C,1
KUHRADESDP,N,15,4
PROPLATIT,N,15,4
VYUCTOVANO,L
SLEVA,N,15,4
SLEVAPOL,N,15,4
ZAKLAD_0,N,15,4
ZAKLAD_1,N,15,4
ZAKLAD_2,N,15,4
DPH_1,N,15,4
DPH_2,N,15,4
KOREKCECEN,L
TYP,C,10
VYSTAVIL,C,50
DATVYST,D
CASVYST,C,5
PRIKUHRADY,D
PRIUHRZBYV,N,15,4
STREDISKO,C,10
FLAGDEL,L
MENA,C,4
POCETJEDN,N,11,0
KURS,N,15,4
VALUTYKUHR,N,15,4
VALUTYPROP,N,15,4
VALUTYZAK0,N,15,4
VALUTYZAK1,N,15,4
VALUTYZAK2,N,15,4
VALUTYDPH1,N,15,4
VALUTYDPH2,N,15,4
NOEXPIMP,N,11,0
SLAVE,N,3,0
TYPOP,N,3,0
DUMMY,L
DATSKPOH,D
UZAMCENI,L
SUMZALOHA,N,15,4
SUMZALOHAC,N,15,4
DATEUPOM1,D
DATEUPOM2,D
DATEUPOML,D
POZNAMKA,M
DOKUMENTY,M
TYPTRANS,C,2
DODACIPODM,C,3
DRUHDOPR,C,1
DOPRAVTUZ,N,15,4
DOPRAVZAHR,N,15,4
DATUMITS,D
VERSION,N,11,0


    -->

  <xsl:template match="faktura-prijata">
  
    <faktura-prijata>
      <id>ext:moneyS3:FP<xsl:value-of select="CISLO"/></id>
      <id>ext:moneyS3:FP<xsl:value-of select="DOKLAD"/></id>
      <kod>FP<xsl:value-of select="DOKLAD"/></kod>
      <nazev><xsl:value-of select="java:flexibee.Tool.trim(POPIS)"/></nazev>
      <typDokl>code:FAKTURA</typDokl>
      <typUcOp></typUcOp>
      
      <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(VYSTAVENO, 'd.M.y')"/></datVyst>
      <datSplat><xsl:value-of select="java:flexibee.Tool.parseDate(SPLATNO, 'd.M.y')"/></datSplat>
      <bezPolozek>true</bezPolozek>
      
      <xsl:if test="ZAKAZKA != ''">
        <cisObj><xsl:value-of select="ZAKAZKA"/></cisObj>
      </xsl:if>
      
      <xsl:if test="PLNENODPH != ''">
        <duzpPuv><xsl:value-of select="java:flexibee.Tool.parseDate(PLNENODPH, 'd.M.y')"/></duzpPuv>
      </xsl:if>
      
      <cisDosle>
        <xsl:choose>
          <xsl:when test="PRIJATDOKL != ''">
            <xsl:value-of select="PRIJATDOKL"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="DOKLAD"/>
          </xsl:otherwise>
        </xsl:choose>
      </cisDosle>
      
      <!-- bankovní věci -->
      <xsl:choose>
        <xsl:when test="VARSYMBOL != ''">
          <varSym><xsl:value-of select="VARSYMBOL"/></varSym>
        </xsl:when>
        <xsl:otherwise>
          <varSym><xsl:value-of select="DOKLAD"/></varSym>
        </xsl:otherwise>
      </xsl:choose>
      
      <konSym>code:<xsl:value-of select="java:flexibee.Tool.padNumber(4,KONSTSYM)"/></konSym>
      <szbDphSniz><xsl:value-of select="java:flexibee.Tool.parseMoney(SAZBADPH1)"/></szbDphSniz>
      <szbDphZakl><xsl:value-of select="java:flexibee.Tool.parseMoney(SAZBADPH2)"/></szbDphZakl>
            
      <xsl:choose>
        <xsl:when test="MENA != ''">
          <sumOsvMen><xsl:value-of select="java:flexibee.Tool.parseMoney(VALUTYKUHR)"/></sumOsvMen>
          <mena>code:<xsl:value-of select="java:flexibee.Tool.toUpper(MENA)"/></mena>
          <kurz><xsl:value-of select="java:flexibee.Tool.parseMoney(KURS)"/></kurz>
          <kurzMnozstvi><xsl:value-of select="java:flexibee.Tool.parseMoney(POCETJEDN)"/></kurzMnozstvi>
        </xsl:when>
        <xsl:otherwise>
          <xsl:choose>
            <xsl:when test="ZAKLAD_0 != '0'">
              <sumOsv><xsl:value-of select="java:flexibee.Tool.parseMoney(ZAKLAD_0)"/></sumOsv>
            </xsl:when>
            <xsl:when test="ZAKLAD_1 != '0'">
              <sumZklSniz><xsl:value-of select="java:flexibee.Tool.parseMoney(ZAKLAD_1)"/></sumZklSniz>
            </xsl:when>
            <xsl:when test="ZAKLAD_2 != '0'">
              <sumZklZakl><xsl:value-of select="java:flexibee.Tool.parseMoney(ZAKLAD_2)"/></sumZklZakl>
            </xsl:when>
          </xsl:choose>
        </xsl:otherwise>
      </xsl:choose>
      
      <xsl:if test="DODAVATEL != ''">
        <firma>code:M<xsl:value-of select="java:flexibee.Tool.toUpper(DODAVATEL)"/></firma>
        <nazFirmy><xsl:value-of select="D_NAZEV"/></nazFirmy>
        <ulice><xsl:value-of select="D_ULICE"/></ulice>
        <mesto><xsl:value-of select="D_MESTO"/></mesto>
        <psc><xsl:value-of select="DPSC"/></psc>
        <ic><xsl:value-of select="D_ICO"/></ic>
        <dic><xsl:value-of select="D_DIC"/></dic>
        <stat></stat>
      </xsl:if>
      
      <!--<xsl:if test="java:flexibee.Tool.isNumber(UCET_ODB)">
        <buc><xsl:value-of select="UCET_ODB"/></buc>
        <smerKod>code:<xsl:value-of select="KOD_ODB"/></smerKod>
      </xsl:if>
      
      <xsl:if test="not(java:flexibee.Tool.isNumber(UCET_ODB))">
        <iban><xsl:value-of select="UCET_ODB"/></iban>
        <bic><xsl:value-of select="KOD_ODB"/></bic>
      </xsl:if>-->
      
      <formaUhrK>
        <xsl:choose>
          <xsl:when test="UHRADA = 'Hotově'">formaUhr.hotove</xsl:when>
          <xsl:otherwise>formaUhr.prevod</xsl:otherwise>
        </xsl:choose>
      </formaUhrK>
    </faktura-prijata>
    
  </xsl:template>
</xsl:stylesheet>