<?xml version="1.0" encoding="utf-8" ?>
<!--ve sloupci popis u polozky "Systémové zaokrouhlení CM" není uvedená měna-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java" >
  <xsl:output method="xml" indent="yes" encoding="utf-8" />
  <xsl:template match="winstrom">
    <winstrom version="1.0">
      <bankovni-ucet>
        <id>ext:moneyS3:UCET MIGRACE</id>
        <kod>UCET MIGRACE</kod>
        <nazev>UCET MIGRACE</nazev>
        <typDoklK>typDokladu.proforma</typDoklK>
        <bucPrimarni>false</bucPrimarni>
        <primUcet>code:221001</primUcet>
      </bankovni-ucet>
      <xsl:apply-templates select="sparovani"/>
    </winstrom>
  </xsl:template>
    <!--

CISLO,N,11,0
CISLOSKPOL,N,11,0
TYPEPOL,N,3,0
POPIS,C,50
POZNAMKA,M
CISLOKAT,C,20
TEXTMJ,C,10
POCETMJ,N,15,4
SAZBADPH,N,15,4
CENA,N,15,4
CENATYP,N,3,0
SLEVA,N,15,4
SLEVAZAKL,N,15,4
CINNOST,C,10
PORADI,N,11,0
KODDPH,C,10
STREDISKO,C,10
ZAKAZKA,C,10
PREDKONTAC,C,10
TYPZARUKA,C,1
ZARUKA,N,5,0
VALUTY,N,15,4
DUMMY,L
NAKLADY,L
ZALOHA,L
CISLOZAFAK,N,11,0
ROKZAFAK,C,3
ZFCASTKAV,N,15,4
KURZVD,N,15,4
POCETVD,N,11,0
BEZIDKURZR,L
KRPORADI,N,11,0
PROTIZAPIS,L
TYPTRANS,C,2
KODSTPUV,C,2
HMOTNOST,N,15,4
TYPZDROJ,C,2
CENAUZIV,L
PLNENODPH,D

    -->
  
  <xsl:template match="sparovani">
  
  <xsl:if test="CASTKA != '0'">
  
            
                <banka>
                  <id>ext:moneyS3:banka:<xsl:value-of select="TYPEHDOKL"/><xsl:value-of select="CISLOHDOKL"/></id>
                  <kod><xsl:value-of select="TYPEHDOKL"/><xsl:value-of select="CISLOHDOKL"/></kod>
                  <typDokl>code:UCET MIGRACE</typDokl>
                  <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(DATUM, 'd.M.y')"/></datVyst>
                  <bezPolozek>false</bezPolozek>
                
                  <xsl:choose> 
            		    <xsl:when test="PRIJEM = 'false'">
            			    <typPohybuK>typPohybu.vydej</typPohybuK>
            		    </xsl:when>
            		    <xsl:when test="PRIJEM!= 'true'">
            			    <typPohybuK>typPohybu.prijem</typPohybuK>
            		    </xsl:when>
            		  </xsl:choose>
                  
                  <xsl:choose> 
            		    <xsl:when test="MENA != ''">
            			    <mena>code:<xsl:value-of select="java:flexibee.Tool.toUpper(MENA)"/></mena>
            			    <kurz><xsl:value-of select="java:flexibee.Tool.parseMoney(KURS)"/></kurz>
            			    <kurzMnozstvi><xsl:value-of select="java:flexibee.Tool.parseMoney(M_KURS)"/></kurzMnozstvi>
            		    </xsl:when>
            		  </xsl:choose>
                  
                  
                  <polozkyIntDokladu>
                    <banka-polozka>
                      <id>ext:PREMIER:banka:POL<xsl:value-of select="PORADI"/></id>
                      <nazev><xsl:value-of select="java:flexibee.Tool.trim(POPIS)"/></nazev>
                      <sumZkl><xsl:value-of select="java:flexibee.Tool.parseMoney(CASTKA)"/></sumZkl>
            			    <typSzbDphK><xsl:value-of select="java:flexibee.Tool.vatToCode(SAZBA_DPH)"/></typSzbDphK>
                      <typCenyDphK>typCeny.bezDph</typCenyDphK>
                      <szbDph><xsl:value-of select="java:flexibee.Tool.parseMoney(SAZBA_DPH)"/></szbDph>
                    </banka-polozka>
                  </polozkyIntDokladu>
                </banka>
          
	  </xsl:if>
	  
  </xsl:template>
</xsl:stylesheet>