<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
  <xsl:output method="xml" indent="yes" encoding="UTF-8"/>
  <xsl:template match="winstrom">
    <winstrom version="1.0">
      <xsl:apply-templates select="faktura-prijata"/>
    </winstrom>
  </xsl:template>
  
    <!--
    
TERC,N,1,0
FAKTURA,N,8,0
TEXT,C,96
MNOZSTVI,N,12,3
MJ,C,6
CENA_MJ,N,15,3
CENA_SLV,N,14,2
SLEVA_PR,N,6,2
CENA_DPH,N,14,2
CENA,N,14,2
SAZBA_DPH,N,5,2
KOD_DPH,C,2
MATERIAL,N,8,0
ZDROJ,N,1,0
OPERACE,C,3
ANALYT,C,3
UC_S,C,3
UC_SA,C,3
UC_D,C,3
UC_DA,C,3
ZKKOD,N,12,0
STKOD,N,12,0
PUB_INT,N,8,0
PUB_DINT,N,8,0
POL_INT,N,8,0
POL_SORT,N,8,0
POL_TER,N,8,0
POL_KOD,C,1
SLEVA,N,14,2
DAN1,N,12,0
DAN2,N,12,0
DAN3,C,12
VAP,N,15,2
VAP_PR,N,7,2
TS,C,40
ID,C,36
VS,C,12
PORDER,N,5,0
POMER,N,1,0
PROCENT,N,5,2
ZAKLADNA,N,14,2
ZLOMEK_1,N,4,0
ZLOMEK_2,N,4,0
IN_STATU,C,2
IN_STATP,C,2
IN_KRAJP,C,2
IN_KG,N,12,3
IN_MNOZ2,N,12,3
IN_TRAN,N,2,0
IN_DODP,C,3
IN_DOPR,N,1,0
IN_SZNAK,C,3
IN_KOD,C,10
IN_ZVLP,C,2
IN_NOTIST,L
IN_DIC,C,2
ROZL_OD,D
ROZL_DO,D
ROZL_AKT,L
INT_VS,C,12
      
	  -->

  <xsl:template match="faktura-prijata">
  
      <xsl:if test="SB_KOD = 'PF'">
        <faktura-prijata create="ignore">
          <id>ext:PREMIER:FP<xsl:value-of select="CISLO"/></id>
          <bezPolozek>false</bezPolozek>
          <zaokrNaSumK showAs="!nezaokrouhlovat">zaokrNa.zadne</zaokrNaSumK>
          <zaokrNaDphK showAs="!nezaokrouhlovat">zaokrNa.zadne</zaokrNaDphK>
          <polozkyFaktury>
            <faktura-prijata-polozka>
              <id>ext:PREMIER:POL<xsl:value-of select="ID" /></id>
              <typPolozkyK>typPolozky.ucetni</typPolozkyK>
              <nazev><xsl:value-of select="java:flexibee.Tool.trim(POPIS)"/></nazev>
    		      <sumZkl><xsl:value-of select="java:flexibee.Tool.parseMoney(CASTKA)"/></sumZkl>
    		      <kopZklDalUcet>false</kopZklDalUcet>
              <kopZklMdUcet>false</kopZklMdUcet>
    		      <zklMdUcet>code:<xsl:value-of select="MD"/></zklMdUcet>
              <zklDalUcet>code:<xsl:value-of select="DAL"/></zklDalUcet>
              <typSzbDphK><xsl:value-of select="java:flexibee.Tool.vatToCode(SAZBA_DPH)"/></typSzbDphK>
              <typCenyDphK>typCeny.bezDph</typCenyDphK>
              <szbDph><xsl:value-of select="java:flexibee.Tool.parseMoney(SAZBA_DPH)"/></szbDph>
              <zdrojProSkl>false</zdrojProSkl>
              <doklFak>ext:PREMIER:FP<xsl:value-of select="CISLO"/></doklFak>
            </faktura-prijata-polozka>
          </polozkyFaktury>
        </faktura-prijata>
      </xsl:if>
    
  </xsl:template>

</xsl:stylesheet>
