<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
  <xsl:output method="xml" indent="yes" encoding="utf-8" />
  <xsl:template match="winstrom">
    <winstrom version="1.0">
      <xsl:apply-templates select="faktura-vydana-zaloha"/>
    </winstrom>
  </xsl:template>

    <!--
	    
INTER,N,8,0
DOKLAD,C,3
CISLO,N,12,0
ZKKOD,N,12,0
STKOD,N,12,0
K_SYMBOL,C,4
OBJEDNAVKA,C,32
DOD_LIST,C,24
BANKA_DOKL,C,3
BANKA_NAZ,C,24
BANKA_KOD,C,4
BANKA_UCET,C,24
PLATCE_DPH,L
FORMA,C,20
DATUM_USK,D
DATUM_VYS,D
DATUM_SPL,D
CELKEM,N,15,2
ZALOHA,N,15,2
ZAOK,N,6,2
ZAOK_ROUND,N,2,0
VYSTAVIL,C,24
CISLO_ODB,C,10
NAZEV_ODB,C,64
NAZEV_OD2,C,64
ULICE_ODB,C,64
PSC_ODB,C,10
MESTO_ODB,C,28
STAT_ODB,C,24
ICO_ODB,C,8
DIC_ODB,C,14
KON_PRIJEM,C,96
DOPRAVA,C,96
POZNAMKA,C,48
PRILOHY,C,48
MENA,C,3
OZN_MENY,C,3
MENA_PRED,L
SAZ_DPH1,N,5,2
SAZ_DPH2,N,5,2
HLAVICKA,C,240
HLAVICKA2,C,240
HLAVICKA3,C,240
HLAVICKA4,C,240
HLAVICKA5,C,240
HLAVICKA6,C,240
PATICKA,C,240
UC_VF,C,3
UC_VFA,C,3
UC_Z,C,3
UC_ZA,C,3
UC_OK,C,3
UC_OKA,C,3
KURS,N,18,10
M_KURS,N,5,0
RDPH,N,1,0
POPIS,C,48
PUB_ZINT,N,8,0
US_ADD,C,16
US_EDI,C,16
USD_ADD,C,16
USD_EDI,C,16
Z_OPERACE,C,2
Z_ANALYT,C,2
IS_DOKLAD,L
UROK,N,7,3
UR_DOBA,N,1,0
DAN1,N,12,0
DAN2,N,12,0
DAN3,C,12
PUB_OINT,N,8,0
NETTO,N,15,3
BRUTTO,N,15,3
OBJ_VYS,D
OBJ_SPL,D
RIDIC,C,64
PATICKA2,C,240
TS,C,40
ID,C,36
ZAL_VS,C,12
VS,C,10
SKONTO,N,5,2
SKONTO_POP,C,24
TELO,C,240
TELO2,C,240
JAKE_USK,N,1,0
DIC_EU,C,24
TELO3,C,240
TELO4,C,240
PUV_DOKL,N,12,0
DATUM_DPH,D
STATUS,C,12
UC_OKST,N,12,0
KURS_DPH,N,18,10
KOR_MENA,N,4,2
KURS_EU,N,18,10
BARVA,N,8,0
ID_KON,C,36
WORK_STAT,C,2
WORK_ID,C,36
WORK_KOD,C,12

    -->

  <xsl:template match="faktura-vydana-zaloha">
  
    <faktura-vydana>
      <id>ext:PREMIER:Zfak:<xsl:value-of select="INTER"/></id>
      <kod>FV<xsl:value-of select="CISLO"/></kod>
      <nazev><xsl:value-of select="POPIS"/></nazev>
      <typDokl>code:ZÁLOHA</typDokl>
      <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(DATUM_VYS, 'd.M.y')"/></datVyst>
      <datSplat><xsl:value-of select="java:flexibee.Tool.parseDate(DATUM_SPL, 'd.M.y')"/></datSplat>
      <bezPolozek>true</bezPolozek>
      <xsl:if test="OBJEDNAVKA != ''">
        <cisObj><xsl:value-of select="OBJEDNAVKA"/></cisObj>
      </xsl:if>
      <xsl:if test="DATUM_USK != ''">
        <duzpPuv><xsl:value-of select="java:flexibee.Tool.parseDate(DATUM_USK, 'd.M.y')"/></duzpPuv>
      </xsl:if>
      <cisDosle><xsl:value-of select="DOKLAD"/>/<xsl:value-of select="CISLO"/>
        <!--<xsl:choose>
          <xsl:when test="ZKKOD != '0' and ZKKOD != ''">
            <xsl:value-of select="ZKKOD"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="DOKLAD"/>/<xsl:value-of select="CISLO"/>
          </xsl:otherwise>
        </xsl:choose>-->
      </cisDosle>
      <!-- bankovní věci -->
      <varSym><xsl:value-of select="CISLO"/></varSym>
      <konSym>code:<xsl:value-of select="K_SYMBOL"/></konSym>
      <szbDphSniz><xsl:value-of select="java:flexibee.Tool.parseMoney(SAZ_DPH1)"/></szbDphSniz>
      <szbDphZakl><xsl:value-of select="java:flexibee.Tool.parseMoney(SAZ_DPH2)"/></szbDphZakl>
      <xsl:choose>
        <xsl:when test="MENA != ''">
          <sumOsvMen><xsl:value-of select="java:flexibee.Tool.parseMoney(CELKEM)"/></sumOsvMen>
          <mena>code:<xsl:value-of select="java:flexibee.Tool.toUpper(MENA)"/></mena>
          <kurz><xsl:value-of select="java:flexibee.Tool.parseMoney(KURS)"/></kurz>
          <kurzMnozstvi><xsl:value-of select="java:flexibee.Tool.parseMoney(M_KURS)"/></kurzMnozstvi>
        </xsl:when>
        <xsl:otherwise>
          <sumOsv><xsl:value-of select="java:flexibee.Tool.parseMoney(CELKEM)"/></sumOsv>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:if test="CISLO_ODB != ''">
        <firma>code:<xsl:value-of select="java:flexibee.Tool.toUpper(CISLO_ODB)"/></firma>
        <nazFirmy><xsl:value-of select="NAZEV_ODB"/></nazFirmy>
        <ulice><xsl:value-of select="ULICE_ODB"/></ulice>
        <mesto><xsl:value-of select="MESTO_ODB"/></mesto>
        <psc><xsl:value-of select="PSC_ODB"/></psc>
        <ic><xsl:value-of select="ICO_ODB"/></ic>
        <dic><xsl:value-of select="DIC_ODB"/></dic>
        <stat></stat>
      </xsl:if>
      <xsl:if test="java:flexibee.Tool.isNumber(UCET_ODB)">
        <buc><xsl:value-of select="UCET_ODB"/></buc>
        <smerKod>code:<xsl:value-of select="KOD_ODB"/></smerKod>
      </xsl:if>
      <xsl:if test="not(java:flexibee.Tool.isNumber(UCET_ODB))">
        <iban><xsl:value-of select="UCET_ODB"/></iban>
        <bic><xsl:value-of select="KOD_ODB"/></bic>
      </xsl:if>
      <formaUhrK>
        <xsl:choose>
          <xsl:when test="FORMA = 'Hotově'">formaUhr.hotove</xsl:when>
          <xsl:otherwise>formaUhr.prevod</xsl:otherwise>
        </xsl:choose>
      </formaUhrK>
    </faktura-vydana>
    
  </xsl:template>
</xsl:stylesheet>