<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
  <xsl:output method="xml" indent="yes" encoding="utf-8" />
  <xsl:template match="MoneyData">
    <winstrom version="1.0">
      <xsl:apply-templates select="./SeznamFaktVyd/FaktVyd[1]/MojeFirma" />
    </winstrom>
  </xsl:template>
  
  <xsl:template match="MojeFirma">
  <nastaveni>
    <id>1</id>
    <nazFirmy><xsl:value-of select="Nazev"/></nazFirmy>
    <uliceNazev><xsl:value-of select="./Adresa/Ulice"/></uliceNazev>
    <mesto><xsl:value-of select="./Adresa/Misto"/></mesto>
    <psc><xsl:value-of select="./Adresa/PSC"/></psc>
    
    <!-- obchodni adresa neni fakturacni adresa -->
    <xsl:if test="./ObchAdresa and (./Adresa/Ulice != ./ObchAdresa/Ulice or ./Adresa/Misto != ./ObchAdresa/Misto
      or ./Adresa/PSC != ./ObchAdresa/PSC)">
      <fakturacniShodna>false</fakturacniShodna>
      <faUliceNazev><xsl:value-of select="./ObchAdresa/Ulice"/></faUliceNazev>
      <faMesto><xsl:value-of select="./ObchAdresa/Misto"/></faMesto>
      <faPsc><xsl:value-of select="./ObchAdresa/PSC"/></faPsc>
    </xsl:if>
    
    <xsl:if test="normalize-space(./Tel/Cislo) != ''">
      <tel><xsl:if test="normalize-space(./Tel/Pred) != ''"><xsl:value-of select="./Tel/Pred"/></xsl:if><xsl:value-of select="./Tel/Cislo"/><xsl:if test="./Tel/Klapka">-<xsl:value-of select="./Tel/Klapka"/></xsl:if></tel>
    </xsl:if>
    
    <xsl:if test="normalize-space(./Tel/Cislo) != ''">
      <fax><xsl:if test="normalize-space(./Fax/Pred) != ''"><xsl:value-of select="./Fax/Pred"/></xsl:if><xsl:value-of select="./Fax/Cislo"/><xsl:if test="./Fax/Klapka">-<xsl:value-of select="./Fax/Klapka"/></xsl:if></fax>
    </xsl:if>
    
    <xsl:if test="normalize-space(./Mobil/Cislo) != ''">
      <mobil><xsl:if test="normalize-space(./Mobil/Pred) != ''"><xsl:value-of select="./Mobil/Pred"/></xsl:if><xsl:value-of select="./Mobil/Cislo"/><xsl:if test="./Mobil/Klapka">-<xsl:value-of select="./Mobil/Klapka"/></xsl:if></mobil>
    </xsl:if>
    
    <email><xsl:value-of select="Email"/></email>
    <www><xsl:value-of select="WWW"/></www>
    
    <ic><xsl:value-of select="ICO"/></ic>
    <dic><xsl:value-of select="DIC"/></dic>
    
    <mena>code:<xsl:value-of select="MenaKod"/></mena>
  </nastaveni>
  </xsl:template>
</xsl:stylesheet>