<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
  <xsl:output method="xml" indent="yes" encoding="utf-8" />
  <xsl:template match="MoneyData">
    <winstrom version="1.0">
      <pokladna update="ignore">
        <id>code:POKLADNA UHRAD</id>
        <kod>POKLADNA UHRAD</kod>
        <nazev>Pokladna pro úhrady faktur</nazev>
        <popis>Pokladna pro přidávaní úhrad z vydaných faktur. Úhrady budou navázány na jejich vydané faktury.</popis>
        <radaPrijem>code:POKLADNA+</radaPrijem>
        <radaVydej>code:POKLADNA-</radaVydej>
      </pokladna>
      
      <xsl:apply-templates select="./SeznamFaktVyd/FaktVyd/SeznamUhrad"/>
    </winstrom>
  </xsl:template>

  <xsl:template match="SeznamUhrad">
    <xsl:for-each select="./Uhrada">
      <!-- pokud je uvedena castka -->
      <xsl:if test="(not(ValutyHraz) and Castka != 0) or (ValutyHraz and ./ValutyHraz/Castka != 0)">
        <pokladni-pohyb>
          <id>ext:mS3fv-uhr:<xsl:value-of select="./DokladHraz/CisloDokladu"/>-<xsl:value-of select="./DokladUhr/CisloDokladu"/>-<xsl:value-of select="./DokladUhr/Rok"/></id>
          <id>code:<xsl:value-of select="./DokladHraz/CisloDokladu"/><xsl:value-of select="./DokladUhr/Rok"/><xsl:value-of select="./DokladUhr/CisloDokladu"/></id>
          <pokladna>code:POKLADNA UHRAD</pokladna>
          <typDokl>code:STANDARD</typDokl>
          
          <popis>Úhrada dokladu č. <xsl:value-of select="./DokladHraz/CisloDokladu"/></popis>

          <bezPolozek>true</bezPolozek>
          
          <xsl:choose>
            <xsl:when test="not(ValutyHraz)">
              <sumOsv><xsl:value-of select="Castka"/></sumOsv>
              <mena>code:CZK</mena>          
            </xsl:when>
            <xsl:otherwise>
              <sumOsvMen><xsl:value-of select="./ValutyHraz/Castka"/></sumOsvMen>
              <kurz><xsl:value-of select="./ValutyHraz/Mena/Kurs"/></kurz>
              <kurzMnozstvi><xsl:value-of select="./ValutyHraz/Mena/Mnozstvi"/></kurzMnozstvi>
              <mena>code:<xsl:value-of select="./ValutyHraz/Mena/Kod"/></mena>
            </xsl:otherwise>
          </xsl:choose>
          <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(./Datum, 'y-M-d')"/></datVyst>

          <sparovani>
            <uhrazovanaFak type="faktura-vydana">ext:mS3fav:<xsl:value-of select="./DokladHraz/CisloDokladu"/></uhrazovanaFak>          
            <zbytek>ignorovat</zbytek>
          </sparovani>          
        </pokladni-pohyb>
      </xsl:if>
    </xsl:for-each>
    
  </xsl:template>
</xsl:stylesheet>
