<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
xmlns:rsp="http://www.stormware.cz/schema/version_2/response.xsd" 
xmlns:rdc="http://www.stormware.cz/schema/version_2/documentresponse.xsd" 
xmlns:typ="http://www.stormware.cz/schema/version_2/type.xsd" 
xmlns:lst="http://www.stormware.cz/schema/version_2/list.xsd" 
xmlns:lStk="http://www.stormware.cz/schema/version_2/list_stock.xsd" 
xmlns:lAdb="http://www.stormware.cz/schema/version_2/list_addBook.xsd" 
xmlns:acu="http://www.stormware.cz/schema/version_2/accountingunit.xsd" 
xmlns:inv="http://www.stormware.cz/schema/version_2/invoice.xsd"
xmlns:vch="http://www.stormware.cz/schema/version_2/voucher.xsd"
xmlns:int="http://www.stormware.cz/schema/version_2/intDoc.xsd"
xmlns:stk="http://www.stormware.cz/schema/version_2/stock.xsd"
xmlns:ord="http://www.stormware.cz/schema/version_2/order.xsd"
xmlns:ofr="http://www.stormware.cz/schema/version_2/offer.xsd"
xmlns:enq="http://www.stormware.cz/schema/version_2/enquiry.xsd"
xmlns:vyd="http://www.stormware.cz/schema/version_2/vydejka.xsd"
xmlns:pri="http://www.stormware.cz/schema/version_2/prijemka.xsd"
xmlns:bal="http://www.stormware.cz/schema/version_2/balance.xsd"
xmlns:pre="http://www.stormware.cz/schema/version_2/prevodka.xsd"
xmlns:vyr="http://www.stormware.cz/schema/version_2/vyroba.xsd"
xmlns:pro="http://www.stormware.cz/schema/version_2/prodejka.xsd"
xmlns:con="http://www.stormware.cz/schema/version_2/contract.xsd"
xmlns:adb="http://www.stormware.cz/schema/version_2/addressbook.xsd"
xmlns:prm="http://www.stormware.cz/schema/version_2/parameter.xsd"
xmlns:lCon="http://www.stormware.cz/schema/version_2/list_contract.xsd"
xmlns:ctg="http://www.stormware.cz/schema/version_2/category.xsd"
xmlns:ipm="http://www.stormware.cz/schema/version_2/intParam.xsd"
xmlns:str="http://www.stormware.cz/schema/version_2/storage.xsd"
xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
    
	<xsl:output method="xml" encoding="utf-8" />
	
	
	<!-- 
  flexibee2xml-cli.exe -x adresar-pohoda.xml -t adresar-in.xslt -o adresar.xml
   -->
	
	<xsl:template match="lAdb:listAddressBook">
	  <winstrom version="1.0">
			 <xsl:apply-templates select="lAdb:addressbook" mode="adresar"/>
       <xsl:apply-templates select="lAdb:addressbook" mode="kontakt"/>
		</winstrom>
	</xsl:template>
  
  
  <!-- kontakt nejakeho adresare - hledame v druhem pruchodu -->
  <xsl:template match="lAdb:addressbook" mode= "kontakt">
    <xsl:if test="adb:addressbookHeader/adb:refAddress/typ:refAD != ''">
    
      <xsl:call-template name="vytvorStitky"/>
     
	    <kontakt>
        <id>ext:POHODA-KON:<xsl:value-of select="adb:addressbookHeader/adb:id"/></id>
        <firma if-not-found="null">ext:POHODA-ADR:<xsl:value-of select="java:flexibee.Tool.params('year')"/>-<xsl:value-of select="adb:addressbookHeader/adb:refAddress/typ:refAD"/></firma>
        <xsl:for-each select="adb:addressbookHeader/adb:identity">
          <oddeleni><xsl:value-of select="typ:address/typ:division"/></oddeleni>
	        <prijmeni><xsl:value-of select="typ:address/typ:name"/></prijmeni>
          <mesto><xsl:value-of select="typ:address/typ:city"/></mesto>
          <ulice><xsl:value-of select="typ:address/typ:street"/></ulice>
          <psc><xsl:value-of select="typ:address/typ:zip"/></psc>
          <xsl:if test="typ:address/typ:country/typ:ids != ''">
            <stat if-not-found="null">code:<xsl:value-of select="typ:address/typ:country/typ:ids"/></stat>
          </xsl:if>
	       </xsl:for-each>
         
        <tel><xsl:value-of select="adb:addressbookHeader/adb:phone"/></tel>
        <mobil><xsl:value-of select="adb:addressbookHeader/adb:mobil"/></mobil>
        <fax><xsl:value-of select="adb:addressbookHeader/adb:fax"/></fax>
        <email><xsl:value-of select="adb:addressbookHeader/adb:email"/></email>
        <www><xsl:value-of select="adb:addressbookHeader/adb:web"/></www>
        <!-- adb:adGroup - stitky -->
        <!-- adb:adKey - stitky -->
        <!-- adb:number/typ:numberRequested -->

        <poznam><xsl:value-of select="java:flexibee.Tool.join(adb:addressbookHeader/adb:ost2,adb:addressbookHeader/adb:ost1,'; ')"/></poznam>
        <funkce><xsl:value-of select="adb:addressbookHeader/adb:function"/></funkce>
        <!-- adb:personalIdentificationNumber - rodne cislo -->
        <osloveni><xsl:value-of select="adb:addressbookHeader/adb:salutation"/></osloveni>
        <!-- adb:sex - pohlavi -->
        <!-- adb:dateOfBirth - datum narozeni -->
        
        
        <popis><xsl:value-of select="adb:addressbookHeader/adb:message"/></popis>
        <!-- adb:centre - stredisko -->
        <!-- adb:activity - cinnost -->
        <!-- adb:contract - zakazka -->
        
        <xsl:call-template name="pridejStitky"/>
      </kontakt>
    </xsl:if>
  </xsl:template>
  
  
	<!-- vlastni adresar -->
	<xsl:template match="lAdb:addressbook" mode="adresar">
    <xsl:choose>
    <xsl:when test="adb:addressbookHeader/adb:refAddress/typ:refAD != ''"/>
    <xsl:when test="adb:addressbookHeader/adb:identity/typ:address/typ:company != '' or adb:addressbookHeader/adb:identity/typ:address/typ:name != ''">
  
      <xsl:call-template name="vytvorStitky"/>
	
      <adresar>
	      <id>ext:POHODA-ADR:<xsl:value-of select="java:flexibee.Tool.params('year')"/>-<xsl:value-of select="adb:addressbookHeader/adb:id"/></id>
	      
	      <xsl:if test="adb:addressbookHeader/adb:identity/typ:address/typ:ico != ''">
	        <id>ext:POHODA-ADR-ICO:<xsl:value-of select="adb:addressbookHeader/adb:identity/typ:address/typ:ico"/></id>
	      </xsl:if>
	      <xsl:if test="adb:addressbookHeader/adb:identity/typ:address/typ:dic != ''">
	        <id>ext:POHODA-ADR-DIC:<xsl:value-of select="adb:addressbookHeader/adb:identity/typ:address/typ:dic"/></id>
	      </xsl:if>
	      <xsl:if test="adb:addressbookHeader/adb:identity/typ:address/typ:company != ''">
<!--	        <id>ext:POHODA-ADR-NAZ:<xsl:value-of select="java:flexibee.Tool.toUpper(java:flexibee.Tool.trim(substring(adb:addressbookHeader/adb:identity/typ:address/typ:company, 1, 100)))"/></id>  -->
	      </xsl:if>
	      
	      <xsl:for-each select="adb:addressbookHeader/adb:identity">
          <xsl:choose>
            <xsl:when test="java:flexibee.Tool.trim(typ:address/typ:company) != ''">
	            <nazev><xsl:value-of select="java:flexibee.Tool.trim(typ:address/typ:company)"/></nazev>
            </xsl:when>
            <xsl:otherwise>
              <nazev><xsl:value-of select="java:flexibee.Tool.trim(typ:address/typ:name)"/></nazev>
            </xsl:otherwise>
          </xsl:choose>
          <!-- typ:division - jde do primarniho kontaktu -->
          <mesto><xsl:value-of select="typ:address/typ:city"/></mesto>
          <ulice><xsl:value-of select="typ:address/typ:street"/></ulice>
          <psc><xsl:value-of select="typ:address/typ:zip"/></psc>
          <ic><xsl:value-of select="typ:address/typ:ico"/></ic>
          <dic><xsl:value-of select="typ:address/typ:dic"/></dic>
          <xsl:if test="typ:address/typ:country/typ:ids != ''">
            <stat if-not-found="null">code:<xsl:value-of select="typ:address/typ:country/typ:ids"/></stat>
          </xsl:if>
	      </xsl:for-each>
        
        <!-- adb:region -->
        <tel><xsl:value-of select="adb:addressbookHeader/adb:phone"/></tel>
        <mobil><xsl:value-of select="adb:addressbookHeader/adb:mobil"/></mobil>
        <fax><xsl:value-of select="adb:addressbookHeader/adb:fax"/></fax>
        <email><xsl:value-of select="adb:addressbookHeader/adb:email"/></email>
        <www><xsl:value-of select="adb:addressbookHeader/adb:web"/></www>
        <!-- adb:adGroup - stitky -->
        <!-- adb:adKey - stitky -->
        <limitFak><xsl:value-of select="adb:addressbookHeader/adb:credit"/></limitFak>
        <!-- adb:priceIDS - sleva -->
        <splatDny><xsl:value-of select="adb:addressbookHeader/adb:maturity"/></splatDny>
        <!-- adb:paymentType - typ platby -->
        <!-- adb:number/typ:numberRequested -->
        <poznam><xsl:value-of select="java:flexibee.Tool.join(adb:addressbookHeader/adb:ost2,adb:addressbookHeader/adb:ost1,'; ')"/></poznam>
        <popis><xsl:value-of select="adb:addressbookHeader/adb:message"/></popis>
        
        <xsl:if test="adb:addressbookHeader/adb:centre/typ:id != ''">
          <stredisko if-not-found="null">ext:POHODA-STRED:<xsl:value-of select="java:flexibee.Tool.params('year')"/>-<xsl:value-of select="adb:addressbookHeader/adb:centre/typ:id"/></stredisko>
        </xsl:if>
        <!-- adb:activity - cinnost -->
        <!-- adb:contract - zakazka -->
	     
	      <typVztahuK><xsl:choose>
	        <xsl:when test="adb:addressbookHeader/adb:p1 = 'true' and adb:addressbookHeader/adb:p2 = 'true'">typVztahu.odberDodav</xsl:when>
	        <xsl:when test="adb:addressbookHeader/adb:p1 = 'true'">typVztahu.odberatel</xsl:when>
	        <xsl:when test="adb:addressbookHeader/adb:p2 = 'true'">typVztahu.dodavatel</xsl:when>
	        <xsl:otherwise>typVztahu.odberDodav</xsl:otherwise>
	      </xsl:choose></typVztahuK>
	     
	      <xsl:call-template name="pridejStitky"/>
	    </adresar>
	    
      <xsl:if test="java:flexibee.Tool.trim(adb:addressbookHeader/adb:identity/typ:address/typ:division) != '' or (java:flexibee.Tool.trim(adb:addressbookHeader/adb:identity/typ:address/typ:company) != '' and java:flexibee.Tool.trim(adb:addressbookHeader/adb:identity/typ:address/typ:name) != '')">
        <kontakt>
          <id>ext:POHODA-KON:<xsl:value-of select="java:flexibee.Tool.params('year')"/>-<xsl:value-of select="adb:addressbookHeader/adb:id"/></id>
          <firma>ext:POHODA-ADR:<xsl:value-of select="java:flexibee.Tool.params('year')"/>-<xsl:value-of select="adb:addressbookHeader/adb:id"/></firma>
          <xsl:for-each select="adb:addressbookHeader/adb:identity">
            <prijmeni><xsl:value-of select="typ:address/typ:name"/></prijmeni>
            <oddeleni><xsl:value-of select="typ:address/typ:division"/></oddeleni>
            <primarni>true</primarni>
          </xsl:for-each>
        </kontakt>
      </xsl:if>
      
      
      <!-- bankovni ucty -->
      <xsl:for-each select="adb:addressbookAccount/adb:accountItem">
        <xsl:if test="string-length(adb:bankCode) = 4 and string-length(java:flexibee.Tool.trim(adb:accountNumber)) &gt; 0">
          <adresar-bankovni-ucet>
            <id>ext:POHODA-ADRBAN:<xsl:value-of select="java:flexibee.Tool.params('year')"/>-<xsl:value-of select="adb:id"/></id>
            <id>ext:POHODA-ADRBAN-BUC:<xsl:value-of select="adb:accountNumber"/>/<xsl:value-of select="adb:bankCode"/></id>
            <firma>ext:POHODA-ADR:<xsl:value-of select="java:flexibee.Tool.params('year')"/>-<xsl:value-of select="../../adb:addressbookHeader/adb:id"/></firma>
            <buc><xsl:value-of select="adb:accountNumber"/></buc>
            <specSym><xsl:value-of select="adb:symSpec"/></specSym>
            <smerKod if-not-found="nearest-invalid">code:<xsl:value-of select="adb:bankCode"/></smerKod>
            <primarni><xsl:value-of select="adb:defaultAccount"/></primarni>
          </adresar-bankovni-ucet>
        </xsl:if>
      </xsl:for-each>

      <!-- mista urceni -->
      <xsl:for-each select="adb:addressbookHeader/adb:identity/typ:shipToAddress">
        <misto-urceni>
          <id>ext:POHODA-MISURC:<xsl:value-of select="../../adb:id"/></id>
          <firma>ext:POHODA-ADR:<xsl:value-of select="java:flexibee.Tool.params('year')"/>-<xsl:value-of select="../../adb:id"/></firma>
          <!-- typ:division --> 
          <xsl:choose>
            <xsl:when test="typ:company != ''">
              <nazev><xsl:value-of select="typ:company"/></nazev>
            </xsl:when>
            <xsl:when test="typ:name != ''">
              <nazev><xsl:value-of select="typ:name"/></nazev>
            </xsl:when>
            <xsl:when test="../typ:address/typ:company != ''">
              <nazev><xsl:value-of select="../typ:address/typ:company"/></nazev>
            </xsl:when>
            <xsl:otherwise> 
              <nazev><xsl:value-of select="../typ:address/typ:name"/></nazev>
            </xsl:otherwise>
          </xsl:choose>
            
          <mesto><xsl:value-of select="typ:city"/></mesto>  
          <ulice><xsl:value-of select="typ:street"/></ulice>  
          <psc><xsl:value-of select="typ:zip"/></psc>  
        </misto-urceni>
      </xsl:for-each>
      
    </xsl:when>
    <xsl:otherwise>
    </xsl:otherwise>
    </xsl:choose>
	</xsl:template>
  
  <xsl:template name="pridejStitky">
    <stitky>
      <xsl:if test="adb:addressbookHeader/adb:p3 = 'true'">P3,</xsl:if>	 
      <xsl:if test="adb:addressbookHeader/adb:p4 = 'true'">P4,</xsl:if> 
      <xsl:if test="adb:addressbookHeader/adb:p5 = 'true'">P5,</xsl:if>
      <xsl:if test="adb:addressbookHeader/adb:p6 = 'true'">P6,</xsl:if>
      <xsl:if test="adb:addressbookHeader/adb:adGroup != ''">
        <xsl:value-of select="java:flexibee.Tool.trim(java:flexibee.Tool.substring(java:flexibee.Tool.toUpper(adb:addressbookHeader/adb:adGroup), 0, 20))"/>,
      </xsl:if> 
      <xsl:if test="adb:addressbookHeader/adb:adKey != ''">
        <xsl:value-of select="java:flexibee.Tool.trim(java:flexibee.Tool.substring(java:flexibee.Tool.toUpper(adb:addressbookHeader/adb:adKey), 0, 20))"/>,
      </xsl:if> 
    </stitky>
  </xsl:template>
  
  <xsl:template name="vytvorStitky">
      <xsl:if test="adb:addressbookHeader/adb:p3 = 'true'">
	      <stitek update="ignore">
          <id>code:P3</id>
          <id>ext:POHODA-STITEK:P3</id>
          <kod>P3</kod>
          <nazev>Migrovaný štítek z pohody</nazev>
          <vsbAdr>true</vsbAdr>
        </stitek>
	    </xsl:if>
      <xsl:if test="adb:addressbookHeader/adb:p4 = 'true'">
	      <stitek update="ignore">
          <id>code:P4</id>
          <id>ext:POHODA-STITEK:P4</id>
          <kod>P4</kod>
          <nazev>Migrovaný štítek z pohody</nazev>
          <vsbAdr>true</vsbAdr>
        </stitek>
	    </xsl:if>
      <xsl:if test="adb:addressbookHeader/adb:p5 = 'true'">
	      <stitek update="ignore">
          <id>code:P5</id>
          <id>ext:POHODA-STITEK:P5</id>
          <kod>P5</kod>
          <nazev>Migrovaný štítek z pohody</nazev>
          <vsbAdr>true</vsbAdr>
        </stitek>
	    </xsl:if>
	    <xsl:if test="adb:addressbookHeader/adb:p6 = 'true'">
	      <stitek update="ignore">
          <id>code:P6</id>
          <id>ext:POHODA-STITEK:P6</id>
          <kod>P6</kod>
          <nazev>Migrovaný štítek z pohody</nazev>
          <vsbAdr>true</vsbAdr>
        </stitek>
	    </xsl:if>
      
      <xsl:call-template name="vytvorStitekZRetezce">
        <xsl:with-param name="retezec" select="java:flexibee.Tool.toUpper(adb:addressbookHeader/adb:adGroup)"/>
      </xsl:call-template>
      <xsl:call-template name="vytvorStitekZRetezce">
        <xsl:with-param name="retezec" select="java:flexibee.Tool.toUpper(adb:addressbookHeader/adb:adKey)"/>
      </xsl:call-template>
  </xsl:template>
  
  
  <xsl:template name="vytvorStitekZRetezce">
    <xsl:param name="retezec" />

    <xsl:if test="java:flexibee.Tool.split($retezec, ',', 0) != ''">
      <stitek update="ignore">
        <id>code:<xsl:value-of select="java:flexibee.Tool.trim(java:flexibee.Tool.substring(java:flexibee.Tool.split($retezec, ',', 0), 0, 20))"/></id>
        <id>ext:POHODA-STITEK:<xsl:value-of select="java:flexibee.Tool.split($retezec, ',', 0)"/></id>
        <kod><xsl:value-of select="java:flexibee.Tool.trim(java:flexibee.Tool.substring(java:flexibee.Tool.split($retezec, ',', 0), 0, 20))"/></kod>
        <nazev>Migrovaný štítek z pohody</nazev>
        <vsbAdr>true</vsbAdr>
        <vsbKatalog>true</vsbKatalog>
        <vsbSkl>true</vsbSkl>
        <vsbFav>true</vsbFav>
        <vsbPhl>true</vsbPhl>
        <vsbFap>true</vsbFap>
        <vsbZav>true</vsbZav>
        <vsbBan>true</vsbBan>
        <vsbPok>true</vsbPok>
        <vsbInt>true</vsbInt>
        <vsbMaj>true</vsbMaj>
        <vsbObp>true</vsbObp>
        <vsbNav>true</vsbNav>
        <vsbPpp>true</vsbPpp>
        <vsbObv>true</vsbObv>
        <vsbNap>true</vsbNap>
        <vsbPpv>true</vsbPpv>
        <vsbMzd>true</vsbMzd>
      </stitek>
       
      <xsl:call-template name="vytvorStitekZRetezce">
        <xsl:with-param name="retezec" select="substring($retezec, string-length(java:flexibee.Tool.split($retezec, ',', 0))+2)"/>
      </xsl:call-template>
    </xsl:if>  
  </xsl:template>
</xsl:stylesheet>
