<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
xmlns:rsp="http://www.stormware.cz/schema/version_2/response.xsd" 
xmlns:rdc="http://www.stormware.cz/schema/version_2/documentresponse.xsd" 
xmlns:typ="http://www.stormware.cz/schema/version_2/type.xsd" 
xmlns:lst="http://www.stormware.cz/schema/version_2/list.xsd" 
xmlns:lStk="http://www.stormware.cz/schema/version_2/list_stock.xsd" 
xmlns:lAdb="http://www.stormware.cz/schema/version_2/list_addBook.xsd" 
xmlns:acu="http://www.stormware.cz/schema/version_2/accountingunit.xsd" 
xmlns:inv="http://www.stormware.cz/schema/version_2/invoice.xsd"
xmlns:vch="http://www.stormware.cz/schema/version_2/voucher.xsd"
xmlns:int="http://www.stormware.cz/schema/version_2/intDoc.xsd"
xmlns:stk="http://www.stormware.cz/schema/version_2/stock.xsd"
xmlns:ord="http://www.stormware.cz/schema/version_2/order.xsd"
xmlns:ofr="http://www.stormware.cz/schema/version_2/offer.xsd"
xmlns:enq="http://www.stormware.cz/schema/version_2/enquiry.xsd"
xmlns:vyd="http://www.stormware.cz/schema/version_2/vydejka.xsd"
xmlns:pri="http://www.stormware.cz/schema/version_2/prijemka.xsd"
xmlns:bal="http://www.stormware.cz/schema/version_2/balance.xsd"
xmlns:pre="http://www.stormware.cz/schema/version_2/prevodka.xsd"
xmlns:vyr="http://www.stormware.cz/schema/version_2/vyroba.xsd"
xmlns:pro="http://www.stormware.cz/schema/version_2/prodejka.xsd"
xmlns:con="http://www.stormware.cz/schema/version_2/contract.xsd"
xmlns:adb="http://www.stormware.cz/schema/version_2/addressbook.xsd"
xmlns:prm="http://www.stormware.cz/schema/version_2/parameter.xsd"
xmlns:lCon="http://www.stormware.cz/schema/version_2/list_contract.xsd"
xmlns:ctg="http://www.stormware.cz/schema/version_2/category.xsd"
xmlns:ipm="http://www.stormware.cz/schema/version_2/intParam.xsd"
xmlns:str="http://www.stormware.cz/schema/version_2/storage.xsd"
xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
    
	<xsl:output method="xml" encoding="utf-8" />
	
	
	<!-- 
  napred je treba importovat adresar - zakazka ma vazbu na nej
  flexibee2xml-cli.exe -x zakazky-pohoda.xml -t zakazky-in.xslt -o zakazky.xml
   -->
	
	<xsl:template match="lCon:listContract">
	  <winstrom version="1.0">
			 <xsl:apply-templates select="lCon:contract"/>
		</winstrom>
	</xsl:template>
 
  
  <xsl:template match="lCon:contract">
    <zakazka>
      <id>ext:POHODA-ZAK:<xsl:value-of select="java:flexibee.Tool.params('year')"/>-<xsl:value-of select="con:contractDesc/con:id"/></id>
      <kod><xsl:value-of select="con:contractDesc/con:number/typ:numberRequested"/></kod>
      <nazev><xsl:value-of select="con:contractDesc/con:text"/></nazev>
      
      <!-- con:contractDesc/con:datePlanStart -->
      <termin><xsl:value-of select="con:contractDesc/con:datePlanDelivery"/></termin>
      <datZahaj><xsl:value-of select="con:contractDesc/con:dateStart"/></datZahaj>
      <datKonec><xsl:value-of select="con:contractDesc/con:dateDelivery"/></datKonec>
      <!-- con:contractDesc/con:dateWarranty -->
      
      <xsl:if test="con:contractDesc/con:partnerIdentity/typ:id != ''">
        <firma if-not-found="null">ext:POHODA-ADR:<xsl:value-of select="java:flexibee.Tool.params('year')"/>-<xsl:value-of select="con:contractDesc/con:partnerIdentity/typ:id"/></firma>
      </xsl:if>
      
      <xsl:choose>
        <xsl:when test="con:contractDesc/con:contractState = 'planned'">
          <stavZakazky if-not-found="null">code:ZÍSKÁVÁME</stavZakazky>
        </xsl:when>
        <xsl:when test="con:contractDesc/con:contractState = 'opened'">
          <stavZakazky if-not-found="null">code:MÁME</stavZakazky>
        </xsl:when>
        <xsl:when test="con:contractDesc/con:contractState = 'delivered'">
          <stavZakazky if-not-found="null">code:MÁME</stavZakazky>
        </xsl:when>
        <xsl:when test="con:contractDesc/con:contractState = 'closed'">
          <stavZakazky if-not-found="null">code:HOTOVO</stavZakazky>
        </xsl:when>
      </xsl:choose>
      
      <poznam>
        <xsl:if test="con:contractDesc/con:responsiblePerson/typ:ids != ''">Zodpovědná osoba: <xsl:value-of select="con:contractDesc/con:responsiblePerson/typ:ids"/>
        <xsl:text>
</xsl:text>
        </xsl:if>
        <xsl:if test="con:contractDesc/con:dateWarranty != ''">Záruka: <xsl:value-of select="con:contractDesc/con:dateWarranty"/>
        </xsl:if>
      </poznam>
      
      <!-- -->
    </zakazka>
  </xsl:template>
  
  <xsl:template match="text()"/>
</xsl:stylesheet>
