<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:template match="winstrom">
	<winstrom version="1.0"  atomic="false">
		<!-- sdílíme stejnou šablonu pro faktury vydané i přijaté -->
		<xsl:apply-templates select="*"/>
	</winstrom>
    </xsl:template>

    <xsl:template name="obsah-polozky-osv">
			    <id>ext:SOFIX:<xsl:value-of select="translate(UUID_DOKLAD, ':', '')"/>-1</id>
			    <nazev>Osvobozeno</nazev>
			    <typPolozkyK>typPolozky.ucetni</typPolozkyK>
			    <typSzbDphK>typSzbDph.dphOsv</typSzbDphK>
			    <xsl:choose>
				<xsl:when test="MENA != ''">
				    <sumZkl><xsl:value-of select="java:flexibee.Tool.parseMoney2(ZAKLADDPH0, ID_DOKLAD_TYP = 'DOV')"/></sumZkl>
<!--				    <sumCelkem><xsl:value-of select="java:flexibee.Tool.parseMoney2(ZAKLADDPH0, ID_DOKLAD_TYP = 'DOV')"/></sumCelkem> 
				    <sumZklMen><xsl:value-of select="java:flexibee.Tool.parseMoney2(ZAKLADDPH0, ID_DOKLAD_TYP = 'DOV') div java:flexibee.Tool.parseMoney(KURZ)"/></sumZklMen>
				    <sumCelkemMen><xsl:value-of select="java:flexibee.Tool.parseMoney2(ZAKLADDPH0, ID_DOKLAD_TYP = 'DOV') div java:flexibee.Tool.parseMoney(KURZ)"/></sumCelkemMen> -->
				</xsl:when>
				<xsl:otherwise>
				    <sumZkl><xsl:value-of select="java:flexibee.Tool.parseMoney2(ZAKLADDPH0, ID_DOKLAD_TYP = 'DOV')"/></sumZkl>
				    <sumDph>0</sumDph>
				</xsl:otherwise>
			    </xsl:choose>
    </xsl:template>

    <xsl:template name="obsah-polozky-zakl">
			    <id>ext:SOFIX:<xsl:value-of select="translate(UUID_DOKLAD, ':', '')"/>-3</id>
			    <nazev>Snížená sazba</nazev>
			    <typPolozkyK>typPolozky.ucetni</typPolozkyK>
			    <typSzbDphK>typSzbDph.dphZakl</typSzbDphK>
			    <xsl:choose>
				<xsl:when test="MENA != ''">
				    <sumZkl><xsl:value-of select="java:flexibee.Tool.parseMoney2(ZAKLADDPH1, ID_DOKLAD_TYP = 'DOV')"/></sumZkl>
				    <sumDph><xsl:value-of select="java:flexibee.Tool.parseMoney2(DPH1, ID_DOKLAD_TYP = 'DOV')"/></sumDph>
				</xsl:when>
				<xsl:otherwise>
				    <sumZkl><xsl:value-of select="java:flexibee.Tool.parseMoney2(ZAKLADDPH1, ID_DOKLAD_TYP = 'DOV')"/></sumZkl>
				    <sumDph><xsl:value-of select="java:flexibee.Tool.parseMoney2(DPH1, ID_DOKLAD_TYP = 'DOV')"/></sumDph>
				</xsl:otherwise>
			    </xsl:choose>

    </xsl:template>

    <xsl:template name="obsah-polozky-sniz">
			    <id>ext:SOFIX:<xsl:value-of select="translate(UUID_DOKLAD, ':', '')"/>-2</id>
			    <nazev>Základní sazba</nazev>
			    <typPolozkyK>typPolozky.ucetni</typPolozkyK>
			    <typSzbDphK>typSzbDph.dphSniz</typSzbDphK>
			    <xsl:choose>
				<xsl:when test="MENA != ''">
				    <sumZkl><xsl:value-of select="java:flexibee.Tool.parseMoney2(ZAKLADDPH2, ID_DOKLAD_TYP = 'DOV')"/></sumZkl>
				    <sumDph><xsl:value-of select="java:flexibee.Tool.parseMoney2(DPH2, ID_DOKLAD_TYP = 'DOV')"/></sumDph>
				</xsl:when>
				<xsl:otherwise>
				    <sumZkl><xsl:value-of select="java:flexibee.Tool.parseMoney2(ZAKLADDPH2, ID_DOKLAD_TYP = 'DOV')"/></sumZkl>
				    <sumDph><xsl:value-of select="java:flexibee.Tool.parseMoney2(DPH2, ID_DOKLAD_TYP = 'DOV')"/></sumDph>
				</xsl:otherwise>
			    </xsl:choose>

    </xsl:template>


    <xsl:template name="obsah-polozky-zaokr">
			    <id>ext:SOFIX:<xsl:value-of select="translate(UUID_DOKLAD, ':', '')"/>-4</id>
			    <nazev>Zaokrouhleno</nazev>
			    <typPolozkyK>typPolozky.ucetni</typPolozkyK>
			    <typSzbDphK>typSzbDph.dphOsv</typSzbDphK>
			    <xsl:choose>
				<xsl:when test="MENA != ''">
				    <sumZkl><xsl:value-of select="java:flexibee.Tool.parseMoney2(ZAOKROUHLENI, ID_DOKLAD_TYP = 'DOV')"/></sumZkl>
				    <sumDph>0</sumDph>
				</xsl:when>
				<xsl:otherwise>
				    <sumZkl><xsl:value-of select="java:flexibee.Tool.parseMoney2(ZAOKROUHLENI, ID_DOKLAD_TYP = 'DOV')"/></sumZkl>
				    <sumDph>0</sumDph>
				</xsl:otherwise>
			    </xsl:choose>

    </xsl:template>


    <xsl:template name="obsah">
	    <id>ext:SOFIX:<xsl:value-of select="translate(UUID_DOKLAD, ':', '')"/></id>
	    <id>code:<xsl:value-of select="ID_DOKLADU"/></id>
	    <kod><xsl:value-of select="ID_DOKLADU"/></kod>
	    <cisDosle><xsl:value-of select="ID_DOKLADU"/></cisDosle>

	    <xsl:choose>
		<xsl:when test="ID_DOKLAD_TYP = 'PRO' or ID_DOKLAD_TYP = 'VPD' or  ID_DOKLAD_TYP = 'PPD'">
		    <typDokl>code:<xsl:value-of select="java:flexibee.Tool.toUpper(java:flexibee.Tool.params('pokladna'))"/></typDokl>
		</xsl:when>
		<xsl:otherwise>
		    <typDokl>code:<xsl:value-of select="ID_DOKLAD_TYP"/></typDokl>
		</xsl:otherwise>
	    </xsl:choose>
	    <varSym><xsl:choose>
			<xsl:when test="VS != ''"><xsl:value-of select="VS"/></xsl:when>
			<xsl:otherwise>0</xsl:otherwise>
	    </xsl:choose></varSym>
	    <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(DATUM, 'd.M.y')"/></datVyst>
	    <datSplat><xsl:choose>
		<xsl:when test="DATUM2 != ''"><xsl:value-of select="java:flexibee.Tool.parseDate(DATUM2, 'd.M.y')"/></xsl:when>
		<xsl:otherwise><xsl:value-of select="java:flexibee.Tool.parseDate(DATUM, 'd.M.y')"/></xsl:otherwise>
	    </xsl:choose></datSplat>
	    <xsl:choose>
		<xsl:when test="DATUM3 != ''">
		    <duzpPuv><xsl:value-of select="java:flexibee.Tool.parseDate(DATUM3, 'd.M.y')"/></duzpPuv>
		</xsl:when>
		<xsl:otherwise>
		    <duzpPuv><xsl:value-of select="java:flexibee.Tool.parseDate(DATUM, 'd.M.y')"/></duzpPuv>
		</xsl:otherwise>
	    </xsl:choose>
	    <xsl:choose>
		<xsl:when test="ID_DOKLAD_TYP = 'PRO' or ID_DOKLAD_TYP = 'PPD'">
		    <typPohybuK>typPohybu.prijem</typPohybuK>
		</xsl:when>
		<xsl:when test="ID_DOKLAD_TYP = 'VPD'">
		    <typPohybuK>typPohybu.vydej</typPohybuK>
		</xsl:when>
	    </xsl:choose>
	    <firma>in:<xsl:value-of select="ICO"/></firma>
	    <nazev><xsl:value-of select="FNAZEV"/></nazev>
	    <ulice><xsl:value-of select="ULICE"/></ulice>
	    <psc><xsl:value-of select="PSC"/></psc>
	    <mesto><xsl:value-of select="MESTO"/></mesto>

	    <postovniShodna>false</postovniShodna>
	    <faNazev><xsl:value-of select="DNAZEV"/></faNazev>
	    <faUlice><xsl:value-of select="DULICE"/></faUlice>
	    <faPsc><xsl:value-of select="DPSC"/></faPsc>
	    <faMesto><xsl:value-of select="DMESTO"/></faMesto>

<!--	    <xsl:if test="SID_UCET != ''">
	        <typDoklBan>ext:SOFIX-UCTY:<xsl:value-of select="SID_UCET"/></typDoklBan>
	    </xsl:if> -->
	    <xsl:if test="MENA != ''">
	    <mena>code:<xsl:value-of select="MENA"/></mena>
	    <kurz><xsl:value-of select="java:flexibee.Tool.parseMoney(KURZ)"/></kurz>
	    </xsl:if>
	    <xsl:if test="ID_DOKLAD_TYP != 'VPD' and ID_DOKLAD_TYP != 'PRO' and ID_DOKLAD_TYP != 'PPD'">
	    <formaUhrK><xsl:choose>
			<xsl:when test="ZPUSOB_UHRADY = 'Bankovním převodem'">formaUhr.prevod</xsl:when>
			<xsl:when test="ZPUSOB_UHRADY = 'Hotově'">formaUhr.hotove</xsl:when>
			<xsl:otherwise>formaUhr.nespec</xsl:otherwise>
		</xsl:choose></formaUhrK>
	    </xsl:if>

	    <xsl:choose>
		<xsl:when test="ID_DOKLAD_TYP = 'VPD' or ID_DOKLAD_TYP = 'PRO' or ID_DOKLAD_TYP = 'PPD'">

	    <polozkyIntDokladu removeAll="true"> 
		<xsl:if test="ZAKLADDPH0 != '0'">
		    <pokladni-pohyb-polozka>
			<xsl:call-template name="obsah-polozky-osv"/>
		    </pokladni-pohyb-polozka>
		</xsl:if>
		<xsl:if test="ZAKLADDPH2 != '0' or DPH2 != '0'">
		    <pokladni-pohyb-polozka>
			<xsl:call-template name="obsah-polozky-sniz"/>
		    </pokladni-pohyb-polozka>
		</xsl:if>
		<xsl:if test="ZAKLADDPH1 != '0' or DPH1 != '0'">
		    <pokladni-pohyb-polozka>
			<xsl:call-template name="obsah-polozky-zakl"/>
		    </pokladni-pohyb-polozka>
		</xsl:if>
		<xsl:if test="ZAOKROUHLENI != '0'">
		    <pokladni-pohyb-polozka>
			<xsl:call-template name="obsah-polozky-zaokr"/>
		    </pokladni-pohyb-polozka>
		</xsl:if>
	    </polozkyIntDokladu>

		</xsl:when>
		<xsl:otherwise>

	    <polozkyFaktury removeAll="true"> 
		<xsl:if test="ZAKLADDPH0 != '0'">
		    <PolFak>
			<xsl:call-template name="obsah-polozky-osv"/>
		    </PolFak>
		</xsl:if>
		<xsl:if test="ZAKLADDPH2 != '0' or DPH2 != '0'">
		    <PolFak>
			<xsl:call-template name="obsah-polozky-sniz"/>
		    </PolFak>
		</xsl:if>
		<xsl:if test="ZAKLADDPH1 != '0' or DPH1 != '0'">
		    <PolFak>
			<xsl:call-template name="obsah-polozky-zakl"/>
		    </PolFak>
		</xsl:if>
		<xsl:if test="ZAOKROUHLENI != '0'">
		    <PolFak>
			<xsl:call-template name="obsah-polozky-zaokr"/>
		    </PolFak>
		</xsl:if>
	    </polozkyFaktury> 

		</xsl:otherwise>
	</xsl:choose>
    </xsl:template>

    <xsl:template match="faktura-vydana|faktura-prijata|pokladni-pohyb">
	<adresar update="ignore">
		<id>in:<xsl:value-of select="ICO"/></id>
		<ic><xsl:value-of select="ICO"/></ic>
		<nazev><xsl:value-of select="FNAZEV"/></nazev>
		<ulice><xsl:value-of select="ULICE"/></ulice>
	        <psc><xsl:value-of select="PSC"/></psc>
	        <mesto><xsl:value-of select="MESTO"/></mesto>

		<postovniShodna>false</postovniShodna>
		<faNazev><xsl:value-of select="DNAZEV"/></faNazev>
		<faUlice><xsl:value-of select="DULICE"/></faUlice>
		<faPsc><xsl:value-of select="DPSC"/></faPsc>
		<faMesto><xsl:value-of select="DMESTO"/></faMesto>
	</adresar>
<!--	<xsl:if test="SID_UCET != '' and SID_UCET != 'KASA' and not contains(SID_UCET, 'Pokladna') and SID_UCET != 'FACT'">
	<bankovni-ucet update="ignore">
	        <id>ext:SOFIX-UCTY:<xsl:value-of select="SID_UCET"/></id>
	        <firma>in:<xsl:value-of select="ICO"/></firma>
	        <nazev><xsl:value-of select="FIRMA_NAZEV_UCTU"/></nazev>
	        <buc><xsl:value-of select="FIRMA_CISLO_UCTU"/></buc>
	        <smerKod>code:<xsl:value-of select="FIRMA_BANKA"/></smerKod>
	        <iban><xsl:value-of select="FIRMA_IBAN"/></iban>
	</bankovni-ucet>
	</xsl:if> -->

	<xsl:choose>
	    <xsl:when test="ID_DOKLAD_TYP = 'PFA'">
		<faktura-prijata>
			<xsl:call-template name="obsah"/>
		</faktura-prijata>
	    </xsl:when>
	    <xsl:when test="ID_DOKLAD_TYP = 'VPD' or ID_DOKLAD_TYP = 'PRO' or ID_DOKLAD_TYP = 'PPD'">
		<pokladni-pohyb>
			<xsl:call-template name="obsah"/>
		</pokladni-pohyb>
	    </xsl:when>
	    <xsl:otherwise>
		<faktura-vydana>
			<xsl:call-template name="obsah"/>
		</faktura-vydana>
	    </xsl:otherwise>
        </xsl:choose>

<!--
		<UUID_DOKLAD>*SZVnUcWrmfYad0ITYQfex</UUID_DOKLAD> ok
		<ID_DOKLAD_TYP>PFA</ID_DOKLAD_TYP> ok
		<ID_DOKLADU>1060012</ID_DOKLADU> ok
		<ICO>00032433</ICO> ok
		<FNAZEV>JEDNOTA SD ZÁBŘEH</FNAZEV> ok
		<VS>1060012</VS> ok
		<DATUM>1.1.2010</DATUM> ok
		<DATUM2>10.1.2010</DATUM2> ok
		<DATUM3>1.1.2010</DATUM3> ok
		<ZAKLADDPH0>25000</ZAKLADDPH0> ok
		<ZAKLADDPH1>0</ZAKLADDPH1> ok
		<ZAKLADDPH2>0</ZAKLADDPH2> ok
		<DPH1>0</DPH1> ok
		<DPH2>0</DPH2> ok
		<BezDPH>25000</BezDPH> - ignore
		<ZPUSOB_UHRADY>Bankovním převodem</ZPUSOB_UHRADY> ok
		<ZAOKROUHLENI>0</ZAOKROUHLENI> ok
		<CELKEM>25000</CELKEM> - ignore
		<PRODEJKA>0</PRODEJKA>
		<KURZ></KURZ>
		<MENA></MENA>
-->

    </xsl:template>

</xsl:stylesheet>