<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

<!--
        <Objedn.vl.>
                <Vl.objednávka>800/988032</Vl.objednávka>
                <Č.objednávky>988032</Č.objednávky>
                <Dodavatel>1120</Dodavatel>        		X
                <Pobočka>0</Pobočka>
                <Rámcová>Nepravda</Rámcová>
                <Datum_vyst.>06.11.98</Datum_vyst.>		X
                <Vystavil>12</Vystavil>
                <Přepravné>0</Přepravné>
                <Sazba_DPH_přep.>22</Sazba_DPH_přep.>
                <Částka_DPH_přep>0</Částka_DPH_přep>
                <Potvrzena>Nepravda</Potvrzena>
                <Hodnota_obj.>1446,66</Hodnota_obj.>		X
                <Úvodní_text></Úvodní_text>			X
                <Doplňující_text></Doplňující_text>
                <Termín_dodávky>06.11.98</Termín_dodávky>	X
                <Způsob_dopravy></Způsob_dopravy>
                <Obsahuje>smetáky</Obsahuje>
                <Středisko>800</Středisko>			X
                <Bank.spojení>132644211/0100</Bank.spojení>
                <Kód_měny></Kód_měny>
                <Kurs>0</Kurs>
                <Zakázka></Zakázka>				X
                <Místo_dodání>0</Místo_dodání>
                <Ind.splnění>1</Ind.splnění>			X
                <Příjemce></Příjemce>
                <V_jazyce>0</V_jazyce>
                <Jméno></Jméno>
                <Termín_potvrz.>06.11.98</Termín_potvrz.>
                <Č.kup.smlouvy></Č.kup.smlouvy>
                <Smluvní_sleva>0</Smluvní_sleva>
                <Částka_DPH>318,3</Částka_DPH>
                <Adresa_dodání></Adresa_dodání>
                <Exportováno>Nepravda</Exportováno>
                <Volba_adresy>Nepravda</Volba_adresy>
                <Č.poptávky>0</Č.poptávky>
                <Poznámka></Poznámka>				X
        </Objedn.vl.>
-->

    <xsl:variable name="radkyDoc" select="document('obj-vyd-radky.xml')"/>

    <xsl:key name="cisloKey" match="Řádky_vl.obj." use="Vl.objednávka"/>

    <xsl:template match="/Objedn.vl.">
        <winstrom version="1.0">
<!--		<xsl:apply-templates select="*[local-name() = 'Objedn.vl.' and position() &lt; 100]"/> -->
        	<xsl:apply-templates select="Objedn.vl."/> 
        </winstrom>
    </xsl:template>


<!--
/usr/share/flexibee/bin/flexibee2xml -t objednavka-vydana-in.xslt -x obj-vyd.xml -o objednavka-vydana.xml
-->

    <xsl:template match="Objedn.vl.">
	    <xsl:variable name="cislo" select="Vl.objednávka"/>

        <objednavka-vydana update="ignore">
            <id>ext:4DD-VYD:<xsl:value-of select="java:flexibee.Tool.toUpper($cislo)"/></id>
            <typDokl>code:HISTORICKÁ</typDokl>
            <kod><xsl:value-of select="java:flexibee.Tool.toUpper($cislo)"/></kod>
	    <cisDosle><xsl:value-of select="Odběr.č.obj."/></cisDosle>
            <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(Datum_vyst., 'd.M.y')"/></datVyst>
            <datTermin><xsl:value-of select="java:flexibee.Tool.parseDate(Termín_dodávky, 'd.M.y')"/></datTermin>

	    <xsl:choose>
		<xsl:when test="Ind.splnění = '1'">
		    <stavUzivK>stavDoklObch.hotovo</stavUzivK>
		</xsl:when>
		<xsl:otherwise>
		    <stavUzivK>stavDoklObch.pripraveno</stavUzivK>
		</xsl:otherwise>
	    </xsl:choose>

	    <xsl:if test="Dodavatel != '' and Dodavatel != 'False' and Dodavatel != '0'">
        	<firma>ext:4DD-ADR:<xsl:value-of select="Dodavatel"/></firma>
	    </xsl:if>

		<xsl:for-each select="$radkyDoc">
			<xsl:choose>
                    	    <xsl:when test="key('cisloKey',$cislo)[1]/Sklad != ''">
                        	<bsp>code:<xsl:value-of select="java:flexibee.Tool.toUpper(key('cisloKey',$cislo)[1]/Sklad)"/>_HISTORIE</bsp>
                    	    </xsl:when>
                    	    <xsl:otherwise>
                        	<bsp>code:XXX_HISTORIE</bsp>
			    </xsl:otherwise>
                        </xsl:choose>
		</xsl:for-each>


	    <xsl:choose>
		<xsl:when test="Zablokována = 'Pravda'">
		    <stavUzivK>stavDoklObch.storno</stavUzivK>
		</xsl:when>
		<xsl:when test="Ind.plnění = 'Pravda'">
		    <stavUzivK>stavDoklObch.hotovo</stavUzivK>
		</xsl:when>
		<xsl:when test="Ind.potvrzení = 'Pravda'">
		    <stavUzivK>stavDoklObch.schvaleno</stavUzivK>
		</xsl:when>
		<xsl:when test="K_expedici = 'Pravda'">
		    <stavUzivK>stavDoklObch.pripraveno</stavUzivK>
		</xsl:when>
	    </xsl:choose>

	    <xsl:if test="Smluvní_sleva != '0'">
		<slevaDokl><xsl:value-of  select="java:flexibee.Tool.parseMoney(Smluvní_sleva)"/></slevaDokl>
	    </xsl:if>

	    <stredisko if-not-found="null">ext:4DD-STRED:<xsl:value-of select="Středisko"/></stredisko>
	    <xsl:if test="Zakázka != ''">
	    	<zakazka>ext:4DD-ZAK:<xsl:value-of select="Zakázka"/></zakazka>
	    </xsl:if>

            <uvodTxt><xsl:value-of select="Úvodní_text"/></uvodTxt>
            <zavTxt><xsl:value-of select="Doplňující_text"/></zavTxt>
            <poznam><xsl:value-of select="Poznámka"/></poznam>
	    <popis>Hodnota: <xsl:value-of select="Hodnota_obj."/>
		   <xsl:if test="Obsahuje != ''">, <xsl:value-of select="Obsahuje"/></xsl:if>
		   <xsl:if test="Bank.spojení != ''">, Bankovní spojení: <xsl:value-of select="Bank.spojení"/></xsl:if>
		   <xsl:if test="Č.kup.smlouvy != ''">, číslo kupní smlouvy: <xsl:value-of select="Č.kup.smlouvy"/></xsl:if>
		</popis>

	    <polozkyObchDokladu>

		<xsl:for-each select="$radkyDoc">
		    <xsl:for-each select="key('cisloKey',$cislo)">

<!--
        <Řádky_vl.obj.>
                <Vl.objednávka>800/988033</Vl.objednávka>	X
                <Řádek>8</Řádek>                                X
                <Kód_položky>60938</Kód_položky>
                <Název_položky>Wap 1100W</Název_položky>
                <Měrná_jednotka>ks</Měrná_jednotka>
                <Jedn.cena>18585,6</Jedn.cena>
                <Objednáno>1</Objednáno>
                <Sazba_DPH>22</Sazba_DPH>
                <Částka_DPH>4088,83</Částka_DPH>
                <Dodáno>1</Dodáno>
                <Částka>18585,6</Částka>			X
                <Kód_u_dodav.></Kód_u_dodav.>
                <Stornováno>0</Stornováno>
                <Posl.dodávka>0</Posl.dodávka>
                <Zbývá_dodat>0</Zbývá_dodat>
                <Sklad>005</Sklad>				X
                <Poznámka></Poznámka>				X
                <Proc.sleva>0</Proc.sleva>
                <Stav_zásob>0</Stav_zásob>
        </Řádky_vl.obj.>
-->

			<xsl:if test="Množství != 0 or J.cena_nák. != 0 or Kód_položky != ''">
			    <objednavka-vydana-polozka>
				<id>ext:4DD-VYD:<xsl:value-of select="java:flexibee.Tool.toUpper(Vl.objednávka)"/>-<xsl:value-of select="java:flexibee.Tool.toUpper(Řádek)"/></id>
				<xsl:choose>
				    <xsl:when test="Kód_položky != ''">
					<typPolozkyK>typPolozky.katalog</typPolozkyK>
					<cenik if-not-found="null">ean:<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_položky)"/></cenik>
					<kod><xsl:value-of select="Kód_položky"/></kod>
					<xsl:choose>
                    			    <xsl:when test="Sklad != ''">
                        			<sklad>code:<xsl:value-of select="java:flexibee.Tool.toUpper(Sklad)"/>_HISTORIE</sklad>
                    			    </xsl:when>
                    			    <xsl:otherwise>
                        			<sklad>code:XXX_HISTORIE</sklad>
					    </xsl:otherwise>
                    			</xsl:choose>
				    </xsl:when>
				    <xsl:otherwise>
					<typPolozkyK>typPolozky.obecny</typPolozkyK>
				    </xsl:otherwise>
				</xsl:choose>
				<nazev><xsl:value-of select="Název_položky"/></nazev>
				<xsl:choose>
				    <xsl:when test="Celk.množství != '0'">
					<mnozMj><xsl:value-of select="java:flexibee.Tool.parseMoney(Celk.množství)"/></mnozMj>
				    </xsl:when>
				    <xsl:otherwise>
					<mnozMj>1</mnozMj>
				    </xsl:otherwise>
				</xsl:choose>
    				<cenaMj><xsl:value-of select="java:flexibee.Tool.parseMoney(J.cena_prod.)"/></cenaMj>
				<slevaPol><xsl:value-of select="Proc.sleva"/></slevaPol>
				<poznam><xsl:value-of select="Poznámka"/></poznam>


			    </objednavka-vydana-polozka>
			</xsl:if>
		    </xsl:for-each>
		</xsl:for-each>
	    </polozkyObchDokladu>
        </objednavka-vydana>

    </xsl:template>

</xsl:stylesheet>
