<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>
    <xsl:output method="xml" indent="yes" encoding="utf-8" />
    
    

    <xsl:template match="/Root|/Pokl.doklady">
        <winstrom version="1.0">
            <!--
            <xsl:apply-templates select="*[local-name() = 'Pokl.doklady' and position() &lt; 3]"/> 
             -->
            <xsl:apply-templates select="Pokl.doklady"/>  
 
        </winstrom>
    </xsl:template>

<!--
flexibee2xml -t pokladni-pohyb-in.xslt -x pokladna.xml -o pokladni-pohyb.xml
-->
    
<!--
 
 <Pokl.doklady>
    <Pokl.doklady>
        <Doklad>1/1174</Doklad>                 X
        <Číslo_dokladu>1174</Číslo_dokladu>     X
        <Datum>18.07.95</Datum>                 X
        <Úč.období>199507</Úč.období>           X
        <Druh_dokladu>V</Druh_dokladu>          X
        <Obsahuje>VKLAD DO BANKY v  HOTOVOSTI</Obsahuje>    X
        <Částka>40000</Částka>                              X
        <DPH_ve_sníž.sazbě>0</DPH_ve_sníž.sazbě>
        <DPH_v_zákl.sazbě>0</DPH_v_zákl.sazbě>
        <Kurs>0</Kurs>
        <Účet_pokladny>21100</Účet_pokladny>
        <Ind.likvidace>1</Ind.likvidace>
        <Ind.párování>0</Ind.párování>
        <Zpracoval>2</Zpracoval>
        <Uč.doklad>59</Uč.doklad>
        <Od_koho_komu>P.ROMANUTTI  M.</Od_koho_komu>        X
        <Pokladna>1</Pokladna>                              X
        <Ind.daň.dokl.>Nepravda</Ind.daň.dokl.>
        <Základ_v_zákl.sazbě>0</Základ_v_zákl.sazbě>
        <Základ_ve_sníž.sazbě>0</Základ_ve_sníž.sazbě>
        <Základ_be_daně>40000</Základ_be_daně>
        <Dodávka>1</Dodávka>
        <Kon.stav>17693,8</Kon.stav>                        X
        <Poznámka></Poznámka>
        <Exportováno>Nepravda</Exportováno>
        <Středisko_pokl.></Středisko_pokl.>                 X
        <Zakázka></Zakázka>                                 X
        <Datum_uplatnění_DPH>00.00.00</Datum_uplatnění_DPH> X
        <Vratka_DPH>Nepravda</Vratka_DPH>
        <Odpočet_DPH>0</Odpočet_DPH>
        <Firma></Firma>                                     X
        <Zákl.sazba_DPH>22</Zákl.sazba_DPH>
        <Sníž.sazba_DPH>5</Sníž.sazba_DPH>
        <Číslo_prodeje>0</Číslo_prodeje>
 </Pokl.doklady>
 -->

    <xsl:template match="Pokl.doklady">
        <xsl:variable name="cislo" select="Doklad"/>

        <pokladni-pohyb>
            <id>ext:4DD-POKLADNA:<xsl:value-of select="java:flexibee.Tool.toUpper(Doklad)"/></id>
            <typDokl>code:MIGRACNI_POKLADNA</typDokl>
            <bsp>code:MIGRACNI</bsp>
            <xsl:choose>
                <xsl:when test="Druh_dokladu = 'V'">
                    <typPohybuK>typPohybu.vydej</typPohybuK>
                </xsl:when>
                <xsl:otherwise>
                    <typPohybuK>typPohybu.prijem</typPohybuK>
                </xsl:otherwise>
            </xsl:choose>
            <kod><xsl:value-of select="java:flexibee.Tool.toUpper(Doklad)"/></kod>
            <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(Datum, 'd.M.y')"/></datVyst>

            <xsl:if test="Firma != ''">
                <firma if-not-found="null">code:<xsl:value-of select="Firma"/></firma>
            </xsl:if>                
	   
            <zdrojProSkl>false</zdrojProSkl>
            <generovatSkl>false</generovatSkl>

            <!-- duzp jsou tady obe protoze musi byt stejne -->
	    <xsl:if test="Datum_uplatnění_DPH != '0000-00-00' and Datum_uplatnění_DPH != '00.00.00'">
            <datReal><xsl:value-of select="java:flexibee.Tool.parseDate(Datum_uplatnění_DPH, 'd.M.y')"/></datReal>
        	<duzpUcto><xsl:value-of select="java:flexibee.Tool.parseDate(Datum_uplatnění_DPH, 'd.M.y')"/></duzpUcto>
        	<duzpPuv><xsl:value-of select="java:flexibee.Tool.parseDate(Datum_uplatnění_DPH, 'd.M.y')"/></duzpPuv>
	    </xsl:if>

            <bezPolozek>true</bezPolozek>
            <sumOsv><xsl:value-of select="java:flexibee.Tool.parseMoney(Částka)"/></sumOsv>
            
            <popis><xsl:value-of select="Obsahuje"/>, Přijato/vydáno: <xsl:value-of select="Od_koho_komu"/></popis>
            <poznam>Pokladna č. <xsl:value-of select="java:flexibee.Tool.toUpper(Pokladna)"/>, Doklad: <xsl:value-of select="Doklad"/>, Kon. stav: <xsl:value-of select="Kon.stav"/></poznam>
            <xsl:if test="StřStředisko_pokl. != ''">
                <stredisko>code:<xsl:value-of select="StřStředisko_pokl."/></stredisko>
            </xsl:if>
            <xsl:if test="Zakázka != ''">
                <zakazka>code:<xsl:value-of select="java:flexibee.Tool.toUpper(Zakázka)"/></zakazka>
            </xsl:if>
        </pokladni-pohyb>
    </xsl:template>

</xsl:stylesheet>
