<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>
    <xsl:output method="xml" indent="yes" encoding="utf-8" />


    <xsl:variable name="radkyDoc" select="document('prijemky-radky.xml')"/>

    <xsl:key name="cisloKey" match="Řádky_příjemek" use="Číslo_příjemky"/>

    <xsl:template match="/Příjemky">
        <winstrom version="1.0">
<!--            <xsl:apply-templates select="*[local-name() = 'Příjemky' and position() &lt; 100]"/> -->
            <xsl:apply-templates select="Příjemky"/>
        </winstrom>
    </xsl:template>


<!--
/usr/share/flexibee/bin/flexibee2xml -t prijemky-in.xslt -x prijemky.xml -o prijemky-vystup.xml
-->

    <xsl:template match="Příjemky">
	    <xsl:variable name="cislo" select="Číslo_příjemky"/>

	<xsl:variable name="slevaDokl" select="Proc.sleva"/>

	<xsl:if test="Úč.období != '201109'">

        <skladovy-pohyb>
            <id>ext:4DD-PRIJ:<xsl:value-of select="java:flexibee.Tool.toUpper($cislo)"/></id>
            <typDokl>code:HISTORICKÁ</typDokl>
            <kod><xsl:value-of select="java:flexibee.Tool.toUpper(Číslo_příjemky)"/></kod>
	    <typPohybuK>typPohybu.prijem</typPohybuK>
            <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(Datum, 'd.M.y')"/></datVyst>

	    <xsl:if test="Dodavatel != '' and Dodavatel != '0' and Dodavatel != 'False'">
        	<firma>ext:4DD-ADR:<xsl:value-of select="Dodavatel"/></firma>
	    </xsl:if>
            <varSym><xsl:value-of select="Variab.symbol"/></varSym>
	    <xsl:if test="Dodací_list != ''">
	    	<cisDodak>ext:4DD-ZAK:<xsl:value-of select="Dodací_list"/></cisDodak>
	    </xsl:if>

	    <stredisko if-not-found="null">ext:4DD-STRED:<xsl:value-of select="Středisko"/></stredisko>
	    <xsl:if test="Zakázka != ''">
	    	<zakazka>ext:4DD-ZAK:<xsl:value-of select="Zakázka"/></zakazka>
	    </xsl:if>
            <poznam><xsl:value-of select="Poznámka"/></poznam>
	    <popis>Hodnota: <xsl:value-of select="Hodnota"/>
		   <xsl:if test="Úč.doklad != '0'">, Úč. doklad: <xsl:value-of select="Úč.doklad"/></xsl:if>
		   <xsl:if test="Číslo_faktury != '0'">, číslo faktury: <xsl:value-of select="Číslo_faktury"/></xsl:if>
		   <xsl:if test="Č.převodky != '0'">, číslo převodky: <xsl:value-of select="Č.převodky"/></xsl:if>
		</popis>

	    <xsl:for-each select="$radkyDoc">
		    <xsl:choose>
			<xsl:when test="key('cisloKey',$cislo)[1]/Číslo_skladu != ''">
			    <sklad>code:<xsl:value-of select="key('cisloKey',$cislo)[1]/Číslo_skladu"/>_HISTORIE</sklad>
			</xsl:when>
			<xsl:otherwise>
			    <sklad>code:XXX_HISTORIE</sklad>
			</xsl:otherwise>
		    </xsl:choose>
	    </xsl:for-each>


	    <skladovePolozky>

		<xsl:for-each select="$radkyDoc">
			<xsl:for-each select="key('cisloKey',$cislo)">
			    <skladovy-pohyb-polozka>
				<id>ext:4DD-PRIJ:<xsl:value-of select="java:flexibee.Tool.toUpper(Číslo_příjemky)"/>-<xsl:value-of select="java:flexibee.Tool.toUpper(Řádek)"/></id>
				<typPolozkyK>typPolozky.katalog</typPolozkyK>
				<cenik>ean:<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_EAN)"/></cenik>
				<eanKod><xsl:value-of select="java:flexibee.Tool.toUpper(Kód_EAN)"/></eanKod>
				<mnozMj><xsl:value-of select="java:flexibee.Tool.parseMoney(Množství)"/></mnozMj>
				<xsl:choose>
				    <xsl:when test="(Proc.sleva != '' and Proc.sleva != '0') or ($slevaDokl != '' and $slevaDokl != '0')">
					<cenaMj><xsl:value-of select="java:flexibee.Tool.parseMoney(J.cena) * ((100.0 -  java:flexibee.Tool.parseMoney(Proc.sleva) - java:flexibee.Tool.parseMoney($slevaDokl)) div 100.0)"/></cenaMj>
				    </xsl:when>
				    <xsl:otherwise>
					<cenaMj><xsl:value-of select="java:flexibee.Tool.parseMoney(J.cena)"/></cenaMj>
				    </xsl:otherwise>
				</xsl:choose>
				<cenyRucne>true</cenyRucne>
				<xsl:if test="Číslo_skladu = ''">
				<sklad>code:XXX_HISTORIE</sklad>
				</xsl:if>
				<xsl:if test="Číslo_skladu != ''">
				<sklad>code:<xsl:value-of select="java:flexibee.Tool.toUpper(Číslo_skladu)"/>_HISTORIE</sklad>
				</xsl:if>
				<poznam><xsl:value-of select="Poznámka"/>
				    <xsl:if test="(Proc.sleva != '' and Proc.sleva != '0') or ($slevaDokl != '' and $slevaDokl != '0')">
					<xsl:if test="Poznámka != ''">, </xsl:if>
					Cena před slevou (<xsl:value-of select="java:flexibee.Tool.parseMoney(Proc.sleva) + java:flexibee.Tool.parseMoney($slevaDokl)"/>%): <xsl:value-of select="java:flexibee.Tool.parseMoney(J.cena)"/>
				    </xsl:if></poznam>

			    </skladovy-pohyb-polozka>
			</xsl:for-each>
		</xsl:for-each>
	    </skladovePolozky>
        </skladovy-pohyb>

	</xsl:if>
    </xsl:template>

</xsl:stylesheet>
