-------------------------------------------------------------------------
-- Bug 14197 – [WinStrom] Tabulka osob
-------------------------------------------------------------------------

-- Skupiny osob
CREATE SEQUENCE seq_pskuposob
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pskuposob OWNER TO %firmaRole%;

CREATE TABLE pskuposob
(
  idskuposob integer DEFAULT nextval('seq_pskuposob'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  kod character varying(20) NOT NULL,
  nazev character varying(255),
  nazeva character varying(255),
  nazevb character varying(255),
  nazevc character varying(255),
  popis character varying(255),
  poznam text,
  show boolean NOT NULL DEFAULT true,
  platido date,
  platiod date,
  idtdintnahrad integer,
  idtdinthruba integer,
  CONSTRAINT pskuposob_pkey PRIMARY KEY (idskuposob),
  CONSTRAINT fk7623d0dabb627e5c FOREIGN KEY (idtdintnahrad)
      REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk7623d0dae4ebd49e FOREIGN KEY (idtdinthruba)
      REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT pskuposob_kod_key UNIQUE (kod)
);
ALTER TABLE pskuposob OWNER TO %firmaRole%;


-- Tabulka hlaviček zaměstnanců
CREATE SEQUENCE seq_posobahlav
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_posobahlav OWNER TO %firmaRole%;

CREATE TABLE posobahlav
(
  idosobahlav integer DEFAULT nextval('seq_posobahlav'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  CONSTRAINT posobahlav_pkey PRIMARY KEY (idosobahlav)
);
ALTER TABLE posobahlav OWNER TO %firmaRole%;


-- Tabulka nastavení zaměstnanců
CREATE SEQUENCE seq_posoba
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_posoba OWNER TO %firmaRole%;

CREATE TABLE posoba
(
  idosoba integer DEFAULT nextval('seq_posoba'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  cisdomu character varying(20),
  cisdomukon character varying(20),
  cisdomukontuz character varying(20),
  cispojist character varying(20),
  cisprukaz character varying(20),
  cizpojcisdomu character varying(20),
  cizpojcislo character varying(255),
  cizpojmesto character varying(255),
  cizpojnazev character varying(255),
  cizpojpsc character varying(20),
  cizpojspec character varying(255),
  cizpojulice character varying(255),
  dannerezid boolean DEFAULT false,
  datnaroz date,
  email character varying(255),
  fax character varying(255),
  funkce character varying(255),
  ispvokres character varying(255),
  ispvvzdelani character varying(255),
  ispvzamest character varying(255),
  jmeno character varying(255),
  kvalifikace character varying(255),
  mesto character varying(255),
  mestokon character varying(255),
  mestokontuz character varying(255),
  minulesoc numeric(15,2) DEFAULT 0.0,
  minulezdrav numeric(15,2) DEFAULT 0.0,
  mistonaroz character varying(255),
  mobil character varying(255),
  nezdatnaroz date,
  nezdo date,
  nezjmeno character varying(255),
  nezod date,
  nezpartner boolean DEFAULT false,
  nezpohlavik character varying(50),
  nezprijmeni character varying(255),
  nezprijmenirod character varying(255),
  nezrodcis character varying(20),
  neztitul character varying(255),
  nezztp boolean DEFAULT false,
  nezztpdo date,
  nezztpod date,
  odpracdnupred integer DEFAULT 0,
  odpracrokupred integer DEFAULT 0,
  osbcis character varying(20) NOT NULL,
  osbcisalter character varying(20),
  platido date,
  platiod date,
  podpisprohl boolean DEFAULT false,
  pohlavik character varying(50),
  posta character varying(255),
  postakon character varying(255),
  postakontuz character varying(255),
  poznam text,
  prednempoj character varying(255),
  prijmeni character varying(255),
  prijmenipred character varying(255),
  prijmenirod character varying(255),
  psc character varying(20),
  psckon character varying(20),
  psckontuz character varying(20),
  rodcis character varying(20),
  rodstavk character varying(50),
  soucnempoj character varying(255),
  telefon character varying(255),
  titul character varying(255),
  typvztahuk character varying(50),
  ulice character varying(255),
  ulicekon character varying(255),
  ulicekontuz character varying(255),
  zdrpojdoplat boolean DEFAULT false,
  zpusplatbyk character varying(50),
  idcizpojstatu integer,
  idstatunaroz integer,
  idstatukontuz integer,
  idosobahlav integer NOT NULL,
  idstatukon integer,
  idstredisko integer,
  idzdravpoj integer,
  idstatu integer,
  prukazztp boolean DEFAULT false,
  idskuposob integer,
  CONSTRAINT posoba_pkey PRIMARY KEY (idosoba),
  CONSTRAINT fkc3adf9fa3feff3a8 FOREIGN KEY (idstatunaroz)
      REFERENCES astaty (idstatu) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc3adf9fa4248e313 FOREIGN KEY (idcizpojstatu)
      REFERENCES astaty (idstatu) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc3adf9fa43d3196a FOREIGN KEY (idstatu)
      REFERENCES astaty (idstatu) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc3adf9fa4ba9b668 FOREIGN KEY (idstatukon)
      REFERENCES astaty (idstatu) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc3adf9fa73713339 FOREIGN KEY (idstatukontuz)
      REFERENCES astaty (idstatu) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc3adf9faa5048c67 FOREIGN KEY (idzdravpoj)
      REFERENCES aadresar (idfirmy) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc3adf9faf3bcf0d0 FOREIGN KEY (idosobahlav)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc3adf9faf8fd842d FOREIGN KEY (idstredisko)
      REFERENCES ustrediska (idstred) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc3adf9fa695cea0a FOREIGN KEY (idskuposob)
      REFERENCES pskuposob (idskuposob) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE posoba OWNER TO %firmaRole%;

-- Tabulka dětí
CREATE SEQUENCE seq_pdite
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pdite OWNER TO %firmaRole%;

CREATE TABLE pdite
(
  iddite integer DEFAULT nextval('seq_pdite'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  datnaroz date,
  jmeno character varying(255),
  pohlavik character varying(50),
  poznam text,
  prijmeni character varying(255),
  rodcis character varying(20),
  ztp_p boolean DEFAULT false,
  ztp_pdo date,
  ztp_pod date,
  idosoba integer NOT NULL,
  CONSTRAINT pdite_pkey PRIMARY KEY (iddite),
  CONSTRAINT fk64aca46483ac817 FOREIGN KEY (idosoba)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE pdite OWNER TO %firmaRole%;

-- Vazební tabulky pro výběrové klíče

CREATE TABLE wkli_zosoba
(
  idosoba integer NOT NULL,
  idvybklic integer NOT NULL,
  CONSTRAINT wkli_zosoba_pkey PRIMARY KEY (idosoba, idvybklic),
  CONSTRAINT fke47f4fe4c9fb2f1 FOREIGN KEY (idvybklic)
      REFERENCES wvybklice (idvybklice) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fke47f4fecd357b3e FOREIGN KEY (idosoba)
      REFERENCES posoba (idosoba) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE wkli_zosoba OWNER TO %firmaRole%;

CREATE TABLE wkli_zdite
(
  iddite integer NOT NULL,
  idvybklic integer NOT NULL,
  CONSTRAINT wkli_zdite_pkey PRIMARY KEY (iddite, idvybklic),
  CONSTRAINT fk8b2daa24c9fb2f1 FOREIGN KEY (idvybklic)
      REFERENCES wvybklice (idvybklice) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk8b2daa25928fc02 FOREIGN KEY (iddite)
      REFERENCES pdite (iddite) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE wkli_zdite OWNER TO %firmaRole%;

-- Indexy

CREATE INDEX pDite_IdOsoba_index ON pDite USING btree (IdOsoba);
CREATE INDEX pOsoba_IdOsobaHlav_index ON pOsoba USING btree (IdOsobaHlav);
CREATE INDEX pOsoba_IdSkupOsob_index ON pOsoba USING btree (IdSkupOsob);
CREATE INDEX pOsoba_IdStatuNaroz_index ON pOsoba USING btree (IdStatuNaroz);
CREATE INDEX pOsoba_IdStredisko_index ON pOsoba USING btree (IdStredisko);
CREATE INDEX pOsoba_IdStatu_index ON pOsoba USING btree (IdStatu);
CREATE INDEX pOsoba_IdStatuKon_index ON pOsoba USING btree (IdStatuKon);
CREATE INDEX pOsoba_IdStatuKonTuz_index ON pOsoba USING btree (IdStatuKonTuz);
CREATE INDEX pOsoba_IdZdravPoj_index ON pOsoba USING btree (IdZdravPoj);
CREATE INDEX pOsoba_IdCizPojStatu_index ON pOsoba USING btree (IdCizPojStatu);
CREATE INDEX pSkupOsob_IdTdIntHruba_index ON pSkupOsob USING btree (IdTdIntHruba);
CREATE INDEX pSkupOsob_IdTdIntNahrad_index ON pSkupOsob USING btree (IdTdIntNahrad);


---------------------------------------------------------------
-- Bug 14356 – [WinStrom] Další tabulky a formuláře pro mzdy
---------------------------------------------------------------

-- Tabulka číselníku mzdových složek
CREATE SEQUENCE seq_pcismzdsloz
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pcismzdsloz OWNER TO %firmaRole%;

CREATE TABLE pcismzdsloz
(
  idcismzdsloz integer DEFAULT nextval('seq_pcismzdsloz'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  kod character varying(20) NOT NULL,
  nazev character varying(255),
  nazeva character varying(255),
  nazevb character varying(255),
  nazevc character varying(255),
  popis character varying(255),
  poznam text,
  show boolean NOT NULL DEFAULT true,
  skupslozkyk character varying(50),
  typslozkyk character varying(50),
  naosobu boolean DEFAULT false,
  vscastmzd boolean DEFAULT false,
  vscastnaden boolean DEFAULT false,
  vscastnahod boolean DEFAULT false,
  vscisdoklnem boolean DEFAULT false,
  vsdatdo boolean DEFAULT false,
  vsdatod boolean DEFAULT false,
  vsdnykal boolean DEFAULT false,
  vsdnyprac boolean DEFAULT false,
  vsdnysvatek boolean DEFAULT false,
  vshodiny boolean DEFAULT false,
  vsdoplatzdrpoj boolean DEFAULT false,
  vspocetmes boolean DEFAULT false,
  vsprocmzd boolean DEFAULT false,
  vsprumnadennem boolean DEFAULT false,
  vsprumnahodnem boolean DEFAULT false,
  vszakljekracen boolean DEFAULT false,
  vszaklmzd boolean DEFAULT false,
  vszmenacastmzd boolean DEFAULT false,
  platido date,
  platiod date,
  cisrad integer,
  vyznamk character varying(50),
  castmzd numeric(15,2) DEFAULT 0.0,
  castkaden numeric(15,2) DEFAULT 0.0,
  castkahod numeric(15,2) DEFAULT 0.0,
  cisdoklnem integer,
  dnykal numeric(6,2) DEFAULT 0.0,
  dnyprac numeric(6,2) DEFAULT 0.0,
  dnysvatek numeric(6,2) DEFAULT 0.0,
  doplatzdravk character varying(50),
  hodiny numeric(6,2) DEFAULT 0.0,
  pocetmes integer,
  procmzd numeric(15,2) DEFAULT 0.0,
  prumnadennem numeric(15,2) DEFAULT 0.0,
  prumnahodnem numeric(15,2) DEFAULT 0.0,
  zakljekracen boolean DEFAULT false,
  zaklmzd numeric(15,2) DEFAULT 0.0,
  zmenacastmzd boolean DEFAULT false,
  pracovni boolean DEFAULT false,
  CONSTRAINT pcismzdsloz_pkey PRIMARY KEY (idcismzdsloz),
  CONSTRAINT pcismzdsloz_kod_key UNIQUE (kod)
);
ALTER TABLE pcismzdsloz OWNER TO %firmaRole%;


-- Tabulka důchodů
CREATE SEQUENCE seq_pduchod
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pduchod OWNER TO %firmaRole%;

CREATE TABLE pduchod
(
  idduchod integer DEFAULT nextval('seq_pduchod'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  platido date,
  platiod date,
  poznam text,
  typduchoduk character varying(50),
  idosoba integer NOT NULL,
  CONSTRAINT pduchod_pkey PRIMARY KEY (idduchod),
  CONSTRAINT fk9f62c99b483ac817 FOREIGN KEY (idosoba)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE pduchod OWNER TO %firmaRole%;


-- Tabulka odečitatelných položek
CREATE SEQUENCE seq_podecitpol
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_podecitpol OWNER TO %firmaRole%;

CREATE TABLE podecitpol
(
  idodecitpol integer DEFAULT nextval('seq_podecitpol'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  platido date,
  platiod date,
  kod character varying(20) NOT NULL,
  nazev character varying(255),
  skupslozkyk character varying(50),
  typslozkyk character varying(50),
  poznam text,
  idosoba integer NOT NULL,
  idcismzdsloz integer NOT NULL,
  CONSTRAINT podecitpol_pkey PRIMARY KEY (idodecitpol),
  CONSTRAINT fkc2f8053f483ac817 FOREIGN KEY (idosoba)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc2f8053f8c4d9ef2 FOREIGN KEY (idcismzdsloz)
      REFERENCES pcismzdsloz (idcismzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE podecitpol OWNER TO %firmaRole%;


-- Tabulka typů pracovních poměrů
CREATE SEQUENCE seq_ptyppracpom
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_ptyppracpom OWNER TO %firmaRole%;

CREATE TABLE ptyppracpom
(
  idtyppracpom integer DEFAULT nextval('seq_ptyppracpom'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  kod character varying(20) NOT NULL,
  nazev character varying(255) NOT NULL,
  nazeva character varying(255),
  nazevb character varying(255),
  nazevc character varying(255),
  popis character varying(255),
  poznam text,
  "show" boolean NOT NULL DEFAULT true,
  platido date,
  platiod date,
  CONSTRAINT ptyppracpom_pkey PRIMARY KEY (idtyppracpom)
);
ALTER TABLE ptyppracpom OWNER TO %firmaRole%;


-- Tabulka hlaviček pracovních poměrů
CREATE SEQUENCE seq_ppracpomhlav
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_ppracpomhlav OWNER TO %firmaRole%;

CREATE TABLE ppracpomhlav
(
  idpracpomhlav integer NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  idosoba integer NOT NULL,
  aktivnido date,
  aktivniod date,
  CONSTRAINT ppracpomhlav_pkey PRIMARY KEY (idpracpomhlav),
  CONSTRAINT fk5365ced3483ac817 FOREIGN KEY (idosoba)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE ppracpomhlav OWNER TO %firmaRole%;


-- Tabulka pracovních poměrů
CREATE SEQUENCE seq_ppracpom
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_ppracpom OWNER TO %firmaRole%;

CREATE TABLE ppracpom
(
  idpracpom integer DEFAULT nextval('seq_ppracpom'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  platido date,
  platiod date,
  idpracpomhlav integer NOT NULL,
  kod character varying(20) NOT NULL,
  nazev character varying(255),
  aktivnido date,
  aktivniod date,
  hlavni boolean DEFAULT false,
  hodinovamzda numeric(15,2) DEFAULT 0.0,
  kodeldp character varying(20),
  konecpomeru date,
  malyrozsah boolean DEFAULT false,
  mesicnimzda numeric(15,2) DEFAULT 0.0,
  nastup date,
  plneniodprdobyk character varying(50),
  pracrozvrhk character varying(50),
  predhrubprijem numeric(15,2) DEFAULT 0.0,
  procminmzd integer,
  tariftrida character varying(255),
  typmzdyk character varying(50),
  uvazhodtydne integer,
  zacatek date,
  idtyppracpom integer NOT NULL,
  idosoba integer NOT NULL,
  zlistduvod character varying(255),
  zlistsdeleni text,
  zlistukonceni character varying(255),
  uvazdnutydne integer,
  zacpracdoby integer,
  idtdinthruba integer,
  idtdintnahrad integer,
  CONSTRAINT ppracpom_pkey PRIMARY KEY (idpracpom),
  CONSTRAINT fkc283bf7a39186a54 FOREIGN KEY (idtyppracpom)
      REFERENCES ptyppracpom (idtyppracpom) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc283bf7a483ac817 FOREIGN KEY (idosoba)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc283bf7abb627e5c FOREIGN KEY (idtdintnahrad)
      REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc283bf7ae4ebd49e FOREIGN KEY (idtdinthruba)
      REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE ppracpom OWNER TO %firmaRole%;


-- Tabulka nepřítomností
CREATE SEQUENCE seq_pnepritomnost
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pnepritomnost OWNER TO %firmaRole%;

CREATE TABLE pnepritomnost
(
  idnepritomnost integer DEFAULT nextval('seq_pnepritomnost'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  hodin1den integer,
  hodinxden integer,
  platido date,
  platiod date,
  poznam text,
  idosoba integer NOT NULL,
  idpracpom integer NOT NULL,
  idcismzdsloz integer,
  CONSTRAINT pnepritomnost_pkey PRIMARY KEY (idnepritomnost),
  CONSTRAINT fkad948d34483ac817 FOREIGN KEY (idosoba)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkad948d3431a00b7 FOREIGN KEY (idpracpom)
      REFERENCES ppracpomhlav (idpracpomhlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkad948d348c4d9ef2 FOREIGN KEY (idcismzdsloz)
      REFERENCES pcismzdsloz (idcismzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE pnepritomnost OWNER TO %firmaRole%;


-- Tabulka směn
CREATE SEQUENCE seq_psmeny
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_psmeny OWNER TO %firmaRole%;

CREATE TABLE psmeny
(
  idsmeny integer DEFAULT nextval('seq_psmeny'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  mesic integer DEFAULT 0,
  planovane text,
  rok integer,
  skutecne text,
  idpracpom integer,
  idskuposob integer,
  idosoba integer,
  CONSTRAINT psmeny_pkey PRIMARY KEY (idsmeny),
  CONSTRAINT fkc3e379c6483ac817 FOREIGN KEY (idosoba)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc3e379c6695cea0a FOREIGN KEY (idskuposob)
      REFERENCES pskuposob (idskuposob) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkc3e379c6ba9cd3de FOREIGN KEY (idpracpom)
      REFERENCES ppracpomhlav (idpracpomhlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE psmeny OWNER TO %firmaRole%;


-- Vazební tabulky pro výběrové klíče
CREATE TABLE wkli_pnepritomnost
(
  idnepritomnost integer NOT NULL,
  idvybklic integer NOT NULL,
  CONSTRAINT wkli_pnepritomnost_pkey PRIMARY KEY (idnepritomnost, idvybklic),
  CONSTRAINT fk350c308644f0abde FOREIGN KEY (idnepritomnost)
      REFERENCES pnepritomnost (idnepritomnost) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk350c30864c9fb2f1 FOREIGN KEY (idvybklic)
      REFERENCES wvybklice (idvybklice) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE wkli_pnepritomnost OWNER TO %firmaRole%;


-- indexy
CREATE INDEX pDuchod_IdOsoba_index ON pDuchod USING btree (IdOsoba);
CREATE INDEX pNepritomnost_IdOsoba_index ON pNepritomnost USING btree (IdOsoba);
CREATE INDEX pNepritomnost_IdCisMzdSloz_index ON pNepritomnost USING btree (IdCisMzdSloz);
CREATE INDEX pNepritomnost_IdPracPom_index ON pNepritomnost USING btree (IdPracPom);
CREATE INDEX pOdecitPol_IdOsoba_index ON pOdecitPol USING btree (IdOsoba);
CREATE INDEX pOdecitPol_IdCisMzdSloz_index ON pOdecitPol USING btree (IdCisMzdSloz);
CREATE INDEX pPracPom_IdPracPomHlav_index ON pPracPom USING btree (IdPracPomHlav);
CREATE INDEX pPracPom_IdOsoba_index ON pPracPom USING btree (IdOsoba);
CREATE INDEX pPracPom_IdTypPracPom_index ON pPracPom USING btree (IdTypPracPom);
CREATE INDEX pPracPom_IdTdIntHruba_index ON pPracPom USING btree (IdTdIntHruba);
CREATE INDEX pPracPom_IdTdIntNahrad_index ON pPracPom USING btree (IdTdIntNahrad);
CREATE INDEX pPracPomHlav_IdOsoba_index ON pPracPomHlav USING btree (IdOsoba);
CREATE INDEX pSmeny_IdOsoba_index ON pSmeny USING btree (IdOsoba);
CREATE INDEX pSmeny_IdPracPom_index ON pSmeny USING btree (IdPracPom);
CREATE INDEX pSmeny_IdSkupOsob_index ON pSmeny USING btree (IdSkupOsob);



-- Tabulka stálých mzdových složek
CREATE SEQUENCE seq_pstalamzdsloz
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pstalamzdsloz OWNER TO %firmaRole%;

CREATE TABLE pstalamzdsloz
(
  idstalamzdsloz integer DEFAULT nextval('seq_pstalamzdsloz'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  castkaden numeric(15,2) DEFAULT 0.0,
  castkahod numeric(15,2) DEFAULT 0.0,
  datumdo date,
  datumod date,
  kod character varying(20) NOT NULL,
  nazev character varying(255),
  pocetmes integer,
  podil numeric(6,2) DEFAULT 0.0,
  poznam text,
  procmzd numeric(15,2) DEFAULT 0.0,
  skupslozkyk character varying(50),
  typpodilk character varying(50),
  typslozkyk character varying(50),
  zakljekracen boolean DEFAULT false,
  zaklmzd numeric(15,2) DEFAULT 0.0,
  idcismzdsloz integer NOT NULL,
  idpracpom integer NOT NULL,
  idstredisko integer,
  idzakazka integer,
  idosoba integer NOT NULL,
  CONSTRAINT pstalamzdsloz_pkey PRIMARY KEY (idstalamzdsloz),
  CONSTRAINT fk87a8c236483ac817 FOREIGN KEY (idosoba)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk87a8c2368c4d9ef2 FOREIGN KEY (idcismzdsloz)
      REFERENCES pcismzdsloz (idcismzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk87a8c236ba9cd3de FOREIGN KEY (idpracpom)
      REFERENCES ppracpomhlav (idpracpomhlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk87a8c236f8fd842d FOREIGN KEY (idstredisko)
      REFERENCES ustrediska (idstred) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk87a8c236fa994e17 FOREIGN KEY (idzakazka)
      REFERENCES uzakazky (idzakazky) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE pstalamzdsloz OWNER TO %firmaRole%;


-- Tabulka srážek
CREATE SEQUENCE seq_psrazka
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_psrazka OWNER TO %firmaRole%;

CREATE TABLE psrazka
(
  idsrazka integer DEFAULT nextval('seq_psrazka'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  castka numeric(15,2) DEFAULT 0.0,
  celkem numeric(15,2) DEFAULT 0.0,
  deponovatdo date,
  kdatu date,
  kod character varying(20) NOT NULL,
  nazev character varying(255),
  skupslozkyk character varying(50),
  typslozkyk character varying(50),
  pocatek numeric(15,2) DEFAULT 0.0,
  poradi integer,
  poznam text,
  prednostni boolean DEFAULT false,
  procmzd numeric(10,6) DEFAULT 0.0,
  srazkado date,
  srazkaod date,
  zbyva numeric(15,2) DEFAULT 0.0,
  zpusobplatbyk character varying(50),
  idbanspoj integer,
  idtypostzav integer,
  idosoba integer NOT NULL,
  idcismzdsloz integer NOT NULL,
  CONSTRAINT psrazka_pkey PRIMARY KEY (idsrazka),
  CONSTRAINT fkb8d08ebe144f8d03 FOREIGN KEY (idbanspoj)
      REFERENCES abanspoj (idbanspoj) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkb8d08ebe483ac817 FOREIGN KEY (idosoba)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkb8d08ebe852963e7 FOREIGN KEY (idtypostzav)
      REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkb8d08ebe8c4d9ef2 FOREIGN KEY (idcismzdsloz)
      REFERENCES pcismzdsloz (idcismzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE psrazka OWNER TO %firmaRole%;


-- Tabulka mzdových složek
CREATE SEQUENCE seq_pmzdsloz
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pmzdsloz OWNER TO %firmaRole%;

CREATE TABLE pmzdsloz
(
  idmzdsloz integer DEFAULT nextval('seq_pmzdsloz'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  castmzd numeric(15,2) DEFAULT 0.0,
  castkaden numeric(15,2) DEFAULT 0.0,
  castkahod numeric(15,2) DEFAULT 0.0,
  cisdoklnem integer,
  datumdo date,
  datumod date,
  dnykal numeric(6,2) DEFAULT 0.0,
  dnyprac numeric(6,2) DEFAULT 0.0,
  dnysvatek numeric(6,2) DEFAULT 0.0,
  doplatzdravk character varying(50),
  hodiny numeric(6,2) DEFAULT 0.0,
  kod character varying(20) NOT NULL,
  mesic integer,
  nazev character varying(255),
  pocetmes integer,
  cisrad integer,
  poznam text,
  procmzd numeric(15,2) DEFAULT 0.0,
  prumnadennem numeric(15,2) DEFAULT 0.0,
  prumnahodnem numeric(15,2) DEFAULT 0.0,
  rok integer,
  skupslozkyk character varying(50),
  typslozkyk character varying(50),
  zakljekracen boolean DEFAULT false,
  zaklmzd numeric(15,2) DEFAULT 0.0,
  zmenacastmzd boolean DEFAULT false,
  pracovni boolean DEFAULT false,
  idpracpom integer,
  idosoba integer NOT NULL,
  idzakazka integer,
  idcismzdsloz integer NOT NULL,
  idstredisko integer,
  idsrazka integer,
  idstalamzdsloz integer,
  idodecitpol integer,
  idnepritomnost integer,
  CONSTRAINT pmzdsloz_pkey PRIMARY KEY (idmzdsloz),
  CONSTRAINT fk319b3c6b483ac817 FOREIGN KEY (idosoba)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk319b3c6b8c4d9ef2 FOREIGN KEY (idcismzdsloz)
      REFERENCES pcismzdsloz (idcismzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk319b3c6bba9cd3de FOREIGN KEY (idpracpom)
      REFERENCES ppracpomhlav (idpracpomhlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk319b3c6be6f87f72 FOREIGN KEY (idsrazka)
      REFERENCES psrazka (idsrazka) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk319b3c6b95ef09e2 FOREIGN KEY (idstalamzdsloz)
      REFERENCES pstalamzdsloz (idstalamzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk319b3c6bc0de9d9d FOREIGN KEY (idodecitpol)
      REFERENCES podecitpol (idodecitpol) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk319b3c6b44f0abde FOREIGN KEY (idnepritomnost)
      REFERENCES pnepritomnost (idnepritomnost) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk319b3c6bf8fd842d FOREIGN KEY (idstredisko)
      REFERENCES ustrediska (idstred) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk319b3c6bfa994e17 FOREIGN KEY (idzakazka)
      REFERENCES uzakazky (idzakazky) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE pmzdsloz OWNER TO %firmaRole%;



-- Vazební tabulky pro výběrové klíče
CREATE TABLE wkli_pmzdsloz
(
  idmzdsloz integer NOT NULL,
  idvybklic integer NOT NULL,
  CONSTRAINT wkli_pmzdsloz_pkey PRIMARY KEY (idmzdsloz, idvybklic),
  CONSTRAINT fk2ee54d994c9fb2f1 FOREIGN KEY (idvybklic)
      REFERENCES wvybklice (idvybklice) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk2ee54d9998d9e180 FOREIGN KEY (idmzdsloz)
      REFERENCES pmzdsloz (idmzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE wkli_pmzdsloz OWNER TO %firmaRole%;

CREATE TABLE wkli_pstalamzdsloz
(
  idstalamzdsloz integer NOT NULL,
  idvybklic integer NOT NULL,
  CONSTRAINT wkli_pstalamzdsloz_pkey PRIMARY KEY (idstalamzdsloz, idvybklic),
  CONSTRAINT fkabf659884c9fb2f1 FOREIGN KEY (idvybklic)
      REFERENCES wvybklice (idvybklice) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fkabf6598895ef09e2 FOREIGN KEY (idstalamzdsloz)
      REFERENCES pstalamzdsloz (idstalamzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE wkli_pstalamzdsloz OWNER TO %firmaRole%;




CREATE INDEX pCisMzdSloz_VyznamK_index ON pCisMzdSloz USING btree (VyznamK);
CREATE INDEX pMzdSloz_IdOsoba_index ON pMzdSloz USING btree (IdOsoba);
CREATE INDEX pMzdSloz_IdPracPom_index ON pMzdSloz USING btree (IdPracPom);
CREATE INDEX pMzdSloz_IdCisMzdSloz_index ON pMzdSloz USING btree (IdCisMzdSloz);
CREATE INDEX pMzdSloz_IdStredisko_index ON pMzdSloz USING btree (IdStredisko);
CREATE INDEX pMzdSloz_IdZakazka_index ON pMzdSloz USING btree (IdZakazka);
CREATE INDEX pMzdSloz_IdStalaMzdSloz_index ON pMzdSloz USING btree (IdStalaMzdSloz);
CREATE INDEX pMzdSloz_IdSrazka_index ON pMzdSloz USING btree (IdSrazka);
CREATE INDEX pMzdSloz_IdOdecitPol_index ON pMzdSloz USING btree (IdOdecitPol);
CREATE INDEX pMzdSloz_IdNepritomnost_index ON pMzdSloz USING btree (IdNepritomnost);
CREATE INDEX pSrazka_IdOsoba_index ON pSrazka USING btree (IdOsoba);
CREATE INDEX pSrazka_IdCisMzdSloz_index ON pSrazka USING btree (IdCisMzdSloz);
CREATE INDEX pSrazka_IdBanSpoj_index ON pSrazka USING btree (IdBanSpoj);
CREATE INDEX pSrazka_IdTypOstZav_index ON pSrazka USING btree (IdTypOstZav);
CREATE INDEX pStalaMzdSloz_IdOsoba_index ON pStalaMzdSloz USING btree (IdOsoba);
CREATE INDEX pStalaMzdSloz_IdPracPom_index ON pStalaMzdSloz USING btree (IdPracPom);
CREATE INDEX pStalaMzdSloz_IdCisMzdSloz_index ON pStalaMzdSloz USING btree (IdCisMzdSloz);
CREATE INDEX pStalaMzdSloz_IdStredisko_index ON pStalaMzdSloz USING btree (IdStredisko);
CREATE INDEX pStalaMzdSloz_IdZakazka_index ON pStalaMzdSloz USING btree (IdZakazka);



-- Tabulka hlavicek kalkulatoru mezd
CREATE SEQUENCE seq_pmzdcalchlav
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pmzdcalchlav OWNER TO %firmaRole%;

CREATE TABLE pmzdcalchlav
(
  idmzdcalchlav integer DEFAULT nextval('seq_pmzdcalchlav'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  kod character varying(20) NOT NULL,
  nazev character varying(255) NOT NULL,
  nazeva character varying(255),
  nazevb character varying(255),
  nazevc character varying(255),
  popis character varying(255),
  poznam text,
  show boolean NOT NULL DEFAULT true,
  platido date,
  platiod date,
  CONSTRAINT pmzdcalchlav_pkey PRIMARY KEY (idmzdcalchlav)
);
ALTER TABLE pmzdcalchlav OWNER TO %firmaRole%;


-- Tabulka radku kalkulatoru mezd
CREATE SEQUENCE seq_pmzdcalc
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pmzdcalc OWNER TO %firmaRole%;

CREATE TABLE pmzdcalc
(
  idmzdcalc integer DEFAULT nextval('seq_pmzdcalc'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  kod character varying(20) NOT NULL,
  nazev character varying(255) NOT NULL,
  nazeva character varying(255),
  nazevb character varying(255),
  nazevc character varying(255),
  popis character varying(255),
  poznam text,
  show boolean NOT NULL DEFAULT true,
  cisrad integer NOT NULL DEFAULT 0,
  dohodnoty numeric(19,6) DEFAULT 0.0,
  koeficient numeric(19,6) NOT NULL DEFAULT 0.0,
  koeficient2 numeric(19,6) NOT NULL DEFAULT 1.0,
  odhodnoty numeric(19,6) DEFAULT 0.0,
  polein character varying(255) NOT NULL,
  poleout character varying(255) NOT NULL,
  zaokrjakk character varying(50),
  zaokrnak character varying(50),
  operacek character varying(50),
  idmzdcalchlav integer NOT NULL,
  idmzdslozout integer NOT NULL,
  idmzdslozin integer NOT NULL,
  vyhodnotrocne boolean DEFAULT false,
  sumtypk character varying(50),
  summesicu integer DEFAULT 0,
  CONSTRAINT pmzdcalc_pkey PRIMARY KEY (idmzdcalc),
  CONSTRAINT fk3193ccbc59ac65b4 FOREIGN KEY (idmzdcalchlav)
      REFERENCES pmzdcalchlav (idmzdcalchlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk3193ccbc81d0ccae FOREIGN KEY (idmzdslozin)
      REFERENCES pcismzdsloz (idcismzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk3193ccbcffa59017 FOREIGN KEY (idmzdslozout)
      REFERENCES pcismzdsloz (idcismzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE pmzdcalc OWNER TO %firmaRole%;


-- Tabulka parametrů typů pracovních poměrů
CREATE SEQUENCE seq_ptyppracpomparam
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_ptyppracpomparam OWNER TO %firmaRole%;

CREATE TABLE ptyppracpomparam
(
  idtyppracpomparam integer DEFAULT nextval('seq_ptyppracpomparam'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  kod character varying(20) NOT NULL,
  nazev character varying(255) NOT NULL,
  nazeva character varying(255),
  nazevb character varying(255),
  nazevc character varying(255),
  popis character varying(255),
  poznam text,
  "show" boolean NOT NULL DEFAULT true,
  platido date,
  platiod date,
  cisrad integer NOT NULL DEFAULT 0,
  dohodnoty numeric(19,6) DEFAULT 0.0,
  koeficient numeric(10,6) NOT NULL DEFAULT 0.0,
  odhodnoty numeric(19,6) DEFAULT 0.0,
  polenuluj character varying(255) NOT NULL,
  poletest character varying(255) NOT NULL,
  idtyppracpom integer,
  idmzdcalchlav integer NOT NULL,
  idcismzdsloz integer NOT NULL,
  actmaprohl boolean DEFAULT true,
  actmalyroz boolean DEFAULT true,
  actnemaprohl boolean DEFAULT true,
  actvelkyroz boolean DEFAULT true,
  CONSTRAINT ptyppracpomparam_pkey PRIMARY KEY (idtyppracpomparam),
  CONSTRAINT fk764403e59ac65b4 FOREIGN KEY (idmzdcalchlav)
      REFERENCES pmzdcalchlav (idmzdcalchlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk764403e39186a54 FOREIGN KEY (idtyppracpom)
      REFERENCES ptyppracpom (idtyppracpom) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk764403e8c4d9ef2 FOREIGN KEY (idcismzdsloz)
      REFERENCES pcismzdsloz (idcismzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE ptyppracpomparam OWNER TO %firmaRole%;


-- Tabulka radku kalkulatoru mezd pro hromadny vypocet
CREATE SEQUENCE seq_pmzdcalchrom
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pmzdcalchrom OWNER TO %firmaRole%;

CREATE TABLE pmzdcalchrom
(
  idmzdcalchrom integer DEFAULT nextval('seq_pmzdcalchrom'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  kod character varying(20) NOT NULL,
  nazev character varying(255) NOT NULL,
  nazeva character varying(255),
  nazevb character varying(255),
  nazevc character varying(255),
  popis character varying(255),
  poznam text,
  "show" boolean NOT NULL DEFAULT true,
  cisrad integer NOT NULL DEFAULT 0,
  polein character varying(255) NOT NULL,
  poleout character varying(255) NOT NULL,
  zaokrjakk character varying(50),
  zaokrnak character varying(50),
  idmzdcalchlav integer NOT NULL,
  idmzdslozin integer NOT NULL,
  idmzdslozout integer NOT NULL,
  CONSTRAINT pmzdcalchrom_pkey PRIMARY KEY (idmzdcalchrom),
  CONSTRAINT fk7549834459ac65b4 FOREIGN KEY (idmzdcalchlav)
      REFERENCES pmzdcalchlav (idmzdcalchlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk7549834481d0ccae FOREIGN KEY (idmzdslozin)
      REFERENCES pcismzdsloz (idcismzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk75498344ffa59017 FOREIGN KEY (idmzdslozout)
      REFERENCES pcismzdsloz (idcismzdsloz) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE pmzdcalchrom OWNER TO %firmaRole%;


ALTER TABLE pmzdcalchlav ADD COLUMN idradkahromadne integer;
ALTER TABLE pmzdcalchlav ADD CONSTRAINT fk75496b156b60de3 FOREIGN KEY (idradkahromadne)
  REFERENCES pmzdcalc (idmzdcalc) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX pMzdCalcHlav_IdRadkaHromadne_index ON pMzdCalcHlav USING btree (IdRadkaHromadne);
CREATE INDEX pMzdCalc_IdMzdCalcHlav_index ON pMzdCalc USING btree (IdMzdCalcHlav);
CREATE INDEX pMzdCalc_IdMzdSlozIn_index ON pMzdCalc USING btree (IdMzdSlozIn);
CREATE INDEX pMzdCalc_IdMzdSlozOut_index ON pMzdCalc USING btree (IdMzdSlozOut);
CREATE INDEX pTypPracPomParam_IdTypPracPom_index ON pTypPracPomParam USING btree (IdTypPracPom);
CREATE INDEX pTypPracPomParam_IdCisMzdSloz_index ON pTypPracPomParam USING btree (IdCisMzdSloz);
CREATE INDEX pTypPracPomParam_IdMzdCalcHlav_index ON pTypPracPomParam USING btree (IdMzdCalcHlav);
CREATE INDEX pMzdCalcHrom_IdMzdCalcHlav_index ON pMzdCalcHrom USING btree (IdMzdCalcHlav);
CREATE INDEX pMzdCalcHrom_IdMzdSlozIn_index ON pMzdCalcHrom USING btree (IdMzdSlozIn);
CREATE INDEX pMzdCalcHrom_IdMzdSlozOut_index ON pMzdCalcHrom USING btree (IdMzdSlozOut);


-- Vazebni tabulka mezd a zavazku
CREATE SEQUENCE seq_pmzdvazbazav
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pmzdvazbazav OWNER TO %firmaRole%;

CREATE TABLE pmzdvazbazav
(
  idmzdvazbazav integer DEFAULT nextval('seq_pmzdvazbazav'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  mesic smallint DEFAULT 0,
  rok integer,
  vyznamk character varying(50),
  idpolfak integer,
  idosoba integer,
  iddoklfak integer,
  iddoklint integer,
  CONSTRAINT pmzdvazbazav_pkey PRIMARY KEY (idmzdvazbazav),
  CONSTRAINT fk42e09a88127b9d00 FOREIGN KEY (idpolfak)
      REFERENCES dpolfak (idpolfak) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk42e09a884759f20e FOREIGN KEY (iddoklfak)
      REFERENCES ddoklfak (iddoklfak) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk42e09a88475a0bcc FOREIGN KEY (iddoklint)
      REFERENCES ddoklint (iddoklint) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk42e09a88483ac817 FOREIGN KEY (idosoba)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE pmzdvazbazav OWNER TO %firmaRole%;

CREATE INDEX pMzdVazbaZav_IdOsoba_index ON pMzdVazbaZav USING btree (IdOsoba);
CREATE INDEX pMzdVazbaZav_IdDoklFak_index ON pMzdVazbaZav USING btree (IdDoklFak);
CREATE INDEX pMzdVazbaZav_IdPolFak_index ON pMzdVazbaZav USING btree (IdPolFak);
CREATE INDEX pMzdVazbaZav_IdDoklInt_index ON pMzdVazbaZav USING btree (IdDoklInt);

-- tabulka pro parametry mezd
CREATE SEQUENCE seq_pmzdyparam
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_pmzdyparam OWNER TO %firmaRole%;

CREATE TABLE pmzdyparam
(
  idmzdyparam integer DEFAULT nextval('seq_pmzdyparam'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  klic character varying(50),
  hodnota character varying(255),
  CONSTRAINT pmzdyparam_pkey PRIMARY KEY (idmzdyparam)
);
ALTER TABLE pmzdyparam OWNER TO %firmaRole%;


-- Navavazani bankovniho pomeru na osobu
ALTER TABLE abanspoj ADD COLUMN idosoba integer;
ALTER TABLE abanspoj ADD CONSTRAINT fkab68e206483ac817 FOREIGN KEY (idosoba)
  REFERENCES posobahlav (idosobahlav) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX aBanSpoj_IdOsoba_index ON aBanSpoj USING btree (IdOsoba);



-- pro zadany pracovni pomer, mesic a rok vygeneruje smeny
CREATE OR REPLACE FUNCTION pgeneratesmenyforpracpom(_idpracpom integer, _rok integer, _mesic integer)
  RETURNS void AS $$
declare
  _pocatMes date;
  _pracpom record;
  _idsmeny integer;
  _den varchar;
  _mesicS varchar;
  _aktDatum date;
  _denTyden integer;
  _vysledek text;
  _smena integer;
  _pocatSmeny integer;
  _konecSmeny integer;
  _svatku integer;
begin
  _pocatMes = date(_rok || '-' || _mesic || '-01');
  _mesicS = _mesic;
  if (length(_mesicS) < 2) then
    _mesicS = '0' || _mesicS;
  end if;
  
  select * into _pracpom from ppracpom where idpracpomhlav = _idpracpom and 
    (platiOd is null or platiOd <= _pocatMes) and (platiDo is null or platiDo >= _pocatMes) order by platiOd limit 1;
  
  if (_pracpom is null) then
    return;
  end if;
  
  select idsmeny, planovane into _idsmeny, _vysledek from psmeny where idpracpom = _idpracpom and rok = _rok and mesic = _mesic;
  
  if (_vysledek is null) then
    _vysledek = '';
  end if;
  
  if (_pracpom.pracrozvrhk = 'pracRozvrh.pravidelny') then
    _aktDatum = _pocatMes;
    _smena = 1;
    _vysledek = '';
    while extract (month from _aktDatum) = _mesic loop
      _denTyden = extract (dow from _aktDatum);
      _den = extract (day from _aktDatum);
      if (length(_den) < 2) then
        _den = '0' || _den;
      end if;
      if _denTyden = 0 then _denTyden = 7; end if;       -- nedele je 7y den
      
      if (_denTyden <= _pracpom.uvazDnuTydne) then
        select count(*) into _svatku from pmzdyparam where klic = 'svatek' and 
            ((hodnota = _rok || '-' || _mesicS || '-' || _den) or (hodnota = 'XXXX-' || _mesicS || '-' || _den));
      
        if (_svatku = 0) then
          if (_smena > 1) then _vysledek = _vysledek || ';'; end if;  -- pripojime strednik mezi smeny
          
          _pocatSmeny = (extract (day from _aktDatum) - 1) * 1440 + _pracpom.zacPracDoby * 60;
          _konecSmeny = _pocatSmeny + 60 * _pracpom.uvazHodTydne - 1;
          
          _vysledek = _vysledek || _smena || ':' || _pocatSmeny || ':' || _konecSmeny;
          
          _smena = _smena + 1;
        end if;
      end if;
      
      _aktDatum = _aktDatum + interval '1 day';
    end loop;
  
  end if;
  
  if (_idsmeny is null) then
    insert into psmeny (idosoba, idpracpom, rok, mesic, planovane)
      values (_pracpom.idosoba, _idpracpom, _rok, _mesic, _vysledek);
  else
    update psmeny set planovane = _vysledek where idpracpom = _idpracpom and rok = _rok and mesic = _mesic;
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pgeneratesmenyforpracpom(integer, integer, integer) OWNER TO %firmaRole%;


CREATE OR REPLACE FUNCTION pupdatemzdslozfromcis(_idMzdSloz integer, _idCis integer)
  RETURNS void AS $$
declare
  C record;
begin
  select * into C from pcismzdsloz where idcismzdsloz = _idCis;
  
  if (C.idcismzdsloz is not null) then
    update pmzdsloz set idcismzdsloz = _idCis, kod = C.kod, nazev = C.nazev, typslozkyk = C.typslozkyk, skupslozkyk = C.skupslozkyk, cisrad = C.cisrad, pracovni = C.pracovni,
      dnyPrac = C.dnyPrac, dnyKal = C.dnyKal, dnySvatek = C.dnySvatek, hodiny = C.hodiny, castkaHod = C.castkaHod, castkaDen = C.castkaDen, procMzd = C.procMzd, 
      zaklMzd = C.zaklMzd, zaklJeKracen = C.zaklJeKracen, castMzd = C.castMzd, zmenaCastMzd = C.zmenaCastMzd, pocetMes = C.pocetMes, cisDoklNem = C.cisDoklNem, 
      prumNaDenNem = C.prumNaDenNem, prumNaHodNem = C.prumNaHodNem, doplatZdravK = C.doplatZdravK where idmzdsloz = _idMzdSloz;
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pupdatemzdslozfromcis(integer, integer) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION pupdatemzdslozfromodecitpol(_idMzdSloz integer, _idOdecitPol integer)
  RETURNS void AS $$
declare
  O record;
begin
  select * into O from podecitpol where idodecitpol = _idOdecitPol;

  if (O.idodecitpol is not null) then
    -- pokud nesouhlasi ciselnik vyplnime ho
    perform pupdatemzdslozfromcis(idMzdSloz, O.idcismzdsloz) from pmzdsloz where idmzdsloz = _idMzdSloz and idcismzdsloz <> O.idcismzdsloz;
    -- pokud je treba prenest neco z odecitpol preneseme
    update pmzdsloz set idodecitpol = _idOdecitPol where idmzdsloz = _idMzdSloz;
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pupdatemzdslozfromodecitpol(integer, integer) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION pupdatemzdslozfromsrazka(_idMzdSloz integer, _idSrazka integer)
  RETURNS void AS $$
declare
  S record;
begin
  select * into S from psrazka where idsrazka = _idSrazka;

  if (S.idsrazka is not null) then
    -- pokud nesouhlasi ciselnik vyplnime ho
    perform pupdatemzdslozfromcis(idMzdSloz, S.idcismzdsloz) from pmzdsloz where idmzdsloz = _idMzdSloz and idcismzdsloz <> S.idcismzdsloz;
    -- preneseme data ze srazky
    update pmzdsloz set idsrazka = _idSrazka, kod = S.kod, nazev = S.nazev, poznam = S.poznam,
        procmzd = S.procmzd, skupslozkyk = S.skupslozkyk, typslozkyk = S.typslozkyk,
        idcismzdsloz = S.idcismzdsloz, castMzd = S.castka where idmzdsloz = _idMzdSloz;
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pupdatemzdslozfromsrazka(integer, integer) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION pupdatemzdslozfromstalasloz(_idMzdSloz integer, _idStalaSloz integer)
  RETURNS void AS $$
declare
  S record;
begin
  select * into S from pstalamzdsloz where idstalamzdsloz = _idStalaSloz;

  if (S.idstalamzdsloz is not null) then
    -- pokud nesouhlasi ciselnik vyplnime ho
    perform pupdatemzdslozfromcis(idMzdSloz, S.idcismzdsloz) from pmzdsloz where idmzdsloz = _idMzdSloz and idcismzdsloz <> S.idcismzdsloz;
    -- preneseme data ze stale mzdove slozky
    update pmzdsloz set idstalamzdsloz = _idStalaSloz,
        castkaden = S.castkaden, castkahod = S.castkahod, kod = S.kod, nazev = S.nazev, pocetmes = S.pocetmes, poznam = S.poznam,
        procmzd = S.procmzd, skupslozkyk = S.skupslozkyk, typslozkyk = S.typslozkyk, zakljekracen = S.zakljekracen, zaklmzd = S.zaklmzd,
        idcismzdsloz = S.idcismzdsloz, idstredisko = S.idstredisko, idzakazka = S.idzakazka
  -- NEW.podil, NEW.typpodilk,
      where idmzdsloz = _idMzdSloz;
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pupdatemzdslozfromstalasloz(integer, integer) OWNER TO %firmaRole%;


-- pro zadany pracovni pomer, mesic a rok vygeneruje mzdove slozky
CREATE OR REPLACE FUNCTION pgeneratemzdslozforpracpomandmesic(_idpracpom integer, _rok integer, _mesic integer)
  RETURNS void AS $$
declare
  _datum date;
  _datumpo date;
  _idosoba integer;
begin
  _datum = date (_rok || '-' || _mesic || '-01');
  _datumpo = _datum + interval '1 month';
  
  select idosoba into _idosoba from ppracpomhlav where idpracpomhlav = _idpracpom;

  -- vystupni slozky
  insert into pmzdsloz (idosoba, idpracpom, idcismzdsloz, rok, mesic, kod, nazev, typslozkyk, skupslozkyk, cisrad, pracovni) 
    select _idosoba, (case when naOsobu then null else _idpracpom end), idcismzdsloz, _rok, _mesic, kod, nazev, typslozkyk, skupslozkyk, cisrad, pracovni 
      from pcismzdsloz as C where typslozkyk = 'typSlozky.vypocet' 
        and (platiod is null or (platiod < _datumpo)) and (platido is null or (platido >= _datum))
        and (select count(*) from pmzdsloz where idosoba = _idosoba and (naOsobu or idpracpom = _idpracpom) 
              and rok = _rok and mesic = _mesic and idcismzdsloz = C.idcismzdsloz) = 0;
  
  -- stale slozky
  perform pupdatemzdslozfromstalasloz(pcreatemzdslozfromcis(idcismzdsloz, _idpracpom, _idosoba, _rok, _mesic), idstalamzdsloz)
      from pstalamzdsloz as S where idpracpom = _idpracpom
        and (datumod is null or (datumod < _datumpo)) and (datumdo is null or (datumdo >= _datum))
        and (select count(*) from pmzdsloz where rok = _rok and mesic = _mesic and idstalamzdsloz = S.idstalamzdsloz) = 0;
  
  -- srazky
  perform pupdatemzdslozfromsrazka(pcreatemzdslozfromcis(idcismzdsloz, null, _idosoba, _rok, _mesic), idsrazka)
      from psrazka as S where idosoba = _idosoba
        and (srazkaod is null or (srazkaod < _datumpo)) and (srazkado is null or (srazkado >= _datum))
        and (select count(*) from pmzdsloz where rok = _rok and mesic = _mesic and idsrazka = S.idsrazka) = 0;
  
  -- odecitatelne polozky
  perform pupdatemzdslozfromodecitpol(pcreatemzdslozfromcis(idcismzdsloz, null, _idosoba, _rok, _mesic), idodecitpol)
      from podecitpol as O where idosoba = _idosoba
        and (platiod is null or (platiod < _datumpo)) and (platido is null or (platido >= _datum))
        and (select count(*) from pmzdsloz where rok = _rok and mesic = _mesic and idodecitpol = O.idodecitpol) = 0;
  
  -- smeny
  perform pgeneratesmenyforpracpom(_idpracpom, _rok, _mesic);
end; 
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pgeneratemzdslozforpracpomandmesic(integer, integer, integer) OWNER TO %firmaRole%;


-- vygeneruje mzdove slozky pro zadany pracovni pomer, pokud je id -1 generuje pro vsechny
CREATE OR REPLACE FUNCTION pgeneratemzdslozforpracpom(_idpracpom integer)
  RETURNS void AS $$
declare
  _od date;
  _do date;
  rokod integer;
  rokdo integer;
  mesicod integer;
  mesicdo integer;
  
  mesforod integer;
  mesfordo integer;
  aktrok integer;
  aktmesic integer;
  aktdatum date;
begin
  select min(platioddata), max(platidodata) into _od, _do from nucetobdobi;
  rokod = date_part('year', _od);
  rokdo = date_part('year', _do);
  mesicod = date_part('month', _od);
  mesicdo = date_part('month', _do);
  
  -- vymazeme nadbytecne
  delete from pmzdsloz where (rok < rokod or (rok = rokod and mesic < mesicod)) or (rok > rokdo or (rok = rokdo and mesic > mesicdo));
  delete from psmeny where (rok < rokod or (rok = rokod and mesic < mesicod)) or (rok > rokdo or (rok = rokdo and mesic > mesicdo));
  
  -- prochazime roky
  for aktrok in rokod..rokdo loop
    mesforod = 1;
    mesfordo = 12;
    if (aktrok = rokod) then
      mesforod = mesicod;
    end if;  
    if (aktrok = rokdo) then
      mesfordo = mesicdo;
    end if;
    
    -- a mesice
    for aktmesic in mesforod..mesfordo loop
      aktdatum = date (aktrok || '-' || aktmesic || '-01');
      
      perform pgeneratemzdslozforpracpomandmesic(idpracpomhlav, aktrok, aktmesic) from ppracpomhlav where
        (_idpracpom = -1 or idpracpomhlav = _idpracpom) and (aktivnido is null or aktdatum <= aktivnido) and 
        (aktivniod is null or date_part('year', aktivniod) < aktrok or (date_part('year', aktivniod) = aktrok and date_part('month', aktivniod) <= aktmesic));
    end loop;
  end loop;
end; 
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pgeneratemzdslozforpracpom(integer) OWNER TO %firmaRole%;


-- trigger prenasejici datumy aktivnosti pracovniho pomeru z jednoho nastaveni na ostatni a na hlavicku
CREATE OR REPLACE FUNCTION ppracpomupdateaktivni()
  RETURNS trigger AS $$
begin
  update ppracpomhlav set aktivniod = NEW.aktivniod, aktivnido = NEW.aktivnido 
    where idpracpomhlav = NEW.idpracpomhlav and 
      (((aktivniod is null) <> (NEW.aktivniod is null)) or (aktivniod is not null and aktivniod <> NEW.aktivniod) or
      ((aktivnido is null) <> (NEW.aktivnido is null)) or (aktivnido is not null and aktivnido <> NEW.aktivnido));
  
  update ppracpom set aktivniod = NEW.aktivniod, aktivnido = NEW.aktivnido 
    where idpracpomhlav = NEW.idpracpomhlav and 
      (((aktivniod is null) <> (NEW.aktivniod is null)) or (aktivniod is not null and aktivniod <> NEW.aktivniod) or
      ((aktivnido is null) <> (NEW.aktivnido is null)) or (aktivnido is not null and aktivnido <> NEW.aktivnido));
  
  -- pokud vkladame nove nastaveni nebo doslo ke zmene bez zmeny datumu aktivnosti zkontrolujeme smeny
  if (tg_op = 'INSERT') then
    perform pgeneratemzdslozforpracpom(NEW.idpracpomhlav);
  end if;
  if (tg_op = 'UPDATE') then
   if not (((OLD.aktivniod is null) <> (NEW.aktivniod is null)) or (OLD.aktivniod is not null and OLD.aktivniod <> NEW.aktivniod) or
       ((OLD.aktivnido is null) <> (NEW.aktivnido is null)) or (OLD.aktivnido is not null and OLD.aktivnido <> NEW.aktivnido)) then
      perform pgeneratemzdslozforpracpom(NEW.idpracpomhlav);
    end if;
  end if;
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ppracpomupdateaktivni() OWNER TO %firmaRole%;

CREATE TRIGGER ppracpomupdateaktivni AFTER INSERT OR UPDATE ON ppracpom
  FOR EACH ROW EXECUTE PROCEDURE ppracpomupdateaktivni();


-- trigger generujici mzdove slozky pri uprave pracovnich pomeru
CREATE OR REPLACE FUNCTION ppracpomhlavupdatemzdsloz()
  RETURNS trigger AS $$
declare
  nullcount integer;
  _rok integer;
  _mesic integer;
begin
  -- vymazeme nadbytecne slozky pro pracovni pomer
  if (NEW.aktivniod is not null) then
    _rok = date_part('year', NEW.aktivniod);
    _mesic = date_part('month', NEW.aktivniod);
    
    delete from pmzdsloz where idpracpom = NEW.idpracpomhlav and (rok < _rok or (rok = _rok and mesic < _mesic));
    delete from psmeny where idpracpom = NEW.idpracpomhlav and (rok < _rok or (rok = _rok and mesic < _mesic));
  end if;
  
  if (NEW.aktivnido is not null) then
    _rok = date_part('year', NEW.aktivnido);
    _mesic = date_part('month', NEW.aktivnido);
    
    delete from pmzdsloz where idpracpom = NEW.idpracpomhlav and (rok > _rok or (rok = _rok and mesic > _mesic));
    delete from psmeny where idpracpom = NEW.idpracpomhlav and (rok > _rok or (rok = _rok and mesic > _mesic));
  end if;
  
  -- vymazeme nadbytecne spolecne slozky
  select count(*) into nullcount from ppracpomhlav where idosoba = NEW.idosoba and aktivniod is null;
  if nullcount = 0 then
    select date_part('year', min(aktivniod)), date_part('month', min(aktivniod)) into _rok, _mesic from ppracpom where idosoba = NEW.idosoba;
    
    delete from pmzdsloz where idosoba = NEW.idosoba and (rok < _rok or (rok = _rok and mesic < _mesic));
  end if;
  
  select count(*) into nullcount from ppracpomhlav where idosoba = NEW.idosoba and aktivnido is null;
  if nullcount = 0 then
    select date_part('year', max(aktivnido)), date_part('month', max(aktivnido)) into _rok, _mesic from ppracpom where idosoba = NEW.idosoba;
    
    delete from pmzdsloz where idosoba = NEW.idosoba and (rok > _rok or (rok = _rok and mesic > _mesic));
  end if;
  
  -- vygenerujeme chybejici
  perform pgeneratemzdslozforpracpom(NEW.idpracpomhlav);
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ppracpomhlavupdatemzdsloz() OWNER TO %firmaRole%;

CREATE TRIGGER ppracpomhlavupdatemzdsloz AFTER INSERT OR UPDATE ON ppracpomhlav -- TODO pri insertu by melo byt zbytecne spusti se az pri vlozeni do ppracpom
  FOR EACH ROW EXECUTE PROCEDURE ppracpomhlavupdatemzdsloz();


-- trigger generujici mzdove slozky pri uprave ucetniho obdobi
CREATE OR REPLACE FUNCTION nucetobdobiupdatemzdsloz()
  RETURNS trigger AS $$
declare
  ZAZNAM record;
begin
  if (tg_op = 'DELETE') then  
    ZAZNAM := OLD;  
  else  
    ZAZNAM := NEW;  
  end if;
  
  perform pgeneratemzdslozforpracpom(-1);
  
  return ZAZNAM;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.nucetobdobiupdatemzdsloz() OWNER TO %firmaRole%;

CREATE TRIGGER nucetobdobiupdatemzdsloz AFTER INSERT OR UPDATE OR DELETE ON nucetobdobi
  FOR EACH ROW EXECUTE PROCEDURE nucetobdobiupdatemzdsloz();


-- trigger generujici mzdove slozky pri vytvoreni nebo uprave stale mzdove slozky
CREATE OR REPLACE FUNCTION pstalamzdslozupdatemzdsloz()
  RETURNS trigger AS $$
declare
  _rok integer;
  _mesic integer;
begin
  -- vymazeme nadbytecne slozky pro stale slozky
  if (NEW.datumod is not null) then
    _rok = date_part('year', NEW.datumod);
    _mesic = date_part('month', NEW.datumod);
    
    delete from pmzdsloz where idstalamzdsloz = NEW.idstalamzdsloz and (rok < _rok or (rok = _rok and mesic < _mesic));
  end if;
  
  if (NEW.datumdo is not null) then
    _rok = date_part('year', NEW.datumdo);
    _mesic = date_part('month', NEW.datumdo);
    
    delete from pmzdsloz where idstalamzdsloz = NEW.idstalamzdsloz and (rok > _rok or (rok = _rok and mesic > _mesic));
  end if;

  -- vygenerujeme chybejici slozky
  perform pgeneratemzdslozforpracpom(NEW.idpracpom);
  
  -- nastavime aktualni parametry
  perform pupdatemzdslozfromstalasloz(idmzdsloz, NEW.idstalamzdsloz) from pmzdsloz where idstalamzdsloz = NEW.idstalamzdsloz;
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pstalamzdslozupdatemzdsloz() OWNER TO %firmaRole%;

CREATE TRIGGER pstalamzdslozupdatemzdsloz AFTER INSERT OR UPDATE ON pstalamzdsloz
  FOR EACH ROW EXECUTE PROCEDURE pstalamzdslozupdatemzdsloz();


-- trigger mazajici mzdove slozky pri smazani stale mzdove slozky
CREATE OR REPLACE FUNCTION pstalamzdslozdeletemzdsloz()
  RETURNS trigger AS $$
begin
  delete from pmzdsloz where idstalamzdsloz = OLD.idstalamzdsloz;

  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pstalamzdslozdeletemzdsloz() OWNER TO %firmaRole%;

CREATE TRIGGER pstalamzdslozdeletemzdsloz BEFORE DELETE ON pstalamzdsloz
  FOR EACH ROW EXECUTE PROCEDURE pstalamzdslozdeletemzdsloz();


-- trigger generujici mzdove slozky pri vytvoreni nebo uprave srazky
CREATE OR REPLACE FUNCTION psrazkaupdatemzdsloz()
  RETURNS trigger AS $$
declare
  _rok integer;
  _mesic integer;
  _idpracpom integer;
begin
  -- vymazeme nadbytecne slozky pro srazky
  if (NEW.srazkaod is not null) then
    _rok = date_part('year', NEW.srazkaod);
    _mesic = date_part('month', NEW.srazkaod);
    
    delete from pmzdsloz where idsrazka = NEW.idsrazka and (rok < _rok or (rok = _rok and mesic < _mesic));
  end if;
  
  if (NEW.srazkado is not null) then
    _rok = date_part('year', NEW.srazkado);
    _mesic = date_part('month', NEW.srazkado);
    
    delete from pmzdsloz where idsrazka = NEW.idsrazka and (rok > _rok or (rok = _rok and mesic > _mesic));
  end if;

  -- vygenerujeme chybejici slozky
  select idpracpomhlav into _idpracpom from ppracpomhlav where idosoba = NEW.idosoba limit 1;
  if (_idpracpom is not null) then 
    perform pgeneratemzdslozforpracpom(_idpracpom);
  end if;
  
  -- nastavime aktualni parametry
  perform pupdatemzdslozfromsrazka(idmzdsloz, NEW.idsrazka) from pmzdsloz where idsrazka = NEW.idsrazka;
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.psrazkaupdatemzdsloz() OWNER TO %firmaRole%;

CREATE TRIGGER psrazkaupdatemzdsloz AFTER INSERT OR UPDATE ON psrazka
  FOR EACH ROW EXECUTE PROCEDURE psrazkaupdatemzdsloz();


-- trigger mazajici mzdove slozky pri smazani srazky
CREATE OR REPLACE FUNCTION psrazkadeletemzdsloz()
  RETURNS trigger AS $$
begin
  delete from pmzdsloz where idsrazka = OLD.idsrazka;

  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.psrazkadeletemzdsloz() OWNER TO %firmaRole%;

CREATE TRIGGER psrazkadeletemzdsloz BEFORE DELETE ON psrazka
  FOR EACH ROW EXECUTE PROCEDURE psrazkadeletemzdsloz();


-- trigger generujici mzdove slozky pri vytvoreni nebo uprave odecitatelne polozky
CREATE OR REPLACE FUNCTION podecitpolupdatemzdsloz()
  RETURNS trigger AS $$
declare
  _rok integer;
  _mesic integer;
  _idpracpom integer;
begin
  -- vymazeme nadbytecne slozky pro srazky
  if (NEW.platiod is not null) then
    _rok = date_part('year', NEW.platiod);
    _mesic = date_part('month', NEW.platiod);
    
    delete from pmzdsloz where idodecitpol = NEW.idodecitpol and (rok < _rok or (rok = _rok and mesic < _mesic));
  end if;
  
  if (NEW.platido is not null) then
    _rok = date_part('year', NEW.platido);
    _mesic = date_part('month', NEW.platido);
    
    delete from pmzdsloz where idodecitpol = NEW.idodecitpol and (rok > _rok or (rok = _rok and mesic > _mesic));
  end if;

  -- vygenerujeme chybejici slozky
  select idpracpomhlav into _idpracpom from ppracpomhlav where idosoba = NEW.idosoba limit 1;
  if (_idpracpom is not null) then 
    perform pgeneratemzdslozforpracpom(_idpracpom);
  end if;
  
  -- nastavime aktualni parametry
  perform pupdatemzdslozfromodecitpol(idmzdsloz, NEW.idodecitpol) from pmzdsloz where idodecitpol = NEW.idodecitpol;
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.podecitpolupdatemzdsloz() OWNER TO %firmaRole%;

CREATE TRIGGER podecitpolupdatemzdsloz AFTER INSERT OR UPDATE ON podecitpol
  FOR EACH ROW EXECUTE PROCEDURE podecitpolupdatemzdsloz();


-- trigger mazajici mzdove slozky pri smazani odecitatelne polozky
CREATE OR REPLACE FUNCTION podecitpoldeletemzdsloz()
  RETURNS trigger AS $$
begin
  delete from pmzdsloz where idodecitpol = OLD.idodecitpol;

  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.podecitpoldeletemzdsloz() OWNER TO %firmaRole%;

CREATE TRIGGER podecitpoldeletemzdsloz BEFORE DELETE ON podecitpol
  FOR EACH ROW EXECUTE PROCEDURE podecitpoldeletemzdsloz();


-- trigger mazajici mzdove slozky pri smazani nepritomnosti
CREATE OR REPLACE FUNCTION pnepritomnostdeletemzdsloz()
  RETURNS trigger AS $$
begin
  delete from pmzdsloz where idnepritomnost = OLD.idnepritomnost;

  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pnepritomnostdeletemzdsloz() OWNER TO %firmaRole%;

CREATE TRIGGER pnepritomnostdeletemzdsloz BEFORE DELETE ON pnepritomnost
  FOR EACH ROW EXECUTE PROCEDURE pnepritomnostdeletemzdsloz();


-- trigger posunujici cisla radky nasledujicich radek v mzdove kalkulacce pri smazani radky
CREATE OR REPLACE FUNCTION pmzdcalcdeletecisrad()
  RETURNS trigger AS $$
begin
  update pmzdcalc set cisrad = cisrad - 1 where idmzdcalchlav = OLD.idmzdcalchlav and cisrad > OLD.cisrad;

  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pmzdcalcdeletecisrad() OWNER TO %firmaRole%;

CREATE TRIGGER pmzdcalcdeletecisrad AFTER DELETE ON pmzdcalc
  FOR EACH ROW EXECUTE PROCEDURE pmzdcalcdeletecisrad();


-- trigger posunujici cisla radky nasledujicich radek v hromadne mzdove kalkulacce pri smazani radky
CREATE OR REPLACE FUNCTION pmzdcalchromdeletecisrad()
  RETURNS trigger AS $$
begin
  update pmzdcalchrom set cisrad = cisrad - 1 where idmzdcalchlav = OLD.idmzdcalchlav and cisrad > OLD.cisrad;

  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pmzdcalchromdeletecisrad() OWNER TO %firmaRole%;

CREATE TRIGGER pmzdcalchromdeletecisrad AFTER DELETE ON pmzdcalchrom
  FOR EACH ROW EXECUTE PROCEDURE pmzdcalchromdeletecisrad();


-- vygeneruje mzdovou slozku ze zadane ciselnikove slozky pro pracovni pomer a datum
CREATE OR REPLACE FUNCTION pcreatemzdslozfromcis(_idCis integer, _idPracPom integer, _idOsoba integer, _rok integer, _mesic integer)
  RETURNS integer AS $$
declare
  C record;
  _idosobaout integer;
  _idsloz integer;
begin
  select * into C from pcismzdsloz where idcismzdsloz = _idCis;
  
  _idosobaout = _idOsoba;
  if (_idosobaout is null and _idPracPom is not null) then
    select idosoba into _idosobaout from ppracpomhlav where idpracpomhlav = _idPracPom;
  end if;
  
  if (C.idcismzdsloz is not null and _idosobaout is not null) then
    select nextval('seq_pmzdsloz') into _idsloz;
    insert into pmzdsloz (idmzdsloz, idosoba, idpracpom, rok, mesic, idcismzdsloz, kod, nazev, typslozkyk, skupslozkyk, cisrad, pracovni, dnyPrac, dnyKal, dnySvatek, hodiny, castkaHod, castkaDen, procMzd, zaklMzd, zaklJeKracen, castMzd, zmenaCastMzd, pocetMes, cisDoklNem, prumNaDenNem, prumNaHodNem, doplatZdravK)
      values (_idsloz, _idosobaout, _idPracPom, _rok, _mesic, _idCis, C.kod, C.nazev, C.typslozkyk, C.skupslozkyk, C.cisrad, C.pracovni, C.dnyPrac, C.dnyKal, C.dnySvatek, C.hodiny, C.castkaHod, C.castkaDen, C.procMzd, C.zaklMzd, C.zaklJeKracen, C.castMzd, C.zmenaCastMzd, C.pocetMes, C.cisDoklNem, C.prumNaDenNem, C.prumNaHodNem, C.doplatZdravK);
    
    return _idsloz;
  end if;
  
  return -1;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pcreatemzdslozfromcis(integer, integer, integer, integer, integer) OWNER TO %firmaRole%;

-- pro smeny se zadanym id vygeneruje mzdovou slozku pracovni doby
CREATE OR REPLACE FUNCTION pcreatemzdslozforsmeny(_idSmeny integer)
  RETURNS void AS $$
declare
  SM record;
  SMnext record;
  _hodin numeric;
  _dnuPrac numeric;
  _hodinPoc numeric;
  _dnuPracPoc numeric;
  _konecMes date;
  _okolMes date;
  _denOd integer;
  _denDo integer;
  _denOdPoc integer;
  _denDoPoc integer;
  _pocatek boolean;
  _aktivOd date;
  _aktivDo date;
  i integer;
  cisSm integer;
  smeny varchar[];
  smena varchar[];
  aktSmena integer;
  pocSmena integer;
  konSmena integer;
  denSmena integer;
  _idcisMzd integer;
  _idmzdsloz integer;
begin
  select * into SM from psmeny where idsmeny = _idsmeny;
  _hodin = 0;
  _dnuPrac = 0;
  _hodinPoc = 0;
  _dnuPracPoc = 0;
  _konecMes = date(SM.rok || '-' || SM.mesic || '-01') + interval '1 month' - interval '1 day';
  _denOd = 1;
  _denDo = extract (day from _konecMes);
  _denOdPoc = 1;
  _denDoPoc = _denDo;
  
  select aktivniod, aktivnido into _aktivOd, _aktivDo from ppracpomhlav where idpracpomhlav = SM.idpracpom;
  
  if (_aktivOd is not null) then
    if (SM.mesic = extract(month from _aktivOd) and SM.rok = extract(year from _aktivOd)) then
      _denOdPoc = extract (day from _aktivOd);
    end if;
  end if;
  if (_aktivDo is not null) then
    if (SM.mesic = extract(month from _aktivDo) and SM.rok = extract(year from _aktivDo)) then
      _denDoPoc = extract (day from _aktivDo);
    end if;
  end if;
  _pocatek = (_denOd <> _denOdPoc or _denDo <> _denDoPoc);
  
  if (SM.planovane is not null and length(SM.planovane) > 0) then
    smeny = string_to_array(SM.planovane,';');
    aktSmena = 0;
    
    for i in array_lower(smeny,1) .. array_upper(smeny,1) loop  -- prochazime smeny
      smena = string_to_array(smeny[i],':');
      cisSm = smena[1];
      if (cisSm <> 0) then                     -- zbytek smeny z minuleho mesice nas nezajima
        pocSmena = smena[2];
        konSmena = smena[3];
        
        if (aktSmena <> cisSm) then
          denSmena = pocSmena / (24 * 60) + 1;    -- zjistime den
          if (denSmena < _denOdPoc or denSmena > _denDoPoc) then
            _dnuPracPoc = _dnuPracPoc + 1;
          end if;

          _dnuPrac = _dnuPrac + 1;
          aktSmena = cisSm;
        end if;
        
        _hodin = _hodin + (konSmena - pocSmena + 1) / 60;
        if (denSmena < _denOdPoc or denSmena > _denDoPoc) then
          _hodinPoc = _hodinPoc + (konSmena - pocSmena + 1) / 60;
        end if;
      else
        _okolMes = date(SM.rok || '-' || SM.mesic || '-01') - interval '1 month';
        select pcreatemzdslozforsmeny(idsmeny)from psmeny where idpracpom = sm.idpracpom and 
               rok = extract(year from _okolMes) and mesic = extract(month from _okolMes);
      end if;
    end loop;
  end if;
  
  -- podivame se o mesic dal jestli tam nemame kousicek
  _okolMes = date(SM.rok || '-' || SM.mesic || '-01') + interval '1 month';
  select * into SMnext from psmeny where idpracpom = sm.idpracpom and 
               rok = extract(year from _okolMes) and mesic = extract(month from _okolMes) limit 1;
  if (SMnext.idsmeny is not null) then
    if (SMnext.planovane is not null and length(SMnext.planovane) > 0) then
      smeny = string_to_array(SMnext.planovane,';');
      
      for cisSm in array_lower(smeny,1) .. array_upper(smeny,1) loop  -- prochazime smeny
        smena = string_to_array(smeny[cisSm],':');
        cisSm = smena[1];
      
        if (cisSm = 0) then
          pocSmena = smena[2];
          konSmena = smena[3];
          _hodin = _hodin + (konSmena - pocSmena + 1) / 60;
        end if;
      end loop;  
    end if;
  end if;
  
  select idcismzdsloz into _idcisMzd from pcismzdsloz where typslozkyk = 'typSlozky.kopie' and skupslozkyk = 'skupinaSlozky.doba';
  select idmzdsloz into _idmzdsloz from pmzdsloz where idpracpom = SM.idpracpom and rok = SM.rok and mesic = SM.mesic 
      and idcismzdsloz = _idcisMzd;
  
  if (_idmzdsloz is null) then      -- slozka neexistuje vytvorime ji
    select pcreatemzdslozfromcis(_idcisMzd, SM.idpracpom, null, SM.rok, SM.mesic) into _idmzdsloz;
  end if;
  
  update pmzdsloz set dnyKal = (_denDo-_denOd+1), dnyPrac = _dnuPrac, hodiny = _hodin where idmzdsloz = _idmzdsloz;

  if (_pocatek) then
    select idcismzdsloz into _idcisMzd from pcismzdsloz where typslozkyk = 'typSlozky.inicializace' and skupslozkyk = 'skupinaSlozky.doba';
    if (_idcisMzd is not null) then
      select idmzdsloz into _idmzdsloz from pmzdsloz where idpracpom = SM.idpracpom and rok = SM.rok and mesic = SM.mesic
        and idcismzdsloz = _idcisMzd;

      if (_idmzdsloz is null) then      -- slozka neexistuje vytvorime ji
        select pcreatemzdslozfromcis(_idcisMzd, SM.idpracpom, null, SM.rok, SM.mesic) into _idmzdsloz;
      end if;

      update pmzdsloz set dnyKal = (_denDo-_denOd - _denDoPoc+_denOdPoc), dnyPrac = _dnuPracPoc, hodiny = _hodinPoc where idmzdsloz = _idmzdsloz;
    end if;
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pcreatemzdslozforsmeny(integer) OWNER TO %firmaRole%;

-- trigger generujici ze smen mzdove slozky 
CREATE OR REPLACE FUNCTION psmenyupdatemzdsloz()
  RETURNS trigger AS $$
begin
  perform pcreatemzdslozforsmeny(NEW.idSmeny);

  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.psmenyupdatemzdsloz() OWNER TO %firmaRole%;

CREATE TRIGGER psmenyupdatemzdsloz AFTER INSERT OR UPDATE ON psmeny
  FOR EACH ROW EXECUTE PROCEDURE psmenyupdatemzdsloz();

-- trigger mazajici mzdove slozky pri smazani pracovniho pomeru
CREATE OR REPLACE FUNCTION ppracpomhlavdeleteslozky()
  RETURNS trigger AS $$
begin
  delete from pmzdsloz where idpracpom = OLD.idpracpomhlav;
  delete from psmeny where idpracpom = OLD.idpracpomhlav;

  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ppracpomhlavdeleteslozky() OWNER TO %firmaRole%;

CREATE TRIGGER ppracpomhlavdeleteslozky BEFORE DELETE ON ppracpomhlav
  FOR EACH ROW EXECUTE PROCEDURE ppracpomhlavdeleteslozky();

-- trigger mazajici vazbu do mezd pri smazani zavazku
CREATE OR REPLACE FUNCTION ddoklfakdeletemzdvazba()
  RETURNS trigger AS $$
begin
  delete from pmzdvazbazav where iddoklfak = OLD.iddoklfak;

  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ddoklfakdeletemzdvazba() OWNER TO %firmaRole%;

CREATE TRIGGER ddoklfakdeletemzdvazba BEFORE DELETE ON ddoklfak
  FOR EACH ROW EXECUTE PROCEDURE ddoklfakdeletemzdvazba();

-- trigger mazajici vazbu do mezd pri smazani polozky zavazku
CREATE OR REPLACE FUNCTION dpolfakdeletemzdvazba()
  RETURNS trigger AS $$
begin
  delete from pmzdvazbazav where idpolfak = OLD.idpolfak;

  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dpolfakdeletemzdvazba() OWNER TO %firmaRole%;

CREATE TRIGGER dpolfakdeletemzdvazba BEFORE DELETE ON dpolfak
  FOR EACH ROW EXECUTE PROCEDURE dpolfakdeletemzdvazba();


-- trigger mazajici vazbu do mezd pri smazani interniho dokladu
CREATE OR REPLACE FUNCTION ddoklintdeletemzdvazba()
  RETURNS trigger AS $$
begin
  delete from pmzdvazbazav where iddoklint = OLD.iddoklint;

  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ddoklintdeletemzdvazba() OWNER TO %firmaRole%;

CREATE TRIGGER ddoklintdeletemzdvazba BEFORE DELETE ON ddoklint
  FOR EACH ROW EXECUTE PROCEDURE ddoklintdeletemzdvazba();


------------------------------------ DATA --------------------------------------
create or replace function runupgrade()
    returns void as $$
declare
    stat character varying(10);
begin
  select a.uuid into stat from nnastav n  left join utyporg u on u.idtyporg = n.idtyporg left join astaty a on a.idstatu = u.idstatu
    where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);
  
  -- kalkulacku aktualizujeme jen pro cechy, pro vsechny ostatni ji smazeme
  if (stat = 'CZ_CZ') then
-- zacatek ceskeho bloku
-- Číselník mzdových složek
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (39, '2009-11-14 10:18:04.75', 'POHOTOVOST', 'Odměna za pracovní pohotovost', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.priplatky', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, true, false, false, false, false, false, false, false, false, NULL, NULL, 3120, NULL, 0.00, 0.00, 5.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (57, '2009-11-24 18:54:54.671', 'PRESČASY', 'Celková odpracovaná doba v měsíci - z toho  přesčas', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.doba', 'typSlozky.vypocet', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 1080, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (60, '2009-11-24 18:55:20.515', 'NÁHRADA SVÁTEK', 'Celková odpracovaná doba v měsíc - z toho náhrada za svátek', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.doba', 'typSlozky.vypocet', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 1090, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (135, '2009-11-14 11:34:56.421', 'SRÁŽKY CELKEM', 'Celkové srážky', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.srazky', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9170, 'vyznamSlozky.srazkaSporeni', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (119, '2009-11-14 11:35:42.171', 'VÝŽIVNÉ', 'Výživné ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.srazky', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9060, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (58, '2009-11-24 18:55:30.078', 'SVÁTEK', 'Celková odpracovaná doba v měsíc - z toho  svátek', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.doba', 'typSlozky.vypocet', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 1110, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (59, '2009-11-24 18:55:37.265', 'WEEKEND', 'Celková odpracovaná doba v měsíc - z toho v sobotu a v neděli', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.doba', 'typSlozky.vypocet', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 1120, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (147, '2009-11-24 18:58:54.75', 'ODMĚNA ST.ORG.NER.', 'Daň z odměny statutárárního orgánu který není rezident', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5180, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (115, '2009-11-24 18:59:06.687', 'SLEVA ZDR.POJ.STÁT', 'Sleva - Osoba, za kterou platí zdravotní pojištění stát', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.danSleva', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5250, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (145, '2009-10-29 18:42:55.406', 'SRÁŽKOVÁ DAŇ', 'Srážková daň ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5160, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (85, '2009-10-29 18:43:15.156', 'ÚROK Z  ÚVĚRU', 'Opočet úroků z úvěru', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5080, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (117, '2009-10-29 18:43:55.953', 'SLEVA NA DANI CELKEM', 'Sleva na dani cekem', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5060, 'vyznamSlozky.danSlevSum', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (81, '2009-10-29 18:42:19.375', 'OPRAVA SLEVY', 'Oprava slevy na dani celkem', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.danSleva', 'typSlozky.vstup', true, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5280, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (28, '2009-11-10 16:48:32.953', 'PODÍL NA ZISKU', 'Podíly % ze zisku - základu ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.odmeny', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, true, true, false, false, false, true, false, NULL, NULL, 4200, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (29, '2009-11-10 16:48:35.984', 'JUBILEUM', 'Odměna k životnímu, pracobnímu jubileu, odchodu do důchodu', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.odmeny', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 4210, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (30, '2009-11-10 16:48:46.484', 'VYNÁLEZ', 'Odměna podle zákona o vynálezech a ZN', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.odmeny', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 4220, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (32, '2009-11-10 16:48:54.718', 'ODMĚNA NEREZIDENTA', 'Odměna členů statutárního orgánu-nerezident', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.odmeny', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 4240, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (204, '2009-11-23 18:35:33.109', 'ZDR.ZÁK.OD ZAČ.ROKU', 'Základ pro zdravotní pojištění od začátku roku', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.zdravPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 7040, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (166, '2009-11-23 18:56:09.328', 'SLEVA MANŽ.DOMA ', 'Sleva - manžel nebo manželka v domácnosti', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5230, NULL, 2070.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (113, '2009-11-23 19:01:40.39', 'SLEVA ZTP/P', 'Sleva - Držitel průkaz ZTP/P', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.danSleva', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5063, NULL, 1345.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (114, '2009-11-23 19:02:53.546', 'SLEVA STUDENT', 'Sleva - Student připravující se na budoucí povolání', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.danSleva', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5065, NULL, 335.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (84, '2009-11-23 19:06:04.984', 'ODPOČET DARU', 'Odpočet daru', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5090, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (111, '2009-11-23 19:07:35.281', 'SLEVA ČÁST.IN.DŮCH.', 'Sleva - Částečně invalidní důchod', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.danSleva', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5064, NULL, 210.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (88, '2009-11-23 19:09:12.031', 'NEZDAN.ČÁSTKY CELKEM', 'Nezdanitelné částky celkem', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.vypocet', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5085, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (79, '2009-11-23 19:09:53.984', 'OPRAVA ZÁKLADU', 'Oprava zdanitelných příjmů', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.vstup', true, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5095, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (105, '2009-11-24 19:00:26.062', 'ZDR.NEOML.ABSENCE', 'Zdravotní  pojištění za neomluvenou absenci', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.zdravPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 7080, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (118, '2009-11-10 16:01:47.421', 'VÝSLEDNÁ DAŇ', 'Záloha na daň - výsledek po slevách a opravách', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5000, 'vyznamSlozky.dan', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (109, '2009-11-23 19:06:29.125', 'BONUS', 'Daňový bonus', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5072, 'vyznamSlozky.danBonus', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (108, '2009-11-23 19:10:19.781', 'VÝPOČET DANĚ', 'Vypočtená zálohová daň', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5050, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (137, '2009-11-10 17:18:46.015', 'MIMOŘÁDNÁ ZÁLOHA', 'Záloha mimořádná', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.zaloha', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 8010, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (138, '2009-11-10 17:18:48.39', 'VRÁCENÁ ČÁSTKA', 'Vrácená částka', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.zaloha', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 8020, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (80, '2009-11-23 19:12:11.062', 'OPRAVA BONUSU', 'Oprava daňového bonusu', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.vstup', true, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5105, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (86, '2009-11-23 19:13:39.828', 'ROČNÍ ZÚČTOVÁNÍ', 'Roční zúčtování zálohové daně', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.kopie', true, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5110, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (185, '2009-10-30 18:40:04.046', 'DOVOLENÁ VYBRÁNO', 'Vybraná dovolená v roce', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.doba', 'typSlozky.vypocet', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 1030, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (186, '2009-10-30 18:40:11.062', 'DOVOLENÁ ZBÝVÁ', 'Zbývá dovolené v roce', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.doba', 'typSlozky.vypocet', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 1040, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (33, '2009-11-13 19:32:54.75', 'ODMĚNY  OSTATNÍ', 'Ostatní odměny', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.odmeny', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 4250, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (189, '2009-11-23 19:35:14.593', 'DAŇ.ZVÝHOD.DĚTI', 'Daňové zvýhodnění na děti', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5071, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (188, '2009-11-09 15:45:28.921', 'KOEF. PRO MĚS.MZDU ', 'Koeficient vypočtený z toho, co zbývá na měsíční mzdu (fond-neodpracovaná doba-hodnová mzda-úkolová mzda)', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.doba', 'typSlozky.vypocet', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 1130, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (82, '2009-10-29 18:30:55.906', 'OPRAVA DANĚ', 'Oprava zálohy na daň', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.vstup', true, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5100, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (176, '2009-11-23 11:38:58.453', 'REDUKOVANÝ PRŮMĚR', 'Redukovaný průměr pro výpočet náhrady mzdy za nemoc, úraz a karanténu', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.vypocet', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3380, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (63, '2009-11-23 15:47:11.578', 'ODPRACOVÁNO', 'Celková odpracovaná doba v měsíci', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.doba', 'typSlozky.vypocet', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 1050, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (183, '2009-11-23 15:47:32.234', 'ODPRAC.MIN.ČTVRT.', 'Odpracovaná doba celkem za minulé čtvrtletí', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.doba', 'typSlozky.vypocet', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 1070, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (38, '2009-11-23 15:51:47.406', 'PŘIPLATEK ZA SVÁTEK', 'Příplatek za svátek', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.priplatky', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, true, false, false, true, false, false, false, false, false, NULL, NULL, 3090, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 1.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (67, '2009-11-23 15:55:25.281', 'ŽIVOTNÍ POJ.DANĚNO', 'Životní pojištění Skupina.Dan - Daněno', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.kopie', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3320, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (68, '2009-11-23 15:55:32.671', 'NEMOCENSKÉ DÁVKY', 'Nemocenské dávky ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.vypocet', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3330, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (71, '2009-11-23 15:58:56.515', 'OPR.NEMOC.DÁVKY', 'Oprava nemocenské dávky celkem', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3390, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (72, '2009-11-23 15:59:14.468', 'OPRAVA NÁH.ZA  NEMOC', 'Oprava - Náhrada mzdy za nemoc', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3400, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (17, '2009-11-24 18:47:49.843', 'MĚSÍČNÍ MZDA', 'Měsíční mzda ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.zakladMzda', 'typSlozky.vstup', false, true, false, false, false, true, true, false, false, false, false, false, false, false, false, false, false, true, false, NULL, NULL, 3000, 'vyznamSlozky.mzdaMesicni', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (178, '2009-11-24 18:48:21.156', 'REFUNDACE NÁHRADY', 'Refundace náhrady mzdy na pracovníka ( 1/2  náhrady mzdy )', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6080, 'vyznamSlozky.refundNeschop', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (70, '2009-11-09 15:48:04.703', 'NÁHR.NEMOC 4-10', 'Náhrada mzdy za nemoc - 4 až 10 den', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.nepritNemoc', 'typSlozky.kopie', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 2130, 'vyznamSlozky.hrubaMzda', 0.00, 0.00, 0.00, NULL, 0.00, 7.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (177, '2009-11-09 15:48:20.312', 'NÁHR.KARANTÉNA 4-10', 'Náhrada mzdy za karanténu - 4 až 10 den', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.nepritKaran', 'typSlozky.kopie', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 2080, 'vyznamSlozky.hrubaMzda', 0.00, 0.00, 0.00, NULL, 0.00, 7.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (101, '2009-11-23 16:12:22.687', 'SOC.FIR.NEZAM.', 'Soc. pojištění - Firma - Stát.pol.zaměs.   (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6150, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (99, '2009-11-23 16:13:32.328', 'SOC.FIR.DŮCHOD', 'Soc. pojištění - Firma - důchodové  (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6130, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (100, '2009-11-23 16:13:35.609', 'SOC.FIR.NEMOC', 'Soc. pojištění - Firma - nemocenské   (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6140, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (104, '2009-11-23 18:54:08.953', 'ZDRAV.POJ.FIRMA', 'Zdravotní  pojištění - firma / zaměstnavatel', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.zdravPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 7005, 'vyznamSlozky.zdravPojFirma', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (190, '2009-11-23 19:35:23', 'IF  X<>0  THEN  X=0', 'Koeficient pro nulování ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5120, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (169, '2009-11-10 17:40:09.50', 'SOC.27100', 'Limit pro slevu', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6170, NULL, 27100.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (2, '2009-11-10 15:31:42.656', 'DOVOLENÁ', 'Dovolená', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.nepritomnost', 'typSlozky.vstup', false, false, false, false, false, true, true, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 2000, 'vyznamSlozky.dobaDovol', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (11, '2009-11-10 15:33:42.093', 'OBECNÝ ZÁJEM', 'Překážky z důvodů obecného zájmu', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.nepritomnost', 'typSlozky.vstup', false, false, false, false, false, true, true, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 2170, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (10, '2009-11-10 15:33:35.328', 'PŘEKÁŽKY OSOBNÍ', 'Důležité osobní překážky v práci', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.nepritomnost', 'typSlozky.vstup', false, false, false, false, false, true, true, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 2160, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (9, '2009-11-10 15:33:24.531', 'STUDIUM', 'Školení, jiné formy přípravy nebo studia', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.nepritomnost', 'typSlozky.vstup', false, false, false, false, false, true, true, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 2150, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (8, '2009-11-10 15:33:12.89', 'PROSTOJ S NÁHRADOU %', 'Prostoj s náhradou % průměrného výdělku', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.nepritomnost', 'typSlozky.vstup', false, true, false, false, false, true, true, false, false, false, false, false, false, true, false, false, false, true, false, NULL, NULL, 2140, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (6, '2009-11-10 15:32:43.156', 'VOLNO PLACENÉ', 'Volno placené', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.nepritomnost', 'typSlozky.vstup', false, false, false, false, false, true, true, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 2110, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (5, '2009-11-10 15:32:37.312', 'ABSENCE OMLUVENÁ', 'Absence neomluvená', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.nepritomnost', 'typSlozky.vstup', false, false, false, false, false, true, true, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 2100, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (15, '2009-11-10 15:34:32.687', 'NEMOC Z POVOLÁNÍ', 'Nemoc z povolání', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.nepritNemoc', 'typSlozky.vstup', false, false, false, false, true, true, true, false, false, false, false, true, false, false, false, false, false, false, false, NULL, NULL, 2090, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (13, '2009-11-10 15:34:10.812', 'NEPRACOVNÍ ÚRAZ', 'Nemoc - nepracovní úraz', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.nepritNemoc', 'typSlozky.vstup', false, false, false, false, true, true, true, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 2060, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (14, '2009-11-10 15:34:19.875', 'PRACOVNÍ ÚRAZ', 'Nemoc - pracovní úraz', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.nepritNemoc', 'typSlozky.vstup', false, false, false, false, false, true, true, false, false, true, false, false, false, false, false, false, false, false, false, NULL, NULL, 2050, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (12, '2009-11-10 15:33:53.828', 'KARANTÉNA', 'Karanténa', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.nepritKaran', 'typSlozky.vstup', false, false, false, false, true, true, true, false, false, false, false, true, false, false, false, false, false, false, false, NULL, NULL, 2040, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (7, '2009-11-10 15:32:48', 'VOLNO NEPLACENÉ', 'Volno neplacené', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.nepritomnost', 'typSlozky.vstup', false, false, false, false, false, true, true, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 2030, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (4, '2009-11-10 15:32:18.093', 'OČR', 'Ošetřování člena rodiny', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.nepritomnost', 'typSlozky.vstup', false, false, false, false, true, true, true, false, false, true, false, false, false, false, false, false, false, false, false, NULL, NULL, 2020, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (3, '2009-11-10 15:32:06.203', 'NEMOC', 'Nemoc', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.nepritNemoc', 'typSlozky.vstup', false, false, false, false, true, true, true, false, false, false, false, true, false, false, false, false, false, false, false, NULL, NULL, 2010, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (19, '2009-11-10 16:07:49.171', 'ÚKOLOVÁ MZDA', 'Úkolová mzda ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.zakladMzda', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3020, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (20, '2009-11-10 16:07:52.531', 'PODÍLOVÁ MZDA', 'Podílová (provizní) mzda', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.zakladMzda', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, true, false, false, false, true, false, NULL, NULL, 3030, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (217, '2009-11-23 11:39:29.015', 'SOC.POJ.CELKEM', 'Celkové sociální pojištění', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6000, 'vyznamSlozky.socPojCelk', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (159, '2009-11-23 16:01:15.796', 'ZÁKLAD SRÁŽ.DANĚ', 'Základ pro výpočet srážkové daně pro pracovní poměr', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.vypocet', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5140, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (21, '2009-11-10 16:07:55.687', 'NÁHRADA ZA SVÁTEK', 'Náhráda za svátek', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.zakladMzda', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, true, false, false, NULL, NULL, 3040, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (42, '2009-11-14 10:16:42.843', 'PŘÍPLATEK ZA VEDENÍ', 'Příplatek za vedení a zastupování', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.priplatky', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3155, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (43, '2009-11-14 10:20:32.515', 'POMOC V MATEŘSTVÍ', 'Peněžitá pomoc v mateřství', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.vstup', false, true, false, false, false, true, true, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3158, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (140, '2009-11-24 18:47:14.109', 'ČISTÁ MZDA', 'Čistá mzda ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.vyplata', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 8000, 'vyznamSlozky.cistaMzda', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (18, '2009-11-24 18:57:08.609', 'HODINOVÁ MZDA', 'Hodinová mzda', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.zakladMzda', 'typSlozky.vstup', false, true, false, true, false, false, false, false, false, false, true, false, false, false, false, false, false, false, false, NULL, NULL, 3010, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (44, '2009-11-10 17:07:37.781', 'ODSTUPNÉ', 'Odstupné, odchodné, odbytné', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3160, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (46, '2009-11-10 17:07:49.156', 'CESTOVNÉ NAD LIMIT', 'Cestovní náhrady nad limit', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3180, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (41, '2009-11-14 10:15:40.656', 'OSOBNÍ PŘÍPLATEK', 'Osobní příplatek', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.priplatky', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3150, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (40, '2009-11-14 10:15:44.468', 'ZVLÁŠTNÍ PŘÍPLATEK', 'Zvláštní příplatek', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.priplatky', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3140, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (25, '2009-11-10 16:48:13.156', 'PRÉMIE %', 'Prémie % ze základní mzdy', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.odmeny', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, true, true, false, false, false, true, false, NULL, NULL, 4170, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (26, '2009-11-10 16:48:15.765', 'PRÉMIE PEVNÁ', 'Prémie pevnou částkou ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.odmeny', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, true, false, false, false, false, false, false, NULL, NULL, 4180, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (27, '2009-11-10 16:48:18.546', 'PRÉMIE % UKAZATELE', 'Prémie % z ukazatele - základu ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.odmeny', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, true, true, false, false, false, true, false, NULL, NULL, 4190, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (199, '2009-11-23 18:34:42.421', 'SOC.ZÁK.OD ZAČ.ROKU', 'Základ pro sociální pojištění do limitu', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6055, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (174, '2009-11-10 17:08:45.984', 'REDUKČNÍ HRANICE 2', 'Průměr pro náhradu mzdy za nemoc 2.redukční hranice', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.vypocet', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3360, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (175, '2009-11-10 17:08:48.64', 'REDUKČNÍ HRANICE 3', 'Průměr pro náhradu mzdy za nemoc 3.redukční hranice', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.vypocet', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3370, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (136, '2009-11-10 17:18:43.796', 'ŘÁDNÁ ZÁLOHA', 'Záloha řádná', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.zaloha', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 8000, 'vyznamSlozky.zalohaRadna', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (61, '2009-11-23 15:47:18.453', 'ODPRACOVÁNO OPRAVA', 'Oprava odpracované doby', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.doba', 'typSlozky.vstup', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 1060, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (45, '2009-11-23 15:52:47.343', 'CESTOVNÉ DO LIMITU', 'Cestovní náhrady do limit', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3170, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (47, '2009-11-23 15:52:58.875', 'NEČERPANÁ DOVOLENÁ', 'Proplacení nevyčerpané dovolené', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.vstup', false, true, false, false, false, true, true, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3190, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (50, '2009-11-23 15:53:58.593', 'DOPL.DO MIN.MZDZ', 'Doplatek do minimální mzdy', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3220, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (65, '2009-11-23 15:55:12.406', 'PENZIJNÍ POJ.DANĚNO', 'Penzijní připojištění Skupina.Dan - Daněno', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.kopie', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3300, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (66, '2009-11-23 15:55:19.14', 'ŽIVOTNÍ POJ.OSV.', 'Životní pojištění osvobozeno', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.kopie', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3310, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (141, '2009-11-10 17:32:22.062', 'VÝP.ČISTÁ BEZ BONUSU', 'Čistá bez bonusu (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.vyplata', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 8050, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (229, '2009-11-24 18:31:12.281', 'SOC.POJ.FIRMA ', 'Sociální pojištění - firma / zaměstnavatel', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6003, 'vyznamSlozky.socPojFirma', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (230, '2009-11-24 18:37:53.406', 'HRUBA MZDA CELKEM', 'Hrubá mzda celkem ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.hrubaMzda', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9500, 'vyznamSlozky.hrubaMzda', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (223, '2009-11-24 18:50:20.14', 'SOC.PRAC. DŮCHOD JD', 'Sociální  pojištění  zaměstnanec - pro zaměstnance za které firma platí pouze důchodové pojištění ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6150, 'vyznamSlozky.socPojCelkDp', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (173, '2009-11-10 17:08:43.671', 'REDUKČNÍ HRANICE 1', 'Průměr pro náhradu mzdy za nemoc 1.redukční hranice', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.vypocet', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3350, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (51, '2009-11-10 17:08:07.109', 'NÁHR.ŠKOD', 'Náhrada škod podle zákoníku práce', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3230, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (54, '2009-11-10 17:08:16.64', '% VOZU', '1%  vstupní ceny vozu ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3260, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (55, '2009-11-10 17:08:19.312', 'DAR Z FKSP', 'Peněž dar z FKSP', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3270, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (56, '2009-11-10 17:08:22.218', 'NATURÁLNÍ MZDA', 'Naturálni mzda', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3280, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (129, '2009-11-14 11:35:15.468', 'ODBORY %', 'Odbory % ze mzdy', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.srazky', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9120, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (168, '2009-11-23 19:42:33.921', 'SOC.FIRMA SLEVA ZÁKL', 'Sleva na soc. pojištění - Firma (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6160, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (125, '2009-11-14 11:35:35.984', 'POJIŠTĚNÍ', 'Pojištění ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.srazky', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9070, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (120, '2009-11-14 11:35:45.218', 'NÁHRADA ŠKOD', 'Náhrada škod', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.srazky', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9050, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (132, '2009-11-14 11:35:49.046', 'STRAVNÉ', 'Stravné', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.srazky', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9040, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (122, '2009-11-14 11:35:59.437', 'EXEKUCE', 'Ostattní exekuce', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.srazky', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9030, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (121, '2009-11-14 11:36:02.781', 'PŘEPLATKY', 'Přeplatky ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.srazky', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9020, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (124, '2009-11-14 11:36:04.937', 'PŮJČKY', 'Půjčky ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.srazky', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9010, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (123, '2009-11-14 11:36:06.812', 'SPOŘENÍ', 'Spoření', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.srazky', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9000, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (75, '2009-11-23 11:43:37.25', 'SOC.POJ.PRAC.OPRAVA', 'Sociální pojištění - pracovník - oprava', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vstup', true, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6040, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (48, '2009-11-23 15:53:07.39', 'PREČERPANÁ DOVOLENÁ', 'Srážka za přečerpanou dovolenou', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.vstup', false, true, false, false, false, true, true, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3200, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (49, '2009-11-23 15:53:47.328', 'DOPL.DO PRŮM.VÝDĚLKU', 'Doplatek do průměrného výdělku', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3210, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (164, '2009-11-17 14:51:09.078', 'SOC.OPR.ZÁKLADU', 'Sociální pojištění - oprava základu', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vstup', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, true, false, NULL, NULL, 6060, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (78, '2009-11-24 18:39:23.50', 'ZDRAV.POJ.FIR.OPRAVA', 'Oprava zdrav. pojištění - zaměstnavatel', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.zdravPoj', 'typSlozky.vstup', true, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 7010, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (182, '2009-11-14 11:37:07.031', 'ZÁKLAD PPP MIN.ČTVR.', 'Čtvrtletní suma základu pro průměrný výdělek', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.hrubaMzda', 'typSlozky.vypocet', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6350, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (196, '2009-11-23 18:34:36.14', 'SOC.ZÁKLAD POČÁTEK', 'Základ pro sociální pojištění - hodnota základu z předchozího zaměstnání', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.inicializace', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, true, false, NULL, NULL, 6055, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (163, '2009-11-12 13:43:04.463', 'ZDR.ZÁKLAD ', 'Základ pro zdravotní pojištění  pro 1 prac.poměr', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.zdravPoj', 'typSlozky.vypocet', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 7100, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (200, '2009-11-23 18:34:49.984', 'SOC.ZÁK.LIMIT', 'Základ pro sociální pojištění do limitu', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6055, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (22, '2009-11-13 19:31:06.468', 'PRESČAS', 'Mzda za práci přesčas', NULL, NULL, NULL, 'Do částky za hodinu se přesese hodinová mzda vypočtená z měsíční mzdy', NULL, true, 'skupinaSlozky.zakladMzda', 'typSlozky.vstup', false, true, false, true, false, false, false, false, false, false, true, false, false, false, false, false, false, false, false, NULL, NULL, 3050, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (205, '2009-11-14 10:18:21.031', 'POHOTOVOST MIMO', 'Odměna za pracovní pohotovost mimo pracoviště', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.priplatky', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, true, false, false, false, false, false, false, false, false, NULL, NULL, 3130, NULL, 0.00, 0.00, 15.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (198, '2009-11-23 18:35:43.281', 'ZDR.ZÁKLAD POČÁTEK', 'Základ pro zdravotního pojištění - hodnota základu z předchozího zaměstnání', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.zdravPoj', 'typSlozky.inicializace', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, true, false, NULL, NULL, 7045, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (218, '2009-11-23 18:53:58.937', 'ZDRAV.POJ.CELKEM', 'Celkové zdravotní pojištění', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.zdravPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 7000, 'vyznamSlozky.zdravPojCelk', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (162, '2009-11-17 14:05:52.828', 'SOC.ZÁKLAD STD', 'Základ pro sociální pojištění  ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6090, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (221, '2009-11-17 17:10:44.125', 'SOC.ZÁKLAD JEN DP', 'Základ pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6095, 'vyznamSlozky.socPojZaklDp', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (184, '2009-11-23 19:34:03.484', 'DOVOLENÁ POČÁTEK', 'Počáteční stav dovolené ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.nepritomnost', 'typSlozky.inicializace', false, false, false, false, false, false, false, false, true, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 2005, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (216, '2009-11-23 15:51:05.953', 'PŘÍPLATEK ZA PŘESČAS', 'Příplatek za práci přesčas', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.priplatky', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, true, false, false, true, false, false, false, false, false, NULL, NULL, 3060, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.25, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (94, '2009-11-23 11:44:27.843', 'SOC.POJ.ZÁKLAD', 'Sociální pojištění - základ ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6050, 'vyznamSlozky.socPojZakl', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (34, '2009-11-23 15:51:24.609', 'PŘÍPLATEK ZA S+N', 'Příplatek za práci v sobotu a neděli', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.priplatky', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, true, false, false, true, false, false, false, false, false, NULL, NULL, 3070, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.50, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (36, '2009-11-23 15:51:39.515', 'NOČNÍ PŘÍPLATEK', 'Příplatek za noční práci', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.priplatky', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, true, false, false, true, false, false, false, false, false, NULL, NULL, 3080, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.10, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (35, '2009-11-23 15:52:24.921', 'PŘÍPL.ZA PROSTŘEDÍ', 'Příplatek za práci ve stíženém prac. prostředí', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.priplatky', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, true, false, false, false, false, false, false, false, false, NULL, NULL, 3110, NULL, 0.00, 0.00, 6.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (102, '2009-11-24 18:34:24.656', 'SOC.POJ.FIRMA PRAC.', 'Sociální pojištění - firma / zaměstnavatel', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6005, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (181, '2009-11-24 18:34:37.171', 'SOC.POJ.FIRMA ZAOKR.', 'Zaokrouhlení sociálního pojištění firmy / zaměstnavatele', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6020, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (227, '2009-11-24 18:53:59.875', 'DNY PŘED NÁSTUPEM', 'Dny před nástupem do zaměstnání pro výpočet podílu měsíční nebo hodinové mzdy', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.doba', 'typSlozky.inicializace', false, false, false, false, false, false, false, false, true, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 1010, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (171, '2009-11-24 18:56:14.468', 'NÁHR.KARANTÉNA 1-3', 'Náhrada mzdy za karanténu - první 3 dny', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.nepritKaran', 'typSlozky.kopie', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 2070, 'vyznamSlozky.hrubaMzda', 0.00, 0.00, 0.00, NULL, 0.00, 3.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (69, '2009-11-24 18:56:29.625', 'NÁHR.NEMOC 1-3', 'Náhrada mzdy za nemoc  - první 3 dny', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.nepritNemoc', 'typSlozky.kopie', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 2120, 'vyznamSlozky.hrubaMzda', 0.00, 0.00, 0.00, NULL, 0.00, 3.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (167, '2009-11-23 19:15:43.171', 'HRUBA MZDA CELKEM ', 'Hrubá mzda celkem ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.hrubaMzda', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9500, 'vyznamSlozky.hrubaMzda', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (226, '2009-11-25 19:59:47.718', 'NÁHRADA ZA NEMOC', 'Celková náhrada mzdy za nemoc', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.nepritNemoc', 'typSlozky.vypocet', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 2120, 'vyznamSlozky.nahradaNeschop', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (73, '2009-11-23 11:10:17.875', 'OPRAVA HRUBÉ MZDY', 'Oprava hrubé mzdy celkem', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.hrubaMzda', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9510, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (89, '2009-11-23 11:10:55.984', 'NEPATŘÍ DO PPP ', 'Nepatří do základu pro průměrný výdělek', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.hrubaMzda', 'typSlozky.vypocet', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9580, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (148, '2009-11-23 11:11:22.109', 'STAROBNÍ DŮCHOD', 'Starobní důchod', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.duchod', 'typSlozky.info', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9700, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (149, '2009-11-23 11:11:31.125', 'JINÝ DŮCHOD', 'Vdovský (vdovecký, sirodčí) důchod', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.duchod', 'typSlozky.info', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9710, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (150, '2009-11-23 11:11:42.906', 'MATEŘ. DOVOLENÁ', 'Mateřská dovolená (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.vyneti', 'typSlozky.dlouhodobNep', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9810, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (151, '2009-11-23 11:11:46.656', 'RODIČ.DOVOLENÁ', 'Rodičovská dovolená  (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.vyneti', 'typSlozky.dlouhodobNep', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9820, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (153, '2009-11-23 11:11:56.328', 'MIMO EVID.NEOML. ', 'Mimo evidenci neomluveno (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.vyneti', 'typSlozky.dlouhodobNep', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9840, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (152, '2009-11-23 19:19:16.14', 'MIMO EVIDENCI ', 'Mimo evidenci (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.vyneti', 'typSlozky.dlouhodobNep', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9830, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (179, '2009-11-23 15:49:28.796', 'ODPRACOVÁNO VÝPOČET', 'Odpracovaná doba celkem - rozdíl mezi fondem pracovní doby a neodpracovanou dobou', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.doba', 'typSlozky.vypocet', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 1130, 'vyznamSlozky.dobaOdpr', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (98, '2009-11-23 11:43:23.593', 'SOC.POJ.PRACOVNÍK', 'Sociální pojištění - pracovník  ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6030, 'vyznamSlozky.socPojPrac', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (222, '2009-11-24 18:49:36.703', 'SOC.FIR.DŮCHOD JD', 'Sociální  pojištění - firma / zaměstnavatel - pro zaměstnance za které firma platí pouze důchodové pojištění ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6140, 'vyznamSlozky.socPojCelkDp', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (170, '2009-11-24 18:50:45.906', 'SOC.POJ. SLEVA ', 'Sleva na sociálním pojištění - pro firmu / zaměstnavatele', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6070, 'vyznamSlozky.socPojSleva', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (76, '2009-11-24 18:59:24.406', 'SOC.POJ.FIRMA OPRAVA', 'Oprava sociálního pojištění - firma / zaměstnavatel', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vstup', true, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6010, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (1, '2009-11-23 15:44:51.421', 'FOND V MĚSÍCI ', 'Fond pracovní  doby v aktuálním měsíci', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.doba', 'typSlozky.kopie', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 1010, 'vyznamSlozky.dobaFond', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (16, '2009-11-23 15:48:45.937', 'CELKOVÁ NEPŘÍTOMNOST', 'Celková neodpracovaná doba - nepřítomnost', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.doba', 'typSlozky.vypocet', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 1100, 'vyznamSlozky.dobaNeodpr', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (37, '2009-11-23 15:52:07.265', 'PŘÍPL.ZA ROZD.SMĚNU', 'Příplatek za rozdělenou směnu', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.priplatky', 'typSlozky.vstup', false, true, false, true, false, true, false, false, false, false, true, false, false, false, false, false, false, false, false, NULL, NULL, 3100, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (52, '2009-11-23 15:54:29.859', 'SOCIÁLNÍ VÝPOMOC', 'Jednorázová sociální výpomoc', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3240, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (53, '2009-11-23 15:54:40.625', 'VYROV.PŘÍSP.V MATEŘ.', 'Vyrovnávací příspěvěk v těhotenství a mateřství', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3250, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (64, '2009-11-23 15:55:05.781', 'PENZIJNÍ POJ.OSV.', 'Penzijní připojištění osvobozeno', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.kopie', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3290, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (172, '2009-11-23 15:56:38.109', 'PRAC.PRÁVNÍ  PRŮMĚR ', 'Pracovně právní hodinový průměr pro náhradu mzdy za nemoc, dovolenou ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.vypocet', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3340, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (195, '2009-11-23 15:58:28.50', 'PPP-POČEČNÍ STAV ', 'Zadání  PPP před nástupem do zaměstnání nebo při zavedení do mzdového modulu FlexiBEE ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.ostatNahrad', 'typSlozky.inicializace', false, false, false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 3340, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (23, '2009-11-23 15:59:29.078', 'MĚSÍČNÍ ODMĚNA ', 'Měsíční odměna', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.odmeny', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 4150, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (24, '2009-11-23 15:59:35.343', 'MIMOŘÁDNÁ ODMĚNA ', 'Mimořádná odměna ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.odmeny', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, true, false, false, false, false, false, false, NULL, NULL, 4160, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (31, '2009-11-23 15:59:57.812', 'ODMĚNA STAT.ORGÁNU', 'Odměna členů statutárního orgánu', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.odmeny', 'typSlozky.vstup', false, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 4230, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (107, '2009-11-23 16:00:31.406', 'ZÁKLAD DANĚ - SHM', 'Základ pro výpočet daně - superhubá mzda', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5010, 'vyznamSlozky.superhrubaMzda', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (93, '2009-11-24 19:00:11.89', 'ZDR.DOPL.MIN.ZAKL.', 'Doplatek do minimílního  vyměřovacího základu zdravotního pojištění', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.zdravPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 7070, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (157, '2009-11-23 16:01:33.296', 'ZÁKL.SRÁŽKOVÉ DANĚ', 'Základ pro výpočet srážkové daně', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5150, 'vyznamSlozky.danZaklSrazSum', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (83, '2009-11-23 16:02:32.812', 'OPRAVA SRÁŽ.DANĚ', 'Oprava srážkové daně', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.vstup', true, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5170, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (96, '2009-11-23 16:12:48.265', 'SOC.PRAC.NEMOC', 'Soc. pojištění - pracovník - nemocenské  (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6110, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (146, '2009-11-23 16:03:51.328', 'DAN -STATUT.ORGÁN', 'Daň z odměny statutárního orgánu', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5190, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (97, '2009-11-23 16:13:28.343', 'SOC.PRAC.MEZAM', 'Soc. pojištění - pracovník - Stát.pol.zaměs.   (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6120, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (158, '2009-11-23 16:05:33.031', 'ZÁKLAD DANĚ  ', 'Základ daně ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.vypocet', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5200, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (103, '2009-11-23 16:15:18.359', 'ZDRAV.POJ.PRAC.', 'Zdrav. pojištění - pracovník', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.zdravPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 7020, 'vyznamSlozky.zdravPojPrac', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (110, '2009-11-23 19:00:40.421', 'SLEVA NA POPLATNÍKA', 'Sleva na poplatníka (podepsal prohlášení k dani)', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.danSleva', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5061, 'vyznamSlozky.danSlevPrac', 2070.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (112, '2009-11-23 19:01:21.64', 'SLEVA NA INV.DŮCHOD', 'Sleva na invalidní důchod', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.danSleva', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5062, NULL, 420.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (191, '2009-11-23 19:35:10.546', 'SLEVA DĚTI', 'Odečtení slevy na děti, když není bonus', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5070, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (219, '2009-11-23 16:17:04.468', 'SOC.ZÁKL.SLE', 'Základ pro sociální pojištění  ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6050, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (220, '2009-11-23 16:17:27.515', 'SOC.ZÁKL.SLE.SUM', 'Sleva ze základu pro sociální pojištění ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6050, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (201, '2009-11-23 16:18:55.843', 'ZÁKLAD PRO VÝPOČET', 'Základ pro výpočet sociální pojištění, který nepřekračuje roční limit', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6050, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (202, '2009-11-23 16:19:55.765', 'ZDR.ZÁKL.PRO VÝPOČ.', 'Základ pro výpočet zdravotního pojištění, který nepřekračuje roční limit', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.zdravPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 7040, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (165, '2009-11-23 16:21:29.718', 'ZDR.POJ.OPR.ZÁKLADU', 'Oprava základu zdravotního pojištění ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.zdravPoj', 'typSlozky.vstup', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, true, false, NULL, NULL, 7060, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (143, '2009-11-23 16:22:14.359', 'PŘEPLATEK MINULOSTI', 'Přeplatek z minulosti ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.vyplata', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 8010, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (128, '2009-11-23 16:24:58.531', 'ODBORY ČÁSTKA', 'Odbory částka ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.srazky', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9110, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (130, '2009-11-23 16:25:06.328', 'ŽIVOTNÍ POJIŠTĚNÍ', 'Životní pojištění', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.srazky', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9130, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (131, '2009-11-23 16:25:13', 'OSOBNÍ ÚČET', 'Osobní účet ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.srazky', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9140, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (133, '2009-11-23 16:25:18.781', 'STRAVNÉ VYPOČTENÉ', 'Stravné vypočet dle odprac. dnů ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.srazky', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9150, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (134, '2009-11-23 16:25:38.828', 'SRÁŽKA HRUBÉ MZDY %', 'Srážky% z hrubé mzdy ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.srazky', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9160, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (92, '2009-11-23 18:35:26.312', 'ZDRAV.POJ.ZÁKLAD', 'Základ pro zdravotní pojištění', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.zdravPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 7040, 'vyznamSlozky.zdravPojZakl', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (91, '2009-11-23 18:35:58.921', 'ZDR.ODPOČETZÁKLADU', 'Odpočet z vyměřovacího základu pro zdravotní pojištění', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.zdravPoj', 'typSlozky.vypocet', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 7050, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (77, '2009-11-24 18:39:12.421', 'ZDRAV.POJ.PRA.OPRAVA', 'Oprava zdrav. pojištění - pracovník', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.zdravPoj', 'typSlozky.vstup', true, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 7030, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (106, '2009-11-24 19:00:34.265', 'ZDR.POJ.NEPL.VOLNO', 'Zdravotní pojištění za neplacené volno', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.zdravPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 7090, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (142, '2009-11-23 16:22:22.484', 'OPRAVA DOBÍRKY', 'Oprava dobírky', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.vyplata', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 8030, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (139, '2009-11-23 16:22:26.781', 'DOBÍRKA', 'Dobírka ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.vyplata', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 8040, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (144, '2009-11-23 16:22:48.406', 'POHLEDÁVKA', 'Pohledávka za zaměstnancem', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.vyplata', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 8020, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (127, '2009-11-23 16:24:21.265', 'PENZIJNÍ POJIŠTĚNÍ', 'Penzijní pojištění zaměstnance', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.srazky', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9090, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (126, '2009-11-23 16:24:37.812', 'PŘÍSPĚVEK NA PEN.POJ', 'Příspěvek firmy / zamětnavatele na penzijní pojištění zaměstnance', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.srazky', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9080, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (180, '2009-11-23 16:24:48.578', 'PENZ.POJ.DANĚNO', 'Penzijní pojištění daněno', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.srazky', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9100, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (87, '2009-11-23 16:26:10.093', 'HRUBÁ MZDA', 'Hrubá mzda celkem', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.hrubaMzda', 'typSlozky.vypocet', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9520, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (90, '2009-11-23 16:26:35.812', 'ZÁKLAD PPP', 'Základ pro průměrný výdělek', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.hrubaMzda', 'typSlozky.vypocet', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9530, 'vyznamSlozky.hrubaPrumer', 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (74, '2009-11-23 16:26:38.765', 'OPR.ZÁKLADU PPP', 'Oprava základu pro průměrný výdělek', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.hrubaMzda', 'typSlozky.vstup', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, true, false, NULL, NULL, 9540, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (154, '2009-11-23 16:27:03.078', 'NEPATŘÍ DO ZDR.POJ.', 'Nepatří do základu pro zdravotní pojištění', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.hrubaMzda', 'typSlozky.vypocet', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9550, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (228, '2009-11-24 18:39:58.187', 'BONUS -', 'Daňový bonus pro příkaz k úhradě', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.dan', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5072, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (156, '2009-11-23 16:27:40', 'NEPAŘÍ DO VÝPLATY ', 'Nepatří do hrubé mzdy', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.hrubaMzda', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9570, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (155, '2009-11-23 18:31:16.578', 'NEPATŘÍ DO SOC.POJ. ', 'Nepatří do základu pro sociální pojištění', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.hrubaMzda', 'typSlozky.vypocet', false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 9560, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (95, '2009-11-23 18:35:01.328', 'SOC.PRAC.DŮCHOD ', 'Soc. pojištění - pracovník - důchodové  Základ pro sociální pojištění ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.socPoj', 'typSlozky.vypocet', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 6100, NULL, 0.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, true);
INSERT INTO pcismzdsloz (idcismzdsloz, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, skupslozkyk, typslozkyk, naosobu, vscastmzd, vscastnaden, vscastnahod, vscisdoklnem, vsdatdo, vsdatod, vsdnykal, vsdnyprac, vsdnysvatek, vshodiny, vsdoplatzdrpoj, vspocetmes, vsprocmzd, vsprumnadennem, vsprumnahodnem, vszakljekracen, vszaklmzd, vszmenacastmzd, platido, platiod, cisrad, vyznamk, castmzd, castkaden, castkahod, cisdoklnem, dnykal, dnyprac, dnysvatek, doplatzdravk, hodiny, pocetmes, procmzd, prumnadennem, prumnahodnem, zakljekracen, zaklmzd, zmenacastmzd, pracovni) VALUES (116, '2009-11-23 19:04:51.515', 'SLEVA NA DÍTĚ', 'Sleva na dítě ', NULL, NULL, NULL, NULL, NULL, true, 'skupinaSlozky.danSleva', 'typSlozky.kopie', true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, NULL, NULL, 5069, NULL, 890.00, 0.00, 0.00, NULL, 0.00, 0.00, 0.00, NULL, 0.00, NULL, 0.00, 0.00, 0.00, false, 0.00, false, false);

PERFORM pg_catalog.setval('seq_pcismzdsloz', 231, true);

-- Pracovní poměry
INSERT INTO ptyppracpom (idtyppracpom, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod) VALUES (1, '2009-09-23 15:55:38.265', 'STANDARD', 'Standardní pracovní poměr', NULL, NULL, NULL, NULL, NULL, true, NULL, NULL);
INSERT INTO ptyppracpom (idtyppracpom, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod) VALUES (2, '2009-09-23 15:56:01.343', 'DPP', 'Dohoda o provedení práce', NULL, NULL, NULL, NULL, NULL, true, NULL, NULL);
INSERT INTO ptyppracpom (idtyppracpom, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod) VALUES (4, '2009-09-28 11:27:53.015', 'DPČ', 'Dohoda o provedenní činnosti', NULL, NULL, NULL, 'do 2000 se neplatí sociálka zdravotka', NULL, true, NULL, NULL);
INSERT INTO ptyppracpom (idtyppracpom, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod) VALUES (5, '2009-11-16 18:28:23.187', 'ÚČASTNÍCI POUZE DP', 'Společníci, jednatelé, členové družstva atd.', NULL, NULL, NULL, NULL, NULL, true, NULL, NULL);

PERFORM pg_catalog.setval('seq_ptyppracpom', 5, true);

-- Mzdová kalkulačka
INSERT INTO pmzdcalchlav (idmzdcalchlav, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod) VALUES (1, '2009-09-29 16:57:11.50', 'ČESKÉ MZDY 2009', 'Výpočet mzdy pro rok 2009', NULL, NULL, NULL, NULL, NULL, true, NULL, NULL);

INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (206, '2009-11-25 20:16:23.734', '15', '...', NULL, NULL, NULL, NULL, NULL, true, 253, 0.000000, 0.600000, 0.000000, 0.000000, 'hodiny', 'castMzd', NULL, NULL, 'mzdCalcOper.krat', 1, 177, 177, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (360, '2009-11-25 20:16:44.328', '10', 'Sleva na sociálním pojištění - pro firmu / zaměstnavatele', NULL, NULL, NULL, NULL, NULL, true, 199, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 107, 170, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (155, '2009-11-24 11:10:30.39', '10', '----- Sleva na soc. pojištění - Firma (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 193, 0.000000, -1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 102, 170, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (317, '2009-11-23 18:31:44.046', 'SOC.FIRMA SLEVA ', 'Koeficient pro nulování ', NULL, NULL, NULL, NULL, NULL, true, 177, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 170, 190, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (314, '2009-11-23 18:31:44.234', 'SOC.FIRMA SLEVA ', 'Limit pro slevu', NULL, NULL, NULL, NULL, NULL, true, 176, 792.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.plus', 1, 170, 169, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (315, '2009-11-23 18:31:44.625', '11', 'Základ pro sociální pojištění  (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 174, 0.000000, 1.000000, 0.000000, 0.000000, 'zaklMzd;zaklMzd', 'castMzd;zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 190, 219, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (149, '2009-11-23 18:31:45.015', '9', 'Základ pro sociální pojištění  (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 172, 0.000000, -1.000000, 1.000000, 0.000000, 'zaklMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 169, 220, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (152, '2009-11-23 18:31:45.203', '9', '----- Sleva na soc. pojištění - Firma (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 171, 0.000000, 0.000000, 27100.000000, 0.000000, 'zaklMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.krat', 1, 169, 169, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (326, '2009-11-23 18:31:45.39', '9', 'Soc. pojištění - Zaměstnanec -JD', NULL, NULL, NULL, NULL, NULL, true, 170, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.plus', 1, 98, 223, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (80, '2009-11-23 18:31:47.562', '9', '---- Základ pro sociální pojištění po akceptování limitu', NULL, NULL, NULL, NULL, NULL, true, 159, 0.000000, 0.215000, 1.000000, 0.000000, 'zaklMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 99, 201, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (254, '2009-11-23 18:31:47.796', '9**', '---- Výpočet toho co zbyde do limitu aktuální měsíc', NULL, NULL, NULL, NULL, NULL, true, 158, 9999999999999.000000, 1.000000, 1.000000, 0.000000, 'zaklMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 201, 94, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (253, '2009-11-23 18:31:48', '9**', '---- Odečtu od limitu sumu vyýpočtového základu od začátku roku', NULL, NULL, NULL, NULL, NULL, true, 157, 9999999999999.990000, -1.000000, 0.000000, 1130640.000000, 'zaklMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 201, 199, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (252, '2009-11-23 18:31:48.187', '9**', '---- Přidání aktuálního měsíce', NULL, NULL, NULL, NULL, NULL, true, 156, 0.000000, 1.000000, 1.000000, 0.000000, 'zaklMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 199, 94, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (250, '2009-11-23 18:31:48.39', '9**', '---- Přidání počátku ', NULL, NULL, NULL, NULL, NULL, true, 155, 0.000000, 1.000000, 1.000000, 0.000000, 'zaklMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 199, 196, false, 'mzdCalcSuma.rokPred', 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (318, '2009-11-23 18:52:47.953', 'SOC.FIRMA SLEVA ', 'Sleva na soc. pojištění - Firma (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 179, 0.000000, 1.000000, 0.000000, 0.000000, 'zaklMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.krat', 1, 170, 170, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (261, '2009-11-23 18:52:49.953', '10***', '---- Základ pro zdravotní pojištění od začátku roku', NULL, NULL, NULL, NULL, NULL, true, 188, 9999999999999.990000, -1.000000, 0.000000, 1130640.000000, 'zaklMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 202, 204, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (262, '2009-11-23 18:52:50.14', '10***', 'Základ pro zdravotní pojištění', NULL, NULL, NULL, NULL, NULL, true, 189, 9999999999999.000000, 1.000000, 1.000000, 0.000000, 'zaklMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 202, 92, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (95, '2009-11-23 18:52:50.375', '10', 'Základ pro zdravotní pojištění', NULL, NULL, NULL, NULL, NULL, true, 190, 0.000000, 0.090000, 1.000000, 0.000000, 'zaklMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.plus', 1, 104, 202, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (96, '2009-11-23 18:52:50.593', '10', 'Základ pro zdravotní pojištění', NULL, NULL, NULL, NULL, NULL, true, 191, 0.000000, 0.045000, 1.000000, 0.000000, 'zaklMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.plus', 1, 103, 202, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (97, '2009-11-23 18:52:50.781', '10', '----- Oprava zdrav. pojištění - zaměstnavatel', NULL, NULL, NULL, NULL, NULL, true, 192, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 104, 78, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (351, '2009-11-23 18:31:51.531', 'NEPATŘÍ DO SOC.POJ. ', 'Jednorázová sociální výpomoc', NULL, NULL, NULL, NULL, NULL, true, 139, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 155, 52, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (350, '2009-11-23 18:31:51.734', 'NEPATŘÍ DO SOC.POJ. ', 'Náhrada škod podle zákoníku práce', NULL, NULL, NULL, NULL, NULL, true, 138, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 155, 51, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (349, '2009-11-23 18:31:51.953', 'NEPATŘÍ DO SOC.POJ. ', 'Odměna podle zákona o vynálezech a ZN', NULL, NULL, NULL, NULL, NULL, true, 137, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 155, 30, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (348, '2009-11-23 18:31:52.14', 'NEPATŘÍ DO SOC.POJ. ', 'Odměna k životnímu, pracobnímu jubileu, odchodu do důchodu', NULL, NULL, NULL, NULL, NULL, true, 136, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 155, 29, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (347, '2009-11-23 18:31:52.343', 'NEPATŘÍ DO SOC.POJ. ', 'Odstupné, odchodné, odbytné', NULL, NULL, NULL, NULL, NULL, true, 135, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 155, 44, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (346, '2009-11-23 18:31:52.953', '8', 'Jednorázová sociální výpomoc', NULL, NULL, NULL, NULL, NULL, true, 132, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 154, 52, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (345, '2009-11-23 18:31:53.156', '8', 'Náhrada škod podle zákoníku práce', NULL, NULL, NULL, NULL, NULL, true, 131, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 154, 51, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (230, '2009-11-25 20:16:20.171', '16', '----- Přičtení dovolené do výplaty', NULL, NULL, NULL, NULL, NULL, true, 268, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 140, 2, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (221, '2009-11-25 20:16:20.453', '16', '----- Sumace dovolené od začátku roku', NULL, NULL, NULL, 'sumaa odpracované doby za minulé čtvrtletí', NULL, true, 267, 0.000000, 1.000000, 0.000000, 0.000000, 'dnyPrac', 'dnyPrac', NULL, NULL, 'mzdCalcOper.plus', 1, 185, 2, false, 'mzdCalcSuma.rokPred', 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (205, '2009-11-25 20:16:22.109', '15', '----- Průměr pro náhradu mzdy za nemoc redukovaný', NULL, NULL, NULL, NULL, NULL, true, 260, 0.000000, 0.500000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 178, 176, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (215, '2009-11-25 20:16:22.312', '15', '----- Náhrada mzdy za karanténu', NULL, NULL, NULL, NULL, NULL, true, 259, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 140, 177, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (200, '2009-11-25 20:16:23.437', 'SOC.FIRMA REFUNDACE', '...', NULL, NULL, NULL, NULL, NULL, true, 254, 0.000000, 0.500000, 0.000000, 0.000000, 'castMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.plus', 1, 178, 177, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (196, '2009-11-25 20:16:23.937', '15', '----- Přesun redukovaného PPP do  výpočtu náhrady karantény', NULL, NULL, NULL, NULL, NULL, true, 252, 0.000000, 1.000000, 0.000000, 0.000000, 'prumNaHodNem', 'castMzd', NULL, NULL, 'mzdCalcOper.krat', 1, 177, 176, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (74, '2009-11-23 18:31:52.546', '8', '----- Životní pojištění osvobozeno', NULL, NULL, NULL, NULL, NULL, true, 134, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 155, 66, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (213, '2009-11-25 20:16:22.734', '15', '----- Náhrada mzdy za nemoc', NULL, NULL, NULL, NULL, NULL, true, 257, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 140, 70, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (319, '2009-11-23 18:31:43.843', '11', 'Koeficient pro nulování ', NULL, NULL, NULL, NULL, NULL, true, 178, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'castkaHod', NULL, NULL, 'mzdCalcOper.plus', 1, 190, 190, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (154, '2009-11-23 18:31:44.828', 'SOC.27100', '----- Limit pro slevu', NULL, NULL, NULL, NULL, NULL, true, 173, 0.000000, 0.033000, 0.000000, 0.000000, 'zaklMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.plus', 1, 169, 169, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (93, '2009-11-23 18:31:45.593', '9', '----- Oprava soc. pojištění - pracovník', NULL, NULL, NULL, NULL, NULL, true, 169, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 98, 75, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (89, '2009-11-23 18:31:45.781', '9', '----- Sociálka výpočet', NULL, NULL, NULL, NULL, NULL, true, 168, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.plus', 1, 98, 95, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (92, '2009-11-23 18:31:46.015', '9', '----- Oprava soc. pojištění - zaměstnavatel', NULL, NULL, NULL, NULL, NULL, true, 167, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 102, 76, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (325, '2009-11-23 18:31:46.203', '9', 'Soc. pojištění - Firma - pro JD', NULL, NULL, NULL, NULL, NULL, true, 166, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 102, 222, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (135, '2009-11-23 18:31:46.406', '9', '----- Soc. pojištění - Firma - Stát.pol.zaměs.   (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 165, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 102, 101, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (201, '2009-11-25 20:16:25.062', '15', '----- Zaokrouhlení na koruny nahoru', NULL, NULL, NULL, NULL, NULL, true, 247, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.plus', 1, 70, 70, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (202, '2009-11-25 20:16:25.359', '15', '----- Výpočet refundace náhrady', NULL, NULL, NULL, NULL, NULL, true, 246, 0.000000, 0.500000, 1.000000, 0.000000, 'castMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.plus', 1, 178, 70, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (198, '2009-11-25 20:16:25.546', '15', '----- Výpočet náhrady', NULL, NULL, NULL, NULL, NULL, true, 245, 0.000000, 0.600000, 0.000000, 0.000000, 'hodiny', 'castMzd', NULL, NULL, 'mzdCalcOper.krat', 1, 70, 70, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (224, '2009-11-25 20:16:27.437', '14', '----- Přesun průměru PP do složky dovolené', NULL, NULL, NULL, 'sumaa odpracované doby za minulé čtvrtletí', NULL, true, 237, 0.000000, 1.000000, 1.000000, 0.000000, 'prumNaHodNem', 'castMzd', NULL, NULL, 'mzdCalcOper.lomeno', 1, 2, 172, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (147, '2009-11-25 20:16:27.656', '13', '----- Srážková daň ', NULL, NULL, NULL, NULL, NULL, true, 236, 0.000000, -1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 140, 145, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (117, '2009-11-25 20:16:27.859', '13', '----- Nepatří do hrubé mzdy', NULL, NULL, NULL, NULL, NULL, true, 235, 0.000000, -1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 140, 156, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (113, '2009-11-25 20:16:28.062', '13', '----- Zdrav. pojištění - pracovník', NULL, NULL, NULL, NULL, NULL, true, 234, 0.000000, -1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 140, 103, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (112, '2009-11-25 20:16:28.281', '13', '----- Soc. pojištění - pracovník   (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 233, 0.000000, -1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 140, 98, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (146, '2009-11-25 20:16:28.484', 'MZDA', 'Čistá mzda', NULL, NULL, NULL, NULL, NULL, true, 232, 0.000000, -1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 140, 118, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (114, '2009-11-25 20:16:28.687', '13', '----- Hrubá mzda celkem pro všechny pracovní poměry', NULL, NULL, NULL, NULL, NULL, true, 231, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 140, 167, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (140, '2009-11-25 20:16:28.906', '12', '----- Oprava srážkové daně', NULL, NULL, NULL, NULL, NULL, true, 230, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 145, 83, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (139, '2009-11-25 20:16:29.109', '12', '----- Základ pro výpočet srážkové daně', NULL, NULL, NULL, NULL, NULL, true, 229, 0.000000, 0.150000, 1.000000, 0.000000, 'zaklMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.plus', 1, 145, 157, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (145, '2009-11-25 20:16:29.328', '12', '----- Základ pro výpočet srážkové daně pro pracovní poměr', NULL, NULL, NULL, NULL, NULL, true, 228, 0.000000, 1.000000, 1.000000, 0.000000, 'zaklMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 157, 159, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (204, '2009-11-25 20:16:24.156', '15', '----- Zaokrouhlení na koruny nahoru', NULL, NULL, NULL, NULL, NULL, true, 251, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.krat', 1, 171, 171, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (203, '2009-11-25 20:16:24.359', '15', '----- Výpočet refundace náhrady', NULL, NULL, NULL, NULL, NULL, true, 250, 0.000000, 0.500000, 1.000000, 0.000000, 'castMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.plus', 1, 178, 171, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (199, '2009-11-25 20:16:24.578', '15', '----- Výpočet náhrady', NULL, NULL, NULL, NULL, NULL, true, 249, 0.000000, 0.600000, 0.000000, 0.000000, 'hodiny', 'castMzd', NULL, NULL, 'mzdCalcOper.krat', 1, 171, 171, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (197, '2009-11-25 20:16:24.843', 'NÁHRADY ZA KARANTÉNU', '----- Přesun redukovaného PPP do  výpočtu náhrady karantény', NULL, NULL, NULL, NULL, NULL, true, 248, 0.000000, 1.000000, 0.000000, 0.000000, 'castkaHod', 'castMzd', NULL, NULL, 'mzdCalcOper.krat', 1, 171, 176, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (247, '2009-11-25 20:16:30.484', '11', '----- Daňové zvýhodnění na děti', NULL, NULL, NULL, NULL, NULL, true, 223, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 191, 189, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (246, '2009-11-25 20:16:30.703', '11', '----- Koeficient pro nulování do základu daně', NULL, NULL, NULL, NULL, NULL, true, 222, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 191, 190, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (245, '2009-11-25 20:16:30.921', '11', '----- Nulování daně na základě nenulového bonusu', NULL, NULL, NULL, NULL, NULL, true, 221, 0.000000, 1.000000, 0.000000, 0.000000, 'zaklMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.krat', 1, 118, 118, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (244, '2009-11-25 20:16:31.125', '11', '----- Koeficient pro nulování do základu daně', NULL, NULL, NULL, NULL, NULL, true, 220, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 118, 190, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (243, '2009-11-25 20:16:31.343', '11', '----- X * -1 + 1  Když je X 1, pak 0, když je X 0, pak 1 ', NULL, NULL, NULL, NULL, NULL, true, 219, 0.000000, -1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.krat', 1, 190, 190, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (241, '2009-11-25 20:16:31.781', '11', '----- Příprava  X; bonus  do  X a Y', NULL, NULL, NULL, NULL, NULL, true, 217, 4350.000000, 1.000000, 0.000000, 0.000000, 'castMzd;castMzd', 'castMzd;zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 190, 109, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (123, '2009-11-25 20:16:44.328', '10', '----- Základ pro výpočet daně ', NULL, NULL, NULL, NULL, NULL, true, 200, 0.000000, 1.000000, 1.000000, 0.000000, 'zaklMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 107, 158, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (100, '2009-11-23 18:52:51.671', '10', '----- Nezdanitelné částky celkem', NULL, NULL, NULL, NULL, NULL, true, 196, 0.000000, -1.000000, 1.000000, 0.000000, 'castMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 158, 88, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (103, '2009-11-23 18:52:51.859', '10', '----- Oprava zdanitelných příjmů', NULL, NULL, NULL, NULL, NULL, true, 197, 0.000000, 1.000000, 1.000000, 0.000000, 'zaklMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 158, 79, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (130, '2009-11-25 14:27:04.015', '10', 'Sociální pojištění - firma / zaměstnavatel', NULL, NULL, NULL, NULL, NULL, true, 198, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 107, 102, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (99, '2009-11-25 20:16:29.593', '12', 'Srážková daň', NULL, NULL, NULL, NULL, NULL, true, 227, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 159, 87, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (101, '2009-11-25 20:16:29.796', '11', '----- Oprava zálohy na daň', NULL, NULL, NULL, NULL, NULL, true, 226, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 118, 82, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (249, '2009-11-25 20:16:30.078', '11', '----- Odečtení slevy ne děti, když není bonus', NULL, NULL, NULL, NULL, NULL, true, 225, 0.000000, -1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 118, 191, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (248, '2009-11-25 20:16:30.281', '11', '----- Odečtení slevy ne děti, když není bonus', NULL, NULL, NULL, NULL, NULL, true, 224, 0.000000, 1.000000, 0.000000, 0.000000, 'zaklMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.krat', 1, 191, 191, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (120, '2009-11-23 18:52:48.453', '9', '----- *', NULL, NULL, NULL, NULL, NULL, true, 181, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 163, 87, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (79, '2009-11-23 18:52:48.671', 'ZDRAVOTNÍ POJIŠTĚNÍ', 'Výpočet zdravotky', NULL, NULL, NULL, NULL, NULL, true, 182, 0.000000, -1.000000, 1.000000, 0.000000, 'castMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 163, 154, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (122, '2009-11-23 18:52:48.859', '10', '----- Zdravotní pojištění = oprava základ', NULL, NULL, NULL, NULL, NULL, true, 183, 0.000000, 1.000000, 1.000000, 0.000000, 'zaklMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 163, 165, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (94, '2009-11-23 18:52:49.093', '10', '----- Základ za všechny pracovní poměry', NULL, NULL, NULL, NULL, NULL, true, 184, 0.000000, 1.000000, 1.000000, 0.000000, 'zaklMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 92, 163, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (258, '2009-11-23 18:52:49.312', '10***', '---- Základ pro zdravotní pojištění', NULL, NULL, NULL, NULL, NULL, true, 185, 0.000000, 1.000000, 0.000000, 0.000000, 'zaklMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 204, 202, false, 'mzdCalcSuma.rokPred', 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (259, '2009-11-23 18:52:49.531', '10***', '---- Základ pro zdravotního pojištění - hodnota základu z předchozího zaměstnání', NULL, NULL, NULL, NULL, NULL, true, 186, 0.000000, 1.000000, 1.000000, 0.000000, 'zaklMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 204, 198, false, 'mzdCalcSuma.rokPred', 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (260, '2009-11-23 18:52:49.734', '10***', '---- Základ pro zdravotní pojištění', NULL, NULL, NULL, NULL, NULL, true, 187, 0.000000, 1.000000, 1.000000, 0.000000, 'zaklMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 204, 92, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (98, '2009-11-23 18:52:51.203', '10', '----- Zdravotka výpočet ', NULL, NULL, NULL, NULL, NULL, true, 194, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 103, 77, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (124, '2009-11-23 18:52:51.421', 'DANĚ', 'Výpočet daně', NULL, NULL, NULL, NULL, NULL, true, 195, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 158, 87, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (134, '2009-11-23 18:31:46.593', '9', '----- Soc. pojištění - Firma - nemocenské   (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 164, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 102, 100, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (322, '2009-11-23 20:32:15.156', 'SOC.PRAC. DŮCHOD JD', 'Základ pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', NULL, NULL, NULL, NULL, NULL, true, 150, 0.000000, 0.065000, 1.000000, 0.000000, 'zaklMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.plus', 1, 223, 221, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (83, '2009-11-23 18:31:46.984', '9', '---- Základ pro sociální pojištění  (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 162, 0.000000, 0.065000, 1.000000, 0.000000, 'zaklMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 95, 201, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (86, '2009-11-24 18:31:18.75', 'SOC.POJ.FIRMA PRAC.', 'Soc. pojištění - Firma - důchodové  (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 163, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 102, 99, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (82, '2009-11-23 18:31:47.171', '9', '---- Základ pro sociální pojištění  (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 161, 0.000000, 0.012000, 1.000000, 0.000000, 'zaklMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 101, 201, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (81, '2009-11-23 18:31:47.375', '9', '---- Základ pro sociální pojištění  (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 160, 0.000000, 0.023000, 1.000000, 0.000000, 'zaklMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 100, 201, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (251, '2009-11-23 18:31:48.578', '9**', '---- Suma sociálky za minulé měsíce', NULL, NULL, NULL, NULL, NULL, true, 154, 0.000000, 1.000000, 0.000000, 0.000000, 'zaklMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 199, 201, false, 'mzdCalcSuma.rokPred', 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (313, '2009-11-23 18:31:48.781', 'SOC.ZÁKL.SLE.SUM', 'Základ pro sociální pojištění  (pro všechny pracovní poměry) ', NULL, NULL, NULL, NULL, NULL, true, 153, 0.000000, 1.000000, 1.000000, 0.000000, 'zaklMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 220, 219, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (312, '2009-11-23 18:31:48.968', 'SOC.ZÁKL.SLE', '----- *', NULL, NULL, NULL, NULL, NULL, true, 152, 0.000000, 1.000000, 1.000000, 0.000000, 'zaklMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 219, 162, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (119, '2009-11-23 18:31:49.171', '9', '----- *', NULL, NULL, NULL, NULL, NULL, true, 151, 0.000000, 1.000000, 1.000000, 0.000000, 'zaklMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 94, 162, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (321, '2009-11-23 18:31:49.562', 'SOC.FIR.DŮCHOD JD', 'Základ pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', NULL, NULL, NULL, NULL, NULL, true, 149, 0.000000, 0.215000, 1.000000, 0.000000, 'zaklMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 222, 221, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (324, '2009-11-23 18:31:49.765', 'SOC.ZÁKLAD JEN DP', '----- Sociální pojištění - oprava základu', NULL, NULL, NULL, NULL, NULL, true, 148, 0.000000, 1.000000, 1.000000, 0.000000, 'zaklMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 221, 164, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (323, '2009-11-23 18:31:49.984', 'SOC.ZÁKLAD JEN DP', '----- Nepatří do základu pro sociální pojištění', NULL, NULL, NULL, NULL, NULL, true, 147, 0.000000, -1.000000, 1.000000, 0.000000, 'castMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 221, 155, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (121, '2009-11-23 18:31:50.375', '9', '----- Sociální pojištění - oprava základu', NULL, NULL, NULL, NULL, NULL, true, 145, 0.000000, 1.000000, 1.000000, 0.000000, 'zaklMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 162, 164, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (78, '2009-11-23 18:31:50.578', '9', '----- Nepatří do základu pro sociální pojištění', NULL, NULL, NULL, NULL, NULL, true, 144, 0.000000, -1.000000, 1.000000, 0.000000, 'castMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 162, 155, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (76, '2009-11-23 18:31:50.765', 'SOC.ZÁKLAD STD', 'Výpočet sociálky', NULL, NULL, NULL, NULL, NULL, true, 143, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 162, 87, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (133, '2009-11-23 18:31:50.953', '8', 'Hrubá mzda celkem pro všechny pracovní poměry', NULL, NULL, NULL, NULL, NULL, true, 142, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 167, 87, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (69, '2009-11-23 18:31:51.156', '8', '----- Nepatří do základu pro průměrný výdělek', NULL, NULL, NULL, NULL, NULL, true, 141, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 87, 89, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (68, '2009-11-23 18:31:51.343', '8', '----- Základ pro průměrný výdělek', NULL, NULL, NULL, NULL, NULL, true, 140, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 87, 90, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (352, '2009-11-23 18:32:04.671', 'NEPATŘÍ DO ZDR.POJ.', 'Životní pojištění osvobozeno', NULL, NULL, NULL, NULL, NULL, true, 127, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 154, 66, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (71, '2009-11-23 18:31:52.75', '8', '----- Penzijní připojištění osvobozeno', NULL, NULL, NULL, NULL, NULL, true, 133, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 155, 64, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (342, '2009-11-23 18:31:53.546', '88888888888888888888', 'Odstupné, odchodné, odbytné', NULL, NULL, NULL, NULL, NULL, true, 129, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 154, 44, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (75, '2009-11-23 18:31:53.75', '8', 'Odměna podle zákona o vynálezech a ZN', NULL, NULL, NULL, NULL, NULL, true, 128, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 154, 30, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (72, '2009-11-23 18:32:04.671', '8', '----- Penzijní připojištění osvobozeno', NULL, NULL, NULL, NULL, NULL, true, 126, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 154, 64, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (354, '2009-11-25 20:16:16.781', 'SOC.POJ.CELKEM', 'Refundace náhrady mzdy na pracovníka', NULL, NULL, NULL, NULL, NULL, true, 279, 0.000000, -1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 217, 178, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (222, '2009-11-25 20:16:21.093', 'DOVOLENÁ', 'Dovolená', NULL, NULL, NULL, 'sumaa odpracované doby za minulé čtvrtletí', NULL, true, 264, 0.000000, 1.000000, 1.000000, 0.000000, 'dnyPrac', 'dnyPrac', NULL, NULL, 'mzdCalcOper.plus', 1, 186, 184, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (229, '2009-11-25 20:16:21.578', '16', '----- Hodiny x průměr PP = částka dovolené ', NULL, NULL, NULL, '', NULL, true, 262, 0.000000, 1.000000, 0.000000, 0.000000, 'hodiny', 'castMzd', NULL, NULL, 'mzdCalcOper.krat', 1, 2, 2, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (256, '2009-11-25 20:16:20.875', '16', '----- Přičtení aktuálního měsíce', NULL, NULL, NULL, 'sumaa odpracované doby za minulé čtvrtletí', NULL, true, 265, 0.000000, 1.000000, 1.000000, 0.000000, 'dnyPrac', 'dnyPrac', NULL, NULL, 'mzdCalcOper.plus', 1, 185, 2, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (235, '2009-11-25 20:16:21.375', '16', '----- Zaokrouhlení na koruny nahoru', NULL, NULL, NULL, '', NULL, true, 263, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.plus', 1, 2, 2, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (225, '2009-11-25 20:16:21.875', '16', '----- Přesunutí průměru do částky dovolené', NULL, NULL, NULL, '', NULL, true, 261, 0.000000, 1.000000, 1.000000, 0.000000, 'prumNaHodNem;prumNaHodNem', 'castMzd;prumNaHodNem', NULL, NULL, 'mzdCalcOper.plus', 1, 2, 172, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (214, '2009-11-25 20:16:22.515', '15', '----- Náhrada mzdy za karanténu', NULL, NULL, NULL, NULL, NULL, true, 258, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 140, 171, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (333, '2009-11-25 20:16:22.937', 'NÁHR.KARANTÉNA 4-10', '...', NULL, NULL, NULL, NULL, NULL, true, 256, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.krat', 1, 177, 177, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (195, '2009-11-25 20:16:25.765', 'NÁHRADY ZA NEMOC', '----- Přesun redukovaného PPP do  výpočtu náhrady za nemoc', NULL, NULL, NULL, NULL, NULL, true, 244, 0.000000, 1.000000, 0.000000, 0.000000, 'prumNaHodNem', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 70, 176, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (175, '2009-11-25 20:16:25.984', '15', '-----', NULL, NULL, NULL, NULL, NULL, true, 243, 0.000000, 1.000000, 1.000000, 0.000000, 'prumNaHodNem', 'prumNaHodNem', NULL, NULL, 'mzdCalcOper.plus', 1, 176, 175, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (174, '2009-11-25 20:16:26.187', '15', '-----', NULL, NULL, NULL, NULL, NULL, true, 242, 0.000000, 1.000000, 1.000000, 0.000000, 'prumNaHodNem', 'prumNaHodNem', NULL, NULL, 'mzdCalcOper.plus', 1, 176, 174, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (307, '2009-11-25 20:16:17.281', 'SOC.POJ.CELKEM', 'Soc. pojištění - pracovník  ', NULL, NULL, NULL, NULL, NULL, true, 278, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 217, 98, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (308, '2009-11-25 20:16:17.625', 'SOC.POJ.CELKEM', 'Sociální pojištění - firma / zaměstnavatel', NULL, NULL, NULL, NULL, NULL, true, 277, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 217, 229, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (223, '2009-11-25 20:16:20.656', '16', '----- Počáteční satv dovolené - vybráno od začátku roku', NULL, NULL, NULL, 'sumaa odpracované doby za minulé čtvrtletí', NULL, true, 266, 0.000000, -1.000000, 1.000000, 0.000000, 'dnyPrac', 'dnyPrac', NULL, NULL, 'mzdCalcOper.plus', 1, 186, 185, true, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (359, '2009-11-25 20:16:17.984', 'SOC.POJ.FIRMA ', 'Zaokrouhlení sociálního pojištění firmy / zaměstnavatele', NULL, NULL, NULL, NULL, NULL, true, 276, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 229, 181, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (358, '2009-11-25 20:16:18.265', 'SOC.POJ.FIRMA ', 'Sociální pojištění - firma / zaměstnavatel', NULL, NULL, NULL, NULL, NULL, true, 275, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 229, 102, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (173, '2009-11-25 20:16:26.406', '15', '----- Sumace redukčních hranic', NULL, NULL, NULL, NULL, NULL, true, 241, 0.000000, 1.000000, 1.000000, 0.000000, 'prumNaHodNem', 'prumNaHodNem', NULL, NULL, 'mzdCalcOper.plus', 1, 176, 173, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (172, '2009-11-25 20:16:26.625', '15', '----- 3. redukční hranice', NULL, NULL, NULL, NULL, NULL, true, 240, 412.300000, 0.300000, 1.000000, 206.150000, 'prumNaHodNem', 'prumNaHodNem', NULL, NULL, 'mzdCalcOper.plus', 1, 175, 172, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (194, '2009-11-25 20:16:26.843', '15', '----- 2. redukční hranice', NULL, NULL, NULL, NULL, NULL, true, 239, 206.150000, 0.600000, 1.000000, 137.550000, 'prumNaHodNem', 'prumNaHodNem', NULL, NULL, 'mzdCalcOper.plus', 1, 174, 172, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (193, '2009-11-25 20:16:27.14', 'REDUKOVANÝ PRŮMĚR', '----- Výpočet redukovaného průměru pro náhradu za nemoc - 1. redukční hranice', NULL, NULL, NULL, NULL, NULL, true, 238, 137.550000, 0.900000, 1.000000, 0.000000, 'prumNaHodNem', 'prumNaHodNem', NULL, NULL, 'mzdCalcOper.plus', 1, 173, 172, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (239, '2009-11-25 20:16:32.968', '11', 'Bonus', NULL, NULL, NULL, NULL, NULL, true, 212, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 109, 189, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (111, '2009-11-25 20:16:33.187', '11', '----- Odpočet celkové slevy na dani', NULL, NULL, NULL, NULL, NULL, true, 211, 0.000000, -1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 118, 117, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (125, '2009-11-25 20:16:38.703', '11', '----- Vypočtená daň', NULL, NULL, NULL, NULL, NULL, true, 210, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 118, 108, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (136, '2009-11-25 20:16:39.312', '11', '----- Sleva - Dítě', NULL, NULL, NULL, NULL, NULL, true, 209, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 189, 116, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (110, '2009-11-25 20:16:39.921', '11', '----- Oprava slevy na dani celkem', NULL, NULL, NULL, NULL, NULL, true, 208, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 117, 81, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (227, '2009-11-25 20:16:32.687', '11', '----- Je-li daň záporná - vynuluje se', NULL, NULL, NULL, NULL, NULL, true, 213, 9999999999999.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 118, 118, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (109, '2009-11-25 20:16:40.562', '11', '----- Sleva - Držitel průkaz ZTP-P', NULL, NULL, NULL, NULL, NULL, true, 207, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 117, 113, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (108, '2009-11-25 20:16:41.078', '11', '----- Sleva - Osoba, za kterou platí zdrav. pojištění stát', NULL, NULL, NULL, NULL, NULL, true, 206, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 117, 115, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (107, '2009-11-25 20:16:41.437', '11', '----- Sleva - Student připravující se na budoucí povolání', NULL, NULL, NULL, NULL, NULL, true, 205, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 117, 114, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (106, '2009-11-25 20:16:41.796', '11', '----- Sleva - poplatníka', NULL, NULL, NULL, NULL, NULL, true, 204, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 117, 110, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (104, '2009-11-25 20:16:42.187', '11', '----- Základ pro výpočet daně', NULL, NULL, NULL, NULL, NULL, true, 203, 0.000000, 0.150000, 0.000000, 0.000000, 'zaklMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.plus', 1, 108, 107, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (353, '2009-11-25 20:16:42.531', '11', 'Základ pro výpočet daně - superhubá mzda', NULL, NULL, NULL, NULL, NULL, true, 202, 0.000000, 1.000000, 0.000000, 0.000000, 'zaklMzd', 'zaklMzd', 'zaokrJak.nahoru', 'zaokrNa.stovky', 'mzdCalcOper.plus', 1, 107, 107, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (131, '2009-11-25 20:16:42.812', '11', '----- Zdrav. pojištění - zaměstnavatel', NULL, NULL, NULL, NULL, NULL, true, 201, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 107, 104, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (356, '2009-11-25 20:16:32', 'BONUS -', '----- záporný bonus', NULL, NULL, NULL, NULL, NULL, true, 216, 0.000000, -1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 228, 109, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (240, '2009-11-25 20:16:32.203', '11', '----- Omezení rozsahu bonusu na 100 - 4350 Kč', NULL, NULL, NULL, NULL, NULL, true, 215, 4350.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 109, 109, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (238, '2009-11-25 20:16:32.421', '11', '----- Přesunu výslednou daň do daňového bonusu', NULL, NULL, NULL, NULL, NULL, true, 214, 0.000000, -1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 109, 118, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (327, '2009-11-23 18:52:48.234', '9', 'Základ pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', NULL, NULL, NULL, NULL, NULL, true, 180, 0.000000, 1.000000, 1.000000, 0.000000, 'zaklMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 94, 221, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (242, '2009-11-25 20:16:31.562', '11', '----- Y / X', NULL, NULL, NULL, NULL, NULL, true, 218, 0.000000, 1.000000, 0.000000, 0.000000, 'zaklMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.lomeno', 1, 190, 190, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (316, '2009-11-23 18:31:44.437', '11', 'Koeficient pro nulování ', NULL, NULL, NULL, NULL, NULL, true, 175, 0.000000, 1.000000, 0.000000, 0.000000, 'zaklMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.lomeno', 1, 190, 190, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (320, '2009-11-23 18:31:50.187', 'SOC.ZÁKLAD JEN DP', 'Hrubá mzda celkem', NULL, NULL, NULL, NULL, NULL, true, 146, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 221, 87, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (331, '2009-11-25 20:16:18.625', 'NÁHR.NEMOC CELKEM', 'Náhrada mzdy za nemoc - 4 až 10 den', NULL, NULL, NULL, NULL, NULL, true, 274, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 226, 70, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (330, '2009-11-25 20:16:18.937', 'NÁHR.NEMOC CELKEM', 'Náhrada mzdy za nemoc  první 3 dny', NULL, NULL, NULL, NULL, NULL, true, 273, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 226, 69, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (329, '2009-11-25 20:16:19.156', 'NÁHR.NEMOC CELKEM', 'Náhrada mzdy za karanténu - 4 až 10 den', NULL, NULL, NULL, NULL, NULL, true, 272, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 226, 177, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (328, '2009-11-25 20:16:19.453', 'NÁHR.NEMOC CELKEM', 'Náhrada mzdy za karanténu první 3 dny', NULL, NULL, NULL, NULL, NULL, true, 271, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 226, 171, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (311, '2009-11-25 20:16:19.656', 'ZDR.POJ.CELKEM', 'Zdrav. pojištění - zaměstnavatel', NULL, NULL, NULL, NULL, NULL, true, 270, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 218, 104, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (310, '2009-11-25 20:16:19.875', 'ZDR.POJ.CELKEM', 'Zdrav. pojištění - pracovník', NULL, NULL, NULL, NULL, NULL, true, 269, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 218, 103, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (207, '2009-11-25 20:16:23.234', 'SOC.POJ.CELKEM', '...', NULL, NULL, NULL, NULL, NULL, true, 255, 9999999999999.900000, -1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 217, 178, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (62, '2009-11-23 10:33:16.125', '6', '----- Peněž dar z FKSP', NULL, NULL, NULL, NULL, NULL, true, 116, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 89, 55, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (61, '2009-11-23 10:33:16.312', '6', '----- 1%  vstupní ceny vozu ', NULL, NULL, NULL, NULL, NULL, true, 115, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 89, 54, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (65, '2009-11-23 18:24:40.734', '6', '----- Penzijní připojištění Skupina.Dan - Daněno', NULL, NULL, NULL, NULL, NULL, true, 119, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 89, 65, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (66, '2009-11-23 18:24:40.953', '6', '----- Životní pojištění osvobozeno', NULL, NULL, NULL, NULL, NULL, true, 120, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 89, 66, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (67, '2009-11-23 18:24:41.484', '6', '----- Životní pojištění Skupina.Dan - Daněno', NULL, NULL, NULL, NULL, NULL, true, 121, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 89, 67, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (116, '2009-11-23 18:24:41.765', '6', 'Naturálni mzda', NULL, NULL, NULL, NULL, NULL, true, 122, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 156, 56, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (115, '2009-11-23 18:24:42.14', '7', '----- 1%  vstupní ceny vozu ', NULL, NULL, NULL, NULL, NULL, true, 123, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 156, 54, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (57, '2009-11-23 10:33:16.953', '6', '----- Doplatek do minimální mzdy', NULL, NULL, NULL, NULL, NULL, true, 112, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 89, 50, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (56, '2009-11-23 10:33:17.14', '6', '----- Doplatek do průměrného výdělku', NULL, NULL, NULL, NULL, NULL, true, 111, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 89, 49, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (55, '2009-11-23 10:33:17.328', '6', '----- Srážka za přečerpanou dovolenou', NULL, NULL, NULL, NULL, NULL, true, 110, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 89, 48, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (54, '2009-11-23 10:33:17.562', '6', '----- Proplacení nevyčerpané dovolené', NULL, NULL, NULL, NULL, NULL, true, 109, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 89, 47, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (53, '2009-11-23 10:33:17.75', '6', '----- Cestovní náhrady nadlimit', NULL, NULL, NULL, NULL, NULL, true, 108, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 89, 46, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (31, '2009-11-23 10:33:17.953', '6', '----- Odměna k živ, prac. jubileu, odchodu do důch.', NULL, NULL, NULL, NULL, NULL, true, 107, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 89, 29, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (52, '2009-11-23 10:33:18.14', '6', '----- Cestovní náhrady do limit', NULL, NULL, NULL, NULL, NULL, true, 106, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 89, 45, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (47, '2009-11-23 10:33:19.468', '5', '----- Příplatek za vedení a zastupování', NULL, NULL, NULL, NULL, NULL, true, 100, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 42, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (49, '2009-11-23 10:33:22.187', '5', '----- Zvláštní příplatek', NULL, NULL, NULL, NULL, NULL, true, 98, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 40, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (60, '2009-11-23 10:33:16.515', '6', '----- Vyrovnávací příspěvěk v těhotenství a mateřství', NULL, NULL, NULL, NULL, NULL, true, 114, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 89, 53, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (59, '2009-11-23 10:33:16.734', '6', '----- Jednorázová sociální výpomoc', NULL, NULL, NULL, NULL, NULL, true, 113, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 89, 52, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (51, '2009-11-23 10:33:18.343', '6', '----- Odstupné, odchodné, odbytné', NULL, NULL, NULL, NULL, NULL, true, 105, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 89, 44, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (58, '2009-11-23 10:33:18.531', '6', '----- Náhrada škod podle zákoníku práce', NULL, NULL, NULL, NULL, NULL, true, 104, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 89, 51, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (27, '2009-11-23 10:33:18.734', '6', '----- Odměna členů statutárního orgánu-nerezident', NULL, NULL, NULL, NULL, NULL, true, 103, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 89, 32, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (50, '2009-11-23 10:33:18.968', '6', '----- 1%  vstupní ceny vozu ', NULL, NULL, NULL, NULL, NULL, true, 102, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 89, 54, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (29, '2009-11-23 10:33:19.265', '6', 'NEpatří do základu pro výpočet pracocně právního průměru - Odměna členů statutárního orgánu', NULL, NULL, NULL, NULL, NULL, true, 101, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 89, 31, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (45, '2009-11-23 10:33:19.656', '5', '----- Příplatek za rozdělenou směnu', NULL, NULL, NULL, NULL, NULL, true, 99, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 37, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (44, '2009-11-23 10:33:26.187', '5', '----- Příplatek za práci ve stíženém prac. prostředí', NULL, NULL, NULL, NULL, NULL, true, 96, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 35, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (305, '2009-11-23 10:33:26.437', 'PŘÍPL.PROSTŘEDÍ', 'Příplatek za práci ve stíženém prac. prostředí', NULL, NULL, NULL, NULL, NULL, true, 95, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.plus', 1, 35, 35, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (292, '2009-11-23 10:33:26.656', '5', '--------  výpočet příplatku', NULL, NULL, NULL, NULL, NULL, true, 94, 0.000000, 1.000000, 0.000000, 0.000000, 'hodiny', 'castMzd', NULL, NULL, 'mzdCalcOper.krat', 1, 35, 35, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (291, '2009-11-23 10:33:26.89', '5', '--------  výpočet příplatku', NULL, NULL, NULL, NULL, NULL, true, 93, 0.000000, 1.000000, 0.000000, 0.000000, 'castkaHod', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 35, 35, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (297, '2009-11-23 10:33:27.125', '5', 'Odměna za pracovní pohotovost mimo pracoviště', NULL, NULL, NULL, NULL, NULL, true, 92, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 205, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (301, '2009-11-23 10:33:27.328', 'POHOTOVOST MIMO', 'Odměna za pracovní pohotovost mimo pracoviště', NULL, NULL, NULL, NULL, NULL, true, 91, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.plus', 1, 205, 205, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (296, '2009-11-23 10:33:27.546', '5', '--------  výpočet příplatku', NULL, NULL, NULL, NULL, NULL, true, 90, 0.000000, 1.000000, 0.000000, 0.000000, 'hodiny', 'castMzd', NULL, NULL, 'mzdCalcOper.krat', 1, 205, 205, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (295, '2009-11-23 10:33:27.781', '5', '--------  výpočet příplatku', NULL, NULL, NULL, NULL, NULL, true, 89, 0.000000, 1.000000, 0.000000, 0.000000, 'castkaHod', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 205, 205, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (43, '2009-11-23 10:33:28.015', '5', '----- Odměna za pracovní pohotovost', NULL, NULL, NULL, NULL, NULL, true, 88, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 39, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (306, '2009-11-23 10:33:28.203', 'POHOTOVOST', 'Odměna za pracovní pohotovost', NULL, NULL, NULL, NULL, NULL, true, 87, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.plus', 1, 39, 39, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (294, '2009-11-23 10:33:28.437', '5', '--------  výpočet příplatku', NULL, NULL, NULL, NULL, NULL, true, 86, 0.000000, 1.000000, 0.000000, 0.000000, 'hodiny', 'castMzd', NULL, NULL, 'mzdCalcOper.krat', 1, 39, 39, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (293, '2009-11-23 10:33:28.625', '5', '--------  výpočet příplatku', NULL, NULL, NULL, NULL, NULL, true, 85, 0.000000, 1.000000, 0.000000, 0.000000, 'castkaHod', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 39, 39, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (41, '2009-11-23 10:33:28.828', '5', '----- Příplatek za noční práci', NULL, NULL, NULL, NULL, NULL, true, 84, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 36, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (281, '2009-11-23 10:33:33.062', '5', '-------  PPP do částky za hodinu', NULL, NULL, NULL, 'suma odpracované doby za minulé čtvrtletí', NULL, true, 64, 0.000000, 1.000000, 0.000000, 0.000000, 'prumNaHodNem', 'castkaHod', NULL, NULL, 'mzdCalcOper.plus', 1, 38, 172, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (275, '2009-11-23 10:33:33.25', '5', '----- Příplatek za práci přesčas', NULL, NULL, NULL, NULL, NULL, true, 63, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 216, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (300, '2009-11-23 10:33:33.453', 'PŘÍPL.PŘESČAS', 'Příplatek za práci přesčas', NULL, NULL, NULL, NULL, NULL, true, 62, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.plus', 1, 216, 216, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (280, '2009-11-23 10:33:33.671', '5', '-------  Procenta  *  základ = výsledek', NULL, NULL, NULL, 'suma odpracované doby za minulé čtvrtletí', NULL, true, 61, 0.000000, 1.000000, 0.000000, 0.000000, 'procMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.krat', 1, 216, 216, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (279, '2009-11-23 10:33:33.906', '5', '-------  Základ do výsledku', NULL, NULL, NULL, 'suma odpracované doby za minulé čtvrtletí', NULL, true, 60, 0.000000, 1.000000, 0.000000, 0.000000, 'zaklMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 216, 216, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (276, '2009-11-23 10:33:34.50', '5', '-------  PPP do částky za hodinu', NULL, NULL, NULL, 'suma odpracované doby za minulé čtvrtletí', NULL, true, 57, 0.000000, 1.000000, 0.000000, 0.000000, 'prumNaHodNem', 'castkaHod', NULL, NULL, 'mzdCalcOper.plus', 1, 216, 172, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (35, '2009-11-23 10:33:35.50', '5', '----- Ostatní odměny', NULL, NULL, NULL, NULL, NULL, true, 52, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 33, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (298, '2009-11-23 10:33:39.50', '4 ******************', '----- Zaokrouhlení vypočtené měsíční mzdy', NULL, NULL, NULL, NULL, NULL, true, 32, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.plus', 1, 17, 17, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (212, '2009-11-23 10:33:39.687', '4', '----- Zaokrouhlení vypočtené měsíční mzdy', NULL, NULL, NULL, NULL, NULL, true, 31, 0.000000, 1.000000, 0.000000, 0.000000, 'zaklMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.krat', 1, 17, 17, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (211, '2009-11-23 10:33:39.89', 'POMĚR.MĚSÍČNÍ MZDA', '----- Vynásobení měsíční mzdy koeficientem ', NULL, NULL, NULL, NULL, NULL, true, 30, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 17, 188, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (6, '2009-11-23 10:33:40.078', ' ODPRACOVÁNO - SUM', '----- Náhráda za svátek  do odpracované doby', NULL, NULL, NULL, NULL, NULL, true, 29, 0.000000, 1.000000, 1.000000, 0.000000, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', NULL, NULL, 'mzdCalcOper.plus', 1, 63, 21, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (5, '2009-11-23 10:33:40.312', '3', '----- Úkolová mzda  do odpracované doby', NULL, NULL, NULL, NULL, NULL, true, 28, 0.000000, 1.000000, 1.000000, 0.000000, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', NULL, NULL, 'mzdCalcOper.plus', 1, 63, 19, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (219, '2009-11-23 10:33:45.046', '14', '----- Odpracovaná doba celkem za čtvrtletí', NULL, NULL, NULL, 'sumaa odpracované doby za minulé čtvrtletí', NULL, true, 22, 0.000000, 1.000000, 1.000000, 0.000000, 'hodiny;hodiny', 'prumNaHodNem;hodiny', NULL, NULL, 'mzdCalcOper.plus', 1, 172, 183, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (218, '2009-11-23 10:33:45.296', '14', '----- Čtvrtletní suma základu pro průměrný výdělek', NULL, NULL, NULL, 'sumaa odpracované doby za minulé čtvrtletí', NULL, true, 21, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 172, 182, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (216, '2009-11-23 10:33:45.531', '14', '----- Odpracovaná doba za minulé čtvrtletí', NULL, NULL, NULL, '', NULL, true, 20, 0.000000, 1.000000, 0.000000, 0.000000, 'hodiny', 'hodiny', NULL, NULL, 'mzdCalcOper.plus', 1, 183, 179, false, 'mzdCalcSuma.obdobi', 3);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (217, '2009-11-23 10:33:45.812', 'PRAC.PRÁVNÍ PRŮMER', '----- Suma základu pro průměrný výdělek za minulé čtvrtletí', NULL, NULL, NULL, '', NULL, true, 19, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 182, 90, false, 'mzdCalcSuma.obdobi', 3);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (234, '2009-11-23 10:33:46.046', 'KOEF. =  ODPR./ FOND', '----- Koeficient pro poměrnou část měsíční mzdy - Co zbývá na měsíční mzdu / fondem pracovní doby', NULL, NULL, NULL, NULL, NULL, true, 18, 0.000000, 1.000000, 0.000000, 0.000000, 'hodiny', 'castMzd', NULL, NULL, 'mzdCalcOper.lomeno', 1, 188, 188, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (226, '2009-11-23 10:33:46.234', '2', '----- Kopírování  fondu doby pro měsíční mzdu', NULL, NULL, NULL, NULL, NULL, true, 17, 0.000000, 1.000000, 0.000000, 0.000000, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', NULL, NULL, 'mzdCalcOper.plus', 1, 17, 188, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (42, '2009-11-23 10:33:25.734', '5', '----- Osobní příplatek', NULL, NULL, NULL, NULL, NULL, true, 97, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 41, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (303, '2009-11-23 10:33:29.093', 'PŘÍPL.NOC', 'Příplatek za noční práci', NULL, NULL, NULL, NULL, NULL, true, 83, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.plus', 1, 36, 36, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (274, '2009-11-23 10:33:29.281', '5', '-------  Procenta  *  základ = výsledek', NULL, NULL, NULL, 'suma odpracované doby za minulé čtvrtletí', NULL, true, 82, 0.000000, 1.000000, 0.000000, 0.000000, 'procMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.krat', 1, 36, 36, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (273, '2009-11-23 10:33:29.468', '5', '-------  Základ do výsledku', NULL, NULL, NULL, 'suma odpracované doby za minulé čtvrtletí', NULL, true, 81, 0.000000, 1.000000, 0.000000, 0.000000, 'zaklMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 36, 36, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (272, '2009-11-23 10:33:29.703', '5', '-------  hodiny  *  průměr =  základ', NULL, NULL, NULL, 'suma odpracované doby za minulé čtvrtletí', NULL, true, 80, 0.000000, 1.000000, 0.000000, 0.000000, 'castkaHod', 'zaklMzd', NULL, NULL, 'mzdCalcOper.krat', 1, 36, 36, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (271, '2009-11-23 10:33:29.937', '5', '-------  hodiny do základu', NULL, NULL, NULL, 'suma odpracované doby za minulé čtvrtletí', NULL, true, 79, 0.000000, 1.000000, 0.000000, 0.000000, 'hodiny', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 36, 36, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (265, '2009-11-23 10:33:30.125', '5', '-------  PPP do částky za hodinu', NULL, NULL, NULL, 'suma odpracované doby za minulé čtvrtletí', NULL, true, 78, 0.000000, 1.000000, 0.000000, 0.000000, 'prumNaHodNem', 'castkaHod', NULL, NULL, 'mzdCalcOper.plus', 1, 36, 172, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (48, '2009-11-23 10:33:30.328', '5', '----- Příplatek za práci v sobotu a neděli', NULL, NULL, NULL, NULL, NULL, true, 77, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 34, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (299, '2009-11-23 10:33:30.546', 'PŘÍPL.WEEKEND', '222', NULL, NULL, NULL, NULL, NULL, true, 76, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.plus', 1, 34, 34, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (290, '2009-11-23 10:33:30.75', '5', '-------  Procenta  *  základ = výsledek', NULL, NULL, NULL, 'suma odpracované doby za minulé čtvrtletí', NULL, true, 75, 0.000000, 1.000000, 0.000000, 0.000000, 'procMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.krat', 1, 34, 34, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (289, '2009-11-23 10:33:30.984', '5', '-------  Základ do výsledku', NULL, NULL, NULL, 'suma odpracované doby za minulé čtvrtletí', NULL, true, 74, 0.000000, 1.000000, 0.000000, 0.000000, 'zaklMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 34, 34, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (288, '2009-11-23 10:33:31.171', '5', '-------  hodiny  *  průměr =  základ', NULL, NULL, NULL, 'suma odpracované doby za minulé čtvrtletí', NULL, true, 73, 0.000000, 1.000000, 0.000000, 0.000000, 'castkaHod', 'zaklMzd', NULL, NULL, 'mzdCalcOper.krat', 1, 34, 34, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (287, '2009-11-23 10:33:31.406', '5', '-------  hodiny do základu', NULL, NULL, NULL, 'suma odpracované doby za minulé čtvrtletí', NULL, true, 72, 0.000000, 1.000000, 0.000000, 0.000000, 'hodiny', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 34, 34, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (286, '2009-11-23 10:33:31.593', '5', '-------  PPP do částky za hodinu', NULL, NULL, NULL, 'suma odpracované doby za minulé čtvrtletí', NULL, true, 71, 0.000000, 1.000000, 0.000000, 0.000000, 'prumNaHodNem', 'castkaHod', NULL, NULL, 'mzdCalcOper.plus', 1, 34, 172, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (46, '2009-11-23 10:33:31.796', '5', '----- Příplatek za svátek', NULL, NULL, NULL, NULL, NULL, true, 70, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 38, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (304, '2009-11-23 10:33:32.015', 'PŘIPL.SVÁTEK', 'Příplatek za svátek', NULL, NULL, NULL, NULL, NULL, true, 69, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.plus', 1, 38, 38, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (285, '2009-11-23 10:33:32.25', '5', '-------  Procenta  *  základ = výsledek', NULL, NULL, NULL, 'suma odpracované doby za minulé čtvrtletí', NULL, true, 68, 0.000000, 1.000000, 0.000000, 0.000000, 'procMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.krat', 1, 38, 38, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (284, '2009-11-23 10:33:32.484', '5', '-------  Základ do výsledku', NULL, NULL, NULL, 'suma odpracované doby za minulé čtvrtletí', NULL, true, 67, 0.000000, 1.000000, 0.000000, 0.000000, 'zaklMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 38, 38, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (283, '2009-11-23 10:33:32.671', '5', '-------  hodiny  *  průměr =  základ', NULL, NULL, NULL, 'suma odpracované doby za minulé čtvrtletí', NULL, true, 66, 0.000000, 1.000000, 0.000000, 0.000000, 'castkaHod', 'zaklMzd', NULL, NULL, 'mzdCalcOper.krat', 1, 38, 38, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (282, '2009-11-23 10:33:32.859', '5', '-------  hodiny do základu', NULL, NULL, NULL, 'suma odpracované doby za minulé čtvrtletí', NULL, true, 65, 0.000000, 1.000000, 0.000000, 0.000000, 'hodiny', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 38, 38, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (278, '2009-11-23 10:33:34.109', '5', '-------  hodiny  *  průměr =  základ', NULL, NULL, NULL, 'suma odpracované doby za minulé čtvrtletí', NULL, true, 59, 0.000000, 1.000000, 0.000000, 0.000000, 'castkaHod', 'zaklMzd', NULL, NULL, 'mzdCalcOper.krat', 1, 216, 216, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (277, '2009-11-23 10:33:34.312', '5', '-------  hodiny do základu', NULL, NULL, NULL, 'suma odpracované doby za minulé čtvrtletí', NULL, true, 58, 0.000000, 1.000000, 0.000000, 0.000000, 'hodiny', 'zaklMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 216, 216, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (40, '2009-11-23 10:33:34.703', '5', '----- Prémie % z ukazatele - základu ', NULL, NULL, NULL, NULL, NULL, true, 56, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 27, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (39, '2009-11-23 10:33:34.89', '5', '----- Prémie % ze základní mzdy', NULL, NULL, NULL, NULL, NULL, true, 55, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 25, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (38, '2009-11-23 10:33:35.078', '5', '----- Podíly % ze zisku - základu ', NULL, NULL, NULL, NULL, NULL, true, 54, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 28, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (37, '2009-11-23 10:33:35.312', '5', '----- Prémie pevnou částkou ', NULL, NULL, NULL, NULL, NULL, true, 53, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 26, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (34, '2009-11-23 10:33:35.703', '5', '---- Mzda za práci přesčas', NULL, NULL, NULL, NULL, NULL, true, 51, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 22, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (33, '2009-11-23 10:33:35.89', '5', '----- Mimořádná odměna ', NULL, NULL, NULL, NULL, NULL, true, 50, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 24, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (32, '2009-11-23 10:33:36.093', '5', '----- Odměna podle zákona o vynálezech a ZN', NULL, NULL, NULL, NULL, NULL, true, 49, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 30, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (30, '2009-11-23 10:33:36.281', '5', '----- Odměna členů statutárního orgánu-nerezident', NULL, NULL, NULL, NULL, NULL, true, 48, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 32, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (28, '2009-11-23 10:33:36.468', '5', '----- Prémie % z ukazatele - základu ', NULL, NULL, NULL, NULL, NULL, true, 47, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 27, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (26, '2009-11-23 10:33:36.671', '5', '----- Odměna členů statutárního orgánu', NULL, NULL, NULL, NULL, NULL, true, 46, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 31, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (25, '2009-11-23 10:33:36.906', '5', '----- Prémie % z ukazatele - základu ', NULL, NULL, NULL, NULL, NULL, true, 45, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 27, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (24, '2009-11-23 10:33:37.109', '5', '----- Prémie % ze základní mzdy', NULL, NULL, NULL, NULL, NULL, true, 44, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 25, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (23, '2009-11-23 10:33:37.296', '5', '----- Podíly % ze zisku - základu ', NULL, NULL, NULL, NULL, NULL, true, 43, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 28, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (21, '2009-11-23 10:33:37.50', '5', '----- Mimořádná odměna ', NULL, NULL, NULL, NULL, NULL, true, 42, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 24, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (11, '2009-11-23 10:33:37.687', '5', '----- Měsíční odměna', NULL, NULL, NULL, NULL, NULL, true, 41, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 23, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (10, '2009-11-23 10:33:37.89', '5', '----- Mimořádná odměna ', NULL, NULL, NULL, NULL, NULL, true, 40, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 24, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (9, '2009-11-23 10:33:38.078', '5', '----- Podílová (provizní) mzda', NULL, NULL, NULL, NULL, NULL, true, 39, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 20, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (7, '2009-11-23 10:33:38.265', '5', '----- Časová (hodinová) mzda', NULL, NULL, NULL, NULL, NULL, true, 38, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 18, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (8, '2009-11-23 10:33:38.50', 'HRUBÁ MZDA', 'Patří do základu pro výpočet pracocně právního průměru', NULL, NULL, NULL, NULL, NULL, true, 37, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 90, 17, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (338, '2009-11-23 10:33:38.718', '**** 4', 'Časová (hodinová) mzda', NULL, NULL, NULL, NULL, NULL, true, 36, 0.000000, 1.000000, 0.000000, 0.000000, 'castMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'mzdCalcOper.plus', 1, 18, 18, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (339, '2009-11-23 10:33:38.921', '**** 3', '----- Násobení hodin a hodinové sazby', NULL, NULL, NULL, NULL, NULL, true, 35, 0.000000, 1.000000, 0.000000, 0.000000, 'castkaHod', 'castMzd', NULL, NULL, 'mzdCalcOper.krat', 1, 18, 18, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (340, '2009-11-23 10:33:39.109', '**** 2', '----- Kopírování  hodin do základu mzdy', NULL, NULL, NULL, NULL, NULL, true, 34, 0.000000, 1.000000, 0.000000, 0.000000, 'hodiny', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 18, 18, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (336, '2009-11-23 10:33:39.296', '**** 1', '----- Kopírování  fondu doby pro měsíční mzdu', NULL, NULL, NULL, NULL, NULL, true, 33, 0.000000, 1.000000, 0.000000, 0.000000, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', NULL, NULL, 'mzdCalcOper.plus', 1, 18, 188, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (4, '2009-11-23 10:33:40.50', '3', '----- Mzda za práci přesčas  do odpracované doby', NULL, NULL, NULL, NULL, NULL, true, 27, 0.000000, 1.000000, 1.000000, 0.000000, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', NULL, NULL, 'mzdCalcOper.plus', 1, 63, 22, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (1, '2009-11-23 10:33:40.703', '3', '----- Časová (hodinová) mzda do odpracované doby', NULL, NULL, NULL, NULL, NULL, true, 26, 0.000000, 1.000000, 1.000000, 0.000000, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', NULL, NULL, 'mzdCalcOper.plus', 1, 63, 18, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (236, '2009-11-23 10:33:40.921', '3', 'Měsíční mzda (plat)', NULL, NULL, NULL, NULL, NULL, true, 25, 0.000000, 1.000000, 1.000000, 0.000000, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', NULL, NULL, 'mzdCalcOper.plus', 1, 63, 17, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (220, '2009-11-23 10:33:41.109', '14', '----- Inicializace pracovněprávního průměru z hodnot zadaných uživatelem', NULL, NULL, NULL, 'suma odpracované doby za minulé čtvrtletí', NULL, true, 24, 0.000000, 1.000000, 1.000000, 0.000000, 'castkaHod', 'prumNaHodNem', NULL, NULL, 'mzdCalcOper.plus', 1, 172, 195, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (332, '2009-11-23 10:33:41.296', '14', 'Pracovně právní hodinoový průměr pro náhradu mzdy za nemoc, dovolenou ', NULL, NULL, NULL, 'sumaa odpracované doby za minulé čtvrtletí', NULL, true, 23, 0.000000, 1.000000, 1.000000, 0.000000, 'zaklMzd', 'prumNaHodNem', NULL, NULL, 'mzdCalcOper.lomeno', 1, 172, 172, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (181, '2009-11-23 10:33:52.687', '1', '----- Karanténa  do neodpracované doby (čas)', NULL, NULL, NULL, NULL, NULL, true, 3, 0.000000, 1.000000, 1.000000, 0.000000, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', NULL, NULL, 'mzdCalcOper.plus', 1, 16, 12, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (341, '2009-11-23 10:35:02.39', '1', '----- Doba v pracovních dnech před nástupem, který není na začátku měsíce', NULL, NULL, NULL, NULL, NULL, true, 1, 0.000000, 1.000000, 1.000000, 0.000000, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', NULL, NULL, 'mzdCalcOper.plus', 1, 16, 227, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (228, '2009-11-23 10:35:11.296', '1', '----- Dovolená do neodpracované doby (čas)', NULL, NULL, NULL, NULL, NULL, true, 2, 0.000000, 1.000000, 1.000000, 0.000000, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', NULL, NULL, 'mzdCalcOper.plus', 1, 16, 2, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (231, '2009-11-23 10:33:46.468', '2', '----- Výpočetná odpracovaná doba převedna do složky prop výpočet keficientu pro měsíční mzdu', NULL, NULL, NULL, NULL, NULL, true, 16, 0.000000, 1.000000, 0.000000, 0.000000, 'dnyPrac;dnyKal;dnySvatek;hodiny;castMzd', 'dnyPrac;dnyKal;dnySvatek;hodiny;castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 188, 179, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (209, '2009-11-23 10:33:46.671', 'ODPR.DOBA VYPOČ.', '----- Vypočtená odpracovaná doba = od fondu je odečtena  neodpracovaná doba', NULL, NULL, NULL, NULL, NULL, true, 15, 0.000000, -1.000000, 1.000000, 0.000000, 'dnyKal;dnyPrac;dnySvatek;hodiny', 'dnyKal;dnyPrac;dnySvatek;hodiny', NULL, NULL, 'mzdCalcOper.plus', 1, 179, 16, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (208, '2009-11-23 10:33:46.89', '2', 'Začátek výpočtu koeficitntu pro měsíční mzdu - Fond do výpočtu', NULL, NULL, NULL, NULL, NULL, true, 14, 0.000000, 1.000000, 1.000000, 0.000000, 'dnyKal;dnyPrac;dnySvatek;hodiny;hodiny', 'dnyKal;dnyPrac;dnySvatek;hodiny;castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 179, 1, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (192, '2009-11-23 10:33:48.437', 'NEPŘÍTOMNOST - SUM ', '----- Ošetřování člena rodiny  do neodpracované doby (čas)', NULL, NULL, NULL, NULL, NULL, true, 13, 0.000000, 1.000000, 1.000000, 0.000000, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', NULL, NULL, 'mzdCalcOper.plus', 1, 16, 4, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (191, '2009-11-23 10:33:48.703', '1', '----- Důležité osobní překážky v práci  do neodpracované doby (čas)', NULL, NULL, NULL, NULL, NULL, true, 12, 0.000000, 1.000000, 1.000000, 0.000000, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', NULL, NULL, 'mzdCalcOper.plus', 1, 16, 10, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (190, '2009-11-23 10:33:48.984', '1', '----- Volno neplacené  do neodpracované doby (čas)', NULL, NULL, NULL, NULL, NULL, true, 11, 0.000000, 1.000000, 1.000000, 0.000000, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', NULL, NULL, 'mzdCalcOper.plus', 1, 16, 7, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (189, '2009-11-23 10:33:49.218', '1', '----- Volno placené  do neodpracované doby (čas)', NULL, NULL, NULL, NULL, NULL, true, 10, 0.000000, 1.000000, 1.000000, 0.000000, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', NULL, NULL, 'mzdCalcOper.plus', 1, 16, 6, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (188, '2009-11-23 10:33:49.437', '1', '----- Absence neomluvená  do neodpracované doby (čas)', NULL, NULL, NULL, NULL, NULL, true, 9, 0.000000, 1.000000, 1.000000, 0.000000, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', NULL, NULL, 'mzdCalcOper.plus', 1, 16, 5, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (187, '2009-11-23 10:33:49.703', '1', '----- Překážky z důvodů obecného zájmu  do neodpracované doby (čas)', NULL, NULL, NULL, NULL, NULL, true, 8, 0.000000, 1.000000, 1.000000, 0.000000, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', NULL, NULL, 'mzdCalcOper.plus', 1, 16, 11, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (186, '2009-11-23 10:33:49.968', '1', '----- Nemoc z povolání do neodpracované doby (čas)', NULL, NULL, NULL, NULL, NULL, true, 7, 0.000000, 1.000000, 1.000000, 0.000000, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', NULL, NULL, 'mzdCalcOper.plus', 1, 16, 15, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (185, '2009-11-23 10:33:51.968', '1', '----- Nemoc - pracovní úraz  do neodpracované doby (čas)', NULL, NULL, NULL, NULL, NULL, true, 6, 0.000000, 1.000000, 1.000000, 0.000000, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', NULL, NULL, 'mzdCalcOper.plus', 1, 16, 14, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (184, '2009-11-23 10:33:52.218', '1', '----- Nemoc - nepracovní úraz  do neodpracované doby (čas)', NULL, NULL, NULL, NULL, NULL, true, 5, 0.000000, 1.000000, 1.000000, 0.000000, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', NULL, NULL, 'mzdCalcOper.plus', 1, 16, 13, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (183, '2009-11-23 10:33:52.453', '1', '----- Nemoc  do neodpracované doby (čas)', NULL, NULL, NULL, NULL, NULL, true, 4, 0.000000, 1.000000, 1.000000, 0.000000, 'dnyPrac;dnyKal;dnySvatek;hodiny', 'dnyPrac;dnyKal;dnySvatek;hodiny', NULL, NULL, 'mzdCalcOper.plus', 1, 16, 3, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (70, '2009-11-23 18:24:42.484', '8', 'Penzijní připojištění osvobozeno', NULL, NULL, NULL, NULL, NULL, true, 124, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 88, 64, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (73, '2009-11-23 18:24:42.875', '8', '----- Životní pojištění osvobozeno', NULL, NULL, NULL, NULL, NULL, true, 125, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 88, 66, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (63, '2009-11-23 18:24:40.296', '6', '----- Naturálni mzda', NULL, NULL, NULL, NULL, NULL, true, 117, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 89, 56, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (64, '2009-11-23 18:24:40.515', '6', '----- Penzijní připojištění osvobozeno', NULL, NULL, NULL, NULL, NULL, true, 118, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 89, 64, false, NULL, 0);
INSERT INTO pmzdcalc (idmzdcalc, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, dohodnoty, koeficient, koeficient2, odhodnoty, polein, poleout, zaokrjakk, zaokrnak, operacek, idmzdcalchlav, idmzdslozout, idmzdslozin, vyhodnotrocne, sumtypk, summesicu) VALUES (343, '2009-11-23 18:31:53.343', '8', 'Odměna k životnímu, pracobnímu jubileu, odchodu do důchodu', NULL, NULL, NULL, NULL, NULL, true, 130, 0.000000, 1.000000, 1.000000, 0.000000, 'castMzd', 'castMzd', NULL, NULL, 'mzdCalcOper.plus', 1, 154, 29, false, NULL, 0);


INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, cisrad, dohodnoty, koeficient, odhodnoty, polenuluj, poletest, idtyppracpom, idmzdcalchlav, idcismzdsloz, actmaprohl, actmalyroz, actnemaprohl, actvelkyroz) VALUES (4, '2009-11-18 19:37:21.421', '*', 'Nulování sociálky pro zaměstnání malého rozsahu', NULL, NULL, NULL, '', NULL, true, NULL, NULL, 90, 1999.000000, 0.000000, 0.000000, 'zaklMzd', 'zaklMzd', 4, 1, 162, true, true, true, false);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, cisrad, dohodnoty, koeficient, odhodnoty, polenuluj, poletest, idtyppracpom, idmzdcalchlav, idcismzdsloz, actmaprohl, actmalyroz, actnemaprohl, actvelkyroz) VALUES (5, '2009-11-17 16:29:56.468', '*', 'Nulování sociálky pro malý rozsah do 2000', NULL, NULL, NULL, '', NULL, true, NULL, NULL, 40, 1999.000000, 0.000000, 0.000000, 'zaklMzd', 'zaklMzd', 1, 1, 162, true, true, true, false);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, cisrad, dohodnoty, koeficient, odhodnoty, polenuluj, poletest, idtyppracpom, idmzdcalchlav, idcismzdsloz, actmaprohl, actmalyroz, actnemaprohl, actvelkyroz) VALUES (9, '2009-11-17 16:30:08.531', '*', 'Nulování zálohové daně pro NEpodepisovatele do 5000', NULL, NULL, NULL, NULL, NULL, true, NULL, NULL, 10, 5000.000000, 0.000000, 0.000000, 'zaklMzd', 'zaklMzd', NULL, 1, 107, false, true, true, true);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, cisrad, dohodnoty, koeficient, odhodnoty, polenuluj, poletest, idtyppracpom, idmzdcalchlav, idcismzdsloz, actmaprohl, actmalyroz, actnemaprohl, actvelkyroz) VALUES (7, '2009-11-17 16:30:14.062', '*', 'Nulování srážkové daně pro podepisovatele', NULL, NULL, NULL, NULL, NULL, true, NULL, NULL, 20, 9999999999999.000000, 0.000000, 0.000000, 'zaklMzd', 'zaklMzd', NULL, 1, 157, true, true, false, true);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, cisrad, dohodnoty, koeficient, odhodnoty, polenuluj, poletest, idtyppracpom, idmzdcalchlav, idcismzdsloz, actmaprohl, actmalyroz, actnemaprohl, actvelkyroz) VALUES (6, '2009-11-17 16:30:51.343', '*', 'Nulování zdravotky pro malý rozsah do 2000', NULL, NULL, NULL, '', NULL, true, NULL, NULL, 50, 1999.000000, 0.000000, 0.000000, 'zaklMzd', 'zaklMzd', 1, 1, 163, true, true, true, false);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, cisrad, dohodnoty, koeficient, odhodnoty, polenuluj, poletest, idtyppracpom, idmzdcalchlav, idcismzdsloz, actmaprohl, actmalyroz, actnemaprohl, actvelkyroz) VALUES (3, '2009-11-17 16:34:52.515', '*', 'Nulování zdravotky vždy do 2000', NULL, NULL, NULL, '', NULL, true, NULL, NULL, 100, 1999.000000, 0.000000, 0.000000, 'zaklMzd', 'zaklMzd', 4, 1, 163, true, true, true, true);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, cisrad, dohodnoty, koeficient, odhodnoty, polenuluj, poletest, idtyppracpom, idmzdcalchlav, idcismzdsloz, actmaprohl, actmalyroz, actnemaprohl, actvelkyroz) VALUES (14, '2009-11-17 16:40:42.265', '*', 'Nulování základu pro sociální pojištění  pro standardní pracovní poměry  ', NULL, NULL, NULL, '', NULL, true, NULL, NULL, 110, 9999999999999.000000, 0.000000, 0.000000, 'zaklMzd', 'zaklMzd', 5, 1, 162, true, true, true, true);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, cisrad, dohodnoty, koeficient, odhodnoty, polenuluj, poletest, idtyppracpom, idmzdcalchlav, idcismzdsloz, actmaprohl, actmalyroz, actnemaprohl, actvelkyroz) VALUES (12, '2009-11-17 16:40:18.015', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', NULL, NULL, NULL, '', NULL, true, NULL, NULL, 65, 9999999999999.000000, 0.000000, 0.000000, 'zaklMzd', 'zaklMzd', 2, 1, 221, true, true, true, true);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, cisrad, dohodnoty, koeficient, odhodnoty, polenuluj, poletest, idtyppracpom, idmzdcalchlav, idcismzdsloz, actmaprohl, actmalyroz, actnemaprohl, actvelkyroz) VALUES (13, '2009-11-17 16:40:25.937', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', NULL, NULL, NULL, '', NULL, true, NULL, NULL, 85, 9999999999999.000000, 0.000000, 0.000000, 'zaklMzd', 'zaklMzd', 4, 1, 221, true, true, true, true);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, cisrad, dohodnoty, koeficient, odhodnoty, polenuluj, poletest, idtyppracpom, idmzdcalchlav, idcismzdsloz, actmaprohl, actmalyroz, actnemaprohl, actvelkyroz) VALUES (10, '2009-11-17 16:40:57.296', '*', 'Nulování slevy na sociálce pro DPČ', NULL, NULL, NULL, '', NULL, true, NULL, NULL, 80, 9999999999999.000000, 0.000000, 0.000000, 'zaklMzd', 'zaklMzd', 4, 1, 219, true, true, true, true);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, cisrad, dohodnoty, koeficient, odhodnoty, polenuluj, poletest, idtyppracpom, idmzdcalchlav, idcismzdsloz, actmaprohl, actmalyroz, actnemaprohl, actvelkyroz) VALUES (1, '2009-11-17 16:41:10.609', '*', 'Sociálka se nuluje u DPP vždy', NULL, NULL, NULL, '', NULL, true, NULL, NULL, 70, 9999999999999.000000, 0.000000, 0.000000, 'zaklMzd;castMzd', 'castMzd', 2, 1, 162, true, true, true, true);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, cisrad, dohodnoty, koeficient, odhodnoty, polenuluj, poletest, idtyppracpom, idmzdcalchlav, idcismzdsloz, actmaprohl, actmalyroz, actnemaprohl, actvelkyroz) VALUES (8, '2009-11-17 16:43:19.484', '*', 'Nulování srážkové daně pro NEpodepisovatele nad 5000', NULL, NULL, NULL, NULL, NULL, true, NULL, NULL, 30, 9999999999999.000000, 0.000000, 5000.000100, 'zaklMzd', 'zaklMzd', NULL, 1, 157, false, true, true, true);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, cisrad, dohodnoty, koeficient, odhodnoty, polenuluj, poletest, idtyppracpom, idmzdcalchlav, idcismzdsloz, actmaprohl, actmalyroz, actnemaprohl, actvelkyroz) VALUES (11, '2009-11-17 16:43:26.031', '*', 'Nulování základu pro sociální pojištění  - pro pracovní poměry platící jen DP - společníci, jednatelé atd.  ', NULL, NULL, NULL, '', NULL, true, NULL, NULL, 45, 9999999999999.000000, 0.000000, 0.000000, 'zaklMzd', 'zaklMzd', 1, 1, 221, true, true, true, true);
INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, platido, platiod, cisrad, dohodnoty, koeficient, odhodnoty, polenuluj, poletest, idtyppracpom, idmzdcalchlav, idcismzdsloz, actmaprohl, actmalyroz, actnemaprohl, actvelkyroz) VALUES (2, '2009-11-17 16:43:39.562', '*', 'Zdravotka se nuluje u DPP vždy', NULL, NULL, NULL, '', NULL, true, NULL, NULL, 60, 9999999999999.000000, 0.000000, 0.000000, 'zaklMzd;castMzd', 'castMzd', 2, 1, 163, true, true, true, true);


INSERT INTO pmzdcalchrom (idmzdcalchrom, lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, cisrad, polein, poleout, zaokrjakk, zaokrnak, idmzdcalchlav, idmzdslozin, idmzdslozout) VALUES (1, '2009-10-29 10:27:30.296', 'SOC.FIRMA ZAOKR.', 'Soc. pojištění - Firma (pro všechny pracovní poměry) ', NULL, NULL, NULL, 'Dojde k celkovému zaokrouuhlení sumy sociálky firmy  a k rozpuštění mezi jednotlivé zaměstnance ', NULL, true, 1, 'castMzd', 'castMzd', 'zaokrJak.nahoru', 'zaokrNa.jednotky', 1, 102, 181);


PERFORM pg_catalog.setval('seq_pmzdcalchlav', 1, true);
PERFORM pg_catalog.setval('seq_pmzdcalc', 360, true);
PERFORM pg_catalog.setval('seq_ptyppracpomparam', 14, true);
PERFORM pg_catalog.setval('seq_pmzdcalchrom', 1, true);


-- nastavime hromadnou radku do hlavicky
UPDATE pmzdcalchlav SET idradkahromadne = 358 WHERE idmzdcalchlav = 1;

-- Parametry mzdy
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (1, '2008-01-01 00:00:00', 'svatek', 'XXXX-01-01');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (2, '2008-01-01 00:00:00', 'svatek', 'XXXX-05-01');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (3, '2008-01-01 00:00:00', 'svatek', 'XXXX-05-08');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (4, '2008-01-01 00:00:00', 'svatek', 'XXXX-07-05');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (5, '2008-01-01 00:00:00', 'svatek', 'XXXX-07-06');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (6, '2008-01-01 00:00:00', 'svatek', 'XXXX-09-28');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (7, '2008-01-01 00:00:00', 'svatek', 'XXXX-10-28');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (8, '2008-01-01 00:00:00', 'svatek', 'XXXX-11-17');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (9, '2008-01-01 00:00:00', 'svatek', 'XXXX-12-24');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (10, '2008-01-01 00:00:00', 'svatek', 'XXXX-12-25');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (11, '2008-01-01 00:00:00', 'svatek', 'XXXX-12-26');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (16, '2008-01-01 00:00:00', 'svatek', '2013-04-01');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (12, '2008-01-01 00:00:00', 'svatek', '2009-04-13');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (13, '2008-01-01 00:00:00', 'svatek', '2010-04-05');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (14, '2008-01-01 00:00:00', 'svatek', '2011-04-25');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (15, '2008-01-01 00:00:00', 'svatek', '2012-04-09');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (17, '2008-01-01 00:00:00', 'svatek', '2014-04-21');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (19, '2008-01-01 00:00:00', 'svatek', '2016-03-28');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (20, '2008-01-01 00:00:00', 'svatek', '2017-04-17');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (21, '2008-01-01 00:00:00', 'svatek', '2018-04-02');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (22, '2008-01-01 00:00:00', 'svatek', '2019-04-22');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (23, '2008-01-01 00:00:00', 'svatek', '2020-04-13');
INSERT INTO pmzdyparam (idmzdyparam, lastupdate, klic, hodnota) VALUES (18, '2008-01-01 00:00:00', 'svatek', '2015-04-06');

PERFORM pg_catalog.setval('seq_pmzdyparam', 23, true); 
-- konec ceskeho bloku

  end if; 
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 183, 't');
