---------------------------------------------------------------------------------------
-- Bug 32455 – [FlexiBee] Aktualizovat číselník finančních úřadů
---------------------------------------------------------------------------------------

ALTER TABLE nnastav ADD COLUMN idfukraj integer;
ALTER TABLE nnastav ADD COLUMN idfuuzemprac integer;

ALTER TABLE nnastav ADD CONSTRAINT nnastav_idfukraj FOREIGN KEY (idfukraj)
  REFERENCES aadresar (idfirmy) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE nnastav ADD CONSTRAINT nnastav_idfuuzemprac FOREIGN KEY (idfuuzemprac)
  REFERENCES aadresar (idfirmy) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX nNastav_IdFuKraj_index ON nNastav USING btree (IdFuKraj);
CREATE INDEX nNastav_IdFuUzemPrac_index ON nNastav USING btree (IdFuUzemPrac);


create or replace function runupgrade()
    returns void as $$
declare
    stat character varying(10);
    pocet integer;
begin
  select a.uuid into stat from nnastav n  left join utyporg u on u.idtyporg = n.idtyporg left join astaty a on a.idstatu = u.idstatu
    where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);
  
  -- financaky aktualizujeme jen pro cechy
  if (stat = 'CZ_CZ') then
    -- starym financakum ukoncime platnost
    UPDATE aadresar SET platido = 2012 WHERE typvztahuk = 'typVztahu.financniUrad' AND uuid is not null and platido = 9999;

-- nove financaky
INSERT INTO aadresar (lastupdate, kod, nazev, show, platiod, platido, ulice, mesto, psc, postovnishodna, limitfak, limitposplatzakaz, platcedph, bonita, typvztahuk, kodpojistovny, slevadokl, obpautomhotovo, pocetpriloh, uuid)
 VALUES
('2013-01-25 00:00:00.000', generateuniquekod('FÚ GFŘ', 'aadresar', '_'), 'Generální finanční ředitelství', true, 2013, 9999, 'Lazarská 15/7', 'Praha 1', '11722', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '', 0.0, false, 0, 'CZ_FU_2013_GFR'),
('2013-01-25 00:00:00.000', generateuniquekod('FÚ OFŘ', 'aadresar', '_'), 'Odvolací finanční ředitelství', true, 2013, 9999, 'Masarykova 31', 'Brno', '60200', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '', 0.0, false, 0, 'CZ_FU_2013_OFR'),
('2013-01-25 00:00:00.000', generateuniquekod('FÚ PRAHA', 'aadresar', '_'), 'Finanční úřad pro hlavní město Prahu', true, 2013, 9999, 'Štěpánská 619/28', 'Praha 1', '11121', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '451', 0.0, false, 0, 'CZ_FU_2013_451'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PRAHA 1', 'aadresar', '_'), 'Územní pracoviště pro Prahu 1', true, 2013, 9999, 'Štěpánská 619/28', 'Praha 1', '11233', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2001', 0.0, false, 0, 'CZ_FU_2013_2001'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PRAHA 2', 'aadresar', '_'), 'Územní pracoviště pro Prahu 2', true, 2013, 9999, 'Vinohradská 49', 'Praha 2', '12000', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2002', 0.0, false, 0, 'CZ_FU_2013_2002'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PRAHA 3', 'aadresar', '_'), 'Územní pracoviště pro Prahu 3', true, 2013, 9999, 'Drahobejlova 48', 'Praha 9', '19021', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2003', 0.0, false, 0, 'CZ_FU_2013_2003'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PRAHA 4', 'aadresar', '_'), 'Územní pracoviště pro Prahu 4', true, 2013, 9999, 'Budějovická 409/1', 'Praha 4', '14000', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2004', 0.0, false, 0, 'CZ_FU_2013_2004'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PRAHA 5', 'aadresar', '_'), 'Územní pracoviště pro Prahu 5', true, 2013, 9999, 'Peroutkova 263/61', 'Praha 5', '15000', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2005', 0.0, false, 0, 'CZ_FU_2013_2005'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PRAHA 6', 'aadresar', '_'), 'Územní pracoviště pro Prahu 6', true, 2013, 9999, 'Nábř.Kpt.Jaroše 1000/7', 'Praha 7', '17000', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2006', 0.0, false, 0, 'CZ_FU_2013_2006'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PRAHA 7', 'aadresar', '_'), 'Územní pracoviště pro Prahu 7', true, 2013, 9999, 'Nábř.Kpt.Jaroše 1000/7', 'Praha 7', '17000', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2007', 0.0, false, 0, 'CZ_FU_2013_2007'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PRAHA 8', 'aadresar', '_'), 'Územní pracoviště pro Prahu 8', true, 2013, 9999, 'Trojská 13a', 'Praha 8', '18000', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2008', 0.0, false, 0, 'CZ_FU_2013_2008'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PRAHA 9', 'aadresar', '_'), 'Územní pracoviště pro Prahu 9', true, 2013, 9999, 'Drahobejlova 945/48', 'Praha 9', '19021', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2009', 0.0, false, 0, 'CZ_FU_2013_2009'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PRAHA 10', 'aadresar', '_'), 'Územní pracoviště pro Prahu 10', true, 2013, 9999, 'Petrohradská 6', 'Praha 10', '10100', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2010', 0.0, false, 0, 'CZ_FU_2013_2010'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PRAHA 11', 'aadresar', '_'), 'Územní pracoviště pro Prahu - Jižní ', true, 2013, 9999, 'Opatovská 964/18', 'Praha 11', '14902', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2011', 0.0, false, 0, 'CZ_FU_2013_2011'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PRAHA 12', 'aadresar', '_'), 'Územní pracoviště v Praze - Modřanech', true, 2013, 9999, 'Lehárova 1885/2', 'Praha 12', '14300', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2012', 0.0, false, 0, 'CZ_FU_2013_2012'),
('2013-01-25 00:00:00.000', generateuniquekod('FÚ SFÚ', 'aadresar', '_'), 'Specializovaný finanční úřad', true, 2013, 9999, 'Nábřeží kpt. Jaroše 1000/7', 'Praha 7', '170 00', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '', 0.0, false, 0, 'CZ_FU_2013_SFU'),
('2013-01-25 00:00:00.000', generateuniquekod('FÚ JIHOČESKÝ', 'aadresar', '_'), 'Finanční úřad pro Jihočeský kraj', true, 2013, 9999, 'Mánesova 3a', 'České Budějovice', '37187', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '453', 0.0, false, 0, 'CZ_FU_2013_453'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP ČESKÉ BUDĚJOVICE', 'aadresar', '_'), 'Územní pracoviště v Českých Budějovicích', true, 2013, 9999, 'F. A. Gerstnera 1/5', 'České Budějovice', '37001', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2201', 0.0, false, 0, 'CZ_FU_2013_2201'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP BLATNÁ', 'aadresar', '_'), 'Územní pracoviště v Blatné', true, 2013, 9999, 'Třída J.P. Koubka 91', 'Blatná', '38801', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2202', 0.0, false, 0, 'CZ_FU_2013_2202'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP ČESKÝ KRUMLOV', 'aadresar', '_'), 'Územní pracoviště v Českém Krumlově', true, 2013, 9999, 'Vyšehrad 169', 'Český Krumlov', '38101', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2203', 0.0, false, 0, 'CZ_FU_2013_2203'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP DAČICE', 'aadresar', '_'), 'Územní pracoviště v Dačicích', true, 2013, 9999, 'Komenského 39/5', 'Dačice', '38001', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2204', 0.0, false, 0, 'CZ_FU_2013_2204'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP JINDŘICHŮV HRADEC', 'aadresar', '_'), 'Územní pracoviště v Jindřichově Hradci', true, 2013, 9999, 'Česká ulice 1284', 'Jindřichův Hradec', '37701', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2205', 0.0, false, 0, 'CZ_FU_2013_2205'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP KAPLICE', 'aadresar', '_'), 'Územní pracoviště v Kaplici', true, 2013, 9999, 'Kostelní 124', 'Kaplice', '38241', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2206', 0.0, false, 0, 'CZ_FU_2013_2206'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP MILEVSKO', 'aadresar', '_'), 'Územní pracoviště v Milevsku', true, 2013, 9999, 'Za Radnicí 12', 'Milevsko', '39901', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2207', 0.0, false, 0, 'CZ_FU_2013_2207'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PÍSEK', 'aadresar', '_'), 'Územní pracoviště v Písku', true, 2013, 9999, 'Nábřeží 1. máje 2259', 'Písek', '39701', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2208', 0.0, false, 0, 'CZ_FU_2013_2208'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PRACHATICE', 'aadresar', '_'), 'Územní pracoviště v Prachaticích', true, 2013, 9999, 'Vodňanská 376', 'Prachatice', '38301', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2209', 0.0, false, 0, 'CZ_FU_2013_2209'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP SOBĚSLAV', 'aadresar', '_'), 'Územní pracoviště v Soběslavi', true, 2013, 9999, 'Wilsonova 113', 'Soběslav', '39201', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2210', 0.0, false, 0, 'CZ_FU_2013_2210'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP STRAKONICE', 'aadresar', '_'), 'Územní pracoviště ve Strakonicích', true, 2013, 9999, 'Na Ohradě 1067', 'Strakonice', '38601', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2211', 0.0, false, 0, 'CZ_FU_2013_2211'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP TÁBOR', 'aadresar', '_'), 'Územní pracoviště v Táboře', true, 2013, 9999, 'Budějovická 2923', 'Tábor', '39002', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2212', 0.0, false, 0, 'CZ_FU_2013_2212'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP TRHOVÉ SVINY', 'aadresar', '_'), 'Územní pracoviště v Trhových Svinech', true, 2013, 9999, 'Budovatelská 1009', 'Trhové Sviny', '37401', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2213', 0.0, false, 0, 'CZ_FU_2013_2213'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP TŘEBOŇ', 'aadresar', '_'), 'Územní pracoviště v Třeboni', true, 2013, 9999, 'Palackého náměstí 106', 'Třeboň', '37901', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2214', 0.0, false, 0, 'CZ_FU_2013_2214'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP TÝN NAD VLTAVOU', 'aadresar', '_'), 'Územní pracoviště v Týně nad Vltavou', true, 2013, 9999, 'Nádražní 235', 'Týn nad Vltavou', '37501', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2215', 0.0, false, 0, 'CZ_FU_2013_2215'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP VIMPERK', 'aadresar', '_'), 'Územní pracoviště ve Vimperku ', true, 2013, 9999, '1. máje 200', 'Vimperk', '38501', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2216', 0.0, false, 0, 'CZ_FU_2013_2216'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP VODŇANY', 'aadresar', '_'), 'Územní pracoviště ve Vodňanech', true, 2013, 9999, 'Jiráskova 116', 'Vodňany', '38901', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2217', 0.0, false, 0, 'CZ_FU_2013_2217'),
('2013-01-25 00:00:00.000', generateuniquekod('FÚ JIHOMORAVSKÝ', 'aadresar', '_'), 'Finanční úřad pro Jihomoravský kraj', true, 2013, 9999, 'Náměstí Svobody 4', 'Brno', '60200', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '461', 0.0, false, 0, 'CZ_FU_2013_461'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP BRNO I', 'aadresar', '_'), 'Územní pracoviště Brno I', true, 2013, 9999, 'Příkop 25', 'Brno', '60423', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3001', 0.0, false, 0, 'CZ_FU_2013_3001'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP BRNO II', 'aadresar', '_'), 'Územní pracoviště Brno II', true, 2013, 9999, 'Cejl 113', 'Brno', '65961', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3002', 0.0, false, 0, 'CZ_FU_2013_3002'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP BRNO III', 'aadresar', '_'), 'Územní pracoviště Brno III', true, 2013, 9999, 'Šumavská 31', 'Brno', '66349', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3003', 0.0, false, 0, 'CZ_FU_2013_3003'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP BRNO IV', 'aadresar', '_'), 'Územní pracoviště Brno IV', true, 2013, 9999, 'Rybníček 2', 'Brno', '66358', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3004', 0.0, false, 0, 'CZ_FU_2013_3004'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP BRNO VENKOV', 'aadresar', '_'), 'Územní pracoviště Brno - venkov', true, 2013, 9999, 'Příkop 8', 'Brno', '60424', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3005', 0.0, false, 0, 'CZ_FU_2013_3005'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP BLANSKO', 'aadresar', '_'), 'Územní pracoviště v Blansku', true, 2013, 9999, 'Seifertova 7', 'Blansko', '67811', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3006', 0.0, false, 0, 'CZ_FU_2013_3006'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP BOSKOVICE', 'aadresar', '_'), 'Územní pracoviště v Boskovicích', true, 2013, 9999, '17.listopadu 6', 'Boskovice', '68001', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3007', 0.0, false, 0, 'CZ_FU_2013_3007'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP BŘECLAV', 'aadresar', '_'), 'Územní pracoviště v Břeclavi', true, 2013, 9999, 'Sladová 1', 'Břeclav', '69002', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3008', 0.0, false, 0, 'CZ_FU_2013_3008'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP BUČOVICE', 'aadresar', '_'), 'Územní pracoviště v Bučovicích', true, 2013, 9999, 'Slovenská 910', 'Bučovice', '68501', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3009', 0.0, false, 0, 'CZ_FU_2013_3009'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP HODONÍN', 'aadresar', '_'), 'Územní pracoviště v Hodoníně', true, 2013, 9999, 'Dukelských hrdinů 3653/1', 'Hodonín', '69501', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3010', 0.0, false, 0, 'CZ_FU_2013_3010'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP HUSTOPEČE', 'aadresar', '_'), 'Územní pracoviště v Hustopečích', true, 2013, 9999, 'Nádražní 35', 'Hustopeče', '69301', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3011', 0.0, false, 0, 'CZ_FU_2013_3011'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP IVANČICE', 'aadresar', '_'), 'Územní pracoviště v Ivančicích', true, 2013, 9999, 'Na Spojce 1', 'Ivančice', '66491', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3012', 0.0, false, 0, 'CZ_FU_2013_3012'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP KYJOV', 'aadresar', '_'), 'Územní pracoviště v Kyjově', true, 2013, 9999, 'Třída Komenského 1360/18', 'Kyjov', '69701', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3013', 0.0, false, 0, 'CZ_FU_2013_3013'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP MIKULOV', 'aadresar', '_'), 'Územní pracoviště v Mikulově', true, 2013, 9999, 'Gagarinova 9', 'Mikulov', '69201', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3014', 0.0, false, 0, 'CZ_FU_2013_3014'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP MORAVSKÝ KRUMLOV', 'aadresar', '_'), 'Územní pracoviště v Moravském Krumlově', true, 2013, 9999, 'Zámecká 8', 'Moravský Krumlov', '67201', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3015', 0.0, false, 0, 'CZ_FU_2013_3015'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP SLAVKOV U BRNA', 'aadresar', '_'), 'Územní pracoviště ve Slavkově u Brna', true, 2013, 9999, 'Palackého náměstí 89', 'Slavkov u Brna', '68401', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3016', 0.0, false, 0, 'CZ_FU_2013_3016'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP TIŠNOV', 'aadresar', '_'), 'Územní pracoviště v Tišnově', true, 2013, 9999, 'Brněnská 148', 'Tišnov', '66601', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3017', 0.0, false, 0, 'CZ_FU_2013_3017'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP VESELÍ NAD MORAVO', 'aadresar', '_'), 'Územní pracoviště ve Veselí nad Moravou', true, 2013, 9999, 'náměstí Míru 1759', 'Veselí nad Moravou', '69801', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3018', 0.0, false, 0, 'CZ_FU_2013_3018'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP VYŠKOV', 'aadresar', '_'), 'Územní pracoviště ve Vyškově', true, 2013, 9999, 'Dobrovského 3', 'Vyškov', '68201', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3019', 0.0, false, 0, 'CZ_FU_2013_3019'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP ZNOJMO', 'aadresar', '_'), 'Územní pracoviště ve Znojmě', true, 2013, 9999, 'nám. Svobody 8', 'Znojmo', '66901', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3020', 0.0, false, 0, 'CZ_FU_2013_3020'),
('2013-01-25 00:00:00.000', generateuniquekod('FÚ KARLOVASKÝ', 'aadresar', '_'), 'Finanční úřad pro Karlovarský kraj', true, 2013, 9999, 'Západní 19', 'Karlovy Vary', '36001', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '455', 0.0, false, 0, 'CZ_FU_2013_455'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP KARLOVY VARY', 'aadresar', '_'), 'Územní pracoviště v Karlových Varech', true, 2013, 9999, 'Západní 19', 'Karlovy Vary', '36001', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2401', 0.0, false, 0, 'CZ_FU_2013_2401'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP AŠ', 'aadresar', '_'), 'Územní pracoviště v Aši', true, 2013, 9999, 'Karlova 13', 'Aš', '35201', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2402', 0.0, false, 0, 'CZ_FU_2013_2402'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP CHEB', 'aadresar', '_'), 'Územní pracoviště v Chebu', true, 2013, 9999, 'Hálkova 32', 'Cheb', '35002', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2403', 0.0, false, 0, 'CZ_FU_2013_2403'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP KRASLICE', 'aadresar', '_'), 'Územní pracoviště v Kraslicích', true, 2013, 9999, 'Palackého 1891', 'Kraslice', '35801', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2404', 0.0, false, 0, 'CZ_FU_2013_2404'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP MARIÁNSKÉ LÁZNĚ', 'aadresar', '_'), 'Územní pracoviště v Mariánských Lázních', true, 2013, 9999, 'Hlavní 661/140', 'Mariánské Lázně', '35301', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2405', 0.0, false, 0, 'CZ_FU_2013_2405'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP OSTROV', 'aadresar', '_'), 'Územní pracoviště v Ostrově', true, 2013, 9999, 'Klínovecká 998', 'Ostrov', '36301', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2406', 0.0, false, 0, 'CZ_FU_2013_2406'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP SOKOLOV', 'aadresar', '_'), 'Územní pracoviště v Sokolově', true, 2013, 9999, 'Růžové náměstí 1629', 'Sokolov', '35601', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2407', 0.0, false, 0, 'CZ_FU_2013_2407'),
('2013-01-25 00:00:00.000', generateuniquekod('FÚ VYSOČINA', 'aadresar', '_'), 'Finanční úřad pro Kraj Vysočina', true, 2013, 9999, 'Tolstého 2', 'Jihlava', '56801', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '460', 0.0, false, 0, 'CZ_FU_2013_460'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP JIHLAVA', 'aadresar', '_'), 'Územní pracoviště v Jihlavě', true, 2013, 9999, 'Tolstého 2', 'Jihlava', '58601', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2901', 0.0, false, 0, 'CZ_FU_2013_2901'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP BYSTŘICE NAD PERN', 'aadresar', '_'), 'Územní pracoviště v Bystřici nad Pernšt.', true, 2013, 9999, 'Masarykovo náměstí 15', 'Bystřice nad Pernštejnem', '59301', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2902', 0.0, false, 0, 'CZ_FU_2013_2902'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP HAVLÍČKŮV BROD', 'aadresar', '_'), 'Územní pracoviště v Havlíčkově Brodě', true, 2013, 9999, 'Smetanovo náměstí 261', 'Havlíčkův Brod', '58002', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2903', 0.0, false, 0, 'CZ_FU_2013_2903'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP HUMPOLEC', 'aadresar', '_'), 'Územní pracoviště v Humpolci', true, 2013, 9999, 'Příčná 1525', 'Humpolec', '39601', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2904', 0.0, false, 0, 'CZ_FU_2013_2904'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP CHOTĚBOŘ', 'aadresar', '_'), 'Územní pracoviště v Chotěboři', true, 2013, 9999, 'Krále Jana 259', 'Chotěboř', '58301', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2905', 0.0, false, 0, 'CZ_FU_2013_2905'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP LEDEČ NAD SÁZAVOU', 'aadresar', '_'), 'Územní pracoviště v Ledči nad Sázavou', true, 2013, 9999, 'Poštovní 520', 'Ledeč nad Sázavou', '58401', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2906', 0.0, false, 0, 'CZ_FU_2013_2906'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP MORAVSKÉ BUDĚJOVI', 'aadresar', '_'), 'Územní pracoviště v Morav. Budějovicích', true, 2013, 9999, 'Husova 480', 'Moravské Budějovice', '67602', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2907', 0.0, false, 0, 'CZ_FU_2013_2907'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP NÁMĚŠŤ NAD OSLAVO', 'aadresar', '_'), 'Územní pracoviště v Náměšti nad Oslavou', true, 2013, 9999, 'Lipová 387', 'Náměšť nad Oslavou', '67571', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2908', 0.0, false, 0, 'CZ_FU_2013_2908'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PACOV', 'aadresar', '_'), 'Územní pracoviště v Pacově', true, 2013, 9999, 'J. Autengrubera 1076', 'Pacov', '39501', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2909', 0.0, false, 0, 'CZ_FU_2013_2909'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PELHŘIMOV', 'aadresar', '_'), 'Územní pracoviště v Pelhřimově', true, 2013, 9999, 'Příkopy 1754', 'Pelhřimov', '39301', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2910', 0.0, false, 0, 'CZ_FU_2013_2910'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP TELČ', 'aadresar', '_'), 'Územní pracoviště v Telči', true, 2013, 9999, 'Štěpnická 399', 'Telč', '58856', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2911', 0.0, false, 0, 'CZ_FU_2013_2911'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP TŘEBÍČ', 'aadresar', '_'), 'Územní pracoviště v Třebíči', true, 2013, 9999, 'Žerotínovo nám. 17/1', 'Třebíč', '67401', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2912', 0.0, false, 0, 'CZ_FU_2013_2912'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP VELKÉ MEZIŘÍČÍ', 'aadresar', '_'), 'Územní pracoviště ve Velkém Meziříčí', true, 2013, 9999, 'Hornoměstská 864/39', 'Velké Meziříčí', '59401', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2913', 0.0, false, 0, 'CZ_FU_2013_2913'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP ŽĎÁR NAD SÁZAVOU', 'aadresar', '_'), 'Územní pracoviště ve Žďáru nad Sázavou', true, 2013, 9999, 'Strojírenská 28', 'Žďár nad Sázavou', '59101', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2914', 0.0, false, 0, 'CZ_FU_2013_2914'),
('2013-01-25 00:00:00.000', generateuniquekod('FÚ KRÁLOVÉHRADECKÝ', 'aadresar', '_'), 'Finanční úřad pro Královéhradecký kraj', true, 2013, 9999, 'Horova 17', 'Hradec Králové', '50002', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '458', 0.0, false, 0, 'CZ_FU_2013_458'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP HRADEC KRÁLOVÉ', 'aadresar', '_'), 'Územní pracoviště v Hradci Králové', true, 2013, 9999, 'U Koruny 1632', 'Hradec Králové', '50200', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2701', 0.0, false, 0, 'CZ_FU_2013_2701'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP BROUMOV', 'aadresar', '_'), 'Územní pracoviště v Broumově', true, 2013, 9999, 'Opočenského 60', 'Broumov', '55001', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2702', 0.0, false, 0, 'CZ_FU_2013_2702'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP DOBRUŠKA', 'aadresar', '_'), 'Územní pracoviště v Dobrušce', true, 2013, 9999, 'Šubertovo nám. 53', 'Dobruška', '51801', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2703', 0.0, false, 0, 'CZ_FU_2013_2703'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP DVŮR KRÁLOVÉ NAD', 'aadresar', '_'), 'Územní pracoviště ve Dvoře Králové nad L.', true, 2013, 9999, '17. listopadu 2929', 'Dvůr Králové nad Labem', '54401', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2704', 0.0, false, 0, 'CZ_FU_2013_2704'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP HOŘICE', 'aadresar', '_'), 'Územní pracoviště v Hořicích', true, 2013, 9999, 'Čelakovského 1023', 'Hořice', '50801', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2705', 0.0, false, 0, 'CZ_FU_2013_2705'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP JAROMĚŘ', 'aadresar', '_'), 'Územní pracoviště v Jaroměři', true, 2013, 9999, 'Svatopluka Čecha 121', 'Jaroměř', '55101', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2706', 0.0, false, 0, 'CZ_FU_2013_2706'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP JIČÍN', 'aadresar', '_'), 'Územní pracoviště v Jičíně', true, 2013, 9999, 'Valdštejnovo náměstí 1', 'Jičín', '50614', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2707', 0.0, false, 0, 'CZ_FU_2013_2707'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP KOSTELEC NAD ORLI', 'aadresar', '_'), 'Územní pracoviště v Kostelci nad Orlicí', true, 2013, 9999, 'Komenského 583', 'Kostelec nad Orlicí', '51741', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2708', 0.0, false, 0, 'CZ_FU_2013_2708'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP NÁCHOD', 'aadresar', '_'), 'Územní pracoviště v Náchodě', true, 2013, 9999, 'Tyršova 49', 'Náchod', '54701', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2709', 0.0, false, 0, 'CZ_FU_2013_2709'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP NOVÁ PAKA', 'aadresar', '_'), 'Územní pracoviště v Nové Pace', true, 2013, 9999, 'Čelakovského 486', 'Nová Paka', '50901', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2710', 0.0, false, 0, 'CZ_FU_2013_2710'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP NOVÝ BYDŽOV', 'aadresar', '_'), 'Územní pracoviště v Novém Bydžově', true, 2013, 9999, 'Jos. Jungmanna 1533', 'Nový Bydžov', '50401', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2711', 0.0, false, 0, 'CZ_FU_2013_2711'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP RYCHNOV NAD KNĚŽN', 'aadresar', '_'), 'Územní pracoviště v Rychnově nad Kněžnou', true, 2013, 9999, 'Jiráskova 1497', 'Rychnov nad Kněžnou', '51601', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2712', 0.0, false, 0, 'CZ_FU_2013_2712'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP TRUTNOV', 'aadresar', '_'), 'Územní pracoviště v Trutnově', true, 2013, 9999, 'Slezská 166', 'Trutnov', '54101', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2713', 0.0, false, 0, 'CZ_FU_2013_2713'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP VRCHLABÍ', 'aadresar', '_'), 'Územní pracoviště ve Vrchlabí', true, 2013, 9999, 'Krkonošská 148', 'Vrchlabí', '54301', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2714', 0.0, false, 0, 'CZ_FU_2013_2714'),
('2013-01-25 00:00:00.000', generateuniquekod('FÚ LIBERECKÝ', 'aadresar', '_'), 'Finanční úřad pro Liberecký kraj', true, 2013, 9999, 'Tř. 1. máje 97/25', 'Liberec', '46007', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '457', 0.0, false, 0, 'CZ_FU_2013_457'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP LIBEREC', 'aadresar', '_'), 'Územní pracoviště v Liberci', true, 2013, 9999, 'Tř. 1. máje 97/25', 'Liberec', '46007', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2601', 0.0, false, 0, 'CZ_FU_2013_2601'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP ČESKÁ LÍPA', 'aadresar', '_'), 'Územní pracoviště v České Lípě', true, 2013, 9999, 'Pátova 2892', 'Česká Lípa', '47043', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2602', 0.0, false, 0, 'CZ_FU_2013_2602'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP FRÝDLANT', 'aadresar', '_'), 'Územní pracoviště ve Frýdlantě', true, 2013, 9999, 'Komenského nábřeží 680', 'Frýdlant', '46401', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2603', 0.0, false, 0, 'CZ_FU_2013_2603'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP JABLONEC NAD NISO', 'aadresar', '_'), 'Územní pracoviště v Jablonci nad Nisou', true, 2013, 9999, 'Podhorská 469/ 2', 'Jablonec nad Nisou', '46632', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2604', 0.0, false, 0, 'CZ_FU_2013_2604'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP JILEMNICE', 'aadresar', '_'), 'Územní pracoviště v Jilemnici', true, 2013, 9999, 'Jungmannova 151', 'Jilemnice', '51401', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2605', 0.0, false, 0, 'CZ_FU_2013_2605'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP NOVÝ BOR', 'aadresar', '_'), 'Územní pracoviště v Novém Boru', true, 2013, 9999, 'B. Egermanna 245', 'Nový Bor', '47301', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2606', 0.0, false, 0, 'CZ_FU_2013_2606'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP SEMILY', 'aadresar', '_'), 'Územní pracoviště v Semilech', true, 2013, 9999, 'Vysocká 140', 'Semily', '51301', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2607', 0.0, false, 0, 'CZ_FU_2013_2607'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP TANVALD', 'aadresar', '_'), 'Územní pracoviště v Tanvaldě', true, 2013, 9999, 'Krkonošská 350', 'Tanvald', '46841', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2608', 0.0, false, 0, 'CZ_FU_2013_2608'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP TURNOV', 'aadresar', '_'), 'Územní pracoviště v Turnově', true, 2013, 9999, 'Havlíčkovo náměstí 54', 'Turnov', '51101', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2609', 0.0, false, 0, 'CZ_FU_2013_2609'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP ŽELEZNÝ BROD', 'aadresar', '_'), 'Územní pracoviště v Železném Brodě', true, 2013, 9999, 'Příčná 350', 'Železný Brod', '46822', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2610', 0.0, false, 0, 'CZ_FU_2013_2610'),
('2013-01-25 00:00:00.000', generateuniquekod('FÚ MORAVSKOSLEZSKÝ', 'aadresar', '_'), 'Finanční úřad pro Moravskoslezský kraj', true, 2013, 9999, 'Na Jízdárně 3163/ 3', 'Ostrava', '70900', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '463', 0.0, false, 0, 'CZ_FU_2013_463'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP OSTRAVA I', 'aadresar', '_'), 'Územní pracoviště Ostrava I', true, 2013, 9999, 'Jurečkova 940/2', 'Ostrava', '70039', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3201', 0.0, false, 0, 'CZ_FU_2013_3201'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP OSTRAVA II', 'aadresar', '_'), 'Územní pracoviště Ostrava II', true, 2013, 9999, 'Horní 1619/63', 'Ostrava', '70046', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3202', 0.0, false, 0, 'CZ_FU_2013_3202'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP OSTRAVA III', 'aadresar', '_'), 'Územní pracoviště Ostrava III', true, 2013, 9999, 'Opavská 6177/74A', 'Ostrava', '70813', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3203', 0.0, false, 0, 'CZ_FU_2013_3203'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP BOHUMÍN', 'aadresar', '_'), 'Územní pracoviště v Bohumíně', true, 2013, 9999, 'Studentská 1182', 'Bohumín', '73581', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3204', 0.0, false, 0, 'CZ_FU_2013_3204'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP BRUNTÁL', 'aadresar', '_'), 'Územní pracoviště v Bruntále', true, 2013, 9999, 'Ruská 1870/3', 'Bruntál', '79201', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3205', 0.0, false, 0, 'CZ_FU_2013_3205'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP ČESKÝ TĚŠÍN', 'aadresar', '_'), 'Územní pracoviště v Českém Těšíně', true, 2013, 9999, 'Masarykovy sady 84/8', 'Český Těšín', '73701', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3206', 0.0, false, 0, 'CZ_FU_2013_3206'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP FRÝDEK-MÍSTEK', 'aadresar', '_'), 'Územní pracoviště ve Frýdku-Místku', true, 2013, 9999, 'Na Poříčí 3208', 'Frýdek-Místek', '73801', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3207', 0.0, false, 0, 'CZ_FU_2013_3207'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP FRÝDLANT NAD OSTR', 'aadresar', '_'), 'Územní pracoviště ve Frýdlantě nad Ostravicí', true, 2013, 9999, 'Spořitelní 238', 'Frýdlant nad Ostravicí', '73911', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3208', 0.0, false, 0, 'CZ_FU_2013_3208'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP FULNEK', 'aadresar', '_'), 'Územní pracoviště ve Fulneku', true, 2013, 9999, 'Nádražní 690', 'Fulnek', '74245', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3209', 0.0, false, 0, 'CZ_FU_2013_3209'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP HAVÍŘOV', 'aadresar', '_'), 'Územní pracoviště v Havířově', true, 2013, 9999, 'Myslbekova 1470/2', 'Havířov', '73601', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3210', 0.0, false, 0, 'CZ_FU_2013_3210'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP HLUČÍN', 'aadresar', '_'), 'Územní pracoviště v Hlučíně', true, 2013, 9999, 'Čs. armády 52/1', 'Hlučín', '74801', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3211', 0.0, false, 0, 'CZ_FU_2013_3211'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP KARVINÁ', 'aadresar', '_'), 'Územní pracoviště v Karviné', true, 2013, 9999, 'Fryštátská 89/2', 'Karviná', '73301', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3212', 0.0, false, 0, 'CZ_FU_2013_3212'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP KOPŘIVNICE', 'aadresar', '_'), 'Územní pracoviště v Kopřivnici', true, 2013, 9999, 'Kpt. Jaroše 395/1', 'Kopřivnice', '74221', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3213', 0.0, false, 0, 'CZ_FU_2013_3213'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP KRNOV', 'aadresar', '_'), 'Územní pracoviště v Krnově', true, 2013, 9999, 'Albrechtická 2185/39b', 'Krnov', '79401', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3214', 0.0, false, 0, 'CZ_FU_2013_3214'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP NOVÝ JIČÍN', 'aadresar', '_'), 'Územní pracoviště v Novém Jičíně', true, 2013, 9999, 'Svatopluka Čecha 2027/47', 'Nový Jičín', '74101', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3215', 0.0, false, 0, 'CZ_FU_2013_3215'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP OPAVA', 'aadresar', '_'), 'Územní pracoviště v Opavě', true, 2013, 9999, 'Masarykova třída 310/2', 'Opava', '74601', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3216', 0.0, false, 0, 'CZ_FU_2013_3216'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP ORLOVÁ', 'aadresar', '_'), 'Územní pracoviště v Orlové', true, 2013, 9999, 'Masarykova třída 1000', 'Orlová', '73514', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3217', 0.0, false, 0, 'CZ_FU_2013_3217'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP TŘINEC', 'aadresar', '_'), 'Územní pracoviště v Třinci', true, 2013, 9999, 'Nám. Svobody 1141', 'Třinec', '73961', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3218', 0.0, false, 0, 'CZ_FU_2013_3218'),
('2013-01-25 00:00:00.000', generateuniquekod('FÚ OLOMOUCKÝ', 'aadresar', '_'), 'Finanční úřad pro Olomoucký kraj', true, 2013, 9999, 'Lazecká 545/22', 'Olomouc', '77911', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '462', 0.0, false, 0, 'CZ_FU_2013_462'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP OLOMOUC', 'aadresar', '_'), 'Územní pracoviště v Olomouci', true, 2013, 9999, 'Lazecká 545/22', 'Olomouc', '77911', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3101', 0.0, false, 0, 'CZ_FU_2013_3101'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP HRANICE', 'aadresar', '_'), 'Územní pracoviště v Hranicích', true, 2013, 9999, 'Nádražní 332', 'Hranice', '75301', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3102', 0.0, false, 0, 'CZ_FU_2013_3102'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP JESENÍK', 'aadresar', '_'), 'Územní pracoviště v Jeseníku', true, 2013, 9999, 'Fučíkova 1239/14', 'Jeseník', '79001', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3103', 0.0, false, 0, 'CZ_FU_2013_3103'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP KONICE', 'aadresar', '_'), 'Územní pracoviště v Konici', true, 2013, 9999, 'Masarykovo nám. 28', 'Konice', '79852', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3104', 0.0, false, 0, 'CZ_FU_2013_3104'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP LITOVEL', 'aadresar', '_'), 'Územní pracoviště v Litovli', true, 2013, 9999, 'Uničovská 138/19a', 'Litovel', '78401', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3105', 0.0, false, 0, 'CZ_FU_2013_3105'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PROSTĚJOV', 'aadresar', '_'), 'Územní pracoviště v Prostějově', true, 2013, 9999, 'Křížkovského 4186/1', 'Prostějov', '79601', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3106', 0.0, false, 0, 'CZ_FU_2013_3106'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PŘEROV', 'aadresar', '_'), 'Územní pracoviště v Přerově', true, 2013, 9999, 'Wurmova 2831/4', 'Přerov', '75002', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3107', 0.0, false, 0, 'CZ_FU_2013_3107'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP ŠTERNBERK', 'aadresar', '_'), 'Územní pracoviště ve Šternberku', true, 2013, 9999, 'Oblouková 2303/2', 'Šternberk', '78501', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3108', 0.0, false, 0, 'CZ_FU_2013_3108'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP ŠUMPERK', 'aadresar', '_'), 'Územní pracoviště v Šumperku', true, 2013, 9999, 'Gen. Svobody 2790/38', 'Šumperk', '78701', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3109', 0.0, false, 0, 'CZ_FU_2013_3109'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP ZÁBŘEH', 'aadresar', '_'), 'Územní pracoviště v Zábřehu', true, 2013, 9999, 'Bezručova 2068/9', 'Zábřeh', '78901', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3110', 0.0, false, 0, 'CZ_FU_2013_3110'),
('2013-01-25 00:00:00.000', generateuniquekod('FÚ PARDUBICKÝ', 'aadresar', '_'), 'Finanční úřad pro Pardubický kraj', true, 2013, 9999, 'Boženy Němcové 2625', 'Pardubice', '53002', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '459', 0.0, false, 0, 'CZ_FU_2013_459'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PARDUBICE', 'aadresar', '_'), 'Územní pracoviště v Pardubicích', true, 2013, 9999, 'Hronovická ul. 2700', 'Pardubice', '53115', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2801', 0.0, false, 0, 'CZ_FU_2013_2801'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP HLINSKO', 'aadresar', '_'), 'Územní pracoviště v Hlinsku', true, 2013, 9999, 'Wilsonova 834', 'Hlinsko', '53901', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2802', 0.0, false, 0, 'CZ_FU_2013_2802'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP HOLICE', 'aadresar', '_'), 'Územní pracoviště v Holicích', true, 2013, 9999, 'Nám.T.G.Masaryka 15', 'Holice', '53401', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2803', 0.0, false, 0, 'CZ_FU_2013_2803'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP CHRUDIM', 'aadresar', '_'), 'Územní pracoviště v Chrudimi', true, 2013, 9999, 'Pardubická 275', 'Chrudim', '53759', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2804', 0.0, false, 0, 'CZ_FU_2013_2804'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP LITOMYŠL', 'aadresar', '_'), 'Územní pracoviště v Litomyšli', true, 2013, 9999, 'J. E. Purkyně 918', 'Litomyšl', '57001', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2805', 0.0, false, 0, 'CZ_FU_2013_2805'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP MORAVSKÁ TŘEBOVÁ', 'aadresar', '_'), 'Územní pracoviště v Moravské Třebové', true, 2013, 9999, 'Nádražní 1442/8', 'Moravská Třebová', '57101', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2806', 0.0, false, 0, 'CZ_FU_2013_2806'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PŘELOUČ', 'aadresar', '_'), 'Územní pracoviště v Přelouči', true, 2013, 9999, 'Tůmy Přeloučského 1500', 'Přelouč', '53501', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2807', 0.0, false, 0, 'CZ_FU_2013_2807'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP SVITAVY', 'aadresar', '_'), 'Územní pracoviště ve Svitavách', true, 2013, 9999, 'T. G. Masaryka 2057', 'Svitavy', '56802', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2808', 0.0, false, 0, 'CZ_FU_2013_2808'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP ÚSTÍ NAD ORLICÍ', 'aadresar', '_'), 'Územní pracoviště v Ústí nad Orlicí', true, 2013, 9999, 'T. G. Masaryka 1393', 'Ústí nad Orlicí', '56201', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2809', 0.0, false, 0, 'CZ_FU_2013_2809'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP VYSOKÉ MÝTO', 'aadresar', '_'), 'Územní pracoviště ve Vysokém Mýtě', true, 2013, 9999, 'Tůmova 178', 'Vysoké Mýto', '56601', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2810', 0.0, false, 0, 'CZ_FU_2013_2810'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP ŽAMBERK', 'aadresar', '_'), 'Územní pracoviště v Žamberku', true, 2013, 9999, 'Pionýrů 1360', 'Žamberk', '56401', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2811', 0.0, false, 0, 'CZ_FU_2013_2811'),
('2013-01-25 00:00:00.000', generateuniquekod('FÚ PLZEŇSKÝ', 'aadresar', '_'), 'Finanční úřad pro Plzeňský kraj', true, 2013, 9999, 'Hálkova 14 ', 'Plzeň', '30572', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '454', 0.0, false, 0, 'CZ_FU_2013_454'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PLZEŇ', 'aadresar', '_'), 'Územní pracoviště v Plzni', true, 2013, 9999, 'nám. Českých bratří 8', 'Plzeň', '30100', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2301', 0.0, false, 0, 'CZ_FU_2013_2301'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PLZEŇ SEVER', 'aadresar', '_'), 'Územní pracoviště Plzeň - sever', true, 2013, 9999, 'nám. Českých bratří 8', 'Plzeň', '30100', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2302', 0.0, false, 0, 'CZ_FU_2013_2302'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PLZEŇ JIH', 'aadresar', '_'), 'Územní pracoviště Plzeň - jih', true, 2013, 9999, 'Františkánská 18', 'Plzeň', '30100', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2303', 0.0, false, 0, 'CZ_FU_2013_2303'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP BLOVICE', 'aadresar', '_'), 'Územní pracoviště v Blovicích', true, 2013, 9999, 'Hradišťská 3', 'Blovice', '33601', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2304', 0.0, false, 0, 'CZ_FU_2013_2304'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP DOMAŽLICE', 'aadresar', '_'), 'Územní pracoviště v Domažlicích', true, 2013, 9999, 'Msgre. B. Staška 265', 'Domažlice', '34401', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2305', 0.0, false, 0, 'CZ_FU_2013_2305'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP HORAŽĎOVICE', 'aadresar', '_'), 'Územní pracoviště v Horažďovicích', true, 2013, 9999, 'Blatenská 1081', 'Horažďovice', '34101', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2306', 0.0, false, 0, 'CZ_FU_2013_2306'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP HORŠOVSKÝ TÝN', 'aadresar', '_'), 'Územní pracoviště v Horšovském Týně', true, 2013, 9999, 'Domažlická 55', 'Horšovský Týn', '34601', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2307', 0.0, false, 0, 'CZ_FU_2013_2307'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP KLATOVY', 'aadresar', '_'), 'Územní pracoviště v Klatovech', true, 2013, 9999, 'Machníkova 129', 'Klatovy', '33901', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2308', 0.0, false, 0, 'CZ_FU_2013_2308'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP KRALOVICE', 'aadresar', '_'), 'Územní pracoviště v Kralovicích', true, 2013, 9999, 'nám. Osvobození 886', 'Kralovice', '33141', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2309', 0.0, false, 0, 'CZ_FU_2013_2309'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP NEPOMUK', 'aadresar', '_'), 'Územní pracoviště v Nepomuku', true, 2013, 9999, 'nám. A. Němejce 66', 'Nepomuk', '33501', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2310', 0.0, false, 0, 'CZ_FU_2013_2310'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PŘEŠTICE', 'aadresar', '_'), 'Územní pracoviště v Přešticích', true, 2013, 9999, 'Husova 465', 'Přeštice', '33401', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2311', 0.0, false, 0, 'CZ_FU_2013_2311'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP ROKYCANY', 'aadresar', '_'), 'Územní pracoviště v Rokycanech', true, 2013, 9999, 'Malé náměstí 118', 'Rokycany', '33701', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2312', 0.0, false, 0, 'CZ_FU_2013_2312'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP TACHOV', 'aadresar', '_'), 'Územní pracoviště v Tachově', true, 2013, 9999, 'Okružní 2178', 'Tachov', '34711', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2313', 0.0, false, 0, 'CZ_FU_2013_2313'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP STŘÍBRO', 'aadresar', '_'), 'Územní pracoviště ve Stříbře', true, 2013, 9999, 'Revoluční 1010', 'Stříbro', '34901', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2314', 0.0, false, 0, 'CZ_FU_2013_2314'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP SUŠICE', 'aadresar', '_'), 'Územní pracoviště v Sušici', true, 2013, 9999, 'Klostermannova 629', 'Sušice', '34201', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2315', 0.0, false, 0, 'CZ_FU_2013_2315'),
('2013-01-25 00:00:00.000', generateuniquekod('FÚ STŘEDOČESKÝ', 'aadresar', '_'), 'Finanční úřad pro Středočeský kraj', true, 2013, 9999, 'Žitná 12', 'Praha 2', '120 00', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '452', 0.0, false, 0, 'CZ_FU_2013_452'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PRAHA VÝCHOD', 'aadresar', '_'), 'Územní pracoviště Praha – východ', true, 2013, 9999, 'Thámova 27', 'Praha 8', '18621', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2101', 0.0, false, 0, 'CZ_FU_2013_2101'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PRAHA ZÁPAD', 'aadresar', '_'), 'Územní pracoviště Praha – západ', true, 2013, 9999, 'Na Pankráci 95', 'Praha 4', '14021', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2102', 0.0, false, 0, 'CZ_FU_2013_2102'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP BENEŠOV', 'aadresar', '_'), 'Územní pracoviště v Benešově', true, 2013, 9999, 'Tyršova 2074', 'Benešov', '25601', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2103', 0.0, false, 0, 'CZ_FU_2013_2103'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP BEROUN', 'aadresar', '_'), 'Územní pracoviště v Berouně', true, 2013, 9999, 'Tyršova 1634', 'Beroun', '26645', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2104', 0.0, false, 0, 'CZ_FU_2013_2104'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP BRANDÝS NAD LABEM', 'aadresar', '_'), 'Územní pracoviště v Brandýse nad Labem - Staré Boleslavi', true, 2013, 9999, 'Boleslavská 31', 'Brandýs nad Labem - Stará Boleslav', '25001', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2105', 0.0, false, 0, 'CZ_FU_2013_2105'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP ČÁSLAV', 'aadresar', '_'), 'Územní pracoviště v Čáslavi', true, 2013, 9999, 'Žižkovo náměstí 249', 'Čáslav', '28601', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2106', 0.0, false, 0, 'CZ_FU_2013_2106'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP ČESKÝ BROD', 'aadresar', '_'), 'Územní pracoviště v Českém Brodě', true, 2013, 9999, 'Sportovní 501', 'Český Brod', '28201', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2107', 0.0, false, 0, 'CZ_FU_2013_2107'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP DOBŘÍŠ', 'aadresar', '_'), 'Územní pracoviště v Dobříši', true, 2013, 9999, 'Mírové náměstí 1551', 'Dobříš', '26301', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2108', 0.0, false, 0, 'CZ_FU_2013_2108'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP HOŘOVICE', 'aadresar', '_'), 'Územní pracoviště v Hořovicích', true, 2013, 9999, 'Palackého nám. 1417', 'Hořovice', '26801', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2109', 0.0, false, 0, 'CZ_FU_2013_2109'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP KLADNO', 'aadresar', '_'), 'Územní pracoviště v Kladně', true, 2013, 9999, 'Leoše Janáčka 3181', 'Kladno', '27280', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2110', 0.0, false, 0, 'CZ_FU_2013_2110'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP KOLÍN', 'aadresar', '_'), 'Územní pracoviště v Kolíně', true, 2013, 9999, 'Politických vězňů 423', 'Kolín', '28002', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2111', 0.0, false, 0, 'CZ_FU_2013_2111'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP KRALUPY NAD VLTAV', 'aadresar', '_'), 'Územní pracoviště v Kralupech nad Vltavou', true, 2013, 9999, 'Přemyslova 502', 'Kralupy nad Vltavou', '27801', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2112', 0.0, false, 0, 'CZ_FU_2013_2112'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP KUTNÁ HORA', 'aadresar', '_'), 'Územní pracoviště v Kutné Hoře', true, 2013, 9999, 'U Lorce 39', 'Kutná Hora', '28401', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2113', 0.0, false, 0, 'CZ_FU_2013_2113'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP MĚLNÍK', 'aadresar', '_'), 'Územní pracoviště v Mělníce', true, 2013, 9999, 'Tyršova 105', 'Mělník', '27601', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2114', 0.0, false, 0, 'CZ_FU_2013_2114'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP MLADÁ BOLESLAV', 'aadresar', '_'), 'Územní pracoviště v Mladé Boleslavi', true, 2013, 9999, 'Š.tefánikova 1406/III', 'Mladá Boleslav', '29374', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2115', 0.0, false, 0, 'CZ_FU_2013_2115'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP MNICHOVO HRADIŠTĚ', 'aadresar', '_'), 'Územní pracoviště v Mnichově Hradišti', true, 2013, 9999, 'Turnovská 253', 'Mnichovo Hradiště', '29501', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2116', 0.0, false, 0, 'CZ_FU_2013_2116'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP NERATOVICE', 'aadresar', '_'), 'Územní pracoviště v Neratovicích', true, 2013, 9999, 'Smetanova 1222', 'Neratovice', '27711', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2117', 0.0, false, 0, 'CZ_FU_2013_2117'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP NYMBURK', 'aadresar', '_'), 'Územní pracoviště v Nymburku', true, 2013, 9999, 'Bedřicha Smetany 55', 'Nymburk', '28802', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2118', 0.0, false, 0, 'CZ_FU_2013_2118'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PODĚBRADY', 'aadresar', '_'), 'Územní pracoviště v Poděbradech', true, 2013, 9999, 'Hakenova 1404', 'Poděbrady', '29001', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2119', 0.0, false, 0, 'CZ_FU_2013_2119'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PŘÍBRAM', 'aadresar', '_'), 'Územní pracoviště v Příbrami', true, 2013, 9999, 'Čs. armády 175', 'Příbram', '26134', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2120', 0.0, false, 0, 'CZ_FU_2013_2120'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP RAKOVNÍK', 'aadresar', '_'), 'Územní pracoviště v Rakovníku', true, 2013, 9999, 'Masná 265/I', 'Rakovník', '26901', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2121', 0.0, false, 0, 'CZ_FU_2013_2121'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP ŘÍČANY', 'aadresar', '_'), 'Územní pracoviště v Říčanech', true, 2013, 9999, 'Politických vězňů 1233', 'Říčany', '25101', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2122', 0.0, false, 0, 'CZ_FU_2013_2122'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP SEDLČANY', 'aadresar', '_'), 'Územní pracoviště v Sedlčanech', true, 2013, 9999, '28.října 174', 'Sedlčany', '26401', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2123', 0.0, false, 0, 'CZ_FU_2013_2123'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP SLANÝ', 'aadresar', '_'), 'Územní pracoviště ve Slaném', true, 2013, 9999, 'Pod Horou 332', 'Slaný', '27401', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2124', 0.0, false, 0, 'CZ_FU_2013_2124'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP VLAŠIM', 'aadresar', '_'), 'Územní pracoviště ve Vlašimi ', true, 2013, 9999, 'J.Masaryka 1703', 'Vlašim', '25801', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2125', 0.0, false, 0, 'CZ_FU_2013_2125'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP VOTICE', 'aadresar', '_'), 'Územní pracoviště ve Voticích', true, 2013, 9999, 'Pražská 610', 'Votice', '25928', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2126', 0.0, false, 0, 'CZ_FU_2013_2126'),
('2013-01-25 00:00:00.000', generateuniquekod('FÚ ÚSTECKÝ', 'aadresar', '_'), 'Finanční úřad pro Ústecký kraj', true, 2013, 9999, 'Velká Hradební 39/61', 'Ústí nad Labem', '40021', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '456', 0.0, false, 0, 'CZ_FU_2013_456'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP ÚSTÍ NAD LABEM', 'aadresar', '_'), 'Územní pracoviště v Ústí nad Labem', true, 2013, 9999, 'Dlouhá 3359', 'Ústí nad Labem', '40021', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2501', 0.0, false, 0, 'CZ_FU_2013_2501'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP BÍLINA', 'aadresar', '_'), 'Územní pracoviště v Bílině', true, 2013, 9999, 'Žižkovo náměstí 61/2', 'Bílina', '41801', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2502', 0.0, false, 0, 'CZ_FU_2013_2502'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP DĚČÍN', 'aadresar', '_'), 'Územní pracoviště v Děčíně', true, 2013, 9999, 'Řetězová 1369/2a', 'Děčín', '40539', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2503', 0.0, false, 0, 'CZ_FU_2013_2503'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP CHOMUTOV', 'aadresar', '_'), 'Územní pracoviště v Chomutově', true, 2013, 9999, 'Bachmačská 1617/13', 'Chomutov', '43001', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2504', 0.0, false, 0, 'CZ_FU_2013_2504'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP KADAŇ', 'aadresar', '_'), 'Územní pracoviště v Kadani', true, 2013, 9999, 'Mírové náměstí 86', 'Kadaň', '43201', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2505', 0.0, false, 0, 'CZ_FU_2013_2505'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP LIBOCHOVICE', 'aadresar', '_'), 'Územní pracoviště v Libochovicích', true, 2013, 9999, 'Nám. 5.května 50', 'Libochovice', '41117', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2506', 0.0, false, 0, 'CZ_FU_2013_2506'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP LITOMĚŘICE', 'aadresar', '_'), 'Územní pracoviště v Litoměřicích', true, 2013, 9999, 'Masarykova 2000/17', 'Litoměřice', '41201', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2507', 0.0, false, 0, 'CZ_FU_2013_2507'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP LITVÍNOV', 'aadresar', '_'), 'Územní pracoviště v Litvínově', true, 2013, 9999, 'U Zámeckého parku 948', 'Litvínov', '43601', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2508', 0.0, false, 0, 'CZ_FU_2013_2508'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP LOUNY', 'aadresar', '_'), 'Územní pracoviště v Lounech', true, 2013, 9999, 'Rybalkova 2376', 'Louny', '44068', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2509', 0.0, false, 0, 'CZ_FU_2013_2509'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP MOST', 'aadresar', '_'), 'Územní pracoviště v Mostě', true, 2013, 9999, '2. náměstí 3300', 'Most', '43401', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2510', 0.0, false, 0, 'CZ_FU_2013_2510'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP PODBOŘANY', 'aadresar', '_'), 'Územní pracoviště v Podbořanech', true, 2013, 9999, 'Masarykovo náměstí 733', 'Podbořany', '44101', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2511', 0.0, false, 0, 'CZ_FU_2013_2511'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP ROUDNICE NAD LABE', 'aadresar', '_'), 'Územní pracoviště v Roudnici nad Labem', true, 2013, 9999, 'Karlovo náměstí 18', 'Roudnice nad Labem', '41301', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2512', 0.0, false, 0, 'CZ_FU_2013_2512'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP RUMBURK', 'aadresar', '_'), 'Územní pracoviště v Rumburku', true, 2013, 9999, 'Františka Nohy 2', 'Rumburk', '40801', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2513', 0.0, false, 0, 'CZ_FU_2013_2513'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP TEPLICE', 'aadresar', '_'), 'Územní pracoviště v Teplicích', true, 2013, 9999, 'Dlouhá 143/42', 'Teplice', '41501', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2514', 0.0, false, 0, 'CZ_FU_2013_2514'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP ŽATEC', 'aadresar', '_'), 'Územní pracoviště v Žatci', true, 2013, 9999, 'Smetanovo náměstí 1017', 'Žatec', '43801', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '2515', 0.0, false, 0, 'CZ_FU_2013_2515'),
('2013-01-25 00:00:00.000', generateuniquekod('FÚ ZLÍNSKÝ', 'aadresar', '_'), 'Finanční úřad pro Zlínský kraj', true, 2013, 9999, 'třída Tomáše Bati 21', 'Zlín', '76186', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '464', 0.0, false, 0, 'CZ_FU_2013_464'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP ZLÍN', 'aadresar', '_'), 'Územní pracoviště ve Zlíně', true, 2013, 9999, 'třída Tomáše Bati 21', 'Zlín', '76186', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3301', 0.0, false, 0, 'CZ_FU_2013_3301'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP BYSTŘICE POD HOST', 'aadresar', '_'), 'Územní pracoviště v Bystřici pod Hostýnem', true, 2013, 9999, 'Masarykovo nám. 1500', 'Bystřice pod Hostýnem', '76861', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3302', 0.0, false, 0, 'CZ_FU_2013_3302'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP HOLEŠOV', 'aadresar', '_'), 'Územní pracoviště v Holešově', true, 2013, 9999, 'nám.Dr.E.Beneše 59', 'Holešov', '76901', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3303', 0.0, false, 0, 'CZ_FU_2013_3303'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP KROMĚŘÍŽ', 'aadresar', '_'), 'Územní pracoviště v Kroměříži', true, 2013, 9999, 'Husovo náměstí 535/21', 'Kroměříž', '76701', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3304', 0.0, false, 0, 'CZ_FU_2013_3304'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP LUHAČOVICE', 'aadresar', '_'), 'Územní pracoviště v Luhačovicích', true, 2013, 9999, 'Masarykova 137', 'Luhačovice', '76326', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3305', 0.0, false, 0, 'CZ_FU_2013_3305'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP OTROKOVICE', 'aadresar', '_'), 'Územní pracoviště v Otrokovicích', true, 2013, 9999, 'J. Jabůrkové 1427', 'Otrokovice', '76502', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3306', 0.0, false, 0, 'CZ_FU_2013_3306'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP ROŽNOV POD RADHOŠ', 'aadresar', '_'), 'Územní pracoviště v Rožnově pod Radhoštěm', true, 2013, 9999, 'Kulturní 1777', 'Rožnov pod Radhoštěm', '75664', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3307', 0.0, false, 0, 'CZ_FU_2013_3307'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP UHERSKÝ BROD', 'aadresar', '_'), 'Územní pracoviště v Uherském Brodě', true, 2013, 9999, '26. dubna 1917', 'Uherský Brod', '68801', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3308', 0.0, false, 0, 'CZ_FU_2013_3308'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP UHERSKÉ HRADIŠTĚ', 'aadresar', '_'), 'Územní pracoviště v Uherském Hradišti', true, 2013, 9999, 'Otakarova 1073', 'Uherské Hradiště', '68601', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3309', 0.0, false, 0, 'CZ_FU_2013_3309'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP VALAŠSKÉ MEZIŘÍČÍ', 'aadresar', '_'), 'Územní pracoviště ve Valašském Meziříčí', true, 2013, 9999, 'Vrbenská 742', 'Valašské Meziříčí', '75701', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3310', 0.0, false, 0, 'CZ_FU_2013_3310'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP VALAŠSKÉ KLOBOUKY', 'aadresar', '_'), 'Územní pracoviště ve Valašských Kloboukách', true, 2013, 9999, 'Smetanova 1076', 'Valašské Klobouky', '76601', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3311', 0.0, false, 0, 'CZ_FU_2013_3311'),
('2013-01-25 00:00:00.000', generateuniquekod('ÚP VSETÍN', 'aadresar', '_'), 'Územní pracoviště ve Vsetíně', true, 2013, 9999, 'Smetanova 1110', 'Vsetín', '75501', true, 0.0, false, false, 0, 'typVztahu.financniUrad', '3312', 0.0, false, 0, 'CZ_FU_2013_3312');

-- doplneni novych poli v nastaveni
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_451'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2001') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_001'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_451'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2002') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_002'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_451'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2003') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_003'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_451'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2004') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_004'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_451'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2005') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_005'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_451'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2006') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_006'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_451'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2007') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_007'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_451'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2008') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_008'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_451'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2009') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_009'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_451'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2010') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_010'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_451'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2011') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_011'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_451'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2012') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_012'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_451'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_SFU') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_013'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_453'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2201') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_077'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_453'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2202') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_106'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_453'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2203') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_082'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_453'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2204') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_087'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_453'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2205') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_086'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_453'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2206') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_083'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_453'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2207') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_098'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_453'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2208') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_097'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_453'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2209') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_101'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_453'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2210') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_111'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_453'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2211') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_105'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_453'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2212') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_110'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_453'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2213') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_078'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_453'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2214') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_088'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_453'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2215') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_079'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_453'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2216') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_102'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_453'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2217') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_107'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_461'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3001') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_288'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_461'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3002') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_289'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_461'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3003') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_290'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_461'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3004') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_291'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_461'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3005') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_293'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_461'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3006') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_283'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_461'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3007') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_284'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_461'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3008') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_298'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_461'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3009') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_342'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_461'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3010') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_309'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_461'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3011') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_299'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_461'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3012') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_294'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_461'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3013') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_310'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_461'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3014') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_300'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_461'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3015') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_348'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_461'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3016') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_343'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_461'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3017') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_295'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_461'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3018') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_311'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_461'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3019') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_341'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_461'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3020') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_346'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_455'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2401') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_128'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_455'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2402') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_124'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_455'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2403') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_123'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_455'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2404') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_157'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_455'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2405') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_125'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_455'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2406') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_129'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_455'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2407') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_155'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_460'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2901') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_314'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_460'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2902') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_352'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_460'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2903') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_223'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_460'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2904') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_092'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_460'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2905') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_224'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_460'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2906') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_225'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_460'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2907') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_332'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_460'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2908') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_333'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_460'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2909') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_094'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_460'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2910') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_091'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_460'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2911') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_317'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_460'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2912') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_330'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_460'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2913') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_353'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_460'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2914') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_351'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_458'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2701') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_228'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_458'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2702') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_244'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_458'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2703') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_254'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_458'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2704') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_269'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_458'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2705') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_239'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_458'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2706') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_245'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_458'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2707') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_238'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_458'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2708') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_255'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_458'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2709') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_243'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_458'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2710') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_240'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_458'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2711') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_230'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_458'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2712') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_253'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_458'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2713') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_268'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_458'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2714') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_270'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_457'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2601') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_192'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_457'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2602') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_172'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_457'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2603') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_193'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_457'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2604') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_187'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_457'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2605') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_259'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_457'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2606') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_175'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_457'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2607') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_258'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_457'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2608') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_188'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_457'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2609') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_260'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_457'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2610') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_189'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_463'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3201') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_388'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_463'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3202') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_389'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_463'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3203') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_390'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_463'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3204') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_368'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_463'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3205') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_358'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_463'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3206') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_369'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_463'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3207') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_362'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_463'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3208') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_363'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_463'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3209') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_375'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_463'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3210') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_370'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_463'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3211') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_385'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_463'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3212') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_367'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_463'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3213') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_376'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_463'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3214') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_359'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_463'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3215') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_374'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_463'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3216') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_384'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_463'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3217') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_371'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_463'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3218') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_364'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_462'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3101') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_379'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_462'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3102') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_394'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_462'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3103') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_399'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_462'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3104') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_326'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_462'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3105') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_380'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_462'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3106') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_325'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_462'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3107') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_393'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_462'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3108') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_381'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_462'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3109') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_398'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_462'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3110') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_400'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_459'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2801') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_248'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_459'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2802') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_235'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_459'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2803') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_249'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_459'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2804') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_233'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_459'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2805') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_264'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_459'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2806') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_265'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_459'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2807') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_250'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_459'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2808') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_263'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_459'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2809') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_273'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_459'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2810') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_274'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_459'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2811') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_275'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_454'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2301') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_138'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_454'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2302') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_145'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_454'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2303') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_140'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_454'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2304') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_141'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_454'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2305') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_118'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_454'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2306') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_134'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_454'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2307') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_119'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_454'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2308') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_133'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_454'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2309') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_146'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_454'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2310') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_000'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_454'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2311') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_142'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_454'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2312') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_150'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_454'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2313') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_160'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_454'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2314') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_162'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_454'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2315') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_135'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2102') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_060'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2103') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_021'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2104') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_026'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2105') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_057'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2106') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_039'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2107') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_035'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2108') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_065'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2109') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_027'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2110') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_030'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2111') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_034'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2112') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_044'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2113') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_038'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2114') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_043'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2115') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_048'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2116') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_050'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2117') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_045'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2118') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_053'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2119') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_055'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2120') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_063'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2121') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_069'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2122') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_059'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2123') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_066'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2124') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_031'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2125') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_022'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_452'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2126') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_023'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_456'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2501') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_214'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_456'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2502') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_211'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_456'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2503') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_178'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_456'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2504') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_182'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_456'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2505') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_183'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_456'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2506') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_197'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_456'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2507') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_196'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_456'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2508') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_207'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_456'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2509') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_201'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_456'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2510') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_206'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_456'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2511') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_202'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_456'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2512') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_198'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_456'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2513') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_179'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_456'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2514') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_210'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_456'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2515') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_203'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_464'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3301') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_303'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_464'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3302') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_321'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_464'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3303') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_322'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_464'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3304') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_320'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_464'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3305') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_304'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_464'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3306') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_305'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_464'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3307') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_404'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_464'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3308') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_338'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_464'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3309') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_336'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_464'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3310') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_405'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_464'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3311') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_306'), -1);
UPDATE nnastav SET idFuKraj = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_464'), idFuUzemPrac = (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3312') WHERE idFinUrad = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_403'), -1);

-- vytvoreni zadanych bankovnich spojeni u novych financaku
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2001') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_001'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2002') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_002'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2003') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_003'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2004') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_004'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2005') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_005'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2006') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_006'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2007') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_007'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2008') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_008'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2009') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_009'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2010') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_010'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2011') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_011'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2012') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_012'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_SFU') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_013'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2201') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_077'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2202') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_106'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2203') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_082'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2204') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_087'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2205') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_086'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2206') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_083'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2207') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_098'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2208') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_097'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2209') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_101'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2210') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_111'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2211') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_105'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2212') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_110'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2213') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_078'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2214') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_088'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2215') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_079'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2216') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_102'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2217') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_107'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3001') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_288'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3002') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_289'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3003') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_290'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3004') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_291'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3005') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_293'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3006') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_283'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3007') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_284'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3008') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_298'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3009') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_342'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3010') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_309'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3011') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_299'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3012') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_294'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3013') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_310'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3014') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_300'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3015') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_348'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3016') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_343'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3017') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_295'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3018') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_311'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3019') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_341'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3020') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_346'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2401') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_128'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2402') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_124'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2403') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_123'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2404') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_157'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2405') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_125'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2406') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_129'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2407') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_155'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2901') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_314'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2902') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_352'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2903') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_223'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2904') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_092'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2905') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_224'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2906') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_225'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2907') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_332'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2908') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_333'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2909') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_094'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2910') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_091'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2911') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_317'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2912') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_330'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2913') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_353'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2914') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_351'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2701') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_228'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2702') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_244'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2703') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_254'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2704') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_269'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2705') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_239'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2706') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_245'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2707') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_238'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2708') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_255'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2709') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_243'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2710') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_240'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2711') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_230'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2712') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_253'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2713') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_268'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2714') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_270'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2601') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_192'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2602') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_172'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2603') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_193'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2604') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_187'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2605') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_259'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2606') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_175'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2607') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_258'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2608') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_188'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2609') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_260'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2610') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_189'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3201') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_388'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3202') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_389'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3203') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_390'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3204') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_368'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3205') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_358'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3206') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_369'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3207') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_362'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3208') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_363'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3209') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_375'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3210') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_370'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3211') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_385'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3212') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_367'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3213') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_376'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3214') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_359'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3215') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_374'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3216') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_384'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3217') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_371'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3218') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_364'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3101') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_379'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3102') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_394'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3103') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_399'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3104') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_326'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3105') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_380'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3106') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_325'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3107') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_393'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3108') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_381'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3109') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_398'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3110') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_400'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2801') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_248'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2802') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_235'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2803') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_249'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2804') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_233'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2805') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_264'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2806') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_265'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2807') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_250'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2808') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_263'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2809') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_273'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2810') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_274'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2811') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_275'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2301') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_138'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2302') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_145'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2303') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_140'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2304') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_141'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2305') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_118'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2306') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_134'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2307') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_119'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2308') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_133'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2309') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_146'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2310') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_000'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2311') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_142'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2312') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_150'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2313') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_160'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2314') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_162'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2315') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_135'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2102') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_060'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2103') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_021'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2104') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_026'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2105') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_057'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2106') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_039'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2107') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_035'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2108') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_065'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2109') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_027'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2110') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_030'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2111') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_034'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2112') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_044'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2113') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_038'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2114') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_043'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2115') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_048'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2116') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_050'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2117') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_045'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2118') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_053'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2119') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_055'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2120') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_063'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2121') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_069'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2122') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_059'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2123') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_066'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2124') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_031'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2125') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_022'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2126') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_023'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2501') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_214'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2502') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_211'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2503') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_178'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2504') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_182'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2505') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_183'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2506') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_197'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2507') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_196'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2508') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_207'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2509') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_201'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2510') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_206'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2511') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_202'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2512') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_198'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2513') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_179'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2514') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_210'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2515') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_203'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3301') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_303'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3302') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_321'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3303') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_322'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3304') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_320'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3305') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_304'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3306') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_305'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3307') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_404'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3308') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_338'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3309') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_336'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3310') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_405'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3311') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_306'), -1);
INSERT INTO abanspoj (mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, idfirmy) SELECT mesto, psc, ulice, bic, buc, iban, nazbanky, popis, poznam, primarni, specsym, varsym, idsmerkod, idkonsym, idstatu, idosoba, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3312') FROM abanspoj WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_403'), -1);

-- vytvoreni zadanych kontaktu u novych financaku
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2001') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_001'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2002') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_002'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2003') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_003'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2004') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_004'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2005') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_005'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2006') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_006'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2007') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_007'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2008') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_008'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2009') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_009'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2010') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_010'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2011') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_011'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2012') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_012'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_SFU') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_013'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2201') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_077'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2202') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_106'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2203') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_082'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2204') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_087'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2205') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_086'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2206') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_083'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2207') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_098'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2208') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_097'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2209') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_101'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2210') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_111'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2211') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_105'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2212') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_110'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2213') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_078'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2214') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_088'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2215') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_079'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2216') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_102'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2217') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_107'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3001') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_288'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3002') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_289'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3003') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_290'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3004') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_291'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3005') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_293'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3006') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_283'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3007') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_284'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3008') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_298'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3009') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_342'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3010') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_309'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3011') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_299'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3012') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_294'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3013') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_310'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3014') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_300'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3015') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_348'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3016') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_343'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3017') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_295'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3018') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_311'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3019') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_341'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3020') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_346'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2401') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_128'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2402') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_124'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2403') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_123'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2404') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_157'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2405') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_125'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2406') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_129'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2407') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_155'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2901') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_314'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2902') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_352'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2903') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_223'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2904') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_092'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2905') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_224'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2906') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_225'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2907') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_332'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2908') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_333'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2909') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_094'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2910') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_091'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2911') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_317'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2912') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_330'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2913') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_353'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2914') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_351'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2701') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_228'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2702') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_244'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2703') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_254'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2704') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_269'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2705') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_239'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2706') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_245'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2707') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_238'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2708') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_255'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2709') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_243'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2710') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_240'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2711') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_230'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2712') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_253'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2713') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_268'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2714') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_270'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2601') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_192'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2602') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_172'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2603') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_193'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2604') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_187'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2605') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_259'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2606') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_175'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2607') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_258'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2608') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_188'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2609') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_260'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2610') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_189'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3201') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_388'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3202') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_389'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3203') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_390'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3204') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_368'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3205') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_358'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3206') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_369'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3207') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_362'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3208') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_363'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3209') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_375'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3210') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_370'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3211') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_385'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3212') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_367'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3213') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_376'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3214') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_359'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3215') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_374'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3216') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_384'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3217') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_371'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3218') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_364'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3101') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_379'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3102') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_394'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3103') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_399'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3104') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_326'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3105') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_380'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3106') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_325'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3107') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_393'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3108') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_381'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3109') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_398'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3110') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_400'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2801') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_248'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2802') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_235'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2803') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_249'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2804') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_233'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2805') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_264'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2806') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_265'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2807') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_250'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2808') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_263'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2809') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_273'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2810') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_274'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2811') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_275'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2301') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_138'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2302') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_145'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2303') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_140'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2304') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_141'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2305') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_118'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2306') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_134'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2307') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_119'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2308') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_133'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2309') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_146'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2310') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_000'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2311') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_142'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2312') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_150'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2313') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_160'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2314') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_162'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2315') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_135'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2102') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_060'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2103') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_021'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2104') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_026'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2105') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_057'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2106') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_039'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2107') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_035'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2108') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_065'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2109') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_027'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2110') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_030'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2111') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_034'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2112') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_044'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2113') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_038'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2114') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_043'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2115') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_048'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2116') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_050'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2117') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_045'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2118') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_053'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2119') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_055'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2120') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_063'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2121') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_069'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2122') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_059'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2123') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_066'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2124') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_031'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2125') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_022'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2126') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_023'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2501') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_214'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2502') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_211'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2503') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_178'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2504') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_182'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2505') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_183'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2506') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_197'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2507') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_196'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2508') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_207'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2509') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_201'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2510') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_206'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2511') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_202'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2512') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_198'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2513') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_179'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2514') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_210'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2515') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_203'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3301') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_303'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3302') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_321'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3303') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_322'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3304') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_320'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3305') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_304'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3306') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_305'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3307') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_404'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3308') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_338'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3309') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_336'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3310') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_405'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3311') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_306'), -1);
INSERT INTO akontakty (mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, funkce, jmeno, oddeleni, osloveni, popis, poznam, prijmeni, primarni, titul, titulza, odesilatfak, odesilatobj, odesilatppt, odesilatnab, odesilatpok, odesilatskl, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3312') FROM akontakty WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_403'), -1);

-- vytvoreni zadanych mist urceni u novych financaku
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2001') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_001'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2002') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_002'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2003') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_003'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2004') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_004'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2005') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_005'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2006') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_006'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2007') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_007'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2008') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_008'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2009') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_009'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2010') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_010'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2011') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_011'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2012') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_012'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_SFU') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_013'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2201') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_077'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2202') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_106'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2203') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_082'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2204') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_087'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2205') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_086'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2206') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_083'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2207') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_098'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2208') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_097'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2209') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_101'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2210') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_111'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2211') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_105'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2212') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_110'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2213') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_078'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2214') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_088'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2215') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_079'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2216') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_102'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2217') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_107'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3001') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_288'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3002') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_289'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3003') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_290'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3004') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_291'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3005') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_293'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3006') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_283'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3007') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_284'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3008') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_298'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3009') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_342'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3010') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_309'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3011') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_299'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3012') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_294'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3013') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_310'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3014') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_300'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3015') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_348'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3016') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_343'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3017') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_295'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3018') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_311'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3019') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_341'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3020') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_346'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2401') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_128'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2402') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_124'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2403') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_123'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2404') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_157'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2405') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_125'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2406') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_129'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2407') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_155'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2901') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_314'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2902') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_352'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2903') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_223'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2904') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_092'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2905') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_224'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2906') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_225'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2907') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_332'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2908') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_333'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2909') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_094'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2910') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_091'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2911') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_317'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2912') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_330'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2913') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_353'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2914') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_351'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2701') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_228'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2702') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_244'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2703') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_254'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2704') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_269'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2705') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_239'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2706') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_245'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2707') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_238'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2708') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_255'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2709') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_243'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2710') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_240'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2711') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_230'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2712') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_253'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2713') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_268'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2714') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_270'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2601') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_192'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2602') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_172'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2603') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_193'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2604') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_187'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2605') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_259'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2606') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_175'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2607') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_258'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2608') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_188'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2609') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_260'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2610') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_189'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3201') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_388'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3202') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_389'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3203') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_390'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3204') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_368'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3205') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_358'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3206') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_369'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3207') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_362'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3208') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_363'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3209') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_375'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3210') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_370'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3211') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_385'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3212') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_367'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3213') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_376'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3214') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_359'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3215') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_374'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3216') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_384'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3217') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_371'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3218') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_364'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3101') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_379'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3102') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_394'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3103') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_399'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3104') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_326'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3105') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_380'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3106') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_325'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3107') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_393'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3108') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_381'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3109') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_398'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3110') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_400'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2801') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_248'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2802') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_235'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2803') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_249'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2804') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_233'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2805') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_264'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2806') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_265'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2807') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_250'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2808') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_263'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2809') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_273'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2810') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_274'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2811') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_275'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2301') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_138'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2302') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_145'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2303') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_140'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2304') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_141'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2305') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_118'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2306') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_134'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2307') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_119'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2308') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_133'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2309') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_146'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2310') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_000'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2311') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_142'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2312') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_150'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2313') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_160'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2314') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_162'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2315') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_135'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2102') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_060'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2103') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_021'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2104') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_026'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2105') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_057'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2106') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_039'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2107') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_035'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2108') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_065'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2109') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_027'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2110') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_030'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2111') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_034'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2112') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_044'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2113') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_038'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2114') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_043'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2115') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_048'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2116') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_050'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2117') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_045'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2118') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_053'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2119') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_055'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2120') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_063'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2121') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_069'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2122') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_059'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2123') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_066'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2124') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_031'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2125') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_022'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2126') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_023'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2501') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_214'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2502') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_211'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2503') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_178'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2504') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_182'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2505') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_183'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2506') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_197'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2507') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_196'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2508') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_207'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2509') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_201'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2510') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_206'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2511') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_202'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2512') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_198'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2513') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_179'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2514') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_210'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2515') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_203'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3301') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_303'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3302') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_321'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3303') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_322'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3304') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_320'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3305') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_304'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3306') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_305'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3307') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_404'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3308') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_338'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3309') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_336'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3310') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_405'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3311') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_306'), -1);
INSERT INTO amisturc (mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, idfirmy) SELECT mesto, psc, ulice, email, fax, mobil, tel, www, eankod, nazev, popis, poznam, primarni, idstatu, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3312') FROM amisturc WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_403'), -1);

-- vytvoreni zadanych udalosti u novych financaku
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2001') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_001'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2002') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_002'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2003') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_003'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2004') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_004'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2005') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_005'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2006') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_006'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2007') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_007'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2008') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_008'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2009') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_009'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2010') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_010'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2011') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_011'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2012') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_012'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_SFU') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_013'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2201') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_077'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2202') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_106'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2203') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_082'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2204') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_087'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2205') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_086'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2206') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_083'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2207') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_098'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2208') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_097'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2209') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_101'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2210') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_111'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2211') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_105'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2212') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_110'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2213') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_078'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2214') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_088'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2215') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_079'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2216') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_102'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2217') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_107'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3001') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_288'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3002') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_289'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3003') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_290'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3004') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_291'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3005') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_293'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3006') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_283'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3007') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_284'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3008') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_298'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3009') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_342'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3010') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_309'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3011') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_299'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3012') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_294'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3013') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_310'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3014') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_300'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3015') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_348'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3016') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_343'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3017') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_295'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3018') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_311'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3019') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_341'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3020') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_346'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2401') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_128'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2402') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_124'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2403') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_123'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2404') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_157'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2405') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_125'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2406') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_129'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2407') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_155'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2901') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_314'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2902') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_352'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2903') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_223'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2904') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_092'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2905') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_224'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2906') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_225'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2907') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_332'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2908') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_333'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2909') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_094'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2910') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_091'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2911') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_317'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2912') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_330'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2913') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_353'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2914') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_351'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2701') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_228'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2702') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_244'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2703') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_254'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2704') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_269'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2705') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_239'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2706') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_245'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2707') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_238'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2708') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_255'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2709') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_243'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2710') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_240'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2711') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_230'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2712') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_253'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2713') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_268'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2714') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_270'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2601') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_192'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2602') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_172'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2603') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_193'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2604') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_187'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2605') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_259'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2606') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_175'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2607') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_258'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2608') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_188'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2609') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_260'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2610') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_189'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3201') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_388'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3202') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_389'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3203') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_390'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3204') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_368'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3205') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_358'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3206') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_369'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3207') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_362'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3208') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_363'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3209') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_375'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3210') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_370'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3211') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_385'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3212') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_367'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3213') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_376'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3214') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_359'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3215') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_374'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3216') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_384'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3217') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_371'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3218') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_364'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3101') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_379'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3102') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_394'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3103') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_399'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3104') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_326'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3105') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_380'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3106') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_325'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3107') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_393'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3108') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_381'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3109') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_398'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3110') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_400'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2801') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_248'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2802') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_235'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2803') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_249'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2804') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_233'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2805') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_264'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2806') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_265'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2807') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_250'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2808') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_263'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2809') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_273'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2810') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_274'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2811') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_275'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2301') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_138'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2302') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_145'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2303') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_140'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2304') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_141'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2305') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_118'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2306') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_134'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2307') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_119'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2308') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_133'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2309') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_146'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2310') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_000'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2311') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_142'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2312') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_150'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2313') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_160'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2314') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_162'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2315') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_135'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2102') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_060'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2103') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_021'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2104') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_026'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2105') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_057'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2106') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_039'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2107') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_035'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2108') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_065'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2109') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_027'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2110') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_030'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2111') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_034'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2112') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_044'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2113') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_038'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2114') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_043'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2115') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_048'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2116') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_050'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2117') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_045'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2118') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_053'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2119') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_055'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2120') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_063'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2121') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_069'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2122') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_059'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2123') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_066'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2124') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_031'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2125') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_022'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2126') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_023'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2501') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_214'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2502') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_211'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2503') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_178'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2504') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_182'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2505') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_183'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2506') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_197'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2507') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_196'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2508') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_207'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2509') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_201'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2510') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_206'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2511') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_202'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2512') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_198'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2513') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_179'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2514') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_210'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_2515') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_203'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3301') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_303'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3302') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_321'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3303') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_322'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3304') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_320'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3305') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_304'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3306') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_305'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3307') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_404'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3308') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_338'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3309') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_336'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3310') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_405'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3311') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_306'), -1);
INSERT INTO audalosti (celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, idfirmy) SELECT celodenni, dokonceni, druhudalk, predmet, prioritak, stavudalk, termin, umisteni, volno, zahajeni, popis, poznam, idtypakt, iduzivatel, idzakazky, (select idfirmy from aadresar where uuid = 'CZ_FU_2013_3312') FROM audalosti WHERE idfirmy = coalesce((select idfirmy from aadresar where uuid = 'CZ_FU_403'), -1);

-- konec ceskeho bloku
  end if; 
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 703, 't', %appVersion%, clock_timestamp());
